"""
Type annotations for ec2 service type definitions.

[Open documentation](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_ec2/type_defs/)

Usage::

    ```python
    from mypy_boto3_ec2.type_defs import AcceleratorCountOutputTypeDef

    data: AcceleratorCountOutputTypeDef = {...}
    ```
"""
import sys
from datetime import datetime
from typing import IO, Any, Dict, List, Sequence, Union

from botocore.response import StreamingBody

from .literals import (
    AcceleratorManufacturerType,
    AcceleratorNameType,
    AcceleratorTypeType,
    AccountAttributeNameType,
    ActivityStatusType,
    AddressFamilyType,
    AddressTransferStatusType,
    AffinityType,
    AllocationStateType,
    AllocationStrategyType,
    AllowsMultipleInstanceTypesType,
    AmdSevSnpSpecificationType,
    AnalysisStatusType,
    ApplianceModeSupportValueType,
    ArchitectureTypeType,
    ArchitectureValuesType,
    AssociationStatusCodeType,
    AttachmentStatusType,
    AutoAcceptSharedAssociationsValueType,
    AutoAcceptSharedAttachmentsValueType,
    AutoPlacementType,
    AvailabilityZoneOptInStatusType,
    AvailabilityZoneStateType,
    BareMetalType,
    BatchStateType,
    BgpStatusType,
    BootModeTypeType,
    BootModeValuesType,
    BundleTaskStateType,
    BurstablePerformanceType,
    ByoipCidrStateType,
    CancelBatchErrorCodeType,
    CancelSpotInstanceRequestStateType,
    CapacityReservationFleetStateType,
    CapacityReservationInstancePlatformType,
    CapacityReservationPreferenceType,
    CapacityReservationStateType,
    CapacityReservationTenancyType,
    CarrierGatewayStateType,
    ClientCertificateRevocationListStatusCodeType,
    ClientVpnAuthenticationTypeType,
    ClientVpnAuthorizationRuleStatusCodeType,
    ClientVpnConnectionStatusCodeType,
    ClientVpnEndpointAttributeStatusCodeType,
    ClientVpnEndpointStatusCodeType,
    ClientVpnRouteStatusCodeType,
    ConnectionNotificationStateType,
    ConnectivityTypeType,
    ConversionTaskStateType,
    CpuManufacturerType,
    DatafeedSubscriptionStateType,
    DefaultRouteTableAssociationValueType,
    DefaultRouteTablePropagationValueType,
    DefaultTargetCapacityTypeType,
    DeleteFleetErrorCodeType,
    DeleteQueuedReservedInstancesErrorCodeType,
    DestinationFileFormatType,
    DeviceTrustProviderTypeType,
    DeviceTypeType,
    DiskImageFormatType,
    DiskTypeType,
    DnsNameStateType,
    DnsRecordIpTypeType,
    DnsSupportValueType,
    DomainTypeType,
    DynamicRoutingValueType,
    EbsEncryptionSupportType,
    EbsNvmeSupportType,
    EbsOptimizedSupportType,
    Ec2InstanceConnectEndpointStateType,
    ElasticGpuStatusType,
    EnaSupportType,
    EndDateTypeType,
    EphemeralNvmeSupportType,
    EventCodeType,
    EventTypeType,
    ExcessCapacityTerminationPolicyType,
    ExportEnvironmentType,
    ExportTaskStateType,
    FastLaunchStateCodeType,
    FastSnapshotRestoreStateCodeType,
    FindingsFoundType,
    FleetActivityStatusType,
    FleetEventTypeType,
    FleetExcessCapacityTerminationPolicyType,
    FleetOnDemandAllocationStrategyType,
    FleetReplacementStrategyType,
    FleetStateCodeType,
    FleetTypeType,
    FlowLogsResourceTypeType,
    FpgaImageAttributeNameType,
    FpgaImageStateCodeType,
    GatewayAssociationStateType,
    HostMaintenanceType,
    HostnameTypeType,
    HostRecoveryType,
    HostTenancyType,
    HttpTokensStateType,
    HypervisorTypeType,
    IamInstanceProfileAssociationStateType,
    Igmpv2SupportValueType,
    ImageAttributeNameType,
    ImageStateType,
    ImageTypeValuesType,
    InstanceAttributeNameType,
    InstanceAutoRecoveryStateType,
    InstanceBootModeValuesType,
    InstanceEventWindowStateType,
    InstanceGenerationType,
    InstanceHealthStatusType,
    InstanceInterruptionBehaviorType,
    InstanceLifecycleType,
    InstanceLifecycleTypeType,
    InstanceMatchCriteriaType,
    InstanceMetadataEndpointStateType,
    InstanceMetadataOptionsStateType,
    InstanceMetadataProtocolStateType,
    InstanceMetadataTagsStateType,
    InstanceStateNameType,
    InstanceStorageEncryptionSupportType,
    InstanceTypeHypervisorType,
    InstanceTypeType,
    InterfacePermissionTypeType,
    InterfaceProtocolTypeType,
    IpAddressTypeType,
    IpamAddressHistoryResourceTypeType,
    IpamAssociatedResourceDiscoveryStatusType,
    IpamComplianceStatusType,
    IpamDiscoveryFailureCodeType,
    IpamManagementStateType,
    IpamOverlapStatusType,
    IpamPoolAllocationResourceTypeType,
    IpamPoolCidrFailureCodeType,
    IpamPoolCidrStateType,
    IpamPoolPublicIpSourceType,
    IpamPoolStateType,
    IpamResourceDiscoveryAssociationStateType,
    IpamResourceDiscoveryStateType,
    IpamResourceTypeType,
    IpamScopeStateType,
    IpamScopeTypeType,
    IpamStateType,
    Ipv6SupportValueType,
    KeyFormatType,
    KeyTypeType,
    LaunchTemplateAutoRecoveryStateType,
    LaunchTemplateErrorCodeType,
    LaunchTemplateHttpTokensStateType,
    LaunchTemplateInstanceMetadataEndpointStateType,
    LaunchTemplateInstanceMetadataOptionsStateType,
    LaunchTemplateInstanceMetadataProtocolIpv6Type,
    LaunchTemplateInstanceMetadataTagsStateType,
    ListingStateType,
    ListingStatusType,
    LocalGatewayRouteStateType,
    LocalGatewayRouteTableModeType,
    LocalGatewayRouteTypeType,
    LocalStorageType,
    LocalStorageTypeType,
    LocationTypeType,
    LogDestinationTypeType,
    MembershipTypeType,
    ModifyAvailabilityZoneOptInStatusType,
    MonitoringStateType,
    MoveStatusType,
    MulticastSupportValueType,
    NatGatewayAddressStatusType,
    NatGatewayStateType,
    NetworkInterfaceAttributeType,
    NetworkInterfaceCreationTypeType,
    NetworkInterfacePermissionStateCodeType,
    NetworkInterfaceStatusType,
    NetworkInterfaceTypeType,
    NitroEnclavesSupportType,
    OfferingClassTypeType,
    OfferingTypeValuesType,
    OnDemandAllocationStrategyType,
    OperationTypeType,
    PartitionLoadFrequencyType,
    PaymentOptionType,
    PeriodTypeType,
    PlacementGroupStateType,
    PlacementGroupStrategyType,
    PlacementStrategyType,
    PrefixListStateType,
    PrincipalTypeType,
    ProductCodeValuesType,
    ProtocolType,
    ReplacementStrategyType,
    ReplaceRootVolumeTaskStateType,
    ReportInstanceReasonCodesType,
    ReportStatusTypeType,
    ReservationStateType,
    ReservedInstanceStateType,
    ResourceTypeType,
    RIProductDescriptionType,
    RootDeviceTypeType,
    RouteOriginType,
    RouteStateType,
    RouteTableAssociationStateCodeType,
    RuleActionType,
    SelfServicePortalType,
    ServiceConnectivityTypeType,
    ServiceStateType,
    ServiceTypeType,
    ShutdownBehaviorType,
    SnapshotAttributeNameType,
    SnapshotStateType,
    SpotAllocationStrategyType,
    SpotInstanceInterruptionBehaviorType,
    SpotInstanceStateType,
    SpotInstanceTypeType,
    SpreadLevelType,
    StateType,
    StaticSourcesSupportValueType,
    StatusType,
    StatusTypeType,
    StorageTierType,
    SubnetCidrBlockStateCodeType,
    SubnetCidrReservationTypeType,
    SubnetStateType,
    SummaryStatusType,
    TargetCapacityUnitTypeType,
    TelemetryStatusType,
    TenancyType,
    TieringOperationStatusType,
    TrafficDirectionType,
    TrafficMirrorFilterRuleFieldType,
    TrafficMirrorRuleActionType,
    TrafficMirrorSessionFieldType,
    TrafficMirrorTargetTypeType,
    TrafficTypeType,
    TransitGatewayAssociationStateType,
    TransitGatewayAttachmentResourceTypeType,
    TransitGatewayAttachmentStateType,
    TransitGatewayConnectPeerStateType,
    TransitGatewayMulitcastDomainAssociationStateType,
    TransitGatewayMulticastDomainStateType,
    TransitGatewayPolicyTableStateType,
    TransitGatewayPrefixListReferenceStateType,
    TransitGatewayPropagationStateType,
    TransitGatewayRouteStateType,
    TransitGatewayRouteTableAnnouncementDirectionType,
    TransitGatewayRouteTableAnnouncementStateType,
    TransitGatewayRouteTableStateType,
    TransitGatewayRouteTypeType,
    TransitGatewayStateType,
    TransportProtocolType,
    TrustProviderTypeType,
    TunnelInsideIpVersionType,
    UnlimitedSupportedInstanceFamilyType,
    UnsuccessfulInstanceCreditSpecificationErrorCodeType,
    UsageClassTypeType,
    UserTrustProviderTypeType,
    VerifiedAccessEndpointProtocolType,
    VerifiedAccessEndpointStatusCodeType,
    VerifiedAccessEndpointTypeType,
    VerifiedAccessLogDeliveryStatusCodeType,
    VirtualizationTypeType,
    VolumeAttachmentStateType,
    VolumeAttributeNameType,
    VolumeModificationStateType,
    VolumeStateType,
    VolumeStatusInfoStatusType,
    VolumeStatusNameType,
    VolumeTypeType,
    VpcAttributeNameType,
    VpcCidrBlockStateCodeType,
    VpcEndpointTypeType,
    VpcPeeringConnectionStateReasonCodeType,
    VpcStateType,
    VpnEcmpSupportValueType,
    VpnStateType,
    WeekDayType,
    scopeType,
)

if sys.version_info >= (3, 9):
    from typing import Literal
else:
    from typing_extensions import Literal
if sys.version_info >= (3, 9):
    from typing import TypedDict
else:
    from typing_extensions import TypedDict


__all__ = (
    "AcceleratorCountOutputTypeDef",
    "AcceleratorCountRequestTypeDef",
    "AcceleratorCountTypeDef",
    "AcceleratorTotalMemoryMiBOutputTypeDef",
    "AcceleratorTotalMemoryMiBRequestTypeDef",
    "AcceleratorTotalMemoryMiBTypeDef",
    "AddressTransferOutputTypeDef",
    "TargetConfigurationRequestTypeDef",
    "AcceptReservedInstancesExchangeQuoteResultOutputTypeDef",
    "AcceptTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    "AcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    "AcceptTransitGatewayVpcAttachmentRequestRequestTypeDef",
    "AcceptVpcEndpointConnectionsRequestRequestTypeDef",
    "AcceptVpcPeeringConnectionRequestRequestTypeDef",
    "AcceptVpcPeeringConnectionRequestVpcPeeringConnectionAcceptTypeDef",
    "AccountAttributeValueOutputTypeDef",
    "ActiveInstanceOutputTypeDef",
    "AddIpamOperatingRegionTypeDef",
    "AddPrefixListEntryTypeDef",
    "AddedPrincipalOutputTypeDef",
    "AnalysisComponentOutputTypeDef",
    "RuleGroupTypePairOutputTypeDef",
    "RuleOptionOutputTypeDef",
    "PtrUpdateStatusOutputTypeDef",
    "TagOutputTypeDef",
    "AdvertiseByoipCidrRequestRequestTypeDef",
    "ByoipCidrOutputTypeDef",
    "AllocateAddressResultOutputTypeDef",
    "AllocateHostsResultOutputTypeDef",
    "AllocateIpamPoolCidrRequestRequestTypeDef",
    "IpamPoolAllocationOutputTypeDef",
    "AlternatePathHintOutputTypeDef",
    "PortRangeOutputTypeDef",
    "AnalysisLoadBalancerListenerOutputTypeDef",
    "AnalysisRouteTableRouteOutputTypeDef",
    "ApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef",
    "ApplySecurityGroupsToClientVpnTargetNetworkResultOutputTypeDef",
    "AssignIpv6AddressesRequestRequestTypeDef",
    "AssignIpv6AddressesResultOutputTypeDef",
    "AssignPrivateIpAddressesRequestNetworkInterfaceAssignPrivateIpAddressesTypeDef",
    "AssignPrivateIpAddressesRequestRequestTypeDef",
    "AssignedPrivateIpAddressOutputTypeDef",
    "Ipv4PrefixSpecificationOutputTypeDef",
    "AssignPrivateNatGatewayAddressRequestRequestTypeDef",
    "NatGatewayAddressOutputTypeDef",
    "AssociateAddressRequestClassicAddressAssociateTypeDef",
    "AssociateAddressRequestRequestTypeDef",
    "AssociateAddressRequestVpcAddressAssociateTypeDef",
    "AssociateAddressResultOutputTypeDef",
    "AssociateClientVpnTargetNetworkRequestRequestTypeDef",
    "AssociationStatusOutputTypeDef",
    "AssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef",
    "AssociateDhcpOptionsRequestRequestTypeDef",
    "AssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef",
    "AssociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    "AssociateEnclaveCertificateIamRoleResultOutputTypeDef",
    "IamInstanceProfileSpecificationTypeDef",
    "AssociateNatGatewayAddressRequestRequestTypeDef",
    "AssociateRouteTableRequestRequestTypeDef",
    "AssociateRouteTableRequestRouteTableAssociateWithSubnetTypeDef",
    "RouteTableAssociationStateOutputTypeDef",
    "AssociateSubnetCidrBlockRequestRequestTypeDef",
    "AssociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    "AssociateTransitGatewayPolicyTableRequestRequestTypeDef",
    "TransitGatewayPolicyTableAssociationOutputTypeDef",
    "AssociateTransitGatewayRouteTableRequestRequestTypeDef",
    "TransitGatewayAssociationOutputTypeDef",
    "AssociateTrunkInterfaceRequestRequestTypeDef",
    "AssociateVpcCidrBlockRequestRequestTypeDef",
    "AssociatedRoleOutputTypeDef",
    "AssociatedTargetNetworkOutputTypeDef",
    "AthenaIntegrationTypeDef",
    "AttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef",
    "AttachClassicLinkVpcRequestRequestTypeDef",
    "AttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef",
    "AttachClassicLinkVpcResultOutputTypeDef",
    "AttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef",
    "AttachInternetGatewayRequestRequestTypeDef",
    "AttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef",
    "AttachNetworkInterfaceResultOutputTypeDef",
    "AttachVerifiedAccessTrustProviderRequestRequestTypeDef",
    "AttachVolumeRequestInstanceAttachVolumeTypeDef",
    "AttachVolumeRequestRequestTypeDef",
    "AttachVolumeRequestVolumeAttachToInstanceTypeDef",
    "AttachVpnGatewayRequestRequestTypeDef",
    "VpcAttachmentOutputTypeDef",
    "AttachmentEnaSrdUdpSpecificationOutputTypeDef",
    "AttributeBooleanValueOutputTypeDef",
    "AttributeBooleanValueTypeDef",
    "AttributeValueOutputTypeDef",
    "AttributeValueTypeDef",
    "ClientVpnAuthorizationRuleStatusOutputTypeDef",
    "AuthorizeClientVpnIngressRequestRequestTypeDef",
    "AvailabilityZoneMessageOutputTypeDef",
    "InstanceCapacityOutputTypeDef",
    "BaselineEbsBandwidthMbpsOutputTypeDef",
    "BaselineEbsBandwidthMbpsRequestTypeDef",
    "BaselineEbsBandwidthMbpsTypeDef",
    "BlobAttributeValueTypeDef",
    "EbsBlockDeviceOutputTypeDef",
    "EbsBlockDeviceTypeDef",
    "BundleTaskErrorOutputTypeDef",
    "CancelBundleTaskRequestRequestTypeDef",
    "CancelCapacityReservationFleetErrorOutputTypeDef",
    "CancelCapacityReservationFleetsRequestRequestTypeDef",
    "CapacityReservationFleetCancellationStateOutputTypeDef",
    "CancelCapacityReservationRequestRequestTypeDef",
    "CancelCapacityReservationResultOutputTypeDef",
    "CancelConversionRequestRequestTypeDef",
    "CancelExportTaskRequestRequestTypeDef",
    "CancelImageLaunchPermissionRequestRequestTypeDef",
    "CancelImageLaunchPermissionResultOutputTypeDef",
    "CancelImportTaskRequestRequestTypeDef",
    "CancelImportTaskResultOutputTypeDef",
    "CancelReservedInstancesListingRequestRequestTypeDef",
    "CancelSpotFleetRequestsErrorOutputTypeDef",
    "CancelSpotFleetRequestsRequestRequestTypeDef",
    "CancelSpotFleetRequestsSuccessItemOutputTypeDef",
    "CancelSpotInstanceRequestsRequestRequestTypeDef",
    "CancelledSpotInstanceRequestOutputTypeDef",
    "CapacityAllocationOutputTypeDef",
    "FleetCapacityReservationOutputTypeDef",
    "CapacityReservationGroupOutputTypeDef",
    "CapacityReservationOptionsOutputTypeDef",
    "CapacityReservationOptionsRequestTypeDef",
    "CapacityReservationTargetResponseOutputTypeDef",
    "CapacityReservationTargetTypeDef",
    "CertificateAuthenticationOutputTypeDef",
    "CertificateAuthenticationRequestTypeDef",
    "CidrAuthorizationContextTypeDef",
    "CidrBlockOutputTypeDef",
    "ClassicLinkDnsSupportOutputTypeDef",
    "GroupIdentifierOutputTypeDef",
    "ClassicLoadBalancerOutputTypeDef",
    "ClassicLoadBalancerTypeDef",
    "ClientCertificateRevocationListStatusOutputTypeDef",
    "ClientConnectOptionsTypeDef",
    "ClientVpnEndpointAttributeStatusOutputTypeDef",
    "TagTypeDef",
    "ClientDataTypeDef",
    "ClientLoginBannerOptionsTypeDef",
    "ClientLoginBannerResponseOptionsOutputTypeDef",
    "DirectoryServiceAuthenticationOutputTypeDef",
    "FederatedAuthenticationOutputTypeDef",
    "DirectoryServiceAuthenticationRequestTypeDef",
    "FederatedAuthenticationRequestTypeDef",
    "ClientVpnConnectionStatusOutputTypeDef",
    "ClientVpnEndpointStatusOutputTypeDef",
    "ConnectionLogResponseOptionsOutputTypeDef",
    "ClientVpnRouteStatusOutputTypeDef",
    "CloudWatchLogOptionsOutputTypeDef",
    "CloudWatchLogOptionsSpecificationTypeDef",
    "CoipAddressUsageOutputTypeDef",
    "CoipCidrOutputTypeDef",
    "ConfirmProductInstanceRequestRequestTypeDef",
    "ConfirmProductInstanceResultOutputTypeDef",
    "ConnectionLogOptionsTypeDef",
    "ConnectionNotificationOutputTypeDef",
    "CopyFpgaImageRequestRequestTypeDef",
    "CopyFpgaImageResultOutputTypeDef",
    "CopyImageRequestRequestTypeDef",
    "CopyImageResultOutputTypeDef",
    "CpuOptionsOutputTypeDef",
    "CpuOptionsRequestTypeDef",
    "CpuOptionsResponseMetadataTypeDef",
    "ReservationFleetInstanceSpecificationTypeDef",
    "CreateClientVpnRouteRequestRequestTypeDef",
    "CreateCoipCidrRequestRequestTypeDef",
    "CreateDefaultSubnetRequestRequestTypeDef",
    "CreateDefaultVpcRequestRequestTypeDef",
    "NewDhcpConfigurationTypeDef",
    "TargetCapacitySpecificationRequestTypeDef",
    "DestinationOptionsRequestTypeDef",
    "StorageLocationTypeDef",
    "CreateFpgaImageResultOutputTypeDef",
    "CreateImageResultOutputTypeDef",
    "InstanceEventWindowTimeRangeRequestTypeDef",
    "ExportToS3TaskSpecificationTypeDef",
    "RequestIpamResourceTagTypeDef",
    "CreateLocalGatewayRouteRequestRequestTypeDef",
    "LocalGatewayRouteOutputTypeDef",
    "IcmpTypeCodeTypeDef",
    "PortRangeTypeDef",
    "CreateNetworkInterfacePermissionRequestRequestTypeDef",
    "InstanceIpv6AddressTypeDef",
    "Ipv4PrefixSpecificationRequestTypeDef",
    "Ipv6PrefixSpecificationRequestTypeDef",
    "PrivateIpAddressSpecificationTypeDef",
    "CreatePublicIpv4PoolResultOutputTypeDef",
    "PriceScheduleSpecificationTypeDef",
    "CreateRestoreImageTaskResultOutputTypeDef",
    "CreateRouteRequestRequestTypeDef",
    "CreateRouteRequestRouteTableCreateRouteTypeDef",
    "CreateRouteResultOutputTypeDef",
    "InstanceSpecificationTypeDef",
    "CreateSpotDatafeedSubscriptionRequestRequestTypeDef",
    "S3ObjectTagTypeDef",
    "CreateStoreImageTaskResultOutputTypeDef",
    "TrafficMirrorPortRangeRequestTypeDef",
    "TransitGatewayConnectRequestBgpOptionsTypeDef",
    "CreateTransitGatewayConnectRequestOptionsTypeDef",
    "CreateTransitGatewayMulticastDomainRequestOptionsTypeDef",
    "CreateTransitGatewayPeeringAttachmentRequestOptionsTypeDef",
    "CreateTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    "TransitGatewayRequestOptionsTypeDef",
    "CreateTransitGatewayRouteRequestRequestTypeDef",
    "CreateTransitGatewayVpcAttachmentRequestOptionsTypeDef",
    "CreateVerifiedAccessEndpointEniOptionsTypeDef",
    "CreateVerifiedAccessEndpointLoadBalancerOptionsTypeDef",
    "CreateVerifiedAccessTrustProviderDeviceOptionsTypeDef",
    "CreateVerifiedAccessTrustProviderOidcOptionsTypeDef",
    "CreateVolumePermissionTypeDef",
    "CreateVolumePermissionOutputTypeDef",
    "CreateVpcEndpointConnectionNotificationRequestRequestTypeDef",
    "DnsOptionsSpecificationTypeDef",
    "CreateVpnConnectionRouteRequestRequestTypeDef",
    "CreditSpecificationOutputTypeDef",
    "CreditSpecificationRequestTypeDef",
    "DataQueryTypeDef",
    "MetricPointOutputTypeDef",
    "DeleteCarrierGatewayRequestRequestTypeDef",
    "DeleteClientVpnEndpointRequestRequestTypeDef",
    "DeleteClientVpnRouteRequestRequestTypeDef",
    "DeleteCoipCidrRequestRequestTypeDef",
    "DeleteCoipPoolRequestRequestTypeDef",
    "DeleteCustomerGatewayRequestRequestTypeDef",
    "DeleteDhcpOptionsRequestDhcpOptionsDeleteTypeDef",
    "DeleteDhcpOptionsRequestRequestTypeDef",
    "DeleteEgressOnlyInternetGatewayRequestRequestTypeDef",
    "DeleteEgressOnlyInternetGatewayResultOutputTypeDef",
    "DeleteFleetErrorOutputTypeDef",
    "DeleteFleetSuccessItemOutputTypeDef",
    "DeleteFleetsRequestRequestTypeDef",
    "DeleteFlowLogsRequestRequestTypeDef",
    "DeleteFpgaImageRequestRequestTypeDef",
    "DeleteFpgaImageResultOutputTypeDef",
    "DeleteInstanceConnectEndpointRequestRequestTypeDef",
    "DeleteInstanceEventWindowRequestRequestTypeDef",
    "InstanceEventWindowStateChangeOutputTypeDef",
    "DeleteInternetGatewayRequestInternetGatewayDeleteTypeDef",
    "DeleteInternetGatewayRequestRequestTypeDef",
    "DeleteIpamPoolRequestRequestTypeDef",
    "DeleteIpamRequestRequestTypeDef",
    "DeleteIpamResourceDiscoveryRequestRequestTypeDef",
    "DeleteIpamScopeRequestRequestTypeDef",
    "DeleteKeyPairRequestKeyPairDeleteTypeDef",
    "DeleteKeyPairRequestKeyPairInfoDeleteTypeDef",
    "DeleteKeyPairRequestRequestTypeDef",
    "DeleteLaunchTemplateRequestRequestTypeDef",
    "DeleteLaunchTemplateVersionsRequestRequestTypeDef",
    "ResponseErrorOutputTypeDef",
    "DeleteLaunchTemplateVersionsResponseSuccessItemOutputTypeDef",
    "DeleteLocalGatewayRouteRequestRequestTypeDef",
    "DeleteLocalGatewayRouteTableRequestRequestTypeDef",
    "DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    "DeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    "DeleteManagedPrefixListRequestRequestTypeDef",
    "DeleteNatGatewayRequestRequestTypeDef",
    "DeleteNatGatewayResultOutputTypeDef",
    "DeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef",
    "DeleteNetworkAclEntryRequestRequestTypeDef",
    "DeleteNetworkAclRequestNetworkAclDeleteTypeDef",
    "DeleteNetworkAclRequestRequestTypeDef",
    "DeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    "DeleteNetworkInsightsAccessScopeAnalysisResultOutputTypeDef",
    "DeleteNetworkInsightsAccessScopeRequestRequestTypeDef",
    "DeleteNetworkInsightsAccessScopeResultOutputTypeDef",
    "DeleteNetworkInsightsAnalysisRequestRequestTypeDef",
    "DeleteNetworkInsightsAnalysisResultOutputTypeDef",
    "DeleteNetworkInsightsPathRequestRequestTypeDef",
    "DeleteNetworkInsightsPathResultOutputTypeDef",
    "DeleteNetworkInterfacePermissionRequestRequestTypeDef",
    "DeleteNetworkInterfacePermissionResultOutputTypeDef",
    "DeleteNetworkInterfaceRequestNetworkInterfaceDeleteTypeDef",
    "DeleteNetworkInterfaceRequestRequestTypeDef",
    "DeletePlacementGroupRequestPlacementGroupDeleteTypeDef",
    "DeletePlacementGroupRequestRequestTypeDef",
    "DeletePublicIpv4PoolRequestRequestTypeDef",
    "DeletePublicIpv4PoolResultOutputTypeDef",
    "DeleteQueuedReservedInstancesErrorOutputTypeDef",
    "DeleteQueuedReservedInstancesRequestRequestTypeDef",
    "SuccessfulQueuedPurchaseDeletionOutputTypeDef",
    "DeleteRouteRequestRequestTypeDef",
    "DeleteRouteRequestRouteDeleteTypeDef",
    "DeleteRouteTableRequestRequestTypeDef",
    "DeleteRouteTableRequestRouteTableDeleteTypeDef",
    "DeleteSecurityGroupRequestRequestTypeDef",
    "DeleteSecurityGroupRequestSecurityGroupDeleteTypeDef",
    "DeleteSnapshotRequestRequestTypeDef",
    "DeleteSnapshotRequestSnapshotDeleteTypeDef",
    "DeleteSpotDatafeedSubscriptionRequestRequestTypeDef",
    "DeleteSubnetCidrReservationRequestRequestTypeDef",
    "DeleteSubnetRequestRequestTypeDef",
    "DeleteSubnetRequestSubnetDeleteTypeDef",
    "DeleteTagsRequestTagDeleteTypeDef",
    "DeleteTrafficMirrorFilterRequestRequestTypeDef",
    "DeleteTrafficMirrorFilterResultOutputTypeDef",
    "DeleteTrafficMirrorFilterRuleRequestRequestTypeDef",
    "DeleteTrafficMirrorFilterRuleResultOutputTypeDef",
    "DeleteTrafficMirrorSessionRequestRequestTypeDef",
    "DeleteTrafficMirrorSessionResultOutputTypeDef",
    "DeleteTrafficMirrorTargetRequestRequestTypeDef",
    "DeleteTrafficMirrorTargetResultOutputTypeDef",
    "DeleteTransitGatewayConnectPeerRequestRequestTypeDef",
    "DeleteTransitGatewayConnectRequestRequestTypeDef",
    "DeleteTransitGatewayMulticastDomainRequestRequestTypeDef",
    "DeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    "DeleteTransitGatewayPolicyTableRequestRequestTypeDef",
    "DeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    "DeleteTransitGatewayRequestRequestTypeDef",
    "DeleteTransitGatewayRouteRequestRequestTypeDef",
    "DeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    "DeleteTransitGatewayRouteTableRequestRequestTypeDef",
    "DeleteTransitGatewayVpcAttachmentRequestRequestTypeDef",
    "DeleteVerifiedAccessEndpointRequestRequestTypeDef",
    "DeleteVerifiedAccessGroupRequestRequestTypeDef",
    "DeleteVerifiedAccessInstanceRequestRequestTypeDef",
    "DeleteVerifiedAccessTrustProviderRequestRequestTypeDef",
    "DeleteVolumeRequestRequestTypeDef",
    "DeleteVolumeRequestVolumeDeleteTypeDef",
    "DeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef",
    "DeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef",
    "DeleteVpcEndpointsRequestRequestTypeDef",
    "DeleteVpcPeeringConnectionRequestRequestTypeDef",
    "DeleteVpcPeeringConnectionRequestVpcPeeringConnectionDeleteTypeDef",
    "DeleteVpcPeeringConnectionResultOutputTypeDef",
    "DeleteVpcRequestRequestTypeDef",
    "DeleteVpcRequestVpcDeleteTypeDef",
    "DeleteVpnConnectionRequestRequestTypeDef",
    "DeleteVpnConnectionRouteRequestRequestTypeDef",
    "DeleteVpnGatewayRequestRequestTypeDef",
    "DeprovisionByoipCidrRequestRequestTypeDef",
    "DeprovisionIpamPoolCidrRequestRequestTypeDef",
    "DeprovisionPublicIpv4PoolCidrRequestRequestTypeDef",
    "DeprovisionPublicIpv4PoolCidrResultOutputTypeDef",
    "DeregisterImageRequestImageDeregisterTypeDef",
    "DeregisterImageRequestRequestTypeDef",
    "DeregisterInstanceTagAttributeRequestTypeDef",
    "InstanceTagNotificationAttributeOutputTypeDef",
    "DeregisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef",
    "TransitGatewayMulticastDeregisteredGroupMembersOutputTypeDef",
    "DeregisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef",
    "TransitGatewayMulticastDeregisteredGroupSourcesOutputTypeDef",
    "DescribeAccountAttributesRequestRequestTypeDef",
    "DescribeAddressTransfersRequestDescribeAddressTransfersPaginateTypeDef",
    "DescribeAddressTransfersRequestRequestTypeDef",
    "DescribeAddressesAttributeRequestDescribeAddressesAttributePaginateTypeDef",
    "DescribeAddressesAttributeRequestRequestTypeDef",
    "FilterTypeDef",
    "DescribeAggregateIdFormatRequestRequestTypeDef",
    "IdFormatOutputTypeDef",
    "SubscriptionOutputTypeDef",
    "WaiterConfigTypeDef",
    "DescribeByoipCidrsRequestDescribeByoipCidrsPaginateTypeDef",
    "DescribeByoipCidrsRequestRequestTypeDef",
    "DescribeConversionTasksRequestRequestTypeDef",
    "FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef",
    "FastLaunchSnapshotConfigurationResponseOutputTypeDef",
    "DescribeFastSnapshotRestoreSuccessItemOutputTypeDef",
    "DescribeFleetHistoryRequestRequestTypeDef",
    "DescribeFpgaImageAttributeRequestRequestTypeDef",
    "HostOfferingOutputTypeDef",
    "DescribeIdFormatRequestRequestTypeDef",
    "DescribeIdentityIdFormatRequestRequestTypeDef",
    "DescribeImageAttributeRequestImageDescribeAttributeTypeDef",
    "DescribeImageAttributeRequestRequestTypeDef",
    "DescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef",
    "DescribeInstanceAttributeRequestRequestTypeDef",
    "InstanceCreditSpecificationOutputTypeDef",
    "DescribeInstanceEventNotificationAttributesRequestRequestTypeDef",
    "InstanceTypeOfferingOutputTypeDef",
    "MovingAddressStatusOutputTypeDef",
    "DescribeNetworkInterfaceAttributeRequestNetworkInterfaceDescribeAttributeTypeDef",
    "DescribeNetworkInterfaceAttributeRequestRequestTypeDef",
    "PrefixListOutputTypeDef",
    "DescribePrincipalIdFormatRequestDescribePrincipalIdFormatPaginateTypeDef",
    "DescribePrincipalIdFormatRequestRequestTypeDef",
    "RegionOutputTypeDef",
    "ScheduledInstanceRecurrenceRequestTypeDef",
    "SlotDateTimeRangeRequestTypeDef",
    "SlotStartTimeRangeRequestTypeDef",
    "DescribeSecurityGroupReferencesRequestRequestTypeDef",
    "SecurityGroupReferenceOutputTypeDef",
    "DescribeSnapshotAttributeRequestRequestTypeDef",
    "DescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef",
    "ProductCodeOutputTypeDef",
    "DescribeSpotDatafeedSubscriptionRequestRequestTypeDef",
    "DescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef",
    "DescribeSpotFleetInstancesRequestRequestTypeDef",
    "DescribeSpotFleetRequestHistoryRequestRequestTypeDef",
    "DescribeSpotFleetRequestsRequestDescribeSpotFleetRequestsPaginateTypeDef",
    "DescribeSpotFleetRequestsRequestRequestTypeDef",
    "SpotPriceOutputTypeDef",
    "DescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef",
    "DescribeStaleSecurityGroupsRequestRequestTypeDef",
    "StoreImageTaskResultOutputTypeDef",
    "TagDescriptionOutputTypeDef",
    "DescribeVolumeAttributeRequestRequestTypeDef",
    "DescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef",
    "VolumeModificationOutputTypeDef",
    "DescribeVpcAttributeRequestRequestTypeDef",
    "DescribeVpcAttributeRequestVpcDescribeAttributeTypeDef",
    "DescribeVpcClassicLinkDnsSupportRequestDescribeVpcClassicLinkDnsSupportPaginateTypeDef",
    "DescribeVpcClassicLinkDnsSupportRequestRequestTypeDef",
    "DestinationOptionsResponseOutputTypeDef",
    "DetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef",
    "DetachClassicLinkVpcRequestRequestTypeDef",
    "DetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef",
    "DetachClassicLinkVpcResultOutputTypeDef",
    "DetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef",
    "DetachInternetGatewayRequestRequestTypeDef",
    "DetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef",
    "DetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef",
    "DetachNetworkInterfaceRequestRequestTypeDef",
    "DetachVerifiedAccessTrustProviderRequestRequestTypeDef",
    "DetachVolumeRequestInstanceDetachVolumeTypeDef",
    "DetachVolumeRequestRequestTypeDef",
    "DetachVolumeRequestVolumeDetachFromInstanceTypeDef",
    "DetachVpnGatewayRequestRequestTypeDef",
    "DeviceOptionsOutputTypeDef",
    "DisableAddressTransferRequestRequestTypeDef",
    "DisableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef",
    "DisableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef",
    "DisableEbsEncryptionByDefaultRequestRequestTypeDef",
    "DisableEbsEncryptionByDefaultResultOutputTypeDef",
    "DisableFastLaunchRequestRequestTypeDef",
    "DisableFastSnapshotRestoreStateErrorOutputTypeDef",
    "DisableFastSnapshotRestoreSuccessItemOutputTypeDef",
    "DisableFastSnapshotRestoresRequestRequestTypeDef",
    "DisableImageDeprecationRequestRequestTypeDef",
    "DisableImageDeprecationResultOutputTypeDef",
    "DisableIpamOrganizationAdminAccountRequestRequestTypeDef",
    "DisableIpamOrganizationAdminAccountResultOutputTypeDef",
    "DisableSerialConsoleAccessRequestRequestTypeDef",
    "DisableSerialConsoleAccessResultOutputTypeDef",
    "DisableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    "TransitGatewayPropagationOutputTypeDef",
    "DisableVgwRoutePropagationRequestRequestTypeDef",
    "DisableVpcClassicLinkDnsSupportRequestRequestTypeDef",
    "DisableVpcClassicLinkDnsSupportResultOutputTypeDef",
    "DisableVpcClassicLinkRequestRequestTypeDef",
    "DisableVpcClassicLinkRequestVpcDisableClassicLinkTypeDef",
    "DisableVpcClassicLinkResultOutputTypeDef",
    "DisassociateAddressRequestClassicAddressDisassociateTypeDef",
    "DisassociateAddressRequestNetworkInterfaceAssociationDeleteTypeDef",
    "DisassociateAddressRequestRequestTypeDef",
    "DisassociateClientVpnTargetNetworkRequestRequestTypeDef",
    "DisassociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    "DisassociateEnclaveCertificateIamRoleResultOutputTypeDef",
    "DisassociateIamInstanceProfileRequestRequestTypeDef",
    "DisassociateIpamResourceDiscoveryRequestRequestTypeDef",
    "DisassociateNatGatewayAddressRequestRequestTypeDef",
    "DisassociateRouteTableRequestRequestTypeDef",
    "DisassociateRouteTableRequestRouteTableAssociationDeleteTypeDef",
    "DisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef",
    "DisassociateSubnetCidrBlockRequestRequestTypeDef",
    "DisassociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    "DisassociateTransitGatewayPolicyTableRequestRequestTypeDef",
    "DisassociateTransitGatewayRouteTableRequestRequestTypeDef",
    "DisassociateTrunkInterfaceRequestRequestTypeDef",
    "DisassociateTrunkInterfaceResultOutputTypeDef",
    "DisassociateVpcCidrBlockRequestRequestTypeDef",
    "DiskImageDescriptionOutputTypeDef",
    "DiskImageDetailTypeDef",
    "VolumeDetailTypeDef",
    "DiskImageVolumeDescriptionOutputTypeDef",
    "DiskInfoOutputTypeDef",
    "DnsEntryOutputTypeDef",
    "DnsOptionsOutputTypeDef",
    "DnsServersOptionsModifyStructureTypeDef",
    "EbsOptimizedInfoOutputTypeDef",
    "EbsInstanceBlockDeviceOutputTypeDef",
    "EbsInstanceBlockDeviceSpecificationTypeDef",
    "EfaInfoOutputTypeDef",
    "InternetGatewayAttachmentOutputTypeDef",
    "ElasticGpuAssociationOutputTypeDef",
    "ElasticGpuHealthOutputTypeDef",
    "ElasticGpuSpecificationResponseOutputTypeDef",
    "ElasticGpuSpecificationTypeDef",
    "ElasticInferenceAcceleratorAssociationOutputTypeDef",
    "ElasticInferenceAcceleratorTypeDef",
    "EmptyResponseMetadataTypeDef",
    "EnaSrdUdpSpecificationTypeDef",
    "EnableAddressTransferRequestRequestTypeDef",
    "EnableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef",
    "EnableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef",
    "EnableEbsEncryptionByDefaultRequestRequestTypeDef",
    "EnableEbsEncryptionByDefaultResultOutputTypeDef",
    "FastLaunchLaunchTemplateSpecificationRequestTypeDef",
    "FastLaunchSnapshotConfigurationRequestTypeDef",
    "EnableFastSnapshotRestoreStateErrorOutputTypeDef",
    "EnableFastSnapshotRestoreSuccessItemOutputTypeDef",
    "EnableFastSnapshotRestoresRequestRequestTypeDef",
    "EnableImageDeprecationRequestRequestTypeDef",
    "EnableImageDeprecationResultOutputTypeDef",
    "EnableIpamOrganizationAdminAccountRequestRequestTypeDef",
    "EnableIpamOrganizationAdminAccountResultOutputTypeDef",
    "EnableReachabilityAnalyzerOrganizationSharingRequestRequestTypeDef",
    "EnableReachabilityAnalyzerOrganizationSharingResultOutputTypeDef",
    "EnableSerialConsoleAccessRequestRequestTypeDef",
    "EnableSerialConsoleAccessResultOutputTypeDef",
    "EnableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    "EnableVgwRoutePropagationRequestRequestTypeDef",
    "EnableVolumeIORequestRequestTypeDef",
    "EnableVolumeIORequestVolumeEnableIoTypeDef",
    "EnableVpcClassicLinkDnsSupportRequestRequestTypeDef",
    "EnableVpcClassicLinkDnsSupportResultOutputTypeDef",
    "EnableVpcClassicLinkRequestRequestTypeDef",
    "EnableVpcClassicLinkRequestVpcEnableClassicLinkTypeDef",
    "EnableVpcClassicLinkResultOutputTypeDef",
    "EnclaveOptionsOutputTypeDef",
    "EnclaveOptionsRequestTypeDef",
    "EnclaveOptionsResponseMetadataTypeDef",
    "EventInformationOutputTypeDef",
    "TransitGatewayRouteTableRouteOutputTypeDef",
    "ExportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    "ExportClientVpnClientConfigurationRequestRequestTypeDef",
    "ExportClientVpnClientConfigurationResultOutputTypeDef",
    "ExportTaskS3LocationRequestTypeDef",
    "ExportTaskS3LocationOutputTypeDef",
    "ExportToS3TaskOutputTypeDef",
    "InstanceExportDetailsOutputTypeDef",
    "ExportTransitGatewayRoutesResultOutputTypeDef",
    "FilterPortRangeOutputTypeDef",
    "TargetCapacitySpecificationOutputTypeDef",
    "FleetLaunchTemplateSpecificationOutputTypeDef",
    "FleetLaunchTemplateSpecificationRequestTypeDef",
    "PlacementResponseOutputTypeDef",
    "PlacementTypeDef",
    "FleetLaunchTemplateSpecificationTypeDef",
    "FleetSpotCapacityRebalanceOutputTypeDef",
    "FleetSpotCapacityRebalanceRequestTypeDef",
    "FpgaDeviceMemoryInfoOutputTypeDef",
    "LoadPermissionOutputTypeDef",
    "FpgaImageStateOutputTypeDef",
    "PciIdOutputTypeDef",
    "GetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef",
    "GetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef",
    "GetAssociatedIpv6PoolCidrsRequestRequestTypeDef",
    "Ipv6CidrAssociationOutputTypeDef",
    "GetCapacityReservationUsageRequestRequestTypeDef",
    "InstanceUsageOutputTypeDef",
    "GetConsoleOutputRequestInstanceConsoleOutputTypeDef",
    "GetConsoleOutputRequestRequestTypeDef",
    "GetConsoleOutputResultOutputTypeDef",
    "GetConsoleScreenshotRequestRequestTypeDef",
    "GetConsoleScreenshotResultOutputTypeDef",
    "GetDefaultCreditSpecificationRequestRequestTypeDef",
    "InstanceFamilyCreditSpecificationOutputTypeDef",
    "GetEbsDefaultKmsKeyIdRequestRequestTypeDef",
    "GetEbsDefaultKmsKeyIdResultOutputTypeDef",
    "GetEbsEncryptionByDefaultRequestRequestTypeDef",
    "GetEbsEncryptionByDefaultResultOutputTypeDef",
    "GetFlowLogsIntegrationTemplateResultOutputTypeDef",
    "GetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef",
    "GetGroupsForCapacityReservationRequestRequestTypeDef",
    "GetHostReservationPurchasePreviewRequestRequestTypeDef",
    "PurchaseOutputTypeDef",
    "InstanceTypeInfoFromInstanceRequirementsOutputTypeDef",
    "GetInstanceUefiDataRequestRequestTypeDef",
    "GetInstanceUefiDataResultOutputTypeDef",
    "GetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef",
    "GetIpamAddressHistoryRequestRequestTypeDef",
    "IpamAddressHistoryRecordOutputTypeDef",
    "GetLaunchTemplateDataRequestRequestTypeDef",
    "GetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef",
    "GetManagedPrefixListAssociationsRequestRequestTypeDef",
    "PrefixListAssociationOutputTypeDef",
    "GetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef",
    "GetManagedPrefixListEntriesRequestRequestTypeDef",
    "PrefixListEntryOutputTypeDef",
    "GetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef",
    "GetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef",
    "GetNetworkInsightsAccessScopeContentRequestRequestTypeDef",
    "GetPasswordDataRequestInstancePasswordDataTypeDef",
    "GetPasswordDataRequestRequestTypeDef",
    "GetPasswordDataResultOutputTypeDef",
    "ReservationValueOutputTypeDef",
    "GetSerialConsoleAccessStatusRequestRequestTypeDef",
    "GetSerialConsoleAccessStatusResultOutputTypeDef",
    "SpotPlacementScoreOutputTypeDef",
    "TransitGatewayAttachmentPropagationOutputTypeDef",
    "TransitGatewayRouteTableAssociationOutputTypeDef",
    "TransitGatewayRouteTablePropagationOutputTypeDef",
    "GetVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    "GetVerifiedAccessEndpointPolicyResultOutputTypeDef",
    "GetVerifiedAccessGroupPolicyRequestRequestTypeDef",
    "GetVerifiedAccessGroupPolicyResultOutputTypeDef",
    "GetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef",
    "GetVpnConnectionDeviceSampleConfigurationResultOutputTypeDef",
    "GetVpnConnectionDeviceTypesRequestGetVpnConnectionDeviceTypesPaginateTypeDef",
    "GetVpnConnectionDeviceTypesRequestRequestTypeDef",
    "VpnConnectionDeviceTypeOutputTypeDef",
    "GetVpnTunnelReplacementStatusRequestRequestTypeDef",
    "MaintenanceDetailsOutputTypeDef",
    "GpuDeviceMemoryInfoOutputTypeDef",
    "GroupIdentifierTypeDef",
    "HibernationOptionsOutputTypeDef",
    "HibernationOptionsRequestTypeDef",
    "HibernationOptionsResponseMetadataTypeDef",
    "HostInstanceOutputTypeDef",
    "HostPropertiesOutputTypeDef",
    "IKEVersionsListValueOutputTypeDef",
    "IKEVersionsRequestListValueTypeDef",
    "IamInstanceProfileOutputTypeDef",
    "IamInstanceProfileResponseMetadataTypeDef",
    "IamInstanceProfileSpecificationOutputTypeDef",
    "IcmpTypeCodeOutputTypeDef",
    "LaunchPermissionOutputTypeDef",
    "UserBucketTypeDef",
    "StateReasonOutputTypeDef",
    "ImageRecycleBinInfoOutputTypeDef",
    "ImportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    "ImportClientVpnClientCertificateRevocationListResultOutputTypeDef",
    "ImportImageLicenseConfigurationRequestTypeDef",
    "ImportImageLicenseConfigurationResponseOutputTypeDef",
    "UserDataTypeDef",
    "InferenceDeviceInfoOutputTypeDef",
    "InstanceCountOutputTypeDef",
    "InstanceCreditSpecificationRequestTypeDef",
    "InstanceEventWindowTimeRangeOutputTypeDef",
    "InstanceIpv4PrefixOutputTypeDef",
    "InstanceIpv6AddressOutputTypeDef",
    "InstanceIpv6AddressRequestTypeDef",
    "InstanceIpv6PrefixOutputTypeDef",
    "InstanceMaintenanceOptionsOutputTypeDef",
    "InstanceMaintenanceOptionsRequestTypeDef",
    "InstanceMaintenanceOptionsResponseMetadataTypeDef",
    "SpotMarketOptionsTypeDef",
    "InstanceMetadataOptionsRequestTypeDef",
    "InstanceMetadataOptionsResponseOutputTypeDef",
    "InstanceMetadataOptionsResponseResponseMetadataTypeDef",
    "MonitoringOutputTypeDef",
    "InstanceNetworkInterfaceAssociationOutputTypeDef",
    "InstanceNetworkInterfaceAttachmentOutputTypeDef",
    "Ipv4PrefixSpecificationRequestOutputTypeDef",
    "Ipv6PrefixSpecificationRequestOutputTypeDef",
    "PrivateIpAddressSpecificationOutputTypeDef",
    "InstanceStateOutputTypeDef",
    "LicenseConfigurationOutputTypeDef",
    "PlacementOutputTypeDef",
    "PrivateDnsNameOptionsResponseOutputTypeDef",
    "MemoryGiBPerVCpuOutputTypeDef",
    "MemoryMiBOutputTypeDef",
    "NetworkBandwidthGbpsOutputTypeDef",
    "NetworkInterfaceCountOutputTypeDef",
    "TotalLocalStorageGBOutputTypeDef",
    "VCpuCountRangeOutputTypeDef",
    "MemoryGiBPerVCpuRequestTypeDef",
    "MemoryMiBRequestTypeDef",
    "NetworkBandwidthGbpsRequestTypeDef",
    "NetworkInterfaceCountRequestTypeDef",
    "TotalLocalStorageGBRequestTypeDef",
    "VCpuCountRangeRequestTypeDef",
    "MemoryGiBPerVCpuTypeDef",
    "MemoryMiBTypeDef",
    "NetworkBandwidthGbpsTypeDef",
    "NetworkInterfaceCountTypeDef",
    "TotalLocalStorageGBTypeDef",
    "VCpuCountRangeTypeDef",
    "InstanceStateResponseMetadataTypeDef",
    "InstanceStatusDetailsOutputTypeDef",
    "InstanceStatusEventOutputTypeDef",
    "MemoryInfoOutputTypeDef",
    "PlacementGroupInfoOutputTypeDef",
    "ProcessorInfoOutputTypeDef",
    "VCpuInfoOutputTypeDef",
    "IpRangeOutputTypeDef",
    "Ipv6RangeOutputTypeDef",
    "PrefixListIdOutputTypeDef",
    "UserIdGroupPairOutputTypeDef",
    "IpRangeTypeDef",
    "Ipv6RangeTypeDef",
    "PrefixListIdTypeDef",
    "UserIdGroupPairTypeDef",
    "IpamCidrAuthorizationContextTypeDef",
    "IpamDiscoveryFailureReasonOutputTypeDef",
    "IpamResourceTagOutputTypeDef",
    "IpamOperatingRegionOutputTypeDef",
    "IpamPoolCidrFailureReasonOutputTypeDef",
    "Ipv4PrefixSpecificationResponseOutputTypeDef",
    "Ipv6CidrBlockOutputTypeDef",
    "PoolCidrBlockOutputTypeDef",
    "Ipv6PrefixSpecificationOutputTypeDef",
    "Ipv6PrefixSpecificationResponseOutputTypeDef",
    "LastErrorOutputTypeDef",
    "LaunchPermissionTypeDef",
    "RunInstancesMonitoringEnabledOutputTypeDef",
    "SpotPlacementOutputTypeDef",
    "LaunchTemplateEbsBlockDeviceOutputTypeDef",
    "LaunchTemplateEbsBlockDeviceRequestTypeDef",
    "LaunchTemplateCpuOptionsOutputTypeDef",
    "LaunchTemplateCpuOptionsRequestTypeDef",
    "LaunchTemplateElasticInferenceAcceleratorResponseOutputTypeDef",
    "LaunchTemplateElasticInferenceAcceleratorTypeDef",
    "LaunchTemplateEnclaveOptionsOutputTypeDef",
    "LaunchTemplateEnclaveOptionsRequestTypeDef",
    "LaunchTemplateHibernationOptionsOutputTypeDef",
    "LaunchTemplateHibernationOptionsRequestTypeDef",
    "LaunchTemplateIamInstanceProfileSpecificationOutputTypeDef",
    "LaunchTemplateIamInstanceProfileSpecificationRequestTypeDef",
    "LaunchTemplateInstanceMaintenanceOptionsOutputTypeDef",
    "LaunchTemplateInstanceMaintenanceOptionsRequestTypeDef",
    "LaunchTemplateSpotMarketOptionsOutputTypeDef",
    "LaunchTemplateSpotMarketOptionsRequestTypeDef",
    "LaunchTemplateInstanceMetadataOptionsOutputTypeDef",
    "LaunchTemplateInstanceMetadataOptionsRequestTypeDef",
    "LaunchTemplateLicenseConfigurationOutputTypeDef",
    "LaunchTemplateLicenseConfigurationRequestTypeDef",
    "LaunchTemplatePlacementOutputTypeDef",
    "LaunchTemplatePlacementRequestTypeDef",
    "LaunchTemplatePrivateDnsNameOptionsOutputTypeDef",
    "LaunchTemplatePrivateDnsNameOptionsRequestTypeDef",
    "LaunchTemplateSpecificationTypeDef",
    "LaunchTemplatesMonitoringOutputTypeDef",
    "LaunchTemplatesMonitoringRequestTypeDef",
    "LicenseConfigurationRequestTypeDef",
    "ListImagesInRecycleBinRequestListImagesInRecycleBinPaginateTypeDef",
    "ListImagesInRecycleBinRequestRequestTypeDef",
    "ListSnapshotsInRecycleBinRequestListSnapshotsInRecycleBinPaginateTypeDef",
    "ListSnapshotsInRecycleBinRequestRequestTypeDef",
    "SnapshotRecycleBinInfoOutputTypeDef",
    "LoadPermissionRequestTypeDef",
    "ModifyAddressAttributeRequestRequestTypeDef",
    "ModifyAvailabilityZoneGroupRequestRequestTypeDef",
    "ModifyAvailabilityZoneGroupResultOutputTypeDef",
    "ModifyCapacityReservationFleetRequestRequestTypeDef",
    "ModifyCapacityReservationFleetResultOutputTypeDef",
    "ModifyCapacityReservationRequestRequestTypeDef",
    "ModifyCapacityReservationResultOutputTypeDef",
    "ModifyClientVpnEndpointResultOutputTypeDef",
    "ModifyDefaultCreditSpecificationRequestRequestTypeDef",
    "ModifyEbsDefaultKmsKeyIdRequestRequestTypeDef",
    "ModifyEbsDefaultKmsKeyIdResultOutputTypeDef",
    "ModifyFleetResultOutputTypeDef",
    "ModifyHostsRequestRequestTypeDef",
    "ModifyIdFormatRequestRequestTypeDef",
    "ModifyIdentityIdFormatRequestRequestTypeDef",
    "ModifyInstanceCapacityReservationAttributesResultOutputTypeDef",
    "SuccessfulInstanceCreditSpecificationItemOutputTypeDef",
    "ModifyInstanceEventStartTimeRequestRequestTypeDef",
    "ModifyInstanceMaintenanceOptionsRequestRequestTypeDef",
    "ModifyInstanceMaintenanceOptionsResultOutputTypeDef",
    "ModifyInstanceMetadataOptionsRequestRequestTypeDef",
    "ModifyInstancePlacementRequestRequestTypeDef",
    "ModifyInstancePlacementResultOutputTypeDef",
    "RemoveIpamOperatingRegionTypeDef",
    "ModifyIpamResourceCidrRequestRequestTypeDef",
    "ModifyIpamScopeRequestRequestTypeDef",
    "ModifyLaunchTemplateRequestRequestTypeDef",
    "ModifyLocalGatewayRouteRequestRequestTypeDef",
    "RemovePrefixListEntryTypeDef",
    "NetworkInterfaceAttachmentChangesTypeDef",
    "ModifyPrivateDnsNameOptionsRequestRequestTypeDef",
    "ModifyPrivateDnsNameOptionsResultOutputTypeDef",
    "ReservedInstancesConfigurationTypeDef",
    "ModifyReservedInstancesResultOutputTypeDef",
    "ModifySecurityGroupRulesResultOutputTypeDef",
    "ModifySnapshotTierRequestRequestTypeDef",
    "ModifySnapshotTierResultOutputTypeDef",
    "ModifySpotFleetRequestResponseOutputTypeDef",
    "ModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef",
    "ModifyTrafficMirrorSessionRequestRequestTypeDef",
    "ModifyTransitGatewayOptionsTypeDef",
    "ModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    "ModifyTransitGatewayVpcAttachmentRequestOptionsTypeDef",
    "ModifyVerifiedAccessEndpointEniOptionsTypeDef",
    "ModifyVerifiedAccessEndpointLoadBalancerOptionsTypeDef",
    "ModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    "ModifyVerifiedAccessEndpointPolicyResultOutputTypeDef",
    "ModifyVerifiedAccessGroupPolicyRequestRequestTypeDef",
    "ModifyVerifiedAccessGroupPolicyResultOutputTypeDef",
    "ModifyVerifiedAccessGroupRequestRequestTypeDef",
    "ModifyVerifiedAccessInstanceRequestRequestTypeDef",
    "ModifyVerifiedAccessTrustProviderOidcOptionsTypeDef",
    "ModifyVolumeRequestRequestTypeDef",
    "ModifyVpcEndpointConnectionNotificationRequestRequestTypeDef",
    "ModifyVpcEndpointConnectionNotificationResultOutputTypeDef",
    "ModifyVpcEndpointResultOutputTypeDef",
    "ModifyVpcEndpointServiceConfigurationRequestRequestTypeDef",
    "ModifyVpcEndpointServiceConfigurationResultOutputTypeDef",
    "ModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef",
    "ModifyVpcEndpointServicePayerResponsibilityResultOutputTypeDef",
    "ModifyVpcEndpointServicePermissionsRequestRequestTypeDef",
    "PeeringConnectionOptionsRequestTypeDef",
    "PeeringConnectionOptionsOutputTypeDef",
    "ModifyVpcTenancyRequestRequestTypeDef",
    "ModifyVpcTenancyResultOutputTypeDef",
    "ModifyVpnConnectionOptionsRequestRequestTypeDef",
    "ModifyVpnConnectionRequestRequestTypeDef",
    "ModifyVpnTunnelCertificateRequestRequestTypeDef",
    "Phase1DHGroupNumbersRequestListValueTypeDef",
    "Phase1EncryptionAlgorithmsRequestListValueTypeDef",
    "Phase1IntegrityAlgorithmsRequestListValueTypeDef",
    "Phase2DHGroupNumbersRequestListValueTypeDef",
    "Phase2EncryptionAlgorithmsRequestListValueTypeDef",
    "Phase2IntegrityAlgorithmsRequestListValueTypeDef",
    "MonitorInstancesRequestInstanceMonitorTypeDef",
    "MonitorInstancesRequestRequestTypeDef",
    "MonitoringResponseMetadataTypeDef",
    "MoveAddressToVpcRequestRequestTypeDef",
    "MoveAddressToVpcResultOutputTypeDef",
    "MoveByoipCidrToIpamRequestRequestTypeDef",
    "ProvisionedBandwidthOutputTypeDef",
    "NetworkAclAssociationOutputTypeDef",
    "NetworkCardInfoOutputTypeDef",
    "NetworkInterfaceAssociationOutputTypeDef",
    "NetworkInterfaceAssociationResponseMetadataTypeDef",
    "NetworkInterfaceIpv6AddressOutputTypeDef",
    "NetworkInterfacePermissionStateOutputTypeDef",
    "OidcOptionsOutputTypeDef",
    "PacketHeaderStatementOutputTypeDef",
    "PacketHeaderStatementRequestTypeDef",
    "PaginatorConfigTypeDef",
    "RequestFilterPortRangeTypeDef",
    "ResourceStatementOutputTypeDef",
    "ResourceStatementRequestTypeDef",
    "PeeringAttachmentStatusOutputTypeDef",
    "PeeringTgwInfoOutputTypeDef",
    "Phase1DHGroupNumbersListValueOutputTypeDef",
    "Phase1EncryptionAlgorithmsListValueOutputTypeDef",
    "Phase1IntegrityAlgorithmsListValueOutputTypeDef",
    "Phase2DHGroupNumbersListValueOutputTypeDef",
    "Phase2EncryptionAlgorithmsListValueOutputTypeDef",
    "Phase2IntegrityAlgorithmsListValueOutputTypeDef",
    "PlacementResponseMetadataTypeDef",
    "PriceScheduleOutputTypeDef",
    "PricingDetailOutputTypeDef",
    "PrivateDnsDetailsOutputTypeDef",
    "PrivateDnsNameConfigurationOutputTypeDef",
    "PrivateDnsNameOptionsOnLaunchOutputTypeDef",
    "PrivateDnsNameOptionsOnLaunchResponseMetadataTypeDef",
    "PrivateDnsNameOptionsRequestTypeDef",
    "PrivateDnsNameOptionsResponseResponseMetadataTypeDef",
    "PropagatingVgwOutputTypeDef",
    "ProvisionPublicIpv4PoolCidrRequestRequestTypeDef",
    "PublicIpv4PoolRangeOutputTypeDef",
    "PurchaseRequestTypeDef",
    "ReservedInstanceLimitPriceTypeDef",
    "PurchaseReservedInstancesOfferingResultOutputTypeDef",
    "RebootInstancesRequestInstanceRebootTypeDef",
    "RebootInstancesRequestRequestTypeDef",
    "RecurringChargeOutputTypeDef",
    "ReferencedSecurityGroupOutputTypeDef",
    "RegisterImageResultOutputTypeDef",
    "RegisterInstanceTagAttributeRequestTypeDef",
    "RegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef",
    "TransitGatewayMulticastRegisteredGroupMembersOutputTypeDef",
    "RegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef",
    "TransitGatewayMulticastRegisteredGroupSourcesOutputTypeDef",
    "RejectTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    "RejectTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    "RejectTransitGatewayVpcAttachmentRequestRequestTypeDef",
    "RejectVpcEndpointConnectionsRequestRequestTypeDef",
    "RejectVpcPeeringConnectionRequestRequestTypeDef",
    "RejectVpcPeeringConnectionRequestVpcPeeringConnectionRejectTypeDef",
    "RejectVpcPeeringConnectionResultOutputTypeDef",
    "ReleaseAddressRequestClassicAddressReleaseTypeDef",
    "ReleaseAddressRequestRequestTypeDef",
    "ReleaseAddressRequestVpcAddressReleaseTypeDef",
    "ReleaseHostsRequestRequestTypeDef",
    "ReleaseIpamPoolAllocationRequestRequestTypeDef",
    "ReleaseIpamPoolAllocationResultOutputTypeDef",
    "ReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef",
    "ReplaceNetworkAclAssociationRequestRequestTypeDef",
    "ReplaceNetworkAclAssociationResultOutputTypeDef",
    "ReplaceRouteRequestRequestTypeDef",
    "ReplaceRouteRequestRouteReplaceTypeDef",
    "ReplaceRouteTableAssociationRequestRequestTypeDef",
    "ReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef",
    "ReplaceTransitGatewayRouteRequestRequestTypeDef",
    "ReplaceVpnTunnelRequestRequestTypeDef",
    "ReplaceVpnTunnelResultOutputTypeDef",
    "ReportInstanceStatusRequestInstanceReportStatusTypeDef",
    "ReportInstanceStatusRequestRequestTypeDef",
    "RequestSpotFleetResponseOutputTypeDef",
    "RunInstancesMonitoringEnabledTypeDef",
    "SpotPlacementTypeDef",
    "ReservedInstancesConfigurationOutputTypeDef",
    "ReservedInstancesIdOutputTypeDef",
    "ResetAddressAttributeRequestRequestTypeDef",
    "ResetEbsDefaultKmsKeyIdRequestRequestTypeDef",
    "ResetEbsDefaultKmsKeyIdResultOutputTypeDef",
    "ResetFpgaImageAttributeRequestRequestTypeDef",
    "ResetFpgaImageAttributeResultOutputTypeDef",
    "ResetImageAttributeRequestImageResetAttributeTypeDef",
    "ResetImageAttributeRequestRequestTypeDef",
    "ResetInstanceAttributeRequestInstanceResetAttributeTypeDef",
    "ResetInstanceAttributeRequestInstanceResetKernelTypeDef",
    "ResetInstanceAttributeRequestInstanceResetRamdiskTypeDef",
    "ResetInstanceAttributeRequestInstanceResetSourceDestCheckTypeDef",
    "ResetInstanceAttributeRequestRequestTypeDef",
    "ResetNetworkInterfaceAttributeRequestNetworkInterfaceResetAttributeTypeDef",
    "ResetNetworkInterfaceAttributeRequestRequestTypeDef",
    "ResetSnapshotAttributeRequestRequestTypeDef",
    "ResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef",
    "ResponseMetadataTypeDef",
    "RestoreAddressToClassicRequestRequestTypeDef",
    "RestoreAddressToClassicResultOutputTypeDef",
    "RestoreImageFromRecycleBinRequestRequestTypeDef",
    "RestoreImageFromRecycleBinResultOutputTypeDef",
    "RestoreManagedPrefixListVersionRequestRequestTypeDef",
    "RestoreSnapshotFromRecycleBinRequestRequestTypeDef",
    "RestoreSnapshotFromRecycleBinResultOutputTypeDef",
    "RestoreSnapshotTierRequestRequestTypeDef",
    "RestoreSnapshotTierResultOutputTypeDef",
    "RevokeClientVpnIngressRequestRequestTypeDef",
    "RouteOutputTypeDef",
    "RouteTableAssociationStateResponseMetadataTypeDef",
    "RunScheduledInstancesResultOutputTypeDef",
    "S3StorageOutputTypeDef",
    "S3StorageTypeDef",
    "ScheduledInstanceRecurrenceOutputTypeDef",
    "ScheduledInstancesEbsTypeDef",
    "ScheduledInstancesIamInstanceProfileTypeDef",
    "ScheduledInstancesIpv6AddressTypeDef",
    "ScheduledInstancesMonitoringTypeDef",
    "ScheduledInstancesPlacementTypeDef",
    "ScheduledInstancesPrivateIpAddressConfigTypeDef",
    "TransitGatewayMulticastGroupOutputTypeDef",
    "SecurityGroupIdentifierOutputTypeDef",
    "SecurityGroupRuleDescriptionTypeDef",
    "SecurityGroupRuleRequestTypeDef",
    "SendDiagnosticInterruptRequestRequestTypeDef",
    "ServiceTypeDetailOutputTypeDef",
    "UserBucketDetailsOutputTypeDef",
    "SpotCapacityRebalanceOutputTypeDef",
    "SpotCapacityRebalanceTypeDef",
    "SpotInstanceStateFaultOutputTypeDef",
    "SpotFleetMonitoringOutputTypeDef",
    "SpotFleetMonitoringTypeDef",
    "SpotInstanceStatusOutputTypeDef",
    "StartInstancesRequestInstanceStartTypeDef",
    "StartInstancesRequestRequestTypeDef",
    "StartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef",
    "StartVpcEndpointServicePrivateDnsVerificationResultOutputTypeDef",
    "StateReasonResponseMetadataTypeDef",
    "StopInstancesRequestInstanceStopTypeDef",
    "StopInstancesRequestRequestTypeDef",
    "SubnetAssociationOutputTypeDef",
    "SubnetCidrBlockStateOutputTypeDef",
    "TargetConfigurationOutputTypeDef",
    "TargetGroupOutputTypeDef",
    "TargetGroupTypeDef",
    "TerminateClientVpnConnectionsRequestRequestTypeDef",
    "TerminateInstancesRequestInstanceTerminateTypeDef",
    "TerminateInstancesRequestRequestTypeDef",
    "TrafficMirrorPortRangeOutputTypeDef",
    "TransitGatewayAttachmentAssociationOutputTypeDef",
    "TransitGatewayAttachmentBgpConfigurationOutputTypeDef",
    "TransitGatewayConnectOptionsOutputTypeDef",
    "TransitGatewayMulticastDomainOptionsOutputTypeDef",
    "TransitGatewayOptionsOutputTypeDef",
    "TransitGatewayPeeringAttachmentOptionsOutputTypeDef",
    "TransitGatewayPolicyRuleMetaDataOutputTypeDef",
    "TransitGatewayPrefixListAttachmentOutputTypeDef",
    "TransitGatewayRouteAttachmentOutputTypeDef",
    "TransitGatewayVpcAttachmentOptionsOutputTypeDef",
    "UnassignIpv6AddressesRequestRequestTypeDef",
    "UnassignIpv6AddressesResultOutputTypeDef",
    "UnassignPrivateIpAddressesRequestNetworkInterfaceUnassignPrivateIpAddressesTypeDef",
    "UnassignPrivateIpAddressesRequestRequestTypeDef",
    "UnassignPrivateNatGatewayAddressRequestRequestTypeDef",
    "UnmonitorInstancesRequestInstanceUnmonitorTypeDef",
    "UnmonitorInstancesRequestRequestTypeDef",
    "UnsuccessfulInstanceCreditSpecificationItemErrorOutputTypeDef",
    "UnsuccessfulItemErrorOutputTypeDef",
    "UpdateSecurityGroupRuleDescriptionsEgressResultOutputTypeDef",
    "UpdateSecurityGroupRuleDescriptionsIngressResultOutputTypeDef",
    "ValidationErrorOutputTypeDef",
    "VerifiedAccessEndpointEniOptionsOutputTypeDef",
    "VerifiedAccessEndpointLoadBalancerOptionsOutputTypeDef",
    "VerifiedAccessEndpointStatusOutputTypeDef",
    "VerifiedAccessTrustProviderCondensedOutputTypeDef",
    "VerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef",
    "VerifiedAccessLogDeliveryStatusOutputTypeDef",
    "VerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef",
    "VerifiedAccessLogS3DestinationOptionsTypeDef",
    "VgwTelemetryOutputTypeDef",
    "VolumeAttachmentOutputTypeDef",
    "VolumeAttachmentResponseMetadataTypeDef",
    "VolumeStatusActionOutputTypeDef",
    "VolumeStatusAttachmentStatusOutputTypeDef",
    "VolumeStatusDetailsOutputTypeDef",
    "VolumeStatusEventOutputTypeDef",
    "VpcCidrBlockStateOutputTypeDef",
    "VpcPeeringConnectionOptionsDescriptionOutputTypeDef",
    "VpcPeeringConnectionStateReasonOutputTypeDef",
    "VpcPeeringConnectionStateReasonResponseMetadataTypeDef",
    "VpnStaticRouteOutputTypeDef",
    "WithdrawByoipCidrRequestRequestTypeDef",
    "AcceptAddressTransferResultOutputTypeDef",
    "DescribeAddressTransfersResultOutputTypeDef",
    "DisableAddressTransferResultOutputTypeDef",
    "EnableAddressTransferResultOutputTypeDef",
    "AcceptReservedInstancesExchangeQuoteRequestRequestTypeDef",
    "GetReservedInstancesExchangeQuoteRequestRequestTypeDef",
    "AccountAttributeOutputTypeDef",
    "DescribeFleetInstancesResultOutputTypeDef",
    "DescribeSpotFleetInstancesResponseOutputTypeDef",
    "ModifyVpcEndpointServicePermissionsResultOutputTypeDef",
    "AnalysisLoadBalancerTargetOutputTypeDef",
    "RuleGroupRuleOptionsPairOutputTypeDef",
    "AddressAttributeOutputTypeDef",
    "AddressOutputTypeDef",
    "AllowedPrincipalOutputTypeDef",
    "CarrierGatewayOutputTypeDef",
    "CoipPoolOutputTypeDef",
    "CopySnapshotResultOutputTypeDef",
    "CreateSecurityGroupResultOutputTypeDef",
    "CustomerGatewayOutputTypeDef",
    "Ec2InstanceConnectEndpointOutputTypeDef",
    "HostReservationOutputTypeDef",
    "ImportKeyPairResultOutputTypeDef",
    "InstanceEventWindowAssociationTargetOutputTypeDef",
    "IpamResourceDiscoveryAssociationOutputTypeDef",
    "IpamScopeOutputTypeDef",
    "KeyPairInfoOutputTypeDef",
    "KeyPairOutputTypeDef",
    "LaunchTemplateOutputTypeDef",
    "LaunchTemplateTagSpecificationOutputTypeDef",
    "LocalGatewayOutputTypeDef",
    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef",
    "LocalGatewayRouteTableVpcAssociationOutputTypeDef",
    "LocalGatewayVirtualInterfaceGroupOutputTypeDef",
    "LocalGatewayVirtualInterfaceOutputTypeDef",
    "ManagedPrefixListOutputTypeDef",
    "NetworkInsightsAccessScopeAnalysisOutputTypeDef",
    "NetworkInsightsAccessScopeOutputTypeDef",
    "PlacementGroupOutputTypeDef",
    "ReplaceRootVolumeTaskOutputTypeDef",
    "SnapshotInfoOutputTypeDef",
    "SnapshotOutputTypeDef",
    "SnapshotResponseMetadataTypeDef",
    "SnapshotTierStatusOutputTypeDef",
    "SpotFleetTagSpecificationOutputTypeDef",
    "SubnetCidrReservationOutputTypeDef",
    "TagSpecificationOutputTypeDef",
    "TrafficMirrorSessionOutputTypeDef",
    "TrafficMirrorTargetOutputTypeDef",
    "TransitGatewayPolicyTableOutputTypeDef",
    "TransitGatewayRouteTableAnnouncementOutputTypeDef",
    "TransitGatewayRouteTableOutputTypeDef",
    "TrunkInterfaceAssociationOutputTypeDef",
    "VerifiedAccessGroupOutputTypeDef",
    "VpcClassicLinkOutputTypeDef",
    "AdvertiseByoipCidrResultOutputTypeDef",
    "DeprovisionByoipCidrResultOutputTypeDef",
    "DescribeByoipCidrsResultOutputTypeDef",
    "MoveByoipCidrToIpamResultOutputTypeDef",
    "ProvisionByoipCidrResultOutputTypeDef",
    "WithdrawByoipCidrResultOutputTypeDef",
    "AllocateIpamPoolCidrResultOutputTypeDef",
    "GetIpamPoolAllocationsResultOutputTypeDef",
    "AnalysisAclRuleOutputTypeDef",
    "AnalysisPacketHeaderOutputTypeDef",
    "AnalysisSecurityGroupRuleOutputTypeDef",
    "FirewallStatefulRuleOutputTypeDef",
    "FirewallStatelessRuleOutputTypeDef",
    "AssignPrivateIpAddressesResultOutputTypeDef",
    "AssignPrivateNatGatewayAddressResultOutputTypeDef",
    "AssociateNatGatewayAddressResultOutputTypeDef",
    "DisassociateNatGatewayAddressResultOutputTypeDef",
    "UnassignPrivateNatGatewayAddressResultOutputTypeDef",
    "AssociateClientVpnTargetNetworkResultOutputTypeDef",
    "DisassociateClientVpnTargetNetworkResultOutputTypeDef",
    "TargetNetworkOutputTypeDef",
    "AssociateIamInstanceProfileRequestRequestTypeDef",
    "ReplaceIamInstanceProfileAssociationRequestRequestTypeDef",
    "AssociateRouteTableResultOutputTypeDef",
    "ReplaceRouteTableAssociationResultOutputTypeDef",
    "RouteTableAssociationOutputTypeDef",
    "AssociateTransitGatewayPolicyTableResultOutputTypeDef",
    "DisassociateTransitGatewayPolicyTableResultOutputTypeDef",
    "GetTransitGatewayPolicyTableAssociationsResultOutputTypeDef",
    "AssociateTransitGatewayRouteTableResultOutputTypeDef",
    "DisassociateTransitGatewayRouteTableResultOutputTypeDef",
    "GetAssociatedEnclaveCertificateIamRolesResultOutputTypeDef",
    "IntegrateServicesTypeDef",
    "AttachVpnGatewayResultOutputTypeDef",
    "VpnGatewayOutputTypeDef",
    "AttachmentEnaSrdSpecificationOutputTypeDef",
    "DescribeVpcAttributeResultOutputTypeDef",
    "ModifySubnetAttributeRequestRequestTypeDef",
    "ModifyVolumeAttributeRequestRequestTypeDef",
    "ModifyVolumeAttributeRequestVolumeModifyAttributeTypeDef",
    "ModifyVpcAttributeRequestRequestTypeDef",
    "ModifyVpcAttributeRequestVpcModifyAttributeTypeDef",
    "DhcpConfigurationOutputTypeDef",
    "AuthorizationRuleOutputTypeDef",
    "AuthorizeClientVpnIngressResultOutputTypeDef",
    "RevokeClientVpnIngressResultOutputTypeDef",
    "AvailabilityZoneOutputTypeDef",
    "AvailableCapacityOutputTypeDef",
    "BlockDeviceMappingOutputTypeDef",
    "BlockDeviceMappingTypeDef",
    "FailedCapacityReservationFleetCancellationResultOutputTypeDef",
    "CancelSpotFleetRequestsErrorItemOutputTypeDef",
    "CancelSpotInstanceRequestsResultOutputTypeDef",
    "CapacityReservationOutputTypeDef",
    "CapacityReservationFleetOutputTypeDef",
    "CreateCapacityReservationFleetResultOutputTypeDef",
    "GetGroupsForCapacityReservationResultOutputTypeDef",
    "OnDemandOptionsOutputTypeDef",
    "OnDemandOptionsRequestTypeDef",
    "CapacityReservationSpecificationResponseOutputTypeDef",
    "CapacityReservationSpecificationResponseResponseMetadataTypeDef",
    "LaunchTemplateCapacityReservationSpecificationResponseOutputTypeDef",
    "CapacityReservationSpecificationTypeDef",
    "LaunchTemplateCapacityReservationSpecificationRequestTypeDef",
    "DescribeVpcClassicLinkDnsSupportResultOutputTypeDef",
    "ClassicLinkInstanceOutputTypeDef",
    "ClassicLoadBalancersConfigOutputTypeDef",
    "ClassicLoadBalancersConfigTypeDef",
    "ExportClientVpnClientCertificateRevocationListResultOutputTypeDef",
    "ClientConnectResponseOptionsOutputTypeDef",
    "ClientCreateTagsRequestTypeDef",
    "ClientDeleteTagsRequestTypeDef",
    "CreateTagsRequestServiceResourceCreateTagsTypeDef",
    "InstanceCreateTagsRequestTypeDef",
    "InstanceDeleteTagsRequestTypeDef",
    "InstanceEventWindowAssociationRequestTypeDef",
    "InstanceEventWindowDisassociationRequestTypeDef",
    "LaunchTemplateTagSpecificationRequestTypeDef",
    "SpotFleetTagSpecificationTypeDef",
    "TagSpecificationTypeDef",
    "VpcCreateTagsRequestTypeDef",
    "ClientVpnAuthenticationOutputTypeDef",
    "ClientVpnAuthenticationRequestTypeDef",
    "ClientVpnConnectionOutputTypeDef",
    "TerminateConnectionStatusOutputTypeDef",
    "CreateClientVpnEndpointResultOutputTypeDef",
    "DeleteClientVpnEndpointResultOutputTypeDef",
    "ClientVpnRouteOutputTypeDef",
    "CreateClientVpnRouteResultOutputTypeDef",
    "DeleteClientVpnRouteResultOutputTypeDef",
    "VpnTunnelLogOptionsOutputTypeDef",
    "VpnTunnelLogOptionsSpecificationTypeDef",
    "GetCoipPoolUsageResultOutputTypeDef",
    "CreateCoipCidrResultOutputTypeDef",
    "DeleteCoipCidrResultOutputTypeDef",
    "CreateVpcEndpointConnectionNotificationResultOutputTypeDef",
    "DescribeVpcEndpointConnectionNotificationsResultOutputTypeDef",
    "ModifyInstanceEventWindowRequestRequestTypeDef",
    "ModifyIpamPoolRequestRequestTypeDef",
    "CreateLocalGatewayRouteResultOutputTypeDef",
    "DeleteLocalGatewayRouteResultOutputTypeDef",
    "ModifyLocalGatewayRouteResultOutputTypeDef",
    "SearchLocalGatewayRoutesResultOutputTypeDef",
    "CreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef",
    "CreateNetworkAclEntryRequestRequestTypeDef",
    "ReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef",
    "ReplaceNetworkAclEntryRequestRequestTypeDef",
    "InstanceNetworkInterfaceSpecificationTypeDef",
    "CreateReservedInstancesListingRequestRequestTypeDef",
    "CreateStoreImageTaskRequestRequestTypeDef",
    "CreateTrafficMirrorFilterRuleRequestRequestTypeDef",
    "ModifyTrafficMirrorFilterRuleRequestRequestTypeDef",
    "CreateVolumePermissionModificationsTypeDef",
    "ModifyVpcEndpointRequestRequestTypeDef",
    "GetAwsNetworkPerformanceDataRequestGetAwsNetworkPerformanceDataPaginateTypeDef",
    "GetAwsNetworkPerformanceDataRequestRequestTypeDef",
    "DataResponseOutputTypeDef",
    "DeleteFleetErrorItemOutputTypeDef",
    "DeleteInstanceEventWindowResultOutputTypeDef",
    "DeleteLaunchTemplateVersionsResponseErrorItemOutputTypeDef",
    "FailedQueuedPurchaseDeletionOutputTypeDef",
    "DeregisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    "DeregisterInstanceEventNotificationAttributesResultOutputTypeDef",
    "DescribeInstanceEventNotificationAttributesResultOutputTypeDef",
    "RegisterInstanceEventNotificationAttributesResultOutputTypeDef",
    "DeregisterTransitGatewayMulticastGroupMembersResultOutputTypeDef",
    "DeregisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef",
    "DescribeAddressesRequestRequestTypeDef",
    "DescribeAvailabilityZonesRequestRequestTypeDef",
    "DescribeAwsNetworkPerformanceMetricSubscriptionsRequestDescribeAwsNetworkPerformanceMetricSubscriptionsPaginateTypeDef",
    "DescribeAwsNetworkPerformanceMetricSubscriptionsRequestRequestTypeDef",
    "DescribeBundleTasksRequestRequestTypeDef",
    "DescribeCapacityReservationFleetsRequestDescribeCapacityReservationFleetsPaginateTypeDef",
    "DescribeCapacityReservationFleetsRequestRequestTypeDef",
    "DescribeCapacityReservationsRequestDescribeCapacityReservationsPaginateTypeDef",
    "DescribeCapacityReservationsRequestRequestTypeDef",
    "DescribeCarrierGatewaysRequestDescribeCarrierGatewaysPaginateTypeDef",
    "DescribeCarrierGatewaysRequestRequestTypeDef",
    "DescribeClassicLinkInstancesRequestDescribeClassicLinkInstancesPaginateTypeDef",
    "DescribeClassicLinkInstancesRequestRequestTypeDef",
    "DescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef",
    "DescribeClientVpnAuthorizationRulesRequestRequestTypeDef",
    "DescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef",
    "DescribeClientVpnConnectionsRequestRequestTypeDef",
    "DescribeClientVpnEndpointsRequestDescribeClientVpnEndpointsPaginateTypeDef",
    "DescribeClientVpnEndpointsRequestRequestTypeDef",
    "DescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef",
    "DescribeClientVpnRoutesRequestRequestTypeDef",
    "DescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef",
    "DescribeClientVpnTargetNetworksRequestRequestTypeDef",
    "DescribeCoipPoolsRequestDescribeCoipPoolsPaginateTypeDef",
    "DescribeCoipPoolsRequestRequestTypeDef",
    "DescribeCustomerGatewaysRequestRequestTypeDef",
    "DescribeDhcpOptionsRequestDescribeDhcpOptionsPaginateTypeDef",
    "DescribeDhcpOptionsRequestRequestTypeDef",
    "DescribeEgressOnlyInternetGatewaysRequestDescribeEgressOnlyInternetGatewaysPaginateTypeDef",
    "DescribeEgressOnlyInternetGatewaysRequestRequestTypeDef",
    "DescribeElasticGpusRequestRequestTypeDef",
    "DescribeExportImageTasksRequestDescribeExportImageTasksPaginateTypeDef",
    "DescribeExportImageTasksRequestRequestTypeDef",
    "DescribeExportTasksRequestRequestTypeDef",
    "DescribeFastLaunchImagesRequestDescribeFastLaunchImagesPaginateTypeDef",
    "DescribeFastLaunchImagesRequestRequestTypeDef",
    "DescribeFastSnapshotRestoresRequestDescribeFastSnapshotRestoresPaginateTypeDef",
    "DescribeFastSnapshotRestoresRequestRequestTypeDef",
    "DescribeFleetInstancesRequestRequestTypeDef",
    "DescribeFleetsRequestDescribeFleetsPaginateTypeDef",
    "DescribeFleetsRequestRequestTypeDef",
    "DescribeFlowLogsRequestDescribeFlowLogsPaginateTypeDef",
    "DescribeFlowLogsRequestRequestTypeDef",
    "DescribeFpgaImagesRequestDescribeFpgaImagesPaginateTypeDef",
    "DescribeFpgaImagesRequestRequestTypeDef",
    "DescribeHostReservationOfferingsRequestDescribeHostReservationOfferingsPaginateTypeDef",
    "DescribeHostReservationOfferingsRequestRequestTypeDef",
    "DescribeHostReservationsRequestDescribeHostReservationsPaginateTypeDef",
    "DescribeHostReservationsRequestRequestTypeDef",
    "DescribeHostsRequestDescribeHostsPaginateTypeDef",
    "DescribeHostsRequestRequestTypeDef",
    "DescribeIamInstanceProfileAssociationsRequestDescribeIamInstanceProfileAssociationsPaginateTypeDef",
    "DescribeIamInstanceProfileAssociationsRequestRequestTypeDef",
    "DescribeImagesRequestDescribeImagesPaginateTypeDef",
    "DescribeImagesRequestRequestTypeDef",
    "DescribeImportImageTasksRequestDescribeImportImageTasksPaginateTypeDef",
    "DescribeImportImageTasksRequestRequestTypeDef",
    "DescribeImportSnapshotTasksRequestDescribeImportSnapshotTasksPaginateTypeDef",
    "DescribeImportSnapshotTasksRequestRequestTypeDef",
    "DescribeInstanceConnectEndpointsRequestDescribeInstanceConnectEndpointsPaginateTypeDef",
    "DescribeInstanceConnectEndpointsRequestRequestTypeDef",
    "DescribeInstanceCreditSpecificationsRequestDescribeInstanceCreditSpecificationsPaginateTypeDef",
    "DescribeInstanceCreditSpecificationsRequestRequestTypeDef",
    "DescribeInstanceEventWindowsRequestDescribeInstanceEventWindowsPaginateTypeDef",
    "DescribeInstanceEventWindowsRequestRequestTypeDef",
    "DescribeInstanceStatusRequestDescribeInstanceStatusPaginateTypeDef",
    "DescribeInstanceStatusRequestRequestTypeDef",
    "DescribeInstanceTypeOfferingsRequestDescribeInstanceTypeOfferingsPaginateTypeDef",
    "DescribeInstanceTypeOfferingsRequestRequestTypeDef",
    "DescribeInstanceTypesRequestDescribeInstanceTypesPaginateTypeDef",
    "DescribeInstanceTypesRequestRequestTypeDef",
    "DescribeInstancesRequestDescribeInstancesPaginateTypeDef",
    "DescribeInstancesRequestRequestTypeDef",
    "DescribeInternetGatewaysRequestDescribeInternetGatewaysPaginateTypeDef",
    "DescribeInternetGatewaysRequestRequestTypeDef",
    "DescribeIpamPoolsRequestDescribeIpamPoolsPaginateTypeDef",
    "DescribeIpamPoolsRequestRequestTypeDef",
    "DescribeIpamResourceDiscoveriesRequestDescribeIpamResourceDiscoveriesPaginateTypeDef",
    "DescribeIpamResourceDiscoveriesRequestRequestTypeDef",
    "DescribeIpamResourceDiscoveryAssociationsRequestDescribeIpamResourceDiscoveryAssociationsPaginateTypeDef",
    "DescribeIpamResourceDiscoveryAssociationsRequestRequestTypeDef",
    "DescribeIpamScopesRequestDescribeIpamScopesPaginateTypeDef",
    "DescribeIpamScopesRequestRequestTypeDef",
    "DescribeIpamsRequestDescribeIpamsPaginateTypeDef",
    "DescribeIpamsRequestRequestTypeDef",
    "DescribeIpv6PoolsRequestDescribeIpv6PoolsPaginateTypeDef",
    "DescribeIpv6PoolsRequestRequestTypeDef",
    "DescribeKeyPairsRequestRequestTypeDef",
    "DescribeLaunchTemplateVersionsRequestDescribeLaunchTemplateVersionsPaginateTypeDef",
    "DescribeLaunchTemplateVersionsRequestRequestTypeDef",
    "DescribeLaunchTemplatesRequestDescribeLaunchTemplatesPaginateTypeDef",
    "DescribeLaunchTemplatesRequestRequestTypeDef",
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestDescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsPaginateTypeDef",
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestRequestTypeDef",
    "DescribeLocalGatewayRouteTableVpcAssociationsRequestDescribeLocalGatewayRouteTableVpcAssociationsPaginateTypeDef",
    "DescribeLocalGatewayRouteTableVpcAssociationsRequestRequestTypeDef",
    "DescribeLocalGatewayRouteTablesRequestDescribeLocalGatewayRouteTablesPaginateTypeDef",
    "DescribeLocalGatewayRouteTablesRequestRequestTypeDef",
    "DescribeLocalGatewayVirtualInterfaceGroupsRequestDescribeLocalGatewayVirtualInterfaceGroupsPaginateTypeDef",
    "DescribeLocalGatewayVirtualInterfaceGroupsRequestRequestTypeDef",
    "DescribeLocalGatewayVirtualInterfacesRequestDescribeLocalGatewayVirtualInterfacesPaginateTypeDef",
    "DescribeLocalGatewayVirtualInterfacesRequestRequestTypeDef",
    "DescribeLocalGatewaysRequestDescribeLocalGatewaysPaginateTypeDef",
    "DescribeLocalGatewaysRequestRequestTypeDef",
    "DescribeManagedPrefixListsRequestDescribeManagedPrefixListsPaginateTypeDef",
    "DescribeManagedPrefixListsRequestRequestTypeDef",
    "DescribeMovingAddressesRequestDescribeMovingAddressesPaginateTypeDef",
    "DescribeMovingAddressesRequestRequestTypeDef",
    "DescribeNatGatewaysRequestDescribeNatGatewaysPaginateTypeDef",
    "DescribeNatGatewaysRequestRequestTypeDef",
    "DescribeNetworkAclsRequestDescribeNetworkAclsPaginateTypeDef",
    "DescribeNetworkAclsRequestRequestTypeDef",
    "DescribeNetworkInsightsAccessScopeAnalysesRequestDescribeNetworkInsightsAccessScopeAnalysesPaginateTypeDef",
    "DescribeNetworkInsightsAccessScopeAnalysesRequestRequestTypeDef",
    "DescribeNetworkInsightsAccessScopesRequestDescribeNetworkInsightsAccessScopesPaginateTypeDef",
    "DescribeNetworkInsightsAccessScopesRequestRequestTypeDef",
    "DescribeNetworkInsightsAnalysesRequestDescribeNetworkInsightsAnalysesPaginateTypeDef",
    "DescribeNetworkInsightsAnalysesRequestRequestTypeDef",
    "DescribeNetworkInsightsPathsRequestDescribeNetworkInsightsPathsPaginateTypeDef",
    "DescribeNetworkInsightsPathsRequestRequestTypeDef",
    "DescribeNetworkInterfacePermissionsRequestDescribeNetworkInterfacePermissionsPaginateTypeDef",
    "DescribeNetworkInterfacePermissionsRequestRequestTypeDef",
    "DescribeNetworkInterfacesRequestDescribeNetworkInterfacesPaginateTypeDef",
    "DescribeNetworkInterfacesRequestRequestTypeDef",
    "DescribePlacementGroupsRequestRequestTypeDef",
    "DescribePrefixListsRequestDescribePrefixListsPaginateTypeDef",
    "DescribePrefixListsRequestRequestTypeDef",
    "DescribePublicIpv4PoolsRequestDescribePublicIpv4PoolsPaginateTypeDef",
    "DescribePublicIpv4PoolsRequestRequestTypeDef",
    "DescribeRegionsRequestRequestTypeDef",
    "DescribeReplaceRootVolumeTasksRequestDescribeReplaceRootVolumeTasksPaginateTypeDef",
    "DescribeReplaceRootVolumeTasksRequestRequestTypeDef",
    "DescribeReservedInstancesListingsRequestRequestTypeDef",
    "DescribeReservedInstancesModificationsRequestDescribeReservedInstancesModificationsPaginateTypeDef",
    "DescribeReservedInstancesModificationsRequestRequestTypeDef",
    "DescribeReservedInstancesOfferingsRequestDescribeReservedInstancesOfferingsPaginateTypeDef",
    "DescribeReservedInstancesOfferingsRequestRequestTypeDef",
    "DescribeReservedInstancesRequestRequestTypeDef",
    "DescribeRouteTablesRequestDescribeRouteTablesPaginateTypeDef",
    "DescribeRouteTablesRequestRequestTypeDef",
    "DescribeSecurityGroupRulesRequestDescribeSecurityGroupRulesPaginateTypeDef",
    "DescribeSecurityGroupRulesRequestRequestTypeDef",
    "DescribeSecurityGroupsRequestDescribeSecurityGroupsPaginateTypeDef",
    "DescribeSecurityGroupsRequestRequestTypeDef",
    "DescribeSnapshotTierStatusRequestDescribeSnapshotTierStatusPaginateTypeDef",
    "DescribeSnapshotTierStatusRequestRequestTypeDef",
    "DescribeSnapshotsRequestDescribeSnapshotsPaginateTypeDef",
    "DescribeSnapshotsRequestRequestTypeDef",
    "DescribeSpotInstanceRequestsRequestDescribeSpotInstanceRequestsPaginateTypeDef",
    "DescribeSpotInstanceRequestsRequestRequestTypeDef",
    "DescribeSpotPriceHistoryRequestDescribeSpotPriceHistoryPaginateTypeDef",
    "DescribeSpotPriceHistoryRequestRequestTypeDef",
    "DescribeStoreImageTasksRequestDescribeStoreImageTasksPaginateTypeDef",
    "DescribeStoreImageTasksRequestRequestTypeDef",
    "DescribeSubnetsRequestDescribeSubnetsPaginateTypeDef",
    "DescribeSubnetsRequestRequestTypeDef",
    "DescribeTagsRequestDescribeTagsPaginateTypeDef",
    "DescribeTagsRequestRequestTypeDef",
    "DescribeTrafficMirrorFiltersRequestDescribeTrafficMirrorFiltersPaginateTypeDef",
    "DescribeTrafficMirrorFiltersRequestRequestTypeDef",
    "DescribeTrafficMirrorSessionsRequestDescribeTrafficMirrorSessionsPaginateTypeDef",
    "DescribeTrafficMirrorSessionsRequestRequestTypeDef",
    "DescribeTrafficMirrorTargetsRequestDescribeTrafficMirrorTargetsPaginateTypeDef",
    "DescribeTrafficMirrorTargetsRequestRequestTypeDef",
    "DescribeTransitGatewayAttachmentsRequestDescribeTransitGatewayAttachmentsPaginateTypeDef",
    "DescribeTransitGatewayAttachmentsRequestRequestTypeDef",
    "DescribeTransitGatewayConnectPeersRequestDescribeTransitGatewayConnectPeersPaginateTypeDef",
    "DescribeTransitGatewayConnectPeersRequestRequestTypeDef",
    "DescribeTransitGatewayConnectsRequestDescribeTransitGatewayConnectsPaginateTypeDef",
    "DescribeTransitGatewayConnectsRequestRequestTypeDef",
    "DescribeTransitGatewayMulticastDomainsRequestDescribeTransitGatewayMulticastDomainsPaginateTypeDef",
    "DescribeTransitGatewayMulticastDomainsRequestRequestTypeDef",
    "DescribeTransitGatewayPeeringAttachmentsRequestDescribeTransitGatewayPeeringAttachmentsPaginateTypeDef",
    "DescribeTransitGatewayPeeringAttachmentsRequestRequestTypeDef",
    "DescribeTransitGatewayPolicyTablesRequestDescribeTransitGatewayPolicyTablesPaginateTypeDef",
    "DescribeTransitGatewayPolicyTablesRequestRequestTypeDef",
    "DescribeTransitGatewayRouteTableAnnouncementsRequestDescribeTransitGatewayRouteTableAnnouncementsPaginateTypeDef",
    "DescribeTransitGatewayRouteTableAnnouncementsRequestRequestTypeDef",
    "DescribeTransitGatewayRouteTablesRequestDescribeTransitGatewayRouteTablesPaginateTypeDef",
    "DescribeTransitGatewayRouteTablesRequestRequestTypeDef",
    "DescribeTransitGatewayVpcAttachmentsRequestDescribeTransitGatewayVpcAttachmentsPaginateTypeDef",
    "DescribeTransitGatewayVpcAttachmentsRequestRequestTypeDef",
    "DescribeTransitGatewaysRequestDescribeTransitGatewaysPaginateTypeDef",
    "DescribeTransitGatewaysRequestRequestTypeDef",
    "DescribeTrunkInterfaceAssociationsRequestDescribeTrunkInterfaceAssociationsPaginateTypeDef",
    "DescribeTrunkInterfaceAssociationsRequestRequestTypeDef",
    "DescribeVerifiedAccessEndpointsRequestDescribeVerifiedAccessEndpointsPaginateTypeDef",
    "DescribeVerifiedAccessEndpointsRequestRequestTypeDef",
    "DescribeVerifiedAccessGroupsRequestDescribeVerifiedAccessGroupsPaginateTypeDef",
    "DescribeVerifiedAccessGroupsRequestRequestTypeDef",
    "DescribeVerifiedAccessInstanceLoggingConfigurationsRequestDescribeVerifiedAccessInstanceLoggingConfigurationsPaginateTypeDef",
    "DescribeVerifiedAccessInstanceLoggingConfigurationsRequestRequestTypeDef",
    "DescribeVerifiedAccessInstancesRequestDescribeVerifiedAccessInstancesPaginateTypeDef",
    "DescribeVerifiedAccessInstancesRequestRequestTypeDef",
    "DescribeVerifiedAccessTrustProvidersRequestDescribeVerifiedAccessTrustProvidersPaginateTypeDef",
    "DescribeVerifiedAccessTrustProvidersRequestRequestTypeDef",
    "DescribeVolumeStatusRequestDescribeVolumeStatusPaginateTypeDef",
    "DescribeVolumeStatusRequestRequestTypeDef",
    "DescribeVolumeStatusRequestVolumeDescribeStatusTypeDef",
    "DescribeVolumesModificationsRequestDescribeVolumesModificationsPaginateTypeDef",
    "DescribeVolumesModificationsRequestRequestTypeDef",
    "DescribeVolumesRequestDescribeVolumesPaginateTypeDef",
    "DescribeVolumesRequestRequestTypeDef",
    "DescribeVpcClassicLinkRequestRequestTypeDef",
    "DescribeVpcEndpointConnectionNotificationsRequestDescribeVpcEndpointConnectionNotificationsPaginateTypeDef",
    "DescribeVpcEndpointConnectionNotificationsRequestRequestTypeDef",
    "DescribeVpcEndpointConnectionsRequestDescribeVpcEndpointConnectionsPaginateTypeDef",
    "DescribeVpcEndpointConnectionsRequestRequestTypeDef",
    "DescribeVpcEndpointServiceConfigurationsRequestDescribeVpcEndpointServiceConfigurationsPaginateTypeDef",
    "DescribeVpcEndpointServiceConfigurationsRequestRequestTypeDef",
    "DescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef",
    "DescribeVpcEndpointServicePermissionsRequestRequestTypeDef",
    "DescribeVpcEndpointServicesRequestDescribeVpcEndpointServicesPaginateTypeDef",
    "DescribeVpcEndpointServicesRequestRequestTypeDef",
    "DescribeVpcEndpointsRequestDescribeVpcEndpointsPaginateTypeDef",
    "DescribeVpcEndpointsRequestRequestTypeDef",
    "DescribeVpcPeeringConnectionsRequestDescribeVpcPeeringConnectionsPaginateTypeDef",
    "DescribeVpcPeeringConnectionsRequestRequestTypeDef",
    "DescribeVpcsRequestDescribeVpcsPaginateTypeDef",
    "DescribeVpcsRequestRequestTypeDef",
    "DescribeVpnConnectionsRequestRequestTypeDef",
    "DescribeVpnGatewaysRequestRequestTypeDef",
    "ExportTransitGatewayRoutesRequestRequestTypeDef",
    "GetCoipPoolUsageRequestRequestTypeDef",
    "GetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef",
    "GetIpamDiscoveredAccountsRequestRequestTypeDef",
    "GetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef",
    "GetIpamDiscoveredResourceCidrsRequestRequestTypeDef",
    "GetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef",
    "GetIpamPoolAllocationsRequestRequestTypeDef",
    "GetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef",
    "GetIpamPoolCidrsRequestRequestTypeDef",
    "GetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef",
    "GetIpamResourceCidrsRequestRequestTypeDef",
    "GetSubnetCidrReservationsRequestRequestTypeDef",
    "GetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef",
    "GetTransitGatewayAttachmentPropagationsRequestRequestTypeDef",
    "GetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef",
    "GetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    "GetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef",
    "GetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef",
    "GetTransitGatewayPolicyTableEntriesRequestRequestTypeDef",
    "GetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef",
    "GetTransitGatewayPrefixListReferencesRequestRequestTypeDef",
    "GetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef",
    "GetTransitGatewayRouteTableAssociationsRequestRequestTypeDef",
    "GetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef",
    "GetTransitGatewayRouteTablePropagationsRequestRequestTypeDef",
    "SearchLocalGatewayRoutesRequestRequestTypeDef",
    "SearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef",
    "SearchTransitGatewayMulticastGroupsRequestRequestTypeDef",
    "SearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef",
    "SearchTransitGatewayRoutesRequestRequestTypeDef",
    "DescribeAggregateIdFormatResultOutputTypeDef",
    "DescribeIdFormatResultOutputTypeDef",
    "DescribeIdentityIdFormatResultOutputTypeDef",
    "PrincipalIdFormatOutputTypeDef",
    "DescribeAwsNetworkPerformanceMetricSubscriptionsResultOutputTypeDef",
    "DescribeBundleTasksRequestBundleTaskCompleteWaitTypeDef",
    "DescribeConversionTasksRequestConversionTaskCancelledWaitTypeDef",
    "DescribeConversionTasksRequestConversionTaskCompletedWaitTypeDef",
    "DescribeConversionTasksRequestConversionTaskDeletedWaitTypeDef",
    "DescribeCustomerGatewaysRequestCustomerGatewayAvailableWaitTypeDef",
    "DescribeExportTasksRequestExportTaskCancelledWaitTypeDef",
    "DescribeExportTasksRequestExportTaskCompletedWaitTypeDef",
    "DescribeImagesRequestImageAvailableWaitTypeDef",
    "DescribeImagesRequestImageExistsWaitTypeDef",
    "DescribeImportSnapshotTasksRequestSnapshotImportedWaitTypeDef",
    "DescribeInstanceStatusRequestInstanceStatusOkWaitTypeDef",
    "DescribeInstanceStatusRequestSystemStatusOkWaitTypeDef",
    "DescribeInstancesRequestInstanceExistsWaitTypeDef",
    "DescribeInstancesRequestInstanceRunningWaitTypeDef",
    "DescribeInstancesRequestInstanceStoppedWaitTypeDef",
    "DescribeInstancesRequestInstanceTerminatedWaitTypeDef",
    "DescribeInternetGatewaysRequestInternetGatewayExistsWaitTypeDef",
    "DescribeKeyPairsRequestKeyPairExistsWaitTypeDef",
    "DescribeNatGatewaysRequestNatGatewayAvailableWaitTypeDef",
    "DescribeNatGatewaysRequestNatGatewayDeletedWaitTypeDef",
    "DescribeNetworkInterfacesRequestNetworkInterfaceAvailableWaitTypeDef",
    "DescribeSecurityGroupsRequestSecurityGroupExistsWaitTypeDef",
    "DescribeSnapshotsRequestSnapshotCompletedWaitTypeDef",
    "DescribeSpotInstanceRequestsRequestSpotInstanceRequestFulfilledWaitTypeDef",
    "DescribeSubnetsRequestSubnetAvailableWaitTypeDef",
    "DescribeVolumesRequestVolumeAvailableWaitTypeDef",
    "DescribeVolumesRequestVolumeDeletedWaitTypeDef",
    "DescribeVolumesRequestVolumeInUseWaitTypeDef",
    "DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionDeletedWaitTypeDef",
    "DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionExistsWaitTypeDef",
    "DescribeVpcsRequestVpcAvailableWaitTypeDef",
    "DescribeVpcsRequestVpcExistsWaitTypeDef",
    "DescribeVpnConnectionsRequestVpnConnectionAvailableWaitTypeDef",
    "DescribeVpnConnectionsRequestVpnConnectionDeletedWaitTypeDef",
    "GetPasswordDataRequestPasswordDataAvailableWaitTypeDef",
    "DescribeFastLaunchImagesSuccessItemOutputTypeDef",
    "DisableFastLaunchResultOutputTypeDef",
    "EnableFastLaunchResultOutputTypeDef",
    "DescribeFastSnapshotRestoresResultOutputTypeDef",
    "DescribeHostReservationOfferingsResultOutputTypeDef",
    "DescribeInstanceCreditSpecificationsResultOutputTypeDef",
    "DescribeInstanceTypeOfferingsResultOutputTypeDef",
    "DescribeMovingAddressesResultOutputTypeDef",
    "DescribePrefixListsResultOutputTypeDef",
    "DescribeRegionsResultOutputTypeDef",
    "DescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef",
    "DescribeScheduledInstanceAvailabilityRequestRequestTypeDef",
    "DescribeScheduledInstancesRequestDescribeScheduledInstancesPaginateTypeDef",
    "DescribeScheduledInstancesRequestRequestTypeDef",
    "DescribeSecurityGroupReferencesResultOutputTypeDef",
    "DescribeSnapshotAttributeResultOutputTypeDef",
    "DescribeVolumeAttributeResultOutputTypeDef",
    "DescribeSpotPriceHistoryResultOutputTypeDef",
    "DescribeStoreImageTasksResultOutputTypeDef",
    "DescribeTagsResultOutputTypeDef",
    "DescribeVolumesModificationsResultOutputTypeDef",
    "ModifyVolumeResultOutputTypeDef",
    "FlowLogOutputTypeDef",
    "DisableFastSnapshotRestoreStateErrorItemOutputTypeDef",
    "DisableTransitGatewayRouteTablePropagationResultOutputTypeDef",
    "EnableTransitGatewayRouteTablePropagationResultOutputTypeDef",
    "DiskImageTypeDef",
    "ImportVolumeRequestRequestTypeDef",
    "ImportInstanceVolumeDetailItemOutputTypeDef",
    "ImportVolumeTaskDetailsOutputTypeDef",
    "InstanceStorageInfoOutputTypeDef",
    "VpcEndpointConnectionOutputTypeDef",
    "ModifyClientVpnEndpointRequestRequestTypeDef",
    "EbsInfoOutputTypeDef",
    "InstanceBlockDeviceMappingOutputTypeDef",
    "InstanceBlockDeviceMappingSpecificationTypeDef",
    "EgressOnlyInternetGatewayOutputTypeDef",
    "InternetGatewayOutputTypeDef",
    "ElasticGpusOutputTypeDef",
    "EnaSrdSpecificationTypeDef",
    "EnableFastLaunchRequestRequestTypeDef",
    "EnableFastSnapshotRestoreStateErrorItemOutputTypeDef",
    "HistoryRecordEntryOutputTypeDef",
    "HistoryRecordOutputTypeDef",
    "ExportImageResultOutputTypeDef",
    "ExportImageTaskOutputTypeDef",
    "ExportTaskOutputTypeDef",
    "PathFilterOutputTypeDef",
    "FleetSpotMaintenanceStrategiesOutputTypeDef",
    "FleetSpotMaintenanceStrategiesRequestTypeDef",
    "FpgaDeviceInfoOutputTypeDef",
    "FpgaImageAttributeOutputTypeDef",
    "FpgaImageOutputTypeDef",
    "GetAssociatedIpv6PoolCidrsResultOutputTypeDef",
    "GetCapacityReservationUsageResultOutputTypeDef",
    "GetDefaultCreditSpecificationResultOutputTypeDef",
    "ModifyDefaultCreditSpecificationResultOutputTypeDef",
    "GetHostReservationPurchasePreviewResultOutputTypeDef",
    "PurchaseHostReservationResultOutputTypeDef",
    "GetInstanceTypesFromInstanceRequirementsResultOutputTypeDef",
    "GetIpamAddressHistoryResultOutputTypeDef",
    "GetManagedPrefixListAssociationsResultOutputTypeDef",
    "GetManagedPrefixListEntriesResultOutputTypeDef",
    "ReservedInstanceReservationValueOutputTypeDef",
    "GetSpotPlacementScoresResultOutputTypeDef",
    "GetTransitGatewayAttachmentPropagationsResultOutputTypeDef",
    "GetTransitGatewayRouteTableAssociationsResultOutputTypeDef",
    "GetTransitGatewayRouteTablePropagationsResultOutputTypeDef",
    "GetVpnConnectionDeviceTypesResultOutputTypeDef",
    "GetVpnTunnelReplacementStatusResultOutputTypeDef",
    "GpuDeviceInfoOutputTypeDef",
    "IamInstanceProfileAssociationOutputTypeDef",
    "NetworkAclEntryOutputTypeDef",
    "ImageDiskContainerTypeDef",
    "SnapshotDiskContainerTypeDef",
    "LocalGatewayRouteTableOutputTypeDef",
    "ListImagesInRecycleBinResultOutputTypeDef",
    "ImportInstanceLaunchSpecificationTypeDef",
    "InferenceAcceleratorInfoOutputTypeDef",
    "ModifyInstanceCreditSpecificationRequestRequestTypeDef",
    "LaunchTemplateInstanceNetworkInterfaceSpecificationRequestTypeDef",
    "InstanceMarketOptionsRequestTypeDef",
    "ModifyInstanceMetadataOptionsResultOutputTypeDef",
    "InstanceMonitoringOutputTypeDef",
    "InstancePrivateIpAddressOutputTypeDef",
    "InstanceNetworkInterfaceSpecificationOutputTypeDef",
    "InstanceStateChangeOutputTypeDef",
    "InstanceRequirementsOutputTypeDef",
    "InstanceRequirementsRequestTypeDef",
    "InstanceRequirementsTypeDef",
    "InstanceStatusSummaryOutputTypeDef",
    "ModifyInstanceEventStartTimeResultOutputTypeDef",
    "IpPermissionOutputTypeDef",
    "StaleIpPermissionOutputTypeDef",
    "IpPermissionTypeDef",
    "ProvisionIpamPoolCidrRequestRequestTypeDef",
    "IpamDiscoveredAccountOutputTypeDef",
    "IpamDiscoveredResourceCidrOutputTypeDef",
    "IpamPoolOutputTypeDef",
    "IpamResourceCidrOutputTypeDef",
    "IpamOutputTypeDef",
    "IpamResourceDiscoveryOutputTypeDef",
    "IpamPoolCidrOutputTypeDef",
    "Ipv6PoolOutputTypeDef",
    "LaunchTemplateInstanceNetworkInterfaceSpecificationOutputTypeDef",
    "LaunchPermissionModificationsTypeDef",
    "LaunchTemplateBlockDeviceMappingOutputTypeDef",
    "LaunchTemplateBlockDeviceMappingRequestTypeDef",
    "LaunchTemplateInstanceMarketOptionsOutputTypeDef",
    "LaunchTemplateInstanceMarketOptionsRequestTypeDef",
    "ListSnapshotsInRecycleBinResultOutputTypeDef",
    "LoadPermissionModificationsTypeDef",
    "ModifyIpamRequestRequestTypeDef",
    "ModifyIpamResourceDiscoveryRequestRequestTypeDef",
    "ModifyManagedPrefixListRequestRequestTypeDef",
    "ModifyReservedInstancesRequestRequestTypeDef",
    "ModifyTransitGatewayRequestRequestTypeDef",
    "ModifyTransitGatewayVpcAttachmentRequestRequestTypeDef",
    "ModifyVerifiedAccessEndpointRequestRequestTypeDef",
    "ModifyVerifiedAccessTrustProviderRequestRequestTypeDef",
    "ModifyVpcPeeringConnectionOptionsRequestRequestTypeDef",
    "ModifyVpcPeeringConnectionOptionsResultOutputTypeDef",
    "NatGatewayOutputTypeDef",
    "NetworkInfoOutputTypeDef",
    "NetworkInterfacePrivateIpAddressOutputTypeDef",
    "NetworkInterfacePermissionOutputTypeDef",
    "VerifiedAccessTrustProviderOutputTypeDef",
    "PathRequestFilterTypeDef",
    "PathStatementOutputTypeDef",
    "ThroughResourcesStatementOutputTypeDef",
    "PathStatementRequestTypeDef",
    "ThroughResourcesStatementRequestTypeDef",
    "ReservedInstancesListingOutputTypeDef",
    "ProvisionPublicIpv4PoolCidrResultOutputTypeDef",
    "PublicIpv4PoolOutputTypeDef",
    "PurchaseScheduledInstancesRequestRequestTypeDef",
    "PurchaseReservedInstancesOfferingRequestRequestTypeDef",
    "ReservedInstancesOfferingOutputTypeDef",
    "ReservedInstancesOutputTypeDef",
    "SecurityGroupRuleOutputTypeDef",
    "RegisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    "RegisterTransitGatewayMulticastGroupMembersResultOutputTypeDef",
    "RegisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef",
    "ReservedInstancesModificationResultOutputTypeDef",
    "StorageOutputTypeDef",
    "StorageTypeDef",
    "ScheduledInstanceAvailabilityOutputTypeDef",
    "ScheduledInstanceOutputTypeDef",
    "ScheduledInstancesBlockDeviceMappingTypeDef",
    "ScheduledInstancesNetworkInterfaceTypeDef",
    "SearchTransitGatewayMulticastGroupsResultOutputTypeDef",
    "VpcEndpointOutputTypeDef",
    "SecurityGroupRuleUpdateTypeDef",
    "ServiceConfigurationOutputTypeDef",
    "ServiceDetailOutputTypeDef",
    "SnapshotDetailOutputTypeDef",
    "SnapshotTaskDetailOutputTypeDef",
    "SpotMaintenanceStrategiesOutputTypeDef",
    "SpotMaintenanceStrategiesTypeDef",
    "SpotDatafeedSubscriptionOutputTypeDef",
    "TransitGatewayMulticastDomainAssociationOutputTypeDef",
    "TransitGatewayMulticastDomainAssociationsOutputTypeDef",
    "SubnetIpv6CidrBlockAssociationOutputTypeDef",
    "TargetReservationValueOutputTypeDef",
    "TargetGroupsConfigOutputTypeDef",
    "TargetGroupsConfigTypeDef",
    "TrafficMirrorFilterRuleOutputTypeDef",
    "TransitGatewayAttachmentOutputTypeDef",
    "TransitGatewayConnectPeerConfigurationOutputTypeDef",
    "TransitGatewayConnectOutputTypeDef",
    "TransitGatewayMulticastDomainOutputTypeDef",
    "TransitGatewayOutputTypeDef",
    "TransitGatewayPeeringAttachmentOutputTypeDef",
    "TransitGatewayPolicyRuleOutputTypeDef",
    "TransitGatewayPrefixListReferenceOutputTypeDef",
    "TransitGatewayRouteOutputTypeDef",
    "TransitGatewayVpcAttachmentOutputTypeDef",
    "UnsuccessfulInstanceCreditSpecificationItemOutputTypeDef",
    "UnsuccessfulItemOutputTypeDef",
    "ValidationWarningOutputTypeDef",
    "VerifiedAccessEndpointOutputTypeDef",
    "VerifiedAccessInstanceOutputTypeDef",
    "VerifiedAccessLogCloudWatchLogsDestinationOutputTypeDef",
    "VerifiedAccessLogKinesisDataFirehoseDestinationOutputTypeDef",
    "VerifiedAccessLogS3DestinationOutputTypeDef",
    "VerifiedAccessLogOptionsTypeDef",
    "VolumeOutputTypeDef",
    "VolumeResponseMetadataTypeDef",
    "VolumeStatusInfoOutputTypeDef",
    "VpcCidrBlockAssociationOutputTypeDef",
    "VpcIpv6CidrBlockAssociationOutputTypeDef",
    "VpcPeeringConnectionVpcInfoOutputTypeDef",
    "VpcPeeringConnectionVpcInfoResponseMetadataTypeDef",
    "DescribeAccountAttributesResultOutputTypeDef",
    "AdditionalDetailOutputTypeDef",
    "DescribeAddressesAttributeResultOutputTypeDef",
    "ModifyAddressAttributeResultOutputTypeDef",
    "ResetAddressAttributeResultOutputTypeDef",
    "DescribeAddressesResultOutputTypeDef",
    "DescribeVpcEndpointServicePermissionsResultOutputTypeDef",
    "CreateCarrierGatewayResultOutputTypeDef",
    "DeleteCarrierGatewayResultOutputTypeDef",
    "DescribeCarrierGatewaysResultOutputTypeDef",
    "CreateCoipPoolResultOutputTypeDef",
    "DeleteCoipPoolResultOutputTypeDef",
    "DescribeCoipPoolsResultOutputTypeDef",
    "CreateCustomerGatewayResultOutputTypeDef",
    "DescribeCustomerGatewaysResultOutputTypeDef",
    "CreateInstanceConnectEndpointResultOutputTypeDef",
    "DeleteInstanceConnectEndpointResultOutputTypeDef",
    "DescribeInstanceConnectEndpointsResultOutputTypeDef",
    "DescribeHostReservationsResultOutputTypeDef",
    "InstanceEventWindowOutputTypeDef",
    "AssociateIpamResourceDiscoveryResultOutputTypeDef",
    "DescribeIpamResourceDiscoveryAssociationsResultOutputTypeDef",
    "DisassociateIpamResourceDiscoveryResultOutputTypeDef",
    "CreateIpamScopeResultOutputTypeDef",
    "DeleteIpamScopeResultOutputTypeDef",
    "DescribeIpamScopesResultOutputTypeDef",
    "ModifyIpamScopeResultOutputTypeDef",
    "DescribeKeyPairsResultOutputTypeDef",
    "DeleteLaunchTemplateResultOutputTypeDef",
    "DescribeLaunchTemplatesResultOutputTypeDef",
    "ModifyLaunchTemplateResultOutputTypeDef",
    "DescribeLocalGatewaysResultOutputTypeDef",
    "CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef",
    "DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef",
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsResultOutputTypeDef",
    "CreateLocalGatewayRouteTableVpcAssociationResultOutputTypeDef",
    "DeleteLocalGatewayRouteTableVpcAssociationResultOutputTypeDef",
    "DescribeLocalGatewayRouteTableVpcAssociationsResultOutputTypeDef",
    "DescribeLocalGatewayVirtualInterfaceGroupsResultOutputTypeDef",
    "DescribeLocalGatewayVirtualInterfacesResultOutputTypeDef",
    "CreateManagedPrefixListResultOutputTypeDef",
    "DeleteManagedPrefixListResultOutputTypeDef",
    "DescribeManagedPrefixListsResultOutputTypeDef",
    "ModifyManagedPrefixListResultOutputTypeDef",
    "RestoreManagedPrefixListVersionResultOutputTypeDef",
    "DescribeNetworkInsightsAccessScopeAnalysesResultOutputTypeDef",
    "StartNetworkInsightsAccessScopeAnalysisResultOutputTypeDef",
    "DescribeNetworkInsightsAccessScopesResultOutputTypeDef",
    "CreatePlacementGroupResultOutputTypeDef",
    "DescribePlacementGroupsResultOutputTypeDef",
    "CreateReplaceRootVolumeTaskResultOutputTypeDef",
    "DescribeReplaceRootVolumeTasksResultOutputTypeDef",
    "CreateSnapshotsResultOutputTypeDef",
    "DescribeSnapshotsResultOutputTypeDef",
    "DescribeSnapshotTierStatusResultOutputTypeDef",
    "CreateSubnetCidrReservationResultOutputTypeDef",
    "DeleteSubnetCidrReservationResultOutputTypeDef",
    "GetSubnetCidrReservationsResultOutputTypeDef",
    "CreateTrafficMirrorSessionResultOutputTypeDef",
    "DescribeTrafficMirrorSessionsResultOutputTypeDef",
    "ModifyTrafficMirrorSessionResultOutputTypeDef",
    "CreateTrafficMirrorTargetResultOutputTypeDef",
    "DescribeTrafficMirrorTargetsResultOutputTypeDef",
    "CreateTransitGatewayPolicyTableResultOutputTypeDef",
    "DeleteTransitGatewayPolicyTableResultOutputTypeDef",
    "DescribeTransitGatewayPolicyTablesResultOutputTypeDef",
    "CreateTransitGatewayRouteTableAnnouncementResultOutputTypeDef",
    "DeleteTransitGatewayRouteTableAnnouncementResultOutputTypeDef",
    "DescribeTransitGatewayRouteTableAnnouncementsResultOutputTypeDef",
    "CreateTransitGatewayRouteTableResultOutputTypeDef",
    "DeleteTransitGatewayRouteTableResultOutputTypeDef",
    "DescribeTransitGatewayRouteTablesResultOutputTypeDef",
    "AssociateTrunkInterfaceResultOutputTypeDef",
    "DescribeTrunkInterfaceAssociationsResultOutputTypeDef",
    "CreateVerifiedAccessGroupResultOutputTypeDef",
    "DeleteVerifiedAccessGroupResultOutputTypeDef",
    "DescribeVerifiedAccessGroupsResultOutputTypeDef",
    "ModifyVerifiedAccessGroupResultOutputTypeDef",
    "DescribeVpcClassicLinkResultOutputTypeDef",
    "ExplanationOutputTypeDef",
    "DescribeClientVpnTargetNetworksResultOutputTypeDef",
    "RouteTableOutputTypeDef",
    "GetFlowLogsIntegrationTemplateRequestRequestTypeDef",
    "CreateVpnGatewayResultOutputTypeDef",
    "DescribeVpnGatewaysResultOutputTypeDef",
    "NetworkInterfaceAttachmentOutputTypeDef",
    "NetworkInterfaceAttachmentResponseMetadataTypeDef",
    "DhcpOptionsOutputTypeDef",
    "DescribeClientVpnAuthorizationRulesResultOutputTypeDef",
    "DescribeAvailabilityZonesResultOutputTypeDef",
    "HostOutputTypeDef",
    "ImageAttributeOutputTypeDef",
    "ImageOutputTypeDef",
    "RegisterImageRequestRequestTypeDef",
    "RegisterImageRequestServiceResourceRegisterImageTypeDef",
    "CancelCapacityReservationFleetsResultOutputTypeDef",
    "CancelSpotFleetRequestsResponseOutputTypeDef",
    "CreateCapacityReservationResultOutputTypeDef",
    "DescribeCapacityReservationsResultOutputTypeDef",
    "DescribeCapacityReservationFleetsResultOutputTypeDef",
    "ModifyInstanceCapacityReservationAttributesRequestRequestTypeDef",
    "DescribeClassicLinkInstancesResultOutputTypeDef",
    "AssociateInstanceEventWindowRequestRequestTypeDef",
    "DisassociateInstanceEventWindowRequestRequestTypeDef",
    "AcceptAddressTransferRequestRequestTypeDef",
    "AllocateAddressRequestRequestTypeDef",
    "AllocateHostsRequestRequestTypeDef",
    "AssociateIpamResourceDiscoveryRequestRequestTypeDef",
    "CopySnapshotRequestRequestTypeDef",
    "CopySnapshotRequestSnapshotCopyTypeDef",
    "CreateCapacityReservationFleetRequestRequestTypeDef",
    "CreateCapacityReservationRequestRequestTypeDef",
    "CreateCarrierGatewayRequestRequestTypeDef",
    "CreateCoipPoolRequestRequestTypeDef",
    "CreateCustomerGatewayRequestRequestTypeDef",
    "CreateDhcpOptionsRequestRequestTypeDef",
    "CreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef",
    "CreateEgressOnlyInternetGatewayRequestRequestTypeDef",
    "CreateFlowLogsRequestRequestTypeDef",
    "CreateFpgaImageRequestRequestTypeDef",
    "CreateImageRequestInstanceCreateImageTypeDef",
    "CreateImageRequestRequestTypeDef",
    "CreateInstanceConnectEndpointRequestRequestTypeDef",
    "CreateInstanceEventWindowRequestRequestTypeDef",
    "CreateInstanceExportTaskRequestRequestTypeDef",
    "CreateInternetGatewayRequestRequestTypeDef",
    "CreateInternetGatewayRequestServiceResourceCreateInternetGatewayTypeDef",
    "CreateIpamPoolRequestRequestTypeDef",
    "CreateIpamRequestRequestTypeDef",
    "CreateIpamResourceDiscoveryRequestRequestTypeDef",
    "CreateIpamScopeRequestRequestTypeDef",
    "CreateKeyPairRequestRequestTypeDef",
    "CreateKeyPairRequestServiceResourceCreateKeyPairTypeDef",
    "CreateLocalGatewayRouteTableRequestRequestTypeDef",
    "CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    "CreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    "CreateManagedPrefixListRequestRequestTypeDef",
    "CreateNatGatewayRequestRequestTypeDef",
    "CreateNetworkAclRequestRequestTypeDef",
    "CreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef",
    "CreateNetworkAclRequestVpcCreateNetworkAclTypeDef",
    "CreateNetworkInterfaceRequestRequestTypeDef",
    "CreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef",
    "CreateNetworkInterfaceRequestSubnetCreateNetworkInterfaceTypeDef",
    "CreatePlacementGroupRequestRequestTypeDef",
    "CreatePlacementGroupRequestServiceResourceCreatePlacementGroupTypeDef",
    "CreatePublicIpv4PoolRequestRequestTypeDef",
    "CreateReplaceRootVolumeTaskRequestRequestTypeDef",
    "CreateRestoreImageTaskRequestRequestTypeDef",
    "CreateRouteTableRequestRequestTypeDef",
    "CreateRouteTableRequestServiceResourceCreateRouteTableTypeDef",
    "CreateRouteTableRequestVpcCreateRouteTableTypeDef",
    "CreateSecurityGroupRequestRequestTypeDef",
    "CreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef",
    "CreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef",
    "CreateSnapshotRequestRequestTypeDef",
    "CreateSnapshotRequestServiceResourceCreateSnapshotTypeDef",
    "CreateSnapshotRequestVolumeCreateSnapshotTypeDef",
    "CreateSnapshotsRequestRequestTypeDef",
    "CreateSubnetCidrReservationRequestRequestTypeDef",
    "CreateSubnetRequestRequestTypeDef",
    "CreateSubnetRequestServiceResourceCreateSubnetTypeDef",
    "CreateSubnetRequestVpcCreateSubnetTypeDef",
    "CreateTrafficMirrorFilterRequestRequestTypeDef",
    "CreateTrafficMirrorSessionRequestRequestTypeDef",
    "CreateTrafficMirrorTargetRequestRequestTypeDef",
    "CreateTransitGatewayConnectPeerRequestRequestTypeDef",
    "CreateTransitGatewayConnectRequestRequestTypeDef",
    "CreateTransitGatewayMulticastDomainRequestRequestTypeDef",
    "CreateTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    "CreateTransitGatewayPolicyTableRequestRequestTypeDef",
    "CreateTransitGatewayRequestRequestTypeDef",
    "CreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    "CreateTransitGatewayRouteTableRequestRequestTypeDef",
    "CreateTransitGatewayVpcAttachmentRequestRequestTypeDef",
    "CreateVerifiedAccessEndpointRequestRequestTypeDef",
    "CreateVerifiedAccessGroupRequestRequestTypeDef",
    "CreateVerifiedAccessInstanceRequestRequestTypeDef",
    "CreateVerifiedAccessTrustProviderRequestRequestTypeDef",
    "CreateVolumeRequestRequestTypeDef",
    "CreateVolumeRequestServiceResourceCreateVolumeTypeDef",
    "CreateVpcEndpointRequestRequestTypeDef",
    "CreateVpcEndpointServiceConfigurationRequestRequestTypeDef",
    "CreateVpcPeeringConnectionRequestRequestTypeDef",
    "CreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef",
    "CreateVpcPeeringConnectionRequestVpcRequestVpcPeeringConnectionTypeDef",
    "CreateVpcRequestRequestTypeDef",
    "CreateVpcRequestServiceResourceCreateVpcTypeDef",
    "CreateVpnGatewayRequestRequestTypeDef",
    "ExportImageRequestRequestTypeDef",
    "ImportKeyPairRequestRequestTypeDef",
    "ImportKeyPairRequestServiceResourceImportKeyPairTypeDef",
    "ProvisionByoipCidrRequestRequestTypeDef",
    "PurchaseHostReservationRequestRequestTypeDef",
    "StartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    "StartNetworkInsightsAnalysisRequestRequestTypeDef",
    "ClientVpnEndpointOutputTypeDef",
    "CreateClientVpnEndpointRequestRequestTypeDef",
    "DescribeClientVpnConnectionsResultOutputTypeDef",
    "TerminateClientVpnConnectionsResultOutputTypeDef",
    "DescribeClientVpnRoutesResultOutputTypeDef",
    "TunnelOptionOutputTypeDef",
    "ModifyVpnTunnelOptionsSpecificationTypeDef",
    "VpnTunnelOptionsSpecificationTypeDef",
    "RequestSpotLaunchSpecificationTypeDef",
    "ModifySnapshotAttributeRequestRequestTypeDef",
    "ModifySnapshotAttributeRequestSnapshotModifyAttributeTypeDef",
    "GetAwsNetworkPerformanceDataResultOutputTypeDef",
    "DeleteFleetsResultOutputTypeDef",
    "DeleteLaunchTemplateVersionsResultOutputTypeDef",
    "DeleteQueuedReservedInstancesResultOutputTypeDef",
    "DescribePrincipalIdFormatResultOutputTypeDef",
    "DescribeFastLaunchImagesResultOutputTypeDef",
    "DescribeFlowLogsResultOutputTypeDef",
    "DisableFastSnapshotRestoreErrorItemOutputTypeDef",
    "ImportInstanceTaskDetailsOutputTypeDef",
    "DescribeVpcEndpointConnectionsResultOutputTypeDef",
    "InstanceAttributeOutputTypeDef",
    "ModifyInstanceAttributeRequestInstanceModifyAttributeTypeDef",
    "ModifyInstanceAttributeRequestRequestTypeDef",
    "CreateEgressOnlyInternetGatewayResultOutputTypeDef",
    "DescribeEgressOnlyInternetGatewaysResultOutputTypeDef",
    "CreateInternetGatewayResultOutputTypeDef",
    "DescribeInternetGatewaysResultOutputTypeDef",
    "DescribeElasticGpusResultOutputTypeDef",
    "AttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef",
    "AttachNetworkInterfaceRequestRequestTypeDef",
    "ModifyNetworkInterfaceAttributeRequestNetworkInterfaceModifyAttributeTypeDef",
    "ModifyNetworkInterfaceAttributeRequestRequestTypeDef",
    "EnableFastSnapshotRestoreErrorItemOutputTypeDef",
    "DescribeFleetHistoryResultOutputTypeDef",
    "DescribeSpotFleetRequestHistoryResponseOutputTypeDef",
    "DescribeExportImageTasksResultOutputTypeDef",
    "CreateInstanceExportTaskResultOutputTypeDef",
    "DescribeExportTasksResultOutputTypeDef",
    "NetworkInsightsPathOutputTypeDef",
    "SpotOptionsOutputTypeDef",
    "SpotOptionsRequestTypeDef",
    "FpgaInfoOutputTypeDef",
    "DescribeFpgaImageAttributeResultOutputTypeDef",
    "ModifyFpgaImageAttributeResultOutputTypeDef",
    "DescribeFpgaImagesResultOutputTypeDef",
    "GpuInfoOutputTypeDef",
    "AssociateIamInstanceProfileResultOutputTypeDef",
    "DescribeIamInstanceProfileAssociationsResultOutputTypeDef",
    "DisassociateIamInstanceProfileResultOutputTypeDef",
    "ReplaceIamInstanceProfileAssociationResultOutputTypeDef",
    "NetworkAclOutputTypeDef",
    "ImportImageRequestRequestTypeDef",
    "ImportSnapshotRequestRequestTypeDef",
    "CreateLocalGatewayRouteTableResultOutputTypeDef",
    "DeleteLocalGatewayRouteTableResultOutputTypeDef",
    "DescribeLocalGatewayRouteTablesResultOutputTypeDef",
    "ImportInstanceRequestRequestTypeDef",
    "RunInstancesRequestRequestTypeDef",
    "RunInstancesRequestServiceResourceCreateInstancesTypeDef",
    "RunInstancesRequestSubnetCreateInstancesTypeDef",
    "MonitorInstancesResultOutputTypeDef",
    "UnmonitorInstancesResultOutputTypeDef",
    "InstanceNetworkInterfaceOutputTypeDef",
    "LaunchSpecificationOutputTypeDef",
    "StartInstancesResultOutputTypeDef",
    "StopInstancesResultOutputTypeDef",
    "TerminateInstancesResultOutputTypeDef",
    "FleetLaunchTemplateOverridesOutputTypeDef",
    "LaunchTemplateOverridesOutputTypeDef",
    "SpotFleetLaunchSpecificationOutputTypeDef",
    "FleetLaunchTemplateOverridesRequestTypeDef",
    "GetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef",
    "GetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef",
    "InstanceRequirementsWithMetadataRequestTypeDef",
    "LaunchTemplateOverridesTypeDef",
    "SpotFleetLaunchSpecificationTypeDef",
    "InstanceStatusOutputTypeDef",
    "RevokeSecurityGroupEgressResultOutputTypeDef",
    "RevokeSecurityGroupIngressResultOutputTypeDef",
    "SecurityGroupOutputTypeDef",
    "StaleSecurityGroupOutputTypeDef",
    "AuthorizeSecurityGroupEgressRequestRequestTypeDef",
    "AuthorizeSecurityGroupEgressRequestSecurityGroupAuthorizeEgressTypeDef",
    "AuthorizeSecurityGroupIngressRequestRequestTypeDef",
    "AuthorizeSecurityGroupIngressRequestSecurityGroupAuthorizeIngressTypeDef",
    "RevokeSecurityGroupEgressRequestRequestTypeDef",
    "RevokeSecurityGroupEgressRequestSecurityGroupRevokeEgressTypeDef",
    "RevokeSecurityGroupIngressRequestRequestTypeDef",
    "RevokeSecurityGroupIngressRequestSecurityGroupRevokeIngressTypeDef",
    "UpdateSecurityGroupRuleDescriptionsEgressRequestRequestTypeDef",
    "UpdateSecurityGroupRuleDescriptionsIngressRequestRequestTypeDef",
    "GetIpamDiscoveredAccountsResultOutputTypeDef",
    "GetIpamDiscoveredResourceCidrsResultOutputTypeDef",
    "CreateIpamPoolResultOutputTypeDef",
    "DeleteIpamPoolResultOutputTypeDef",
    "DescribeIpamPoolsResultOutputTypeDef",
    "ModifyIpamPoolResultOutputTypeDef",
    "GetIpamResourceCidrsResultOutputTypeDef",
    "ModifyIpamResourceCidrResultOutputTypeDef",
    "CreateIpamResultOutputTypeDef",
    "DeleteIpamResultOutputTypeDef",
    "DescribeIpamsResultOutputTypeDef",
    "ModifyIpamResultOutputTypeDef",
    "CreateIpamResourceDiscoveryResultOutputTypeDef",
    "DeleteIpamResourceDiscoveryResultOutputTypeDef",
    "DescribeIpamResourceDiscoveriesResultOutputTypeDef",
    "ModifyIpamResourceDiscoveryResultOutputTypeDef",
    "DeprovisionIpamPoolCidrResultOutputTypeDef",
    "GetIpamPoolCidrsResultOutputTypeDef",
    "ProvisionIpamPoolCidrResultOutputTypeDef",
    "DescribeIpv6PoolsResultOutputTypeDef",
    "ModifyImageAttributeRequestImageModifyAttributeTypeDef",
    "ModifyImageAttributeRequestRequestTypeDef",
    "ResponseLaunchTemplateDataOutputTypeDef",
    "RequestLaunchTemplateDataTypeDef",
    "ModifyFpgaImageAttributeRequestRequestTypeDef",
    "CreateNatGatewayResultOutputTypeDef",
    "DescribeNatGatewaysResultOutputTypeDef",
    "CreateNetworkInterfacePermissionResultOutputTypeDef",
    "DescribeNetworkInterfacePermissionsResultOutputTypeDef",
    "CreateVerifiedAccessTrustProviderResultOutputTypeDef",
    "DeleteVerifiedAccessTrustProviderResultOutputTypeDef",
    "DescribeVerifiedAccessTrustProvidersResultOutputTypeDef",
    "ModifyVerifiedAccessTrustProviderResultOutputTypeDef",
    "CreateNetworkInsightsPathRequestRequestTypeDef",
    "AccessScopePathOutputTypeDef",
    "AccessScopePathRequestTypeDef",
    "CancelReservedInstancesListingResultOutputTypeDef",
    "CreateReservedInstancesListingResultOutputTypeDef",
    "DescribeReservedInstancesListingsResultOutputTypeDef",
    "DescribePublicIpv4PoolsResultOutputTypeDef",
    "DescribeReservedInstancesOfferingsResultOutputTypeDef",
    "DescribeReservedInstancesResultOutputTypeDef",
    "AuthorizeSecurityGroupEgressResultOutputTypeDef",
    "AuthorizeSecurityGroupIngressResultOutputTypeDef",
    "DescribeSecurityGroupRulesResultOutputTypeDef",
    "ReservedInstancesModificationOutputTypeDef",
    "BundleTaskOutputTypeDef",
    "BundleInstanceRequestRequestTypeDef",
    "DescribeScheduledInstanceAvailabilityResultOutputTypeDef",
    "DescribeScheduledInstancesResultOutputTypeDef",
    "PurchaseScheduledInstancesResultOutputTypeDef",
    "ScheduledInstancesLaunchSpecificationTypeDef",
    "CreateVpcEndpointResultOutputTypeDef",
    "DescribeVpcEndpointsResultOutputTypeDef",
    "ModifySecurityGroupRulesRequestRequestTypeDef",
    "CreateVpcEndpointServiceConfigurationResultOutputTypeDef",
    "DescribeVpcEndpointServiceConfigurationsResultOutputTypeDef",
    "DescribeVpcEndpointServicesResultOutputTypeDef",
    "ImportImageResultOutputTypeDef",
    "ImportImageTaskOutputTypeDef",
    "ImportSnapshotResultOutputTypeDef",
    "ImportSnapshotTaskOutputTypeDef",
    "CreateSpotDatafeedSubscriptionResultOutputTypeDef",
    "DescribeSpotDatafeedSubscriptionResultOutputTypeDef",
    "GetTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    "AcceptTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    "AssociateTransitGatewayMulticastDomainResultOutputTypeDef",
    "DisassociateTransitGatewayMulticastDomainResultOutputTypeDef",
    "RejectTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    "AssociateSubnetCidrBlockResultOutputTypeDef",
    "DisassociateSubnetCidrBlockResultOutputTypeDef",
    "SubnetOutputTypeDef",
    "GetReservedInstancesExchangeQuoteResultOutputTypeDef",
    "LoadBalancersConfigOutputTypeDef",
    "LoadBalancersConfigTypeDef",
    "CreateTrafficMirrorFilterRuleResultOutputTypeDef",
    "ModifyTrafficMirrorFilterRuleResultOutputTypeDef",
    "TrafficMirrorFilterOutputTypeDef",
    "DescribeTransitGatewayAttachmentsResultOutputTypeDef",
    "TransitGatewayConnectPeerOutputTypeDef",
    "CreateTransitGatewayConnectResultOutputTypeDef",
    "DeleteTransitGatewayConnectResultOutputTypeDef",
    "DescribeTransitGatewayConnectsResultOutputTypeDef",
    "CreateTransitGatewayMulticastDomainResultOutputTypeDef",
    "DeleteTransitGatewayMulticastDomainResultOutputTypeDef",
    "DescribeTransitGatewayMulticastDomainsResultOutputTypeDef",
    "CreateTransitGatewayResultOutputTypeDef",
    "DeleteTransitGatewayResultOutputTypeDef",
    "DescribeTransitGatewaysResultOutputTypeDef",
    "ModifyTransitGatewayResultOutputTypeDef",
    "AcceptTransitGatewayPeeringAttachmentResultOutputTypeDef",
    "CreateTransitGatewayPeeringAttachmentResultOutputTypeDef",
    "DeleteTransitGatewayPeeringAttachmentResultOutputTypeDef",
    "DescribeTransitGatewayPeeringAttachmentsResultOutputTypeDef",
    "RejectTransitGatewayPeeringAttachmentResultOutputTypeDef",
    "TransitGatewayPolicyTableEntryOutputTypeDef",
    "CreateTransitGatewayPrefixListReferenceResultOutputTypeDef",
    "DeleteTransitGatewayPrefixListReferenceResultOutputTypeDef",
    "GetTransitGatewayPrefixListReferencesResultOutputTypeDef",
    "ModifyTransitGatewayPrefixListReferenceResultOutputTypeDef",
    "CreateTransitGatewayRouteResultOutputTypeDef",
    "DeleteTransitGatewayRouteResultOutputTypeDef",
    "ReplaceTransitGatewayRouteResultOutputTypeDef",
    "SearchTransitGatewayRoutesResultOutputTypeDef",
    "AcceptTransitGatewayVpcAttachmentResultOutputTypeDef",
    "CreateTransitGatewayVpcAttachmentResultOutputTypeDef",
    "DeleteTransitGatewayVpcAttachmentResultOutputTypeDef",
    "DescribeTransitGatewayVpcAttachmentsResultOutputTypeDef",
    "ModifyTransitGatewayVpcAttachmentResultOutputTypeDef",
    "RejectTransitGatewayVpcAttachmentResultOutputTypeDef",
    "ModifyInstanceCreditSpecificationResultOutputTypeDef",
    "AcceptVpcEndpointConnectionsResultOutputTypeDef",
    "CreateFlowLogsResultOutputTypeDef",
    "DeleteFlowLogsResultOutputTypeDef",
    "DeleteVpcEndpointConnectionNotificationsResultOutputTypeDef",
    "DeleteVpcEndpointServiceConfigurationsResultOutputTypeDef",
    "DeleteVpcEndpointsResultOutputTypeDef",
    "ModifyHostsResultOutputTypeDef",
    "RejectVpcEndpointConnectionsResultOutputTypeDef",
    "ReleaseHostsResultOutputTypeDef",
    "CreateLaunchTemplateResultOutputTypeDef",
    "CreateVerifiedAccessEndpointResultOutputTypeDef",
    "DeleteVerifiedAccessEndpointResultOutputTypeDef",
    "DescribeVerifiedAccessEndpointsResultOutputTypeDef",
    "ModifyVerifiedAccessEndpointResultOutputTypeDef",
    "AttachVerifiedAccessTrustProviderResultOutputTypeDef",
    "CreateVerifiedAccessInstanceResultOutputTypeDef",
    "DeleteVerifiedAccessInstanceResultOutputTypeDef",
    "DescribeVerifiedAccessInstancesResultOutputTypeDef",
    "DetachVerifiedAccessTrustProviderResultOutputTypeDef",
    "ModifyVerifiedAccessInstanceResultOutputTypeDef",
    "VerifiedAccessLogsOutputTypeDef",
    "ModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef",
    "DescribeVolumesResultOutputTypeDef",
    "VolumeStatusItemOutputTypeDef",
    "AssociateVpcCidrBlockResultOutputTypeDef",
    "DisassociateVpcCidrBlockResultOutputTypeDef",
    "VpcOutputTypeDef",
    "VpcPeeringConnectionOutputTypeDef",
    "AssociateInstanceEventWindowResultOutputTypeDef",
    "CreateInstanceEventWindowResultOutputTypeDef",
    "DescribeInstanceEventWindowsResultOutputTypeDef",
    "DisassociateInstanceEventWindowResultOutputTypeDef",
    "ModifyInstanceEventWindowResultOutputTypeDef",
    "PathComponentOutputTypeDef",
    "CreateRouteTableResultOutputTypeDef",
    "DescribeRouteTablesResultOutputTypeDef",
    "DescribeNetworkInterfaceAttributeResultOutputTypeDef",
    "NetworkInterfaceOutputTypeDef",
    "CreateDhcpOptionsResultOutputTypeDef",
    "DescribeDhcpOptionsResultOutputTypeDef",
    "DescribeHostsResultOutputTypeDef",
    "DescribeImagesResultOutputTypeDef",
    "DescribeClientVpnEndpointsResultOutputTypeDef",
    "VpnConnectionOptionsOutputTypeDef",
    "ModifyVpnTunnelOptionsRequestRequestTypeDef",
    "VpnConnectionOptionsSpecificationTypeDef",
    "RequestSpotInstancesRequestRequestTypeDef",
    "DisableFastSnapshotRestoresResultOutputTypeDef",
    "ConversionTaskOutputTypeDef",
    "EnableFastSnapshotRestoresResultOutputTypeDef",
    "CreateNetworkInsightsPathResultOutputTypeDef",
    "DescribeNetworkInsightsPathsResultOutputTypeDef",
    "InstanceTypeInfoOutputTypeDef",
    "CreateNetworkAclResultOutputTypeDef",
    "DescribeNetworkAclsResultOutputTypeDef",
    "InstanceOutputTypeDef",
    "SpotInstanceRequestOutputTypeDef",
    "FleetLaunchTemplateConfigOutputTypeDef",
    "LaunchTemplateAndOverridesResponseOutputTypeDef",
    "LaunchTemplateConfigOutputTypeDef",
    "FleetLaunchTemplateConfigRequestTypeDef",
    "GetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef",
    "GetSpotPlacementScoresRequestRequestTypeDef",
    "LaunchTemplateConfigTypeDef",
    "DescribeInstanceStatusResultOutputTypeDef",
    "DescribeSecurityGroupsResultOutputTypeDef",
    "DescribeStaleSecurityGroupsResultOutputTypeDef",
    "GetLaunchTemplateDataResultOutputTypeDef",
    "LaunchTemplateVersionOutputTypeDef",
    "CreateLaunchTemplateRequestRequestTypeDef",
    "CreateLaunchTemplateVersionRequestRequestTypeDef",
    "NetworkInsightsAccessScopeContentOutputTypeDef",
    "CreateNetworkInsightsAccessScopeRequestRequestTypeDef",
    "DescribeReservedInstancesModificationsResultOutputTypeDef",
    "BundleInstanceResultOutputTypeDef",
    "CancelBundleTaskResultOutputTypeDef",
    "DescribeBundleTasksResultOutputTypeDef",
    "RunScheduledInstancesRequestRequestTypeDef",
    "DescribeImportImageTasksResultOutputTypeDef",
    "DescribeImportSnapshotTasksResultOutputTypeDef",
    "CreateDefaultSubnetResultOutputTypeDef",
    "CreateSubnetResultOutputTypeDef",
    "DescribeSubnetsResultOutputTypeDef",
    "CreateTrafficMirrorFilterResultOutputTypeDef",
    "DescribeTrafficMirrorFiltersResultOutputTypeDef",
    "ModifyTrafficMirrorFilterNetworkServicesResultOutputTypeDef",
    "CreateTransitGatewayConnectPeerResultOutputTypeDef",
    "DeleteTransitGatewayConnectPeerResultOutputTypeDef",
    "DescribeTransitGatewayConnectPeersResultOutputTypeDef",
    "GetTransitGatewayPolicyTableEntriesResultOutputTypeDef",
    "VerifiedAccessInstanceLoggingConfigurationOutputTypeDef",
    "DescribeVolumeStatusResultOutputTypeDef",
    "CreateDefaultVpcResultOutputTypeDef",
    "CreateVpcResultOutputTypeDef",
    "DescribeVpcsResultOutputTypeDef",
    "AcceptVpcPeeringConnectionResultOutputTypeDef",
    "CreateVpcPeeringConnectionResultOutputTypeDef",
    "DescribeVpcPeeringConnectionsResultOutputTypeDef",
    "AccessScopeAnalysisFindingOutputTypeDef",
    "NetworkInsightsAnalysisOutputTypeDef",
    "CreateNetworkInterfaceResultOutputTypeDef",
    "DescribeNetworkInterfacesResultOutputTypeDef",
    "VpnConnectionOutputTypeDef",
    "CreateVpnConnectionRequestRequestTypeDef",
    "DescribeConversionTasksResultOutputTypeDef",
    "ImportInstanceResultOutputTypeDef",
    "ImportVolumeResultOutputTypeDef",
    "DescribeInstanceTypesResultOutputTypeDef",
    "ReservationOutputTypeDef",
    "ReservationResponseMetadataTypeDef",
    "DescribeSpotInstanceRequestsResultOutputTypeDef",
    "RequestSpotInstancesResultOutputTypeDef",
    "CreateFleetErrorOutputTypeDef",
    "CreateFleetInstanceOutputTypeDef",
    "DescribeFleetErrorOutputTypeDef",
    "DescribeFleetsInstancesOutputTypeDef",
    "SpotFleetRequestConfigDataOutputTypeDef",
    "CreateFleetRequestRequestTypeDef",
    "ModifyFleetRequestRequestTypeDef",
    "ModifySpotFleetRequestRequestRequestTypeDef",
    "SpotFleetRequestConfigDataTypeDef",
    "CreateLaunchTemplateVersionResultOutputTypeDef",
    "DescribeLaunchTemplateVersionsResultOutputTypeDef",
    "CreateNetworkInsightsAccessScopeResultOutputTypeDef",
    "GetNetworkInsightsAccessScopeContentResultOutputTypeDef",
    "DescribeVerifiedAccessInstanceLoggingConfigurationsResultOutputTypeDef",
    "ModifyVerifiedAccessInstanceLoggingConfigurationResultOutputTypeDef",
    "GetNetworkInsightsAccessScopeAnalysisFindingsResultOutputTypeDef",
    "DescribeNetworkInsightsAnalysesResultOutputTypeDef",
    "StartNetworkInsightsAnalysisResultOutputTypeDef",
    "CreateVpnConnectionResultOutputTypeDef",
    "DescribeVpnConnectionsResultOutputTypeDef",
    "ModifyVpnConnectionOptionsResultOutputTypeDef",
    "ModifyVpnConnectionResultOutputTypeDef",
    "ModifyVpnTunnelCertificateResultOutputTypeDef",
    "ModifyVpnTunnelOptionsResultOutputTypeDef",
    "DescribeInstancesResultOutputTypeDef",
    "CreateFleetResultOutputTypeDef",
    "FleetDataOutputTypeDef",
    "SpotFleetRequestConfigOutputTypeDef",
    "RequestSpotFleetRequestRequestTypeDef",
    "DescribeFleetsResultOutputTypeDef",
    "DescribeSpotFleetRequestsResponseOutputTypeDef",
)

AcceleratorCountOutputTypeDef = TypedDict(
    "AcceleratorCountOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

AcceleratorCountRequestTypeDef = TypedDict(
    "AcceleratorCountRequestTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

AcceleratorCountTypeDef = TypedDict(
    "AcceleratorCountTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

AcceleratorTotalMemoryMiBOutputTypeDef = TypedDict(
    "AcceleratorTotalMemoryMiBOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

AcceleratorTotalMemoryMiBRequestTypeDef = TypedDict(
    "AcceleratorTotalMemoryMiBRequestTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

AcceleratorTotalMemoryMiBTypeDef = TypedDict(
    "AcceleratorTotalMemoryMiBTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

AddressTransferOutputTypeDef = TypedDict(
    "AddressTransferOutputTypeDef",
    {
        "PublicIp": str,
        "AllocationId": str,
        "TransferAccountId": str,
        "TransferOfferExpirationTimestamp": datetime,
        "TransferOfferAcceptedTimestamp": datetime,
        "AddressTransferStatus": AddressTransferStatusType,
    },
)

_RequiredTargetConfigurationRequestTypeDef = TypedDict(
    "_RequiredTargetConfigurationRequestTypeDef",
    {
        "OfferingId": str,
    },
)
_OptionalTargetConfigurationRequestTypeDef = TypedDict(
    "_OptionalTargetConfigurationRequestTypeDef",
    {
        "InstanceCount": int,
    },
    total=False,
)


class TargetConfigurationRequestTypeDef(
    _RequiredTargetConfigurationRequestTypeDef, _OptionalTargetConfigurationRequestTypeDef
):
    pass


AcceptReservedInstancesExchangeQuoteResultOutputTypeDef = TypedDict(
    "AcceptReservedInstancesExchangeQuoteResultOutputTypeDef",
    {
        "ExchangeId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef = TypedDict(
    "AcceptTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayAttachmentId": str,
        "SubnetIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

_RequiredAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef(
    _RequiredAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef,
    _OptionalAcceptTransitGatewayPeeringAttachmentRequestRequestTypeDef,
):
    pass


_RequiredAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AcceptTransitGatewayVpcAttachmentRequestRequestTypeDef(
    _RequiredAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef,
    _OptionalAcceptTransitGatewayVpcAttachmentRequestRequestTypeDef,
):
    pass


_RequiredAcceptVpcEndpointConnectionsRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptVpcEndpointConnectionsRequestRequestTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointIds": Sequence[str],
    },
)
_OptionalAcceptVpcEndpointConnectionsRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptVpcEndpointConnectionsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AcceptVpcEndpointConnectionsRequestRequestTypeDef(
    _RequiredAcceptVpcEndpointConnectionsRequestRequestTypeDef,
    _OptionalAcceptVpcEndpointConnectionsRequestRequestTypeDef,
):
    pass


_RequiredAcceptVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptVpcPeeringConnectionRequestRequestTypeDef",
    {
        "VpcPeeringConnectionId": str,
    },
)
_OptionalAcceptVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptVpcPeeringConnectionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AcceptVpcPeeringConnectionRequestRequestTypeDef(
    _RequiredAcceptVpcPeeringConnectionRequestRequestTypeDef,
    _OptionalAcceptVpcPeeringConnectionRequestRequestTypeDef,
):
    pass


AcceptVpcPeeringConnectionRequestVpcPeeringConnectionAcceptTypeDef = TypedDict(
    "AcceptVpcPeeringConnectionRequestVpcPeeringConnectionAcceptTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

AccountAttributeValueOutputTypeDef = TypedDict(
    "AccountAttributeValueOutputTypeDef",
    {
        "AttributeValue": str,
    },
)

ActiveInstanceOutputTypeDef = TypedDict(
    "ActiveInstanceOutputTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": InstanceHealthStatusType,
    },
)

AddIpamOperatingRegionTypeDef = TypedDict(
    "AddIpamOperatingRegionTypeDef",
    {
        "RegionName": str,
    },
    total=False,
)

_RequiredAddPrefixListEntryTypeDef = TypedDict(
    "_RequiredAddPrefixListEntryTypeDef",
    {
        "Cidr": str,
    },
)
_OptionalAddPrefixListEntryTypeDef = TypedDict(
    "_OptionalAddPrefixListEntryTypeDef",
    {
        "Description": str,
    },
    total=False,
)


class AddPrefixListEntryTypeDef(
    _RequiredAddPrefixListEntryTypeDef, _OptionalAddPrefixListEntryTypeDef
):
    pass


AddedPrincipalOutputTypeDef = TypedDict(
    "AddedPrincipalOutputTypeDef",
    {
        "PrincipalType": PrincipalTypeType,
        "Principal": str,
        "ServicePermissionId": str,
        "ServiceId": str,
    },
)

AnalysisComponentOutputTypeDef = TypedDict(
    "AnalysisComponentOutputTypeDef",
    {
        "Id": str,
        "Arn": str,
        "Name": str,
    },
)

RuleGroupTypePairOutputTypeDef = TypedDict(
    "RuleGroupTypePairOutputTypeDef",
    {
        "RuleGroupArn": str,
        "RuleGroupType": str,
    },
)

RuleOptionOutputTypeDef = TypedDict(
    "RuleOptionOutputTypeDef",
    {
        "Keyword": str,
        "Settings": List[str],
    },
)

PtrUpdateStatusOutputTypeDef = TypedDict(
    "PtrUpdateStatusOutputTypeDef",
    {
        "Value": str,
        "Status": str,
        "Reason": str,
    },
)

TagOutputTypeDef = TypedDict(
    "TagOutputTypeDef",
    {
        "Key": str,
        "Value": str,
    },
)

_RequiredAdvertiseByoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredAdvertiseByoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
    },
)
_OptionalAdvertiseByoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalAdvertiseByoipCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AdvertiseByoipCidrRequestRequestTypeDef(
    _RequiredAdvertiseByoipCidrRequestRequestTypeDef,
    _OptionalAdvertiseByoipCidrRequestRequestTypeDef,
):
    pass


ByoipCidrOutputTypeDef = TypedDict(
    "ByoipCidrOutputTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": ByoipCidrStateType,
    },
)

AllocateAddressResultOutputTypeDef = TypedDict(
    "AllocateAddressResultOutputTypeDef",
    {
        "PublicIp": str,
        "AllocationId": str,
        "PublicIpv4Pool": str,
        "NetworkBorderGroup": str,
        "Domain": DomainTypeType,
        "CustomerOwnedIp": str,
        "CustomerOwnedIpv4Pool": str,
        "CarrierIp": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AllocateHostsResultOutputTypeDef = TypedDict(
    "AllocateHostsResultOutputTypeDef",
    {
        "HostIds": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAllocateIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_RequiredAllocateIpamPoolCidrRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalAllocateIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_OptionalAllocateIpamPoolCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Cidr": str,
        "NetmaskLength": int,
        "ClientToken": str,
        "Description": str,
        "PreviewNextCidr": bool,
        "DisallowedCidrs": Sequence[str],
    },
    total=False,
)


class AllocateIpamPoolCidrRequestRequestTypeDef(
    _RequiredAllocateIpamPoolCidrRequestRequestTypeDef,
    _OptionalAllocateIpamPoolCidrRequestRequestTypeDef,
):
    pass


IpamPoolAllocationOutputTypeDef = TypedDict(
    "IpamPoolAllocationOutputTypeDef",
    {
        "Cidr": str,
        "IpamPoolAllocationId": str,
        "Description": str,
        "ResourceId": str,
        "ResourceType": IpamPoolAllocationResourceTypeType,
        "ResourceRegion": str,
        "ResourceOwner": str,
    },
)

AlternatePathHintOutputTypeDef = TypedDict(
    "AlternatePathHintOutputTypeDef",
    {
        "ComponentId": str,
        "ComponentArn": str,
    },
)

PortRangeOutputTypeDef = TypedDict(
    "PortRangeOutputTypeDef",
    {
        "From": int,
        "To": int,
    },
)

AnalysisLoadBalancerListenerOutputTypeDef = TypedDict(
    "AnalysisLoadBalancerListenerOutputTypeDef",
    {
        "LoadBalancerPort": int,
        "InstancePort": int,
    },
)

AnalysisRouteTableRouteOutputTypeDef = TypedDict(
    "AnalysisRouteTableRouteOutputTypeDef",
    {
        "DestinationCidr": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "NatGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": str,
        "TransitGatewayId": str,
        "VpcPeeringConnectionId": str,
        "State": str,
        "CarrierGatewayId": str,
        "CoreNetworkArn": str,
        "LocalGatewayId": str,
    },
)

_RequiredApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_RequiredApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "VpcId": str,
        "SecurityGroupIds": Sequence[str],
    },
)
_OptionalApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_OptionalApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef(
    _RequiredApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef,
    _OptionalApplySecurityGroupsToClientVpnTargetNetworkRequestRequestTypeDef,
):
    pass


ApplySecurityGroupsToClientVpnTargetNetworkResultOutputTypeDef = TypedDict(
    "ApplySecurityGroupsToClientVpnTargetNetworkResultOutputTypeDef",
    {
        "SecurityGroupIds": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAssignIpv6AddressesRequestRequestTypeDef = TypedDict(
    "_RequiredAssignIpv6AddressesRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalAssignIpv6AddressesRequestRequestTypeDef = TypedDict(
    "_OptionalAssignIpv6AddressesRequestRequestTypeDef",
    {
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[str],
        "Ipv6PrefixCount": int,
        "Ipv6Prefixes": Sequence[str],
    },
    total=False,
)


class AssignIpv6AddressesRequestRequestTypeDef(
    _RequiredAssignIpv6AddressesRequestRequestTypeDef,
    _OptionalAssignIpv6AddressesRequestRequestTypeDef,
):
    pass


AssignIpv6AddressesResultOutputTypeDef = TypedDict(
    "AssignIpv6AddressesResultOutputTypeDef",
    {
        "AssignedIpv6Addresses": List[str],
        "AssignedIpv6Prefixes": List[str],
        "NetworkInterfaceId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssignPrivateIpAddressesRequestNetworkInterfaceAssignPrivateIpAddressesTypeDef = TypedDict(
    "AssignPrivateIpAddressesRequestNetworkInterfaceAssignPrivateIpAddressesTypeDef",
    {
        "AllowReassignment": bool,
        "PrivateIpAddresses": Sequence[str],
        "SecondaryPrivateIpAddressCount": int,
        "Ipv4Prefixes": Sequence[str],
        "Ipv4PrefixCount": int,
    },
    total=False,
)

_RequiredAssignPrivateIpAddressesRequestRequestTypeDef = TypedDict(
    "_RequiredAssignPrivateIpAddressesRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalAssignPrivateIpAddressesRequestRequestTypeDef = TypedDict(
    "_OptionalAssignPrivateIpAddressesRequestRequestTypeDef",
    {
        "AllowReassignment": bool,
        "PrivateIpAddresses": Sequence[str],
        "SecondaryPrivateIpAddressCount": int,
        "Ipv4Prefixes": Sequence[str],
        "Ipv4PrefixCount": int,
    },
    total=False,
)


class AssignPrivateIpAddressesRequestRequestTypeDef(
    _RequiredAssignPrivateIpAddressesRequestRequestTypeDef,
    _OptionalAssignPrivateIpAddressesRequestRequestTypeDef,
):
    pass


AssignedPrivateIpAddressOutputTypeDef = TypedDict(
    "AssignedPrivateIpAddressOutputTypeDef",
    {
        "PrivateIpAddress": str,
    },
)

Ipv4PrefixSpecificationOutputTypeDef = TypedDict(
    "Ipv4PrefixSpecificationOutputTypeDef",
    {
        "Ipv4Prefix": str,
    },
)

_RequiredAssignPrivateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_RequiredAssignPrivateNatGatewayAddressRequestRequestTypeDef",
    {
        "NatGatewayId": str,
    },
)
_OptionalAssignPrivateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_OptionalAssignPrivateNatGatewayAddressRequestRequestTypeDef",
    {
        "PrivateIpAddresses": Sequence[str],
        "PrivateIpAddressCount": int,
        "DryRun": bool,
    },
    total=False,
)


class AssignPrivateNatGatewayAddressRequestRequestTypeDef(
    _RequiredAssignPrivateNatGatewayAddressRequestRequestTypeDef,
    _OptionalAssignPrivateNatGatewayAddressRequestRequestTypeDef,
):
    pass


NatGatewayAddressOutputTypeDef = TypedDict(
    "NatGatewayAddressOutputTypeDef",
    {
        "AllocationId": str,
        "NetworkInterfaceId": str,
        "PrivateIp": str,
        "PublicIp": str,
        "AssociationId": str,
        "IsPrimary": bool,
        "FailureMessage": str,
        "Status": NatGatewayAddressStatusType,
    },
)

AssociateAddressRequestClassicAddressAssociateTypeDef = TypedDict(
    "AssociateAddressRequestClassicAddressAssociateTypeDef",
    {
        "AllocationId": str,
        "InstanceId": str,
        "AllowReassociation": bool,
        "DryRun": bool,
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
    },
    total=False,
)

AssociateAddressRequestRequestTypeDef = TypedDict(
    "AssociateAddressRequestRequestTypeDef",
    {
        "AllocationId": str,
        "InstanceId": str,
        "PublicIp": str,
        "AllowReassociation": bool,
        "DryRun": bool,
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
    },
    total=False,
)

AssociateAddressRequestVpcAddressAssociateTypeDef = TypedDict(
    "AssociateAddressRequestVpcAddressAssociateTypeDef",
    {
        "InstanceId": str,
        "PublicIp": str,
        "AllowReassociation": bool,
        "DryRun": bool,
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
    },
    total=False,
)

AssociateAddressResultOutputTypeDef = TypedDict(
    "AssociateAddressResultOutputTypeDef",
    {
        "AssociationId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAssociateClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "SubnetId": str,
    },
)
_OptionalAssociateClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class AssociateClientVpnTargetNetworkRequestRequestTypeDef(
    _RequiredAssociateClientVpnTargetNetworkRequestRequestTypeDef,
    _OptionalAssociateClientVpnTargetNetworkRequestRequestTypeDef,
):
    pass


AssociationStatusOutputTypeDef = TypedDict(
    "AssociationStatusOutputTypeDef",
    {
        "Code": AssociationStatusCodeType,
        "Message": str,
    },
)

_RequiredAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef = TypedDict(
    "_RequiredAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef = TypedDict(
    "_OptionalAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef(
    _RequiredAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef,
    _OptionalAssociateDhcpOptionsRequestDhcpOptionsAssociateWithVpcTypeDef,
):
    pass


_RequiredAssociateDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateDhcpOptionsRequestRequestTypeDef",
    {
        "DhcpOptionsId": str,
        "VpcId": str,
    },
)
_OptionalAssociateDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateDhcpOptionsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateDhcpOptionsRequestRequestTypeDef(
    _RequiredAssociateDhcpOptionsRequestRequestTypeDef,
    _OptionalAssociateDhcpOptionsRequestRequestTypeDef,
):
    pass


_RequiredAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef = TypedDict(
    "_RequiredAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef",
    {
        "DhcpOptionsId": str,
    },
)
_OptionalAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef = TypedDict(
    "_OptionalAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef(
    _RequiredAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef,
    _OptionalAssociateDhcpOptionsRequestVpcAssociateDhcpOptionsTypeDef,
):
    pass


_RequiredAssociateEnclaveCertificateIamRoleRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    {
        "CertificateArn": str,
        "RoleArn": str,
    },
)
_OptionalAssociateEnclaveCertificateIamRoleRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateEnclaveCertificateIamRoleRequestRequestTypeDef(
    _RequiredAssociateEnclaveCertificateIamRoleRequestRequestTypeDef,
    _OptionalAssociateEnclaveCertificateIamRoleRequestRequestTypeDef,
):
    pass


AssociateEnclaveCertificateIamRoleResultOutputTypeDef = TypedDict(
    "AssociateEnclaveCertificateIamRoleResultOutputTypeDef",
    {
        "CertificateS3BucketName": str,
        "CertificateS3ObjectKey": str,
        "EncryptionKmsKeyId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

IamInstanceProfileSpecificationTypeDef = TypedDict(
    "IamInstanceProfileSpecificationTypeDef",
    {
        "Arn": str,
        "Name": str,
    },
    total=False,
)

_RequiredAssociateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateNatGatewayAddressRequestRequestTypeDef",
    {
        "NatGatewayId": str,
        "AllocationIds": Sequence[str],
    },
)
_OptionalAssociateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateNatGatewayAddressRequestRequestTypeDef",
    {
        "PrivateIpAddresses": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)


class AssociateNatGatewayAddressRequestRequestTypeDef(
    _RequiredAssociateNatGatewayAddressRequestRequestTypeDef,
    _OptionalAssociateNatGatewayAddressRequestRequestTypeDef,
):
    pass


_RequiredAssociateRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateRouteTableRequestRequestTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalAssociateRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
        "SubnetId": str,
        "GatewayId": str,
    },
    total=False,
)


class AssociateRouteTableRequestRequestTypeDef(
    _RequiredAssociateRouteTableRequestRequestTypeDef,
    _OptionalAssociateRouteTableRequestRequestTypeDef,
):
    pass


AssociateRouteTableRequestRouteTableAssociateWithSubnetTypeDef = TypedDict(
    "AssociateRouteTableRequestRouteTableAssociateWithSubnetTypeDef",
    {
        "DryRun": bool,
        "SubnetId": str,
        "GatewayId": str,
    },
    total=False,
)

RouteTableAssociationStateOutputTypeDef = TypedDict(
    "RouteTableAssociationStateOutputTypeDef",
    {
        "State": RouteTableAssociationStateCodeType,
        "StatusMessage": str,
    },
)

AssociateSubnetCidrBlockRequestRequestTypeDef = TypedDict(
    "AssociateSubnetCidrBlockRequestRequestTypeDef",
    {
        "Ipv6CidrBlock": str,
        "SubnetId": str,
    },
)

_RequiredAssociateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayAttachmentId": str,
        "SubnetIds": Sequence[str],
    },
)
_OptionalAssociateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateTransitGatewayMulticastDomainRequestRequestTypeDef(
    _RequiredAssociateTransitGatewayMulticastDomainRequestRequestTypeDef,
    _OptionalAssociateTransitGatewayMulticastDomainRequestRequestTypeDef,
):
    pass


_RequiredAssociateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalAssociateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateTransitGatewayPolicyTableRequestRequestTypeDef(
    _RequiredAssociateTransitGatewayPolicyTableRequestRequestTypeDef,
    _OptionalAssociateTransitGatewayPolicyTableRequestRequestTypeDef,
):
    pass


TransitGatewayPolicyTableAssociationOutputTypeDef = TypedDict(
    "TransitGatewayPolicyTableAssociationOutputTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "State": TransitGatewayAssociationStateType,
    },
)

_RequiredAssociateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalAssociateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateTransitGatewayRouteTableRequestRequestTypeDef(
    _RequiredAssociateTransitGatewayRouteTableRequestRequestTypeDef,
    _OptionalAssociateTransitGatewayRouteTableRequestRequestTypeDef,
):
    pass


TransitGatewayAssociationOutputTypeDef = TypedDict(
    "TransitGatewayAssociationOutputTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "State": TransitGatewayAssociationStateType,
    },
)

_RequiredAssociateTrunkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateTrunkInterfaceRequestRequestTypeDef",
    {
        "BranchInterfaceId": str,
        "TrunkInterfaceId": str,
    },
)
_OptionalAssociateTrunkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateTrunkInterfaceRequestRequestTypeDef",
    {
        "VlanId": int,
        "GreKey": int,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class AssociateTrunkInterfaceRequestRequestTypeDef(
    _RequiredAssociateTrunkInterfaceRequestRequestTypeDef,
    _OptionalAssociateTrunkInterfaceRequestRequestTypeDef,
):
    pass


_RequiredAssociateVpcCidrBlockRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateVpcCidrBlockRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalAssociateVpcCidrBlockRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateVpcCidrBlockRequestRequestTypeDef",
    {
        "AmazonProvidedIpv6CidrBlock": bool,
        "CidrBlock": str,
        "Ipv6CidrBlockNetworkBorderGroup": str,
        "Ipv6Pool": str,
        "Ipv6CidrBlock": str,
        "Ipv4IpamPoolId": str,
        "Ipv4NetmaskLength": int,
        "Ipv6IpamPoolId": str,
        "Ipv6NetmaskLength": int,
    },
    total=False,
)


class AssociateVpcCidrBlockRequestRequestTypeDef(
    _RequiredAssociateVpcCidrBlockRequestRequestTypeDef,
    _OptionalAssociateVpcCidrBlockRequestRequestTypeDef,
):
    pass


AssociatedRoleOutputTypeDef = TypedDict(
    "AssociatedRoleOutputTypeDef",
    {
        "AssociatedRoleArn": str,
        "CertificateS3BucketName": str,
        "CertificateS3ObjectKey": str,
        "EncryptionKmsKeyId": str,
    },
)

AssociatedTargetNetworkOutputTypeDef = TypedDict(
    "AssociatedTargetNetworkOutputTypeDef",
    {
        "NetworkId": str,
        "NetworkType": Literal["vpc"],
    },
)

_RequiredAthenaIntegrationTypeDef = TypedDict(
    "_RequiredAthenaIntegrationTypeDef",
    {
        "IntegrationResultS3DestinationArn": str,
        "PartitionLoadFrequency": PartitionLoadFrequencyType,
    },
)
_OptionalAthenaIntegrationTypeDef = TypedDict(
    "_OptionalAthenaIntegrationTypeDef",
    {
        "PartitionStartDate": Union[datetime, str],
        "PartitionEndDate": Union[datetime, str],
    },
    total=False,
)


class AthenaIntegrationTypeDef(
    _RequiredAthenaIntegrationTypeDef, _OptionalAthenaIntegrationTypeDef
):
    pass


_RequiredAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef = TypedDict(
    "_RequiredAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef",
    {
        "Groups": Sequence[str],
        "VpcId": str,
    },
)
_OptionalAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef = TypedDict(
    "_OptionalAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef(
    _RequiredAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef,
    _OptionalAttachClassicLinkVpcRequestInstanceAttachClassicLinkVpcTypeDef,
):
    pass


_RequiredAttachClassicLinkVpcRequestRequestTypeDef = TypedDict(
    "_RequiredAttachClassicLinkVpcRequestRequestTypeDef",
    {
        "Groups": Sequence[str],
        "InstanceId": str,
        "VpcId": str,
    },
)
_OptionalAttachClassicLinkVpcRequestRequestTypeDef = TypedDict(
    "_OptionalAttachClassicLinkVpcRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachClassicLinkVpcRequestRequestTypeDef(
    _RequiredAttachClassicLinkVpcRequestRequestTypeDef,
    _OptionalAttachClassicLinkVpcRequestRequestTypeDef,
):
    pass


_RequiredAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef = TypedDict(
    "_RequiredAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef",
    {
        "Groups": Sequence[str],
        "InstanceId": str,
    },
)
_OptionalAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef = TypedDict(
    "_OptionalAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef(
    _RequiredAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef,
    _OptionalAttachClassicLinkVpcRequestVpcAttachClassicLinkInstanceTypeDef,
):
    pass


AttachClassicLinkVpcResultOutputTypeDef = TypedDict(
    "AttachClassicLinkVpcResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef = TypedDict(
    "_RequiredAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef = TypedDict(
    "_OptionalAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef(
    _RequiredAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef,
    _OptionalAttachInternetGatewayRequestInternetGatewayAttachToVpcTypeDef,
):
    pass


_RequiredAttachInternetGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredAttachInternetGatewayRequestRequestTypeDef",
    {
        "InternetGatewayId": str,
        "VpcId": str,
    },
)
_OptionalAttachInternetGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalAttachInternetGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachInternetGatewayRequestRequestTypeDef(
    _RequiredAttachInternetGatewayRequestRequestTypeDef,
    _OptionalAttachInternetGatewayRequestRequestTypeDef,
):
    pass


_RequiredAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef = TypedDict(
    "_RequiredAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef",
    {
        "InternetGatewayId": str,
    },
)
_OptionalAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef = TypedDict(
    "_OptionalAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef(
    _RequiredAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef,
    _OptionalAttachInternetGatewayRequestVpcAttachInternetGatewayTypeDef,
):
    pass


AttachNetworkInterfaceResultOutputTypeDef = TypedDict(
    "AttachNetworkInterfaceResultOutputTypeDef",
    {
        "AttachmentId": str,
        "NetworkCardIndex": int,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAttachVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_RequiredAttachVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "VerifiedAccessTrustProviderId": str,
    },
)
_OptionalAttachVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_OptionalAttachVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class AttachVerifiedAccessTrustProviderRequestRequestTypeDef(
    _RequiredAttachVerifiedAccessTrustProviderRequestRequestTypeDef,
    _OptionalAttachVerifiedAccessTrustProviderRequestRequestTypeDef,
):
    pass


_RequiredAttachVolumeRequestInstanceAttachVolumeTypeDef = TypedDict(
    "_RequiredAttachVolumeRequestInstanceAttachVolumeTypeDef",
    {
        "Device": str,
        "VolumeId": str,
    },
)
_OptionalAttachVolumeRequestInstanceAttachVolumeTypeDef = TypedDict(
    "_OptionalAttachVolumeRequestInstanceAttachVolumeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachVolumeRequestInstanceAttachVolumeTypeDef(
    _RequiredAttachVolumeRequestInstanceAttachVolumeTypeDef,
    _OptionalAttachVolumeRequestInstanceAttachVolumeTypeDef,
):
    pass


_RequiredAttachVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredAttachVolumeRequestRequestTypeDef",
    {
        "Device": str,
        "InstanceId": str,
        "VolumeId": str,
    },
)
_OptionalAttachVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalAttachVolumeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachVolumeRequestRequestTypeDef(
    _RequiredAttachVolumeRequestRequestTypeDef, _OptionalAttachVolumeRequestRequestTypeDef
):
    pass


_RequiredAttachVolumeRequestVolumeAttachToInstanceTypeDef = TypedDict(
    "_RequiredAttachVolumeRequestVolumeAttachToInstanceTypeDef",
    {
        "Device": str,
        "InstanceId": str,
    },
)
_OptionalAttachVolumeRequestVolumeAttachToInstanceTypeDef = TypedDict(
    "_OptionalAttachVolumeRequestVolumeAttachToInstanceTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachVolumeRequestVolumeAttachToInstanceTypeDef(
    _RequiredAttachVolumeRequestVolumeAttachToInstanceTypeDef,
    _OptionalAttachVolumeRequestVolumeAttachToInstanceTypeDef,
):
    pass


_RequiredAttachVpnGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredAttachVpnGatewayRequestRequestTypeDef",
    {
        "VpcId": str,
        "VpnGatewayId": str,
    },
)
_OptionalAttachVpnGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalAttachVpnGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AttachVpnGatewayRequestRequestTypeDef(
    _RequiredAttachVpnGatewayRequestRequestTypeDef, _OptionalAttachVpnGatewayRequestRequestTypeDef
):
    pass


VpcAttachmentOutputTypeDef = TypedDict(
    "VpcAttachmentOutputTypeDef",
    {
        "State": AttachmentStatusType,
        "VpcId": str,
    },
)

AttachmentEnaSrdUdpSpecificationOutputTypeDef = TypedDict(
    "AttachmentEnaSrdUdpSpecificationOutputTypeDef",
    {
        "EnaSrdUdpEnabled": bool,
    },
)

AttributeBooleanValueOutputTypeDef = TypedDict(
    "AttributeBooleanValueOutputTypeDef",
    {
        "Value": bool,
    },
)

AttributeBooleanValueTypeDef = TypedDict(
    "AttributeBooleanValueTypeDef",
    {
        "Value": bool,
    },
    total=False,
)

AttributeValueOutputTypeDef = TypedDict(
    "AttributeValueOutputTypeDef",
    {
        "Value": str,
    },
)

AttributeValueTypeDef = TypedDict(
    "AttributeValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

ClientVpnAuthorizationRuleStatusOutputTypeDef = TypedDict(
    "ClientVpnAuthorizationRuleStatusOutputTypeDef",
    {
        "Code": ClientVpnAuthorizationRuleStatusCodeType,
        "Message": str,
    },
)

_RequiredAuthorizeClientVpnIngressRequestRequestTypeDef = TypedDict(
    "_RequiredAuthorizeClientVpnIngressRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "TargetNetworkCidr": str,
    },
)
_OptionalAuthorizeClientVpnIngressRequestRequestTypeDef = TypedDict(
    "_OptionalAuthorizeClientVpnIngressRequestRequestTypeDef",
    {
        "AccessGroupId": str,
        "AuthorizeAllGroups": bool,
        "Description": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class AuthorizeClientVpnIngressRequestRequestTypeDef(
    _RequiredAuthorizeClientVpnIngressRequestRequestTypeDef,
    _OptionalAuthorizeClientVpnIngressRequestRequestTypeDef,
):
    pass


AvailabilityZoneMessageOutputTypeDef = TypedDict(
    "AvailabilityZoneMessageOutputTypeDef",
    {
        "Message": str,
    },
)

InstanceCapacityOutputTypeDef = TypedDict(
    "InstanceCapacityOutputTypeDef",
    {
        "AvailableCapacity": int,
        "InstanceType": str,
        "TotalCapacity": int,
    },
)

BaselineEbsBandwidthMbpsOutputTypeDef = TypedDict(
    "BaselineEbsBandwidthMbpsOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

BaselineEbsBandwidthMbpsRequestTypeDef = TypedDict(
    "BaselineEbsBandwidthMbpsRequestTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

BaselineEbsBandwidthMbpsTypeDef = TypedDict(
    "BaselineEbsBandwidthMbpsTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

BlobAttributeValueTypeDef = TypedDict(
    "BlobAttributeValueTypeDef",
    {
        "Value": Union[str, bytes, IO[Any], StreamingBody],
    },
    total=False,
)

EbsBlockDeviceOutputTypeDef = TypedDict(
    "EbsBlockDeviceOutputTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": VolumeTypeType,
        "KmsKeyId": str,
        "Throughput": int,
        "OutpostArn": str,
        "Encrypted": bool,
    },
)

EbsBlockDeviceTypeDef = TypedDict(
    "EbsBlockDeviceTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": VolumeTypeType,
        "KmsKeyId": str,
        "Throughput": int,
        "OutpostArn": str,
        "Encrypted": bool,
    },
    total=False,
)

BundleTaskErrorOutputTypeDef = TypedDict(
    "BundleTaskErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

_RequiredCancelBundleTaskRequestRequestTypeDef = TypedDict(
    "_RequiredCancelBundleTaskRequestRequestTypeDef",
    {
        "BundleId": str,
    },
)
_OptionalCancelBundleTaskRequestRequestTypeDef = TypedDict(
    "_OptionalCancelBundleTaskRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelBundleTaskRequestRequestTypeDef(
    _RequiredCancelBundleTaskRequestRequestTypeDef, _OptionalCancelBundleTaskRequestRequestTypeDef
):
    pass


CancelCapacityReservationFleetErrorOutputTypeDef = TypedDict(
    "CancelCapacityReservationFleetErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

_RequiredCancelCapacityReservationFleetsRequestRequestTypeDef = TypedDict(
    "_RequiredCancelCapacityReservationFleetsRequestRequestTypeDef",
    {
        "CapacityReservationFleetIds": Sequence[str],
    },
)
_OptionalCancelCapacityReservationFleetsRequestRequestTypeDef = TypedDict(
    "_OptionalCancelCapacityReservationFleetsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelCapacityReservationFleetsRequestRequestTypeDef(
    _RequiredCancelCapacityReservationFleetsRequestRequestTypeDef,
    _OptionalCancelCapacityReservationFleetsRequestRequestTypeDef,
):
    pass


CapacityReservationFleetCancellationStateOutputTypeDef = TypedDict(
    "CapacityReservationFleetCancellationStateOutputTypeDef",
    {
        "CurrentFleetState": CapacityReservationFleetStateType,
        "PreviousFleetState": CapacityReservationFleetStateType,
        "CapacityReservationFleetId": str,
    },
)

_RequiredCancelCapacityReservationRequestRequestTypeDef = TypedDict(
    "_RequiredCancelCapacityReservationRequestRequestTypeDef",
    {
        "CapacityReservationId": str,
    },
)
_OptionalCancelCapacityReservationRequestRequestTypeDef = TypedDict(
    "_OptionalCancelCapacityReservationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelCapacityReservationRequestRequestTypeDef(
    _RequiredCancelCapacityReservationRequestRequestTypeDef,
    _OptionalCancelCapacityReservationRequestRequestTypeDef,
):
    pass


CancelCapacityReservationResultOutputTypeDef = TypedDict(
    "CancelCapacityReservationResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCancelConversionRequestRequestTypeDef = TypedDict(
    "_RequiredCancelConversionRequestRequestTypeDef",
    {
        "ConversionTaskId": str,
    },
)
_OptionalCancelConversionRequestRequestTypeDef = TypedDict(
    "_OptionalCancelConversionRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ReasonMessage": str,
    },
    total=False,
)


class CancelConversionRequestRequestTypeDef(
    _RequiredCancelConversionRequestRequestTypeDef, _OptionalCancelConversionRequestRequestTypeDef
):
    pass


CancelExportTaskRequestRequestTypeDef = TypedDict(
    "CancelExportTaskRequestRequestTypeDef",
    {
        "ExportTaskId": str,
    },
)

_RequiredCancelImageLaunchPermissionRequestRequestTypeDef = TypedDict(
    "_RequiredCancelImageLaunchPermissionRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalCancelImageLaunchPermissionRequestRequestTypeDef = TypedDict(
    "_OptionalCancelImageLaunchPermissionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelImageLaunchPermissionRequestRequestTypeDef(
    _RequiredCancelImageLaunchPermissionRequestRequestTypeDef,
    _OptionalCancelImageLaunchPermissionRequestRequestTypeDef,
):
    pass


CancelImageLaunchPermissionResultOutputTypeDef = TypedDict(
    "CancelImageLaunchPermissionResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CancelImportTaskRequestRequestTypeDef = TypedDict(
    "CancelImportTaskRequestRequestTypeDef",
    {
        "CancelReason": str,
        "DryRun": bool,
        "ImportTaskId": str,
    },
    total=False,
)

CancelImportTaskResultOutputTypeDef = TypedDict(
    "CancelImportTaskResultOutputTypeDef",
    {
        "ImportTaskId": str,
        "PreviousState": str,
        "State": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CancelReservedInstancesListingRequestRequestTypeDef = TypedDict(
    "CancelReservedInstancesListingRequestRequestTypeDef",
    {
        "ReservedInstancesListingId": str,
    },
)

CancelSpotFleetRequestsErrorOutputTypeDef = TypedDict(
    "CancelSpotFleetRequestsErrorOutputTypeDef",
    {
        "Code": CancelBatchErrorCodeType,
        "Message": str,
    },
)

_RequiredCancelSpotFleetRequestsRequestRequestTypeDef = TypedDict(
    "_RequiredCancelSpotFleetRequestsRequestRequestTypeDef",
    {
        "SpotFleetRequestIds": Sequence[str],
        "TerminateInstances": bool,
    },
)
_OptionalCancelSpotFleetRequestsRequestRequestTypeDef = TypedDict(
    "_OptionalCancelSpotFleetRequestsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelSpotFleetRequestsRequestRequestTypeDef(
    _RequiredCancelSpotFleetRequestsRequestRequestTypeDef,
    _OptionalCancelSpotFleetRequestsRequestRequestTypeDef,
):
    pass


CancelSpotFleetRequestsSuccessItemOutputTypeDef = TypedDict(
    "CancelSpotFleetRequestsSuccessItemOutputTypeDef",
    {
        "CurrentSpotFleetRequestState": BatchStateType,
        "PreviousSpotFleetRequestState": BatchStateType,
        "SpotFleetRequestId": str,
    },
)

_RequiredCancelSpotInstanceRequestsRequestRequestTypeDef = TypedDict(
    "_RequiredCancelSpotInstanceRequestsRequestRequestTypeDef",
    {
        "SpotInstanceRequestIds": Sequence[str],
    },
)
_OptionalCancelSpotInstanceRequestsRequestRequestTypeDef = TypedDict(
    "_OptionalCancelSpotInstanceRequestsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CancelSpotInstanceRequestsRequestRequestTypeDef(
    _RequiredCancelSpotInstanceRequestsRequestRequestTypeDef,
    _OptionalCancelSpotInstanceRequestsRequestRequestTypeDef,
):
    pass


CancelledSpotInstanceRequestOutputTypeDef = TypedDict(
    "CancelledSpotInstanceRequestOutputTypeDef",
    {
        "SpotInstanceRequestId": str,
        "State": CancelSpotInstanceRequestStateType,
    },
)

CapacityAllocationOutputTypeDef = TypedDict(
    "CapacityAllocationOutputTypeDef",
    {
        "AllocationType": Literal["used"],
        "Count": int,
    },
)

FleetCapacityReservationOutputTypeDef = TypedDict(
    "FleetCapacityReservationOutputTypeDef",
    {
        "CapacityReservationId": str,
        "AvailabilityZoneId": str,
        "InstanceType": InstanceTypeType,
        "InstancePlatform": CapacityReservationInstancePlatformType,
        "AvailabilityZone": str,
        "TotalInstanceCount": int,
        "FulfilledCapacity": float,
        "EbsOptimized": bool,
        "CreateDate": datetime,
        "Weight": float,
        "Priority": int,
    },
)

CapacityReservationGroupOutputTypeDef = TypedDict(
    "CapacityReservationGroupOutputTypeDef",
    {
        "GroupArn": str,
        "OwnerId": str,
    },
)

CapacityReservationOptionsOutputTypeDef = TypedDict(
    "CapacityReservationOptionsOutputTypeDef",
    {
        "UsageStrategy": Literal["use-capacity-reservations-first"],
    },
)

CapacityReservationOptionsRequestTypeDef = TypedDict(
    "CapacityReservationOptionsRequestTypeDef",
    {
        "UsageStrategy": Literal["use-capacity-reservations-first"],
    },
    total=False,
)

CapacityReservationTargetResponseOutputTypeDef = TypedDict(
    "CapacityReservationTargetResponseOutputTypeDef",
    {
        "CapacityReservationId": str,
        "CapacityReservationResourceGroupArn": str,
    },
)

CapacityReservationTargetTypeDef = TypedDict(
    "CapacityReservationTargetTypeDef",
    {
        "CapacityReservationId": str,
        "CapacityReservationResourceGroupArn": str,
    },
    total=False,
)

CertificateAuthenticationOutputTypeDef = TypedDict(
    "CertificateAuthenticationOutputTypeDef",
    {
        "ClientRootCertificateChain": str,
    },
)

CertificateAuthenticationRequestTypeDef = TypedDict(
    "CertificateAuthenticationRequestTypeDef",
    {
        "ClientRootCertificateChainArn": str,
    },
    total=False,
)

CidrAuthorizationContextTypeDef = TypedDict(
    "CidrAuthorizationContextTypeDef",
    {
        "Message": str,
        "Signature": str,
    },
)

CidrBlockOutputTypeDef = TypedDict(
    "CidrBlockOutputTypeDef",
    {
        "CidrBlock": str,
    },
)

ClassicLinkDnsSupportOutputTypeDef = TypedDict(
    "ClassicLinkDnsSupportOutputTypeDef",
    {
        "ClassicLinkDnsSupported": bool,
        "VpcId": str,
    },
)

GroupIdentifierOutputTypeDef = TypedDict(
    "GroupIdentifierOutputTypeDef",
    {
        "GroupName": str,
        "GroupId": str,
    },
)

ClassicLoadBalancerOutputTypeDef = TypedDict(
    "ClassicLoadBalancerOutputTypeDef",
    {
        "Name": str,
    },
)

ClassicLoadBalancerTypeDef = TypedDict(
    "ClassicLoadBalancerTypeDef",
    {
        "Name": str,
    },
    total=False,
)

ClientCertificateRevocationListStatusOutputTypeDef = TypedDict(
    "ClientCertificateRevocationListStatusOutputTypeDef",
    {
        "Code": ClientCertificateRevocationListStatusCodeType,
        "Message": str,
    },
)

ClientConnectOptionsTypeDef = TypedDict(
    "ClientConnectOptionsTypeDef",
    {
        "Enabled": bool,
        "LambdaFunctionArn": str,
    },
    total=False,
)

ClientVpnEndpointAttributeStatusOutputTypeDef = TypedDict(
    "ClientVpnEndpointAttributeStatusOutputTypeDef",
    {
        "Code": ClientVpnEndpointAttributeStatusCodeType,
        "Message": str,
    },
)

TagTypeDef = TypedDict(
    "TagTypeDef",
    {
        "Key": str,
        "Value": str,
    },
    total=False,
)

ClientDataTypeDef = TypedDict(
    "ClientDataTypeDef",
    {
        "Comment": str,
        "UploadEnd": Union[datetime, str],
        "UploadSize": float,
        "UploadStart": Union[datetime, str],
    },
    total=False,
)

ClientLoginBannerOptionsTypeDef = TypedDict(
    "ClientLoginBannerOptionsTypeDef",
    {
        "Enabled": bool,
        "BannerText": str,
    },
    total=False,
)

ClientLoginBannerResponseOptionsOutputTypeDef = TypedDict(
    "ClientLoginBannerResponseOptionsOutputTypeDef",
    {
        "Enabled": bool,
        "BannerText": str,
    },
)

DirectoryServiceAuthenticationOutputTypeDef = TypedDict(
    "DirectoryServiceAuthenticationOutputTypeDef",
    {
        "DirectoryId": str,
    },
)

FederatedAuthenticationOutputTypeDef = TypedDict(
    "FederatedAuthenticationOutputTypeDef",
    {
        "SamlProviderArn": str,
        "SelfServiceSamlProviderArn": str,
    },
)

DirectoryServiceAuthenticationRequestTypeDef = TypedDict(
    "DirectoryServiceAuthenticationRequestTypeDef",
    {
        "DirectoryId": str,
    },
    total=False,
)

FederatedAuthenticationRequestTypeDef = TypedDict(
    "FederatedAuthenticationRequestTypeDef",
    {
        "SAMLProviderArn": str,
        "SelfServiceSAMLProviderArn": str,
    },
    total=False,
)

ClientVpnConnectionStatusOutputTypeDef = TypedDict(
    "ClientVpnConnectionStatusOutputTypeDef",
    {
        "Code": ClientVpnConnectionStatusCodeType,
        "Message": str,
    },
)

ClientVpnEndpointStatusOutputTypeDef = TypedDict(
    "ClientVpnEndpointStatusOutputTypeDef",
    {
        "Code": ClientVpnEndpointStatusCodeType,
        "Message": str,
    },
)

ConnectionLogResponseOptionsOutputTypeDef = TypedDict(
    "ConnectionLogResponseOptionsOutputTypeDef",
    {
        "Enabled": bool,
        "CloudwatchLogGroup": str,
        "CloudwatchLogStream": str,
    },
)

ClientVpnRouteStatusOutputTypeDef = TypedDict(
    "ClientVpnRouteStatusOutputTypeDef",
    {
        "Code": ClientVpnRouteStatusCodeType,
        "Message": str,
    },
)

CloudWatchLogOptionsOutputTypeDef = TypedDict(
    "CloudWatchLogOptionsOutputTypeDef",
    {
        "LogEnabled": bool,
        "LogGroupArn": str,
        "LogOutputFormat": str,
    },
)

CloudWatchLogOptionsSpecificationTypeDef = TypedDict(
    "CloudWatchLogOptionsSpecificationTypeDef",
    {
        "LogEnabled": bool,
        "LogGroupArn": str,
        "LogOutputFormat": str,
    },
    total=False,
)

CoipAddressUsageOutputTypeDef = TypedDict(
    "CoipAddressUsageOutputTypeDef",
    {
        "AllocationId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "CoIp": str,
    },
)

CoipCidrOutputTypeDef = TypedDict(
    "CoipCidrOutputTypeDef",
    {
        "Cidr": str,
        "CoipPoolId": str,
        "LocalGatewayRouteTableId": str,
    },
)

_RequiredConfirmProductInstanceRequestRequestTypeDef = TypedDict(
    "_RequiredConfirmProductInstanceRequestRequestTypeDef",
    {
        "InstanceId": str,
        "ProductCode": str,
    },
)
_OptionalConfirmProductInstanceRequestRequestTypeDef = TypedDict(
    "_OptionalConfirmProductInstanceRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ConfirmProductInstanceRequestRequestTypeDef(
    _RequiredConfirmProductInstanceRequestRequestTypeDef,
    _OptionalConfirmProductInstanceRequestRequestTypeDef,
):
    pass


ConfirmProductInstanceResultOutputTypeDef = TypedDict(
    "ConfirmProductInstanceResultOutputTypeDef",
    {
        "OwnerId": str,
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ConnectionLogOptionsTypeDef = TypedDict(
    "ConnectionLogOptionsTypeDef",
    {
        "Enabled": bool,
        "CloudwatchLogGroup": str,
        "CloudwatchLogStream": str,
    },
    total=False,
)

ConnectionNotificationOutputTypeDef = TypedDict(
    "ConnectionNotificationOutputTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": Literal["Topic"],
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": ConnectionNotificationStateType,
    },
)

_RequiredCopyFpgaImageRequestRequestTypeDef = TypedDict(
    "_RequiredCopyFpgaImageRequestRequestTypeDef",
    {
        "SourceFpgaImageId": str,
        "SourceRegion": str,
    },
)
_OptionalCopyFpgaImageRequestRequestTypeDef = TypedDict(
    "_OptionalCopyFpgaImageRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "Name": str,
        "ClientToken": str,
    },
    total=False,
)


class CopyFpgaImageRequestRequestTypeDef(
    _RequiredCopyFpgaImageRequestRequestTypeDef, _OptionalCopyFpgaImageRequestRequestTypeDef
):
    pass


CopyFpgaImageResultOutputTypeDef = TypedDict(
    "CopyFpgaImageResultOutputTypeDef",
    {
        "FpgaImageId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCopyImageRequestRequestTypeDef = TypedDict(
    "_RequiredCopyImageRequestRequestTypeDef",
    {
        "Name": str,
        "SourceImageId": str,
        "SourceRegion": str,
    },
)
_OptionalCopyImageRequestRequestTypeDef = TypedDict(
    "_OptionalCopyImageRequestRequestTypeDef",
    {
        "ClientToken": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "DestinationOutpostArn": str,
        "DryRun": bool,
        "CopyImageTags": bool,
    },
    total=False,
)


class CopyImageRequestRequestTypeDef(
    _RequiredCopyImageRequestRequestTypeDef, _OptionalCopyImageRequestRequestTypeDef
):
    pass


CopyImageResultOutputTypeDef = TypedDict(
    "CopyImageResultOutputTypeDef",
    {
        "ImageId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CpuOptionsOutputTypeDef = TypedDict(
    "CpuOptionsOutputTypeDef",
    {
        "CoreCount": int,
        "ThreadsPerCore": int,
        "AmdSevSnp": AmdSevSnpSpecificationType,
    },
)

CpuOptionsRequestTypeDef = TypedDict(
    "CpuOptionsRequestTypeDef",
    {
        "CoreCount": int,
        "ThreadsPerCore": int,
        "AmdSevSnp": AmdSevSnpSpecificationType,
    },
    total=False,
)

CpuOptionsResponseMetadataTypeDef = TypedDict(
    "CpuOptionsResponseMetadataTypeDef",
    {
        "CoreCount": int,
        "ThreadsPerCore": int,
        "AmdSevSnp": AmdSevSnpSpecificationType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservationFleetInstanceSpecificationTypeDef = TypedDict(
    "ReservationFleetInstanceSpecificationTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "InstancePlatform": CapacityReservationInstancePlatformType,
        "Weight": float,
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "EbsOptimized": bool,
        "Priority": int,
    },
    total=False,
)

_RequiredCreateClientVpnRouteRequestRequestTypeDef = TypedDict(
    "_RequiredCreateClientVpnRouteRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidrBlock": str,
        "TargetVpcSubnetId": str,
    },
)
_OptionalCreateClientVpnRouteRequestRequestTypeDef = TypedDict(
    "_OptionalCreateClientVpnRouteRequestRequestTypeDef",
    {
        "Description": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateClientVpnRouteRequestRequestTypeDef(
    _RequiredCreateClientVpnRouteRequestRequestTypeDef,
    _OptionalCreateClientVpnRouteRequestRequestTypeDef,
):
    pass


_RequiredCreateCoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
        "CoipPoolId": str,
    },
)
_OptionalCreateCoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCoipCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CreateCoipCidrRequestRequestTypeDef(
    _RequiredCreateCoipCidrRequestRequestTypeDef, _OptionalCreateCoipCidrRequestRequestTypeDef
):
    pass


_RequiredCreateDefaultSubnetRequestRequestTypeDef = TypedDict(
    "_RequiredCreateDefaultSubnetRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
    },
)
_OptionalCreateDefaultSubnetRequestRequestTypeDef = TypedDict(
    "_OptionalCreateDefaultSubnetRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Ipv6Native": bool,
    },
    total=False,
)


class CreateDefaultSubnetRequestRequestTypeDef(
    _RequiredCreateDefaultSubnetRequestRequestTypeDef,
    _OptionalCreateDefaultSubnetRequestRequestTypeDef,
):
    pass


CreateDefaultVpcRequestRequestTypeDef = TypedDict(
    "CreateDefaultVpcRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

NewDhcpConfigurationTypeDef = TypedDict(
    "NewDhcpConfigurationTypeDef",
    {
        "Key": str,
        "Values": Sequence[str],
    },
    total=False,
)

_RequiredTargetCapacitySpecificationRequestTypeDef = TypedDict(
    "_RequiredTargetCapacitySpecificationRequestTypeDef",
    {
        "TotalTargetCapacity": int,
    },
)
_OptionalTargetCapacitySpecificationRequestTypeDef = TypedDict(
    "_OptionalTargetCapacitySpecificationRequestTypeDef",
    {
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": DefaultTargetCapacityTypeType,
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
    },
    total=False,
)


class TargetCapacitySpecificationRequestTypeDef(
    _RequiredTargetCapacitySpecificationRequestTypeDef,
    _OptionalTargetCapacitySpecificationRequestTypeDef,
):
    pass


DestinationOptionsRequestTypeDef = TypedDict(
    "DestinationOptionsRequestTypeDef",
    {
        "FileFormat": DestinationFileFormatType,
        "HiveCompatiblePartitions": bool,
        "PerHourPartition": bool,
    },
    total=False,
)

StorageLocationTypeDef = TypedDict(
    "StorageLocationTypeDef",
    {
        "Bucket": str,
        "Key": str,
    },
    total=False,
)

CreateFpgaImageResultOutputTypeDef = TypedDict(
    "CreateFpgaImageResultOutputTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateImageResultOutputTypeDef = TypedDict(
    "CreateImageResultOutputTypeDef",
    {
        "ImageId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceEventWindowTimeRangeRequestTypeDef = TypedDict(
    "InstanceEventWindowTimeRangeRequestTypeDef",
    {
        "StartWeekDay": WeekDayType,
        "StartHour": int,
        "EndWeekDay": WeekDayType,
        "EndHour": int,
    },
    total=False,
)

ExportToS3TaskSpecificationTypeDef = TypedDict(
    "ExportToS3TaskSpecificationTypeDef",
    {
        "ContainerFormat": Literal["ova"],
        "DiskImageFormat": DiskImageFormatType,
        "S3Bucket": str,
        "S3Prefix": str,
    },
    total=False,
)

RequestIpamResourceTagTypeDef = TypedDict(
    "RequestIpamResourceTagTypeDef",
    {
        "Key": str,
        "Value": str,
    },
    total=False,
)

_RequiredCreateLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLocalGatewayRouteRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalCreateLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLocalGatewayRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "LocalGatewayVirtualInterfaceGroupId": str,
        "DryRun": bool,
        "NetworkInterfaceId": str,
        "DestinationPrefixListId": str,
    },
    total=False,
)


class CreateLocalGatewayRouteRequestRequestTypeDef(
    _RequiredCreateLocalGatewayRouteRequestRequestTypeDef,
    _OptionalCreateLocalGatewayRouteRequestRequestTypeDef,
):
    pass


LocalGatewayRouteOutputTypeDef = TypedDict(
    "LocalGatewayRouteOutputTypeDef",
    {
        "DestinationCidrBlock": str,
        "LocalGatewayVirtualInterfaceGroupId": str,
        "Type": LocalGatewayRouteTypeType,
        "State": LocalGatewayRouteStateType,
        "LocalGatewayRouteTableId": str,
        "LocalGatewayRouteTableArn": str,
        "OwnerId": str,
        "SubnetId": str,
        "CoipPoolId": str,
        "NetworkInterfaceId": str,
        "DestinationPrefixListId": str,
    },
)

IcmpTypeCodeTypeDef = TypedDict(
    "IcmpTypeCodeTypeDef",
    {
        "Code": int,
        "Type": int,
    },
    total=False,
)

PortRangeTypeDef = TypedDict(
    "PortRangeTypeDef",
    {
        "From": int,
        "To": int,
    },
    total=False,
)

_RequiredCreateNetworkInterfacePermissionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkInterfacePermissionRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
        "Permission": InterfacePermissionTypeType,
    },
)
_OptionalCreateNetworkInterfacePermissionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkInterfacePermissionRequestRequestTypeDef",
    {
        "AwsAccountId": str,
        "AwsService": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateNetworkInterfacePermissionRequestRequestTypeDef(
    _RequiredCreateNetworkInterfacePermissionRequestRequestTypeDef,
    _OptionalCreateNetworkInterfacePermissionRequestRequestTypeDef,
):
    pass


InstanceIpv6AddressTypeDef = TypedDict(
    "InstanceIpv6AddressTypeDef",
    {
        "Ipv6Address": str,
    },
    total=False,
)

Ipv4PrefixSpecificationRequestTypeDef = TypedDict(
    "Ipv4PrefixSpecificationRequestTypeDef",
    {
        "Ipv4Prefix": str,
    },
    total=False,
)

Ipv6PrefixSpecificationRequestTypeDef = TypedDict(
    "Ipv6PrefixSpecificationRequestTypeDef",
    {
        "Ipv6Prefix": str,
    },
    total=False,
)

PrivateIpAddressSpecificationTypeDef = TypedDict(
    "PrivateIpAddressSpecificationTypeDef",
    {
        "Primary": bool,
        "PrivateIpAddress": str,
    },
    total=False,
)

CreatePublicIpv4PoolResultOutputTypeDef = TypedDict(
    "CreatePublicIpv4PoolResultOutputTypeDef",
    {
        "PoolId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PriceScheduleSpecificationTypeDef = TypedDict(
    "PriceScheduleSpecificationTypeDef",
    {
        "CurrencyCode": Literal["USD"],
        "Price": float,
        "Term": int,
    },
    total=False,
)

CreateRestoreImageTaskResultOutputTypeDef = TypedDict(
    "CreateRestoreImageTaskResultOutputTypeDef",
    {
        "ImageId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCreateRouteRequestRequestTypeDef = TypedDict(
    "_RequiredCreateRouteRequestRequestTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalCreateRouteRequestRequestTypeDef = TypedDict(
    "_OptionalCreateRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
        "VpcEndpointId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "LocalGatewayId": str,
        "CarrierGatewayId": str,
        "NetworkInterfaceId": str,
        "VpcPeeringConnectionId": str,
        "CoreNetworkArn": str,
    },
    total=False,
)


class CreateRouteRequestRequestTypeDef(
    _RequiredCreateRouteRequestRequestTypeDef, _OptionalCreateRouteRequestRequestTypeDef
):
    pass


CreateRouteRequestRouteTableCreateRouteTypeDef = TypedDict(
    "CreateRouteRequestRouteTableCreateRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
        "VpcEndpointId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "LocalGatewayId": str,
        "CarrierGatewayId": str,
        "NetworkInterfaceId": str,
        "VpcPeeringConnectionId": str,
        "CoreNetworkArn": str,
    },
    total=False,
)

CreateRouteResultOutputTypeDef = TypedDict(
    "CreateRouteResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredInstanceSpecificationTypeDef = TypedDict(
    "_RequiredInstanceSpecificationTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalInstanceSpecificationTypeDef = TypedDict(
    "_OptionalInstanceSpecificationTypeDef",
    {
        "ExcludeBootVolume": bool,
        "ExcludeDataVolumeIds": Sequence[str],
    },
    total=False,
)


class InstanceSpecificationTypeDef(
    _RequiredInstanceSpecificationTypeDef, _OptionalInstanceSpecificationTypeDef
):
    pass


_RequiredCreateSpotDatafeedSubscriptionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSpotDatafeedSubscriptionRequestRequestTypeDef",
    {
        "Bucket": str,
    },
)
_OptionalCreateSpotDatafeedSubscriptionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSpotDatafeedSubscriptionRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Prefix": str,
    },
    total=False,
)


class CreateSpotDatafeedSubscriptionRequestRequestTypeDef(
    _RequiredCreateSpotDatafeedSubscriptionRequestRequestTypeDef,
    _OptionalCreateSpotDatafeedSubscriptionRequestRequestTypeDef,
):
    pass


S3ObjectTagTypeDef = TypedDict(
    "S3ObjectTagTypeDef",
    {
        "Key": str,
        "Value": str,
    },
    total=False,
)

CreateStoreImageTaskResultOutputTypeDef = TypedDict(
    "CreateStoreImageTaskResultOutputTypeDef",
    {
        "ObjectKey": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TrafficMirrorPortRangeRequestTypeDef = TypedDict(
    "TrafficMirrorPortRangeRequestTypeDef",
    {
        "FromPort": int,
        "ToPort": int,
    },
    total=False,
)

TransitGatewayConnectRequestBgpOptionsTypeDef = TypedDict(
    "TransitGatewayConnectRequestBgpOptionsTypeDef",
    {
        "PeerAsn": int,
    },
    total=False,
)

CreateTransitGatewayConnectRequestOptionsTypeDef = TypedDict(
    "CreateTransitGatewayConnectRequestOptionsTypeDef",
    {
        "Protocol": Literal["gre"],
    },
)

CreateTransitGatewayMulticastDomainRequestOptionsTypeDef = TypedDict(
    "CreateTransitGatewayMulticastDomainRequestOptionsTypeDef",
    {
        "Igmpv2Support": Igmpv2SupportValueType,
        "StaticSourcesSupport": StaticSourcesSupportValueType,
        "AutoAcceptSharedAssociations": AutoAcceptSharedAssociationsValueType,
    },
    total=False,
)

CreateTransitGatewayPeeringAttachmentRequestOptionsTypeDef = TypedDict(
    "CreateTransitGatewayPeeringAttachmentRequestOptionsTypeDef",
    {
        "DynamicRouting": DynamicRoutingValueType,
    },
    total=False,
)

_RequiredCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "PrefixListId": str,
    },
)
_OptionalCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "Blackhole": bool,
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayPrefixListReferenceRequestRequestTypeDef(
    _RequiredCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef,
    _OptionalCreateTransitGatewayPrefixListReferenceRequestRequestTypeDef,
):
    pass


TransitGatewayRequestOptionsTypeDef = TypedDict(
    "TransitGatewayRequestOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": AutoAcceptSharedAttachmentsValueType,
        "DefaultRouteTableAssociation": DefaultRouteTableAssociationValueType,
        "DefaultRouteTablePropagation": DefaultRouteTablePropagationValueType,
        "VpnEcmpSupport": VpnEcmpSupportValueType,
        "DnsSupport": DnsSupportValueType,
        "MulticastSupport": MulticastSupportValueType,
        "TransitGatewayCidrBlocks": Sequence[str],
    },
    total=False,
)

_RequiredCreateTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalCreateTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayRouteRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "Blackhole": bool,
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayRouteRequestRequestTypeDef(
    _RequiredCreateTransitGatewayRouteRequestRequestTypeDef,
    _OptionalCreateTransitGatewayRouteRequestRequestTypeDef,
):
    pass


CreateTransitGatewayVpcAttachmentRequestOptionsTypeDef = TypedDict(
    "CreateTransitGatewayVpcAttachmentRequestOptionsTypeDef",
    {
        "DnsSupport": DnsSupportValueType,
        "Ipv6Support": Ipv6SupportValueType,
        "ApplianceModeSupport": ApplianceModeSupportValueType,
    },
    total=False,
)

CreateVerifiedAccessEndpointEniOptionsTypeDef = TypedDict(
    "CreateVerifiedAccessEndpointEniOptionsTypeDef",
    {
        "NetworkInterfaceId": str,
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
    },
    total=False,
)

CreateVerifiedAccessEndpointLoadBalancerOptionsTypeDef = TypedDict(
    "CreateVerifiedAccessEndpointLoadBalancerOptionsTypeDef",
    {
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
        "LoadBalancerArn": str,
        "SubnetIds": Sequence[str],
    },
    total=False,
)

CreateVerifiedAccessTrustProviderDeviceOptionsTypeDef = TypedDict(
    "CreateVerifiedAccessTrustProviderDeviceOptionsTypeDef",
    {
        "TenantId": str,
    },
    total=False,
)

CreateVerifiedAccessTrustProviderOidcOptionsTypeDef = TypedDict(
    "CreateVerifiedAccessTrustProviderOidcOptionsTypeDef",
    {
        "Issuer": str,
        "AuthorizationEndpoint": str,
        "TokenEndpoint": str,
        "UserInfoEndpoint": str,
        "ClientId": str,
        "ClientSecret": str,
        "Scope": str,
    },
    total=False,
)

CreateVolumePermissionTypeDef = TypedDict(
    "CreateVolumePermissionTypeDef",
    {
        "Group": Literal["all"],
        "UserId": str,
    },
    total=False,
)

CreateVolumePermissionOutputTypeDef = TypedDict(
    "CreateVolumePermissionOutputTypeDef",
    {
        "Group": Literal["all"],
        "UserId": str,
    },
)

_RequiredCreateVpcEndpointConnectionNotificationRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVpcEndpointConnectionNotificationRequestRequestTypeDef",
    {
        "ConnectionNotificationArn": str,
        "ConnectionEvents": Sequence[str],
    },
)
_OptionalCreateVpcEndpointConnectionNotificationRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVpcEndpointConnectionNotificationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ClientToken": str,
    },
    total=False,
)


class CreateVpcEndpointConnectionNotificationRequestRequestTypeDef(
    _RequiredCreateVpcEndpointConnectionNotificationRequestRequestTypeDef,
    _OptionalCreateVpcEndpointConnectionNotificationRequestRequestTypeDef,
):
    pass


DnsOptionsSpecificationTypeDef = TypedDict(
    "DnsOptionsSpecificationTypeDef",
    {
        "DnsRecordIpType": DnsRecordIpTypeType,
        "PrivateDnsOnlyForInboundResolverEndpoint": bool,
    },
    total=False,
)

CreateVpnConnectionRouteRequestRequestTypeDef = TypedDict(
    "CreateVpnConnectionRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "VpnConnectionId": str,
    },
)

CreditSpecificationOutputTypeDef = TypedDict(
    "CreditSpecificationOutputTypeDef",
    {
        "CpuCredits": str,
    },
)

CreditSpecificationRequestTypeDef = TypedDict(
    "CreditSpecificationRequestTypeDef",
    {
        "CpuCredits": str,
    },
)

DataQueryTypeDef = TypedDict(
    "DataQueryTypeDef",
    {
        "Id": str,
        "Source": str,
        "Destination": str,
        "Metric": Literal["aggregate-latency"],
        "Statistic": Literal["p50"],
        "Period": PeriodTypeType,
    },
    total=False,
)

MetricPointOutputTypeDef = TypedDict(
    "MetricPointOutputTypeDef",
    {
        "StartDate": datetime,
        "EndDate": datetime,
        "Value": float,
        "Status": str,
    },
)

_RequiredDeleteCarrierGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteCarrierGatewayRequestRequestTypeDef",
    {
        "CarrierGatewayId": str,
    },
)
_OptionalDeleteCarrierGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteCarrierGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteCarrierGatewayRequestRequestTypeDef(
    _RequiredDeleteCarrierGatewayRequestRequestTypeDef,
    _OptionalDeleteCarrierGatewayRequestRequestTypeDef,
):
    pass


_RequiredDeleteClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteClientVpnEndpointRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDeleteClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteClientVpnEndpointRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteClientVpnEndpointRequestRequestTypeDef(
    _RequiredDeleteClientVpnEndpointRequestRequestTypeDef,
    _OptionalDeleteClientVpnEndpointRequestRequestTypeDef,
):
    pass


_RequiredDeleteClientVpnRouteRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteClientVpnRouteRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidrBlock": str,
    },
)
_OptionalDeleteClientVpnRouteRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteClientVpnRouteRequestRequestTypeDef",
    {
        "TargetVpcSubnetId": str,
        "DryRun": bool,
    },
    total=False,
)


class DeleteClientVpnRouteRequestRequestTypeDef(
    _RequiredDeleteClientVpnRouteRequestRequestTypeDef,
    _OptionalDeleteClientVpnRouteRequestRequestTypeDef,
):
    pass


_RequiredDeleteCoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteCoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
        "CoipPoolId": str,
    },
)
_OptionalDeleteCoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteCoipCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteCoipCidrRequestRequestTypeDef(
    _RequiredDeleteCoipCidrRequestRequestTypeDef, _OptionalDeleteCoipCidrRequestRequestTypeDef
):
    pass


_RequiredDeleteCoipPoolRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteCoipPoolRequestRequestTypeDef",
    {
        "CoipPoolId": str,
    },
)
_OptionalDeleteCoipPoolRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteCoipPoolRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteCoipPoolRequestRequestTypeDef(
    _RequiredDeleteCoipPoolRequestRequestTypeDef, _OptionalDeleteCoipPoolRequestRequestTypeDef
):
    pass


_RequiredDeleteCustomerGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteCustomerGatewayRequestRequestTypeDef",
    {
        "CustomerGatewayId": str,
    },
)
_OptionalDeleteCustomerGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteCustomerGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteCustomerGatewayRequestRequestTypeDef(
    _RequiredDeleteCustomerGatewayRequestRequestTypeDef,
    _OptionalDeleteCustomerGatewayRequestRequestTypeDef,
):
    pass


DeleteDhcpOptionsRequestDhcpOptionsDeleteTypeDef = TypedDict(
    "DeleteDhcpOptionsRequestDhcpOptionsDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteDhcpOptionsRequestRequestTypeDef",
    {
        "DhcpOptionsId": str,
    },
)
_OptionalDeleteDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteDhcpOptionsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteDhcpOptionsRequestRequestTypeDef(
    _RequiredDeleteDhcpOptionsRequestRequestTypeDef, _OptionalDeleteDhcpOptionsRequestRequestTypeDef
):
    pass


_RequiredDeleteEgressOnlyInternetGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteEgressOnlyInternetGatewayRequestRequestTypeDef",
    {
        "EgressOnlyInternetGatewayId": str,
    },
)
_OptionalDeleteEgressOnlyInternetGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteEgressOnlyInternetGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteEgressOnlyInternetGatewayRequestRequestTypeDef(
    _RequiredDeleteEgressOnlyInternetGatewayRequestRequestTypeDef,
    _OptionalDeleteEgressOnlyInternetGatewayRequestRequestTypeDef,
):
    pass


DeleteEgressOnlyInternetGatewayResultOutputTypeDef = TypedDict(
    "DeleteEgressOnlyInternetGatewayResultOutputTypeDef",
    {
        "ReturnCode": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteFleetErrorOutputTypeDef = TypedDict(
    "DeleteFleetErrorOutputTypeDef",
    {
        "Code": DeleteFleetErrorCodeType,
        "Message": str,
    },
)

DeleteFleetSuccessItemOutputTypeDef = TypedDict(
    "DeleteFleetSuccessItemOutputTypeDef",
    {
        "CurrentFleetState": FleetStateCodeType,
        "PreviousFleetState": FleetStateCodeType,
        "FleetId": str,
    },
)

_RequiredDeleteFleetsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteFleetsRequestRequestTypeDef",
    {
        "FleetIds": Sequence[str],
        "TerminateInstances": bool,
    },
)
_OptionalDeleteFleetsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteFleetsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteFleetsRequestRequestTypeDef(
    _RequiredDeleteFleetsRequestRequestTypeDef, _OptionalDeleteFleetsRequestRequestTypeDef
):
    pass


_RequiredDeleteFlowLogsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteFlowLogsRequestRequestTypeDef",
    {
        "FlowLogIds": Sequence[str],
    },
)
_OptionalDeleteFlowLogsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteFlowLogsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteFlowLogsRequestRequestTypeDef(
    _RequiredDeleteFlowLogsRequestRequestTypeDef, _OptionalDeleteFlowLogsRequestRequestTypeDef
):
    pass


_RequiredDeleteFpgaImageRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteFpgaImageRequestRequestTypeDef",
    {
        "FpgaImageId": str,
    },
)
_OptionalDeleteFpgaImageRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteFpgaImageRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteFpgaImageRequestRequestTypeDef(
    _RequiredDeleteFpgaImageRequestRequestTypeDef, _OptionalDeleteFpgaImageRequestRequestTypeDef
):
    pass


DeleteFpgaImageResultOutputTypeDef = TypedDict(
    "DeleteFpgaImageResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteInstanceConnectEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteInstanceConnectEndpointRequestRequestTypeDef",
    {
        "InstanceConnectEndpointId": str,
    },
)
_OptionalDeleteInstanceConnectEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteInstanceConnectEndpointRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteInstanceConnectEndpointRequestRequestTypeDef(
    _RequiredDeleteInstanceConnectEndpointRequestRequestTypeDef,
    _OptionalDeleteInstanceConnectEndpointRequestRequestTypeDef,
):
    pass


_RequiredDeleteInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteInstanceEventWindowRequestRequestTypeDef",
    {
        "InstanceEventWindowId": str,
    },
)
_OptionalDeleteInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteInstanceEventWindowRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ForceDelete": bool,
    },
    total=False,
)


class DeleteInstanceEventWindowRequestRequestTypeDef(
    _RequiredDeleteInstanceEventWindowRequestRequestTypeDef,
    _OptionalDeleteInstanceEventWindowRequestRequestTypeDef,
):
    pass


InstanceEventWindowStateChangeOutputTypeDef = TypedDict(
    "InstanceEventWindowStateChangeOutputTypeDef",
    {
        "InstanceEventWindowId": str,
        "State": InstanceEventWindowStateType,
    },
)

DeleteInternetGatewayRequestInternetGatewayDeleteTypeDef = TypedDict(
    "DeleteInternetGatewayRequestInternetGatewayDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteInternetGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteInternetGatewayRequestRequestTypeDef",
    {
        "InternetGatewayId": str,
    },
)
_OptionalDeleteInternetGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteInternetGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteInternetGatewayRequestRequestTypeDef(
    _RequiredDeleteInternetGatewayRequestRequestTypeDef,
    _OptionalDeleteInternetGatewayRequestRequestTypeDef,
):
    pass


_RequiredDeleteIpamPoolRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteIpamPoolRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalDeleteIpamPoolRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteIpamPoolRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteIpamPoolRequestRequestTypeDef(
    _RequiredDeleteIpamPoolRequestRequestTypeDef, _OptionalDeleteIpamPoolRequestRequestTypeDef
):
    pass


_RequiredDeleteIpamRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteIpamRequestRequestTypeDef",
    {
        "IpamId": str,
    },
)
_OptionalDeleteIpamRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteIpamRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Cascade": bool,
    },
    total=False,
)


class DeleteIpamRequestRequestTypeDef(
    _RequiredDeleteIpamRequestRequestTypeDef, _OptionalDeleteIpamRequestRequestTypeDef
):
    pass


_RequiredDeleteIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "IpamResourceDiscoveryId": str,
    },
)
_OptionalDeleteIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteIpamResourceDiscoveryRequestRequestTypeDef(
    _RequiredDeleteIpamResourceDiscoveryRequestRequestTypeDef,
    _OptionalDeleteIpamResourceDiscoveryRequestRequestTypeDef,
):
    pass


_RequiredDeleteIpamScopeRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteIpamScopeRequestRequestTypeDef",
    {
        "IpamScopeId": str,
    },
)
_OptionalDeleteIpamScopeRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteIpamScopeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteIpamScopeRequestRequestTypeDef(
    _RequiredDeleteIpamScopeRequestRequestTypeDef, _OptionalDeleteIpamScopeRequestRequestTypeDef
):
    pass


DeleteKeyPairRequestKeyPairDeleteTypeDef = TypedDict(
    "DeleteKeyPairRequestKeyPairDeleteTypeDef",
    {
        "KeyPairId": str,
        "DryRun": bool,
    },
    total=False,
)

DeleteKeyPairRequestKeyPairInfoDeleteTypeDef = TypedDict(
    "DeleteKeyPairRequestKeyPairInfoDeleteTypeDef",
    {
        "KeyPairId": str,
        "DryRun": bool,
    },
    total=False,
)

DeleteKeyPairRequestRequestTypeDef = TypedDict(
    "DeleteKeyPairRequestRequestTypeDef",
    {
        "KeyName": str,
        "KeyPairId": str,
        "DryRun": bool,
    },
    total=False,
)

DeleteLaunchTemplateRequestRequestTypeDef = TypedDict(
    "DeleteLaunchTemplateRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
    },
    total=False,
)

_RequiredDeleteLaunchTemplateVersionsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteLaunchTemplateVersionsRequestRequestTypeDef",
    {
        "Versions": Sequence[str],
    },
)
_OptionalDeleteLaunchTemplateVersionsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteLaunchTemplateVersionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
    },
    total=False,
)


class DeleteLaunchTemplateVersionsRequestRequestTypeDef(
    _RequiredDeleteLaunchTemplateVersionsRequestRequestTypeDef,
    _OptionalDeleteLaunchTemplateVersionsRequestRequestTypeDef,
):
    pass


ResponseErrorOutputTypeDef = TypedDict(
    "ResponseErrorOutputTypeDef",
    {
        "Code": LaunchTemplateErrorCodeType,
        "Message": str,
    },
)

DeleteLaunchTemplateVersionsResponseSuccessItemOutputTypeDef = TypedDict(
    "DeleteLaunchTemplateVersionsResponseSuccessItemOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
    },
)

_RequiredDeleteLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteLocalGatewayRouteRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalDeleteLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteLocalGatewayRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "DryRun": bool,
        "DestinationPrefixListId": str,
    },
    total=False,
)


class DeleteLocalGatewayRouteRequestRequestTypeDef(
    _RequiredDeleteLocalGatewayRouteRequestRequestTypeDef,
    _OptionalDeleteLocalGatewayRouteRequestRequestTypeDef,
):
    pass


_RequiredDeleteLocalGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteLocalGatewayRouteTableRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalDeleteLocalGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteLocalGatewayRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteLocalGatewayRouteTableRequestRequestTypeDef(
    _RequiredDeleteLocalGatewayRouteTableRequestRequestTypeDef,
    _OptionalDeleteLocalGatewayRouteTableRequestRequestTypeDef,
):
    pass


_RequiredDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": str,
    },
)
_OptionalDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef(
    _RequiredDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef,
    _OptionalDeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef,
):
    pass


_RequiredDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociationId": str,
    },
)
_OptionalDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef(
    _RequiredDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef,
    _OptionalDeleteLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef,
):
    pass


_RequiredDeleteManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteManagedPrefixListRequestRequestTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalDeleteManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteManagedPrefixListRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteManagedPrefixListRequestRequestTypeDef(
    _RequiredDeleteManagedPrefixListRequestRequestTypeDef,
    _OptionalDeleteManagedPrefixListRequestRequestTypeDef,
):
    pass


_RequiredDeleteNatGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNatGatewayRequestRequestTypeDef",
    {
        "NatGatewayId": str,
    },
)
_OptionalDeleteNatGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNatGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNatGatewayRequestRequestTypeDef(
    _RequiredDeleteNatGatewayRequestRequestTypeDef, _OptionalDeleteNatGatewayRequestRequestTypeDef
):
    pass


DeleteNatGatewayResultOutputTypeDef = TypedDict(
    "DeleteNatGatewayResultOutputTypeDef",
    {
        "NatGatewayId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef = TypedDict(
    "_RequiredDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef",
    {
        "Egress": bool,
        "RuleNumber": int,
    },
)
_OptionalDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef = TypedDict(
    "_OptionalDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef(
    _RequiredDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef,
    _OptionalDeleteNetworkAclEntryRequestNetworkAclDeleteEntryTypeDef,
):
    pass


_RequiredDeleteNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkAclEntryRequestRequestTypeDef",
    {
        "Egress": bool,
        "NetworkAclId": str,
        "RuleNumber": int,
    },
)
_OptionalDeleteNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkAclEntryRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkAclEntryRequestRequestTypeDef(
    _RequiredDeleteNetworkAclEntryRequestRequestTypeDef,
    _OptionalDeleteNetworkAclEntryRequestRequestTypeDef,
):
    pass


DeleteNetworkAclRequestNetworkAclDeleteTypeDef = TypedDict(
    "DeleteNetworkAclRequestNetworkAclDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteNetworkAclRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkAclRequestRequestTypeDef",
    {
        "NetworkAclId": str,
    },
)
_OptionalDeleteNetworkAclRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkAclRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkAclRequestRequestTypeDef(
    _RequiredDeleteNetworkAclRequestRequestTypeDef, _OptionalDeleteNetworkAclRequestRequestTypeDef
):
    pass


_RequiredDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
    },
)
_OptionalDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef(
    _RequiredDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef,
    _OptionalDeleteNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef,
):
    pass


DeleteNetworkInsightsAccessScopeAnalysisResultOutputTypeDef = TypedDict(
    "DeleteNetworkInsightsAccessScopeAnalysisResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteNetworkInsightsAccessScopeRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInsightsAccessScopeRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
    },
)
_OptionalDeleteNetworkInsightsAccessScopeRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInsightsAccessScopeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInsightsAccessScopeRequestRequestTypeDef(
    _RequiredDeleteNetworkInsightsAccessScopeRequestRequestTypeDef,
    _OptionalDeleteNetworkInsightsAccessScopeRequestRequestTypeDef,
):
    pass


DeleteNetworkInsightsAccessScopeResultOutputTypeDef = TypedDict(
    "DeleteNetworkInsightsAccessScopeResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteNetworkInsightsAnalysisRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInsightsAnalysisRequestRequestTypeDef",
    {
        "NetworkInsightsAnalysisId": str,
    },
)
_OptionalDeleteNetworkInsightsAnalysisRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInsightsAnalysisRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInsightsAnalysisRequestRequestTypeDef(
    _RequiredDeleteNetworkInsightsAnalysisRequestRequestTypeDef,
    _OptionalDeleteNetworkInsightsAnalysisRequestRequestTypeDef,
):
    pass


DeleteNetworkInsightsAnalysisResultOutputTypeDef = TypedDict(
    "DeleteNetworkInsightsAnalysisResultOutputTypeDef",
    {
        "NetworkInsightsAnalysisId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteNetworkInsightsPathRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInsightsPathRequestRequestTypeDef",
    {
        "NetworkInsightsPathId": str,
    },
)
_OptionalDeleteNetworkInsightsPathRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInsightsPathRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInsightsPathRequestRequestTypeDef(
    _RequiredDeleteNetworkInsightsPathRequestRequestTypeDef,
    _OptionalDeleteNetworkInsightsPathRequestRequestTypeDef,
):
    pass


DeleteNetworkInsightsPathResultOutputTypeDef = TypedDict(
    "DeleteNetworkInsightsPathResultOutputTypeDef",
    {
        "NetworkInsightsPathId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteNetworkInterfacePermissionRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInterfacePermissionRequestRequestTypeDef",
    {
        "NetworkInterfacePermissionId": str,
    },
)
_OptionalDeleteNetworkInterfacePermissionRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInterfacePermissionRequestRequestTypeDef",
    {
        "Force": bool,
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInterfacePermissionRequestRequestTypeDef(
    _RequiredDeleteNetworkInterfacePermissionRequestRequestTypeDef,
    _OptionalDeleteNetworkInterfacePermissionRequestRequestTypeDef,
):
    pass


DeleteNetworkInterfacePermissionResultOutputTypeDef = TypedDict(
    "DeleteNetworkInterfacePermissionResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteNetworkInterfaceRequestNetworkInterfaceDeleteTypeDef = TypedDict(
    "DeleteNetworkInterfaceRequestNetworkInterfaceDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteNetworkInterfaceRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalDeleteNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteNetworkInterfaceRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteNetworkInterfaceRequestRequestTypeDef(
    _RequiredDeleteNetworkInterfaceRequestRequestTypeDef,
    _OptionalDeleteNetworkInterfaceRequestRequestTypeDef,
):
    pass


DeletePlacementGroupRequestPlacementGroupDeleteTypeDef = TypedDict(
    "DeletePlacementGroupRequestPlacementGroupDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeletePlacementGroupRequestRequestTypeDef = TypedDict(
    "_RequiredDeletePlacementGroupRequestRequestTypeDef",
    {
        "GroupName": str,
    },
)
_OptionalDeletePlacementGroupRequestRequestTypeDef = TypedDict(
    "_OptionalDeletePlacementGroupRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeletePlacementGroupRequestRequestTypeDef(
    _RequiredDeletePlacementGroupRequestRequestTypeDef,
    _OptionalDeletePlacementGroupRequestRequestTypeDef,
):
    pass


_RequiredDeletePublicIpv4PoolRequestRequestTypeDef = TypedDict(
    "_RequiredDeletePublicIpv4PoolRequestRequestTypeDef",
    {
        "PoolId": str,
    },
)
_OptionalDeletePublicIpv4PoolRequestRequestTypeDef = TypedDict(
    "_OptionalDeletePublicIpv4PoolRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeletePublicIpv4PoolRequestRequestTypeDef(
    _RequiredDeletePublicIpv4PoolRequestRequestTypeDef,
    _OptionalDeletePublicIpv4PoolRequestRequestTypeDef,
):
    pass


DeletePublicIpv4PoolResultOutputTypeDef = TypedDict(
    "DeletePublicIpv4PoolResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteQueuedReservedInstancesErrorOutputTypeDef = TypedDict(
    "DeleteQueuedReservedInstancesErrorOutputTypeDef",
    {
        "Code": DeleteQueuedReservedInstancesErrorCodeType,
        "Message": str,
    },
)

_RequiredDeleteQueuedReservedInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteQueuedReservedInstancesRequestRequestTypeDef",
    {
        "ReservedInstancesIds": Sequence[str],
    },
)
_OptionalDeleteQueuedReservedInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteQueuedReservedInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteQueuedReservedInstancesRequestRequestTypeDef(
    _RequiredDeleteQueuedReservedInstancesRequestRequestTypeDef,
    _OptionalDeleteQueuedReservedInstancesRequestRequestTypeDef,
):
    pass


SuccessfulQueuedPurchaseDeletionOutputTypeDef = TypedDict(
    "SuccessfulQueuedPurchaseDeletionOutputTypeDef",
    {
        "ReservedInstancesId": str,
    },
)

_RequiredDeleteRouteRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteRouteRequestRequestTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalDeleteRouteRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
    },
    total=False,
)


class DeleteRouteRequestRequestTypeDef(
    _RequiredDeleteRouteRequestRequestTypeDef, _OptionalDeleteRouteRequestRequestTypeDef
):
    pass


DeleteRouteRequestRouteDeleteTypeDef = TypedDict(
    "DeleteRouteRequestRouteDeleteTypeDef",
    {
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteRouteTableRequestRequestTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalDeleteRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteRouteTableRequestRequestTypeDef(
    _RequiredDeleteRouteTableRequestRequestTypeDef, _OptionalDeleteRouteTableRequestRequestTypeDef
):
    pass


DeleteRouteTableRequestRouteTableDeleteTypeDef = TypedDict(
    "DeleteRouteTableRequestRouteTableDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DeleteSecurityGroupRequestRequestTypeDef = TypedDict(
    "DeleteSecurityGroupRequestRequestTypeDef",
    {
        "GroupId": str,
        "GroupName": str,
        "DryRun": bool,
    },
    total=False,
)

DeleteSecurityGroupRequestSecurityGroupDeleteTypeDef = TypedDict(
    "DeleteSecurityGroupRequestSecurityGroupDeleteTypeDef",
    {
        "GroupName": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteSnapshotRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteSnapshotRequestRequestTypeDef",
    {
        "SnapshotId": str,
    },
)
_OptionalDeleteSnapshotRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteSnapshotRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteSnapshotRequestRequestTypeDef(
    _RequiredDeleteSnapshotRequestRequestTypeDef, _OptionalDeleteSnapshotRequestRequestTypeDef
):
    pass


DeleteSnapshotRequestSnapshotDeleteTypeDef = TypedDict(
    "DeleteSnapshotRequestSnapshotDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DeleteSpotDatafeedSubscriptionRequestRequestTypeDef = TypedDict(
    "DeleteSpotDatafeedSubscriptionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteSubnetCidrReservationRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteSubnetCidrReservationRequestRequestTypeDef",
    {
        "SubnetCidrReservationId": str,
    },
)
_OptionalDeleteSubnetCidrReservationRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteSubnetCidrReservationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteSubnetCidrReservationRequestRequestTypeDef(
    _RequiredDeleteSubnetCidrReservationRequestRequestTypeDef,
    _OptionalDeleteSubnetCidrReservationRequestRequestTypeDef,
):
    pass


_RequiredDeleteSubnetRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteSubnetRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalDeleteSubnetRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteSubnetRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteSubnetRequestRequestTypeDef(
    _RequiredDeleteSubnetRequestRequestTypeDef, _OptionalDeleteSubnetRequestRequestTypeDef
):
    pass


DeleteSubnetRequestSubnetDeleteTypeDef = TypedDict(
    "DeleteSubnetRequestSubnetDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DeleteTagsRequestTagDeleteTypeDef = TypedDict(
    "DeleteTagsRequestTagDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteTrafficMirrorFilterRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTrafficMirrorFilterRequestRequestTypeDef",
    {
        "TrafficMirrorFilterId": str,
    },
)
_OptionalDeleteTrafficMirrorFilterRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTrafficMirrorFilterRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTrafficMirrorFilterRequestRequestTypeDef(
    _RequiredDeleteTrafficMirrorFilterRequestRequestTypeDef,
    _OptionalDeleteTrafficMirrorFilterRequestRequestTypeDef,
):
    pass


DeleteTrafficMirrorFilterResultOutputTypeDef = TypedDict(
    "DeleteTrafficMirrorFilterResultOutputTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
    },
)
_OptionalDeleteTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTrafficMirrorFilterRuleRequestRequestTypeDef(
    _RequiredDeleteTrafficMirrorFilterRuleRequestRequestTypeDef,
    _OptionalDeleteTrafficMirrorFilterRuleRequestRequestTypeDef,
):
    pass


DeleteTrafficMirrorFilterRuleResultOutputTypeDef = TypedDict(
    "DeleteTrafficMirrorFilterRuleResultOutputTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTrafficMirrorSessionRequestRequestTypeDef",
    {
        "TrafficMirrorSessionId": str,
    },
)
_OptionalDeleteTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTrafficMirrorSessionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTrafficMirrorSessionRequestRequestTypeDef(
    _RequiredDeleteTrafficMirrorSessionRequestRequestTypeDef,
    _OptionalDeleteTrafficMirrorSessionRequestRequestTypeDef,
):
    pass


DeleteTrafficMirrorSessionResultOutputTypeDef = TypedDict(
    "DeleteTrafficMirrorSessionResultOutputTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteTrafficMirrorTargetRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTrafficMirrorTargetRequestRequestTypeDef",
    {
        "TrafficMirrorTargetId": str,
    },
)
_OptionalDeleteTrafficMirrorTargetRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTrafficMirrorTargetRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTrafficMirrorTargetRequestRequestTypeDef(
    _RequiredDeleteTrafficMirrorTargetRequestRequestTypeDef,
    _OptionalDeleteTrafficMirrorTargetRequestRequestTypeDef,
):
    pass


DeleteTrafficMirrorTargetResultOutputTypeDef = TypedDict(
    "DeleteTrafficMirrorTargetResultOutputTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteTransitGatewayConnectPeerRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayConnectPeerRequestRequestTypeDef",
    {
        "TransitGatewayConnectPeerId": str,
    },
)
_OptionalDeleteTransitGatewayConnectPeerRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayConnectPeerRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayConnectPeerRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayConnectPeerRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayConnectPeerRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayConnectRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayConnectRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalDeleteTransitGatewayConnectRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayConnectRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayConnectRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayConnectRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayConnectRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
    },
)
_OptionalDeleteTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayMulticastDomainRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayMulticastDomainRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayMulticastDomainRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayPeeringAttachmentRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
    },
)
_OptionalDeleteTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayPolicyTableRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayPolicyTableRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayPolicyTableRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "PrefixListId": str,
    },
)
_OptionalDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayPrefixListReferenceRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
    },
)
_OptionalDeleteTransitGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayRouteRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "DestinationCidrBlock": str,
    },
)
_OptionalDeleteTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayRouteRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayRouteRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayRouteRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayRouteRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableAnnouncementId": str,
    },
)
_OptionalDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayRouteTableAnnouncementRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalDeleteTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayRouteTableRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayRouteTableRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayRouteTableRequestRequestTypeDef,
):
    pass


_RequiredDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteTransitGatewayVpcAttachmentRequestRequestTypeDef(
    _RequiredDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef,
    _OptionalDeleteTransitGatewayVpcAttachmentRequestRequestTypeDef,
):
    pass


_RequiredDeleteVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "VerifiedAccessEndpointId": str,
    },
)
_OptionalDeleteVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class DeleteVerifiedAccessEndpointRequestRequestTypeDef(
    _RequiredDeleteVerifiedAccessEndpointRequestRequestTypeDef,
    _OptionalDeleteVerifiedAccessEndpointRequestRequestTypeDef,
):
    pass


_RequiredDeleteVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVerifiedAccessGroupRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
    },
)
_OptionalDeleteVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVerifiedAccessGroupRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class DeleteVerifiedAccessGroupRequestRequestTypeDef(
    _RequiredDeleteVerifiedAccessGroupRequestRequestTypeDef,
    _OptionalDeleteVerifiedAccessGroupRequestRequestTypeDef,
):
    pass


_RequiredDeleteVerifiedAccessInstanceRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVerifiedAccessInstanceRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
    },
)
_OptionalDeleteVerifiedAccessInstanceRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVerifiedAccessInstanceRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class DeleteVerifiedAccessInstanceRequestRequestTypeDef(
    _RequiredDeleteVerifiedAccessInstanceRequestRequestTypeDef,
    _OptionalDeleteVerifiedAccessInstanceRequestRequestTypeDef,
):
    pass


_RequiredDeleteVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "VerifiedAccessTrustProviderId": str,
    },
)
_OptionalDeleteVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class DeleteVerifiedAccessTrustProviderRequestRequestTypeDef(
    _RequiredDeleteVerifiedAccessTrustProviderRequestRequestTypeDef,
    _OptionalDeleteVerifiedAccessTrustProviderRequestRequestTypeDef,
):
    pass


_RequiredDeleteVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVolumeRequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalDeleteVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVolumeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVolumeRequestRequestTypeDef(
    _RequiredDeleteVolumeRequestRequestTypeDef, _OptionalDeleteVolumeRequestRequestTypeDef
):
    pass


DeleteVolumeRequestVolumeDeleteTypeDef = TypedDict(
    "DeleteVolumeRequestVolumeDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef",
    {
        "ConnectionNotificationIds": Sequence[str],
    },
)
_OptionalDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef(
    _RequiredDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef,
    _OptionalDeleteVpcEndpointConnectionNotificationsRequestRequestTypeDef,
):
    pass


_RequiredDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef",
    {
        "ServiceIds": Sequence[str],
    },
)
_OptionalDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef(
    _RequiredDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef,
    _OptionalDeleteVpcEndpointServiceConfigurationsRequestRequestTypeDef,
):
    pass


_RequiredDeleteVpcEndpointsRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpcEndpointsRequestRequestTypeDef",
    {
        "VpcEndpointIds": Sequence[str],
    },
)
_OptionalDeleteVpcEndpointsRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpcEndpointsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpcEndpointsRequestRequestTypeDef(
    _RequiredDeleteVpcEndpointsRequestRequestTypeDef,
    _OptionalDeleteVpcEndpointsRequestRequestTypeDef,
):
    pass


_RequiredDeleteVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpcPeeringConnectionRequestRequestTypeDef",
    {
        "VpcPeeringConnectionId": str,
    },
)
_OptionalDeleteVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpcPeeringConnectionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpcPeeringConnectionRequestRequestTypeDef(
    _RequiredDeleteVpcPeeringConnectionRequestRequestTypeDef,
    _OptionalDeleteVpcPeeringConnectionRequestRequestTypeDef,
):
    pass


DeleteVpcPeeringConnectionRequestVpcPeeringConnectionDeleteTypeDef = TypedDict(
    "DeleteVpcPeeringConnectionRequestVpcPeeringConnectionDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DeleteVpcPeeringConnectionResultOutputTypeDef = TypedDict(
    "DeleteVpcPeeringConnectionResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDeleteVpcRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpcRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDeleteVpcRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpcRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpcRequestRequestTypeDef(
    _RequiredDeleteVpcRequestRequestTypeDef, _OptionalDeleteVpcRequestRequestTypeDef
):
    pass


DeleteVpcRequestVpcDeleteTypeDef = TypedDict(
    "DeleteVpcRequestVpcDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeleteVpnConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpnConnectionRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
    },
)
_OptionalDeleteVpnConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpnConnectionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpnConnectionRequestRequestTypeDef(
    _RequiredDeleteVpnConnectionRequestRequestTypeDef,
    _OptionalDeleteVpnConnectionRequestRequestTypeDef,
):
    pass


DeleteVpnConnectionRouteRequestRequestTypeDef = TypedDict(
    "DeleteVpnConnectionRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "VpnConnectionId": str,
    },
)

_RequiredDeleteVpnGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDeleteVpnGatewayRequestRequestTypeDef",
    {
        "VpnGatewayId": str,
    },
)
_OptionalDeleteVpnGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDeleteVpnGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeleteVpnGatewayRequestRequestTypeDef(
    _RequiredDeleteVpnGatewayRequestRequestTypeDef, _OptionalDeleteVpnGatewayRequestRequestTypeDef
):
    pass


_RequiredDeprovisionByoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredDeprovisionByoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
    },
)
_OptionalDeprovisionByoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalDeprovisionByoipCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeprovisionByoipCidrRequestRequestTypeDef(
    _RequiredDeprovisionByoipCidrRequestRequestTypeDef,
    _OptionalDeprovisionByoipCidrRequestRequestTypeDef,
):
    pass


_RequiredDeprovisionIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_RequiredDeprovisionIpamPoolCidrRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalDeprovisionIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_OptionalDeprovisionIpamPoolCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Cidr": str,
    },
    total=False,
)


class DeprovisionIpamPoolCidrRequestRequestTypeDef(
    _RequiredDeprovisionIpamPoolCidrRequestRequestTypeDef,
    _OptionalDeprovisionIpamPoolCidrRequestRequestTypeDef,
):
    pass


_RequiredDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef = TypedDict(
    "_RequiredDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef",
    {
        "PoolId": str,
        "Cidr": str,
    },
)
_OptionalDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef = TypedDict(
    "_OptionalDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeprovisionPublicIpv4PoolCidrRequestRequestTypeDef(
    _RequiredDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef,
    _OptionalDeprovisionPublicIpv4PoolCidrRequestRequestTypeDef,
):
    pass


DeprovisionPublicIpv4PoolCidrResultOutputTypeDef = TypedDict(
    "DeprovisionPublicIpv4PoolCidrResultOutputTypeDef",
    {
        "PoolId": str,
        "DeprovisionedAddresses": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeregisterImageRequestImageDeregisterTypeDef = TypedDict(
    "DeregisterImageRequestImageDeregisterTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDeregisterImageRequestRequestTypeDef = TypedDict(
    "_RequiredDeregisterImageRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalDeregisterImageRequestRequestTypeDef = TypedDict(
    "_OptionalDeregisterImageRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeregisterImageRequestRequestTypeDef(
    _RequiredDeregisterImageRequestRequestTypeDef, _OptionalDeregisterImageRequestRequestTypeDef
):
    pass


DeregisterInstanceTagAttributeRequestTypeDef = TypedDict(
    "DeregisterInstanceTagAttributeRequestTypeDef",
    {
        "IncludeAllTagsOfInstance": bool,
        "InstanceTagKeys": Sequence[str],
    },
    total=False,
)

InstanceTagNotificationAttributeOutputTypeDef = TypedDict(
    "InstanceTagNotificationAttributeOutputTypeDef",
    {
        "InstanceTagKeys": List[str],
        "IncludeAllTagsOfInstance": bool,
    },
)

DeregisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef = TypedDict(
    "DeregisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "GroupIpAddress": str,
        "NetworkInterfaceIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

TransitGatewayMulticastDeregisteredGroupMembersOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDeregisteredGroupMembersOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "DeregisteredNetworkInterfaceIds": List[str],
        "GroupIpAddress": str,
    },
)

DeregisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef = TypedDict(
    "DeregisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "GroupIpAddress": str,
        "NetworkInterfaceIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

TransitGatewayMulticastDeregisteredGroupSourcesOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDeregisteredGroupSourcesOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "DeregisteredNetworkInterfaceIds": List[str],
        "GroupIpAddress": str,
    },
)

DescribeAccountAttributesRequestRequestTypeDef = TypedDict(
    "DescribeAccountAttributesRequestRequestTypeDef",
    {
        "AttributeNames": Sequence[AccountAttributeNameType],
        "DryRun": bool,
    },
    total=False,
)

DescribeAddressTransfersRequestDescribeAddressTransfersPaginateTypeDef = TypedDict(
    "DescribeAddressTransfersRequestDescribeAddressTransfersPaginateTypeDef",
    {
        "AllocationIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeAddressTransfersRequestRequestTypeDef = TypedDict(
    "DescribeAddressTransfersRequestRequestTypeDef",
    {
        "AllocationIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)

DescribeAddressesAttributeRequestDescribeAddressesAttributePaginateTypeDef = TypedDict(
    "DescribeAddressesAttributeRequestDescribeAddressesAttributePaginateTypeDef",
    {
        "AllocationIds": Sequence[str],
        "Attribute": Literal["domain-name"],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeAddressesAttributeRequestRequestTypeDef = TypedDict(
    "DescribeAddressesAttributeRequestRequestTypeDef",
    {
        "AllocationIds": Sequence[str],
        "Attribute": Literal["domain-name"],
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)

FilterTypeDef = TypedDict(
    "FilterTypeDef",
    {
        "Name": str,
        "Values": Sequence[str],
    },
    total=False,
)

DescribeAggregateIdFormatRequestRequestTypeDef = TypedDict(
    "DescribeAggregateIdFormatRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

IdFormatOutputTypeDef = TypedDict(
    "IdFormatOutputTypeDef",
    {
        "Deadline": datetime,
        "Resource": str,
        "UseLongIds": bool,
    },
)

SubscriptionOutputTypeDef = TypedDict(
    "SubscriptionOutputTypeDef",
    {
        "Source": str,
        "Destination": str,
        "Metric": Literal["aggregate-latency"],
        "Statistic": Literal["p50"],
        "Period": PeriodTypeType,
    },
)

WaiterConfigTypeDef = TypedDict(
    "WaiterConfigTypeDef",
    {
        "Delay": int,
        "MaxAttempts": int,
    },
    total=False,
)

DescribeByoipCidrsRequestDescribeByoipCidrsPaginateTypeDef = TypedDict(
    "DescribeByoipCidrsRequestDescribeByoipCidrsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

_RequiredDescribeByoipCidrsRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeByoipCidrsRequestRequestTypeDef",
    {
        "MaxResults": int,
    },
)
_OptionalDescribeByoipCidrsRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeByoipCidrsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "NextToken": str,
    },
    total=False,
)


class DescribeByoipCidrsRequestRequestTypeDef(
    _RequiredDescribeByoipCidrsRequestRequestTypeDef,
    _OptionalDescribeByoipCidrsRequestRequestTypeDef,
):
    pass


DescribeConversionTasksRequestRequestTypeDef = TypedDict(
    "DescribeConversionTasksRequestRequestTypeDef",
    {
        "ConversionTaskIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef = TypedDict(
    "FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Version": str,
    },
)

FastLaunchSnapshotConfigurationResponseOutputTypeDef = TypedDict(
    "FastLaunchSnapshotConfigurationResponseOutputTypeDef",
    {
        "TargetResourceCount": int,
    },
)

DescribeFastSnapshotRestoreSuccessItemOutputTypeDef = TypedDict(
    "DescribeFastSnapshotRestoreSuccessItemOutputTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": FastSnapshotRestoreStateCodeType,
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
)

_RequiredDescribeFleetHistoryRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeFleetHistoryRequestRequestTypeDef",
    {
        "FleetId": str,
        "StartTime": Union[datetime, str],
    },
)
_OptionalDescribeFleetHistoryRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeFleetHistoryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "EventType": FleetEventTypeType,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeFleetHistoryRequestRequestTypeDef(
    _RequiredDescribeFleetHistoryRequestRequestTypeDef,
    _OptionalDescribeFleetHistoryRequestRequestTypeDef,
):
    pass


_RequiredDescribeFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeFpgaImageAttributeRequestRequestTypeDef",
    {
        "FpgaImageId": str,
        "Attribute": FpgaImageAttributeNameType,
    },
)
_OptionalDescribeFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeFpgaImageAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeFpgaImageAttributeRequestRequestTypeDef(
    _RequiredDescribeFpgaImageAttributeRequestRequestTypeDef,
    _OptionalDescribeFpgaImageAttributeRequestRequestTypeDef,
):
    pass


HostOfferingOutputTypeDef = TypedDict(
    "HostOfferingOutputTypeDef",
    {
        "CurrencyCode": Literal["USD"],
        "Duration": int,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": PaymentOptionType,
        "UpfrontPrice": str,
    },
)

DescribeIdFormatRequestRequestTypeDef = TypedDict(
    "DescribeIdFormatRequestRequestTypeDef",
    {
        "Resource": str,
    },
    total=False,
)

_RequiredDescribeIdentityIdFormatRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeIdentityIdFormatRequestRequestTypeDef",
    {
        "PrincipalArn": str,
    },
)
_OptionalDescribeIdentityIdFormatRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeIdentityIdFormatRequestRequestTypeDef",
    {
        "Resource": str,
    },
    total=False,
)


class DescribeIdentityIdFormatRequestRequestTypeDef(
    _RequiredDescribeIdentityIdFormatRequestRequestTypeDef,
    _OptionalDescribeIdentityIdFormatRequestRequestTypeDef,
):
    pass


_RequiredDescribeImageAttributeRequestImageDescribeAttributeTypeDef = TypedDict(
    "_RequiredDescribeImageAttributeRequestImageDescribeAttributeTypeDef",
    {
        "Attribute": ImageAttributeNameType,
    },
)
_OptionalDescribeImageAttributeRequestImageDescribeAttributeTypeDef = TypedDict(
    "_OptionalDescribeImageAttributeRequestImageDescribeAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeImageAttributeRequestImageDescribeAttributeTypeDef(
    _RequiredDescribeImageAttributeRequestImageDescribeAttributeTypeDef,
    _OptionalDescribeImageAttributeRequestImageDescribeAttributeTypeDef,
):
    pass


_RequiredDescribeImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeImageAttributeRequestRequestTypeDef",
    {
        "Attribute": ImageAttributeNameType,
        "ImageId": str,
    },
)
_OptionalDescribeImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeImageAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeImageAttributeRequestRequestTypeDef(
    _RequiredDescribeImageAttributeRequestRequestTypeDef,
    _OptionalDescribeImageAttributeRequestRequestTypeDef,
):
    pass


_RequiredDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef = TypedDict(
    "_RequiredDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
    },
)
_OptionalDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef = TypedDict(
    "_OptionalDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef(
    _RequiredDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef,
    _OptionalDescribeInstanceAttributeRequestInstanceDescribeAttributeTypeDef,
):
    pass


_RequiredDescribeInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeInstanceAttributeRequestRequestTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
        "InstanceId": str,
    },
)
_OptionalDescribeInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeInstanceAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeInstanceAttributeRequestRequestTypeDef(
    _RequiredDescribeInstanceAttributeRequestRequestTypeDef,
    _OptionalDescribeInstanceAttributeRequestRequestTypeDef,
):
    pass


InstanceCreditSpecificationOutputTypeDef = TypedDict(
    "InstanceCreditSpecificationOutputTypeDef",
    {
        "InstanceId": str,
        "CpuCredits": str,
    },
)

DescribeInstanceEventNotificationAttributesRequestRequestTypeDef = TypedDict(
    "DescribeInstanceEventNotificationAttributesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

InstanceTypeOfferingOutputTypeDef = TypedDict(
    "InstanceTypeOfferingOutputTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "LocationType": LocationTypeType,
        "Location": str,
    },
)

MovingAddressStatusOutputTypeDef = TypedDict(
    "MovingAddressStatusOutputTypeDef",
    {
        "MoveStatus": MoveStatusType,
        "PublicIp": str,
    },
)

DescribeNetworkInterfaceAttributeRequestNetworkInterfaceDescribeAttributeTypeDef = TypedDict(
    "DescribeNetworkInterfaceAttributeRequestNetworkInterfaceDescribeAttributeTypeDef",
    {
        "Attribute": NetworkInterfaceAttributeType,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDescribeNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalDescribeNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "Attribute": NetworkInterfaceAttributeType,
        "DryRun": bool,
    },
    total=False,
)


class DescribeNetworkInterfaceAttributeRequestRequestTypeDef(
    _RequiredDescribeNetworkInterfaceAttributeRequestRequestTypeDef,
    _OptionalDescribeNetworkInterfaceAttributeRequestRequestTypeDef,
):
    pass


PrefixListOutputTypeDef = TypedDict(
    "PrefixListOutputTypeDef",
    {
        "Cidrs": List[str],
        "PrefixListId": str,
        "PrefixListName": str,
    },
)

DescribePrincipalIdFormatRequestDescribePrincipalIdFormatPaginateTypeDef = TypedDict(
    "DescribePrincipalIdFormatRequestDescribePrincipalIdFormatPaginateTypeDef",
    {
        "DryRun": bool,
        "Resources": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribePrincipalIdFormatRequestRequestTypeDef = TypedDict(
    "DescribePrincipalIdFormatRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Resources": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

RegionOutputTypeDef = TypedDict(
    "RegionOutputTypeDef",
    {
        "Endpoint": str,
        "RegionName": str,
        "OptInStatus": str,
    },
)

ScheduledInstanceRecurrenceRequestTypeDef = TypedDict(
    "ScheduledInstanceRecurrenceRequestTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDays": Sequence[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)

SlotDateTimeRangeRequestTypeDef = TypedDict(
    "SlotDateTimeRangeRequestTypeDef",
    {
        "EarliestTime": Union[datetime, str],
        "LatestTime": Union[datetime, str],
    },
)

SlotStartTimeRangeRequestTypeDef = TypedDict(
    "SlotStartTimeRangeRequestTypeDef",
    {
        "EarliestTime": Union[datetime, str],
        "LatestTime": Union[datetime, str],
    },
    total=False,
)

_RequiredDescribeSecurityGroupReferencesRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeSecurityGroupReferencesRequestRequestTypeDef",
    {
        "GroupId": Sequence[str],
    },
)
_OptionalDescribeSecurityGroupReferencesRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeSecurityGroupReferencesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeSecurityGroupReferencesRequestRequestTypeDef(
    _RequiredDescribeSecurityGroupReferencesRequestRequestTypeDef,
    _OptionalDescribeSecurityGroupReferencesRequestRequestTypeDef,
):
    pass


SecurityGroupReferenceOutputTypeDef = TypedDict(
    "SecurityGroupReferenceOutputTypeDef",
    {
        "GroupId": str,
        "ReferencingVpcId": str,
        "VpcPeeringConnectionId": str,
    },
)

_RequiredDescribeSnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeSnapshotAttributeRequestRequestTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
        "SnapshotId": str,
    },
)
_OptionalDescribeSnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeSnapshotAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeSnapshotAttributeRequestRequestTypeDef(
    _RequiredDescribeSnapshotAttributeRequestRequestTypeDef,
    _OptionalDescribeSnapshotAttributeRequestRequestTypeDef,
):
    pass


_RequiredDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef = TypedDict(
    "_RequiredDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
    },
)
_OptionalDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef = TypedDict(
    "_OptionalDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef(
    _RequiredDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef,
    _OptionalDescribeSnapshotAttributeRequestSnapshotDescribeAttributeTypeDef,
):
    pass


ProductCodeOutputTypeDef = TypedDict(
    "ProductCodeOutputTypeDef",
    {
        "ProductCodeId": str,
        "ProductCodeType": ProductCodeValuesType,
    },
)

DescribeSpotDatafeedSubscriptionRequestRequestTypeDef = TypedDict(
    "DescribeSpotDatafeedSubscriptionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef = TypedDict(
    "_RequiredDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef",
    {
        "SpotFleetRequestId": str,
    },
)
_OptionalDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef = TypedDict(
    "_OptionalDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef(
    _RequiredDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef,
    _OptionalDescribeSpotFleetInstancesRequestDescribeSpotFleetInstancesPaginateTypeDef,
):
    pass


_RequiredDescribeSpotFleetInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeSpotFleetInstancesRequestRequestTypeDef",
    {
        "SpotFleetRequestId": str,
    },
)
_OptionalDescribeSpotFleetInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeSpotFleetInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeSpotFleetInstancesRequestRequestTypeDef(
    _RequiredDescribeSpotFleetInstancesRequestRequestTypeDef,
    _OptionalDescribeSpotFleetInstancesRequestRequestTypeDef,
):
    pass


_RequiredDescribeSpotFleetRequestHistoryRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeSpotFleetRequestHistoryRequestRequestTypeDef",
    {
        "SpotFleetRequestId": str,
        "StartTime": Union[datetime, str],
    },
)
_OptionalDescribeSpotFleetRequestHistoryRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeSpotFleetRequestHistoryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "EventType": EventTypeType,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeSpotFleetRequestHistoryRequestRequestTypeDef(
    _RequiredDescribeSpotFleetRequestHistoryRequestRequestTypeDef,
    _OptionalDescribeSpotFleetRequestHistoryRequestRequestTypeDef,
):
    pass


DescribeSpotFleetRequestsRequestDescribeSpotFleetRequestsPaginateTypeDef = TypedDict(
    "DescribeSpotFleetRequestsRequestDescribeSpotFleetRequestsPaginateTypeDef",
    {
        "DryRun": bool,
        "SpotFleetRequestIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSpotFleetRequestsRequestRequestTypeDef = TypedDict(
    "DescribeSpotFleetRequestsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "SpotFleetRequestIds": Sequence[str],
    },
    total=False,
)

SpotPriceOutputTypeDef = TypedDict(
    "SpotPriceOutputTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceType": InstanceTypeType,
        "ProductDescription": RIProductDescriptionType,
        "SpotPrice": str,
        "Timestamp": datetime,
    },
)

_RequiredDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef = TypedDict(
    "_RequiredDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef = TypedDict(
    "_OptionalDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef(
    _RequiredDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef,
    _OptionalDescribeStaleSecurityGroupsRequestDescribeStaleSecurityGroupsPaginateTypeDef,
):
    pass


_RequiredDescribeStaleSecurityGroupsRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeStaleSecurityGroupsRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDescribeStaleSecurityGroupsRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeStaleSecurityGroupsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsRequestRequestTypeDef(
    _RequiredDescribeStaleSecurityGroupsRequestRequestTypeDef,
    _OptionalDescribeStaleSecurityGroupsRequestRequestTypeDef,
):
    pass


StoreImageTaskResultOutputTypeDef = TypedDict(
    "StoreImageTaskResultOutputTypeDef",
    {
        "AmiId": str,
        "TaskStartTime": datetime,
        "Bucket": str,
        "S3objectKey": str,
        "ProgressPercentage": int,
        "StoreTaskState": str,
        "StoreTaskFailureReason": str,
    },
)

TagDescriptionOutputTypeDef = TypedDict(
    "TagDescriptionOutputTypeDef",
    {
        "Key": str,
        "ResourceId": str,
        "ResourceType": ResourceTypeType,
        "Value": str,
    },
)

_RequiredDescribeVolumeAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeVolumeAttributeRequestRequestTypeDef",
    {
        "Attribute": VolumeAttributeNameType,
        "VolumeId": str,
    },
)
_OptionalDescribeVolumeAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeVolumeAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeVolumeAttributeRequestRequestTypeDef(
    _RequiredDescribeVolumeAttributeRequestRequestTypeDef,
    _OptionalDescribeVolumeAttributeRequestRequestTypeDef,
):
    pass


_RequiredDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef = TypedDict(
    "_RequiredDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef",
    {
        "Attribute": VolumeAttributeNameType,
    },
)
_OptionalDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef = TypedDict(
    "_OptionalDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef(
    _RequiredDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef,
    _OptionalDescribeVolumeAttributeRequestVolumeDescribeAttributeTypeDef,
):
    pass


VolumeModificationOutputTypeDef = TypedDict(
    "VolumeModificationOutputTypeDef",
    {
        "VolumeId": str,
        "ModificationState": VolumeModificationStateType,
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": VolumeTypeType,
        "TargetThroughput": int,
        "TargetMultiAttachEnabled": bool,
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": VolumeTypeType,
        "OriginalThroughput": int,
        "OriginalMultiAttachEnabled": bool,
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
)

_RequiredDescribeVpcAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeVpcAttributeRequestRequestTypeDef",
    {
        "Attribute": VpcAttributeNameType,
        "VpcId": str,
    },
)
_OptionalDescribeVpcAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeVpcAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeVpcAttributeRequestRequestTypeDef(
    _RequiredDescribeVpcAttributeRequestRequestTypeDef,
    _OptionalDescribeVpcAttributeRequestRequestTypeDef,
):
    pass


_RequiredDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef = TypedDict(
    "_RequiredDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef",
    {
        "Attribute": VpcAttributeNameType,
    },
)
_OptionalDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef = TypedDict(
    "_OptionalDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DescribeVpcAttributeRequestVpcDescribeAttributeTypeDef(
    _RequiredDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef,
    _OptionalDescribeVpcAttributeRequestVpcDescribeAttributeTypeDef,
):
    pass


DescribeVpcClassicLinkDnsSupportRequestDescribeVpcClassicLinkDnsSupportPaginateTypeDef = TypedDict(
    "DescribeVpcClassicLinkDnsSupportRequestDescribeVpcClassicLinkDnsSupportPaginateTypeDef",
    {
        "VpcIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcClassicLinkDnsSupportRequestRequestTypeDef = TypedDict(
    "DescribeVpcClassicLinkDnsSupportRequestRequestTypeDef",
    {
        "MaxResults": int,
        "NextToken": str,
        "VpcIds": Sequence[str],
    },
    total=False,
)

DestinationOptionsResponseOutputTypeDef = TypedDict(
    "DestinationOptionsResponseOutputTypeDef",
    {
        "FileFormat": DestinationFileFormatType,
        "HiveCompatiblePartitions": bool,
        "PerHourPartition": bool,
    },
)

_RequiredDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef = TypedDict(
    "_RequiredDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef = TypedDict(
    "_OptionalDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef(
    _RequiredDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef,
    _OptionalDetachClassicLinkVpcRequestInstanceDetachClassicLinkVpcTypeDef,
):
    pass


_RequiredDetachClassicLinkVpcRequestRequestTypeDef = TypedDict(
    "_RequiredDetachClassicLinkVpcRequestRequestTypeDef",
    {
        "InstanceId": str,
        "VpcId": str,
    },
)
_OptionalDetachClassicLinkVpcRequestRequestTypeDef = TypedDict(
    "_OptionalDetachClassicLinkVpcRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachClassicLinkVpcRequestRequestTypeDef(
    _RequiredDetachClassicLinkVpcRequestRequestTypeDef,
    _OptionalDetachClassicLinkVpcRequestRequestTypeDef,
):
    pass


_RequiredDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef = TypedDict(
    "_RequiredDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef = TypedDict(
    "_OptionalDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef(
    _RequiredDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef,
    _OptionalDetachClassicLinkVpcRequestVpcDetachClassicLinkInstanceTypeDef,
):
    pass


DetachClassicLinkVpcResultOutputTypeDef = TypedDict(
    "DetachClassicLinkVpcResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef = TypedDict(
    "_RequiredDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef = TypedDict(
    "_OptionalDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef(
    _RequiredDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef,
    _OptionalDetachInternetGatewayRequestInternetGatewayDetachFromVpcTypeDef,
):
    pass


_RequiredDetachInternetGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDetachInternetGatewayRequestRequestTypeDef",
    {
        "InternetGatewayId": str,
        "VpcId": str,
    },
)
_OptionalDetachInternetGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDetachInternetGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachInternetGatewayRequestRequestTypeDef(
    _RequiredDetachInternetGatewayRequestRequestTypeDef,
    _OptionalDetachInternetGatewayRequestRequestTypeDef,
):
    pass


_RequiredDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef = TypedDict(
    "_RequiredDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef",
    {
        "InternetGatewayId": str,
    },
)
_OptionalDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef = TypedDict(
    "_OptionalDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef(
    _RequiredDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef,
    _OptionalDetachInternetGatewayRequestVpcDetachInternetGatewayTypeDef,
):
    pass


_RequiredDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef = TypedDict(
    "_RequiredDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef",
    {
        "AttachmentId": str,
    },
)
_OptionalDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef = TypedDict(
    "_OptionalDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef",
    {
        "DryRun": bool,
        "Force": bool,
    },
    total=False,
)


class DetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef(
    _RequiredDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef,
    _OptionalDetachNetworkInterfaceRequestNetworkInterfaceDetachTypeDef,
):
    pass


_RequiredDetachNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredDetachNetworkInterfaceRequestRequestTypeDef",
    {
        "AttachmentId": str,
    },
)
_OptionalDetachNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalDetachNetworkInterfaceRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Force": bool,
    },
    total=False,
)


class DetachNetworkInterfaceRequestRequestTypeDef(
    _RequiredDetachNetworkInterfaceRequestRequestTypeDef,
    _OptionalDetachNetworkInterfaceRequestRequestTypeDef,
):
    pass


_RequiredDetachVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_RequiredDetachVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "VerifiedAccessTrustProviderId": str,
    },
)
_OptionalDetachVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_OptionalDetachVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class DetachVerifiedAccessTrustProviderRequestRequestTypeDef(
    _RequiredDetachVerifiedAccessTrustProviderRequestRequestTypeDef,
    _OptionalDetachVerifiedAccessTrustProviderRequestRequestTypeDef,
):
    pass


_RequiredDetachVolumeRequestInstanceDetachVolumeTypeDef = TypedDict(
    "_RequiredDetachVolumeRequestInstanceDetachVolumeTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalDetachVolumeRequestInstanceDetachVolumeTypeDef = TypedDict(
    "_OptionalDetachVolumeRequestInstanceDetachVolumeTypeDef",
    {
        "Device": str,
        "Force": bool,
        "DryRun": bool,
    },
    total=False,
)


class DetachVolumeRequestInstanceDetachVolumeTypeDef(
    _RequiredDetachVolumeRequestInstanceDetachVolumeTypeDef,
    _OptionalDetachVolumeRequestInstanceDetachVolumeTypeDef,
):
    pass


_RequiredDetachVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredDetachVolumeRequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalDetachVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalDetachVolumeRequestRequestTypeDef",
    {
        "Device": str,
        "Force": bool,
        "InstanceId": str,
        "DryRun": bool,
    },
    total=False,
)


class DetachVolumeRequestRequestTypeDef(
    _RequiredDetachVolumeRequestRequestTypeDef, _OptionalDetachVolumeRequestRequestTypeDef
):
    pass


DetachVolumeRequestVolumeDetachFromInstanceTypeDef = TypedDict(
    "DetachVolumeRequestVolumeDetachFromInstanceTypeDef",
    {
        "Device": str,
        "Force": bool,
        "InstanceId": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDetachVpnGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredDetachVpnGatewayRequestRequestTypeDef",
    {
        "VpcId": str,
        "VpnGatewayId": str,
    },
)
_OptionalDetachVpnGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalDetachVpnGatewayRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DetachVpnGatewayRequestRequestTypeDef(
    _RequiredDetachVpnGatewayRequestRequestTypeDef, _OptionalDetachVpnGatewayRequestRequestTypeDef
):
    pass


DeviceOptionsOutputTypeDef = TypedDict(
    "DeviceOptionsOutputTypeDef",
    {
        "TenantId": str,
    },
)

_RequiredDisableAddressTransferRequestRequestTypeDef = TypedDict(
    "_RequiredDisableAddressTransferRequestRequestTypeDef",
    {
        "AllocationId": str,
    },
)
_OptionalDisableAddressTransferRequestRequestTypeDef = TypedDict(
    "_OptionalDisableAddressTransferRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableAddressTransferRequestRequestTypeDef(
    _RequiredDisableAddressTransferRequestRequestTypeDef,
    _OptionalDisableAddressTransferRequestRequestTypeDef,
):
    pass


DisableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef = TypedDict(
    "DisableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef",
    {
        "Source": str,
        "Destination": str,
        "Metric": Literal["aggregate-latency"],
        "Statistic": Literal["p50"],
        "DryRun": bool,
    },
    total=False,
)

DisableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef = TypedDict(
    "DisableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef",
    {
        "Output": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisableEbsEncryptionByDefaultRequestRequestTypeDef = TypedDict(
    "DisableEbsEncryptionByDefaultRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DisableEbsEncryptionByDefaultResultOutputTypeDef = TypedDict(
    "DisableEbsEncryptionByDefaultResultOutputTypeDef",
    {
        "EbsEncryptionByDefault": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDisableFastLaunchRequestRequestTypeDef = TypedDict(
    "_RequiredDisableFastLaunchRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalDisableFastLaunchRequestRequestTypeDef = TypedDict(
    "_OptionalDisableFastLaunchRequestRequestTypeDef",
    {
        "Force": bool,
        "DryRun": bool,
    },
    total=False,
)


class DisableFastLaunchRequestRequestTypeDef(
    _RequiredDisableFastLaunchRequestRequestTypeDef, _OptionalDisableFastLaunchRequestRequestTypeDef
):
    pass


DisableFastSnapshotRestoreStateErrorOutputTypeDef = TypedDict(
    "DisableFastSnapshotRestoreStateErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

DisableFastSnapshotRestoreSuccessItemOutputTypeDef = TypedDict(
    "DisableFastSnapshotRestoreSuccessItemOutputTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": FastSnapshotRestoreStateCodeType,
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
)

_RequiredDisableFastSnapshotRestoresRequestRequestTypeDef = TypedDict(
    "_RequiredDisableFastSnapshotRestoresRequestRequestTypeDef",
    {
        "AvailabilityZones": Sequence[str],
        "SourceSnapshotIds": Sequence[str],
    },
)
_OptionalDisableFastSnapshotRestoresRequestRequestTypeDef = TypedDict(
    "_OptionalDisableFastSnapshotRestoresRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableFastSnapshotRestoresRequestRequestTypeDef(
    _RequiredDisableFastSnapshotRestoresRequestRequestTypeDef,
    _OptionalDisableFastSnapshotRestoresRequestRequestTypeDef,
):
    pass


_RequiredDisableImageDeprecationRequestRequestTypeDef = TypedDict(
    "_RequiredDisableImageDeprecationRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalDisableImageDeprecationRequestRequestTypeDef = TypedDict(
    "_OptionalDisableImageDeprecationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableImageDeprecationRequestRequestTypeDef(
    _RequiredDisableImageDeprecationRequestRequestTypeDef,
    _OptionalDisableImageDeprecationRequestRequestTypeDef,
):
    pass


DisableImageDeprecationResultOutputTypeDef = TypedDict(
    "DisableImageDeprecationResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDisableIpamOrganizationAdminAccountRequestRequestTypeDef = TypedDict(
    "_RequiredDisableIpamOrganizationAdminAccountRequestRequestTypeDef",
    {
        "DelegatedAdminAccountId": str,
    },
)
_OptionalDisableIpamOrganizationAdminAccountRequestRequestTypeDef = TypedDict(
    "_OptionalDisableIpamOrganizationAdminAccountRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableIpamOrganizationAdminAccountRequestRequestTypeDef(
    _RequiredDisableIpamOrganizationAdminAccountRequestRequestTypeDef,
    _OptionalDisableIpamOrganizationAdminAccountRequestRequestTypeDef,
):
    pass


DisableIpamOrganizationAdminAccountResultOutputTypeDef = TypedDict(
    "DisableIpamOrganizationAdminAccountResultOutputTypeDef",
    {
        "Success": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisableSerialConsoleAccessRequestRequestTypeDef = TypedDict(
    "DisableSerialConsoleAccessRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DisableSerialConsoleAccessResultOutputTypeDef = TypedDict(
    "DisableSerialConsoleAccessResultOutputTypeDef",
    {
        "SerialConsoleAccessEnabled": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef = TypedDict(
    "_RequiredDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef = TypedDict(
    "_OptionalDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "DryRun": bool,
        "TransitGatewayRouteTableAnnouncementId": str,
    },
    total=False,
)


class DisableTransitGatewayRouteTablePropagationRequestRequestTypeDef(
    _RequiredDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef,
    _OptionalDisableTransitGatewayRouteTablePropagationRequestRequestTypeDef,
):
    pass


TransitGatewayPropagationOutputTypeDef = TypedDict(
    "TransitGatewayPropagationOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "TransitGatewayRouteTableId": str,
        "State": TransitGatewayPropagationStateType,
        "TransitGatewayRouteTableAnnouncementId": str,
    },
)

_RequiredDisableVgwRoutePropagationRequestRequestTypeDef = TypedDict(
    "_RequiredDisableVgwRoutePropagationRequestRequestTypeDef",
    {
        "GatewayId": str,
        "RouteTableId": str,
    },
)
_OptionalDisableVgwRoutePropagationRequestRequestTypeDef = TypedDict(
    "_OptionalDisableVgwRoutePropagationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableVgwRoutePropagationRequestRequestTypeDef(
    _RequiredDisableVgwRoutePropagationRequestRequestTypeDef,
    _OptionalDisableVgwRoutePropagationRequestRequestTypeDef,
):
    pass


DisableVpcClassicLinkDnsSupportRequestRequestTypeDef = TypedDict(
    "DisableVpcClassicLinkDnsSupportRequestRequestTypeDef",
    {
        "VpcId": str,
    },
    total=False,
)

DisableVpcClassicLinkDnsSupportResultOutputTypeDef = TypedDict(
    "DisableVpcClassicLinkDnsSupportResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDisableVpcClassicLinkRequestRequestTypeDef = TypedDict(
    "_RequiredDisableVpcClassicLinkRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalDisableVpcClassicLinkRequestRequestTypeDef = TypedDict(
    "_OptionalDisableVpcClassicLinkRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisableVpcClassicLinkRequestRequestTypeDef(
    _RequiredDisableVpcClassicLinkRequestRequestTypeDef,
    _OptionalDisableVpcClassicLinkRequestRequestTypeDef,
):
    pass


DisableVpcClassicLinkRequestVpcDisableClassicLinkTypeDef = TypedDict(
    "DisableVpcClassicLinkRequestVpcDisableClassicLinkTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

DisableVpcClassicLinkResultOutputTypeDef = TypedDict(
    "DisableVpcClassicLinkResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateAddressRequestClassicAddressDisassociateTypeDef = TypedDict(
    "DisassociateAddressRequestClassicAddressDisassociateTypeDef",
    {
        "AssociationId": str,
        "PublicIp": str,
        "DryRun": bool,
    },
    total=False,
)

DisassociateAddressRequestNetworkInterfaceAssociationDeleteTypeDef = TypedDict(
    "DisassociateAddressRequestNetworkInterfaceAssociationDeleteTypeDef",
    {
        "PublicIp": str,
        "DryRun": bool,
    },
    total=False,
)

DisassociateAddressRequestRequestTypeDef = TypedDict(
    "DisassociateAddressRequestRequestTypeDef",
    {
        "AssociationId": str,
        "PublicIp": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDisassociateClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "AssociationId": str,
    },
)
_OptionalDisassociateClientVpnTargetNetworkRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateClientVpnTargetNetworkRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateClientVpnTargetNetworkRequestRequestTypeDef(
    _RequiredDisassociateClientVpnTargetNetworkRequestRequestTypeDef,
    _OptionalDisassociateClientVpnTargetNetworkRequestRequestTypeDef,
):
    pass


_RequiredDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    {
        "CertificateArn": str,
        "RoleArn": str,
    },
)
_OptionalDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateEnclaveCertificateIamRoleRequestRequestTypeDef(
    _RequiredDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef,
    _OptionalDisassociateEnclaveCertificateIamRoleRequestRequestTypeDef,
):
    pass


DisassociateEnclaveCertificateIamRoleResultOutputTypeDef = TypedDict(
    "DisassociateEnclaveCertificateIamRoleResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateIamInstanceProfileRequestRequestTypeDef = TypedDict(
    "DisassociateIamInstanceProfileRequestRequestTypeDef",
    {
        "AssociationId": str,
    },
)

_RequiredDisassociateIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "IpamResourceDiscoveryAssociationId": str,
    },
)
_OptionalDisassociateIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateIpamResourceDiscoveryRequestRequestTypeDef(
    _RequiredDisassociateIpamResourceDiscoveryRequestRequestTypeDef,
    _OptionalDisassociateIpamResourceDiscoveryRequestRequestTypeDef,
):
    pass


_RequiredDisassociateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateNatGatewayAddressRequestRequestTypeDef",
    {
        "NatGatewayId": str,
        "AssociationIds": Sequence[str],
    },
)
_OptionalDisassociateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateNatGatewayAddressRequestRequestTypeDef",
    {
        "MaxDrainDurationSeconds": int,
        "DryRun": bool,
    },
    total=False,
)


class DisassociateNatGatewayAddressRequestRequestTypeDef(
    _RequiredDisassociateNatGatewayAddressRequestRequestTypeDef,
    _OptionalDisassociateNatGatewayAddressRequestRequestTypeDef,
):
    pass


_RequiredDisassociateRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateRouteTableRequestRequestTypeDef",
    {
        "AssociationId": str,
    },
)
_OptionalDisassociateRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateRouteTableRequestRequestTypeDef(
    _RequiredDisassociateRouteTableRequestRequestTypeDef,
    _OptionalDisassociateRouteTableRequestRequestTypeDef,
):
    pass


DisassociateRouteTableRequestRouteTableAssociationDeleteTypeDef = TypedDict(
    "DisassociateRouteTableRequestRouteTableAssociationDeleteTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef = TypedDict(
    "_RequiredDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef",
    {
        "AssociationId": str,
    },
)
_OptionalDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef = TypedDict(
    "_OptionalDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef(
    _RequiredDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef,
    _OptionalDisassociateRouteTableRequestServiceResourceDisassociateRouteTableTypeDef,
):
    pass


DisassociateSubnetCidrBlockRequestRequestTypeDef = TypedDict(
    "DisassociateSubnetCidrBlockRequestRequestTypeDef",
    {
        "AssociationId": str,
    },
)

_RequiredDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayAttachmentId": str,
        "SubnetIds": Sequence[str],
    },
)
_OptionalDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateTransitGatewayMulticastDomainRequestRequestTypeDef(
    _RequiredDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef,
    _OptionalDisassociateTransitGatewayMulticastDomainRequestRequestTypeDef,
):
    pass


_RequiredDisassociateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalDisassociateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateTransitGatewayPolicyTableRequestRequestTypeDef(
    _RequiredDisassociateTransitGatewayPolicyTableRequestRequestTypeDef,
    _OptionalDisassociateTransitGatewayPolicyTableRequestRequestTypeDef,
):
    pass


_RequiredDisassociateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalDisassociateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateTransitGatewayRouteTableRequestRequestTypeDef(
    _RequiredDisassociateTransitGatewayRouteTableRequestRequestTypeDef,
    _OptionalDisassociateTransitGatewayRouteTableRequestRequestTypeDef,
):
    pass


_RequiredDisassociateTrunkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateTrunkInterfaceRequestRequestTypeDef",
    {
        "AssociationId": str,
    },
)
_OptionalDisassociateTrunkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateTrunkInterfaceRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class DisassociateTrunkInterfaceRequestRequestTypeDef(
    _RequiredDisassociateTrunkInterfaceRequestRequestTypeDef,
    _OptionalDisassociateTrunkInterfaceRequestRequestTypeDef,
):
    pass


DisassociateTrunkInterfaceResultOutputTypeDef = TypedDict(
    "DisassociateTrunkInterfaceResultOutputTypeDef",
    {
        "Return": bool,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateVpcCidrBlockRequestRequestTypeDef = TypedDict(
    "DisassociateVpcCidrBlockRequestRequestTypeDef",
    {
        "AssociationId": str,
    },
)

DiskImageDescriptionOutputTypeDef = TypedDict(
    "DiskImageDescriptionOutputTypeDef",
    {
        "Checksum": str,
        "Format": DiskImageFormatType,
        "ImportManifestUrl": str,
        "Size": int,
    },
)

DiskImageDetailTypeDef = TypedDict(
    "DiskImageDetailTypeDef",
    {
        "Bytes": int,
        "Format": DiskImageFormatType,
        "ImportManifestUrl": str,
    },
)

VolumeDetailTypeDef = TypedDict(
    "VolumeDetailTypeDef",
    {
        "Size": int,
    },
)

DiskImageVolumeDescriptionOutputTypeDef = TypedDict(
    "DiskImageVolumeDescriptionOutputTypeDef",
    {
        "Id": str,
        "Size": int,
    },
)

DiskInfoOutputTypeDef = TypedDict(
    "DiskInfoOutputTypeDef",
    {
        "SizeInGB": int,
        "Count": int,
        "Type": DiskTypeType,
    },
)

DnsEntryOutputTypeDef = TypedDict(
    "DnsEntryOutputTypeDef",
    {
        "DnsName": str,
        "HostedZoneId": str,
    },
)

DnsOptionsOutputTypeDef = TypedDict(
    "DnsOptionsOutputTypeDef",
    {
        "DnsRecordIpType": DnsRecordIpTypeType,
        "PrivateDnsOnlyForInboundResolverEndpoint": bool,
    },
)

DnsServersOptionsModifyStructureTypeDef = TypedDict(
    "DnsServersOptionsModifyStructureTypeDef",
    {
        "CustomDnsServers": Sequence[str],
        "Enabled": bool,
    },
    total=False,
)

EbsOptimizedInfoOutputTypeDef = TypedDict(
    "EbsOptimizedInfoOutputTypeDef",
    {
        "BaselineBandwidthInMbps": int,
        "BaselineThroughputInMBps": float,
        "BaselineIops": int,
        "MaximumBandwidthInMbps": int,
        "MaximumThroughputInMBps": float,
        "MaximumIops": int,
    },
)

EbsInstanceBlockDeviceOutputTypeDef = TypedDict(
    "EbsInstanceBlockDeviceOutputTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": AttachmentStatusType,
        "VolumeId": str,
    },
)

EbsInstanceBlockDeviceSpecificationTypeDef = TypedDict(
    "EbsInstanceBlockDeviceSpecificationTypeDef",
    {
        "DeleteOnTermination": bool,
        "VolumeId": str,
    },
    total=False,
)

EfaInfoOutputTypeDef = TypedDict(
    "EfaInfoOutputTypeDef",
    {
        "MaximumEfaInterfaces": int,
    },
)

InternetGatewayAttachmentOutputTypeDef = TypedDict(
    "InternetGatewayAttachmentOutputTypeDef",
    {
        "State": AttachmentStatusType,
        "VpcId": str,
    },
)

ElasticGpuAssociationOutputTypeDef = TypedDict(
    "ElasticGpuAssociationOutputTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
)

ElasticGpuHealthOutputTypeDef = TypedDict(
    "ElasticGpuHealthOutputTypeDef",
    {
        "Status": ElasticGpuStatusType,
    },
)

ElasticGpuSpecificationResponseOutputTypeDef = TypedDict(
    "ElasticGpuSpecificationResponseOutputTypeDef",
    {
        "Type": str,
    },
)

ElasticGpuSpecificationTypeDef = TypedDict(
    "ElasticGpuSpecificationTypeDef",
    {
        "Type": str,
    },
)

ElasticInferenceAcceleratorAssociationOutputTypeDef = TypedDict(
    "ElasticInferenceAcceleratorAssociationOutputTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
)

_RequiredElasticInferenceAcceleratorTypeDef = TypedDict(
    "_RequiredElasticInferenceAcceleratorTypeDef",
    {
        "Type": str,
    },
)
_OptionalElasticInferenceAcceleratorTypeDef = TypedDict(
    "_OptionalElasticInferenceAcceleratorTypeDef",
    {
        "Count": int,
    },
    total=False,
)


class ElasticInferenceAcceleratorTypeDef(
    _RequiredElasticInferenceAcceleratorTypeDef, _OptionalElasticInferenceAcceleratorTypeDef
):
    pass


EmptyResponseMetadataTypeDef = TypedDict(
    "EmptyResponseMetadataTypeDef",
    {
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnaSrdUdpSpecificationTypeDef = TypedDict(
    "EnaSrdUdpSpecificationTypeDef",
    {
        "EnaSrdUdpEnabled": bool,
    },
    total=False,
)

_RequiredEnableAddressTransferRequestRequestTypeDef = TypedDict(
    "_RequiredEnableAddressTransferRequestRequestTypeDef",
    {
        "AllocationId": str,
        "TransferAccountId": str,
    },
)
_OptionalEnableAddressTransferRequestRequestTypeDef = TypedDict(
    "_OptionalEnableAddressTransferRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableAddressTransferRequestRequestTypeDef(
    _RequiredEnableAddressTransferRequestRequestTypeDef,
    _OptionalEnableAddressTransferRequestRequestTypeDef,
):
    pass


EnableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef = TypedDict(
    "EnableAwsNetworkPerformanceMetricSubscriptionRequestRequestTypeDef",
    {
        "Source": str,
        "Destination": str,
        "Metric": Literal["aggregate-latency"],
        "Statistic": Literal["p50"],
        "DryRun": bool,
    },
    total=False,
)

EnableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef = TypedDict(
    "EnableAwsNetworkPerformanceMetricSubscriptionResultOutputTypeDef",
    {
        "Output": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableEbsEncryptionByDefaultRequestRequestTypeDef = TypedDict(
    "EnableEbsEncryptionByDefaultRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

EnableEbsEncryptionByDefaultResultOutputTypeDef = TypedDict(
    "EnableEbsEncryptionByDefaultResultOutputTypeDef",
    {
        "EbsEncryptionByDefault": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredFastLaunchLaunchTemplateSpecificationRequestTypeDef = TypedDict(
    "_RequiredFastLaunchLaunchTemplateSpecificationRequestTypeDef",
    {
        "Version": str,
    },
)
_OptionalFastLaunchLaunchTemplateSpecificationRequestTypeDef = TypedDict(
    "_OptionalFastLaunchLaunchTemplateSpecificationRequestTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
    },
    total=False,
)


class FastLaunchLaunchTemplateSpecificationRequestTypeDef(
    _RequiredFastLaunchLaunchTemplateSpecificationRequestTypeDef,
    _OptionalFastLaunchLaunchTemplateSpecificationRequestTypeDef,
):
    pass


FastLaunchSnapshotConfigurationRequestTypeDef = TypedDict(
    "FastLaunchSnapshotConfigurationRequestTypeDef",
    {
        "TargetResourceCount": int,
    },
    total=False,
)

EnableFastSnapshotRestoreStateErrorOutputTypeDef = TypedDict(
    "EnableFastSnapshotRestoreStateErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

EnableFastSnapshotRestoreSuccessItemOutputTypeDef = TypedDict(
    "EnableFastSnapshotRestoreSuccessItemOutputTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": FastSnapshotRestoreStateCodeType,
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
)

_RequiredEnableFastSnapshotRestoresRequestRequestTypeDef = TypedDict(
    "_RequiredEnableFastSnapshotRestoresRequestRequestTypeDef",
    {
        "AvailabilityZones": Sequence[str],
        "SourceSnapshotIds": Sequence[str],
    },
)
_OptionalEnableFastSnapshotRestoresRequestRequestTypeDef = TypedDict(
    "_OptionalEnableFastSnapshotRestoresRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableFastSnapshotRestoresRequestRequestTypeDef(
    _RequiredEnableFastSnapshotRestoresRequestRequestTypeDef,
    _OptionalEnableFastSnapshotRestoresRequestRequestTypeDef,
):
    pass


_RequiredEnableImageDeprecationRequestRequestTypeDef = TypedDict(
    "_RequiredEnableImageDeprecationRequestRequestTypeDef",
    {
        "ImageId": str,
        "DeprecateAt": Union[datetime, str],
    },
)
_OptionalEnableImageDeprecationRequestRequestTypeDef = TypedDict(
    "_OptionalEnableImageDeprecationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableImageDeprecationRequestRequestTypeDef(
    _RequiredEnableImageDeprecationRequestRequestTypeDef,
    _OptionalEnableImageDeprecationRequestRequestTypeDef,
):
    pass


EnableImageDeprecationResultOutputTypeDef = TypedDict(
    "EnableImageDeprecationResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredEnableIpamOrganizationAdminAccountRequestRequestTypeDef = TypedDict(
    "_RequiredEnableIpamOrganizationAdminAccountRequestRequestTypeDef",
    {
        "DelegatedAdminAccountId": str,
    },
)
_OptionalEnableIpamOrganizationAdminAccountRequestRequestTypeDef = TypedDict(
    "_OptionalEnableIpamOrganizationAdminAccountRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableIpamOrganizationAdminAccountRequestRequestTypeDef(
    _RequiredEnableIpamOrganizationAdminAccountRequestRequestTypeDef,
    _OptionalEnableIpamOrganizationAdminAccountRequestRequestTypeDef,
):
    pass


EnableIpamOrganizationAdminAccountResultOutputTypeDef = TypedDict(
    "EnableIpamOrganizationAdminAccountResultOutputTypeDef",
    {
        "Success": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableReachabilityAnalyzerOrganizationSharingRequestRequestTypeDef = TypedDict(
    "EnableReachabilityAnalyzerOrganizationSharingRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

EnableReachabilityAnalyzerOrganizationSharingResultOutputTypeDef = TypedDict(
    "EnableReachabilityAnalyzerOrganizationSharingResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableSerialConsoleAccessRequestRequestTypeDef = TypedDict(
    "EnableSerialConsoleAccessRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

EnableSerialConsoleAccessResultOutputTypeDef = TypedDict(
    "EnableSerialConsoleAccessResultOutputTypeDef",
    {
        "SerialConsoleAccessEnabled": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef = TypedDict(
    "_RequiredEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef = TypedDict(
    "_OptionalEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "DryRun": bool,
        "TransitGatewayRouteTableAnnouncementId": str,
    },
    total=False,
)


class EnableTransitGatewayRouteTablePropagationRequestRequestTypeDef(
    _RequiredEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef,
    _OptionalEnableTransitGatewayRouteTablePropagationRequestRequestTypeDef,
):
    pass


_RequiredEnableVgwRoutePropagationRequestRequestTypeDef = TypedDict(
    "_RequiredEnableVgwRoutePropagationRequestRequestTypeDef",
    {
        "GatewayId": str,
        "RouteTableId": str,
    },
)
_OptionalEnableVgwRoutePropagationRequestRequestTypeDef = TypedDict(
    "_OptionalEnableVgwRoutePropagationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableVgwRoutePropagationRequestRequestTypeDef(
    _RequiredEnableVgwRoutePropagationRequestRequestTypeDef,
    _OptionalEnableVgwRoutePropagationRequestRequestTypeDef,
):
    pass


_RequiredEnableVolumeIORequestRequestTypeDef = TypedDict(
    "_RequiredEnableVolumeIORequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalEnableVolumeIORequestRequestTypeDef = TypedDict(
    "_OptionalEnableVolumeIORequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableVolumeIORequestRequestTypeDef(
    _RequiredEnableVolumeIORequestRequestTypeDef, _OptionalEnableVolumeIORequestRequestTypeDef
):
    pass


EnableVolumeIORequestVolumeEnableIoTypeDef = TypedDict(
    "EnableVolumeIORequestVolumeEnableIoTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

EnableVpcClassicLinkDnsSupportRequestRequestTypeDef = TypedDict(
    "EnableVpcClassicLinkDnsSupportRequestRequestTypeDef",
    {
        "VpcId": str,
    },
    total=False,
)

EnableVpcClassicLinkDnsSupportResultOutputTypeDef = TypedDict(
    "EnableVpcClassicLinkDnsSupportResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredEnableVpcClassicLinkRequestRequestTypeDef = TypedDict(
    "_RequiredEnableVpcClassicLinkRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalEnableVpcClassicLinkRequestRequestTypeDef = TypedDict(
    "_OptionalEnableVpcClassicLinkRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class EnableVpcClassicLinkRequestRequestTypeDef(
    _RequiredEnableVpcClassicLinkRequestRequestTypeDef,
    _OptionalEnableVpcClassicLinkRequestRequestTypeDef,
):
    pass


EnableVpcClassicLinkRequestVpcEnableClassicLinkTypeDef = TypedDict(
    "EnableVpcClassicLinkRequestVpcEnableClassicLinkTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

EnableVpcClassicLinkResultOutputTypeDef = TypedDict(
    "EnableVpcClassicLinkResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnclaveOptionsOutputTypeDef = TypedDict(
    "EnclaveOptionsOutputTypeDef",
    {
        "Enabled": bool,
    },
)

EnclaveOptionsRequestTypeDef = TypedDict(
    "EnclaveOptionsRequestTypeDef",
    {
        "Enabled": bool,
    },
    total=False,
)

EnclaveOptionsResponseMetadataTypeDef = TypedDict(
    "EnclaveOptionsResponseMetadataTypeDef",
    {
        "Enabled": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EventInformationOutputTypeDef = TypedDict(
    "EventInformationOutputTypeDef",
    {
        "EventDescription": str,
        "EventSubType": str,
        "InstanceId": str,
    },
)

TransitGatewayRouteTableRouteOutputTypeDef = TypedDict(
    "TransitGatewayRouteTableRouteOutputTypeDef",
    {
        "DestinationCidr": str,
        "State": str,
        "RouteOrigin": str,
        "PrefixListId": str,
        "AttachmentId": str,
        "ResourceId": str,
        "ResourceType": str,
    },
)

_RequiredExportClientVpnClientCertificateRevocationListRequestRequestTypeDef = TypedDict(
    "_RequiredExportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalExportClientVpnClientCertificateRevocationListRequestRequestTypeDef = TypedDict(
    "_OptionalExportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ExportClientVpnClientCertificateRevocationListRequestRequestTypeDef(
    _RequiredExportClientVpnClientCertificateRevocationListRequestRequestTypeDef,
    _OptionalExportClientVpnClientCertificateRevocationListRequestRequestTypeDef,
):
    pass


_RequiredExportClientVpnClientConfigurationRequestRequestTypeDef = TypedDict(
    "_RequiredExportClientVpnClientConfigurationRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalExportClientVpnClientConfigurationRequestRequestTypeDef = TypedDict(
    "_OptionalExportClientVpnClientConfigurationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ExportClientVpnClientConfigurationRequestRequestTypeDef(
    _RequiredExportClientVpnClientConfigurationRequestRequestTypeDef,
    _OptionalExportClientVpnClientConfigurationRequestRequestTypeDef,
):
    pass


ExportClientVpnClientConfigurationResultOutputTypeDef = TypedDict(
    "ExportClientVpnClientConfigurationResultOutputTypeDef",
    {
        "ClientConfiguration": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredExportTaskS3LocationRequestTypeDef = TypedDict(
    "_RequiredExportTaskS3LocationRequestTypeDef",
    {
        "S3Bucket": str,
    },
)
_OptionalExportTaskS3LocationRequestTypeDef = TypedDict(
    "_OptionalExportTaskS3LocationRequestTypeDef",
    {
        "S3Prefix": str,
    },
    total=False,
)


class ExportTaskS3LocationRequestTypeDef(
    _RequiredExportTaskS3LocationRequestTypeDef, _OptionalExportTaskS3LocationRequestTypeDef
):
    pass


ExportTaskS3LocationOutputTypeDef = TypedDict(
    "ExportTaskS3LocationOutputTypeDef",
    {
        "S3Bucket": str,
        "S3Prefix": str,
    },
)

ExportToS3TaskOutputTypeDef = TypedDict(
    "ExportToS3TaskOutputTypeDef",
    {
        "ContainerFormat": Literal["ova"],
        "DiskImageFormat": DiskImageFormatType,
        "S3Bucket": str,
        "S3Key": str,
    },
)

InstanceExportDetailsOutputTypeDef = TypedDict(
    "InstanceExportDetailsOutputTypeDef",
    {
        "InstanceId": str,
        "TargetEnvironment": ExportEnvironmentType,
    },
)

ExportTransitGatewayRoutesResultOutputTypeDef = TypedDict(
    "ExportTransitGatewayRoutesResultOutputTypeDef",
    {
        "S3Location": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

FilterPortRangeOutputTypeDef = TypedDict(
    "FilterPortRangeOutputTypeDef",
    {
        "FromPort": int,
        "ToPort": int,
    },
)

TargetCapacitySpecificationOutputTypeDef = TypedDict(
    "TargetCapacitySpecificationOutputTypeDef",
    {
        "TotalTargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": DefaultTargetCapacityTypeType,
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
    },
)

FleetLaunchTemplateSpecificationOutputTypeDef = TypedDict(
    "FleetLaunchTemplateSpecificationOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Version": str,
    },
)

FleetLaunchTemplateSpecificationRequestTypeDef = TypedDict(
    "FleetLaunchTemplateSpecificationRequestTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Version": str,
    },
    total=False,
)

PlacementResponseOutputTypeDef = TypedDict(
    "PlacementResponseOutputTypeDef",
    {
        "GroupName": str,
    },
)

PlacementTypeDef = TypedDict(
    "PlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": TenancyType,
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
        "GroupId": str,
    },
    total=False,
)

FleetLaunchTemplateSpecificationTypeDef = TypedDict(
    "FleetLaunchTemplateSpecificationTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Version": str,
    },
    total=False,
)

FleetSpotCapacityRebalanceOutputTypeDef = TypedDict(
    "FleetSpotCapacityRebalanceOutputTypeDef",
    {
        "ReplacementStrategy": FleetReplacementStrategyType,
        "TerminationDelay": int,
    },
)

FleetSpotCapacityRebalanceRequestTypeDef = TypedDict(
    "FleetSpotCapacityRebalanceRequestTypeDef",
    {
        "ReplacementStrategy": FleetReplacementStrategyType,
        "TerminationDelay": int,
    },
    total=False,
)

FpgaDeviceMemoryInfoOutputTypeDef = TypedDict(
    "FpgaDeviceMemoryInfoOutputTypeDef",
    {
        "SizeInMiB": int,
    },
)

LoadPermissionOutputTypeDef = TypedDict(
    "LoadPermissionOutputTypeDef",
    {
        "UserId": str,
        "Group": Literal["all"],
    },
)

FpgaImageStateOutputTypeDef = TypedDict(
    "FpgaImageStateOutputTypeDef",
    {
        "Code": FpgaImageStateCodeType,
        "Message": str,
    },
)

PciIdOutputTypeDef = TypedDict(
    "PciIdOutputTypeDef",
    {
        "DeviceId": str,
        "VendorId": str,
        "SubsystemId": str,
        "SubsystemVendorId": str,
    },
)

_RequiredGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef = TypedDict(
    "_RequiredGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef",
    {
        "CertificateArn": str,
    },
)
_OptionalGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef = TypedDict(
    "_OptionalGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef(
    _RequiredGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef,
    _OptionalGetAssociatedEnclaveCertificateIamRolesRequestRequestTypeDef,
):
    pass


_RequiredGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef = TypedDict(
    "_RequiredGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef",
    {
        "PoolId": str,
    },
)
_OptionalGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef = TypedDict(
    "_OptionalGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef(
    _RequiredGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef,
    _OptionalGetAssociatedIpv6PoolCidrsRequestGetAssociatedIpv6PoolCidrsPaginateTypeDef,
):
    pass


_RequiredGetAssociatedIpv6PoolCidrsRequestRequestTypeDef = TypedDict(
    "_RequiredGetAssociatedIpv6PoolCidrsRequestRequestTypeDef",
    {
        "PoolId": str,
    },
)
_OptionalGetAssociatedIpv6PoolCidrsRequestRequestTypeDef = TypedDict(
    "_OptionalGetAssociatedIpv6PoolCidrsRequestRequestTypeDef",
    {
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)


class GetAssociatedIpv6PoolCidrsRequestRequestTypeDef(
    _RequiredGetAssociatedIpv6PoolCidrsRequestRequestTypeDef,
    _OptionalGetAssociatedIpv6PoolCidrsRequestRequestTypeDef,
):
    pass


Ipv6CidrAssociationOutputTypeDef = TypedDict(
    "Ipv6CidrAssociationOutputTypeDef",
    {
        "Ipv6Cidr": str,
        "AssociatedResource": str,
    },
)

_RequiredGetCapacityReservationUsageRequestRequestTypeDef = TypedDict(
    "_RequiredGetCapacityReservationUsageRequestRequestTypeDef",
    {
        "CapacityReservationId": str,
    },
)
_OptionalGetCapacityReservationUsageRequestRequestTypeDef = TypedDict(
    "_OptionalGetCapacityReservationUsageRequestRequestTypeDef",
    {
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)


class GetCapacityReservationUsageRequestRequestTypeDef(
    _RequiredGetCapacityReservationUsageRequestRequestTypeDef,
    _OptionalGetCapacityReservationUsageRequestRequestTypeDef,
):
    pass


InstanceUsageOutputTypeDef = TypedDict(
    "InstanceUsageOutputTypeDef",
    {
        "AccountId": str,
        "UsedInstanceCount": int,
    },
)

GetConsoleOutputRequestInstanceConsoleOutputTypeDef = TypedDict(
    "GetConsoleOutputRequestInstanceConsoleOutputTypeDef",
    {
        "DryRun": bool,
        "Latest": bool,
    },
    total=False,
)

_RequiredGetConsoleOutputRequestRequestTypeDef = TypedDict(
    "_RequiredGetConsoleOutputRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetConsoleOutputRequestRequestTypeDef = TypedDict(
    "_OptionalGetConsoleOutputRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Latest": bool,
    },
    total=False,
)


class GetConsoleOutputRequestRequestTypeDef(
    _RequiredGetConsoleOutputRequestRequestTypeDef, _OptionalGetConsoleOutputRequestRequestTypeDef
):
    pass


GetConsoleOutputResultOutputTypeDef = TypedDict(
    "GetConsoleOutputResultOutputTypeDef",
    {
        "InstanceId": str,
        "Output": str,
        "Timestamp": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetConsoleScreenshotRequestRequestTypeDef = TypedDict(
    "_RequiredGetConsoleScreenshotRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetConsoleScreenshotRequestRequestTypeDef = TypedDict(
    "_OptionalGetConsoleScreenshotRequestRequestTypeDef",
    {
        "DryRun": bool,
        "WakeUp": bool,
    },
    total=False,
)


class GetConsoleScreenshotRequestRequestTypeDef(
    _RequiredGetConsoleScreenshotRequestRequestTypeDef,
    _OptionalGetConsoleScreenshotRequestRequestTypeDef,
):
    pass


GetConsoleScreenshotResultOutputTypeDef = TypedDict(
    "GetConsoleScreenshotResultOutputTypeDef",
    {
        "ImageData": str,
        "InstanceId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetDefaultCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_RequiredGetDefaultCreditSpecificationRequestRequestTypeDef",
    {
        "InstanceFamily": UnlimitedSupportedInstanceFamilyType,
    },
)
_OptionalGetDefaultCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_OptionalGetDefaultCreditSpecificationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetDefaultCreditSpecificationRequestRequestTypeDef(
    _RequiredGetDefaultCreditSpecificationRequestRequestTypeDef,
    _OptionalGetDefaultCreditSpecificationRequestRequestTypeDef,
):
    pass


InstanceFamilyCreditSpecificationOutputTypeDef = TypedDict(
    "InstanceFamilyCreditSpecificationOutputTypeDef",
    {
        "InstanceFamily": UnlimitedSupportedInstanceFamilyType,
        "CpuCredits": str,
    },
)

GetEbsDefaultKmsKeyIdRequestRequestTypeDef = TypedDict(
    "GetEbsDefaultKmsKeyIdRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

GetEbsDefaultKmsKeyIdResultOutputTypeDef = TypedDict(
    "GetEbsDefaultKmsKeyIdResultOutputTypeDef",
    {
        "KmsKeyId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetEbsEncryptionByDefaultRequestRequestTypeDef = TypedDict(
    "GetEbsEncryptionByDefaultRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

GetEbsEncryptionByDefaultResultOutputTypeDef = TypedDict(
    "GetEbsEncryptionByDefaultResultOutputTypeDef",
    {
        "EbsEncryptionByDefault": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetFlowLogsIntegrationTemplateResultOutputTypeDef = TypedDict(
    "GetFlowLogsIntegrationTemplateResultOutputTypeDef",
    {
        "Result": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef = TypedDict(
    "_RequiredGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef",
    {
        "CapacityReservationId": str,
    },
)
_OptionalGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef = TypedDict(
    "_OptionalGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef(
    _RequiredGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef,
    _OptionalGetGroupsForCapacityReservationRequestGetGroupsForCapacityReservationPaginateTypeDef,
):
    pass


_RequiredGetGroupsForCapacityReservationRequestRequestTypeDef = TypedDict(
    "_RequiredGetGroupsForCapacityReservationRequestRequestTypeDef",
    {
        "CapacityReservationId": str,
    },
)
_OptionalGetGroupsForCapacityReservationRequestRequestTypeDef = TypedDict(
    "_OptionalGetGroupsForCapacityReservationRequestRequestTypeDef",
    {
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)


class GetGroupsForCapacityReservationRequestRequestTypeDef(
    _RequiredGetGroupsForCapacityReservationRequestRequestTypeDef,
    _OptionalGetGroupsForCapacityReservationRequestRequestTypeDef,
):
    pass


GetHostReservationPurchasePreviewRequestRequestTypeDef = TypedDict(
    "GetHostReservationPurchasePreviewRequestRequestTypeDef",
    {
        "HostIdSet": Sequence[str],
        "OfferingId": str,
    },
)

PurchaseOutputTypeDef = TypedDict(
    "PurchaseOutputTypeDef",
    {
        "CurrencyCode": Literal["USD"],
        "Duration": int,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "PaymentOption": PaymentOptionType,
        "UpfrontPrice": str,
    },
)

InstanceTypeInfoFromInstanceRequirementsOutputTypeDef = TypedDict(
    "InstanceTypeInfoFromInstanceRequirementsOutputTypeDef",
    {
        "InstanceType": str,
    },
)

_RequiredGetInstanceUefiDataRequestRequestTypeDef = TypedDict(
    "_RequiredGetInstanceUefiDataRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetInstanceUefiDataRequestRequestTypeDef = TypedDict(
    "_OptionalGetInstanceUefiDataRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetInstanceUefiDataRequestRequestTypeDef(
    _RequiredGetInstanceUefiDataRequestRequestTypeDef,
    _OptionalGetInstanceUefiDataRequestRequestTypeDef,
):
    pass


GetInstanceUefiDataResultOutputTypeDef = TypedDict(
    "GetInstanceUefiDataResultOutputTypeDef",
    {
        "InstanceId": str,
        "UefiData": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef = TypedDict(
    "_RequiredGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef",
    {
        "Cidr": str,
        "IpamScopeId": str,
    },
)
_OptionalGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef = TypedDict(
    "_OptionalGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef",
    {
        "DryRun": bool,
        "VpcId": str,
        "StartTime": Union[datetime, str],
        "EndTime": Union[datetime, str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef(
    _RequiredGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef,
    _OptionalGetIpamAddressHistoryRequestGetIpamAddressHistoryPaginateTypeDef,
):
    pass


_RequiredGetIpamAddressHistoryRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamAddressHistoryRequestRequestTypeDef",
    {
        "Cidr": str,
        "IpamScopeId": str,
    },
)
_OptionalGetIpamAddressHistoryRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamAddressHistoryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "VpcId": str,
        "StartTime": Union[datetime, str],
        "EndTime": Union[datetime, str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetIpamAddressHistoryRequestRequestTypeDef(
    _RequiredGetIpamAddressHistoryRequestRequestTypeDef,
    _OptionalGetIpamAddressHistoryRequestRequestTypeDef,
):
    pass


IpamAddressHistoryRecordOutputTypeDef = TypedDict(
    "IpamAddressHistoryRecordOutputTypeDef",
    {
        "ResourceOwnerId": str,
        "ResourceRegion": str,
        "ResourceType": IpamAddressHistoryResourceTypeType,
        "ResourceId": str,
        "ResourceCidr": str,
        "ResourceName": str,
        "ResourceComplianceStatus": IpamComplianceStatusType,
        "ResourceOverlapStatus": IpamOverlapStatusType,
        "VpcId": str,
        "SampledStartTime": datetime,
        "SampledEndTime": datetime,
    },
)

_RequiredGetLaunchTemplateDataRequestRequestTypeDef = TypedDict(
    "_RequiredGetLaunchTemplateDataRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetLaunchTemplateDataRequestRequestTypeDef = TypedDict(
    "_OptionalGetLaunchTemplateDataRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetLaunchTemplateDataRequestRequestTypeDef(
    _RequiredGetLaunchTemplateDataRequestRequestTypeDef,
    _OptionalGetLaunchTemplateDataRequestRequestTypeDef,
):
    pass


_RequiredGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef = TypedDict(
    "_RequiredGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef = TypedDict(
    "_OptionalGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef(
    _RequiredGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef,
    _OptionalGetManagedPrefixListAssociationsRequestGetManagedPrefixListAssociationsPaginateTypeDef,
):
    pass


_RequiredGetManagedPrefixListAssociationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetManagedPrefixListAssociationsRequestRequestTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalGetManagedPrefixListAssociationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetManagedPrefixListAssociationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetManagedPrefixListAssociationsRequestRequestTypeDef(
    _RequiredGetManagedPrefixListAssociationsRequestRequestTypeDef,
    _OptionalGetManagedPrefixListAssociationsRequestRequestTypeDef,
):
    pass


PrefixListAssociationOutputTypeDef = TypedDict(
    "PrefixListAssociationOutputTypeDef",
    {
        "ResourceId": str,
        "ResourceOwner": str,
    },
)

_RequiredGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef = TypedDict(
    "_RequiredGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef = TypedDict(
    "_OptionalGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef",
    {
        "DryRun": bool,
        "TargetVersion": int,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef(
    _RequiredGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef,
    _OptionalGetManagedPrefixListEntriesRequestGetManagedPrefixListEntriesPaginateTypeDef,
):
    pass


_RequiredGetManagedPrefixListEntriesRequestRequestTypeDef = TypedDict(
    "_RequiredGetManagedPrefixListEntriesRequestRequestTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalGetManagedPrefixListEntriesRequestRequestTypeDef = TypedDict(
    "_OptionalGetManagedPrefixListEntriesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TargetVersion": int,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetManagedPrefixListEntriesRequestRequestTypeDef(
    _RequiredGetManagedPrefixListEntriesRequestRequestTypeDef,
    _OptionalGetManagedPrefixListEntriesRequestRequestTypeDef,
):
    pass


PrefixListEntryOutputTypeDef = TypedDict(
    "PrefixListEntryOutputTypeDef",
    {
        "Cidr": str,
        "Description": str,
    },
)

_RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef = TypedDict(
    "_RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
    },
)
_OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef = TypedDict(
    "_OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef(
    _RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef,
    _OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestGetNetworkInsightsAccessScopeAnalysisFindingsPaginateTypeDef,
):
    pass


_RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef = TypedDict(
    "_RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
    },
)
_OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef = TypedDict(
    "_OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef",
    {
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef(
    _RequiredGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef,
    _OptionalGetNetworkInsightsAccessScopeAnalysisFindingsRequestRequestTypeDef,
):
    pass


_RequiredGetNetworkInsightsAccessScopeContentRequestRequestTypeDef = TypedDict(
    "_RequiredGetNetworkInsightsAccessScopeContentRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
    },
)
_OptionalGetNetworkInsightsAccessScopeContentRequestRequestTypeDef = TypedDict(
    "_OptionalGetNetworkInsightsAccessScopeContentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetNetworkInsightsAccessScopeContentRequestRequestTypeDef(
    _RequiredGetNetworkInsightsAccessScopeContentRequestRequestTypeDef,
    _OptionalGetNetworkInsightsAccessScopeContentRequestRequestTypeDef,
):
    pass


GetPasswordDataRequestInstancePasswordDataTypeDef = TypedDict(
    "GetPasswordDataRequestInstancePasswordDataTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredGetPasswordDataRequestRequestTypeDef = TypedDict(
    "_RequiredGetPasswordDataRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetPasswordDataRequestRequestTypeDef = TypedDict(
    "_OptionalGetPasswordDataRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetPasswordDataRequestRequestTypeDef(
    _RequiredGetPasswordDataRequestRequestTypeDef, _OptionalGetPasswordDataRequestRequestTypeDef
):
    pass


GetPasswordDataResultOutputTypeDef = TypedDict(
    "GetPasswordDataResultOutputTypeDef",
    {
        "InstanceId": str,
        "PasswordData": str,
        "Timestamp": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservationValueOutputTypeDef = TypedDict(
    "ReservationValueOutputTypeDef",
    {
        "HourlyPrice": str,
        "RemainingTotalValue": str,
        "RemainingUpfrontValue": str,
    },
)

GetSerialConsoleAccessStatusRequestRequestTypeDef = TypedDict(
    "GetSerialConsoleAccessStatusRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

GetSerialConsoleAccessStatusResultOutputTypeDef = TypedDict(
    "GetSerialConsoleAccessStatusResultOutputTypeDef",
    {
        "SerialConsoleAccessEnabled": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SpotPlacementScoreOutputTypeDef = TypedDict(
    "SpotPlacementScoreOutputTypeDef",
    {
        "Region": str,
        "AvailabilityZoneId": str,
        "Score": int,
    },
)

TransitGatewayAttachmentPropagationOutputTypeDef = TypedDict(
    "TransitGatewayAttachmentPropagationOutputTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": TransitGatewayPropagationStateType,
    },
)

TransitGatewayRouteTableAssociationOutputTypeDef = TypedDict(
    "TransitGatewayRouteTableAssociationOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "State": TransitGatewayAssociationStateType,
    },
)

TransitGatewayRouteTablePropagationOutputTypeDef = TypedDict(
    "TransitGatewayRouteTablePropagationOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "State": TransitGatewayPropagationStateType,
        "TransitGatewayRouteTableAnnouncementId": str,
    },
)

_RequiredGetVerifiedAccessEndpointPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredGetVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    {
        "VerifiedAccessEndpointId": str,
    },
)
_OptionalGetVerifiedAccessEndpointPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalGetVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetVerifiedAccessEndpointPolicyRequestRequestTypeDef(
    _RequiredGetVerifiedAccessEndpointPolicyRequestRequestTypeDef,
    _OptionalGetVerifiedAccessEndpointPolicyRequestRequestTypeDef,
):
    pass


GetVerifiedAccessEndpointPolicyResultOutputTypeDef = TypedDict(
    "GetVerifiedAccessEndpointPolicyResultOutputTypeDef",
    {
        "PolicyEnabled": bool,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetVerifiedAccessGroupPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredGetVerifiedAccessGroupPolicyRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
    },
)
_OptionalGetVerifiedAccessGroupPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalGetVerifiedAccessGroupPolicyRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetVerifiedAccessGroupPolicyRequestRequestTypeDef(
    _RequiredGetVerifiedAccessGroupPolicyRequestRequestTypeDef,
    _OptionalGetVerifiedAccessGroupPolicyRequestRequestTypeDef,
):
    pass


GetVerifiedAccessGroupPolicyResultOutputTypeDef = TypedDict(
    "GetVerifiedAccessGroupPolicyResultOutputTypeDef",
    {
        "PolicyEnabled": bool,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef = TypedDict(
    "_RequiredGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
        "VpnConnectionDeviceTypeId": str,
    },
)
_OptionalGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef = TypedDict(
    "_OptionalGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef",
    {
        "InternetKeyExchangeVersion": str,
        "DryRun": bool,
    },
    total=False,
)


class GetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef(
    _RequiredGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef,
    _OptionalGetVpnConnectionDeviceSampleConfigurationRequestRequestTypeDef,
):
    pass


GetVpnConnectionDeviceSampleConfigurationResultOutputTypeDef = TypedDict(
    "GetVpnConnectionDeviceSampleConfigurationResultOutputTypeDef",
    {
        "VpnConnectionDeviceSampleConfiguration": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetVpnConnectionDeviceTypesRequestGetVpnConnectionDeviceTypesPaginateTypeDef = TypedDict(
    "GetVpnConnectionDeviceTypesRequestGetVpnConnectionDeviceTypesPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

GetVpnConnectionDeviceTypesRequestRequestTypeDef = TypedDict(
    "GetVpnConnectionDeviceTypesRequestRequestTypeDef",
    {
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

VpnConnectionDeviceTypeOutputTypeDef = TypedDict(
    "VpnConnectionDeviceTypeOutputTypeDef",
    {
        "VpnConnectionDeviceTypeId": str,
        "Vendor": str,
        "Platform": str,
        "Software": str,
    },
)

_RequiredGetVpnTunnelReplacementStatusRequestRequestTypeDef = TypedDict(
    "_RequiredGetVpnTunnelReplacementStatusRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
        "VpnTunnelOutsideIpAddress": str,
    },
)
_OptionalGetVpnTunnelReplacementStatusRequestRequestTypeDef = TypedDict(
    "_OptionalGetVpnTunnelReplacementStatusRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetVpnTunnelReplacementStatusRequestRequestTypeDef(
    _RequiredGetVpnTunnelReplacementStatusRequestRequestTypeDef,
    _OptionalGetVpnTunnelReplacementStatusRequestRequestTypeDef,
):
    pass


MaintenanceDetailsOutputTypeDef = TypedDict(
    "MaintenanceDetailsOutputTypeDef",
    {
        "PendingMaintenance": str,
        "MaintenanceAutoAppliedAfter": datetime,
        "LastMaintenanceApplied": datetime,
    },
)

GpuDeviceMemoryInfoOutputTypeDef = TypedDict(
    "GpuDeviceMemoryInfoOutputTypeDef",
    {
        "SizeInMiB": int,
    },
)

GroupIdentifierTypeDef = TypedDict(
    "GroupIdentifierTypeDef",
    {
        "GroupName": str,
        "GroupId": str,
    },
    total=False,
)

HibernationOptionsOutputTypeDef = TypedDict(
    "HibernationOptionsOutputTypeDef",
    {
        "Configured": bool,
    },
)

HibernationOptionsRequestTypeDef = TypedDict(
    "HibernationOptionsRequestTypeDef",
    {
        "Configured": bool,
    },
    total=False,
)

HibernationOptionsResponseMetadataTypeDef = TypedDict(
    "HibernationOptionsResponseMetadataTypeDef",
    {
        "Configured": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

HostInstanceOutputTypeDef = TypedDict(
    "HostInstanceOutputTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "OwnerId": str,
    },
)

HostPropertiesOutputTypeDef = TypedDict(
    "HostPropertiesOutputTypeDef",
    {
        "Cores": int,
        "InstanceType": str,
        "InstanceFamily": str,
        "Sockets": int,
        "TotalVCpus": int,
    },
)

IKEVersionsListValueOutputTypeDef = TypedDict(
    "IKEVersionsListValueOutputTypeDef",
    {
        "Value": str,
    },
)

IKEVersionsRequestListValueTypeDef = TypedDict(
    "IKEVersionsRequestListValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

IamInstanceProfileOutputTypeDef = TypedDict(
    "IamInstanceProfileOutputTypeDef",
    {
        "Arn": str,
        "Id": str,
    },
)

IamInstanceProfileResponseMetadataTypeDef = TypedDict(
    "IamInstanceProfileResponseMetadataTypeDef",
    {
        "Arn": str,
        "Id": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

IamInstanceProfileSpecificationOutputTypeDef = TypedDict(
    "IamInstanceProfileSpecificationOutputTypeDef",
    {
        "Arn": str,
        "Name": str,
    },
)

IcmpTypeCodeOutputTypeDef = TypedDict(
    "IcmpTypeCodeOutputTypeDef",
    {
        "Code": int,
        "Type": int,
    },
)

LaunchPermissionOutputTypeDef = TypedDict(
    "LaunchPermissionOutputTypeDef",
    {
        "Group": Literal["all"],
        "UserId": str,
        "OrganizationArn": str,
        "OrganizationalUnitArn": str,
    },
)

UserBucketTypeDef = TypedDict(
    "UserBucketTypeDef",
    {
        "S3Bucket": str,
        "S3Key": str,
    },
    total=False,
)

StateReasonOutputTypeDef = TypedDict(
    "StateReasonOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

ImageRecycleBinInfoOutputTypeDef = TypedDict(
    "ImageRecycleBinInfoOutputTypeDef",
    {
        "ImageId": str,
        "Name": str,
        "Description": str,
        "RecycleBinEnterTime": datetime,
        "RecycleBinExitTime": datetime,
    },
)

_RequiredImportClientVpnClientCertificateRevocationListRequestRequestTypeDef = TypedDict(
    "_RequiredImportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "CertificateRevocationList": str,
    },
)
_OptionalImportClientVpnClientCertificateRevocationListRequestRequestTypeDef = TypedDict(
    "_OptionalImportClientVpnClientCertificateRevocationListRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ImportClientVpnClientCertificateRevocationListRequestRequestTypeDef(
    _RequiredImportClientVpnClientCertificateRevocationListRequestRequestTypeDef,
    _OptionalImportClientVpnClientCertificateRevocationListRequestRequestTypeDef,
):
    pass


ImportClientVpnClientCertificateRevocationListResultOutputTypeDef = TypedDict(
    "ImportClientVpnClientCertificateRevocationListResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportImageLicenseConfigurationRequestTypeDef = TypedDict(
    "ImportImageLicenseConfigurationRequestTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
    total=False,
)

ImportImageLicenseConfigurationResponseOutputTypeDef = TypedDict(
    "ImportImageLicenseConfigurationResponseOutputTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
)

UserDataTypeDef = TypedDict(
    "UserDataTypeDef",
    {
        "Data": str,
    },
    total=False,
)

InferenceDeviceInfoOutputTypeDef = TypedDict(
    "InferenceDeviceInfoOutputTypeDef",
    {
        "Count": int,
        "Name": str,
        "Manufacturer": str,
    },
)

InstanceCountOutputTypeDef = TypedDict(
    "InstanceCountOutputTypeDef",
    {
        "InstanceCount": int,
        "State": ListingStateType,
    },
)

_RequiredInstanceCreditSpecificationRequestTypeDef = TypedDict(
    "_RequiredInstanceCreditSpecificationRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalInstanceCreditSpecificationRequestTypeDef = TypedDict(
    "_OptionalInstanceCreditSpecificationRequestTypeDef",
    {
        "CpuCredits": str,
    },
    total=False,
)


class InstanceCreditSpecificationRequestTypeDef(
    _RequiredInstanceCreditSpecificationRequestTypeDef,
    _OptionalInstanceCreditSpecificationRequestTypeDef,
):
    pass


InstanceEventWindowTimeRangeOutputTypeDef = TypedDict(
    "InstanceEventWindowTimeRangeOutputTypeDef",
    {
        "StartWeekDay": WeekDayType,
        "StartHour": int,
        "EndWeekDay": WeekDayType,
        "EndHour": int,
    },
)

InstanceIpv4PrefixOutputTypeDef = TypedDict(
    "InstanceIpv4PrefixOutputTypeDef",
    {
        "Ipv4Prefix": str,
    },
)

InstanceIpv6AddressOutputTypeDef = TypedDict(
    "InstanceIpv6AddressOutputTypeDef",
    {
        "Ipv6Address": str,
    },
)

InstanceIpv6AddressRequestTypeDef = TypedDict(
    "InstanceIpv6AddressRequestTypeDef",
    {
        "Ipv6Address": str,
    },
    total=False,
)

InstanceIpv6PrefixOutputTypeDef = TypedDict(
    "InstanceIpv6PrefixOutputTypeDef",
    {
        "Ipv6Prefix": str,
    },
)

InstanceMaintenanceOptionsOutputTypeDef = TypedDict(
    "InstanceMaintenanceOptionsOutputTypeDef",
    {
        "AutoRecovery": InstanceAutoRecoveryStateType,
    },
)

InstanceMaintenanceOptionsRequestTypeDef = TypedDict(
    "InstanceMaintenanceOptionsRequestTypeDef",
    {
        "AutoRecovery": InstanceAutoRecoveryStateType,
    },
    total=False,
)

InstanceMaintenanceOptionsResponseMetadataTypeDef = TypedDict(
    "InstanceMaintenanceOptionsResponseMetadataTypeDef",
    {
        "AutoRecovery": InstanceAutoRecoveryStateType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SpotMarketOptionsTypeDef = TypedDict(
    "SpotMarketOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": SpotInstanceTypeType,
        "BlockDurationMinutes": int,
        "ValidUntil": Union[datetime, str],
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
    },
    total=False,
)

InstanceMetadataOptionsRequestTypeDef = TypedDict(
    "InstanceMetadataOptionsRequestTypeDef",
    {
        "HttpTokens": HttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": InstanceMetadataEndpointStateType,
        "HttpProtocolIpv6": InstanceMetadataProtocolStateType,
        "InstanceMetadataTags": InstanceMetadataTagsStateType,
    },
    total=False,
)

InstanceMetadataOptionsResponseOutputTypeDef = TypedDict(
    "InstanceMetadataOptionsResponseOutputTypeDef",
    {
        "State": InstanceMetadataOptionsStateType,
        "HttpTokens": HttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": InstanceMetadataEndpointStateType,
        "HttpProtocolIpv6": InstanceMetadataProtocolStateType,
        "InstanceMetadataTags": InstanceMetadataTagsStateType,
    },
)

InstanceMetadataOptionsResponseResponseMetadataTypeDef = TypedDict(
    "InstanceMetadataOptionsResponseResponseMetadataTypeDef",
    {
        "State": InstanceMetadataOptionsStateType,
        "HttpTokens": HttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": InstanceMetadataEndpointStateType,
        "HttpProtocolIpv6": InstanceMetadataProtocolStateType,
        "InstanceMetadataTags": InstanceMetadataTagsStateType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

MonitoringOutputTypeDef = TypedDict(
    "MonitoringOutputTypeDef",
    {
        "State": MonitoringStateType,
    },
)

InstanceNetworkInterfaceAssociationOutputTypeDef = TypedDict(
    "InstanceNetworkInterfaceAssociationOutputTypeDef",
    {
        "CarrierIp": str,
        "CustomerOwnedIp": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
)

InstanceNetworkInterfaceAttachmentOutputTypeDef = TypedDict(
    "InstanceNetworkInterfaceAttachmentOutputTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": AttachmentStatusType,
        "NetworkCardIndex": int,
    },
)

Ipv4PrefixSpecificationRequestOutputTypeDef = TypedDict(
    "Ipv4PrefixSpecificationRequestOutputTypeDef",
    {
        "Ipv4Prefix": str,
    },
)

Ipv6PrefixSpecificationRequestOutputTypeDef = TypedDict(
    "Ipv6PrefixSpecificationRequestOutputTypeDef",
    {
        "Ipv6Prefix": str,
    },
)

PrivateIpAddressSpecificationOutputTypeDef = TypedDict(
    "PrivateIpAddressSpecificationOutputTypeDef",
    {
        "Primary": bool,
        "PrivateIpAddress": str,
    },
)

InstanceStateOutputTypeDef = TypedDict(
    "InstanceStateOutputTypeDef",
    {
        "Code": int,
        "Name": InstanceStateNameType,
    },
)

LicenseConfigurationOutputTypeDef = TypedDict(
    "LicenseConfigurationOutputTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
)

PlacementOutputTypeDef = TypedDict(
    "PlacementOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": TenancyType,
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
        "GroupId": str,
    },
)

PrivateDnsNameOptionsResponseOutputTypeDef = TypedDict(
    "PrivateDnsNameOptionsResponseOutputTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
)

MemoryGiBPerVCpuOutputTypeDef = TypedDict(
    "MemoryGiBPerVCpuOutputTypeDef",
    {
        "Min": float,
        "Max": float,
    },
)

MemoryMiBOutputTypeDef = TypedDict(
    "MemoryMiBOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

NetworkBandwidthGbpsOutputTypeDef = TypedDict(
    "NetworkBandwidthGbpsOutputTypeDef",
    {
        "Min": float,
        "Max": float,
    },
)

NetworkInterfaceCountOutputTypeDef = TypedDict(
    "NetworkInterfaceCountOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

TotalLocalStorageGBOutputTypeDef = TypedDict(
    "TotalLocalStorageGBOutputTypeDef",
    {
        "Min": float,
        "Max": float,
    },
)

VCpuCountRangeOutputTypeDef = TypedDict(
    "VCpuCountRangeOutputTypeDef",
    {
        "Min": int,
        "Max": int,
    },
)

MemoryGiBPerVCpuRequestTypeDef = TypedDict(
    "MemoryGiBPerVCpuRequestTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

_RequiredMemoryMiBRequestTypeDef = TypedDict(
    "_RequiredMemoryMiBRequestTypeDef",
    {
        "Min": int,
    },
)
_OptionalMemoryMiBRequestTypeDef = TypedDict(
    "_OptionalMemoryMiBRequestTypeDef",
    {
        "Max": int,
    },
    total=False,
)


class MemoryMiBRequestTypeDef(_RequiredMemoryMiBRequestTypeDef, _OptionalMemoryMiBRequestTypeDef):
    pass


NetworkBandwidthGbpsRequestTypeDef = TypedDict(
    "NetworkBandwidthGbpsRequestTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

NetworkInterfaceCountRequestTypeDef = TypedDict(
    "NetworkInterfaceCountRequestTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

TotalLocalStorageGBRequestTypeDef = TypedDict(
    "TotalLocalStorageGBRequestTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

_RequiredVCpuCountRangeRequestTypeDef = TypedDict(
    "_RequiredVCpuCountRangeRequestTypeDef",
    {
        "Min": int,
    },
)
_OptionalVCpuCountRangeRequestTypeDef = TypedDict(
    "_OptionalVCpuCountRangeRequestTypeDef",
    {
        "Max": int,
    },
    total=False,
)


class VCpuCountRangeRequestTypeDef(
    _RequiredVCpuCountRangeRequestTypeDef, _OptionalVCpuCountRangeRequestTypeDef
):
    pass


MemoryGiBPerVCpuTypeDef = TypedDict(
    "MemoryGiBPerVCpuTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

MemoryMiBTypeDef = TypedDict(
    "MemoryMiBTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

NetworkBandwidthGbpsTypeDef = TypedDict(
    "NetworkBandwidthGbpsTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

NetworkInterfaceCountTypeDef = TypedDict(
    "NetworkInterfaceCountTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

TotalLocalStorageGBTypeDef = TypedDict(
    "TotalLocalStorageGBTypeDef",
    {
        "Min": float,
        "Max": float,
    },
    total=False,
)

VCpuCountRangeTypeDef = TypedDict(
    "VCpuCountRangeTypeDef",
    {
        "Min": int,
        "Max": int,
    },
    total=False,
)

InstanceStateResponseMetadataTypeDef = TypedDict(
    "InstanceStateResponseMetadataTypeDef",
    {
        "Code": int,
        "Name": InstanceStateNameType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceStatusDetailsOutputTypeDef = TypedDict(
    "InstanceStatusDetailsOutputTypeDef",
    {
        "ImpairedSince": datetime,
        "Name": Literal["reachability"],
        "Status": StatusTypeType,
    },
)

InstanceStatusEventOutputTypeDef = TypedDict(
    "InstanceStatusEventOutputTypeDef",
    {
        "InstanceEventId": str,
        "Code": EventCodeType,
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
)

MemoryInfoOutputTypeDef = TypedDict(
    "MemoryInfoOutputTypeDef",
    {
        "SizeInMiB": int,
    },
)

PlacementGroupInfoOutputTypeDef = TypedDict(
    "PlacementGroupInfoOutputTypeDef",
    {
        "SupportedStrategies": List[PlacementGroupStrategyType],
    },
)

ProcessorInfoOutputTypeDef = TypedDict(
    "ProcessorInfoOutputTypeDef",
    {
        "SupportedArchitectures": List[ArchitectureTypeType],
        "SustainedClockSpeedInGhz": float,
        "SupportedFeatures": List[Literal["amd-sev-snp"]],
    },
)

VCpuInfoOutputTypeDef = TypedDict(
    "VCpuInfoOutputTypeDef",
    {
        "DefaultVCpus": int,
        "DefaultCores": int,
        "DefaultThreadsPerCore": int,
        "ValidCores": List[int],
        "ValidThreadsPerCore": List[int],
    },
)

IpRangeOutputTypeDef = TypedDict(
    "IpRangeOutputTypeDef",
    {
        "CidrIp": str,
        "Description": str,
    },
)

Ipv6RangeOutputTypeDef = TypedDict(
    "Ipv6RangeOutputTypeDef",
    {
        "CidrIpv6": str,
        "Description": str,
    },
)

PrefixListIdOutputTypeDef = TypedDict(
    "PrefixListIdOutputTypeDef",
    {
        "Description": str,
        "PrefixListId": str,
    },
)

UserIdGroupPairOutputTypeDef = TypedDict(
    "UserIdGroupPairOutputTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
)

IpRangeTypeDef = TypedDict(
    "IpRangeTypeDef",
    {
        "CidrIp": str,
        "Description": str,
    },
    total=False,
)

Ipv6RangeTypeDef = TypedDict(
    "Ipv6RangeTypeDef",
    {
        "CidrIpv6": str,
        "Description": str,
    },
    total=False,
)

PrefixListIdTypeDef = TypedDict(
    "PrefixListIdTypeDef",
    {
        "Description": str,
        "PrefixListId": str,
    },
    total=False,
)

UserIdGroupPairTypeDef = TypedDict(
    "UserIdGroupPairTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)

IpamCidrAuthorizationContextTypeDef = TypedDict(
    "IpamCidrAuthorizationContextTypeDef",
    {
        "Message": str,
        "Signature": str,
    },
    total=False,
)

IpamDiscoveryFailureReasonOutputTypeDef = TypedDict(
    "IpamDiscoveryFailureReasonOutputTypeDef",
    {
        "Code": IpamDiscoveryFailureCodeType,
        "Message": str,
    },
)

IpamResourceTagOutputTypeDef = TypedDict(
    "IpamResourceTagOutputTypeDef",
    {
        "Key": str,
        "Value": str,
    },
)

IpamOperatingRegionOutputTypeDef = TypedDict(
    "IpamOperatingRegionOutputTypeDef",
    {
        "RegionName": str,
    },
)

IpamPoolCidrFailureReasonOutputTypeDef = TypedDict(
    "IpamPoolCidrFailureReasonOutputTypeDef",
    {
        "Code": IpamPoolCidrFailureCodeType,
        "Message": str,
    },
)

Ipv4PrefixSpecificationResponseOutputTypeDef = TypedDict(
    "Ipv4PrefixSpecificationResponseOutputTypeDef",
    {
        "Ipv4Prefix": str,
    },
)

Ipv6CidrBlockOutputTypeDef = TypedDict(
    "Ipv6CidrBlockOutputTypeDef",
    {
        "Ipv6CidrBlock": str,
    },
)

PoolCidrBlockOutputTypeDef = TypedDict(
    "PoolCidrBlockOutputTypeDef",
    {
        "Cidr": str,
    },
)

Ipv6PrefixSpecificationOutputTypeDef = TypedDict(
    "Ipv6PrefixSpecificationOutputTypeDef",
    {
        "Ipv6Prefix": str,
    },
)

Ipv6PrefixSpecificationResponseOutputTypeDef = TypedDict(
    "Ipv6PrefixSpecificationResponseOutputTypeDef",
    {
        "Ipv6Prefix": str,
    },
)

LastErrorOutputTypeDef = TypedDict(
    "LastErrorOutputTypeDef",
    {
        "Message": str,
        "Code": str,
    },
)

LaunchPermissionTypeDef = TypedDict(
    "LaunchPermissionTypeDef",
    {
        "Group": Literal["all"],
        "UserId": str,
        "OrganizationArn": str,
        "OrganizationalUnitArn": str,
    },
    total=False,
)

RunInstancesMonitoringEnabledOutputTypeDef = TypedDict(
    "RunInstancesMonitoringEnabledOutputTypeDef",
    {
        "Enabled": bool,
    },
)

SpotPlacementOutputTypeDef = TypedDict(
    "SpotPlacementOutputTypeDef",
    {
        "AvailabilityZone": str,
        "GroupName": str,
        "Tenancy": TenancyType,
    },
)

LaunchTemplateEbsBlockDeviceOutputTypeDef = TypedDict(
    "LaunchTemplateEbsBlockDeviceOutputTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": VolumeTypeType,
        "Throughput": int,
    },
)

LaunchTemplateEbsBlockDeviceRequestTypeDef = TypedDict(
    "LaunchTemplateEbsBlockDeviceRequestTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": VolumeTypeType,
        "Throughput": int,
    },
    total=False,
)

LaunchTemplateCpuOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateCpuOptionsOutputTypeDef",
    {
        "CoreCount": int,
        "ThreadsPerCore": int,
        "AmdSevSnp": AmdSevSnpSpecificationType,
    },
)

LaunchTemplateCpuOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateCpuOptionsRequestTypeDef",
    {
        "CoreCount": int,
        "ThreadsPerCore": int,
        "AmdSevSnp": AmdSevSnpSpecificationType,
    },
    total=False,
)

LaunchTemplateElasticInferenceAcceleratorResponseOutputTypeDef = TypedDict(
    "LaunchTemplateElasticInferenceAcceleratorResponseOutputTypeDef",
    {
        "Type": str,
        "Count": int,
    },
)

_RequiredLaunchTemplateElasticInferenceAcceleratorTypeDef = TypedDict(
    "_RequiredLaunchTemplateElasticInferenceAcceleratorTypeDef",
    {
        "Type": str,
    },
)
_OptionalLaunchTemplateElasticInferenceAcceleratorTypeDef = TypedDict(
    "_OptionalLaunchTemplateElasticInferenceAcceleratorTypeDef",
    {
        "Count": int,
    },
    total=False,
)


class LaunchTemplateElasticInferenceAcceleratorTypeDef(
    _RequiredLaunchTemplateElasticInferenceAcceleratorTypeDef,
    _OptionalLaunchTemplateElasticInferenceAcceleratorTypeDef,
):
    pass


LaunchTemplateEnclaveOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateEnclaveOptionsOutputTypeDef",
    {
        "Enabled": bool,
    },
)

LaunchTemplateEnclaveOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateEnclaveOptionsRequestTypeDef",
    {
        "Enabled": bool,
    },
    total=False,
)

LaunchTemplateHibernationOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateHibernationOptionsOutputTypeDef",
    {
        "Configured": bool,
    },
)

LaunchTemplateHibernationOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateHibernationOptionsRequestTypeDef",
    {
        "Configured": bool,
    },
    total=False,
)

LaunchTemplateIamInstanceProfileSpecificationOutputTypeDef = TypedDict(
    "LaunchTemplateIamInstanceProfileSpecificationOutputTypeDef",
    {
        "Arn": str,
        "Name": str,
    },
)

LaunchTemplateIamInstanceProfileSpecificationRequestTypeDef = TypedDict(
    "LaunchTemplateIamInstanceProfileSpecificationRequestTypeDef",
    {
        "Arn": str,
        "Name": str,
    },
    total=False,
)

LaunchTemplateInstanceMaintenanceOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateInstanceMaintenanceOptionsOutputTypeDef",
    {
        "AutoRecovery": LaunchTemplateAutoRecoveryStateType,
    },
)

LaunchTemplateInstanceMaintenanceOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateInstanceMaintenanceOptionsRequestTypeDef",
    {
        "AutoRecovery": LaunchTemplateAutoRecoveryStateType,
    },
    total=False,
)

LaunchTemplateSpotMarketOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateSpotMarketOptionsOutputTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": SpotInstanceTypeType,
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
    },
)

LaunchTemplateSpotMarketOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateSpotMarketOptionsRequestTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": SpotInstanceTypeType,
        "BlockDurationMinutes": int,
        "ValidUntil": Union[datetime, str],
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
    },
    total=False,
)

LaunchTemplateInstanceMetadataOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateInstanceMetadataOptionsOutputTypeDef",
    {
        "State": LaunchTemplateInstanceMetadataOptionsStateType,
        "HttpTokens": LaunchTemplateHttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": LaunchTemplateInstanceMetadataEndpointStateType,
        "HttpProtocolIpv6": LaunchTemplateInstanceMetadataProtocolIpv6Type,
        "InstanceMetadataTags": LaunchTemplateInstanceMetadataTagsStateType,
    },
)

LaunchTemplateInstanceMetadataOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateInstanceMetadataOptionsRequestTypeDef",
    {
        "HttpTokens": LaunchTemplateHttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": LaunchTemplateInstanceMetadataEndpointStateType,
        "HttpProtocolIpv6": LaunchTemplateInstanceMetadataProtocolIpv6Type,
        "InstanceMetadataTags": LaunchTemplateInstanceMetadataTagsStateType,
    },
    total=False,
)

LaunchTemplateLicenseConfigurationOutputTypeDef = TypedDict(
    "LaunchTemplateLicenseConfigurationOutputTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
)

LaunchTemplateLicenseConfigurationRequestTypeDef = TypedDict(
    "LaunchTemplateLicenseConfigurationRequestTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
    total=False,
)

LaunchTemplatePlacementOutputTypeDef = TypedDict(
    "LaunchTemplatePlacementOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": TenancyType,
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
        "PartitionNumber": int,
        "GroupId": str,
    },
)

LaunchTemplatePlacementRequestTypeDef = TypedDict(
    "LaunchTemplatePlacementRequestTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": TenancyType,
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
        "PartitionNumber": int,
        "GroupId": str,
    },
    total=False,
)

LaunchTemplatePrivateDnsNameOptionsOutputTypeDef = TypedDict(
    "LaunchTemplatePrivateDnsNameOptionsOutputTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
)

LaunchTemplatePrivateDnsNameOptionsRequestTypeDef = TypedDict(
    "LaunchTemplatePrivateDnsNameOptionsRequestTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
    total=False,
)

LaunchTemplateSpecificationTypeDef = TypedDict(
    "LaunchTemplateSpecificationTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Version": str,
    },
    total=False,
)

LaunchTemplatesMonitoringOutputTypeDef = TypedDict(
    "LaunchTemplatesMonitoringOutputTypeDef",
    {
        "Enabled": bool,
    },
)

LaunchTemplatesMonitoringRequestTypeDef = TypedDict(
    "LaunchTemplatesMonitoringRequestTypeDef",
    {
        "Enabled": bool,
    },
    total=False,
)

LicenseConfigurationRequestTypeDef = TypedDict(
    "LicenseConfigurationRequestTypeDef",
    {
        "LicenseConfigurationArn": str,
    },
    total=False,
)

ListImagesInRecycleBinRequestListImagesInRecycleBinPaginateTypeDef = TypedDict(
    "ListImagesInRecycleBinRequestListImagesInRecycleBinPaginateTypeDef",
    {
        "ImageIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListImagesInRecycleBinRequestRequestTypeDef = TypedDict(
    "ListImagesInRecycleBinRequestRequestTypeDef",
    {
        "ImageIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)

ListSnapshotsInRecycleBinRequestListSnapshotsInRecycleBinPaginateTypeDef = TypedDict(
    "ListSnapshotsInRecycleBinRequestListSnapshotsInRecycleBinPaginateTypeDef",
    {
        "SnapshotIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

ListSnapshotsInRecycleBinRequestRequestTypeDef = TypedDict(
    "ListSnapshotsInRecycleBinRequestRequestTypeDef",
    {
        "MaxResults": int,
        "NextToken": str,
        "SnapshotIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

SnapshotRecycleBinInfoOutputTypeDef = TypedDict(
    "SnapshotRecycleBinInfoOutputTypeDef",
    {
        "SnapshotId": str,
        "RecycleBinEnterTime": datetime,
        "RecycleBinExitTime": datetime,
        "Description": str,
        "VolumeId": str,
    },
)

LoadPermissionRequestTypeDef = TypedDict(
    "LoadPermissionRequestTypeDef",
    {
        "Group": Literal["all"],
        "UserId": str,
    },
    total=False,
)

_RequiredModifyAddressAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyAddressAttributeRequestRequestTypeDef",
    {
        "AllocationId": str,
    },
)
_OptionalModifyAddressAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyAddressAttributeRequestRequestTypeDef",
    {
        "DomainName": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyAddressAttributeRequestRequestTypeDef(
    _RequiredModifyAddressAttributeRequestRequestTypeDef,
    _OptionalModifyAddressAttributeRequestRequestTypeDef,
):
    pass


_RequiredModifyAvailabilityZoneGroupRequestRequestTypeDef = TypedDict(
    "_RequiredModifyAvailabilityZoneGroupRequestRequestTypeDef",
    {
        "GroupName": str,
        "OptInStatus": ModifyAvailabilityZoneOptInStatusType,
    },
)
_OptionalModifyAvailabilityZoneGroupRequestRequestTypeDef = TypedDict(
    "_OptionalModifyAvailabilityZoneGroupRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyAvailabilityZoneGroupRequestRequestTypeDef(
    _RequiredModifyAvailabilityZoneGroupRequestRequestTypeDef,
    _OptionalModifyAvailabilityZoneGroupRequestRequestTypeDef,
):
    pass


ModifyAvailabilityZoneGroupResultOutputTypeDef = TypedDict(
    "ModifyAvailabilityZoneGroupResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyCapacityReservationFleetRequestRequestTypeDef = TypedDict(
    "_RequiredModifyCapacityReservationFleetRequestRequestTypeDef",
    {
        "CapacityReservationFleetId": str,
    },
)
_OptionalModifyCapacityReservationFleetRequestRequestTypeDef = TypedDict(
    "_OptionalModifyCapacityReservationFleetRequestRequestTypeDef",
    {
        "TotalTargetCapacity": int,
        "EndDate": Union[datetime, str],
        "DryRun": bool,
        "RemoveEndDate": bool,
    },
    total=False,
)


class ModifyCapacityReservationFleetRequestRequestTypeDef(
    _RequiredModifyCapacityReservationFleetRequestRequestTypeDef,
    _OptionalModifyCapacityReservationFleetRequestRequestTypeDef,
):
    pass


ModifyCapacityReservationFleetResultOutputTypeDef = TypedDict(
    "ModifyCapacityReservationFleetResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyCapacityReservationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyCapacityReservationRequestRequestTypeDef",
    {
        "CapacityReservationId": str,
    },
)
_OptionalModifyCapacityReservationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyCapacityReservationRequestRequestTypeDef",
    {
        "InstanceCount": int,
        "EndDate": Union[datetime, str],
        "EndDateType": EndDateTypeType,
        "Accept": bool,
        "DryRun": bool,
        "AdditionalInfo": str,
    },
    total=False,
)


class ModifyCapacityReservationRequestRequestTypeDef(
    _RequiredModifyCapacityReservationRequestRequestTypeDef,
    _OptionalModifyCapacityReservationRequestRequestTypeDef,
):
    pass


ModifyCapacityReservationResultOutputTypeDef = TypedDict(
    "ModifyCapacityReservationResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyClientVpnEndpointResultOutputTypeDef = TypedDict(
    "ModifyClientVpnEndpointResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyDefaultCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyDefaultCreditSpecificationRequestRequestTypeDef",
    {
        "InstanceFamily": UnlimitedSupportedInstanceFamilyType,
        "CpuCredits": str,
    },
)
_OptionalModifyDefaultCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyDefaultCreditSpecificationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyDefaultCreditSpecificationRequestRequestTypeDef(
    _RequiredModifyDefaultCreditSpecificationRequestRequestTypeDef,
    _OptionalModifyDefaultCreditSpecificationRequestRequestTypeDef,
):
    pass


_RequiredModifyEbsDefaultKmsKeyIdRequestRequestTypeDef = TypedDict(
    "_RequiredModifyEbsDefaultKmsKeyIdRequestRequestTypeDef",
    {
        "KmsKeyId": str,
    },
)
_OptionalModifyEbsDefaultKmsKeyIdRequestRequestTypeDef = TypedDict(
    "_OptionalModifyEbsDefaultKmsKeyIdRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyEbsDefaultKmsKeyIdRequestRequestTypeDef(
    _RequiredModifyEbsDefaultKmsKeyIdRequestRequestTypeDef,
    _OptionalModifyEbsDefaultKmsKeyIdRequestRequestTypeDef,
):
    pass


ModifyEbsDefaultKmsKeyIdResultOutputTypeDef = TypedDict(
    "ModifyEbsDefaultKmsKeyIdResultOutputTypeDef",
    {
        "KmsKeyId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyFleetResultOutputTypeDef = TypedDict(
    "ModifyFleetResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyHostsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyHostsRequestRequestTypeDef",
    {
        "HostIds": Sequence[str],
    },
)
_OptionalModifyHostsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyHostsRequestRequestTypeDef",
    {
        "AutoPlacement": AutoPlacementType,
        "HostRecovery": HostRecoveryType,
        "InstanceType": str,
        "InstanceFamily": str,
        "HostMaintenance": HostMaintenanceType,
    },
    total=False,
)


class ModifyHostsRequestRequestTypeDef(
    _RequiredModifyHostsRequestRequestTypeDef, _OptionalModifyHostsRequestRequestTypeDef
):
    pass


ModifyIdFormatRequestRequestTypeDef = TypedDict(
    "ModifyIdFormatRequestRequestTypeDef",
    {
        "Resource": str,
        "UseLongIds": bool,
    },
)

ModifyIdentityIdFormatRequestRequestTypeDef = TypedDict(
    "ModifyIdentityIdFormatRequestRequestTypeDef",
    {
        "PrincipalArn": str,
        "Resource": str,
        "UseLongIds": bool,
    },
)

ModifyInstanceCapacityReservationAttributesResultOutputTypeDef = TypedDict(
    "ModifyInstanceCapacityReservationAttributesResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SuccessfulInstanceCreditSpecificationItemOutputTypeDef = TypedDict(
    "SuccessfulInstanceCreditSpecificationItemOutputTypeDef",
    {
        "InstanceId": str,
    },
)

_RequiredModifyInstanceEventStartTimeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceEventStartTimeRequestRequestTypeDef",
    {
        "InstanceId": str,
        "InstanceEventId": str,
        "NotBefore": Union[datetime, str],
    },
)
_OptionalModifyInstanceEventStartTimeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceEventStartTimeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyInstanceEventStartTimeRequestRequestTypeDef(
    _RequiredModifyInstanceEventStartTimeRequestRequestTypeDef,
    _OptionalModifyInstanceEventStartTimeRequestRequestTypeDef,
):
    pass


_RequiredModifyInstanceMaintenanceOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceMaintenanceOptionsRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalModifyInstanceMaintenanceOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceMaintenanceOptionsRequestRequestTypeDef",
    {
        "AutoRecovery": InstanceAutoRecoveryStateType,
        "DryRun": bool,
    },
    total=False,
)


class ModifyInstanceMaintenanceOptionsRequestRequestTypeDef(
    _RequiredModifyInstanceMaintenanceOptionsRequestRequestTypeDef,
    _OptionalModifyInstanceMaintenanceOptionsRequestRequestTypeDef,
):
    pass


ModifyInstanceMaintenanceOptionsResultOutputTypeDef = TypedDict(
    "ModifyInstanceMaintenanceOptionsResultOutputTypeDef",
    {
        "InstanceId": str,
        "AutoRecovery": InstanceAutoRecoveryStateType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyInstanceMetadataOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceMetadataOptionsRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalModifyInstanceMetadataOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceMetadataOptionsRequestRequestTypeDef",
    {
        "HttpTokens": HttpTokensStateType,
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": InstanceMetadataEndpointStateType,
        "DryRun": bool,
        "HttpProtocolIpv6": InstanceMetadataProtocolStateType,
        "InstanceMetadataTags": InstanceMetadataTagsStateType,
    },
    total=False,
)


class ModifyInstanceMetadataOptionsRequestRequestTypeDef(
    _RequiredModifyInstanceMetadataOptionsRequestRequestTypeDef,
    _OptionalModifyInstanceMetadataOptionsRequestRequestTypeDef,
):
    pass


_RequiredModifyInstancePlacementRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstancePlacementRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalModifyInstancePlacementRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstancePlacementRequestRequestTypeDef",
    {
        "Affinity": AffinityType,
        "GroupName": str,
        "HostId": str,
        "Tenancy": HostTenancyType,
        "PartitionNumber": int,
        "HostResourceGroupArn": str,
        "GroupId": str,
    },
    total=False,
)


class ModifyInstancePlacementRequestRequestTypeDef(
    _RequiredModifyInstancePlacementRequestRequestTypeDef,
    _OptionalModifyInstancePlacementRequestRequestTypeDef,
):
    pass


ModifyInstancePlacementResultOutputTypeDef = TypedDict(
    "ModifyInstancePlacementResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RemoveIpamOperatingRegionTypeDef = TypedDict(
    "RemoveIpamOperatingRegionTypeDef",
    {
        "RegionName": str,
    },
    total=False,
)

_RequiredModifyIpamResourceCidrRequestRequestTypeDef = TypedDict(
    "_RequiredModifyIpamResourceCidrRequestRequestTypeDef",
    {
        "ResourceId": str,
        "ResourceCidr": str,
        "ResourceRegion": str,
        "CurrentIpamScopeId": str,
        "Monitored": bool,
    },
)
_OptionalModifyIpamResourceCidrRequestRequestTypeDef = TypedDict(
    "_OptionalModifyIpamResourceCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
        "DestinationIpamScopeId": str,
    },
    total=False,
)


class ModifyIpamResourceCidrRequestRequestTypeDef(
    _RequiredModifyIpamResourceCidrRequestRequestTypeDef,
    _OptionalModifyIpamResourceCidrRequestRequestTypeDef,
):
    pass


_RequiredModifyIpamScopeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyIpamScopeRequestRequestTypeDef",
    {
        "IpamScopeId": str,
    },
)
_OptionalModifyIpamScopeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyIpamScopeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
    },
    total=False,
)


class ModifyIpamScopeRequestRequestTypeDef(
    _RequiredModifyIpamScopeRequestRequestTypeDef, _OptionalModifyIpamScopeRequestRequestTypeDef
):
    pass


ModifyLaunchTemplateRequestRequestTypeDef = TypedDict(
    "ModifyLaunchTemplateRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "DefaultVersion": str,
    },
    total=False,
)

_RequiredModifyLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredModifyLocalGatewayRouteRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalModifyLocalGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalModifyLocalGatewayRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "LocalGatewayVirtualInterfaceGroupId": str,
        "NetworkInterfaceId": str,
        "DryRun": bool,
        "DestinationPrefixListId": str,
    },
    total=False,
)


class ModifyLocalGatewayRouteRequestRequestTypeDef(
    _RequiredModifyLocalGatewayRouteRequestRequestTypeDef,
    _OptionalModifyLocalGatewayRouteRequestRequestTypeDef,
):
    pass


RemovePrefixListEntryTypeDef = TypedDict(
    "RemovePrefixListEntryTypeDef",
    {
        "Cidr": str,
    },
)

NetworkInterfaceAttachmentChangesTypeDef = TypedDict(
    "NetworkInterfaceAttachmentChangesTypeDef",
    {
        "AttachmentId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)

_RequiredModifyPrivateDnsNameOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyPrivateDnsNameOptionsRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalModifyPrivateDnsNameOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyPrivateDnsNameOptionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "PrivateDnsHostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
    total=False,
)


class ModifyPrivateDnsNameOptionsRequestRequestTypeDef(
    _RequiredModifyPrivateDnsNameOptionsRequestRequestTypeDef,
    _OptionalModifyPrivateDnsNameOptionsRequestRequestTypeDef,
):
    pass


ModifyPrivateDnsNameOptionsResultOutputTypeDef = TypedDict(
    "ModifyPrivateDnsNameOptionsResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservedInstancesConfigurationTypeDef = TypedDict(
    "ReservedInstancesConfigurationTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": InstanceTypeType,
        "Platform": str,
        "Scope": scopeType,
    },
    total=False,
)

ModifyReservedInstancesResultOutputTypeDef = TypedDict(
    "ModifyReservedInstancesResultOutputTypeDef",
    {
        "ReservedInstancesModificationId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifySecurityGroupRulesResultOutputTypeDef = TypedDict(
    "ModifySecurityGroupRulesResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifySnapshotTierRequestRequestTypeDef = TypedDict(
    "_RequiredModifySnapshotTierRequestRequestTypeDef",
    {
        "SnapshotId": str,
    },
)
_OptionalModifySnapshotTierRequestRequestTypeDef = TypedDict(
    "_OptionalModifySnapshotTierRequestRequestTypeDef",
    {
        "StorageTier": Literal["archive"],
        "DryRun": bool,
    },
    total=False,
)


class ModifySnapshotTierRequestRequestTypeDef(
    _RequiredModifySnapshotTierRequestRequestTypeDef,
    _OptionalModifySnapshotTierRequestRequestTypeDef,
):
    pass


ModifySnapshotTierResultOutputTypeDef = TypedDict(
    "ModifySnapshotTierResultOutputTypeDef",
    {
        "SnapshotId": str,
        "TieringStartTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifySpotFleetRequestResponseOutputTypeDef = TypedDict(
    "ModifySpotFleetRequestResponseOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef",
    {
        "TrafficMirrorFilterId": str,
    },
)
_OptionalModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef",
    {
        "AddNetworkServices": Sequence[Literal["amazon-dns"]],
        "RemoveNetworkServices": Sequence[Literal["amazon-dns"]],
        "DryRun": bool,
    },
    total=False,
)


class ModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef(
    _RequiredModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef,
    _OptionalModifyTrafficMirrorFilterNetworkServicesRequestRequestTypeDef,
):
    pass


_RequiredModifyTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTrafficMirrorSessionRequestRequestTypeDef",
    {
        "TrafficMirrorSessionId": str,
    },
)
_OptionalModifyTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTrafficMirrorSessionRequestRequestTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "RemoveFields": Sequence[TrafficMirrorSessionFieldType],
        "DryRun": bool,
    },
    total=False,
)


class ModifyTrafficMirrorSessionRequestRequestTypeDef(
    _RequiredModifyTrafficMirrorSessionRequestRequestTypeDef,
    _OptionalModifyTrafficMirrorSessionRequestRequestTypeDef,
):
    pass


ModifyTransitGatewayOptionsTypeDef = TypedDict(
    "ModifyTransitGatewayOptionsTypeDef",
    {
        "AddTransitGatewayCidrBlocks": Sequence[str],
        "RemoveTransitGatewayCidrBlocks": Sequence[str],
        "VpnEcmpSupport": VpnEcmpSupportValueType,
        "DnsSupport": DnsSupportValueType,
        "AutoAcceptSharedAttachments": AutoAcceptSharedAttachmentsValueType,
        "DefaultRouteTableAssociation": DefaultRouteTableAssociationValueType,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": DefaultRouteTablePropagationValueType,
        "PropagationDefaultRouteTableId": str,
        "AmazonSideAsn": int,
    },
    total=False,
)

_RequiredModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "PrefixListId": str,
    },
)
_OptionalModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "Blackhole": bool,
        "DryRun": bool,
    },
    total=False,
)


class ModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef(
    _RequiredModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef,
    _OptionalModifyTransitGatewayPrefixListReferenceRequestRequestTypeDef,
):
    pass


ModifyTransitGatewayVpcAttachmentRequestOptionsTypeDef = TypedDict(
    "ModifyTransitGatewayVpcAttachmentRequestOptionsTypeDef",
    {
        "DnsSupport": DnsSupportValueType,
        "Ipv6Support": Ipv6SupportValueType,
        "ApplianceModeSupport": ApplianceModeSupportValueType,
    },
    total=False,
)

ModifyVerifiedAccessEndpointEniOptionsTypeDef = TypedDict(
    "ModifyVerifiedAccessEndpointEniOptionsTypeDef",
    {
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
    },
    total=False,
)

ModifyVerifiedAccessEndpointLoadBalancerOptionsTypeDef = TypedDict(
    "ModifyVerifiedAccessEndpointLoadBalancerOptionsTypeDef",
    {
        "SubnetIds": Sequence[str],
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
    },
    total=False,
)

_RequiredModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    {
        "VerifiedAccessEndpointId": str,
        "PolicyEnabled": bool,
    },
)
_OptionalModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef",
    {
        "PolicyDocument": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessEndpointPolicyRequestRequestTypeDef,
):
    pass


ModifyVerifiedAccessEndpointPolicyResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessEndpointPolicyResultOutputTypeDef",
    {
        "PolicyEnabled": bool,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVerifiedAccessGroupPolicyRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessGroupPolicyRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
        "PolicyEnabled": bool,
    },
)
_OptionalModifyVerifiedAccessGroupPolicyRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessGroupPolicyRequestRequestTypeDef",
    {
        "PolicyDocument": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVerifiedAccessGroupPolicyRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessGroupPolicyRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessGroupPolicyRequestRequestTypeDef,
):
    pass


ModifyVerifiedAccessGroupPolicyResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessGroupPolicyResultOutputTypeDef",
    {
        "PolicyEnabled": bool,
        "PolicyDocument": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessGroupRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
    },
)
_OptionalModifyVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessGroupRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "Description": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVerifiedAccessGroupRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessGroupRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessGroupRequestRequestTypeDef,
):
    pass


_RequiredModifyVerifiedAccessInstanceRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessInstanceRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
    },
)
_OptionalModifyVerifiedAccessInstanceRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessInstanceRequestRequestTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class ModifyVerifiedAccessInstanceRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessInstanceRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessInstanceRequestRequestTypeDef,
):
    pass


ModifyVerifiedAccessTrustProviderOidcOptionsTypeDef = TypedDict(
    "ModifyVerifiedAccessTrustProviderOidcOptionsTypeDef",
    {
        "Issuer": str,
        "AuthorizationEndpoint": str,
        "TokenEndpoint": str,
        "UserInfoEndpoint": str,
        "ClientId": str,
        "ClientSecret": str,
        "Scope": str,
    },
    total=False,
)

_RequiredModifyVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVolumeRequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalModifyVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVolumeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Size": int,
        "VolumeType": VolumeTypeType,
        "Iops": int,
        "Throughput": int,
        "MultiAttachEnabled": bool,
    },
    total=False,
)


class ModifyVolumeRequestRequestTypeDef(
    _RequiredModifyVolumeRequestRequestTypeDef, _OptionalModifyVolumeRequestRequestTypeDef
):
    pass


_RequiredModifyVpcEndpointConnectionNotificationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcEndpointConnectionNotificationRequestRequestTypeDef",
    {
        "ConnectionNotificationId": str,
    },
)
_OptionalModifyVpcEndpointConnectionNotificationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcEndpointConnectionNotificationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": Sequence[str],
    },
    total=False,
)


class ModifyVpcEndpointConnectionNotificationRequestRequestTypeDef(
    _RequiredModifyVpcEndpointConnectionNotificationRequestRequestTypeDef,
    _OptionalModifyVpcEndpointConnectionNotificationRequestRequestTypeDef,
):
    pass


ModifyVpcEndpointConnectionNotificationResultOutputTypeDef = TypedDict(
    "ModifyVpcEndpointConnectionNotificationResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpcEndpointResultOutputTypeDef = TypedDict(
    "ModifyVpcEndpointResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVpcEndpointServiceConfigurationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcEndpointServiceConfigurationRequestRequestTypeDef",
    {
        "ServiceId": str,
    },
)
_OptionalModifyVpcEndpointServiceConfigurationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcEndpointServiceConfigurationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "PrivateDnsName": str,
        "RemovePrivateDnsName": bool,
        "AcceptanceRequired": bool,
        "AddNetworkLoadBalancerArns": Sequence[str],
        "RemoveNetworkLoadBalancerArns": Sequence[str],
        "AddGatewayLoadBalancerArns": Sequence[str],
        "RemoveGatewayLoadBalancerArns": Sequence[str],
        "AddSupportedIpAddressTypes": Sequence[str],
        "RemoveSupportedIpAddressTypes": Sequence[str],
    },
    total=False,
)


class ModifyVpcEndpointServiceConfigurationRequestRequestTypeDef(
    _RequiredModifyVpcEndpointServiceConfigurationRequestRequestTypeDef,
    _OptionalModifyVpcEndpointServiceConfigurationRequestRequestTypeDef,
):
    pass


ModifyVpcEndpointServiceConfigurationResultOutputTypeDef = TypedDict(
    "ModifyVpcEndpointServiceConfigurationResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef",
    {
        "ServiceId": str,
        "PayerResponsibility": Literal["ServiceOwner"],
    },
)
_OptionalModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef(
    _RequiredModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef,
    _OptionalModifyVpcEndpointServicePayerResponsibilityRequestRequestTypeDef,
):
    pass


ModifyVpcEndpointServicePayerResponsibilityResultOutputTypeDef = TypedDict(
    "ModifyVpcEndpointServicePayerResponsibilityResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVpcEndpointServicePermissionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcEndpointServicePermissionsRequestRequestTypeDef",
    {
        "ServiceId": str,
    },
)
_OptionalModifyVpcEndpointServicePermissionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcEndpointServicePermissionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "AddAllowedPrincipals": Sequence[str],
        "RemoveAllowedPrincipals": Sequence[str],
    },
    total=False,
)


class ModifyVpcEndpointServicePermissionsRequestRequestTypeDef(
    _RequiredModifyVpcEndpointServicePermissionsRequestRequestTypeDef,
    _OptionalModifyVpcEndpointServicePermissionsRequestRequestTypeDef,
):
    pass


PeeringConnectionOptionsRequestTypeDef = TypedDict(
    "PeeringConnectionOptionsRequestTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)

PeeringConnectionOptionsOutputTypeDef = TypedDict(
    "PeeringConnectionOptionsOutputTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
)

_RequiredModifyVpcTenancyRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcTenancyRequestRequestTypeDef",
    {
        "VpcId": str,
        "InstanceTenancy": Literal["default"],
    },
)
_OptionalModifyVpcTenancyRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcTenancyRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyVpcTenancyRequestRequestTypeDef(
    _RequiredModifyVpcTenancyRequestRequestTypeDef, _OptionalModifyVpcTenancyRequestRequestTypeDef
):
    pass


ModifyVpcTenancyResultOutputTypeDef = TypedDict(
    "ModifyVpcTenancyResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyVpnConnectionOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpnConnectionOptionsRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
    },
)
_OptionalModifyVpnConnectionOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpnConnectionOptionsRequestRequestTypeDef",
    {
        "LocalIpv4NetworkCidr": str,
        "RemoteIpv4NetworkCidr": str,
        "LocalIpv6NetworkCidr": str,
        "RemoteIpv6NetworkCidr": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVpnConnectionOptionsRequestRequestTypeDef(
    _RequiredModifyVpnConnectionOptionsRequestRequestTypeDef,
    _OptionalModifyVpnConnectionOptionsRequestRequestTypeDef,
):
    pass


_RequiredModifyVpnConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpnConnectionRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
    },
)
_OptionalModifyVpnConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpnConnectionRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
        "CustomerGatewayId": str,
        "VpnGatewayId": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVpnConnectionRequestRequestTypeDef(
    _RequiredModifyVpnConnectionRequestRequestTypeDef,
    _OptionalModifyVpnConnectionRequestRequestTypeDef,
):
    pass


_RequiredModifyVpnTunnelCertificateRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpnTunnelCertificateRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
        "VpnTunnelOutsideIpAddress": str,
    },
)
_OptionalModifyVpnTunnelCertificateRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpnTunnelCertificateRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyVpnTunnelCertificateRequestRequestTypeDef(
    _RequiredModifyVpnTunnelCertificateRequestRequestTypeDef,
    _OptionalModifyVpnTunnelCertificateRequestRequestTypeDef,
):
    pass


Phase1DHGroupNumbersRequestListValueTypeDef = TypedDict(
    "Phase1DHGroupNumbersRequestListValueTypeDef",
    {
        "Value": int,
    },
    total=False,
)

Phase1EncryptionAlgorithmsRequestListValueTypeDef = TypedDict(
    "Phase1EncryptionAlgorithmsRequestListValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

Phase1IntegrityAlgorithmsRequestListValueTypeDef = TypedDict(
    "Phase1IntegrityAlgorithmsRequestListValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

Phase2DHGroupNumbersRequestListValueTypeDef = TypedDict(
    "Phase2DHGroupNumbersRequestListValueTypeDef",
    {
        "Value": int,
    },
    total=False,
)

Phase2EncryptionAlgorithmsRequestListValueTypeDef = TypedDict(
    "Phase2EncryptionAlgorithmsRequestListValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

Phase2IntegrityAlgorithmsRequestListValueTypeDef = TypedDict(
    "Phase2IntegrityAlgorithmsRequestListValueTypeDef",
    {
        "Value": str,
    },
    total=False,
)

MonitorInstancesRequestInstanceMonitorTypeDef = TypedDict(
    "MonitorInstancesRequestInstanceMonitorTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredMonitorInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredMonitorInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalMonitorInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalMonitorInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class MonitorInstancesRequestRequestTypeDef(
    _RequiredMonitorInstancesRequestRequestTypeDef, _OptionalMonitorInstancesRequestRequestTypeDef
):
    pass


MonitoringResponseMetadataTypeDef = TypedDict(
    "MonitoringResponseMetadataTypeDef",
    {
        "State": MonitoringStateType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredMoveAddressToVpcRequestRequestTypeDef = TypedDict(
    "_RequiredMoveAddressToVpcRequestRequestTypeDef",
    {
        "PublicIp": str,
    },
)
_OptionalMoveAddressToVpcRequestRequestTypeDef = TypedDict(
    "_OptionalMoveAddressToVpcRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class MoveAddressToVpcRequestRequestTypeDef(
    _RequiredMoveAddressToVpcRequestRequestTypeDef, _OptionalMoveAddressToVpcRequestRequestTypeDef
):
    pass


MoveAddressToVpcResultOutputTypeDef = TypedDict(
    "MoveAddressToVpcResultOutputTypeDef",
    {
        "AllocationId": str,
        "Status": StatusType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredMoveByoipCidrToIpamRequestRequestTypeDef = TypedDict(
    "_RequiredMoveByoipCidrToIpamRequestRequestTypeDef",
    {
        "Cidr": str,
        "IpamPoolId": str,
        "IpamPoolOwner": str,
    },
)
_OptionalMoveByoipCidrToIpamRequestRequestTypeDef = TypedDict(
    "_OptionalMoveByoipCidrToIpamRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class MoveByoipCidrToIpamRequestRequestTypeDef(
    _RequiredMoveByoipCidrToIpamRequestRequestTypeDef,
    _OptionalMoveByoipCidrToIpamRequestRequestTypeDef,
):
    pass


ProvisionedBandwidthOutputTypeDef = TypedDict(
    "ProvisionedBandwidthOutputTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
)

NetworkAclAssociationOutputTypeDef = TypedDict(
    "NetworkAclAssociationOutputTypeDef",
    {
        "NetworkAclAssociationId": str,
        "NetworkAclId": str,
        "SubnetId": str,
    },
)

NetworkCardInfoOutputTypeDef = TypedDict(
    "NetworkCardInfoOutputTypeDef",
    {
        "NetworkCardIndex": int,
        "NetworkPerformance": str,
        "MaximumNetworkInterfaces": int,
    },
)

NetworkInterfaceAssociationOutputTypeDef = TypedDict(
    "NetworkInterfaceAssociationOutputTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
        "CustomerOwnedIp": str,
        "CarrierIp": str,
    },
)

NetworkInterfaceAssociationResponseMetadataTypeDef = TypedDict(
    "NetworkInterfaceAssociationResponseMetadataTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
        "CustomerOwnedIp": str,
        "CarrierIp": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NetworkInterfaceIpv6AddressOutputTypeDef = TypedDict(
    "NetworkInterfaceIpv6AddressOutputTypeDef",
    {
        "Ipv6Address": str,
    },
)

NetworkInterfacePermissionStateOutputTypeDef = TypedDict(
    "NetworkInterfacePermissionStateOutputTypeDef",
    {
        "State": NetworkInterfacePermissionStateCodeType,
        "StatusMessage": str,
    },
)

OidcOptionsOutputTypeDef = TypedDict(
    "OidcOptionsOutputTypeDef",
    {
        "Issuer": str,
        "AuthorizationEndpoint": str,
        "TokenEndpoint": str,
        "UserInfoEndpoint": str,
        "ClientId": str,
        "ClientSecret": str,
        "Scope": str,
    },
)

PacketHeaderStatementOutputTypeDef = TypedDict(
    "PacketHeaderStatementOutputTypeDef",
    {
        "SourceAddresses": List[str],
        "DestinationAddresses": List[str],
        "SourcePorts": List[str],
        "DestinationPorts": List[str],
        "SourcePrefixLists": List[str],
        "DestinationPrefixLists": List[str],
        "Protocols": List[ProtocolType],
    },
)

PacketHeaderStatementRequestTypeDef = TypedDict(
    "PacketHeaderStatementRequestTypeDef",
    {
        "SourceAddresses": Sequence[str],
        "DestinationAddresses": Sequence[str],
        "SourcePorts": Sequence[str],
        "DestinationPorts": Sequence[str],
        "SourcePrefixLists": Sequence[str],
        "DestinationPrefixLists": Sequence[str],
        "Protocols": Sequence[ProtocolType],
    },
    total=False,
)

PaginatorConfigTypeDef = TypedDict(
    "PaginatorConfigTypeDef",
    {
        "MaxItems": int,
        "PageSize": int,
        "StartingToken": str,
    },
    total=False,
)

RequestFilterPortRangeTypeDef = TypedDict(
    "RequestFilterPortRangeTypeDef",
    {
        "FromPort": int,
        "ToPort": int,
    },
    total=False,
)

ResourceStatementOutputTypeDef = TypedDict(
    "ResourceStatementOutputTypeDef",
    {
        "Resources": List[str],
        "ResourceTypes": List[str],
    },
)

ResourceStatementRequestTypeDef = TypedDict(
    "ResourceStatementRequestTypeDef",
    {
        "Resources": Sequence[str],
        "ResourceTypes": Sequence[str],
    },
    total=False,
)

PeeringAttachmentStatusOutputTypeDef = TypedDict(
    "PeeringAttachmentStatusOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

PeeringTgwInfoOutputTypeDef = TypedDict(
    "PeeringTgwInfoOutputTypeDef",
    {
        "TransitGatewayId": str,
        "CoreNetworkId": str,
        "OwnerId": str,
        "Region": str,
    },
)

Phase1DHGroupNumbersListValueOutputTypeDef = TypedDict(
    "Phase1DHGroupNumbersListValueOutputTypeDef",
    {
        "Value": int,
    },
)

Phase1EncryptionAlgorithmsListValueOutputTypeDef = TypedDict(
    "Phase1EncryptionAlgorithmsListValueOutputTypeDef",
    {
        "Value": str,
    },
)

Phase1IntegrityAlgorithmsListValueOutputTypeDef = TypedDict(
    "Phase1IntegrityAlgorithmsListValueOutputTypeDef",
    {
        "Value": str,
    },
)

Phase2DHGroupNumbersListValueOutputTypeDef = TypedDict(
    "Phase2DHGroupNumbersListValueOutputTypeDef",
    {
        "Value": int,
    },
)

Phase2EncryptionAlgorithmsListValueOutputTypeDef = TypedDict(
    "Phase2EncryptionAlgorithmsListValueOutputTypeDef",
    {
        "Value": str,
    },
)

Phase2IntegrityAlgorithmsListValueOutputTypeDef = TypedDict(
    "Phase2IntegrityAlgorithmsListValueOutputTypeDef",
    {
        "Value": str,
    },
)

PlacementResponseMetadataTypeDef = TypedDict(
    "PlacementResponseMetadataTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": TenancyType,
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
        "GroupId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PriceScheduleOutputTypeDef = TypedDict(
    "PriceScheduleOutputTypeDef",
    {
        "Active": bool,
        "CurrencyCode": Literal["USD"],
        "Price": float,
        "Term": int,
    },
)

PricingDetailOutputTypeDef = TypedDict(
    "PricingDetailOutputTypeDef",
    {
        "Count": int,
        "Price": float,
    },
)

PrivateDnsDetailsOutputTypeDef = TypedDict(
    "PrivateDnsDetailsOutputTypeDef",
    {
        "PrivateDnsName": str,
    },
)

PrivateDnsNameConfigurationOutputTypeDef = TypedDict(
    "PrivateDnsNameConfigurationOutputTypeDef",
    {
        "State": DnsNameStateType,
        "Type": str,
        "Value": str,
        "Name": str,
    },
)

PrivateDnsNameOptionsOnLaunchOutputTypeDef = TypedDict(
    "PrivateDnsNameOptionsOnLaunchOutputTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
)

PrivateDnsNameOptionsOnLaunchResponseMetadataTypeDef = TypedDict(
    "PrivateDnsNameOptionsOnLaunchResponseMetadataTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PrivateDnsNameOptionsRequestTypeDef = TypedDict(
    "PrivateDnsNameOptionsRequestTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
    },
    total=False,
)

PrivateDnsNameOptionsResponseResponseMetadataTypeDef = TypedDict(
    "PrivateDnsNameOptionsResponseResponseMetadataTypeDef",
    {
        "HostnameType": HostnameTypeType,
        "EnableResourceNameDnsARecord": bool,
        "EnableResourceNameDnsAAAARecord": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PropagatingVgwOutputTypeDef = TypedDict(
    "PropagatingVgwOutputTypeDef",
    {
        "GatewayId": str,
    },
)

_RequiredProvisionPublicIpv4PoolCidrRequestRequestTypeDef = TypedDict(
    "_RequiredProvisionPublicIpv4PoolCidrRequestRequestTypeDef",
    {
        "IpamPoolId": str,
        "PoolId": str,
        "NetmaskLength": int,
    },
)
_OptionalProvisionPublicIpv4PoolCidrRequestRequestTypeDef = TypedDict(
    "_OptionalProvisionPublicIpv4PoolCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ProvisionPublicIpv4PoolCidrRequestRequestTypeDef(
    _RequiredProvisionPublicIpv4PoolCidrRequestRequestTypeDef,
    _OptionalProvisionPublicIpv4PoolCidrRequestRequestTypeDef,
):
    pass


PublicIpv4PoolRangeOutputTypeDef = TypedDict(
    "PublicIpv4PoolRangeOutputTypeDef",
    {
        "FirstAddress": str,
        "LastAddress": str,
        "AddressCount": int,
        "AvailableAddressCount": int,
    },
)

PurchaseRequestTypeDef = TypedDict(
    "PurchaseRequestTypeDef",
    {
        "InstanceCount": int,
        "PurchaseToken": str,
    },
)

ReservedInstanceLimitPriceTypeDef = TypedDict(
    "ReservedInstanceLimitPriceTypeDef",
    {
        "Amount": float,
        "CurrencyCode": Literal["USD"],
    },
    total=False,
)

PurchaseReservedInstancesOfferingResultOutputTypeDef = TypedDict(
    "PurchaseReservedInstancesOfferingResultOutputTypeDef",
    {
        "ReservedInstancesId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RebootInstancesRequestInstanceRebootTypeDef = TypedDict(
    "RebootInstancesRequestInstanceRebootTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredRebootInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredRebootInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalRebootInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalRebootInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RebootInstancesRequestRequestTypeDef(
    _RequiredRebootInstancesRequestRequestTypeDef, _OptionalRebootInstancesRequestRequestTypeDef
):
    pass


RecurringChargeOutputTypeDef = TypedDict(
    "RecurringChargeOutputTypeDef",
    {
        "Amount": float,
        "Frequency": Literal["Hourly"],
    },
)

ReferencedSecurityGroupOutputTypeDef = TypedDict(
    "ReferencedSecurityGroupOutputTypeDef",
    {
        "GroupId": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
)

RegisterImageResultOutputTypeDef = TypedDict(
    "RegisterImageResultOutputTypeDef",
    {
        "ImageId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RegisterInstanceTagAttributeRequestTypeDef = TypedDict(
    "RegisterInstanceTagAttributeRequestTypeDef",
    {
        "IncludeAllTagsOfInstance": bool,
        "InstanceTagKeys": Sequence[str],
    },
    total=False,
)

_RequiredRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef = TypedDict(
    "_RequiredRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "NetworkInterfaceIds": Sequence[str],
    },
)
_OptionalRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef = TypedDict(
    "_OptionalRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef",
    {
        "GroupIpAddress": str,
        "DryRun": bool,
    },
    total=False,
)


class RegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef(
    _RequiredRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef,
    _OptionalRegisterTransitGatewayMulticastGroupMembersRequestRequestTypeDef,
):
    pass


TransitGatewayMulticastRegisteredGroupMembersOutputTypeDef = TypedDict(
    "TransitGatewayMulticastRegisteredGroupMembersOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "RegisteredNetworkInterfaceIds": List[str],
        "GroupIpAddress": str,
    },
)

_RequiredRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef = TypedDict(
    "_RequiredRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "NetworkInterfaceIds": Sequence[str],
    },
)
_OptionalRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef = TypedDict(
    "_OptionalRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef",
    {
        "GroupIpAddress": str,
        "DryRun": bool,
    },
    total=False,
)


class RegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef(
    _RequiredRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef,
    _OptionalRegisterTransitGatewayMulticastGroupSourcesRequestRequestTypeDef,
):
    pass


TransitGatewayMulticastRegisteredGroupSourcesOutputTypeDef = TypedDict(
    "TransitGatewayMulticastRegisteredGroupSourcesOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "RegisteredNetworkInterfaceIds": List[str],
        "GroupIpAddress": str,
    },
)

RejectTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef = TypedDict(
    "RejectTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayAttachmentId": str,
        "SubnetIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

_RequiredRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RejectTransitGatewayPeeringAttachmentRequestRequestTypeDef(
    _RequiredRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef,
    _OptionalRejectTransitGatewayPeeringAttachmentRequestRequestTypeDef,
):
    pass


_RequiredRejectTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredRejectTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalRejectTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalRejectTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RejectTransitGatewayVpcAttachmentRequestRequestTypeDef(
    _RequiredRejectTransitGatewayVpcAttachmentRequestRequestTypeDef,
    _OptionalRejectTransitGatewayVpcAttachmentRequestRequestTypeDef,
):
    pass


_RequiredRejectVpcEndpointConnectionsRequestRequestTypeDef = TypedDict(
    "_RequiredRejectVpcEndpointConnectionsRequestRequestTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointIds": Sequence[str],
    },
)
_OptionalRejectVpcEndpointConnectionsRequestRequestTypeDef = TypedDict(
    "_OptionalRejectVpcEndpointConnectionsRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RejectVpcEndpointConnectionsRequestRequestTypeDef(
    _RequiredRejectVpcEndpointConnectionsRequestRequestTypeDef,
    _OptionalRejectVpcEndpointConnectionsRequestRequestTypeDef,
):
    pass


_RequiredRejectVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredRejectVpcPeeringConnectionRequestRequestTypeDef",
    {
        "VpcPeeringConnectionId": str,
    },
)
_OptionalRejectVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalRejectVpcPeeringConnectionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RejectVpcPeeringConnectionRequestRequestTypeDef(
    _RequiredRejectVpcPeeringConnectionRequestRequestTypeDef,
    _OptionalRejectVpcPeeringConnectionRequestRequestTypeDef,
):
    pass


RejectVpcPeeringConnectionRequestVpcPeeringConnectionRejectTypeDef = TypedDict(
    "RejectVpcPeeringConnectionRequestVpcPeeringConnectionRejectTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

RejectVpcPeeringConnectionResultOutputTypeDef = TypedDict(
    "RejectVpcPeeringConnectionResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReleaseAddressRequestClassicAddressReleaseTypeDef = TypedDict(
    "ReleaseAddressRequestClassicAddressReleaseTypeDef",
    {
        "AllocationId": str,
        "PublicIp": str,
        "NetworkBorderGroup": str,
        "DryRun": bool,
    },
    total=False,
)

ReleaseAddressRequestRequestTypeDef = TypedDict(
    "ReleaseAddressRequestRequestTypeDef",
    {
        "AllocationId": str,
        "PublicIp": str,
        "NetworkBorderGroup": str,
        "DryRun": bool,
    },
    total=False,
)

ReleaseAddressRequestVpcAddressReleaseTypeDef = TypedDict(
    "ReleaseAddressRequestVpcAddressReleaseTypeDef",
    {
        "AllocationId": str,
        "PublicIp": str,
        "NetworkBorderGroup": str,
        "DryRun": bool,
    },
    total=False,
)

ReleaseHostsRequestRequestTypeDef = TypedDict(
    "ReleaseHostsRequestRequestTypeDef",
    {
        "HostIds": Sequence[str],
    },
)

_RequiredReleaseIpamPoolAllocationRequestRequestTypeDef = TypedDict(
    "_RequiredReleaseIpamPoolAllocationRequestRequestTypeDef",
    {
        "IpamPoolId": str,
        "Cidr": str,
        "IpamPoolAllocationId": str,
    },
)
_OptionalReleaseIpamPoolAllocationRequestRequestTypeDef = TypedDict(
    "_OptionalReleaseIpamPoolAllocationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ReleaseIpamPoolAllocationRequestRequestTypeDef(
    _RequiredReleaseIpamPoolAllocationRequestRequestTypeDef,
    _OptionalReleaseIpamPoolAllocationRequestRequestTypeDef,
):
    pass


ReleaseIpamPoolAllocationResultOutputTypeDef = TypedDict(
    "ReleaseIpamPoolAllocationResultOutputTypeDef",
    {
        "Success": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef = TypedDict(
    "_RequiredReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef",
    {
        "AssociationId": str,
    },
)
_OptionalReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef = TypedDict(
    "_OptionalReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef(
    _RequiredReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef,
    _OptionalReplaceNetworkAclAssociationRequestNetworkAclReplaceAssociationTypeDef,
):
    pass


_RequiredReplaceNetworkAclAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceNetworkAclAssociationRequestRequestTypeDef",
    {
        "AssociationId": str,
        "NetworkAclId": str,
    },
)
_OptionalReplaceNetworkAclAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceNetworkAclAssociationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ReplaceNetworkAclAssociationRequestRequestTypeDef(
    _RequiredReplaceNetworkAclAssociationRequestRequestTypeDef,
    _OptionalReplaceNetworkAclAssociationRequestRequestTypeDef,
):
    pass


ReplaceNetworkAclAssociationResultOutputTypeDef = TypedDict(
    "ReplaceNetworkAclAssociationResultOutputTypeDef",
    {
        "NewAssociationId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredReplaceRouteRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceRouteRequestRequestTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalReplaceRouteRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
        "VpcEndpointId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "LocalTarget": bool,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "LocalGatewayId": str,
        "CarrierGatewayId": str,
        "NetworkInterfaceId": str,
        "VpcPeeringConnectionId": str,
        "CoreNetworkArn": str,
    },
    total=False,
)


class ReplaceRouteRequestRequestTypeDef(
    _RequiredReplaceRouteRequestRequestTypeDef, _OptionalReplaceRouteRequestRequestTypeDef
):
    pass


ReplaceRouteRequestRouteReplaceTypeDef = TypedDict(
    "ReplaceRouteRequestRouteReplaceTypeDef",
    {
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "DryRun": bool,
        "VpcEndpointId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "LocalTarget": bool,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "LocalGatewayId": str,
        "CarrierGatewayId": str,
        "NetworkInterfaceId": str,
        "VpcPeeringConnectionId": str,
        "CoreNetworkArn": str,
    },
    total=False,
)

_RequiredReplaceRouteTableAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceRouteTableAssociationRequestRequestTypeDef",
    {
        "AssociationId": str,
        "RouteTableId": str,
    },
)
_OptionalReplaceRouteTableAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceRouteTableAssociationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ReplaceRouteTableAssociationRequestRequestTypeDef(
    _RequiredReplaceRouteTableAssociationRequestRequestTypeDef,
    _OptionalReplaceRouteTableAssociationRequestRequestTypeDef,
):
    pass


_RequiredReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef = TypedDict(
    "_RequiredReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef",
    {
        "RouteTableId": str,
    },
)
_OptionalReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef = TypedDict(
    "_OptionalReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef(
    _RequiredReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef,
    _OptionalReplaceRouteTableAssociationRequestRouteTableAssociationReplaceSubnetTypeDef,
):
    pass


_RequiredReplaceTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceTransitGatewayRouteRequestRequestTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalReplaceTransitGatewayRouteRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceTransitGatewayRouteRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "Blackhole": bool,
        "DryRun": bool,
    },
    total=False,
)


class ReplaceTransitGatewayRouteRequestRequestTypeDef(
    _RequiredReplaceTransitGatewayRouteRequestRequestTypeDef,
    _OptionalReplaceTransitGatewayRouteRequestRequestTypeDef,
):
    pass


_RequiredReplaceVpnTunnelRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceVpnTunnelRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
        "VpnTunnelOutsideIpAddress": str,
    },
)
_OptionalReplaceVpnTunnelRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceVpnTunnelRequestRequestTypeDef",
    {
        "ApplyPendingMaintenance": bool,
        "DryRun": bool,
    },
    total=False,
)


class ReplaceVpnTunnelRequestRequestTypeDef(
    _RequiredReplaceVpnTunnelRequestRequestTypeDef, _OptionalReplaceVpnTunnelRequestRequestTypeDef
):
    pass


ReplaceVpnTunnelResultOutputTypeDef = TypedDict(
    "ReplaceVpnTunnelResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredReportInstanceStatusRequestInstanceReportStatusTypeDef = TypedDict(
    "_RequiredReportInstanceStatusRequestInstanceReportStatusTypeDef",
    {
        "ReasonCodes": Sequence[ReportInstanceReasonCodesType],
        "Status": ReportStatusTypeType,
    },
)
_OptionalReportInstanceStatusRequestInstanceReportStatusTypeDef = TypedDict(
    "_OptionalReportInstanceStatusRequestInstanceReportStatusTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "EndTime": Union[datetime, str],
        "StartTime": Union[datetime, str],
    },
    total=False,
)


class ReportInstanceStatusRequestInstanceReportStatusTypeDef(
    _RequiredReportInstanceStatusRequestInstanceReportStatusTypeDef,
    _OptionalReportInstanceStatusRequestInstanceReportStatusTypeDef,
):
    pass


_RequiredReportInstanceStatusRequestRequestTypeDef = TypedDict(
    "_RequiredReportInstanceStatusRequestRequestTypeDef",
    {
        "Instances": Sequence[str],
        "ReasonCodes": Sequence[ReportInstanceReasonCodesType],
        "Status": ReportStatusTypeType,
    },
)
_OptionalReportInstanceStatusRequestRequestTypeDef = TypedDict(
    "_OptionalReportInstanceStatusRequestRequestTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "EndTime": Union[datetime, str],
        "StartTime": Union[datetime, str],
    },
    total=False,
)


class ReportInstanceStatusRequestRequestTypeDef(
    _RequiredReportInstanceStatusRequestRequestTypeDef,
    _OptionalReportInstanceStatusRequestRequestTypeDef,
):
    pass


RequestSpotFleetResponseOutputTypeDef = TypedDict(
    "RequestSpotFleetResponseOutputTypeDef",
    {
        "SpotFleetRequestId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RunInstancesMonitoringEnabledTypeDef = TypedDict(
    "RunInstancesMonitoringEnabledTypeDef",
    {
        "Enabled": bool,
    },
)

SpotPlacementTypeDef = TypedDict(
    "SpotPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "GroupName": str,
        "Tenancy": TenancyType,
    },
    total=False,
)

ReservedInstancesConfigurationOutputTypeDef = TypedDict(
    "ReservedInstancesConfigurationOutputTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": InstanceTypeType,
        "Platform": str,
        "Scope": scopeType,
    },
)

ReservedInstancesIdOutputTypeDef = TypedDict(
    "ReservedInstancesIdOutputTypeDef",
    {
        "ReservedInstancesId": str,
    },
)

_RequiredResetAddressAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetAddressAttributeRequestRequestTypeDef",
    {
        "AllocationId": str,
        "Attribute": Literal["domain-name"],
    },
)
_OptionalResetAddressAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetAddressAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetAddressAttributeRequestRequestTypeDef(
    _RequiredResetAddressAttributeRequestRequestTypeDef,
    _OptionalResetAddressAttributeRequestRequestTypeDef,
):
    pass


ResetEbsDefaultKmsKeyIdRequestRequestTypeDef = TypedDict(
    "ResetEbsDefaultKmsKeyIdRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

ResetEbsDefaultKmsKeyIdResultOutputTypeDef = TypedDict(
    "ResetEbsDefaultKmsKeyIdResultOutputTypeDef",
    {
        "KmsKeyId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredResetFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetFpgaImageAttributeRequestRequestTypeDef",
    {
        "FpgaImageId": str,
    },
)
_OptionalResetFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetFpgaImageAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Attribute": Literal["loadPermission"],
    },
    total=False,
)


class ResetFpgaImageAttributeRequestRequestTypeDef(
    _RequiredResetFpgaImageAttributeRequestRequestTypeDef,
    _OptionalResetFpgaImageAttributeRequestRequestTypeDef,
):
    pass


ResetFpgaImageAttributeResultOutputTypeDef = TypedDict(
    "ResetFpgaImageAttributeResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredResetImageAttributeRequestImageResetAttributeTypeDef = TypedDict(
    "_RequiredResetImageAttributeRequestImageResetAttributeTypeDef",
    {
        "Attribute": Literal["launchPermission"],
    },
)
_OptionalResetImageAttributeRequestImageResetAttributeTypeDef = TypedDict(
    "_OptionalResetImageAttributeRequestImageResetAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetImageAttributeRequestImageResetAttributeTypeDef(
    _RequiredResetImageAttributeRequestImageResetAttributeTypeDef,
    _OptionalResetImageAttributeRequestImageResetAttributeTypeDef,
):
    pass


_RequiredResetImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetImageAttributeRequestRequestTypeDef",
    {
        "Attribute": Literal["launchPermission"],
        "ImageId": str,
    },
)
_OptionalResetImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetImageAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetImageAttributeRequestRequestTypeDef(
    _RequiredResetImageAttributeRequestRequestTypeDef,
    _OptionalResetImageAttributeRequestRequestTypeDef,
):
    pass


_RequiredResetInstanceAttributeRequestInstanceResetAttributeTypeDef = TypedDict(
    "_RequiredResetInstanceAttributeRequestInstanceResetAttributeTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
    },
)
_OptionalResetInstanceAttributeRequestInstanceResetAttributeTypeDef = TypedDict(
    "_OptionalResetInstanceAttributeRequestInstanceResetAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetInstanceAttributeRequestInstanceResetAttributeTypeDef(
    _RequiredResetInstanceAttributeRequestInstanceResetAttributeTypeDef,
    _OptionalResetInstanceAttributeRequestInstanceResetAttributeTypeDef,
):
    pass


ResetInstanceAttributeRequestInstanceResetKernelTypeDef = TypedDict(
    "ResetInstanceAttributeRequestInstanceResetKernelTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
        "DryRun": bool,
    },
    total=False,
)

ResetInstanceAttributeRequestInstanceResetRamdiskTypeDef = TypedDict(
    "ResetInstanceAttributeRequestInstanceResetRamdiskTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
        "DryRun": bool,
    },
    total=False,
)

ResetInstanceAttributeRequestInstanceResetSourceDestCheckTypeDef = TypedDict(
    "ResetInstanceAttributeRequestInstanceResetSourceDestCheckTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
        "DryRun": bool,
    },
    total=False,
)

_RequiredResetInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetInstanceAttributeRequestRequestTypeDef",
    {
        "Attribute": InstanceAttributeNameType,
        "InstanceId": str,
    },
)
_OptionalResetInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetInstanceAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetInstanceAttributeRequestRequestTypeDef(
    _RequiredResetInstanceAttributeRequestRequestTypeDef,
    _OptionalResetInstanceAttributeRequestRequestTypeDef,
):
    pass


ResetNetworkInterfaceAttributeRequestNetworkInterfaceResetAttributeTypeDef = TypedDict(
    "ResetNetworkInterfaceAttributeRequestNetworkInterfaceResetAttributeTypeDef",
    {
        "DryRun": bool,
        "SourceDestCheck": str,
    },
    total=False,
)

_RequiredResetNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalResetNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "SourceDestCheck": str,
    },
    total=False,
)


class ResetNetworkInterfaceAttributeRequestRequestTypeDef(
    _RequiredResetNetworkInterfaceAttributeRequestRequestTypeDef,
    _OptionalResetNetworkInterfaceAttributeRequestRequestTypeDef,
):
    pass


_RequiredResetSnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredResetSnapshotAttributeRequestRequestTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
        "SnapshotId": str,
    },
)
_OptionalResetSnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalResetSnapshotAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetSnapshotAttributeRequestRequestTypeDef(
    _RequiredResetSnapshotAttributeRequestRequestTypeDef,
    _OptionalResetSnapshotAttributeRequestRequestTypeDef,
):
    pass


_RequiredResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef = TypedDict(
    "_RequiredResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
    },
)
_OptionalResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef = TypedDict(
    "_OptionalResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef(
    _RequiredResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef,
    _OptionalResetSnapshotAttributeRequestSnapshotResetAttributeTypeDef,
):
    pass


ResponseMetadataTypeDef = TypedDict(
    "ResponseMetadataTypeDef",
    {
        "RequestId": str,
        "HostId": str,
        "HTTPStatusCode": int,
        "HTTPHeaders": Dict[str, str],
        "RetryAttempts": int,
    },
)

_RequiredRestoreAddressToClassicRequestRequestTypeDef = TypedDict(
    "_RequiredRestoreAddressToClassicRequestRequestTypeDef",
    {
        "PublicIp": str,
    },
)
_OptionalRestoreAddressToClassicRequestRequestTypeDef = TypedDict(
    "_OptionalRestoreAddressToClassicRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RestoreAddressToClassicRequestRequestTypeDef(
    _RequiredRestoreAddressToClassicRequestRequestTypeDef,
    _OptionalRestoreAddressToClassicRequestRequestTypeDef,
):
    pass


RestoreAddressToClassicResultOutputTypeDef = TypedDict(
    "RestoreAddressToClassicResultOutputTypeDef",
    {
        "PublicIp": str,
        "Status": StatusType,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredRestoreImageFromRecycleBinRequestRequestTypeDef = TypedDict(
    "_RequiredRestoreImageFromRecycleBinRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalRestoreImageFromRecycleBinRequestRequestTypeDef = TypedDict(
    "_OptionalRestoreImageFromRecycleBinRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RestoreImageFromRecycleBinRequestRequestTypeDef(
    _RequiredRestoreImageFromRecycleBinRequestRequestTypeDef,
    _OptionalRestoreImageFromRecycleBinRequestRequestTypeDef,
):
    pass


RestoreImageFromRecycleBinResultOutputTypeDef = TypedDict(
    "RestoreImageFromRecycleBinResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredRestoreManagedPrefixListVersionRequestRequestTypeDef = TypedDict(
    "_RequiredRestoreManagedPrefixListVersionRequestRequestTypeDef",
    {
        "PrefixListId": str,
        "PreviousVersion": int,
        "CurrentVersion": int,
    },
)
_OptionalRestoreManagedPrefixListVersionRequestRequestTypeDef = TypedDict(
    "_OptionalRestoreManagedPrefixListVersionRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RestoreManagedPrefixListVersionRequestRequestTypeDef(
    _RequiredRestoreManagedPrefixListVersionRequestRequestTypeDef,
    _OptionalRestoreManagedPrefixListVersionRequestRequestTypeDef,
):
    pass


_RequiredRestoreSnapshotFromRecycleBinRequestRequestTypeDef = TypedDict(
    "_RequiredRestoreSnapshotFromRecycleBinRequestRequestTypeDef",
    {
        "SnapshotId": str,
    },
)
_OptionalRestoreSnapshotFromRecycleBinRequestRequestTypeDef = TypedDict(
    "_OptionalRestoreSnapshotFromRecycleBinRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RestoreSnapshotFromRecycleBinRequestRequestTypeDef(
    _RequiredRestoreSnapshotFromRecycleBinRequestRequestTypeDef,
    _OptionalRestoreSnapshotFromRecycleBinRequestRequestTypeDef,
):
    pass


RestoreSnapshotFromRecycleBinResultOutputTypeDef = TypedDict(
    "RestoreSnapshotFromRecycleBinResultOutputTypeDef",
    {
        "SnapshotId": str,
        "OutpostArn": str,
        "Description": str,
        "Encrypted": bool,
        "OwnerId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": SnapshotStateType,
        "VolumeId": str,
        "VolumeSize": int,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredRestoreSnapshotTierRequestRequestTypeDef = TypedDict(
    "_RequiredRestoreSnapshotTierRequestRequestTypeDef",
    {
        "SnapshotId": str,
    },
)
_OptionalRestoreSnapshotTierRequestRequestTypeDef = TypedDict(
    "_OptionalRestoreSnapshotTierRequestRequestTypeDef",
    {
        "TemporaryRestoreDays": int,
        "PermanentRestore": bool,
        "DryRun": bool,
    },
    total=False,
)


class RestoreSnapshotTierRequestRequestTypeDef(
    _RequiredRestoreSnapshotTierRequestRequestTypeDef,
    _OptionalRestoreSnapshotTierRequestRequestTypeDef,
):
    pass


RestoreSnapshotTierResultOutputTypeDef = TypedDict(
    "RestoreSnapshotTierResultOutputTypeDef",
    {
        "SnapshotId": str,
        "RestoreStartTime": datetime,
        "RestoreDuration": int,
        "IsPermanentRestore": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredRevokeClientVpnIngressRequestRequestTypeDef = TypedDict(
    "_RequiredRevokeClientVpnIngressRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
        "TargetNetworkCidr": str,
    },
)
_OptionalRevokeClientVpnIngressRequestRequestTypeDef = TypedDict(
    "_OptionalRevokeClientVpnIngressRequestRequestTypeDef",
    {
        "AccessGroupId": str,
        "RevokeAllGroups": bool,
        "DryRun": bool,
    },
    total=False,
)


class RevokeClientVpnIngressRequestRequestTypeDef(
    _RequiredRevokeClientVpnIngressRequestRequestTypeDef,
    _OptionalRevokeClientVpnIngressRequestRequestTypeDef,
):
    pass


RouteOutputTypeDef = TypedDict(
    "RouteOutputTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "LocalGatewayId": str,
        "CarrierGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": RouteOriginType,
        "State": RouteStateType,
        "VpcPeeringConnectionId": str,
        "CoreNetworkArn": str,
    },
)

RouteTableAssociationStateResponseMetadataTypeDef = TypedDict(
    "RouteTableAssociationStateResponseMetadataTypeDef",
    {
        "State": RouteTableAssociationStateCodeType,
        "StatusMessage": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RunScheduledInstancesResultOutputTypeDef = TypedDict(
    "RunScheduledInstancesResultOutputTypeDef",
    {
        "InstanceIdSet": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

S3StorageOutputTypeDef = TypedDict(
    "S3StorageOutputTypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
)

S3StorageTypeDef = TypedDict(
    "S3StorageTypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": Union[str, bytes, IO[Any], StreamingBody],
        "UploadPolicySignature": str,
    },
    total=False,
)

ScheduledInstanceRecurrenceOutputTypeDef = TypedDict(
    "ScheduledInstanceRecurrenceOutputTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
)

ScheduledInstancesEbsTypeDef = TypedDict(
    "ScheduledInstancesEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Encrypted": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)

ScheduledInstancesIamInstanceProfileTypeDef = TypedDict(
    "ScheduledInstancesIamInstanceProfileTypeDef",
    {
        "Arn": str,
        "Name": str,
    },
    total=False,
)

ScheduledInstancesIpv6AddressTypeDef = TypedDict(
    "ScheduledInstancesIpv6AddressTypeDef",
    {
        "Ipv6Address": str,
    },
    total=False,
)

ScheduledInstancesMonitoringTypeDef = TypedDict(
    "ScheduledInstancesMonitoringTypeDef",
    {
        "Enabled": bool,
    },
    total=False,
)

ScheduledInstancesPlacementTypeDef = TypedDict(
    "ScheduledInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "GroupName": str,
    },
    total=False,
)

ScheduledInstancesPrivateIpAddressConfigTypeDef = TypedDict(
    "ScheduledInstancesPrivateIpAddressConfigTypeDef",
    {
        "Primary": bool,
        "PrivateIpAddress": str,
    },
    total=False,
)

TransitGatewayMulticastGroupOutputTypeDef = TypedDict(
    "TransitGatewayMulticastGroupOutputTypeDef",
    {
        "GroupIpAddress": str,
        "TransitGatewayAttachmentId": str,
        "SubnetId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "ResourceOwnerId": str,
        "NetworkInterfaceId": str,
        "GroupMember": bool,
        "GroupSource": bool,
        "MemberType": MembershipTypeType,
        "SourceType": MembershipTypeType,
    },
)

SecurityGroupIdentifierOutputTypeDef = TypedDict(
    "SecurityGroupIdentifierOutputTypeDef",
    {
        "GroupId": str,
        "GroupName": str,
    },
)

SecurityGroupRuleDescriptionTypeDef = TypedDict(
    "SecurityGroupRuleDescriptionTypeDef",
    {
        "SecurityGroupRuleId": str,
        "Description": str,
    },
    total=False,
)

SecurityGroupRuleRequestTypeDef = TypedDict(
    "SecurityGroupRuleRequestTypeDef",
    {
        "IpProtocol": str,
        "FromPort": int,
        "ToPort": int,
        "CidrIpv4": str,
        "CidrIpv6": str,
        "PrefixListId": str,
        "ReferencedGroupId": str,
        "Description": str,
    },
    total=False,
)

_RequiredSendDiagnosticInterruptRequestRequestTypeDef = TypedDict(
    "_RequiredSendDiagnosticInterruptRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalSendDiagnosticInterruptRequestRequestTypeDef = TypedDict(
    "_OptionalSendDiagnosticInterruptRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class SendDiagnosticInterruptRequestRequestTypeDef(
    _RequiredSendDiagnosticInterruptRequestRequestTypeDef,
    _OptionalSendDiagnosticInterruptRequestRequestTypeDef,
):
    pass


ServiceTypeDetailOutputTypeDef = TypedDict(
    "ServiceTypeDetailOutputTypeDef",
    {
        "ServiceType": ServiceTypeType,
    },
)

UserBucketDetailsOutputTypeDef = TypedDict(
    "UserBucketDetailsOutputTypeDef",
    {
        "S3Bucket": str,
        "S3Key": str,
    },
)

SpotCapacityRebalanceOutputTypeDef = TypedDict(
    "SpotCapacityRebalanceOutputTypeDef",
    {
        "ReplacementStrategy": ReplacementStrategyType,
        "TerminationDelay": int,
    },
)

SpotCapacityRebalanceTypeDef = TypedDict(
    "SpotCapacityRebalanceTypeDef",
    {
        "ReplacementStrategy": ReplacementStrategyType,
        "TerminationDelay": int,
    },
    total=False,
)

SpotInstanceStateFaultOutputTypeDef = TypedDict(
    "SpotInstanceStateFaultOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

SpotFleetMonitoringOutputTypeDef = TypedDict(
    "SpotFleetMonitoringOutputTypeDef",
    {
        "Enabled": bool,
    },
)

SpotFleetMonitoringTypeDef = TypedDict(
    "SpotFleetMonitoringTypeDef",
    {
        "Enabled": bool,
    },
    total=False,
)

SpotInstanceStatusOutputTypeDef = TypedDict(
    "SpotInstanceStatusOutputTypeDef",
    {
        "Code": str,
        "Message": str,
        "UpdateTime": datetime,
    },
)

StartInstancesRequestInstanceStartTypeDef = TypedDict(
    "StartInstancesRequestInstanceStartTypeDef",
    {
        "AdditionalInfo": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredStartInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredStartInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalStartInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalStartInstancesRequestRequestTypeDef",
    {
        "AdditionalInfo": str,
        "DryRun": bool,
    },
    total=False,
)


class StartInstancesRequestRequestTypeDef(
    _RequiredStartInstancesRequestRequestTypeDef, _OptionalStartInstancesRequestRequestTypeDef
):
    pass


_RequiredStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef = TypedDict(
    "_RequiredStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef",
    {
        "ServiceId": str,
    },
)
_OptionalStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef = TypedDict(
    "_OptionalStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class StartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef(
    _RequiredStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef,
    _OptionalStartVpcEndpointServicePrivateDnsVerificationRequestRequestTypeDef,
):
    pass


StartVpcEndpointServicePrivateDnsVerificationResultOutputTypeDef = TypedDict(
    "StartVpcEndpointServicePrivateDnsVerificationResultOutputTypeDef",
    {
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StateReasonResponseMetadataTypeDef = TypedDict(
    "StateReasonResponseMetadataTypeDef",
    {
        "Code": str,
        "Message": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StopInstancesRequestInstanceStopTypeDef = TypedDict(
    "StopInstancesRequestInstanceStopTypeDef",
    {
        "Hibernate": bool,
        "DryRun": bool,
        "Force": bool,
    },
    total=False,
)

_RequiredStopInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredStopInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalStopInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalStopInstancesRequestRequestTypeDef",
    {
        "Hibernate": bool,
        "DryRun": bool,
        "Force": bool,
    },
    total=False,
)


class StopInstancesRequestRequestTypeDef(
    _RequiredStopInstancesRequestRequestTypeDef, _OptionalStopInstancesRequestRequestTypeDef
):
    pass


SubnetAssociationOutputTypeDef = TypedDict(
    "SubnetAssociationOutputTypeDef",
    {
        "SubnetId": str,
        "State": TransitGatewayMulitcastDomainAssociationStateType,
    },
)

SubnetCidrBlockStateOutputTypeDef = TypedDict(
    "SubnetCidrBlockStateOutputTypeDef",
    {
        "State": SubnetCidrBlockStateCodeType,
        "StatusMessage": str,
    },
)

TargetConfigurationOutputTypeDef = TypedDict(
    "TargetConfigurationOutputTypeDef",
    {
        "InstanceCount": int,
        "OfferingId": str,
    },
)

TargetGroupOutputTypeDef = TypedDict(
    "TargetGroupOutputTypeDef",
    {
        "Arn": str,
    },
)

TargetGroupTypeDef = TypedDict(
    "TargetGroupTypeDef",
    {
        "Arn": str,
    },
    total=False,
)

_RequiredTerminateClientVpnConnectionsRequestRequestTypeDef = TypedDict(
    "_RequiredTerminateClientVpnConnectionsRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalTerminateClientVpnConnectionsRequestRequestTypeDef = TypedDict(
    "_OptionalTerminateClientVpnConnectionsRequestRequestTypeDef",
    {
        "ConnectionId": str,
        "Username": str,
        "DryRun": bool,
    },
    total=False,
)


class TerminateClientVpnConnectionsRequestRequestTypeDef(
    _RequiredTerminateClientVpnConnectionsRequestRequestTypeDef,
    _OptionalTerminateClientVpnConnectionsRequestRequestTypeDef,
):
    pass


TerminateInstancesRequestInstanceTerminateTypeDef = TypedDict(
    "TerminateInstancesRequestInstanceTerminateTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredTerminateInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredTerminateInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalTerminateInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalTerminateInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class TerminateInstancesRequestRequestTypeDef(
    _RequiredTerminateInstancesRequestRequestTypeDef,
    _OptionalTerminateInstancesRequestRequestTypeDef,
):
    pass


TrafficMirrorPortRangeOutputTypeDef = TypedDict(
    "TrafficMirrorPortRangeOutputTypeDef",
    {
        "FromPort": int,
        "ToPort": int,
    },
)

TransitGatewayAttachmentAssociationOutputTypeDef = TypedDict(
    "TransitGatewayAttachmentAssociationOutputTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": TransitGatewayAssociationStateType,
    },
)

TransitGatewayAttachmentBgpConfigurationOutputTypeDef = TypedDict(
    "TransitGatewayAttachmentBgpConfigurationOutputTypeDef",
    {
        "TransitGatewayAsn": int,
        "PeerAsn": int,
        "TransitGatewayAddress": str,
        "PeerAddress": str,
        "BgpStatus": BgpStatusType,
    },
)

TransitGatewayConnectOptionsOutputTypeDef = TypedDict(
    "TransitGatewayConnectOptionsOutputTypeDef",
    {
        "Protocol": Literal["gre"],
    },
)

TransitGatewayMulticastDomainOptionsOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDomainOptionsOutputTypeDef",
    {
        "Igmpv2Support": Igmpv2SupportValueType,
        "StaticSourcesSupport": StaticSourcesSupportValueType,
        "AutoAcceptSharedAssociations": AutoAcceptSharedAssociationsValueType,
    },
)

TransitGatewayOptionsOutputTypeDef = TypedDict(
    "TransitGatewayOptionsOutputTypeDef",
    {
        "AmazonSideAsn": int,
        "TransitGatewayCidrBlocks": List[str],
        "AutoAcceptSharedAttachments": AutoAcceptSharedAttachmentsValueType,
        "DefaultRouteTableAssociation": DefaultRouteTableAssociationValueType,
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": DefaultRouteTablePropagationValueType,
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": VpnEcmpSupportValueType,
        "DnsSupport": DnsSupportValueType,
        "MulticastSupport": MulticastSupportValueType,
    },
)

TransitGatewayPeeringAttachmentOptionsOutputTypeDef = TypedDict(
    "TransitGatewayPeeringAttachmentOptionsOutputTypeDef",
    {
        "DynamicRouting": DynamicRoutingValueType,
    },
)

TransitGatewayPolicyRuleMetaDataOutputTypeDef = TypedDict(
    "TransitGatewayPolicyRuleMetaDataOutputTypeDef",
    {
        "MetaDataKey": str,
        "MetaDataValue": str,
    },
)

TransitGatewayPrefixListAttachmentOutputTypeDef = TypedDict(
    "TransitGatewayPrefixListAttachmentOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "ResourceId": str,
    },
)

TransitGatewayRouteAttachmentOutputTypeDef = TypedDict(
    "TransitGatewayRouteAttachmentOutputTypeDef",
    {
        "ResourceId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
    },
)

TransitGatewayVpcAttachmentOptionsOutputTypeDef = TypedDict(
    "TransitGatewayVpcAttachmentOptionsOutputTypeDef",
    {
        "DnsSupport": DnsSupportValueType,
        "Ipv6Support": Ipv6SupportValueType,
        "ApplianceModeSupport": ApplianceModeSupportValueType,
    },
)

_RequiredUnassignIpv6AddressesRequestRequestTypeDef = TypedDict(
    "_RequiredUnassignIpv6AddressesRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalUnassignIpv6AddressesRequestRequestTypeDef = TypedDict(
    "_OptionalUnassignIpv6AddressesRequestRequestTypeDef",
    {
        "Ipv6Addresses": Sequence[str],
        "Ipv6Prefixes": Sequence[str],
    },
    total=False,
)


class UnassignIpv6AddressesRequestRequestTypeDef(
    _RequiredUnassignIpv6AddressesRequestRequestTypeDef,
    _OptionalUnassignIpv6AddressesRequestRequestTypeDef,
):
    pass


UnassignIpv6AddressesResultOutputTypeDef = TypedDict(
    "UnassignIpv6AddressesResultOutputTypeDef",
    {
        "NetworkInterfaceId": str,
        "UnassignedIpv6Addresses": List[str],
        "UnassignedIpv6Prefixes": List[str],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UnassignPrivateIpAddressesRequestNetworkInterfaceUnassignPrivateIpAddressesTypeDef = TypedDict(
    "UnassignPrivateIpAddressesRequestNetworkInterfaceUnassignPrivateIpAddressesTypeDef",
    {
        "PrivateIpAddresses": Sequence[str],
        "Ipv4Prefixes": Sequence[str],
    },
    total=False,
)

_RequiredUnassignPrivateIpAddressesRequestRequestTypeDef = TypedDict(
    "_RequiredUnassignPrivateIpAddressesRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalUnassignPrivateIpAddressesRequestRequestTypeDef = TypedDict(
    "_OptionalUnassignPrivateIpAddressesRequestRequestTypeDef",
    {
        "PrivateIpAddresses": Sequence[str],
        "Ipv4Prefixes": Sequence[str],
    },
    total=False,
)


class UnassignPrivateIpAddressesRequestRequestTypeDef(
    _RequiredUnassignPrivateIpAddressesRequestRequestTypeDef,
    _OptionalUnassignPrivateIpAddressesRequestRequestTypeDef,
):
    pass


_RequiredUnassignPrivateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_RequiredUnassignPrivateNatGatewayAddressRequestRequestTypeDef",
    {
        "NatGatewayId": str,
        "PrivateIpAddresses": Sequence[str],
    },
)
_OptionalUnassignPrivateNatGatewayAddressRequestRequestTypeDef = TypedDict(
    "_OptionalUnassignPrivateNatGatewayAddressRequestRequestTypeDef",
    {
        "MaxDrainDurationSeconds": int,
        "DryRun": bool,
    },
    total=False,
)


class UnassignPrivateNatGatewayAddressRequestRequestTypeDef(
    _RequiredUnassignPrivateNatGatewayAddressRequestRequestTypeDef,
    _OptionalUnassignPrivateNatGatewayAddressRequestRequestTypeDef,
):
    pass


UnmonitorInstancesRequestInstanceUnmonitorTypeDef = TypedDict(
    "UnmonitorInstancesRequestInstanceUnmonitorTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)

_RequiredUnmonitorInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredUnmonitorInstancesRequestRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
    },
)
_OptionalUnmonitorInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalUnmonitorInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class UnmonitorInstancesRequestRequestTypeDef(
    _RequiredUnmonitorInstancesRequestRequestTypeDef,
    _OptionalUnmonitorInstancesRequestRequestTypeDef,
):
    pass


UnsuccessfulInstanceCreditSpecificationItemErrorOutputTypeDef = TypedDict(
    "UnsuccessfulInstanceCreditSpecificationItemErrorOutputTypeDef",
    {
        "Code": UnsuccessfulInstanceCreditSpecificationErrorCodeType,
        "Message": str,
    },
)

UnsuccessfulItemErrorOutputTypeDef = TypedDict(
    "UnsuccessfulItemErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

UpdateSecurityGroupRuleDescriptionsEgressResultOutputTypeDef = TypedDict(
    "UpdateSecurityGroupRuleDescriptionsEgressResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UpdateSecurityGroupRuleDescriptionsIngressResultOutputTypeDef = TypedDict(
    "UpdateSecurityGroupRuleDescriptionsIngressResultOutputTypeDef",
    {
        "Return": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ValidationErrorOutputTypeDef = TypedDict(
    "ValidationErrorOutputTypeDef",
    {
        "Code": str,
        "Message": str,
    },
)

VerifiedAccessEndpointEniOptionsOutputTypeDef = TypedDict(
    "VerifiedAccessEndpointEniOptionsOutputTypeDef",
    {
        "NetworkInterfaceId": str,
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
    },
)

VerifiedAccessEndpointLoadBalancerOptionsOutputTypeDef = TypedDict(
    "VerifiedAccessEndpointLoadBalancerOptionsOutputTypeDef",
    {
        "Protocol": VerifiedAccessEndpointProtocolType,
        "Port": int,
        "LoadBalancerArn": str,
        "SubnetIds": List[str],
    },
)

VerifiedAccessEndpointStatusOutputTypeDef = TypedDict(
    "VerifiedAccessEndpointStatusOutputTypeDef",
    {
        "Code": VerifiedAccessEndpointStatusCodeType,
        "Message": str,
    },
)

VerifiedAccessTrustProviderCondensedOutputTypeDef = TypedDict(
    "VerifiedAccessTrustProviderCondensedOutputTypeDef",
    {
        "VerifiedAccessTrustProviderId": str,
        "Description": str,
        "TrustProviderType": TrustProviderTypeType,
        "UserTrustProviderType": UserTrustProviderTypeType,
        "DeviceTrustProviderType": DeviceTrustProviderTypeType,
    },
)

_RequiredVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef = TypedDict(
    "_RequiredVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef",
    {
        "Enabled": bool,
    },
)
_OptionalVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef = TypedDict(
    "_OptionalVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef",
    {
        "LogGroup": str,
    },
    total=False,
)


class VerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef(
    _RequiredVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef,
    _OptionalVerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef,
):
    pass


VerifiedAccessLogDeliveryStatusOutputTypeDef = TypedDict(
    "VerifiedAccessLogDeliveryStatusOutputTypeDef",
    {
        "Code": VerifiedAccessLogDeliveryStatusCodeType,
        "Message": str,
    },
)

_RequiredVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef = TypedDict(
    "_RequiredVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef",
    {
        "Enabled": bool,
    },
)
_OptionalVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef = TypedDict(
    "_OptionalVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef",
    {
        "DeliveryStream": str,
    },
    total=False,
)


class VerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef(
    _RequiredVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef,
    _OptionalVerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef,
):
    pass


_RequiredVerifiedAccessLogS3DestinationOptionsTypeDef = TypedDict(
    "_RequiredVerifiedAccessLogS3DestinationOptionsTypeDef",
    {
        "Enabled": bool,
    },
)
_OptionalVerifiedAccessLogS3DestinationOptionsTypeDef = TypedDict(
    "_OptionalVerifiedAccessLogS3DestinationOptionsTypeDef",
    {
        "BucketName": str,
        "Prefix": str,
        "BucketOwner": str,
    },
    total=False,
)


class VerifiedAccessLogS3DestinationOptionsTypeDef(
    _RequiredVerifiedAccessLogS3DestinationOptionsTypeDef,
    _OptionalVerifiedAccessLogS3DestinationOptionsTypeDef,
):
    pass


VgwTelemetryOutputTypeDef = TypedDict(
    "VgwTelemetryOutputTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": TelemetryStatusType,
        "StatusMessage": str,
        "CertificateArn": str,
    },
)

VolumeAttachmentOutputTypeDef = TypedDict(
    "VolumeAttachmentOutputTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": VolumeAttachmentStateType,
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
)

VolumeAttachmentResponseMetadataTypeDef = TypedDict(
    "VolumeAttachmentResponseMetadataTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": VolumeAttachmentStateType,
        "VolumeId": str,
        "DeleteOnTermination": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VolumeStatusActionOutputTypeDef = TypedDict(
    "VolumeStatusActionOutputTypeDef",
    {
        "Code": str,
        "Description": str,
        "EventId": str,
        "EventType": str,
    },
)

VolumeStatusAttachmentStatusOutputTypeDef = TypedDict(
    "VolumeStatusAttachmentStatusOutputTypeDef",
    {
        "IoPerformance": str,
        "InstanceId": str,
    },
)

VolumeStatusDetailsOutputTypeDef = TypedDict(
    "VolumeStatusDetailsOutputTypeDef",
    {
        "Name": VolumeStatusNameType,
        "Status": str,
    },
)

VolumeStatusEventOutputTypeDef = TypedDict(
    "VolumeStatusEventOutputTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "InstanceId": str,
    },
)

VpcCidrBlockStateOutputTypeDef = TypedDict(
    "VpcCidrBlockStateOutputTypeDef",
    {
        "State": VpcCidrBlockStateCodeType,
        "StatusMessage": str,
    },
)

VpcPeeringConnectionOptionsDescriptionOutputTypeDef = TypedDict(
    "VpcPeeringConnectionOptionsDescriptionOutputTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
)

VpcPeeringConnectionStateReasonOutputTypeDef = TypedDict(
    "VpcPeeringConnectionStateReasonOutputTypeDef",
    {
        "Code": VpcPeeringConnectionStateReasonCodeType,
        "Message": str,
    },
)

VpcPeeringConnectionStateReasonResponseMetadataTypeDef = TypedDict(
    "VpcPeeringConnectionStateReasonResponseMetadataTypeDef",
    {
        "Code": VpcPeeringConnectionStateReasonCodeType,
        "Message": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpnStaticRouteOutputTypeDef = TypedDict(
    "VpnStaticRouteOutputTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": Literal["Static"],
        "State": VpnStateType,
    },
)

_RequiredWithdrawByoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredWithdrawByoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
    },
)
_OptionalWithdrawByoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalWithdrawByoipCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class WithdrawByoipCidrRequestRequestTypeDef(
    _RequiredWithdrawByoipCidrRequestRequestTypeDef, _OptionalWithdrawByoipCidrRequestRequestTypeDef
):
    pass


AcceptAddressTransferResultOutputTypeDef = TypedDict(
    "AcceptAddressTransferResultOutputTypeDef",
    {
        "AddressTransfer": AddressTransferOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeAddressTransfersResultOutputTypeDef = TypedDict(
    "DescribeAddressTransfersResultOutputTypeDef",
    {
        "AddressTransfers": List[AddressTransferOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisableAddressTransferResultOutputTypeDef = TypedDict(
    "DisableAddressTransferResultOutputTypeDef",
    {
        "AddressTransfer": AddressTransferOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableAddressTransferResultOutputTypeDef = TypedDict(
    "EnableAddressTransferResultOutputTypeDef",
    {
        "AddressTransfer": AddressTransferOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef",
    {
        "ReservedInstanceIds": Sequence[str],
    },
)
_OptionalAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TargetConfigurations": Sequence[TargetConfigurationRequestTypeDef],
    },
    total=False,
)


class AcceptReservedInstancesExchangeQuoteRequestRequestTypeDef(
    _RequiredAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef,
    _OptionalAcceptReservedInstancesExchangeQuoteRequestRequestTypeDef,
):
    pass


_RequiredGetReservedInstancesExchangeQuoteRequestRequestTypeDef = TypedDict(
    "_RequiredGetReservedInstancesExchangeQuoteRequestRequestTypeDef",
    {
        "ReservedInstanceIds": Sequence[str],
    },
)
_OptionalGetReservedInstancesExchangeQuoteRequestRequestTypeDef = TypedDict(
    "_OptionalGetReservedInstancesExchangeQuoteRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TargetConfigurations": Sequence[TargetConfigurationRequestTypeDef],
    },
    total=False,
)


class GetReservedInstancesExchangeQuoteRequestRequestTypeDef(
    _RequiredGetReservedInstancesExchangeQuoteRequestRequestTypeDef,
    _OptionalGetReservedInstancesExchangeQuoteRequestRequestTypeDef,
):
    pass


AccountAttributeOutputTypeDef = TypedDict(
    "AccountAttributeOutputTypeDef",
    {
        "AttributeName": str,
        "AttributeValues": List[AccountAttributeValueOutputTypeDef],
    },
)

DescribeFleetInstancesResultOutputTypeDef = TypedDict(
    "DescribeFleetInstancesResultOutputTypeDef",
    {
        "ActiveInstances": List[ActiveInstanceOutputTypeDef],
        "NextToken": str,
        "FleetId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotFleetInstancesResponseOutputTypeDef = TypedDict(
    "DescribeSpotFleetInstancesResponseOutputTypeDef",
    {
        "ActiveInstances": List[ActiveInstanceOutputTypeDef],
        "NextToken": str,
        "SpotFleetRequestId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpcEndpointServicePermissionsResultOutputTypeDef = TypedDict(
    "ModifyVpcEndpointServicePermissionsResultOutputTypeDef",
    {
        "AddedPrincipals": List[AddedPrincipalOutputTypeDef],
        "ReturnValue": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AnalysisLoadBalancerTargetOutputTypeDef = TypedDict(
    "AnalysisLoadBalancerTargetOutputTypeDef",
    {
        "Address": str,
        "AvailabilityZone": str,
        "Instance": AnalysisComponentOutputTypeDef,
        "Port": int,
    },
)

RuleGroupRuleOptionsPairOutputTypeDef = TypedDict(
    "RuleGroupRuleOptionsPairOutputTypeDef",
    {
        "RuleGroupArn": str,
        "RuleOptions": List[RuleOptionOutputTypeDef],
    },
)

AddressAttributeOutputTypeDef = TypedDict(
    "AddressAttributeOutputTypeDef",
    {
        "PublicIp": str,
        "AllocationId": str,
        "PtrRecord": str,
        "PtrRecordUpdate": PtrUpdateStatusOutputTypeDef,
    },
)

AddressOutputTypeDef = TypedDict(
    "AddressOutputTypeDef",
    {
        "InstanceId": str,
        "PublicIp": str,
        "AllocationId": str,
        "AssociationId": str,
        "Domain": DomainTypeType,
        "NetworkInterfaceId": str,
        "NetworkInterfaceOwnerId": str,
        "PrivateIpAddress": str,
        "Tags": List[TagOutputTypeDef],
        "PublicIpv4Pool": str,
        "NetworkBorderGroup": str,
        "CustomerOwnedIp": str,
        "CustomerOwnedIpv4Pool": str,
        "CarrierIp": str,
    },
)

AllowedPrincipalOutputTypeDef = TypedDict(
    "AllowedPrincipalOutputTypeDef",
    {
        "PrincipalType": PrincipalTypeType,
        "Principal": str,
        "ServicePermissionId": str,
        "Tags": List[TagOutputTypeDef],
        "ServiceId": str,
    },
)

CarrierGatewayOutputTypeDef = TypedDict(
    "CarrierGatewayOutputTypeDef",
    {
        "CarrierGatewayId": str,
        "VpcId": str,
        "State": CarrierGatewayStateType,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

CoipPoolOutputTypeDef = TypedDict(
    "CoipPoolOutputTypeDef",
    {
        "PoolId": str,
        "PoolCidrs": List[str],
        "LocalGatewayRouteTableId": str,
        "Tags": List[TagOutputTypeDef],
        "PoolArn": str,
    },
)

CopySnapshotResultOutputTypeDef = TypedDict(
    "CopySnapshotResultOutputTypeDef",
    {
        "SnapshotId": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateSecurityGroupResultOutputTypeDef = TypedDict(
    "CreateSecurityGroupResultOutputTypeDef",
    {
        "GroupId": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CustomerGatewayOutputTypeDef = TypedDict(
    "CustomerGatewayOutputTypeDef",
    {
        "BgpAsn": str,
        "CustomerGatewayId": str,
        "IpAddress": str,
        "CertificateArn": str,
        "State": str,
        "Type": str,
        "DeviceName": str,
        "Tags": List[TagOutputTypeDef],
    },
)

Ec2InstanceConnectEndpointOutputTypeDef = TypedDict(
    "Ec2InstanceConnectEndpointOutputTypeDef",
    {
        "OwnerId": str,
        "InstanceConnectEndpointId": str,
        "InstanceConnectEndpointArn": str,
        "State": Ec2InstanceConnectEndpointStateType,
        "StateMessage": str,
        "DnsName": str,
        "FipsDnsName": str,
        "NetworkInterfaceIds": List[str],
        "VpcId": str,
        "AvailabilityZone": str,
        "CreatedAt": datetime,
        "SubnetId": str,
        "PreserveClientIp": bool,
        "SecurityGroupIds": List[str],
        "Tags": List[TagOutputTypeDef],
    },
)

HostReservationOutputTypeDef = TypedDict(
    "HostReservationOutputTypeDef",
    {
        "Count": int,
        "CurrencyCode": Literal["USD"],
        "Duration": int,
        "End": datetime,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": PaymentOptionType,
        "Start": datetime,
        "State": ReservationStateType,
        "UpfrontPrice": str,
        "Tags": List[TagOutputTypeDef],
    },
)

ImportKeyPairResultOutputTypeDef = TypedDict(
    "ImportKeyPairResultOutputTypeDef",
    {
        "KeyFingerprint": str,
        "KeyName": str,
        "KeyPairId": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceEventWindowAssociationTargetOutputTypeDef = TypedDict(
    "InstanceEventWindowAssociationTargetOutputTypeDef",
    {
        "InstanceIds": List[str],
        "Tags": List[TagOutputTypeDef],
        "DedicatedHostIds": List[str],
    },
)

IpamResourceDiscoveryAssociationOutputTypeDef = TypedDict(
    "IpamResourceDiscoveryAssociationOutputTypeDef",
    {
        "OwnerId": str,
        "IpamResourceDiscoveryAssociationId": str,
        "IpamResourceDiscoveryAssociationArn": str,
        "IpamResourceDiscoveryId": str,
        "IpamId": str,
        "IpamArn": str,
        "IpamRegion": str,
        "IsDefault": bool,
        "ResourceDiscoveryStatus": IpamAssociatedResourceDiscoveryStatusType,
        "State": IpamResourceDiscoveryAssociationStateType,
        "Tags": List[TagOutputTypeDef],
    },
)

IpamScopeOutputTypeDef = TypedDict(
    "IpamScopeOutputTypeDef",
    {
        "OwnerId": str,
        "IpamScopeId": str,
        "IpamScopeArn": str,
        "IpamArn": str,
        "IpamRegion": str,
        "IpamScopeType": IpamScopeTypeType,
        "IsDefault": bool,
        "Description": str,
        "PoolCount": int,
        "State": IpamScopeStateType,
        "Tags": List[TagOutputTypeDef],
    },
)

KeyPairInfoOutputTypeDef = TypedDict(
    "KeyPairInfoOutputTypeDef",
    {
        "KeyPairId": str,
        "KeyFingerprint": str,
        "KeyName": str,
        "KeyType": KeyTypeType,
        "Tags": List[TagOutputTypeDef],
        "PublicKey": str,
        "CreateTime": datetime,
    },
)

KeyPairOutputTypeDef = TypedDict(
    "KeyPairOutputTypeDef",
    {
        "KeyFingerprint": str,
        "KeyMaterial": str,
        "KeyName": str,
        "KeyPairId": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

LaunchTemplateOutputTypeDef = TypedDict(
    "LaunchTemplateOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[TagOutputTypeDef],
    },
)

LaunchTemplateTagSpecificationOutputTypeDef = TypedDict(
    "LaunchTemplateTagSpecificationOutputTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": List[TagOutputTypeDef],
    },
)

LocalGatewayOutputTypeDef = TypedDict(
    "LocalGatewayOutputTypeDef",
    {
        "LocalGatewayId": str,
        "OutpostArn": str,
        "OwnerId": str,
        "State": str,
        "Tags": List[TagOutputTypeDef],
    },
)

LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef = TypedDict(
    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": str,
        "LocalGatewayVirtualInterfaceGroupId": str,
        "LocalGatewayId": str,
        "LocalGatewayRouteTableId": str,
        "LocalGatewayRouteTableArn": str,
        "OwnerId": str,
        "State": str,
        "Tags": List[TagOutputTypeDef],
    },
)

LocalGatewayRouteTableVpcAssociationOutputTypeDef = TypedDict(
    "LocalGatewayRouteTableVpcAssociationOutputTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociationId": str,
        "LocalGatewayRouteTableId": str,
        "LocalGatewayRouteTableArn": str,
        "LocalGatewayId": str,
        "VpcId": str,
        "OwnerId": str,
        "State": str,
        "Tags": List[TagOutputTypeDef],
    },
)

LocalGatewayVirtualInterfaceGroupOutputTypeDef = TypedDict(
    "LocalGatewayVirtualInterfaceGroupOutputTypeDef",
    {
        "LocalGatewayVirtualInterfaceGroupId": str,
        "LocalGatewayVirtualInterfaceIds": List[str],
        "LocalGatewayId": str,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

LocalGatewayVirtualInterfaceOutputTypeDef = TypedDict(
    "LocalGatewayVirtualInterfaceOutputTypeDef",
    {
        "LocalGatewayVirtualInterfaceId": str,
        "LocalGatewayId": str,
        "Vlan": int,
        "LocalAddress": str,
        "PeerAddress": str,
        "LocalBgpAsn": int,
        "PeerBgpAsn": int,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

ManagedPrefixListOutputTypeDef = TypedDict(
    "ManagedPrefixListOutputTypeDef",
    {
        "PrefixListId": str,
        "AddressFamily": str,
        "State": PrefixListStateType,
        "StateMessage": str,
        "PrefixListArn": str,
        "PrefixListName": str,
        "MaxEntries": int,
        "Version": int,
        "Tags": List[TagOutputTypeDef],
        "OwnerId": str,
    },
)

NetworkInsightsAccessScopeAnalysisOutputTypeDef = TypedDict(
    "NetworkInsightsAccessScopeAnalysisOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
        "NetworkInsightsAccessScopeAnalysisArn": str,
        "NetworkInsightsAccessScopeId": str,
        "Status": AnalysisStatusType,
        "StatusMessage": str,
        "WarningMessage": str,
        "StartDate": datetime,
        "EndDate": datetime,
        "FindingsFound": FindingsFoundType,
        "AnalyzedEniCount": int,
        "Tags": List[TagOutputTypeDef],
    },
)

NetworkInsightsAccessScopeOutputTypeDef = TypedDict(
    "NetworkInsightsAccessScopeOutputTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
        "NetworkInsightsAccessScopeArn": str,
        "CreatedDate": datetime,
        "UpdatedDate": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

PlacementGroupOutputTypeDef = TypedDict(
    "PlacementGroupOutputTypeDef",
    {
        "GroupName": str,
        "State": PlacementGroupStateType,
        "Strategy": PlacementStrategyType,
        "PartitionCount": int,
        "GroupId": str,
        "Tags": List[TagOutputTypeDef],
        "GroupArn": str,
        "SpreadLevel": SpreadLevelType,
    },
)

ReplaceRootVolumeTaskOutputTypeDef = TypedDict(
    "ReplaceRootVolumeTaskOutputTypeDef",
    {
        "ReplaceRootVolumeTaskId": str,
        "InstanceId": str,
        "TaskState": ReplaceRootVolumeTaskStateType,
        "StartTime": str,
        "CompleteTime": str,
        "Tags": List[TagOutputTypeDef],
        "ImageId": str,
        "SnapshotId": str,
        "DeleteReplacedRootVolume": bool,
    },
)

SnapshotInfoOutputTypeDef = TypedDict(
    "SnapshotInfoOutputTypeDef",
    {
        "Description": str,
        "Tags": List[TagOutputTypeDef],
        "Encrypted": bool,
        "VolumeId": str,
        "State": SnapshotStateType,
        "VolumeSize": int,
        "StartTime": datetime,
        "Progress": str,
        "OwnerId": str,
        "SnapshotId": str,
        "OutpostArn": str,
    },
)

SnapshotOutputTypeDef = TypedDict(
    "SnapshotOutputTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": SnapshotStateType,
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "OutpostArn": str,
        "Tags": List[TagOutputTypeDef],
        "StorageTier": StorageTierType,
        "RestoreExpiryTime": datetime,
    },
)

SnapshotResponseMetadataTypeDef = TypedDict(
    "SnapshotResponseMetadataTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": SnapshotStateType,
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "OutpostArn": str,
        "Tags": List[TagOutputTypeDef],
        "StorageTier": StorageTierType,
        "RestoreExpiryTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SnapshotTierStatusOutputTypeDef = TypedDict(
    "SnapshotTierStatusOutputTypeDef",
    {
        "SnapshotId": str,
        "VolumeId": str,
        "Status": SnapshotStateType,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
        "StorageTier": StorageTierType,
        "LastTieringStartTime": datetime,
        "LastTieringProgress": int,
        "LastTieringOperationStatus": TieringOperationStatusType,
        "LastTieringOperationStatusDetail": str,
        "ArchivalCompleteTime": datetime,
        "RestoreExpiryTime": datetime,
    },
)

SpotFleetTagSpecificationOutputTypeDef = TypedDict(
    "SpotFleetTagSpecificationOutputTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": List[TagOutputTypeDef],
    },
)

SubnetCidrReservationOutputTypeDef = TypedDict(
    "SubnetCidrReservationOutputTypeDef",
    {
        "SubnetCidrReservationId": str,
        "SubnetId": str,
        "Cidr": str,
        "ReservationType": SubnetCidrReservationTypeType,
        "OwnerId": str,
        "Description": str,
        "Tags": List[TagOutputTypeDef],
    },
)

TagSpecificationOutputTypeDef = TypedDict(
    "TagSpecificationOutputTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": List[TagOutputTypeDef],
    },
)

TrafficMirrorSessionOutputTypeDef = TypedDict(
    "TrafficMirrorSessionOutputTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[TagOutputTypeDef],
    },
)

TrafficMirrorTargetOutputTypeDef = TypedDict(
    "TrafficMirrorTargetOutputTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": TrafficMirrorTargetTypeType,
        "Description": str,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
        "GatewayLoadBalancerEndpointId": str,
    },
)

TransitGatewayPolicyTableOutputTypeDef = TypedDict(
    "TransitGatewayPolicyTableOutputTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
        "TransitGatewayId": str,
        "State": TransitGatewayPolicyTableStateType,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayRouteTableAnnouncementOutputTypeDef = TypedDict(
    "TransitGatewayRouteTableAnnouncementOutputTypeDef",
    {
        "TransitGatewayRouteTableAnnouncementId": str,
        "TransitGatewayId": str,
        "CoreNetworkId": str,
        "PeerTransitGatewayId": str,
        "PeerCoreNetworkId": str,
        "PeeringAttachmentId": str,
        "AnnouncementDirection": TransitGatewayRouteTableAnnouncementDirectionType,
        "TransitGatewayRouteTableId": str,
        "State": TransitGatewayRouteTableAnnouncementStateType,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayRouteTableOutputTypeDef = TypedDict(
    "TransitGatewayRouteTableOutputTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": TransitGatewayRouteTableStateType,
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TrunkInterfaceAssociationOutputTypeDef = TypedDict(
    "TrunkInterfaceAssociationOutputTypeDef",
    {
        "AssociationId": str,
        "BranchInterfaceId": str,
        "TrunkInterfaceId": str,
        "InterfaceProtocol": InterfaceProtocolTypeType,
        "VlanId": int,
        "GreKey": int,
        "Tags": List[TagOutputTypeDef],
    },
)

VerifiedAccessGroupOutputTypeDef = TypedDict(
    "VerifiedAccessGroupOutputTypeDef",
    {
        "VerifiedAccessGroupId": str,
        "VerifiedAccessInstanceId": str,
        "Description": str,
        "Owner": str,
        "VerifiedAccessGroupArn": str,
        "CreationTime": str,
        "LastUpdatedTime": str,
        "DeletionTime": str,
        "Tags": List[TagOutputTypeDef],
    },
)

VpcClassicLinkOutputTypeDef = TypedDict(
    "VpcClassicLinkOutputTypeDef",
    {
        "ClassicLinkEnabled": bool,
        "Tags": List[TagOutputTypeDef],
        "VpcId": str,
    },
)

AdvertiseByoipCidrResultOutputTypeDef = TypedDict(
    "AdvertiseByoipCidrResultOutputTypeDef",
    {
        "ByoipCidr": ByoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeprovisionByoipCidrResultOutputTypeDef = TypedDict(
    "DeprovisionByoipCidrResultOutputTypeDef",
    {
        "ByoipCidr": ByoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeByoipCidrsResultOutputTypeDef = TypedDict(
    "DescribeByoipCidrsResultOutputTypeDef",
    {
        "ByoipCidrs": List[ByoipCidrOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

MoveByoipCidrToIpamResultOutputTypeDef = TypedDict(
    "MoveByoipCidrToIpamResultOutputTypeDef",
    {
        "ByoipCidr": ByoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ProvisionByoipCidrResultOutputTypeDef = TypedDict(
    "ProvisionByoipCidrResultOutputTypeDef",
    {
        "ByoipCidr": ByoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

WithdrawByoipCidrResultOutputTypeDef = TypedDict(
    "WithdrawByoipCidrResultOutputTypeDef",
    {
        "ByoipCidr": ByoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AllocateIpamPoolCidrResultOutputTypeDef = TypedDict(
    "AllocateIpamPoolCidrResultOutputTypeDef",
    {
        "IpamPoolAllocation": IpamPoolAllocationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetIpamPoolAllocationsResultOutputTypeDef = TypedDict(
    "GetIpamPoolAllocationsResultOutputTypeDef",
    {
        "IpamPoolAllocations": List[IpamPoolAllocationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AnalysisAclRuleOutputTypeDef = TypedDict(
    "AnalysisAclRuleOutputTypeDef",
    {
        "Cidr": str,
        "Egress": bool,
        "PortRange": PortRangeOutputTypeDef,
        "Protocol": str,
        "RuleAction": str,
        "RuleNumber": int,
    },
)

AnalysisPacketHeaderOutputTypeDef = TypedDict(
    "AnalysisPacketHeaderOutputTypeDef",
    {
        "DestinationAddresses": List[str],
        "DestinationPortRanges": List[PortRangeOutputTypeDef],
        "Protocol": str,
        "SourceAddresses": List[str],
        "SourcePortRanges": List[PortRangeOutputTypeDef],
    },
)

AnalysisSecurityGroupRuleOutputTypeDef = TypedDict(
    "AnalysisSecurityGroupRuleOutputTypeDef",
    {
        "Cidr": str,
        "Direction": str,
        "SecurityGroupId": str,
        "PortRange": PortRangeOutputTypeDef,
        "PrefixListId": str,
        "Protocol": str,
    },
)

FirewallStatefulRuleOutputTypeDef = TypedDict(
    "FirewallStatefulRuleOutputTypeDef",
    {
        "RuleGroupArn": str,
        "Sources": List[str],
        "Destinations": List[str],
        "SourcePorts": List[PortRangeOutputTypeDef],
        "DestinationPorts": List[PortRangeOutputTypeDef],
        "Protocol": str,
        "RuleAction": str,
        "Direction": str,
    },
)

FirewallStatelessRuleOutputTypeDef = TypedDict(
    "FirewallStatelessRuleOutputTypeDef",
    {
        "RuleGroupArn": str,
        "Sources": List[str],
        "Destinations": List[str],
        "SourcePorts": List[PortRangeOutputTypeDef],
        "DestinationPorts": List[PortRangeOutputTypeDef],
        "Protocols": List[int],
        "RuleAction": str,
        "Priority": int,
    },
)

AssignPrivateIpAddressesResultOutputTypeDef = TypedDict(
    "AssignPrivateIpAddressesResultOutputTypeDef",
    {
        "NetworkInterfaceId": str,
        "AssignedPrivateIpAddresses": List[AssignedPrivateIpAddressOutputTypeDef],
        "AssignedIpv4Prefixes": List[Ipv4PrefixSpecificationOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssignPrivateNatGatewayAddressResultOutputTypeDef = TypedDict(
    "AssignPrivateNatGatewayAddressResultOutputTypeDef",
    {
        "NatGatewayId": str,
        "NatGatewayAddresses": List[NatGatewayAddressOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateNatGatewayAddressResultOutputTypeDef = TypedDict(
    "AssociateNatGatewayAddressResultOutputTypeDef",
    {
        "NatGatewayId": str,
        "NatGatewayAddresses": List[NatGatewayAddressOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateNatGatewayAddressResultOutputTypeDef = TypedDict(
    "DisassociateNatGatewayAddressResultOutputTypeDef",
    {
        "NatGatewayId": str,
        "NatGatewayAddresses": List[NatGatewayAddressOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UnassignPrivateNatGatewayAddressResultOutputTypeDef = TypedDict(
    "UnassignPrivateNatGatewayAddressResultOutputTypeDef",
    {
        "NatGatewayId": str,
        "NatGatewayAddresses": List[NatGatewayAddressOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateClientVpnTargetNetworkResultOutputTypeDef = TypedDict(
    "AssociateClientVpnTargetNetworkResultOutputTypeDef",
    {
        "AssociationId": str,
        "Status": AssociationStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateClientVpnTargetNetworkResultOutputTypeDef = TypedDict(
    "DisassociateClientVpnTargetNetworkResultOutputTypeDef",
    {
        "AssociationId": str,
        "Status": AssociationStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TargetNetworkOutputTypeDef = TypedDict(
    "TargetNetworkOutputTypeDef",
    {
        "AssociationId": str,
        "VpcId": str,
        "TargetNetworkId": str,
        "ClientVpnEndpointId": str,
        "Status": AssociationStatusOutputTypeDef,
        "SecurityGroups": List[str],
    },
)

AssociateIamInstanceProfileRequestRequestTypeDef = TypedDict(
    "AssociateIamInstanceProfileRequestRequestTypeDef",
    {
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "InstanceId": str,
    },
)

ReplaceIamInstanceProfileAssociationRequestRequestTypeDef = TypedDict(
    "ReplaceIamInstanceProfileAssociationRequestRequestTypeDef",
    {
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "AssociationId": str,
    },
)

AssociateRouteTableResultOutputTypeDef = TypedDict(
    "AssociateRouteTableResultOutputTypeDef",
    {
        "AssociationId": str,
        "AssociationState": RouteTableAssociationStateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReplaceRouteTableAssociationResultOutputTypeDef = TypedDict(
    "ReplaceRouteTableAssociationResultOutputTypeDef",
    {
        "NewAssociationId": str,
        "AssociationState": RouteTableAssociationStateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RouteTableAssociationOutputTypeDef = TypedDict(
    "RouteTableAssociationOutputTypeDef",
    {
        "Main": bool,
        "RouteTableAssociationId": str,
        "RouteTableId": str,
        "SubnetId": str,
        "GatewayId": str,
        "AssociationState": RouteTableAssociationStateOutputTypeDef,
    },
)

AssociateTransitGatewayPolicyTableResultOutputTypeDef = TypedDict(
    "AssociateTransitGatewayPolicyTableResultOutputTypeDef",
    {
        "Association": TransitGatewayPolicyTableAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateTransitGatewayPolicyTableResultOutputTypeDef = TypedDict(
    "DisassociateTransitGatewayPolicyTableResultOutputTypeDef",
    {
        "Association": TransitGatewayPolicyTableAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayPolicyTableAssociationsResultOutputTypeDef = TypedDict(
    "GetTransitGatewayPolicyTableAssociationsResultOutputTypeDef",
    {
        "Associations": List[TransitGatewayPolicyTableAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateTransitGatewayRouteTableResultOutputTypeDef = TypedDict(
    "AssociateTransitGatewayRouteTableResultOutputTypeDef",
    {
        "Association": TransitGatewayAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateTransitGatewayRouteTableResultOutputTypeDef = TypedDict(
    "DisassociateTransitGatewayRouteTableResultOutputTypeDef",
    {
        "Association": TransitGatewayAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetAssociatedEnclaveCertificateIamRolesResultOutputTypeDef = TypedDict(
    "GetAssociatedEnclaveCertificateIamRolesResultOutputTypeDef",
    {
        "AssociatedRoles": List[AssociatedRoleOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

IntegrateServicesTypeDef = TypedDict(
    "IntegrateServicesTypeDef",
    {
        "AthenaIntegrations": Sequence[AthenaIntegrationTypeDef],
    },
    total=False,
)

AttachVpnGatewayResultOutputTypeDef = TypedDict(
    "AttachVpnGatewayResultOutputTypeDef",
    {
        "VpcAttachment": VpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpnGatewayOutputTypeDef = TypedDict(
    "VpnGatewayOutputTypeDef",
    {
        "AvailabilityZone": str,
        "State": VpnStateType,
        "Type": Literal["ipsec.1"],
        "VpcAttachments": List[VpcAttachmentOutputTypeDef],
        "VpnGatewayId": str,
        "AmazonSideAsn": int,
        "Tags": List[TagOutputTypeDef],
    },
)

AttachmentEnaSrdSpecificationOutputTypeDef = TypedDict(
    "AttachmentEnaSrdSpecificationOutputTypeDef",
    {
        "EnaSrdEnabled": bool,
        "EnaSrdUdpSpecification": AttachmentEnaSrdUdpSpecificationOutputTypeDef,
    },
)

DescribeVpcAttributeResultOutputTypeDef = TypedDict(
    "DescribeVpcAttributeResultOutputTypeDef",
    {
        "VpcId": str,
        "EnableDnsHostnames": AttributeBooleanValueOutputTypeDef,
        "EnableDnsSupport": AttributeBooleanValueOutputTypeDef,
        "EnableNetworkAddressUsageMetrics": AttributeBooleanValueOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifySubnetAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifySubnetAttributeRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalModifySubnetAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifySubnetAttributeRequestRequestTypeDef",
    {
        "AssignIpv6AddressOnCreation": AttributeBooleanValueTypeDef,
        "MapPublicIpOnLaunch": AttributeBooleanValueTypeDef,
        "MapCustomerOwnedIpOnLaunch": AttributeBooleanValueTypeDef,
        "CustomerOwnedIpv4Pool": str,
        "EnableDns64": AttributeBooleanValueTypeDef,
        "PrivateDnsHostnameTypeOnLaunch": HostnameTypeType,
        "EnableResourceNameDnsARecordOnLaunch": AttributeBooleanValueTypeDef,
        "EnableResourceNameDnsAAAARecordOnLaunch": AttributeBooleanValueTypeDef,
        "EnableLniAtDeviceIndex": int,
        "DisableLniAtDeviceIndex": AttributeBooleanValueTypeDef,
    },
    total=False,
)


class ModifySubnetAttributeRequestRequestTypeDef(
    _RequiredModifySubnetAttributeRequestRequestTypeDef,
    _OptionalModifySubnetAttributeRequestRequestTypeDef,
):
    pass


_RequiredModifyVolumeAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVolumeAttributeRequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalModifyVolumeAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVolumeAttributeRequestRequestTypeDef",
    {
        "AutoEnableIO": AttributeBooleanValueTypeDef,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVolumeAttributeRequestRequestTypeDef(
    _RequiredModifyVolumeAttributeRequestRequestTypeDef,
    _OptionalModifyVolumeAttributeRequestRequestTypeDef,
):
    pass


ModifyVolumeAttributeRequestVolumeModifyAttributeTypeDef = TypedDict(
    "ModifyVolumeAttributeRequestVolumeModifyAttributeTypeDef",
    {
        "AutoEnableIO": AttributeBooleanValueTypeDef,
        "DryRun": bool,
    },
    total=False,
)

_RequiredModifyVpcAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcAttributeRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalModifyVpcAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcAttributeRequestRequestTypeDef",
    {
        "EnableDnsHostnames": AttributeBooleanValueTypeDef,
        "EnableDnsSupport": AttributeBooleanValueTypeDef,
        "EnableNetworkAddressUsageMetrics": AttributeBooleanValueTypeDef,
    },
    total=False,
)


class ModifyVpcAttributeRequestRequestTypeDef(
    _RequiredModifyVpcAttributeRequestRequestTypeDef,
    _OptionalModifyVpcAttributeRequestRequestTypeDef,
):
    pass


ModifyVpcAttributeRequestVpcModifyAttributeTypeDef = TypedDict(
    "ModifyVpcAttributeRequestVpcModifyAttributeTypeDef",
    {
        "EnableDnsHostnames": AttributeBooleanValueTypeDef,
        "EnableDnsSupport": AttributeBooleanValueTypeDef,
        "EnableNetworkAddressUsageMetrics": AttributeBooleanValueTypeDef,
    },
    total=False,
)

DhcpConfigurationOutputTypeDef = TypedDict(
    "DhcpConfigurationOutputTypeDef",
    {
        "Key": str,
        "Values": List[AttributeValueOutputTypeDef],
    },
)

AuthorizationRuleOutputTypeDef = TypedDict(
    "AuthorizationRuleOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "GroupId": str,
        "AccessAll": bool,
        "DestinationCidr": str,
        "Status": ClientVpnAuthorizationRuleStatusOutputTypeDef,
    },
)

AuthorizeClientVpnIngressResultOutputTypeDef = TypedDict(
    "AuthorizeClientVpnIngressResultOutputTypeDef",
    {
        "Status": ClientVpnAuthorizationRuleStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RevokeClientVpnIngressResultOutputTypeDef = TypedDict(
    "RevokeClientVpnIngressResultOutputTypeDef",
    {
        "Status": ClientVpnAuthorizationRuleStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AvailabilityZoneOutputTypeDef = TypedDict(
    "AvailabilityZoneOutputTypeDef",
    {
        "State": AvailabilityZoneStateType,
        "OptInStatus": AvailabilityZoneOptInStatusType,
        "Messages": List[AvailabilityZoneMessageOutputTypeDef],
        "RegionName": str,
        "ZoneName": str,
        "ZoneId": str,
        "GroupName": str,
        "NetworkBorderGroup": str,
        "ZoneType": str,
        "ParentZoneName": str,
        "ParentZoneId": str,
    },
)

AvailableCapacityOutputTypeDef = TypedDict(
    "AvailableCapacityOutputTypeDef",
    {
        "AvailableInstanceCapacity": List[InstanceCapacityOutputTypeDef],
        "AvailableVCpus": int,
    },
)

BlockDeviceMappingOutputTypeDef = TypedDict(
    "BlockDeviceMappingOutputTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": EbsBlockDeviceOutputTypeDef,
        "NoDevice": str,
    },
)

BlockDeviceMappingTypeDef = TypedDict(
    "BlockDeviceMappingTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": EbsBlockDeviceTypeDef,
        "NoDevice": str,
    },
    total=False,
)

FailedCapacityReservationFleetCancellationResultOutputTypeDef = TypedDict(
    "FailedCapacityReservationFleetCancellationResultOutputTypeDef",
    {
        "CapacityReservationFleetId": str,
        "CancelCapacityReservationFleetError": CancelCapacityReservationFleetErrorOutputTypeDef,
    },
)

CancelSpotFleetRequestsErrorItemOutputTypeDef = TypedDict(
    "CancelSpotFleetRequestsErrorItemOutputTypeDef",
    {
        "Error": CancelSpotFleetRequestsErrorOutputTypeDef,
        "SpotFleetRequestId": str,
    },
)

CancelSpotInstanceRequestsResultOutputTypeDef = TypedDict(
    "CancelSpotInstanceRequestsResultOutputTypeDef",
    {
        "CancelledSpotInstanceRequests": List[CancelledSpotInstanceRequestOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CapacityReservationOutputTypeDef = TypedDict(
    "CapacityReservationOutputTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": CapacityReservationInstancePlatformType,
        "AvailabilityZone": str,
        "Tenancy": CapacityReservationTenancyType,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": CapacityReservationStateType,
        "StartDate": datetime,
        "EndDate": datetime,
        "EndDateType": EndDateTypeType,
        "InstanceMatchCriteria": InstanceMatchCriteriaType,
        "CreateDate": datetime,
        "Tags": List[TagOutputTypeDef],
        "OutpostArn": str,
        "CapacityReservationFleetId": str,
        "PlacementGroupArn": str,
        "CapacityAllocations": List[CapacityAllocationOutputTypeDef],
    },
)

CapacityReservationFleetOutputTypeDef = TypedDict(
    "CapacityReservationFleetOutputTypeDef",
    {
        "CapacityReservationFleetId": str,
        "CapacityReservationFleetArn": str,
        "State": CapacityReservationFleetStateType,
        "TotalTargetCapacity": int,
        "TotalFulfilledCapacity": float,
        "Tenancy": Literal["default"],
        "EndDate": datetime,
        "CreateTime": datetime,
        "InstanceMatchCriteria": Literal["open"],
        "AllocationStrategy": str,
        "InstanceTypeSpecifications": List[FleetCapacityReservationOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
    },
)

CreateCapacityReservationFleetResultOutputTypeDef = TypedDict(
    "CreateCapacityReservationFleetResultOutputTypeDef",
    {
        "CapacityReservationFleetId": str,
        "State": CapacityReservationFleetStateType,
        "TotalTargetCapacity": int,
        "TotalFulfilledCapacity": float,
        "InstanceMatchCriteria": Literal["open"],
        "AllocationStrategy": str,
        "CreateTime": datetime,
        "EndDate": datetime,
        "Tenancy": Literal["default"],
        "FleetCapacityReservations": List[FleetCapacityReservationOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetGroupsForCapacityReservationResultOutputTypeDef = TypedDict(
    "GetGroupsForCapacityReservationResultOutputTypeDef",
    {
        "NextToken": str,
        "CapacityReservationGroups": List[CapacityReservationGroupOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

OnDemandOptionsOutputTypeDef = TypedDict(
    "OnDemandOptionsOutputTypeDef",
    {
        "AllocationStrategy": FleetOnDemandAllocationStrategyType,
        "CapacityReservationOptions": CapacityReservationOptionsOutputTypeDef,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
)

OnDemandOptionsRequestTypeDef = TypedDict(
    "OnDemandOptionsRequestTypeDef",
    {
        "AllocationStrategy": FleetOnDemandAllocationStrategyType,
        "CapacityReservationOptions": CapacityReservationOptionsRequestTypeDef,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)

CapacityReservationSpecificationResponseOutputTypeDef = TypedDict(
    "CapacityReservationSpecificationResponseOutputTypeDef",
    {
        "CapacityReservationPreference": CapacityReservationPreferenceType,
        "CapacityReservationTarget": CapacityReservationTargetResponseOutputTypeDef,
    },
)

CapacityReservationSpecificationResponseResponseMetadataTypeDef = TypedDict(
    "CapacityReservationSpecificationResponseResponseMetadataTypeDef",
    {
        "CapacityReservationPreference": CapacityReservationPreferenceType,
        "CapacityReservationTarget": CapacityReservationTargetResponseOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

LaunchTemplateCapacityReservationSpecificationResponseOutputTypeDef = TypedDict(
    "LaunchTemplateCapacityReservationSpecificationResponseOutputTypeDef",
    {
        "CapacityReservationPreference": CapacityReservationPreferenceType,
        "CapacityReservationTarget": CapacityReservationTargetResponseOutputTypeDef,
    },
)

CapacityReservationSpecificationTypeDef = TypedDict(
    "CapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": CapacityReservationPreferenceType,
        "CapacityReservationTarget": CapacityReservationTargetTypeDef,
    },
    total=False,
)

LaunchTemplateCapacityReservationSpecificationRequestTypeDef = TypedDict(
    "LaunchTemplateCapacityReservationSpecificationRequestTypeDef",
    {
        "CapacityReservationPreference": CapacityReservationPreferenceType,
        "CapacityReservationTarget": CapacityReservationTargetTypeDef,
    },
    total=False,
)

DescribeVpcClassicLinkDnsSupportResultOutputTypeDef = TypedDict(
    "DescribeVpcClassicLinkDnsSupportResultOutputTypeDef",
    {
        "NextToken": str,
        "Vpcs": List[ClassicLinkDnsSupportOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ClassicLinkInstanceOutputTypeDef = TypedDict(
    "ClassicLinkInstanceOutputTypeDef",
    {
        "Groups": List[GroupIdentifierOutputTypeDef],
        "InstanceId": str,
        "Tags": List[TagOutputTypeDef],
        "VpcId": str,
    },
)

ClassicLoadBalancersConfigOutputTypeDef = TypedDict(
    "ClassicLoadBalancersConfigOutputTypeDef",
    {
        "ClassicLoadBalancers": List[ClassicLoadBalancerOutputTypeDef],
    },
)

ClassicLoadBalancersConfigTypeDef = TypedDict(
    "ClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": Sequence[ClassicLoadBalancerTypeDef],
    },
    total=False,
)

ExportClientVpnClientCertificateRevocationListResultOutputTypeDef = TypedDict(
    "ExportClientVpnClientCertificateRevocationListResultOutputTypeDef",
    {
        "CertificateRevocationList": str,
        "Status": ClientCertificateRevocationListStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ClientConnectResponseOptionsOutputTypeDef = TypedDict(
    "ClientConnectResponseOptionsOutputTypeDef",
    {
        "Enabled": bool,
        "LambdaFunctionArn": str,
        "Status": ClientVpnEndpointAttributeStatusOutputTypeDef,
    },
)

_RequiredClientCreateTagsRequestTypeDef = TypedDict(
    "_RequiredClientCreateTagsRequestTypeDef",
    {
        "Resources": Sequence[str],
        "Tags": Sequence[TagTypeDef],
    },
)
_OptionalClientCreateTagsRequestTypeDef = TypedDict(
    "_OptionalClientCreateTagsRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ClientCreateTagsRequestTypeDef(
    _RequiredClientCreateTagsRequestTypeDef, _OptionalClientCreateTagsRequestTypeDef
):
    pass


_RequiredClientDeleteTagsRequestTypeDef = TypedDict(
    "_RequiredClientDeleteTagsRequestTypeDef",
    {
        "Resources": Sequence[str],
    },
)
_OptionalClientDeleteTagsRequestTypeDef = TypedDict(
    "_OptionalClientDeleteTagsRequestTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class ClientDeleteTagsRequestTypeDef(
    _RequiredClientDeleteTagsRequestTypeDef, _OptionalClientDeleteTagsRequestTypeDef
):
    pass


_RequiredCreateTagsRequestServiceResourceCreateTagsTypeDef = TypedDict(
    "_RequiredCreateTagsRequestServiceResourceCreateTagsTypeDef",
    {
        "Resources": Sequence[str],
        "Tags": Sequence[TagTypeDef],
    },
)
_OptionalCreateTagsRequestServiceResourceCreateTagsTypeDef = TypedDict(
    "_OptionalCreateTagsRequestServiceResourceCreateTagsTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class CreateTagsRequestServiceResourceCreateTagsTypeDef(
    _RequiredCreateTagsRequestServiceResourceCreateTagsTypeDef,
    _OptionalCreateTagsRequestServiceResourceCreateTagsTypeDef,
):
    pass


_RequiredInstanceCreateTagsRequestTypeDef = TypedDict(
    "_RequiredInstanceCreateTagsRequestTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
    },
)
_OptionalInstanceCreateTagsRequestTypeDef = TypedDict(
    "_OptionalInstanceCreateTagsRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class InstanceCreateTagsRequestTypeDef(
    _RequiredInstanceCreateTagsRequestTypeDef, _OptionalInstanceCreateTagsRequestTypeDef
):
    pass


InstanceDeleteTagsRequestTypeDef = TypedDict(
    "InstanceDeleteTagsRequestTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
        "DryRun": bool,
    },
    total=False,
)

InstanceEventWindowAssociationRequestTypeDef = TypedDict(
    "InstanceEventWindowAssociationRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
        "InstanceTags": Sequence[TagTypeDef],
        "DedicatedHostIds": Sequence[str],
    },
    total=False,
)

InstanceEventWindowDisassociationRequestTypeDef = TypedDict(
    "InstanceEventWindowDisassociationRequestTypeDef",
    {
        "InstanceIds": Sequence[str],
        "InstanceTags": Sequence[TagTypeDef],
        "DedicatedHostIds": Sequence[str],
    },
    total=False,
)

LaunchTemplateTagSpecificationRequestTypeDef = TypedDict(
    "LaunchTemplateTagSpecificationRequestTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)

SpotFleetTagSpecificationTypeDef = TypedDict(
    "SpotFleetTagSpecificationTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)

TagSpecificationTypeDef = TypedDict(
    "TagSpecificationTypeDef",
    {
        "ResourceType": ResourceTypeType,
        "Tags": Sequence[TagTypeDef],
    },
    total=False,
)

_RequiredVpcCreateTagsRequestTypeDef = TypedDict(
    "_RequiredVpcCreateTagsRequestTypeDef",
    {
        "Tags": Sequence[TagTypeDef],
    },
)
_OptionalVpcCreateTagsRequestTypeDef = TypedDict(
    "_OptionalVpcCreateTagsRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class VpcCreateTagsRequestTypeDef(
    _RequiredVpcCreateTagsRequestTypeDef, _OptionalVpcCreateTagsRequestTypeDef
):
    pass


ClientVpnAuthenticationOutputTypeDef = TypedDict(
    "ClientVpnAuthenticationOutputTypeDef",
    {
        "Type": ClientVpnAuthenticationTypeType,
        "ActiveDirectory": DirectoryServiceAuthenticationOutputTypeDef,
        "MutualAuthentication": CertificateAuthenticationOutputTypeDef,
        "FederatedAuthentication": FederatedAuthenticationOutputTypeDef,
    },
)

ClientVpnAuthenticationRequestTypeDef = TypedDict(
    "ClientVpnAuthenticationRequestTypeDef",
    {
        "Type": ClientVpnAuthenticationTypeType,
        "ActiveDirectory": DirectoryServiceAuthenticationRequestTypeDef,
        "MutualAuthentication": CertificateAuthenticationRequestTypeDef,
        "FederatedAuthentication": FederatedAuthenticationRequestTypeDef,
    },
    total=False,
)

ClientVpnConnectionOutputTypeDef = TypedDict(
    "ClientVpnConnectionOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Timestamp": str,
        "ConnectionId": str,
        "Username": str,
        "ConnectionEstablishedTime": str,
        "IngressBytes": str,
        "EgressBytes": str,
        "IngressPackets": str,
        "EgressPackets": str,
        "ClientIp": str,
        "CommonName": str,
        "Status": ClientVpnConnectionStatusOutputTypeDef,
        "ConnectionEndTime": str,
        "PostureComplianceStatuses": List[str],
    },
)

TerminateConnectionStatusOutputTypeDef = TypedDict(
    "TerminateConnectionStatusOutputTypeDef",
    {
        "ConnectionId": str,
        "PreviousStatus": ClientVpnConnectionStatusOutputTypeDef,
        "CurrentStatus": ClientVpnConnectionStatusOutputTypeDef,
    },
)

CreateClientVpnEndpointResultOutputTypeDef = TypedDict(
    "CreateClientVpnEndpointResultOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Status": ClientVpnEndpointStatusOutputTypeDef,
        "DnsName": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteClientVpnEndpointResultOutputTypeDef = TypedDict(
    "DeleteClientVpnEndpointResultOutputTypeDef",
    {
        "Status": ClientVpnEndpointStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ClientVpnRouteOutputTypeDef = TypedDict(
    "ClientVpnRouteOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidr": str,
        "TargetSubnet": str,
        "Type": str,
        "Origin": str,
        "Status": ClientVpnRouteStatusOutputTypeDef,
        "Description": str,
    },
)

CreateClientVpnRouteResultOutputTypeDef = TypedDict(
    "CreateClientVpnRouteResultOutputTypeDef",
    {
        "Status": ClientVpnRouteStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteClientVpnRouteResultOutputTypeDef = TypedDict(
    "DeleteClientVpnRouteResultOutputTypeDef",
    {
        "Status": ClientVpnRouteStatusOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpnTunnelLogOptionsOutputTypeDef = TypedDict(
    "VpnTunnelLogOptionsOutputTypeDef",
    {
        "CloudWatchLogOptions": CloudWatchLogOptionsOutputTypeDef,
    },
)

VpnTunnelLogOptionsSpecificationTypeDef = TypedDict(
    "VpnTunnelLogOptionsSpecificationTypeDef",
    {
        "CloudWatchLogOptions": CloudWatchLogOptionsSpecificationTypeDef,
    },
    total=False,
)

GetCoipPoolUsageResultOutputTypeDef = TypedDict(
    "GetCoipPoolUsageResultOutputTypeDef",
    {
        "CoipPoolId": str,
        "CoipAddressUsages": List[CoipAddressUsageOutputTypeDef],
        "LocalGatewayRouteTableId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateCoipCidrResultOutputTypeDef = TypedDict(
    "CreateCoipCidrResultOutputTypeDef",
    {
        "CoipCidr": CoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteCoipCidrResultOutputTypeDef = TypedDict(
    "DeleteCoipCidrResultOutputTypeDef",
    {
        "CoipCidr": CoipCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVpcEndpointConnectionNotificationResultOutputTypeDef = TypedDict(
    "CreateVpcEndpointConnectionNotificationResultOutputTypeDef",
    {
        "ConnectionNotification": ConnectionNotificationOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcEndpointConnectionNotificationsResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionNotificationsResultOutputTypeDef",
    {
        "ConnectionNotificationSet": List[ConnectionNotificationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceEventWindowRequestRequestTypeDef",
    {
        "InstanceEventWindowId": str,
    },
)
_OptionalModifyInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceEventWindowRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Name": str,
        "TimeRanges": Sequence[InstanceEventWindowTimeRangeRequestTypeDef],
        "CronExpression": str,
    },
    total=False,
)


class ModifyInstanceEventWindowRequestRequestTypeDef(
    _RequiredModifyInstanceEventWindowRequestRequestTypeDef,
    _OptionalModifyInstanceEventWindowRequestRequestTypeDef,
):
    pass


_RequiredModifyIpamPoolRequestRequestTypeDef = TypedDict(
    "_RequiredModifyIpamPoolRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalModifyIpamPoolRequestRequestTypeDef = TypedDict(
    "_OptionalModifyIpamPoolRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "AutoImport": bool,
        "AllocationMinNetmaskLength": int,
        "AllocationMaxNetmaskLength": int,
        "AllocationDefaultNetmaskLength": int,
        "ClearAllocationDefaultNetmaskLength": bool,
        "AddAllocationResourceTags": Sequence[RequestIpamResourceTagTypeDef],
        "RemoveAllocationResourceTags": Sequence[RequestIpamResourceTagTypeDef],
    },
    total=False,
)


class ModifyIpamPoolRequestRequestTypeDef(
    _RequiredModifyIpamPoolRequestRequestTypeDef, _OptionalModifyIpamPoolRequestRequestTypeDef
):
    pass


CreateLocalGatewayRouteResultOutputTypeDef = TypedDict(
    "CreateLocalGatewayRouteResultOutputTypeDef",
    {
        "Route": LocalGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLocalGatewayRouteResultOutputTypeDef = TypedDict(
    "DeleteLocalGatewayRouteResultOutputTypeDef",
    {
        "Route": LocalGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyLocalGatewayRouteResultOutputTypeDef = TypedDict(
    "ModifyLocalGatewayRouteResultOutputTypeDef",
    {
        "Route": LocalGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SearchLocalGatewayRoutesResultOutputTypeDef = TypedDict(
    "SearchLocalGatewayRoutesResultOutputTypeDef",
    {
        "Routes": List[LocalGatewayRouteOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef = TypedDict(
    "_RequiredCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef",
    {
        "Egress": bool,
        "Protocol": str,
        "RuleAction": RuleActionType,
        "RuleNumber": int,
    },
)
_OptionalCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef = TypedDict(
    "_OptionalCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef",
    {
        "CidrBlock": str,
        "DryRun": bool,
        "IcmpTypeCode": IcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": PortRangeTypeDef,
    },
    total=False,
)


class CreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef(
    _RequiredCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef,
    _OptionalCreateNetworkAclEntryRequestNetworkAclCreateEntryTypeDef,
):
    pass


_RequiredCreateNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkAclEntryRequestRequestTypeDef",
    {
        "Egress": bool,
        "NetworkAclId": str,
        "Protocol": str,
        "RuleAction": RuleActionType,
        "RuleNumber": int,
    },
)
_OptionalCreateNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkAclEntryRequestRequestTypeDef",
    {
        "CidrBlock": str,
        "DryRun": bool,
        "IcmpTypeCode": IcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": PortRangeTypeDef,
    },
    total=False,
)


class CreateNetworkAclEntryRequestRequestTypeDef(
    _RequiredCreateNetworkAclEntryRequestRequestTypeDef,
    _OptionalCreateNetworkAclEntryRequestRequestTypeDef,
):
    pass


_RequiredReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef = TypedDict(
    "_RequiredReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef",
    {
        "Egress": bool,
        "Protocol": str,
        "RuleAction": RuleActionType,
        "RuleNumber": int,
    },
)
_OptionalReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef = TypedDict(
    "_OptionalReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef",
    {
        "CidrBlock": str,
        "DryRun": bool,
        "IcmpTypeCode": IcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": PortRangeTypeDef,
    },
    total=False,
)


class ReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef(
    _RequiredReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef,
    _OptionalReplaceNetworkAclEntryRequestNetworkAclReplaceEntryTypeDef,
):
    pass


_RequiredReplaceNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_RequiredReplaceNetworkAclEntryRequestRequestTypeDef",
    {
        "Egress": bool,
        "NetworkAclId": str,
        "Protocol": str,
        "RuleAction": RuleActionType,
        "RuleNumber": int,
    },
)
_OptionalReplaceNetworkAclEntryRequestRequestTypeDef = TypedDict(
    "_OptionalReplaceNetworkAclEntryRequestRequestTypeDef",
    {
        "CidrBlock": str,
        "DryRun": bool,
        "IcmpTypeCode": IcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": PortRangeTypeDef,
    },
    total=False,
)


class ReplaceNetworkAclEntryRequestRequestTypeDef(
    _RequiredReplaceNetworkAclEntryRequestRequestTypeDef,
    _OptionalReplaceNetworkAclEntryRequestRequestTypeDef,
):
    pass


InstanceNetworkInterfaceSpecificationTypeDef = TypedDict(
    "InstanceNetworkInterfaceSpecificationTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": Sequence[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": Sequence[PrivateIpAddressSpecificationTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "AssociateCarrierIpAddress": bool,
        "InterfaceType": str,
        "NetworkCardIndex": int,
        "Ipv4Prefixes": Sequence[Ipv4PrefixSpecificationRequestTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": Sequence[Ipv6PrefixSpecificationRequestTypeDef],
        "Ipv6PrefixCount": int,
    },
    total=False,
)

CreateReservedInstancesListingRequestRequestTypeDef = TypedDict(
    "CreateReservedInstancesListingRequestRequestTypeDef",
    {
        "ClientToken": str,
        "InstanceCount": int,
        "PriceSchedules": Sequence[PriceScheduleSpecificationTypeDef],
        "ReservedInstancesId": str,
    },
)

_RequiredCreateStoreImageTaskRequestRequestTypeDef = TypedDict(
    "_RequiredCreateStoreImageTaskRequestRequestTypeDef",
    {
        "ImageId": str,
        "Bucket": str,
    },
)
_OptionalCreateStoreImageTaskRequestRequestTypeDef = TypedDict(
    "_OptionalCreateStoreImageTaskRequestRequestTypeDef",
    {
        "S3ObjectTags": Sequence[S3ObjectTagTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateStoreImageTaskRequestRequestTypeDef(
    _RequiredCreateStoreImageTaskRequestRequestTypeDef,
    _OptionalCreateStoreImageTaskRequestRequestTypeDef,
):
    pass


_RequiredCreateTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "TrafficDirection": TrafficDirectionType,
        "RuleNumber": int,
        "RuleAction": TrafficMirrorRuleActionType,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
    },
)
_OptionalCreateTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "DestinationPortRange": TrafficMirrorPortRangeRequestTypeDef,
        "SourcePortRange": TrafficMirrorPortRangeRequestTypeDef,
        "Protocol": int,
        "Description": str,
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class CreateTrafficMirrorFilterRuleRequestRequestTypeDef(
    _RequiredCreateTrafficMirrorFilterRuleRequestRequestTypeDef,
    _OptionalCreateTrafficMirrorFilterRuleRequestRequestTypeDef,
):
    pass


_RequiredModifyTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
    },
)
_OptionalModifyTrafficMirrorFilterRuleRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTrafficMirrorFilterRuleRequestRequestTypeDef",
    {
        "TrafficDirection": TrafficDirectionType,
        "RuleNumber": int,
        "RuleAction": TrafficMirrorRuleActionType,
        "DestinationPortRange": TrafficMirrorPortRangeRequestTypeDef,
        "SourcePortRange": TrafficMirrorPortRangeRequestTypeDef,
        "Protocol": int,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
        "RemoveFields": Sequence[TrafficMirrorFilterRuleFieldType],
        "DryRun": bool,
    },
    total=False,
)


class ModifyTrafficMirrorFilterRuleRequestRequestTypeDef(
    _RequiredModifyTrafficMirrorFilterRuleRequestRequestTypeDef,
    _OptionalModifyTrafficMirrorFilterRuleRequestRequestTypeDef,
):
    pass


CreateVolumePermissionModificationsTypeDef = TypedDict(
    "CreateVolumePermissionModificationsTypeDef",
    {
        "Add": Sequence[CreateVolumePermissionTypeDef],
        "Remove": Sequence[CreateVolumePermissionTypeDef],
    },
    total=False,
)

_RequiredModifyVpcEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcEndpointRequestRequestTypeDef",
    {
        "VpcEndpointId": str,
    },
)
_OptionalModifyVpcEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcEndpointRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ResetPolicy": bool,
        "PolicyDocument": str,
        "AddRouteTableIds": Sequence[str],
        "RemoveRouteTableIds": Sequence[str],
        "AddSubnetIds": Sequence[str],
        "RemoveSubnetIds": Sequence[str],
        "AddSecurityGroupIds": Sequence[str],
        "RemoveSecurityGroupIds": Sequence[str],
        "IpAddressType": IpAddressTypeType,
        "DnsOptions": DnsOptionsSpecificationTypeDef,
        "PrivateDnsEnabled": bool,
    },
    total=False,
)


class ModifyVpcEndpointRequestRequestTypeDef(
    _RequiredModifyVpcEndpointRequestRequestTypeDef, _OptionalModifyVpcEndpointRequestRequestTypeDef
):
    pass


GetAwsNetworkPerformanceDataRequestGetAwsNetworkPerformanceDataPaginateTypeDef = TypedDict(
    "GetAwsNetworkPerformanceDataRequestGetAwsNetworkPerformanceDataPaginateTypeDef",
    {
        "DataQueries": Sequence[DataQueryTypeDef],
        "StartTime": Union[datetime, str],
        "EndTime": Union[datetime, str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

GetAwsNetworkPerformanceDataRequestRequestTypeDef = TypedDict(
    "GetAwsNetworkPerformanceDataRequestRequestTypeDef",
    {
        "DataQueries": Sequence[DataQueryTypeDef],
        "StartTime": Union[datetime, str],
        "EndTime": Union[datetime, str],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DataResponseOutputTypeDef = TypedDict(
    "DataResponseOutputTypeDef",
    {
        "Id": str,
        "Source": str,
        "Destination": str,
        "Metric": Literal["aggregate-latency"],
        "Statistic": Literal["p50"],
        "Period": PeriodTypeType,
        "MetricPoints": List[MetricPointOutputTypeDef],
    },
)

DeleteFleetErrorItemOutputTypeDef = TypedDict(
    "DeleteFleetErrorItemOutputTypeDef",
    {
        "Error": DeleteFleetErrorOutputTypeDef,
        "FleetId": str,
    },
)

DeleteInstanceEventWindowResultOutputTypeDef = TypedDict(
    "DeleteInstanceEventWindowResultOutputTypeDef",
    {
        "InstanceEventWindowState": InstanceEventWindowStateChangeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLaunchTemplateVersionsResponseErrorItemOutputTypeDef = TypedDict(
    "DeleteLaunchTemplateVersionsResponseErrorItemOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "ResponseError": ResponseErrorOutputTypeDef,
    },
)

FailedQueuedPurchaseDeletionOutputTypeDef = TypedDict(
    "FailedQueuedPurchaseDeletionOutputTypeDef",
    {
        "Error": DeleteQueuedReservedInstancesErrorOutputTypeDef,
        "ReservedInstancesId": str,
    },
)

_RequiredDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef = TypedDict(
    "_RequiredDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    {
        "InstanceTagAttribute": DeregisterInstanceTagAttributeRequestTypeDef,
    },
)
_OptionalDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef = TypedDict(
    "_OptionalDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DeregisterInstanceEventNotificationAttributesRequestRequestTypeDef(
    _RequiredDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef,
    _OptionalDeregisterInstanceEventNotificationAttributesRequestRequestTypeDef,
):
    pass


DeregisterInstanceEventNotificationAttributesResultOutputTypeDef = TypedDict(
    "DeregisterInstanceEventNotificationAttributesResultOutputTypeDef",
    {
        "InstanceTagAttribute": InstanceTagNotificationAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceEventNotificationAttributesResultOutputTypeDef = TypedDict(
    "DescribeInstanceEventNotificationAttributesResultOutputTypeDef",
    {
        "InstanceTagAttribute": InstanceTagNotificationAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RegisterInstanceEventNotificationAttributesResultOutputTypeDef = TypedDict(
    "RegisterInstanceEventNotificationAttributesResultOutputTypeDef",
    {
        "InstanceTagAttribute": InstanceTagNotificationAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeregisterTransitGatewayMulticastGroupMembersResultOutputTypeDef = TypedDict(
    "DeregisterTransitGatewayMulticastGroupMembersResultOutputTypeDef",
    {
        "DeregisteredMulticastGroupMembers": (
            TransitGatewayMulticastDeregisteredGroupMembersOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeregisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef = TypedDict(
    "DeregisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef",
    {
        "DeregisteredMulticastGroupSources": (
            TransitGatewayMulticastDeregisteredGroupSourcesOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeAddressesRequestRequestTypeDef = TypedDict(
    "DescribeAddressesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "PublicIps": Sequence[str],
        "AllocationIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

DescribeAvailabilityZonesRequestRequestTypeDef = TypedDict(
    "DescribeAvailabilityZonesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "ZoneNames": Sequence[str],
        "ZoneIds": Sequence[str],
        "AllAvailabilityZones": bool,
        "DryRun": bool,
    },
    total=False,
)

DescribeAwsNetworkPerformanceMetricSubscriptionsRequestDescribeAwsNetworkPerformanceMetricSubscriptionsPaginateTypeDef = TypedDict(
    "DescribeAwsNetworkPerformanceMetricSubscriptionsRequestDescribeAwsNetworkPerformanceMetricSubscriptionsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeAwsNetworkPerformanceMetricSubscriptionsRequestRequestTypeDef = TypedDict(
    "DescribeAwsNetworkPerformanceMetricSubscriptionsRequestRequestTypeDef",
    {
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeBundleTasksRequestRequestTypeDef = TypedDict(
    "DescribeBundleTasksRequestRequestTypeDef",
    {
        "BundleIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeCapacityReservationFleetsRequestDescribeCapacityReservationFleetsPaginateTypeDef = (
    TypedDict(
        "DescribeCapacityReservationFleetsRequestDescribeCapacityReservationFleetsPaginateTypeDef",
        {
            "CapacityReservationFleetIds": Sequence[str],
            "Filters": Sequence[FilterTypeDef],
            "DryRun": bool,
            "PaginationConfig": "PaginatorConfigTypeDef",
        },
        total=False,
    )
)

DescribeCapacityReservationFleetsRequestRequestTypeDef = TypedDict(
    "DescribeCapacityReservationFleetsRequestRequestTypeDef",
    {
        "CapacityReservationFleetIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeCapacityReservationsRequestDescribeCapacityReservationsPaginateTypeDef = TypedDict(
    "DescribeCapacityReservationsRequestDescribeCapacityReservationsPaginateTypeDef",
    {
        "CapacityReservationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeCapacityReservationsRequestRequestTypeDef = TypedDict(
    "DescribeCapacityReservationsRequestRequestTypeDef",
    {
        "CapacityReservationIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeCarrierGatewaysRequestDescribeCarrierGatewaysPaginateTypeDef = TypedDict(
    "DescribeCarrierGatewaysRequestDescribeCarrierGatewaysPaginateTypeDef",
    {
        "CarrierGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeCarrierGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeCarrierGatewaysRequestRequestTypeDef",
    {
        "CarrierGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeClassicLinkInstancesRequestDescribeClassicLinkInstancesPaginateTypeDef = TypedDict(
    "DescribeClassicLinkInstancesRequestDescribeClassicLinkInstancesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "InstanceIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeClassicLinkInstancesRequestRequestTypeDef = TypedDict(
    "DescribeClassicLinkInstancesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "InstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

_RequiredDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef = TypedDict(
    "_RequiredDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef = TypedDict(
    "_OptionalDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef(
    _RequiredDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef,
    _OptionalDescribeClientVpnAuthorizationRulesRequestDescribeClientVpnAuthorizationRulesPaginateTypeDef,
):
    pass


_RequiredDescribeClientVpnAuthorizationRulesRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeClientVpnAuthorizationRulesRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnAuthorizationRulesRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeClientVpnAuthorizationRulesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesRequestRequestTypeDef(
    _RequiredDescribeClientVpnAuthorizationRulesRequestRequestTypeDef,
    _OptionalDescribeClientVpnAuthorizationRulesRequestRequestTypeDef,
):
    pass


_RequiredDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef = TypedDict(
    "_RequiredDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef = TypedDict(
    "_OptionalDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef(
    _RequiredDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef,
    _OptionalDescribeClientVpnConnectionsRequestDescribeClientVpnConnectionsPaginateTypeDef,
):
    pass


_RequiredDescribeClientVpnConnectionsRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeClientVpnConnectionsRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnConnectionsRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeClientVpnConnectionsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)


class DescribeClientVpnConnectionsRequestRequestTypeDef(
    _RequiredDescribeClientVpnConnectionsRequestRequestTypeDef,
    _OptionalDescribeClientVpnConnectionsRequestRequestTypeDef,
):
    pass


DescribeClientVpnEndpointsRequestDescribeClientVpnEndpointsPaginateTypeDef = TypedDict(
    "DescribeClientVpnEndpointsRequestDescribeClientVpnEndpointsPaginateTypeDef",
    {
        "ClientVpnEndpointIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeClientVpnEndpointsRequestRequestTypeDef = TypedDict(
    "DescribeClientVpnEndpointsRequestRequestTypeDef",
    {
        "ClientVpnEndpointIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

_RequiredDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef = TypedDict(
    "_RequiredDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef = TypedDict(
    "_OptionalDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef(
    _RequiredDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef,
    _OptionalDescribeClientVpnRoutesRequestDescribeClientVpnRoutesPaginateTypeDef,
):
    pass


_RequiredDescribeClientVpnRoutesRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeClientVpnRoutesRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnRoutesRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeClientVpnRoutesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class DescribeClientVpnRoutesRequestRequestTypeDef(
    _RequiredDescribeClientVpnRoutesRequestRequestTypeDef,
    _OptionalDescribeClientVpnRoutesRequestRequestTypeDef,
):
    pass


_RequiredDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef = TypedDict(
    "_RequiredDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef = TypedDict(
    "_OptionalDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef",
    {
        "AssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef(
    _RequiredDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef,
    _OptionalDescribeClientVpnTargetNetworksRequestDescribeClientVpnTargetNetworksPaginateTypeDef,
):
    pass


_RequiredDescribeClientVpnTargetNetworksRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeClientVpnTargetNetworksRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalDescribeClientVpnTargetNetworksRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeClientVpnTargetNetworksRequestRequestTypeDef",
    {
        "AssociationIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class DescribeClientVpnTargetNetworksRequestRequestTypeDef(
    _RequiredDescribeClientVpnTargetNetworksRequestRequestTypeDef,
    _OptionalDescribeClientVpnTargetNetworksRequestRequestTypeDef,
):
    pass


DescribeCoipPoolsRequestDescribeCoipPoolsPaginateTypeDef = TypedDict(
    "DescribeCoipPoolsRequestDescribeCoipPoolsPaginateTypeDef",
    {
        "PoolIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeCoipPoolsRequestRequestTypeDef = TypedDict(
    "DescribeCoipPoolsRequestRequestTypeDef",
    {
        "PoolIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeCustomerGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeCustomerGatewaysRequestRequestTypeDef",
    {
        "CustomerGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeDhcpOptionsRequestDescribeDhcpOptionsPaginateTypeDef = TypedDict(
    "DescribeDhcpOptionsRequestDescribeDhcpOptionsPaginateTypeDef",
    {
        "DhcpOptionsIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeDhcpOptionsRequestRequestTypeDef = TypedDict(
    "DescribeDhcpOptionsRequestRequestTypeDef",
    {
        "DhcpOptionsIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeEgressOnlyInternetGatewaysRequestDescribeEgressOnlyInternetGatewaysPaginateTypeDef = TypedDict(
    "DescribeEgressOnlyInternetGatewaysRequestDescribeEgressOnlyInternetGatewaysPaginateTypeDef",
    {
        "DryRun": bool,
        "EgressOnlyInternetGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeEgressOnlyInternetGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeEgressOnlyInternetGatewaysRequestRequestTypeDef",
    {
        "DryRun": bool,
        "EgressOnlyInternetGatewayIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeElasticGpusRequestRequestTypeDef = TypedDict(
    "DescribeElasticGpusRequestRequestTypeDef",
    {
        "ElasticGpuIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeExportImageTasksRequestDescribeExportImageTasksPaginateTypeDef = TypedDict(
    "DescribeExportImageTasksRequestDescribeExportImageTasksPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ExportImageTaskIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeExportImageTasksRequestRequestTypeDef = TypedDict(
    "DescribeExportImageTasksRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ExportImageTaskIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeExportTasksRequestRequestTypeDef = TypedDict(
    "DescribeExportTasksRequestRequestTypeDef",
    {
        "ExportTaskIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeFastLaunchImagesRequestDescribeFastLaunchImagesPaginateTypeDef = TypedDict(
    "DescribeFastLaunchImagesRequestDescribeFastLaunchImagesPaginateTypeDef",
    {
        "ImageIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeFastLaunchImagesRequestRequestTypeDef = TypedDict(
    "DescribeFastLaunchImagesRequestRequestTypeDef",
    {
        "ImageIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeFastSnapshotRestoresRequestDescribeFastSnapshotRestoresPaginateTypeDef = TypedDict(
    "DescribeFastSnapshotRestoresRequestDescribeFastSnapshotRestoresPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeFastSnapshotRestoresRequestRequestTypeDef = TypedDict(
    "DescribeFastSnapshotRestoresRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredDescribeFleetInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeFleetInstancesRequestRequestTypeDef",
    {
        "FleetId": str,
    },
)
_OptionalDescribeFleetInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeFleetInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)


class DescribeFleetInstancesRequestRequestTypeDef(
    _RequiredDescribeFleetInstancesRequestRequestTypeDef,
    _OptionalDescribeFleetInstancesRequestRequestTypeDef,
):
    pass


DescribeFleetsRequestDescribeFleetsPaginateTypeDef = TypedDict(
    "DescribeFleetsRequestDescribeFleetsPaginateTypeDef",
    {
        "DryRun": bool,
        "FleetIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeFleetsRequestRequestTypeDef = TypedDict(
    "DescribeFleetsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "FleetIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeFlowLogsRequestDescribeFlowLogsPaginateTypeDef = TypedDict(
    "DescribeFlowLogsRequestDescribeFlowLogsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "FlowLogIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeFlowLogsRequestRequestTypeDef = TypedDict(
    "DescribeFlowLogsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "FlowLogIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeFpgaImagesRequestDescribeFpgaImagesPaginateTypeDef = TypedDict(
    "DescribeFpgaImagesRequestDescribeFpgaImagesPaginateTypeDef",
    {
        "DryRun": bool,
        "FpgaImageIds": Sequence[str],
        "Owners": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeFpgaImagesRequestRequestTypeDef = TypedDict(
    "DescribeFpgaImagesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "FpgaImageIds": Sequence[str],
        "Owners": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeHostReservationOfferingsRequestDescribeHostReservationOfferingsPaginateTypeDef = TypedDict(
    "DescribeHostReservationOfferingsRequestDescribeHostReservationOfferingsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxDuration": int,
        "MinDuration": int,
        "OfferingId": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeHostReservationOfferingsRequestRequestTypeDef = TypedDict(
    "DescribeHostReservationOfferingsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxDuration": int,
        "MaxResults": int,
        "MinDuration": int,
        "NextToken": str,
        "OfferingId": str,
    },
    total=False,
)

DescribeHostReservationsRequestDescribeHostReservationsPaginateTypeDef = TypedDict(
    "DescribeHostReservationsRequestDescribeHostReservationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "HostReservationIdSet": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeHostReservationsRequestRequestTypeDef = TypedDict(
    "DescribeHostReservationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "HostReservationIdSet": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeHostsRequestDescribeHostsPaginateTypeDef = TypedDict(
    "DescribeHostsRequestDescribeHostsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "HostIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeHostsRequestRequestTypeDef = TypedDict(
    "DescribeHostsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "HostIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeIamInstanceProfileAssociationsRequestDescribeIamInstanceProfileAssociationsPaginateTypeDef = TypedDict(
    "DescribeIamInstanceProfileAssociationsRequestDescribeIamInstanceProfileAssociationsPaginateTypeDef",
    {
        "AssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIamInstanceProfileAssociationsRequestRequestTypeDef = TypedDict(
    "DescribeIamInstanceProfileAssociationsRequestRequestTypeDef",
    {
        "AssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeImagesRequestDescribeImagesPaginateTypeDef = TypedDict(
    "DescribeImagesRequestDescribeImagesPaginateTypeDef",
    {
        "ExecutableUsers": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "ImageIds": Sequence[str],
        "Owners": Sequence[str],
        "IncludeDeprecated": bool,
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeImagesRequestRequestTypeDef = TypedDict(
    "DescribeImagesRequestRequestTypeDef",
    {
        "ExecutableUsers": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "ImageIds": Sequence[str],
        "Owners": Sequence[str],
        "IncludeDeprecated": bool,
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeImportImageTasksRequestDescribeImportImageTasksPaginateTypeDef = TypedDict(
    "DescribeImportImageTasksRequestDescribeImportImageTasksPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ImportTaskIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeImportImageTasksRequestRequestTypeDef = TypedDict(
    "DescribeImportImageTasksRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ImportTaskIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeImportSnapshotTasksRequestDescribeImportSnapshotTasksPaginateTypeDef = TypedDict(
    "DescribeImportSnapshotTasksRequestDescribeImportSnapshotTasksPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ImportTaskIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeImportSnapshotTasksRequestRequestTypeDef = TypedDict(
    "DescribeImportSnapshotTasksRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ImportTaskIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInstanceConnectEndpointsRequestDescribeInstanceConnectEndpointsPaginateTypeDef = TypedDict(
    "DescribeInstanceConnectEndpointsRequestDescribeInstanceConnectEndpointsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "InstanceConnectEndpointIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceConnectEndpointsRequestRequestTypeDef = TypedDict(
    "DescribeInstanceConnectEndpointsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "InstanceConnectEndpointIds": Sequence[str],
    },
    total=False,
)

DescribeInstanceCreditSpecificationsRequestDescribeInstanceCreditSpecificationsPaginateTypeDef = TypedDict(
    "DescribeInstanceCreditSpecificationsRequestDescribeInstanceCreditSpecificationsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceCreditSpecificationsRequestRequestTypeDef = TypedDict(
    "DescribeInstanceCreditSpecificationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInstanceEventWindowsRequestDescribeInstanceEventWindowsPaginateTypeDef = TypedDict(
    "DescribeInstanceEventWindowsRequestDescribeInstanceEventWindowsPaginateTypeDef",
    {
        "DryRun": bool,
        "InstanceEventWindowIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceEventWindowsRequestRequestTypeDef = TypedDict(
    "DescribeInstanceEventWindowsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "InstanceEventWindowIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInstanceStatusRequestDescribeInstanceStatusPaginateTypeDef = TypedDict(
    "DescribeInstanceStatusRequestDescribeInstanceStatusPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "IncludeAllInstances": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceStatusRequestRequestTypeDef = TypedDict(
    "DescribeInstanceStatusRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
        "IncludeAllInstances": bool,
    },
    total=False,
)

DescribeInstanceTypeOfferingsRequestDescribeInstanceTypeOfferingsPaginateTypeDef = TypedDict(
    "DescribeInstanceTypeOfferingsRequestDescribeInstanceTypeOfferingsPaginateTypeDef",
    {
        "DryRun": bool,
        "LocationType": LocationTypeType,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceTypeOfferingsRequestRequestTypeDef = TypedDict(
    "DescribeInstanceTypeOfferingsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LocationType": LocationTypeType,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInstanceTypesRequestDescribeInstanceTypesPaginateTypeDef = TypedDict(
    "DescribeInstanceTypesRequestDescribeInstanceTypesPaginateTypeDef",
    {
        "DryRun": bool,
        "InstanceTypes": Sequence[InstanceTypeType],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstanceTypesRequestRequestTypeDef = TypedDict(
    "DescribeInstanceTypesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "InstanceTypes": Sequence[InstanceTypeType],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInstancesRequestDescribeInstancesPaginateTypeDef = TypedDict(
    "DescribeInstancesRequestDescribeInstancesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInstancesRequestRequestTypeDef = TypedDict(
    "DescribeInstancesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeInternetGatewaysRequestDescribeInternetGatewaysPaginateTypeDef = TypedDict(
    "DescribeInternetGatewaysRequestDescribeInternetGatewaysPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "InternetGatewayIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeInternetGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeInternetGatewaysRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "InternetGatewayIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeIpamPoolsRequestDescribeIpamPoolsPaginateTypeDef = TypedDict(
    "DescribeIpamPoolsRequestDescribeIpamPoolsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "IpamPoolIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpamPoolsRequestRequestTypeDef = TypedDict(
    "DescribeIpamPoolsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "IpamPoolIds": Sequence[str],
    },
    total=False,
)

DescribeIpamResourceDiscoveriesRequestDescribeIpamResourceDiscoveriesPaginateTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveriesRequestDescribeIpamResourceDiscoveriesPaginateTypeDef",
    {
        "DryRun": bool,
        "IpamResourceDiscoveryIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpamResourceDiscoveriesRequestRequestTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveriesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "IpamResourceDiscoveryIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeIpamResourceDiscoveryAssociationsRequestDescribeIpamResourceDiscoveryAssociationsPaginateTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveryAssociationsRequestDescribeIpamResourceDiscoveryAssociationsPaginateTypeDef",
    {
        "DryRun": bool,
        "IpamResourceDiscoveryAssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpamResourceDiscoveryAssociationsRequestRequestTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveryAssociationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "IpamResourceDiscoveryAssociationIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeIpamScopesRequestDescribeIpamScopesPaginateTypeDef = TypedDict(
    "DescribeIpamScopesRequestDescribeIpamScopesPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "IpamScopeIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpamScopesRequestRequestTypeDef = TypedDict(
    "DescribeIpamScopesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "IpamScopeIds": Sequence[str],
    },
    total=False,
)

DescribeIpamsRequestDescribeIpamsPaginateTypeDef = TypedDict(
    "DescribeIpamsRequestDescribeIpamsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "IpamIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpamsRequestRequestTypeDef = TypedDict(
    "DescribeIpamsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "IpamIds": Sequence[str],
    },
    total=False,
)

DescribeIpv6PoolsRequestDescribeIpv6PoolsPaginateTypeDef = TypedDict(
    "DescribeIpv6PoolsRequestDescribeIpv6PoolsPaginateTypeDef",
    {
        "PoolIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeIpv6PoolsRequestRequestTypeDef = TypedDict(
    "DescribeIpv6PoolsRequestRequestTypeDef",
    {
        "PoolIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeKeyPairsRequestRequestTypeDef = TypedDict(
    "DescribeKeyPairsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "KeyNames": Sequence[str],
        "KeyPairIds": Sequence[str],
        "DryRun": bool,
        "IncludePublicKey": bool,
    },
    total=False,
)

DescribeLaunchTemplateVersionsRequestDescribeLaunchTemplateVersionsPaginateTypeDef = TypedDict(
    "DescribeLaunchTemplateVersionsRequestDescribeLaunchTemplateVersionsPaginateTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Versions": Sequence[str],
        "MinVersion": str,
        "MaxVersion": str,
        "Filters": Sequence[FilterTypeDef],
        "ResolveAlias": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLaunchTemplateVersionsRequestRequestTypeDef = TypedDict(
    "DescribeLaunchTemplateVersionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "Versions": Sequence[str],
        "MinVersion": str,
        "MaxVersion": str,
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
        "ResolveAlias": bool,
    },
    total=False,
)

DescribeLaunchTemplatesRequestDescribeLaunchTemplatesPaginateTypeDef = TypedDict(
    "DescribeLaunchTemplatesRequestDescribeLaunchTemplatesPaginateTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateIds": Sequence[str],
        "LaunchTemplateNames": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLaunchTemplatesRequestRequestTypeDef = TypedDict(
    "DescribeLaunchTemplatesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LaunchTemplateIds": Sequence[str],
        "LaunchTemplateNames": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestDescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsPaginateTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestDescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsPaginateTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeLocalGatewayRouteTableVpcAssociationsRequestDescribeLocalGatewayRouteTableVpcAssociationsPaginateTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVpcAssociationsRequestDescribeLocalGatewayRouteTableVpcAssociationsPaginateTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewayRouteTableVpcAssociationsRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVpcAssociationsRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociationIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeLocalGatewayRouteTablesRequestDescribeLocalGatewayRouteTablesPaginateTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTablesRequestDescribeLocalGatewayRouteTablesPaginateTypeDef",
    {
        "LocalGatewayRouteTableIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewayRouteTablesRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTablesRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeLocalGatewayVirtualInterfaceGroupsRequestDescribeLocalGatewayVirtualInterfaceGroupsPaginateTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfaceGroupsRequestDescribeLocalGatewayVirtualInterfaceGroupsPaginateTypeDef",
    {
        "LocalGatewayVirtualInterfaceGroupIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewayVirtualInterfaceGroupsRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfaceGroupsRequestRequestTypeDef",
    {
        "LocalGatewayVirtualInterfaceGroupIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeLocalGatewayVirtualInterfacesRequestDescribeLocalGatewayVirtualInterfacesPaginateTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfacesRequestDescribeLocalGatewayVirtualInterfacesPaginateTypeDef",
    {
        "LocalGatewayVirtualInterfaceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewayVirtualInterfacesRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfacesRequestRequestTypeDef",
    {
        "LocalGatewayVirtualInterfaceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeLocalGatewaysRequestDescribeLocalGatewaysPaginateTypeDef = TypedDict(
    "DescribeLocalGatewaysRequestDescribeLocalGatewaysPaginateTypeDef",
    {
        "LocalGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeLocalGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeLocalGatewaysRequestRequestTypeDef",
    {
        "LocalGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeManagedPrefixListsRequestDescribeManagedPrefixListsPaginateTypeDef = TypedDict(
    "DescribeManagedPrefixListsRequestDescribeManagedPrefixListsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PrefixListIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeManagedPrefixListsRequestRequestTypeDef = TypedDict(
    "DescribeManagedPrefixListsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "PrefixListIds": Sequence[str],
    },
    total=False,
)

DescribeMovingAddressesRequestDescribeMovingAddressesPaginateTypeDef = TypedDict(
    "DescribeMovingAddressesRequestDescribeMovingAddressesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PublicIps": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeMovingAddressesRequestRequestTypeDef = TypedDict(
    "DescribeMovingAddressesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "PublicIps": Sequence[str],
    },
    total=False,
)

DescribeNatGatewaysRequestDescribeNatGatewaysPaginateTypeDef = TypedDict(
    "DescribeNatGatewaysRequestDescribeNatGatewaysPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "NatGatewayIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNatGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeNatGatewaysRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NatGatewayIds": Sequence[str],
        "NextToken": str,
    },
    total=False,
)

DescribeNetworkAclsRequestDescribeNetworkAclsPaginateTypeDef = TypedDict(
    "DescribeNetworkAclsRequestDescribeNetworkAclsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NetworkAclIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkAclsRequestRequestTypeDef = TypedDict(
    "DescribeNetworkAclsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NetworkAclIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeNetworkInsightsAccessScopeAnalysesRequestDescribeNetworkInsightsAccessScopeAnalysesPaginateTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopeAnalysesRequestDescribeNetworkInsightsAccessScopeAnalysesPaginateTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisIds": Sequence[str],
        "NetworkInsightsAccessScopeId": str,
        "AnalysisStartTimeBegin": Union[datetime, str],
        "AnalysisStartTimeEnd": Union[datetime, str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInsightsAccessScopeAnalysesRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopeAnalysesRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisIds": Sequence[str],
        "NetworkInsightsAccessScopeId": str,
        "AnalysisStartTimeBegin": Union[datetime, str],
        "AnalysisStartTimeEnd": Union[datetime, str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "DryRun": bool,
        "NextToken": str,
    },
    total=False,
)

DescribeNetworkInsightsAccessScopesRequestDescribeNetworkInsightsAccessScopesPaginateTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopesRequestDescribeNetworkInsightsAccessScopesPaginateTypeDef",
    {
        "NetworkInsightsAccessScopeIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInsightsAccessScopesRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopesRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "DryRun": bool,
        "NextToken": str,
    },
    total=False,
)

DescribeNetworkInsightsAnalysesRequestDescribeNetworkInsightsAnalysesPaginateTypeDef = TypedDict(
    "DescribeNetworkInsightsAnalysesRequestDescribeNetworkInsightsAnalysesPaginateTypeDef",
    {
        "NetworkInsightsAnalysisIds": Sequence[str],
        "NetworkInsightsPathId": str,
        "AnalysisStartTime": Union[datetime, str],
        "AnalysisEndTime": Union[datetime, str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInsightsAnalysesRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInsightsAnalysesRequestRequestTypeDef",
    {
        "NetworkInsightsAnalysisIds": Sequence[str],
        "NetworkInsightsPathId": str,
        "AnalysisStartTime": Union[datetime, str],
        "AnalysisEndTime": Union[datetime, str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "DryRun": bool,
        "NextToken": str,
    },
    total=False,
)

DescribeNetworkInsightsPathsRequestDescribeNetworkInsightsPathsPaginateTypeDef = TypedDict(
    "DescribeNetworkInsightsPathsRequestDescribeNetworkInsightsPathsPaginateTypeDef",
    {
        "NetworkInsightsPathIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInsightsPathsRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInsightsPathsRequestRequestTypeDef",
    {
        "NetworkInsightsPathIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "DryRun": bool,
        "NextToken": str,
    },
    total=False,
)

DescribeNetworkInterfacePermissionsRequestDescribeNetworkInterfacePermissionsPaginateTypeDef = TypedDict(
    "DescribeNetworkInterfacePermissionsRequestDescribeNetworkInterfacePermissionsPaginateTypeDef",
    {
        "NetworkInterfacePermissionIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInterfacePermissionsRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInterfacePermissionsRequestRequestTypeDef",
    {
        "NetworkInterfacePermissionIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeNetworkInterfacesRequestDescribeNetworkInterfacesPaginateTypeDef = TypedDict(
    "DescribeNetworkInterfacesRequestDescribeNetworkInterfacesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NetworkInterfaceIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeNetworkInterfacesRequestRequestTypeDef = TypedDict(
    "DescribeNetworkInterfacesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NetworkInterfaceIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribePlacementGroupsRequestRequestTypeDef = TypedDict(
    "DescribePlacementGroupsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "GroupNames": Sequence[str],
        "GroupIds": Sequence[str],
    },
    total=False,
)

DescribePrefixListsRequestDescribePrefixListsPaginateTypeDef = TypedDict(
    "DescribePrefixListsRequestDescribePrefixListsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PrefixListIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribePrefixListsRequestRequestTypeDef = TypedDict(
    "DescribePrefixListsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "PrefixListIds": Sequence[str],
    },
    total=False,
)

DescribePublicIpv4PoolsRequestDescribePublicIpv4PoolsPaginateTypeDef = TypedDict(
    "DescribePublicIpv4PoolsRequestDescribePublicIpv4PoolsPaginateTypeDef",
    {
        "PoolIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribePublicIpv4PoolsRequestRequestTypeDef = TypedDict(
    "DescribePublicIpv4PoolsRequestRequestTypeDef",
    {
        "PoolIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "Filters": Sequence[FilterTypeDef],
    },
    total=False,
)

DescribeRegionsRequestRequestTypeDef = TypedDict(
    "DescribeRegionsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "RegionNames": Sequence[str],
        "DryRun": bool,
        "AllRegions": bool,
    },
    total=False,
)

DescribeReplaceRootVolumeTasksRequestDescribeReplaceRootVolumeTasksPaginateTypeDef = TypedDict(
    "DescribeReplaceRootVolumeTasksRequestDescribeReplaceRootVolumeTasksPaginateTypeDef",
    {
        "ReplaceRootVolumeTaskIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeReplaceRootVolumeTasksRequestRequestTypeDef = TypedDict(
    "DescribeReplaceRootVolumeTasksRequestRequestTypeDef",
    {
        "ReplaceRootVolumeTaskIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeReservedInstancesListingsRequestRequestTypeDef = TypedDict(
    "DescribeReservedInstancesListingsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
    },
    total=False,
)

DescribeReservedInstancesModificationsRequestDescribeReservedInstancesModificationsPaginateTypeDef = TypedDict(
    "DescribeReservedInstancesModificationsRequestDescribeReservedInstancesModificationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "ReservedInstancesModificationIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeReservedInstancesModificationsRequestRequestTypeDef = TypedDict(
    "DescribeReservedInstancesModificationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "ReservedInstancesModificationIds": Sequence[str],
        "NextToken": str,
    },
    total=False,
)

DescribeReservedInstancesOfferingsRequestDescribeReservedInstancesOfferingsPaginateTypeDef = TypedDict(
    "DescribeReservedInstancesOfferingsRequestDescribeReservedInstancesOfferingsPaginateTypeDef",
    {
        "AvailabilityZone": str,
        "Filters": Sequence[FilterTypeDef],
        "IncludeMarketplace": bool,
        "InstanceType": InstanceTypeType,
        "MaxDuration": int,
        "MaxInstanceCount": int,
        "MinDuration": int,
        "OfferingClass": OfferingClassTypeType,
        "ProductDescription": RIProductDescriptionType,
        "ReservedInstancesOfferingIds": Sequence[str],
        "DryRun": bool,
        "InstanceTenancy": TenancyType,
        "OfferingType": OfferingTypeValuesType,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeReservedInstancesOfferingsRequestRequestTypeDef = TypedDict(
    "DescribeReservedInstancesOfferingsRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
        "Filters": Sequence[FilterTypeDef],
        "IncludeMarketplace": bool,
        "InstanceType": InstanceTypeType,
        "MaxDuration": int,
        "MaxInstanceCount": int,
        "MinDuration": int,
        "OfferingClass": OfferingClassTypeType,
        "ProductDescription": RIProductDescriptionType,
        "ReservedInstancesOfferingIds": Sequence[str],
        "DryRun": bool,
        "InstanceTenancy": TenancyType,
        "MaxResults": int,
        "NextToken": str,
        "OfferingType": OfferingTypeValuesType,
    },
    total=False,
)

DescribeReservedInstancesRequestRequestTypeDef = TypedDict(
    "DescribeReservedInstancesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "OfferingClass": OfferingClassTypeType,
        "ReservedInstancesIds": Sequence[str],
        "DryRun": bool,
        "OfferingType": OfferingTypeValuesType,
    },
    total=False,
)

DescribeRouteTablesRequestDescribeRouteTablesPaginateTypeDef = TypedDict(
    "DescribeRouteTablesRequestDescribeRouteTablesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "RouteTableIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeRouteTablesRequestRequestTypeDef = TypedDict(
    "DescribeRouteTablesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "RouteTableIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSecurityGroupRulesRequestDescribeSecurityGroupRulesPaginateTypeDef = TypedDict(
    "DescribeSecurityGroupRulesRequestDescribeSecurityGroupRulesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "SecurityGroupRuleIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSecurityGroupRulesRequestRequestTypeDef = TypedDict(
    "DescribeSecurityGroupRulesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "SecurityGroupRuleIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSecurityGroupsRequestDescribeSecurityGroupsPaginateTypeDef = TypedDict(
    "DescribeSecurityGroupsRequestDescribeSecurityGroupsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "GroupIds": Sequence[str],
        "GroupNames": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSecurityGroupsRequestRequestTypeDef = TypedDict(
    "DescribeSecurityGroupsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "GroupIds": Sequence[str],
        "GroupNames": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSnapshotTierStatusRequestDescribeSnapshotTierStatusPaginateTypeDef = TypedDict(
    "DescribeSnapshotTierStatusRequestDescribeSnapshotTierStatusPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSnapshotTierStatusRequestRequestTypeDef = TypedDict(
    "DescribeSnapshotTierStatusRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSnapshotsRequestDescribeSnapshotsPaginateTypeDef = TypedDict(
    "DescribeSnapshotsRequestDescribeSnapshotsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "OwnerIds": Sequence[str],
        "RestorableByUserIds": Sequence[str],
        "SnapshotIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSnapshotsRequestRequestTypeDef = TypedDict(
    "DescribeSnapshotsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "OwnerIds": Sequence[str],
        "RestorableByUserIds": Sequence[str],
        "SnapshotIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

DescribeSpotInstanceRequestsRequestDescribeSpotInstanceRequestsPaginateTypeDef = TypedDict(
    "DescribeSpotInstanceRequestsRequestDescribeSpotInstanceRequestsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "SpotInstanceRequestIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSpotInstanceRequestsRequestRequestTypeDef = TypedDict(
    "DescribeSpotInstanceRequestsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "SpotInstanceRequestIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSpotPriceHistoryRequestDescribeSpotPriceHistoryPaginateTypeDef = TypedDict(
    "DescribeSpotPriceHistoryRequestDescribeSpotPriceHistoryPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "AvailabilityZone": str,
        "DryRun": bool,
        "EndTime": Union[datetime, str],
        "InstanceTypes": Sequence[InstanceTypeType],
        "ProductDescriptions": Sequence[str],
        "StartTime": Union[datetime, str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSpotPriceHistoryRequestRequestTypeDef = TypedDict(
    "DescribeSpotPriceHistoryRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "AvailabilityZone": str,
        "DryRun": bool,
        "EndTime": Union[datetime, str],
        "InstanceTypes": Sequence[InstanceTypeType],
        "MaxResults": int,
        "NextToken": str,
        "ProductDescriptions": Sequence[str],
        "StartTime": Union[datetime, str],
    },
    total=False,
)

DescribeStoreImageTasksRequestDescribeStoreImageTasksPaginateTypeDef = TypedDict(
    "DescribeStoreImageTasksRequestDescribeStoreImageTasksPaginateTypeDef",
    {
        "ImageIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeStoreImageTasksRequestRequestTypeDef = TypedDict(
    "DescribeStoreImageTasksRequestRequestTypeDef",
    {
        "ImageIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeSubnetsRequestDescribeSubnetsPaginateTypeDef = TypedDict(
    "DescribeSubnetsRequestDescribeSubnetsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "SubnetIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeSubnetsRequestRequestTypeDef = TypedDict(
    "DescribeSubnetsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "SubnetIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeTagsRequestDescribeTagsPaginateTypeDef = TypedDict(
    "DescribeTagsRequestDescribeTagsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTagsRequestRequestTypeDef = TypedDict(
    "DescribeTagsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeTrafficMirrorFiltersRequestDescribeTrafficMirrorFiltersPaginateTypeDef = TypedDict(
    "DescribeTrafficMirrorFiltersRequestDescribeTrafficMirrorFiltersPaginateTypeDef",
    {
        "TrafficMirrorFilterIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTrafficMirrorFiltersRequestRequestTypeDef = TypedDict(
    "DescribeTrafficMirrorFiltersRequestRequestTypeDef",
    {
        "TrafficMirrorFilterIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeTrafficMirrorSessionsRequestDescribeTrafficMirrorSessionsPaginateTypeDef = TypedDict(
    "DescribeTrafficMirrorSessionsRequestDescribeTrafficMirrorSessionsPaginateTypeDef",
    {
        "TrafficMirrorSessionIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTrafficMirrorSessionsRequestRequestTypeDef = TypedDict(
    "DescribeTrafficMirrorSessionsRequestRequestTypeDef",
    {
        "TrafficMirrorSessionIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeTrafficMirrorTargetsRequestDescribeTrafficMirrorTargetsPaginateTypeDef = TypedDict(
    "DescribeTrafficMirrorTargetsRequestDescribeTrafficMirrorTargetsPaginateTypeDef",
    {
        "TrafficMirrorTargetIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTrafficMirrorTargetsRequestRequestTypeDef = TypedDict(
    "DescribeTrafficMirrorTargetsRequestRequestTypeDef",
    {
        "TrafficMirrorTargetIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeTransitGatewayAttachmentsRequestDescribeTransitGatewayAttachmentsPaginateTypeDef = (
    TypedDict(
        "DescribeTransitGatewayAttachmentsRequestDescribeTransitGatewayAttachmentsPaginateTypeDef",
        {
            "TransitGatewayAttachmentIds": Sequence[str],
            "Filters": Sequence[FilterTypeDef],
            "DryRun": bool,
            "PaginationConfig": "PaginatorConfigTypeDef",
        },
        total=False,
    )
)

DescribeTransitGatewayAttachmentsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayAttachmentsRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayConnectPeersRequestDescribeTransitGatewayConnectPeersPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayConnectPeersRequestDescribeTransitGatewayConnectPeersPaginateTypeDef",
    {
        "TransitGatewayConnectPeerIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayConnectPeersRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayConnectPeersRequestRequestTypeDef",
    {
        "TransitGatewayConnectPeerIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayConnectsRequestDescribeTransitGatewayConnectsPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayConnectsRequestDescribeTransitGatewayConnectsPaginateTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayConnectsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayConnectsRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayMulticastDomainsRequestDescribeTransitGatewayMulticastDomainsPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayMulticastDomainsRequestDescribeTransitGatewayMulticastDomainsPaginateTypeDef",
    {
        "TransitGatewayMulticastDomainIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayMulticastDomainsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayMulticastDomainsRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayPeeringAttachmentsRequestDescribeTransitGatewayPeeringAttachmentsPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayPeeringAttachmentsRequestDescribeTransitGatewayPeeringAttachmentsPaginateTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayPeeringAttachmentsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayPeeringAttachmentsRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayPolicyTablesRequestDescribeTransitGatewayPolicyTablesPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayPolicyTablesRequestDescribeTransitGatewayPolicyTablesPaginateTypeDef",
    {
        "TransitGatewayPolicyTableIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayPolicyTablesRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayPolicyTablesRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayRouteTableAnnouncementsRequestDescribeTransitGatewayRouteTableAnnouncementsPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayRouteTableAnnouncementsRequestDescribeTransitGatewayRouteTableAnnouncementsPaginateTypeDef",
    {
        "TransitGatewayRouteTableAnnouncementIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayRouteTableAnnouncementsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayRouteTableAnnouncementsRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableAnnouncementIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayRouteTablesRequestDescribeTransitGatewayRouteTablesPaginateTypeDef = (
    TypedDict(
        "DescribeTransitGatewayRouteTablesRequestDescribeTransitGatewayRouteTablesPaginateTypeDef",
        {
            "TransitGatewayRouteTableIds": Sequence[str],
            "Filters": Sequence[FilterTypeDef],
            "DryRun": bool,
            "PaginationConfig": "PaginatorConfigTypeDef",
        },
        total=False,
    )
)

DescribeTransitGatewayRouteTablesRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayRouteTablesRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewayVpcAttachmentsRequestDescribeTransitGatewayVpcAttachmentsPaginateTypeDef = TypedDict(
    "DescribeTransitGatewayVpcAttachmentsRequestDescribeTransitGatewayVpcAttachmentsPaginateTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewayVpcAttachmentsRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewayVpcAttachmentsRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTransitGatewaysRequestDescribeTransitGatewaysPaginateTypeDef = TypedDict(
    "DescribeTransitGatewaysRequestDescribeTransitGatewaysPaginateTypeDef",
    {
        "TransitGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTransitGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeTransitGatewaysRequestRequestTypeDef",
    {
        "TransitGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeTrunkInterfaceAssociationsRequestDescribeTrunkInterfaceAssociationsPaginateTypeDef = TypedDict(
    "DescribeTrunkInterfaceAssociationsRequestDescribeTrunkInterfaceAssociationsPaginateTypeDef",
    {
        "AssociationIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeTrunkInterfaceAssociationsRequestRequestTypeDef = TypedDict(
    "DescribeTrunkInterfaceAssociationsRequestRequestTypeDef",
    {
        "AssociationIds": Sequence[str],
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeVerifiedAccessEndpointsRequestDescribeVerifiedAccessEndpointsPaginateTypeDef = TypedDict(
    "DescribeVerifiedAccessEndpointsRequestDescribeVerifiedAccessEndpointsPaginateTypeDef",
    {
        "VerifiedAccessEndpointIds": Sequence[str],
        "VerifiedAccessInstanceId": str,
        "VerifiedAccessGroupId": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVerifiedAccessEndpointsRequestRequestTypeDef = TypedDict(
    "DescribeVerifiedAccessEndpointsRequestRequestTypeDef",
    {
        "VerifiedAccessEndpointIds": Sequence[str],
        "VerifiedAccessInstanceId": str,
        "VerifiedAccessGroupId": str,
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeVerifiedAccessGroupsRequestDescribeVerifiedAccessGroupsPaginateTypeDef = TypedDict(
    "DescribeVerifiedAccessGroupsRequestDescribeVerifiedAccessGroupsPaginateTypeDef",
    {
        "VerifiedAccessGroupIds": Sequence[str],
        "VerifiedAccessInstanceId": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVerifiedAccessGroupsRequestRequestTypeDef = TypedDict(
    "DescribeVerifiedAccessGroupsRequestRequestTypeDef",
    {
        "VerifiedAccessGroupIds": Sequence[str],
        "VerifiedAccessInstanceId": str,
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeVerifiedAccessInstanceLoggingConfigurationsRequestDescribeVerifiedAccessInstanceLoggingConfigurationsPaginateTypeDef = TypedDict(
    "DescribeVerifiedAccessInstanceLoggingConfigurationsRequestDescribeVerifiedAccessInstanceLoggingConfigurationsPaginateTypeDef",
    {
        "VerifiedAccessInstanceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVerifiedAccessInstanceLoggingConfigurationsRequestRequestTypeDef = TypedDict(
    "DescribeVerifiedAccessInstanceLoggingConfigurationsRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeVerifiedAccessInstancesRequestDescribeVerifiedAccessInstancesPaginateTypeDef = TypedDict(
    "DescribeVerifiedAccessInstancesRequestDescribeVerifiedAccessInstancesPaginateTypeDef",
    {
        "VerifiedAccessInstanceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVerifiedAccessInstancesRequestRequestTypeDef = TypedDict(
    "DescribeVerifiedAccessInstancesRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeVerifiedAccessTrustProvidersRequestDescribeVerifiedAccessTrustProvidersPaginateTypeDef = TypedDict(
    "DescribeVerifiedAccessTrustProvidersRequestDescribeVerifiedAccessTrustProvidersPaginateTypeDef",
    {
        "VerifiedAccessTrustProviderIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVerifiedAccessTrustProvidersRequestRequestTypeDef = TypedDict(
    "DescribeVerifiedAccessTrustProvidersRequestRequestTypeDef",
    {
        "VerifiedAccessTrustProviderIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)

DescribeVolumeStatusRequestDescribeVolumeStatusPaginateTypeDef = TypedDict(
    "DescribeVolumeStatusRequestDescribeVolumeStatusPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVolumeStatusRequestRequestTypeDef = TypedDict(
    "DescribeVolumeStatusRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "VolumeIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

DescribeVolumeStatusRequestVolumeDescribeStatusTypeDef = TypedDict(
    "DescribeVolumeStatusRequestVolumeDescribeStatusTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)

DescribeVolumesModificationsRequestDescribeVolumesModificationsPaginateTypeDef = TypedDict(
    "DescribeVolumesModificationsRequestDescribeVolumesModificationsPaginateTypeDef",
    {
        "DryRun": bool,
        "VolumeIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVolumesModificationsRequestRequestTypeDef = TypedDict(
    "DescribeVolumesModificationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "VolumeIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeVolumesRequestDescribeVolumesPaginateTypeDef = TypedDict(
    "DescribeVolumesRequestDescribeVolumesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVolumesRequestRequestTypeDef = TypedDict(
    "DescribeVolumesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeVpcClassicLinkRequestRequestTypeDef = TypedDict(
    "DescribeVpcClassicLinkRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "VpcIds": Sequence[str],
    },
    total=False,
)

DescribeVpcEndpointConnectionNotificationsRequestDescribeVpcEndpointConnectionNotificationsPaginateTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionNotificationsRequestDescribeVpcEndpointConnectionNotificationsPaginateTypeDef",
    {
        "DryRun": bool,
        "ConnectionNotificationId": str,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcEndpointConnectionNotificationsRequestRequestTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionNotificationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ConnectionNotificationId": str,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeVpcEndpointConnectionsRequestDescribeVpcEndpointConnectionsPaginateTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionsRequestDescribeVpcEndpointConnectionsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcEndpointConnectionsRequestRequestTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeVpcEndpointServiceConfigurationsRequestDescribeVpcEndpointServiceConfigurationsPaginateTypeDef = TypedDict(
    "DescribeVpcEndpointServiceConfigurationsRequestDescribeVpcEndpointServiceConfigurationsPaginateTypeDef",
    {
        "DryRun": bool,
        "ServiceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcEndpointServiceConfigurationsRequestRequestTypeDef = TypedDict(
    "DescribeVpcEndpointServiceConfigurationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ServiceIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

_RequiredDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef = TypedDict(
    "_RequiredDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef",
    {
        "ServiceId": str,
    },
)
_OptionalDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef = TypedDict(
    "_OptionalDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef(
    _RequiredDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef,
    _OptionalDescribeVpcEndpointServicePermissionsRequestDescribeVpcEndpointServicePermissionsPaginateTypeDef,
):
    pass


_RequiredDescribeVpcEndpointServicePermissionsRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeVpcEndpointServicePermissionsRequestRequestTypeDef",
    {
        "ServiceId": str,
    },
)
_OptionalDescribeVpcEndpointServicePermissionsRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeVpcEndpointServicePermissionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeVpcEndpointServicePermissionsRequestRequestTypeDef(
    _RequiredDescribeVpcEndpointServicePermissionsRequestRequestTypeDef,
    _OptionalDescribeVpcEndpointServicePermissionsRequestRequestTypeDef,
):
    pass


DescribeVpcEndpointServicesRequestDescribeVpcEndpointServicesPaginateTypeDef = TypedDict(
    "DescribeVpcEndpointServicesRequestDescribeVpcEndpointServicesPaginateTypeDef",
    {
        "DryRun": bool,
        "ServiceNames": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcEndpointServicesRequestRequestTypeDef = TypedDict(
    "DescribeVpcEndpointServicesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ServiceNames": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeVpcEndpointsRequestDescribeVpcEndpointsPaginateTypeDef = TypedDict(
    "DescribeVpcEndpointsRequestDescribeVpcEndpointsPaginateTypeDef",
    {
        "DryRun": bool,
        "VpcEndpointIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcEndpointsRequestRequestTypeDef = TypedDict(
    "DescribeVpcEndpointsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "VpcEndpointIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)

DescribeVpcPeeringConnectionsRequestDescribeVpcPeeringConnectionsPaginateTypeDef = TypedDict(
    "DescribeVpcPeeringConnectionsRequestDescribeVpcPeeringConnectionsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "VpcPeeringConnectionIds": Sequence[str],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcPeeringConnectionsRequestRequestTypeDef = TypedDict(
    "DescribeVpcPeeringConnectionsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "VpcPeeringConnectionIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeVpcsRequestDescribeVpcsPaginateTypeDef = TypedDict(
    "DescribeVpcsRequestDescribeVpcsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpcIds": Sequence[str],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeVpcsRequestRequestTypeDef = TypedDict(
    "DescribeVpcsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpcIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)

DescribeVpnConnectionsRequestRequestTypeDef = TypedDict(
    "DescribeVpnConnectionsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpnConnectionIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

DescribeVpnGatewaysRequestRequestTypeDef = TypedDict(
    "DescribeVpnGatewaysRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpnGatewayIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

_RequiredExportTransitGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_RequiredExportTransitGatewayRoutesRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "S3Bucket": str,
    },
)
_OptionalExportTransitGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_OptionalExportTransitGatewayRoutesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class ExportTransitGatewayRoutesRequestRequestTypeDef(
    _RequiredExportTransitGatewayRoutesRequestRequestTypeDef,
    _OptionalExportTransitGatewayRoutesRequestRequestTypeDef,
):
    pass


_RequiredGetCoipPoolUsageRequestRequestTypeDef = TypedDict(
    "_RequiredGetCoipPoolUsageRequestRequestTypeDef",
    {
        "PoolId": str,
    },
)
_OptionalGetCoipPoolUsageRequestRequestTypeDef = TypedDict(
    "_OptionalGetCoipPoolUsageRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetCoipPoolUsageRequestRequestTypeDef(
    _RequiredGetCoipPoolUsageRequestRequestTypeDef, _OptionalGetCoipPoolUsageRequestRequestTypeDef
):
    pass


_RequiredGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef = TypedDict(
    "_RequiredGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef",
    {
        "IpamResourceDiscoveryId": str,
        "DiscoveryRegion": str,
    },
)
_OptionalGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef = TypedDict(
    "_OptionalGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef(
    _RequiredGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef,
    _OptionalGetIpamDiscoveredAccountsRequestGetIpamDiscoveredAccountsPaginateTypeDef,
):
    pass


_RequiredGetIpamDiscoveredAccountsRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamDiscoveredAccountsRequestRequestTypeDef",
    {
        "IpamResourceDiscoveryId": str,
        "DiscoveryRegion": str,
    },
)
_OptionalGetIpamDiscoveredAccountsRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamDiscoveredAccountsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)


class GetIpamDiscoveredAccountsRequestRequestTypeDef(
    _RequiredGetIpamDiscoveredAccountsRequestRequestTypeDef,
    _OptionalGetIpamDiscoveredAccountsRequestRequestTypeDef,
):
    pass


_RequiredGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef = TypedDict(
    "_RequiredGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef",
    {
        "IpamResourceDiscoveryId": str,
        "ResourceRegion": str,
    },
)
_OptionalGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef = TypedDict(
    "_OptionalGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef(
    _RequiredGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef,
    _OptionalGetIpamDiscoveredResourceCidrsRequestGetIpamDiscoveredResourceCidrsPaginateTypeDef,
):
    pass


_RequiredGetIpamDiscoveredResourceCidrsRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamDiscoveredResourceCidrsRequestRequestTypeDef",
    {
        "IpamResourceDiscoveryId": str,
        "ResourceRegion": str,
    },
)
_OptionalGetIpamDiscoveredResourceCidrsRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamDiscoveredResourceCidrsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)


class GetIpamDiscoveredResourceCidrsRequestRequestTypeDef(
    _RequiredGetIpamDiscoveredResourceCidrsRequestRequestTypeDef,
    _OptionalGetIpamDiscoveredResourceCidrsRequestRequestTypeDef,
):
    pass


_RequiredGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef = TypedDict(
    "_RequiredGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef = TypedDict(
    "_OptionalGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef",
    {
        "DryRun": bool,
        "IpamPoolAllocationId": str,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef(
    _RequiredGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef,
    _OptionalGetIpamPoolAllocationsRequestGetIpamPoolAllocationsPaginateTypeDef,
):
    pass


_RequiredGetIpamPoolAllocationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamPoolAllocationsRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalGetIpamPoolAllocationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamPoolAllocationsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "IpamPoolAllocationId": str,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetIpamPoolAllocationsRequestRequestTypeDef(
    _RequiredGetIpamPoolAllocationsRequestRequestTypeDef,
    _OptionalGetIpamPoolAllocationsRequestRequestTypeDef,
):
    pass


_RequiredGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef = TypedDict(
    "_RequiredGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef = TypedDict(
    "_OptionalGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef(
    _RequiredGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef,
    _OptionalGetIpamPoolCidrsRequestGetIpamPoolCidrsPaginateTypeDef,
):
    pass


_RequiredGetIpamPoolCidrsRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamPoolCidrsRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalGetIpamPoolCidrsRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamPoolCidrsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetIpamPoolCidrsRequestRequestTypeDef(
    _RequiredGetIpamPoolCidrsRequestRequestTypeDef, _OptionalGetIpamPoolCidrsRequestRequestTypeDef
):
    pass


_RequiredGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef = TypedDict(
    "_RequiredGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef",
    {
        "IpamScopeId": str,
    },
)
_OptionalGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef = TypedDict(
    "_OptionalGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "IpamPoolId": str,
        "ResourceId": str,
        "ResourceType": IpamResourceTypeType,
        "ResourceTag": RequestIpamResourceTagTypeDef,
        "ResourceOwner": str,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef(
    _RequiredGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef,
    _OptionalGetIpamResourceCidrsRequestGetIpamResourceCidrsPaginateTypeDef,
):
    pass


_RequiredGetIpamResourceCidrsRequestRequestTypeDef = TypedDict(
    "_RequiredGetIpamResourceCidrsRequestRequestTypeDef",
    {
        "IpamScopeId": str,
    },
)
_OptionalGetIpamResourceCidrsRequestRequestTypeDef = TypedDict(
    "_OptionalGetIpamResourceCidrsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "IpamPoolId": str,
        "ResourceId": str,
        "ResourceType": IpamResourceTypeType,
        "ResourceTag": RequestIpamResourceTagTypeDef,
        "ResourceOwner": str,
    },
    total=False,
)


class GetIpamResourceCidrsRequestRequestTypeDef(
    _RequiredGetIpamResourceCidrsRequestRequestTypeDef,
    _OptionalGetIpamResourceCidrsRequestRequestTypeDef,
):
    pass


_RequiredGetSubnetCidrReservationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetSubnetCidrReservationsRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalGetSubnetCidrReservationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetSubnetCidrReservationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
    },
    total=False,
)


class GetSubnetCidrReservationsRequestRequestTypeDef(
    _RequiredGetSubnetCidrReservationsRequestRequestTypeDef,
    _OptionalGetSubnetCidrReservationsRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef(
    _RequiredGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef,
    _OptionalGetTransitGatewayAttachmentPropagationsRequestGetTransitGatewayAttachmentPropagationsPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayAttachmentPropagationsRequestRequestTypeDef(
    _RequiredGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef,
    _OptionalGetTransitGatewayAttachmentPropagationsRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
    },
)
_OptionalGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef(
    _RequiredGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef,
    _OptionalGetTransitGatewayMulticastDomainAssociationsRequestGetTransitGatewayMulticastDomainAssociationsPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
    },
)
_OptionalGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef(
    _RequiredGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef,
    _OptionalGetTransitGatewayMulticastDomainAssociationsRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
    },
)
_OptionalGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef(
    _RequiredGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef,
    _OptionalGetTransitGatewayPolicyTableAssociationsRequestGetTransitGatewayPolicyTableAssociationsPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
    },
)
_OptionalGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef(
    _RequiredGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef,
    _OptionalGetTransitGatewayPolicyTableAssociationsRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef",
    {
        "TransitGatewayPolicyTableId": str,
    },
)
_OptionalGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayPolicyTableEntriesRequestRequestTypeDef(
    _RequiredGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef,
    _OptionalGetTransitGatewayPolicyTableEntriesRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef(
    _RequiredGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef,
    _OptionalGetTransitGatewayPrefixListReferencesRequestGetTransitGatewayPrefixListReferencesPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayPrefixListReferencesRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayPrefixListReferencesRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayPrefixListReferencesRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayPrefixListReferencesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayPrefixListReferencesRequestRequestTypeDef(
    _RequiredGetTransitGatewayPrefixListReferencesRequestRequestTypeDef,
    _OptionalGetTransitGatewayPrefixListReferencesRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef(
    _RequiredGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef,
    _OptionalGetTransitGatewayRouteTableAssociationsRequestGetTransitGatewayRouteTableAssociationsPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsRequestRequestTypeDef(
    _RequiredGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef,
    _OptionalGetTransitGatewayRouteTableAssociationsRequestRequestTypeDef,
):
    pass


_RequiredGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef = TypedDict(
    "_RequiredGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef = TypedDict(
    "_OptionalGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef(
    _RequiredGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef,
    _OptionalGetTransitGatewayRouteTablePropagationsRequestGetTransitGatewayRouteTablePropagationsPaginateTypeDef,
):
    pass


_RequiredGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef = TypedDict(
    "_RequiredGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
    },
)
_OptionalGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef = TypedDict(
    "_OptionalGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsRequestRequestTypeDef(
    _RequiredGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef,
    _OptionalGetTransitGatewayRouteTablePropagationsRequestRequestTypeDef,
):
    pass


_RequiredSearchLocalGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_RequiredSearchLocalGatewayRoutesRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalSearchLocalGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_OptionalSearchLocalGatewayRoutesRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class SearchLocalGatewayRoutesRequestRequestTypeDef(
    _RequiredSearchLocalGatewayRoutesRequestRequestTypeDef,
    _OptionalSearchLocalGatewayRoutesRequestRequestTypeDef,
):
    pass


_RequiredSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef = TypedDict(
    "_RequiredSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef = TypedDict(
    "_OptionalSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class SearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef(
    _RequiredSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef,
    _OptionalSearchLocalGatewayRoutesRequestSearchLocalGatewayRoutesPaginateTypeDef,
):
    pass


_RequiredSearchTransitGatewayMulticastGroupsRequestRequestTypeDef = TypedDict(
    "_RequiredSearchTransitGatewayMulticastGroupsRequestRequestTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
    },
)
_OptionalSearchTransitGatewayMulticastGroupsRequestRequestTypeDef = TypedDict(
    "_OptionalSearchTransitGatewayMulticastGroupsRequestRequestTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
    },
    total=False,
)


class SearchTransitGatewayMulticastGroupsRequestRequestTypeDef(
    _RequiredSearchTransitGatewayMulticastGroupsRequestRequestTypeDef,
    _OptionalSearchTransitGatewayMulticastGroupsRequestRequestTypeDef,
):
    pass


_RequiredSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef = TypedDict(
    "_RequiredSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
    },
)
_OptionalSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef = TypedDict(
    "_OptionalSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class SearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef(
    _RequiredSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef,
    _OptionalSearchTransitGatewayMulticastGroupsRequestSearchTransitGatewayMulticastGroupsPaginateTypeDef,
):
    pass


_RequiredSearchTransitGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_RequiredSearchTransitGatewayRoutesRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "Filters": Sequence[FilterTypeDef],
    },
)
_OptionalSearchTransitGatewayRoutesRequestRequestTypeDef = TypedDict(
    "_OptionalSearchTransitGatewayRoutesRequestRequestTypeDef",
    {
        "MaxResults": int,
        "DryRun": bool,
    },
    total=False,
)


class SearchTransitGatewayRoutesRequestRequestTypeDef(
    _RequiredSearchTransitGatewayRoutesRequestRequestTypeDef,
    _OptionalSearchTransitGatewayRoutesRequestRequestTypeDef,
):
    pass


DescribeAggregateIdFormatResultOutputTypeDef = TypedDict(
    "DescribeAggregateIdFormatResultOutputTypeDef",
    {
        "UseLongIdsAggregated": bool,
        "Statuses": List[IdFormatOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIdFormatResultOutputTypeDef = TypedDict(
    "DescribeIdFormatResultOutputTypeDef",
    {
        "Statuses": List[IdFormatOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIdentityIdFormatResultOutputTypeDef = TypedDict(
    "DescribeIdentityIdFormatResultOutputTypeDef",
    {
        "Statuses": List[IdFormatOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PrincipalIdFormatOutputTypeDef = TypedDict(
    "PrincipalIdFormatOutputTypeDef",
    {
        "Arn": str,
        "Statuses": List[IdFormatOutputTypeDef],
    },
)

DescribeAwsNetworkPerformanceMetricSubscriptionsResultOutputTypeDef = TypedDict(
    "DescribeAwsNetworkPerformanceMetricSubscriptionsResultOutputTypeDef",
    {
        "NextToken": str,
        "Subscriptions": List[SubscriptionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeBundleTasksRequestBundleTaskCompleteWaitTypeDef = TypedDict(
    "DescribeBundleTasksRequestBundleTaskCompleteWaitTypeDef",
    {
        "BundleIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeConversionTasksRequestConversionTaskCancelledWaitTypeDef = TypedDict(
    "DescribeConversionTasksRequestConversionTaskCancelledWaitTypeDef",
    {
        "ConversionTaskIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeConversionTasksRequestConversionTaskCompletedWaitTypeDef = TypedDict(
    "DescribeConversionTasksRequestConversionTaskCompletedWaitTypeDef",
    {
        "ConversionTaskIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeConversionTasksRequestConversionTaskDeletedWaitTypeDef = TypedDict(
    "DescribeConversionTasksRequestConversionTaskDeletedWaitTypeDef",
    {
        "ConversionTaskIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeCustomerGatewaysRequestCustomerGatewayAvailableWaitTypeDef = TypedDict(
    "DescribeCustomerGatewaysRequestCustomerGatewayAvailableWaitTypeDef",
    {
        "CustomerGatewayIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeExportTasksRequestExportTaskCancelledWaitTypeDef = TypedDict(
    "DescribeExportTasksRequestExportTaskCancelledWaitTypeDef",
    {
        "ExportTaskIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeExportTasksRequestExportTaskCompletedWaitTypeDef = TypedDict(
    "DescribeExportTasksRequestExportTaskCompletedWaitTypeDef",
    {
        "ExportTaskIds": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeImagesRequestImageAvailableWaitTypeDef = TypedDict(
    "DescribeImagesRequestImageAvailableWaitTypeDef",
    {
        "ExecutableUsers": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "ImageIds": Sequence[str],
        "Owners": Sequence[str],
        "IncludeDeprecated": bool,
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeImagesRequestImageExistsWaitTypeDef = TypedDict(
    "DescribeImagesRequestImageExistsWaitTypeDef",
    {
        "ExecutableUsers": Sequence[str],
        "Filters": Sequence[FilterTypeDef],
        "ImageIds": Sequence[str],
        "Owners": Sequence[str],
        "IncludeDeprecated": bool,
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeImportSnapshotTasksRequestSnapshotImportedWaitTypeDef = TypedDict(
    "DescribeImportSnapshotTasksRequestSnapshotImportedWaitTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ImportTaskIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstanceStatusRequestInstanceStatusOkWaitTypeDef = TypedDict(
    "DescribeInstanceStatusRequestInstanceStatusOkWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
        "IncludeAllInstances": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstanceStatusRequestSystemStatusOkWaitTypeDef = TypedDict(
    "DescribeInstanceStatusRequestSystemStatusOkWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "MaxResults": int,
        "NextToken": str,
        "DryRun": bool,
        "IncludeAllInstances": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstancesRequestInstanceExistsWaitTypeDef = TypedDict(
    "DescribeInstancesRequestInstanceExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstancesRequestInstanceRunningWaitTypeDef = TypedDict(
    "DescribeInstancesRequestInstanceRunningWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstancesRequestInstanceStoppedWaitTypeDef = TypedDict(
    "DescribeInstancesRequestInstanceStoppedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInstancesRequestInstanceTerminatedWaitTypeDef = TypedDict(
    "DescribeInstancesRequestInstanceTerminatedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "InstanceIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeInternetGatewaysRequestInternetGatewayExistsWaitTypeDef = TypedDict(
    "DescribeInternetGatewaysRequestInternetGatewayExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "InternetGatewayIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeKeyPairsRequestKeyPairExistsWaitTypeDef = TypedDict(
    "DescribeKeyPairsRequestKeyPairExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "KeyNames": Sequence[str],
        "KeyPairIds": Sequence[str],
        "DryRun": bool,
        "IncludePublicKey": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeNatGatewaysRequestNatGatewayAvailableWaitTypeDef = TypedDict(
    "DescribeNatGatewaysRequestNatGatewayAvailableWaitTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NatGatewayIds": Sequence[str],
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeNatGatewaysRequestNatGatewayDeletedWaitTypeDef = TypedDict(
    "DescribeNatGatewaysRequestNatGatewayDeletedWaitTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NatGatewayIds": Sequence[str],
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeNetworkInterfacesRequestNetworkInterfaceAvailableWaitTypeDef = TypedDict(
    "DescribeNetworkInterfacesRequestNetworkInterfaceAvailableWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "NetworkInterfaceIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeSecurityGroupsRequestSecurityGroupExistsWaitTypeDef = TypedDict(
    "DescribeSecurityGroupsRequestSecurityGroupExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "GroupIds": Sequence[str],
        "GroupNames": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeSnapshotsRequestSnapshotCompletedWaitTypeDef = TypedDict(
    "DescribeSnapshotsRequestSnapshotCompletedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "OwnerIds": Sequence[str],
        "RestorableByUserIds": Sequence[str],
        "SnapshotIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeSpotInstanceRequestsRequestSpotInstanceRequestFulfilledWaitTypeDef = TypedDict(
    "DescribeSpotInstanceRequestsRequestSpotInstanceRequestFulfilledWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "SpotInstanceRequestIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeSubnetsRequestSubnetAvailableWaitTypeDef = TypedDict(
    "DescribeSubnetsRequestSubnetAvailableWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "SubnetIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVolumesRequestVolumeAvailableWaitTypeDef = TypedDict(
    "DescribeVolumesRequestVolumeAvailableWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVolumesRequestVolumeDeletedWaitTypeDef = TypedDict(
    "DescribeVolumesRequestVolumeDeletedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVolumesRequestVolumeInUseWaitTypeDef = TypedDict(
    "DescribeVolumesRequestVolumeInUseWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VolumeIds": Sequence[str],
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionDeletedWaitTypeDef = TypedDict(
    "DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionDeletedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "VpcPeeringConnectionIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionExistsWaitTypeDef = TypedDict(
    "DescribeVpcPeeringConnectionsRequestVpcPeeringConnectionExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "DryRun": bool,
        "VpcPeeringConnectionIds": Sequence[str],
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpcsRequestVpcAvailableWaitTypeDef = TypedDict(
    "DescribeVpcsRequestVpcAvailableWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpcIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpcsRequestVpcExistsWaitTypeDef = TypedDict(
    "DescribeVpcsRequestVpcExistsWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpcIds": Sequence[str],
        "DryRun": bool,
        "NextToken": str,
        "MaxResults": int,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpnConnectionsRequestVpnConnectionAvailableWaitTypeDef = TypedDict(
    "DescribeVpnConnectionsRequestVpnConnectionAvailableWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpnConnectionIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

DescribeVpnConnectionsRequestVpnConnectionDeletedWaitTypeDef = TypedDict(
    "DescribeVpnConnectionsRequestVpnConnectionDeletedWaitTypeDef",
    {
        "Filters": Sequence[FilterTypeDef],
        "VpnConnectionIds": Sequence[str],
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)

_RequiredGetPasswordDataRequestPasswordDataAvailableWaitTypeDef = TypedDict(
    "_RequiredGetPasswordDataRequestPasswordDataAvailableWaitTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalGetPasswordDataRequestPasswordDataAvailableWaitTypeDef = TypedDict(
    "_OptionalGetPasswordDataRequestPasswordDataAvailableWaitTypeDef",
    {
        "DryRun": bool,
        "WaiterConfig": WaiterConfigTypeDef,
    },
    total=False,
)


class GetPasswordDataRequestPasswordDataAvailableWaitTypeDef(
    _RequiredGetPasswordDataRequestPasswordDataAvailableWaitTypeDef,
    _OptionalGetPasswordDataRequestPasswordDataAvailableWaitTypeDef,
):
    pass


DescribeFastLaunchImagesSuccessItemOutputTypeDef = TypedDict(
    "DescribeFastLaunchImagesSuccessItemOutputTypeDef",
    {
        "ImageId": str,
        "ResourceType": Literal["snapshot"],
        "SnapshotConfiguration": FastLaunchSnapshotConfigurationResponseOutputTypeDef,
        "LaunchTemplate": FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef,
        "MaxParallelLaunches": int,
        "OwnerId": str,
        "State": FastLaunchStateCodeType,
        "StateTransitionReason": str,
        "StateTransitionTime": datetime,
    },
)

DisableFastLaunchResultOutputTypeDef = TypedDict(
    "DisableFastLaunchResultOutputTypeDef",
    {
        "ImageId": str,
        "ResourceType": Literal["snapshot"],
        "SnapshotConfiguration": FastLaunchSnapshotConfigurationResponseOutputTypeDef,
        "LaunchTemplate": FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef,
        "MaxParallelLaunches": int,
        "OwnerId": str,
        "State": FastLaunchStateCodeType,
        "StateTransitionReason": str,
        "StateTransitionTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableFastLaunchResultOutputTypeDef = TypedDict(
    "EnableFastLaunchResultOutputTypeDef",
    {
        "ImageId": str,
        "ResourceType": Literal["snapshot"],
        "SnapshotConfiguration": FastLaunchSnapshotConfigurationResponseOutputTypeDef,
        "LaunchTemplate": FastLaunchLaunchTemplateSpecificationResponseOutputTypeDef,
        "MaxParallelLaunches": int,
        "OwnerId": str,
        "State": FastLaunchStateCodeType,
        "StateTransitionReason": str,
        "StateTransitionTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeFastSnapshotRestoresResultOutputTypeDef = TypedDict(
    "DescribeFastSnapshotRestoresResultOutputTypeDef",
    {
        "FastSnapshotRestores": List[DescribeFastSnapshotRestoreSuccessItemOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeHostReservationOfferingsResultOutputTypeDef = TypedDict(
    "DescribeHostReservationOfferingsResultOutputTypeDef",
    {
        "NextToken": str,
        "OfferingSet": List[HostOfferingOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceCreditSpecificationsResultOutputTypeDef = TypedDict(
    "DescribeInstanceCreditSpecificationsResultOutputTypeDef",
    {
        "InstanceCreditSpecifications": List[InstanceCreditSpecificationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceTypeOfferingsResultOutputTypeDef = TypedDict(
    "DescribeInstanceTypeOfferingsResultOutputTypeDef",
    {
        "InstanceTypeOfferings": List[InstanceTypeOfferingOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeMovingAddressesResultOutputTypeDef = TypedDict(
    "DescribeMovingAddressesResultOutputTypeDef",
    {
        "MovingAddressStatuses": List[MovingAddressStatusOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribePrefixListsResultOutputTypeDef = TypedDict(
    "DescribePrefixListsResultOutputTypeDef",
    {
        "NextToken": str,
        "PrefixLists": List[PrefixListOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeRegionsResultOutputTypeDef = TypedDict(
    "DescribeRegionsResultOutputTypeDef",
    {
        "Regions": List[RegionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef = TypedDict(
    "_RequiredDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef",
    {
        "FirstSlotStartTimeRange": SlotDateTimeRangeRequestTypeDef,
        "Recurrence": ScheduledInstanceRecurrenceRequestTypeDef,
    },
)
_OptionalDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef = TypedDict(
    "_OptionalDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxSlotDurationInHours": int,
        "MinSlotDurationInHours": int,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef(
    _RequiredDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef,
    _OptionalDescribeScheduledInstanceAvailabilityRequestDescribeScheduledInstanceAvailabilityPaginateTypeDef,
):
    pass


_RequiredDescribeScheduledInstanceAvailabilityRequestRequestTypeDef = TypedDict(
    "_RequiredDescribeScheduledInstanceAvailabilityRequestRequestTypeDef",
    {
        "FirstSlotStartTimeRange": SlotDateTimeRangeRequestTypeDef,
        "Recurrence": ScheduledInstanceRecurrenceRequestTypeDef,
    },
)
_OptionalDescribeScheduledInstanceAvailabilityRequestRequestTypeDef = TypedDict(
    "_OptionalDescribeScheduledInstanceAvailabilityRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "MaxSlotDurationInHours": int,
        "MinSlotDurationInHours": int,
        "NextToken": str,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityRequestRequestTypeDef(
    _RequiredDescribeScheduledInstanceAvailabilityRequestRequestTypeDef,
    _OptionalDescribeScheduledInstanceAvailabilityRequestRequestTypeDef,
):
    pass


DescribeScheduledInstancesRequestDescribeScheduledInstancesPaginateTypeDef = TypedDict(
    "DescribeScheduledInstancesRequestDescribeScheduledInstancesPaginateTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "ScheduledInstanceIds": Sequence[str],
        "SlotStartTimeRange": SlotStartTimeRangeRequestTypeDef,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)

DescribeScheduledInstancesRequestRequestTypeDef = TypedDict(
    "DescribeScheduledInstancesRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Filters": Sequence[FilterTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "ScheduledInstanceIds": Sequence[str],
        "SlotStartTimeRange": SlotStartTimeRangeRequestTypeDef,
    },
    total=False,
)

DescribeSecurityGroupReferencesResultOutputTypeDef = TypedDict(
    "DescribeSecurityGroupReferencesResultOutputTypeDef",
    {
        "SecurityGroupReferenceSet": List[SecurityGroupReferenceOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSnapshotAttributeResultOutputTypeDef = TypedDict(
    "DescribeSnapshotAttributeResultOutputTypeDef",
    {
        "CreateVolumePermissions": List[CreateVolumePermissionOutputTypeDef],
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "SnapshotId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVolumeAttributeResultOutputTypeDef = TypedDict(
    "DescribeVolumeAttributeResultOutputTypeDef",
    {
        "AutoEnableIO": AttributeBooleanValueOutputTypeDef,
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "VolumeId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotPriceHistoryResultOutputTypeDef = TypedDict(
    "DescribeSpotPriceHistoryResultOutputTypeDef",
    {
        "NextToken": str,
        "SpotPriceHistory": List[SpotPriceOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeStoreImageTasksResultOutputTypeDef = TypedDict(
    "DescribeStoreImageTasksResultOutputTypeDef",
    {
        "StoreImageTaskResults": List[StoreImageTaskResultOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTagsResultOutputTypeDef = TypedDict(
    "DescribeTagsResultOutputTypeDef",
    {
        "NextToken": str,
        "Tags": List[TagDescriptionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVolumesModificationsResultOutputTypeDef = TypedDict(
    "DescribeVolumesModificationsResultOutputTypeDef",
    {
        "VolumesModifications": List[VolumeModificationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVolumeResultOutputTypeDef = TypedDict(
    "ModifyVolumeResultOutputTypeDef",
    {
        "VolumeModification": VolumeModificationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

FlowLogOutputTypeDef = TypedDict(
    "FlowLogOutputTypeDef",
    {
        "CreationTime": datetime,
        "DeliverLogsErrorMessage": str,
        "DeliverLogsPermissionArn": str,
        "DeliverCrossAccountRole": str,
        "DeliverLogsStatus": str,
        "FlowLogId": str,
        "FlowLogStatus": str,
        "LogGroupName": str,
        "ResourceId": str,
        "TrafficType": TrafficTypeType,
        "LogDestinationType": LogDestinationTypeType,
        "LogDestination": str,
        "LogFormat": str,
        "Tags": List[TagOutputTypeDef],
        "MaxAggregationInterval": int,
        "DestinationOptions": DestinationOptionsResponseOutputTypeDef,
    },
)

DisableFastSnapshotRestoreStateErrorItemOutputTypeDef = TypedDict(
    "DisableFastSnapshotRestoreStateErrorItemOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Error": DisableFastSnapshotRestoreStateErrorOutputTypeDef,
    },
)

DisableTransitGatewayRouteTablePropagationResultOutputTypeDef = TypedDict(
    "DisableTransitGatewayRouteTablePropagationResultOutputTypeDef",
    {
        "Propagation": TransitGatewayPropagationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

EnableTransitGatewayRouteTablePropagationResultOutputTypeDef = TypedDict(
    "EnableTransitGatewayRouteTablePropagationResultOutputTypeDef",
    {
        "Propagation": TransitGatewayPropagationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DiskImageTypeDef = TypedDict(
    "DiskImageTypeDef",
    {
        "Description": str,
        "Image": DiskImageDetailTypeDef,
        "Volume": VolumeDetailTypeDef,
    },
    total=False,
)

_RequiredImportVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredImportVolumeRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
        "Image": DiskImageDetailTypeDef,
        "Volume": VolumeDetailTypeDef,
    },
)
_OptionalImportVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalImportVolumeRequestRequestTypeDef",
    {
        "Description": str,
        "DryRun": bool,
    },
    total=False,
)


class ImportVolumeRequestRequestTypeDef(
    _RequiredImportVolumeRequestRequestTypeDef, _OptionalImportVolumeRequestRequestTypeDef
):
    pass


ImportInstanceVolumeDetailItemOutputTypeDef = TypedDict(
    "ImportInstanceVolumeDetailItemOutputTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": DiskImageDescriptionOutputTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": DiskImageVolumeDescriptionOutputTypeDef,
    },
)

ImportVolumeTaskDetailsOutputTypeDef = TypedDict(
    "ImportVolumeTaskDetailsOutputTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": DiskImageDescriptionOutputTypeDef,
        "Volume": DiskImageVolumeDescriptionOutputTypeDef,
    },
)

InstanceStorageInfoOutputTypeDef = TypedDict(
    "InstanceStorageInfoOutputTypeDef",
    {
        "TotalSizeInGB": int,
        "Disks": List[DiskInfoOutputTypeDef],
        "NvmeSupport": EphemeralNvmeSupportType,
        "EncryptionSupport": InstanceStorageEncryptionSupportType,
    },
)

VpcEndpointConnectionOutputTypeDef = TypedDict(
    "VpcEndpointConnectionOutputTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointId": str,
        "VpcEndpointOwner": str,
        "VpcEndpointState": StateType,
        "CreationTimestamp": datetime,
        "DnsEntries": List[DnsEntryOutputTypeDef],
        "NetworkLoadBalancerArns": List[str],
        "GatewayLoadBalancerArns": List[str],
        "IpAddressType": IpAddressTypeType,
        "VpcEndpointConnectionId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

_RequiredModifyClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredModifyClientVpnEndpointRequestRequestTypeDef",
    {
        "ClientVpnEndpointId": str,
    },
)
_OptionalModifyClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalModifyClientVpnEndpointRequestRequestTypeDef",
    {
        "ServerCertificateArn": str,
        "ConnectionLogOptions": ConnectionLogOptionsTypeDef,
        "DnsServers": DnsServersOptionsModifyStructureTypeDef,
        "VpnPort": int,
        "Description": str,
        "SplitTunnel": bool,
        "DryRun": bool,
        "SecurityGroupIds": Sequence[str],
        "VpcId": str,
        "SelfServicePortal": SelfServicePortalType,
        "ClientConnectOptions": ClientConnectOptionsTypeDef,
        "SessionTimeoutHours": int,
        "ClientLoginBannerOptions": ClientLoginBannerOptionsTypeDef,
    },
    total=False,
)


class ModifyClientVpnEndpointRequestRequestTypeDef(
    _RequiredModifyClientVpnEndpointRequestRequestTypeDef,
    _OptionalModifyClientVpnEndpointRequestRequestTypeDef,
):
    pass


EbsInfoOutputTypeDef = TypedDict(
    "EbsInfoOutputTypeDef",
    {
        "EbsOptimizedSupport": EbsOptimizedSupportType,
        "EncryptionSupport": EbsEncryptionSupportType,
        "EbsOptimizedInfo": EbsOptimizedInfoOutputTypeDef,
        "NvmeSupport": EbsNvmeSupportType,
    },
)

InstanceBlockDeviceMappingOutputTypeDef = TypedDict(
    "InstanceBlockDeviceMappingOutputTypeDef",
    {
        "DeviceName": str,
        "Ebs": EbsInstanceBlockDeviceOutputTypeDef,
    },
)

InstanceBlockDeviceMappingSpecificationTypeDef = TypedDict(
    "InstanceBlockDeviceMappingSpecificationTypeDef",
    {
        "DeviceName": str,
        "Ebs": EbsInstanceBlockDeviceSpecificationTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)

EgressOnlyInternetGatewayOutputTypeDef = TypedDict(
    "EgressOnlyInternetGatewayOutputTypeDef",
    {
        "Attachments": List[InternetGatewayAttachmentOutputTypeDef],
        "EgressOnlyInternetGatewayId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

InternetGatewayOutputTypeDef = TypedDict(
    "InternetGatewayOutputTypeDef",
    {
        "Attachments": List[InternetGatewayAttachmentOutputTypeDef],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

ElasticGpusOutputTypeDef = TypedDict(
    "ElasticGpusOutputTypeDef",
    {
        "ElasticGpuId": str,
        "AvailabilityZone": str,
        "ElasticGpuType": str,
        "ElasticGpuHealth": ElasticGpuHealthOutputTypeDef,
        "ElasticGpuState": Literal["ATTACHED"],
        "InstanceId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

EnaSrdSpecificationTypeDef = TypedDict(
    "EnaSrdSpecificationTypeDef",
    {
        "EnaSrdEnabled": bool,
        "EnaSrdUdpSpecification": EnaSrdUdpSpecificationTypeDef,
    },
    total=False,
)

_RequiredEnableFastLaunchRequestRequestTypeDef = TypedDict(
    "_RequiredEnableFastLaunchRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalEnableFastLaunchRequestRequestTypeDef = TypedDict(
    "_OptionalEnableFastLaunchRequestRequestTypeDef",
    {
        "ResourceType": str,
        "SnapshotConfiguration": FastLaunchSnapshotConfigurationRequestTypeDef,
        "LaunchTemplate": FastLaunchLaunchTemplateSpecificationRequestTypeDef,
        "MaxParallelLaunches": int,
        "DryRun": bool,
    },
    total=False,
)


class EnableFastLaunchRequestRequestTypeDef(
    _RequiredEnableFastLaunchRequestRequestTypeDef, _OptionalEnableFastLaunchRequestRequestTypeDef
):
    pass


EnableFastSnapshotRestoreStateErrorItemOutputTypeDef = TypedDict(
    "EnableFastSnapshotRestoreStateErrorItemOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Error": EnableFastSnapshotRestoreStateErrorOutputTypeDef,
    },
)

HistoryRecordEntryOutputTypeDef = TypedDict(
    "HistoryRecordEntryOutputTypeDef",
    {
        "EventInformation": EventInformationOutputTypeDef,
        "EventType": FleetEventTypeType,
        "Timestamp": datetime,
    },
)

HistoryRecordOutputTypeDef = TypedDict(
    "HistoryRecordOutputTypeDef",
    {
        "EventInformation": EventInformationOutputTypeDef,
        "EventType": EventTypeType,
        "Timestamp": datetime,
    },
)

ExportImageResultOutputTypeDef = TypedDict(
    "ExportImageResultOutputTypeDef",
    {
        "Description": str,
        "DiskImageFormat": DiskImageFormatType,
        "ExportImageTaskId": str,
        "ImageId": str,
        "RoleName": str,
        "Progress": str,
        "S3ExportLocation": ExportTaskS3LocationOutputTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ExportImageTaskOutputTypeDef = TypedDict(
    "ExportImageTaskOutputTypeDef",
    {
        "Description": str,
        "ExportImageTaskId": str,
        "ImageId": str,
        "Progress": str,
        "S3ExportLocation": ExportTaskS3LocationOutputTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
    },
)

ExportTaskOutputTypeDef = TypedDict(
    "ExportTaskOutputTypeDef",
    {
        "Description": str,
        "ExportTaskId": str,
        "ExportToS3Task": ExportToS3TaskOutputTypeDef,
        "InstanceExportDetails": InstanceExportDetailsOutputTypeDef,
        "State": ExportTaskStateType,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
    },
)

PathFilterOutputTypeDef = TypedDict(
    "PathFilterOutputTypeDef",
    {
        "SourceAddress": str,
        "SourcePortRange": FilterPortRangeOutputTypeDef,
        "DestinationAddress": str,
        "DestinationPortRange": FilterPortRangeOutputTypeDef,
    },
)

FleetSpotMaintenanceStrategiesOutputTypeDef = TypedDict(
    "FleetSpotMaintenanceStrategiesOutputTypeDef",
    {
        "CapacityRebalance": FleetSpotCapacityRebalanceOutputTypeDef,
    },
)

FleetSpotMaintenanceStrategiesRequestTypeDef = TypedDict(
    "FleetSpotMaintenanceStrategiesRequestTypeDef",
    {
        "CapacityRebalance": FleetSpotCapacityRebalanceRequestTypeDef,
    },
    total=False,
)

FpgaDeviceInfoOutputTypeDef = TypedDict(
    "FpgaDeviceInfoOutputTypeDef",
    {
        "Name": str,
        "Manufacturer": str,
        "Count": int,
        "MemoryInfo": FpgaDeviceMemoryInfoOutputTypeDef,
    },
)

FpgaImageAttributeOutputTypeDef = TypedDict(
    "FpgaImageAttributeOutputTypeDef",
    {
        "FpgaImageId": str,
        "Name": str,
        "Description": str,
        "LoadPermissions": List[LoadPermissionOutputTypeDef],
        "ProductCodes": List[ProductCodeOutputTypeDef],
    },
)

FpgaImageOutputTypeDef = TypedDict(
    "FpgaImageOutputTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "Name": str,
        "Description": str,
        "ShellVersion": str,
        "PciId": PciIdOutputTypeDef,
        "State": FpgaImageStateOutputTypeDef,
        "CreateTime": datetime,
        "UpdateTime": datetime,
        "OwnerId": str,
        "OwnerAlias": str,
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "Public": bool,
        "DataRetentionSupport": bool,
        "InstanceTypes": List[str],
    },
)

GetAssociatedIpv6PoolCidrsResultOutputTypeDef = TypedDict(
    "GetAssociatedIpv6PoolCidrsResultOutputTypeDef",
    {
        "Ipv6CidrAssociations": List[Ipv6CidrAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetCapacityReservationUsageResultOutputTypeDef = TypedDict(
    "GetCapacityReservationUsageResultOutputTypeDef",
    {
        "NextToken": str,
        "CapacityReservationId": str,
        "InstanceType": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "State": CapacityReservationStateType,
        "InstanceUsages": List[InstanceUsageOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetDefaultCreditSpecificationResultOutputTypeDef = TypedDict(
    "GetDefaultCreditSpecificationResultOutputTypeDef",
    {
        "InstanceFamilyCreditSpecification": InstanceFamilyCreditSpecificationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyDefaultCreditSpecificationResultOutputTypeDef = TypedDict(
    "ModifyDefaultCreditSpecificationResultOutputTypeDef",
    {
        "InstanceFamilyCreditSpecification": InstanceFamilyCreditSpecificationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetHostReservationPurchasePreviewResultOutputTypeDef = TypedDict(
    "GetHostReservationPurchasePreviewResultOutputTypeDef",
    {
        "CurrencyCode": Literal["USD"],
        "Purchase": List[PurchaseOutputTypeDef],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PurchaseHostReservationResultOutputTypeDef = TypedDict(
    "PurchaseHostReservationResultOutputTypeDef",
    {
        "ClientToken": str,
        "CurrencyCode": Literal["USD"],
        "Purchase": List[PurchaseOutputTypeDef],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetInstanceTypesFromInstanceRequirementsResultOutputTypeDef = TypedDict(
    "GetInstanceTypesFromInstanceRequirementsResultOutputTypeDef",
    {
        "InstanceTypes": List[InstanceTypeInfoFromInstanceRequirementsOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetIpamAddressHistoryResultOutputTypeDef = TypedDict(
    "GetIpamAddressHistoryResultOutputTypeDef",
    {
        "HistoryRecords": List[IpamAddressHistoryRecordOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetManagedPrefixListAssociationsResultOutputTypeDef = TypedDict(
    "GetManagedPrefixListAssociationsResultOutputTypeDef",
    {
        "PrefixListAssociations": List[PrefixListAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetManagedPrefixListEntriesResultOutputTypeDef = TypedDict(
    "GetManagedPrefixListEntriesResultOutputTypeDef",
    {
        "Entries": List[PrefixListEntryOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservedInstanceReservationValueOutputTypeDef = TypedDict(
    "ReservedInstanceReservationValueOutputTypeDef",
    {
        "ReservationValue": ReservationValueOutputTypeDef,
        "ReservedInstanceId": str,
    },
)

GetSpotPlacementScoresResultOutputTypeDef = TypedDict(
    "GetSpotPlacementScoresResultOutputTypeDef",
    {
        "SpotPlacementScores": List[SpotPlacementScoreOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayAttachmentPropagationsResultOutputTypeDef = TypedDict(
    "GetTransitGatewayAttachmentPropagationsResultOutputTypeDef",
    {
        "TransitGatewayAttachmentPropagations": List[
            TransitGatewayAttachmentPropagationOutputTypeDef
        ],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayRouteTableAssociationsResultOutputTypeDef = TypedDict(
    "GetTransitGatewayRouteTableAssociationsResultOutputTypeDef",
    {
        "Associations": List[TransitGatewayRouteTableAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayRouteTablePropagationsResultOutputTypeDef = TypedDict(
    "GetTransitGatewayRouteTablePropagationsResultOutputTypeDef",
    {
        "TransitGatewayRouteTablePropagations": List[
            TransitGatewayRouteTablePropagationOutputTypeDef
        ],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetVpnConnectionDeviceTypesResultOutputTypeDef = TypedDict(
    "GetVpnConnectionDeviceTypesResultOutputTypeDef",
    {
        "VpnConnectionDeviceTypes": List[VpnConnectionDeviceTypeOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetVpnTunnelReplacementStatusResultOutputTypeDef = TypedDict(
    "GetVpnTunnelReplacementStatusResultOutputTypeDef",
    {
        "VpnConnectionId": str,
        "TransitGatewayId": str,
        "CustomerGatewayId": str,
        "VpnGatewayId": str,
        "VpnTunnelOutsideIpAddress": str,
        "MaintenanceDetails": MaintenanceDetailsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GpuDeviceInfoOutputTypeDef = TypedDict(
    "GpuDeviceInfoOutputTypeDef",
    {
        "Name": str,
        "Manufacturer": str,
        "Count": int,
        "MemoryInfo": GpuDeviceMemoryInfoOutputTypeDef,
    },
)

IamInstanceProfileAssociationOutputTypeDef = TypedDict(
    "IamInstanceProfileAssociationOutputTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": IamInstanceProfileOutputTypeDef,
        "State": IamInstanceProfileAssociationStateType,
        "Timestamp": datetime,
    },
)

NetworkAclEntryOutputTypeDef = TypedDict(
    "NetworkAclEntryOutputTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": IcmpTypeCodeOutputTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": PortRangeOutputTypeDef,
        "Protocol": str,
        "RuleAction": RuleActionType,
        "RuleNumber": int,
    },
)

ImageDiskContainerTypeDef = TypedDict(
    "ImageDiskContainerTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "Format": str,
        "SnapshotId": str,
        "Url": str,
        "UserBucket": UserBucketTypeDef,
    },
    total=False,
)

SnapshotDiskContainerTypeDef = TypedDict(
    "SnapshotDiskContainerTypeDef",
    {
        "Description": str,
        "Format": str,
        "Url": str,
        "UserBucket": UserBucketTypeDef,
    },
    total=False,
)

LocalGatewayRouteTableOutputTypeDef = TypedDict(
    "LocalGatewayRouteTableOutputTypeDef",
    {
        "LocalGatewayRouteTableId": str,
        "LocalGatewayRouteTableArn": str,
        "LocalGatewayId": str,
        "OutpostArn": str,
        "OwnerId": str,
        "State": str,
        "Tags": List[TagOutputTypeDef],
        "Mode": LocalGatewayRouteTableModeType,
        "StateReason": StateReasonOutputTypeDef,
    },
)

ListImagesInRecycleBinResultOutputTypeDef = TypedDict(
    "ListImagesInRecycleBinResultOutputTypeDef",
    {
        "Images": List[ImageRecycleBinInfoOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportInstanceLaunchSpecificationTypeDef = TypedDict(
    "ImportInstanceLaunchSpecificationTypeDef",
    {
        "AdditionalInfo": str,
        "Architecture": ArchitectureValuesType,
        "GroupIds": Sequence[str],
        "GroupNames": Sequence[str],
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "InstanceType": InstanceTypeType,
        "Monitoring": bool,
        "Placement": PlacementTypeDef,
        "PrivateIpAddress": str,
        "SubnetId": str,
        "UserData": UserDataTypeDef,
    },
    total=False,
)

InferenceAcceleratorInfoOutputTypeDef = TypedDict(
    "InferenceAcceleratorInfoOutputTypeDef",
    {
        "Accelerators": List[InferenceDeviceInfoOutputTypeDef],
    },
)

_RequiredModifyInstanceCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceCreditSpecificationRequestRequestTypeDef",
    {
        "InstanceCreditSpecifications": Sequence[InstanceCreditSpecificationRequestTypeDef],
    },
)
_OptionalModifyInstanceCreditSpecificationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceCreditSpecificationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class ModifyInstanceCreditSpecificationRequestRequestTypeDef(
    _RequiredModifyInstanceCreditSpecificationRequestRequestTypeDef,
    _OptionalModifyInstanceCreditSpecificationRequestRequestTypeDef,
):
    pass


LaunchTemplateInstanceNetworkInterfaceSpecificationRequestTypeDef = TypedDict(
    "LaunchTemplateInstanceNetworkInterfaceSpecificationRequestTypeDef",
    {
        "AssociateCarrierIpAddress": bool,
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": Sequence[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressRequestTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": Sequence[PrivateIpAddressSpecificationTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "NetworkCardIndex": int,
        "Ipv4Prefixes": Sequence[Ipv4PrefixSpecificationRequestTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": Sequence[Ipv6PrefixSpecificationRequestTypeDef],
        "Ipv6PrefixCount": int,
    },
    total=False,
)

InstanceMarketOptionsRequestTypeDef = TypedDict(
    "InstanceMarketOptionsRequestTypeDef",
    {
        "MarketType": Literal["spot"],
        "SpotOptions": SpotMarketOptionsTypeDef,
    },
    total=False,
)

ModifyInstanceMetadataOptionsResultOutputTypeDef = TypedDict(
    "ModifyInstanceMetadataOptionsResultOutputTypeDef",
    {
        "InstanceId": str,
        "InstanceMetadataOptions": InstanceMetadataOptionsResponseOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceMonitoringOutputTypeDef = TypedDict(
    "InstanceMonitoringOutputTypeDef",
    {
        "InstanceId": str,
        "Monitoring": MonitoringOutputTypeDef,
    },
)

InstancePrivateIpAddressOutputTypeDef = TypedDict(
    "InstancePrivateIpAddressOutputTypeDef",
    {
        "Association": InstanceNetworkInterfaceAssociationOutputTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
)

InstanceNetworkInterfaceSpecificationOutputTypeDef = TypedDict(
    "InstanceNetworkInterfaceSpecificationOutputTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[InstanceIpv6AddressOutputTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[PrivateIpAddressSpecificationOutputTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "AssociateCarrierIpAddress": bool,
        "InterfaceType": str,
        "NetworkCardIndex": int,
        "Ipv4Prefixes": List[Ipv4PrefixSpecificationRequestOutputTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": List[Ipv6PrefixSpecificationRequestOutputTypeDef],
        "Ipv6PrefixCount": int,
    },
)

InstanceStateChangeOutputTypeDef = TypedDict(
    "InstanceStateChangeOutputTypeDef",
    {
        "CurrentState": InstanceStateOutputTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceStateOutputTypeDef,
    },
)

InstanceRequirementsOutputTypeDef = TypedDict(
    "InstanceRequirementsOutputTypeDef",
    {
        "VCpuCount": VCpuCountRangeOutputTypeDef,
        "MemoryMiB": MemoryMiBOutputTypeDef,
        "CpuManufacturers": List[CpuManufacturerType],
        "MemoryGiBPerVCpu": MemoryGiBPerVCpuOutputTypeDef,
        "ExcludedInstanceTypes": List[str],
        "InstanceGenerations": List[InstanceGenerationType],
        "SpotMaxPricePercentageOverLowestPrice": int,
        "OnDemandMaxPricePercentageOverLowestPrice": int,
        "BareMetal": BareMetalType,
        "BurstablePerformance": BurstablePerformanceType,
        "RequireHibernateSupport": bool,
        "NetworkInterfaceCount": NetworkInterfaceCountOutputTypeDef,
        "LocalStorage": LocalStorageType,
        "LocalStorageTypes": List[LocalStorageTypeType],
        "TotalLocalStorageGB": TotalLocalStorageGBOutputTypeDef,
        "BaselineEbsBandwidthMbps": BaselineEbsBandwidthMbpsOutputTypeDef,
        "AcceleratorTypes": List[AcceleratorTypeType],
        "AcceleratorCount": AcceleratorCountOutputTypeDef,
        "AcceleratorManufacturers": List[AcceleratorManufacturerType],
        "AcceleratorNames": List[AcceleratorNameType],
        "AcceleratorTotalMemoryMiB": AcceleratorTotalMemoryMiBOutputTypeDef,
        "NetworkBandwidthGbps": NetworkBandwidthGbpsOutputTypeDef,
        "AllowedInstanceTypes": List[str],
    },
)

_RequiredInstanceRequirementsRequestTypeDef = TypedDict(
    "_RequiredInstanceRequirementsRequestTypeDef",
    {
        "VCpuCount": VCpuCountRangeRequestTypeDef,
        "MemoryMiB": MemoryMiBRequestTypeDef,
    },
)
_OptionalInstanceRequirementsRequestTypeDef = TypedDict(
    "_OptionalInstanceRequirementsRequestTypeDef",
    {
        "CpuManufacturers": Sequence[CpuManufacturerType],
        "MemoryGiBPerVCpu": MemoryGiBPerVCpuRequestTypeDef,
        "ExcludedInstanceTypes": Sequence[str],
        "InstanceGenerations": Sequence[InstanceGenerationType],
        "SpotMaxPricePercentageOverLowestPrice": int,
        "OnDemandMaxPricePercentageOverLowestPrice": int,
        "BareMetal": BareMetalType,
        "BurstablePerformance": BurstablePerformanceType,
        "RequireHibernateSupport": bool,
        "NetworkInterfaceCount": NetworkInterfaceCountRequestTypeDef,
        "LocalStorage": LocalStorageType,
        "LocalStorageTypes": Sequence[LocalStorageTypeType],
        "TotalLocalStorageGB": TotalLocalStorageGBRequestTypeDef,
        "BaselineEbsBandwidthMbps": BaselineEbsBandwidthMbpsRequestTypeDef,
        "AcceleratorTypes": Sequence[AcceleratorTypeType],
        "AcceleratorCount": AcceleratorCountRequestTypeDef,
        "AcceleratorManufacturers": Sequence[AcceleratorManufacturerType],
        "AcceleratorNames": Sequence[AcceleratorNameType],
        "AcceleratorTotalMemoryMiB": AcceleratorTotalMemoryMiBRequestTypeDef,
        "NetworkBandwidthGbps": NetworkBandwidthGbpsRequestTypeDef,
        "AllowedInstanceTypes": Sequence[str],
    },
    total=False,
)


class InstanceRequirementsRequestTypeDef(
    _RequiredInstanceRequirementsRequestTypeDef, _OptionalInstanceRequirementsRequestTypeDef
):
    pass


InstanceRequirementsTypeDef = TypedDict(
    "InstanceRequirementsTypeDef",
    {
        "VCpuCount": VCpuCountRangeTypeDef,
        "MemoryMiB": MemoryMiBTypeDef,
        "CpuManufacturers": Sequence[CpuManufacturerType],
        "MemoryGiBPerVCpu": MemoryGiBPerVCpuTypeDef,
        "ExcludedInstanceTypes": Sequence[str],
        "InstanceGenerations": Sequence[InstanceGenerationType],
        "SpotMaxPricePercentageOverLowestPrice": int,
        "OnDemandMaxPricePercentageOverLowestPrice": int,
        "BareMetal": BareMetalType,
        "BurstablePerformance": BurstablePerformanceType,
        "RequireHibernateSupport": bool,
        "NetworkInterfaceCount": NetworkInterfaceCountTypeDef,
        "LocalStorage": LocalStorageType,
        "LocalStorageTypes": Sequence[LocalStorageTypeType],
        "TotalLocalStorageGB": TotalLocalStorageGBTypeDef,
        "BaselineEbsBandwidthMbps": BaselineEbsBandwidthMbpsTypeDef,
        "AcceleratorTypes": Sequence[AcceleratorTypeType],
        "AcceleratorCount": AcceleratorCountTypeDef,
        "AcceleratorManufacturers": Sequence[AcceleratorManufacturerType],
        "AcceleratorNames": Sequence[AcceleratorNameType],
        "AcceleratorTotalMemoryMiB": AcceleratorTotalMemoryMiBTypeDef,
        "NetworkBandwidthGbps": NetworkBandwidthGbpsTypeDef,
        "AllowedInstanceTypes": Sequence[str],
    },
    total=False,
)

InstanceStatusSummaryOutputTypeDef = TypedDict(
    "InstanceStatusSummaryOutputTypeDef",
    {
        "Details": List[InstanceStatusDetailsOutputTypeDef],
        "Status": SummaryStatusType,
    },
)

ModifyInstanceEventStartTimeResultOutputTypeDef = TypedDict(
    "ModifyInstanceEventStartTimeResultOutputTypeDef",
    {
        "Event": InstanceStatusEventOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

IpPermissionOutputTypeDef = TypedDict(
    "IpPermissionOutputTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[IpRangeOutputTypeDef],
        "Ipv6Ranges": List[Ipv6RangeOutputTypeDef],
        "PrefixListIds": List[PrefixListIdOutputTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[UserIdGroupPairOutputTypeDef],
    },
)

StaleIpPermissionOutputTypeDef = TypedDict(
    "StaleIpPermissionOutputTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[UserIdGroupPairOutputTypeDef],
    },
)

IpPermissionTypeDef = TypedDict(
    "IpPermissionTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": Sequence[IpRangeTypeDef],
        "Ipv6Ranges": Sequence[Ipv6RangeTypeDef],
        "PrefixListIds": Sequence[PrefixListIdTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": Sequence[UserIdGroupPairTypeDef],
    },
    total=False,
)

_RequiredProvisionIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_RequiredProvisionIpamPoolCidrRequestRequestTypeDef",
    {
        "IpamPoolId": str,
    },
)
_OptionalProvisionIpamPoolCidrRequestRequestTypeDef = TypedDict(
    "_OptionalProvisionIpamPoolCidrRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Cidr": str,
        "CidrAuthorizationContext": IpamCidrAuthorizationContextTypeDef,
        "NetmaskLength": int,
        "ClientToken": str,
    },
    total=False,
)


class ProvisionIpamPoolCidrRequestRequestTypeDef(
    _RequiredProvisionIpamPoolCidrRequestRequestTypeDef,
    _OptionalProvisionIpamPoolCidrRequestRequestTypeDef,
):
    pass


IpamDiscoveredAccountOutputTypeDef = TypedDict(
    "IpamDiscoveredAccountOutputTypeDef",
    {
        "AccountId": str,
        "DiscoveryRegion": str,
        "FailureReason": IpamDiscoveryFailureReasonOutputTypeDef,
        "LastAttemptedDiscoveryTime": datetime,
        "LastSuccessfulDiscoveryTime": datetime,
    },
)

IpamDiscoveredResourceCidrOutputTypeDef = TypedDict(
    "IpamDiscoveredResourceCidrOutputTypeDef",
    {
        "IpamResourceDiscoveryId": str,
        "ResourceRegion": str,
        "ResourceId": str,
        "ResourceOwnerId": str,
        "ResourceCidr": str,
        "ResourceType": IpamResourceTypeType,
        "ResourceTags": List[IpamResourceTagOutputTypeDef],
        "IpUsage": float,
        "VpcId": str,
        "SampleTime": datetime,
    },
)

IpamPoolOutputTypeDef = TypedDict(
    "IpamPoolOutputTypeDef",
    {
        "OwnerId": str,
        "IpamPoolId": str,
        "SourceIpamPoolId": str,
        "IpamPoolArn": str,
        "IpamScopeArn": str,
        "IpamScopeType": IpamScopeTypeType,
        "IpamArn": str,
        "IpamRegion": str,
        "Locale": str,
        "PoolDepth": int,
        "State": IpamPoolStateType,
        "StateMessage": str,
        "Description": str,
        "AutoImport": bool,
        "PubliclyAdvertisable": bool,
        "AddressFamily": AddressFamilyType,
        "AllocationMinNetmaskLength": int,
        "AllocationMaxNetmaskLength": int,
        "AllocationDefaultNetmaskLength": int,
        "AllocationResourceTags": List[IpamResourceTagOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "AwsService": Literal["ec2"],
        "PublicIpSource": IpamPoolPublicIpSourceType,
    },
)

IpamResourceCidrOutputTypeDef = TypedDict(
    "IpamResourceCidrOutputTypeDef",
    {
        "IpamId": str,
        "IpamScopeId": str,
        "IpamPoolId": str,
        "ResourceRegion": str,
        "ResourceOwnerId": str,
        "ResourceId": str,
        "ResourceName": str,
        "ResourceCidr": str,
        "ResourceType": IpamResourceTypeType,
        "ResourceTags": List[IpamResourceTagOutputTypeDef],
        "IpUsage": float,
        "ComplianceStatus": IpamComplianceStatusType,
        "ManagementState": IpamManagementStateType,
        "OverlapStatus": IpamOverlapStatusType,
        "VpcId": str,
    },
)

IpamOutputTypeDef = TypedDict(
    "IpamOutputTypeDef",
    {
        "OwnerId": str,
        "IpamId": str,
        "IpamArn": str,
        "IpamRegion": str,
        "PublicDefaultScopeId": str,
        "PrivateDefaultScopeId": str,
        "ScopeCount": int,
        "Description": str,
        "OperatingRegions": List[IpamOperatingRegionOutputTypeDef],
        "State": IpamStateType,
        "Tags": List[TagOutputTypeDef],
        "DefaultResourceDiscoveryId": str,
        "DefaultResourceDiscoveryAssociationId": str,
        "ResourceDiscoveryAssociationCount": int,
    },
)

IpamResourceDiscoveryOutputTypeDef = TypedDict(
    "IpamResourceDiscoveryOutputTypeDef",
    {
        "OwnerId": str,
        "IpamResourceDiscoveryId": str,
        "IpamResourceDiscoveryArn": str,
        "IpamResourceDiscoveryRegion": str,
        "Description": str,
        "OperatingRegions": List[IpamOperatingRegionOutputTypeDef],
        "IsDefault": bool,
        "State": IpamResourceDiscoveryStateType,
        "Tags": List[TagOutputTypeDef],
    },
)

IpamPoolCidrOutputTypeDef = TypedDict(
    "IpamPoolCidrOutputTypeDef",
    {
        "Cidr": str,
        "State": IpamPoolCidrStateType,
        "FailureReason": IpamPoolCidrFailureReasonOutputTypeDef,
        "IpamPoolCidrId": str,
        "NetmaskLength": int,
    },
)

Ipv6PoolOutputTypeDef = TypedDict(
    "Ipv6PoolOutputTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolCidrBlocks": List[PoolCidrBlockOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
    },
)

LaunchTemplateInstanceNetworkInterfaceSpecificationOutputTypeDef = TypedDict(
    "LaunchTemplateInstanceNetworkInterfaceSpecificationOutputTypeDef",
    {
        "AssociateCarrierIpAddress": bool,
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[InstanceIpv6AddressOutputTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[PrivateIpAddressSpecificationOutputTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "NetworkCardIndex": int,
        "Ipv4Prefixes": List[Ipv4PrefixSpecificationResponseOutputTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": List[Ipv6PrefixSpecificationResponseOutputTypeDef],
        "Ipv6PrefixCount": int,
    },
)

LaunchPermissionModificationsTypeDef = TypedDict(
    "LaunchPermissionModificationsTypeDef",
    {
        "Add": Sequence[LaunchPermissionTypeDef],
        "Remove": Sequence[LaunchPermissionTypeDef],
    },
    total=False,
)

LaunchTemplateBlockDeviceMappingOutputTypeDef = TypedDict(
    "LaunchTemplateBlockDeviceMappingOutputTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": LaunchTemplateEbsBlockDeviceOutputTypeDef,
        "NoDevice": str,
    },
)

LaunchTemplateBlockDeviceMappingRequestTypeDef = TypedDict(
    "LaunchTemplateBlockDeviceMappingRequestTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": LaunchTemplateEbsBlockDeviceRequestTypeDef,
        "NoDevice": str,
    },
    total=False,
)

LaunchTemplateInstanceMarketOptionsOutputTypeDef = TypedDict(
    "LaunchTemplateInstanceMarketOptionsOutputTypeDef",
    {
        "MarketType": Literal["spot"],
        "SpotOptions": LaunchTemplateSpotMarketOptionsOutputTypeDef,
    },
)

LaunchTemplateInstanceMarketOptionsRequestTypeDef = TypedDict(
    "LaunchTemplateInstanceMarketOptionsRequestTypeDef",
    {
        "MarketType": Literal["spot"],
        "SpotOptions": LaunchTemplateSpotMarketOptionsRequestTypeDef,
    },
    total=False,
)

ListSnapshotsInRecycleBinResultOutputTypeDef = TypedDict(
    "ListSnapshotsInRecycleBinResultOutputTypeDef",
    {
        "Snapshots": List[SnapshotRecycleBinInfoOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

LoadPermissionModificationsTypeDef = TypedDict(
    "LoadPermissionModificationsTypeDef",
    {
        "Add": Sequence[LoadPermissionRequestTypeDef],
        "Remove": Sequence[LoadPermissionRequestTypeDef],
    },
    total=False,
)

_RequiredModifyIpamRequestRequestTypeDef = TypedDict(
    "_RequiredModifyIpamRequestRequestTypeDef",
    {
        "IpamId": str,
    },
)
_OptionalModifyIpamRequestRequestTypeDef = TypedDict(
    "_OptionalModifyIpamRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "AddOperatingRegions": Sequence[AddIpamOperatingRegionTypeDef],
        "RemoveOperatingRegions": Sequence[RemoveIpamOperatingRegionTypeDef],
    },
    total=False,
)


class ModifyIpamRequestRequestTypeDef(
    _RequiredModifyIpamRequestRequestTypeDef, _OptionalModifyIpamRequestRequestTypeDef
):
    pass


_RequiredModifyIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_RequiredModifyIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "IpamResourceDiscoveryId": str,
    },
)
_OptionalModifyIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_OptionalModifyIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "AddOperatingRegions": Sequence[AddIpamOperatingRegionTypeDef],
        "RemoveOperatingRegions": Sequence[RemoveIpamOperatingRegionTypeDef],
    },
    total=False,
)


class ModifyIpamResourceDiscoveryRequestRequestTypeDef(
    _RequiredModifyIpamResourceDiscoveryRequestRequestTypeDef,
    _OptionalModifyIpamResourceDiscoveryRequestRequestTypeDef,
):
    pass


_RequiredModifyManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_RequiredModifyManagedPrefixListRequestRequestTypeDef",
    {
        "PrefixListId": str,
    },
)
_OptionalModifyManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_OptionalModifyManagedPrefixListRequestRequestTypeDef",
    {
        "DryRun": bool,
        "CurrentVersion": int,
        "PrefixListName": str,
        "AddEntries": Sequence[AddPrefixListEntryTypeDef],
        "RemoveEntries": Sequence[RemovePrefixListEntryTypeDef],
        "MaxEntries": int,
    },
    total=False,
)


class ModifyManagedPrefixListRequestRequestTypeDef(
    _RequiredModifyManagedPrefixListRequestRequestTypeDef,
    _OptionalModifyManagedPrefixListRequestRequestTypeDef,
):
    pass


_RequiredModifyReservedInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredModifyReservedInstancesRequestRequestTypeDef",
    {
        "ReservedInstancesIds": Sequence[str],
        "TargetConfigurations": Sequence[ReservedInstancesConfigurationTypeDef],
    },
)
_OptionalModifyReservedInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalModifyReservedInstancesRequestRequestTypeDef",
    {
        "ClientToken": str,
    },
    total=False,
)


class ModifyReservedInstancesRequestRequestTypeDef(
    _RequiredModifyReservedInstancesRequestRequestTypeDef,
    _OptionalModifyReservedInstancesRequestRequestTypeDef,
):
    pass


_RequiredModifyTransitGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTransitGatewayRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
    },
)
_OptionalModifyTransitGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTransitGatewayRequestRequestTypeDef",
    {
        "Description": str,
        "Options": ModifyTransitGatewayOptionsTypeDef,
        "DryRun": bool,
    },
    total=False,
)


class ModifyTransitGatewayRequestRequestTypeDef(
    _RequiredModifyTransitGatewayRequestRequestTypeDef,
    _OptionalModifyTransitGatewayRequestRequestTypeDef,
):
    pass


_RequiredModifyTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredModifyTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
    },
)
_OptionalModifyTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalModifyTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "AddSubnetIds": Sequence[str],
        "RemoveSubnetIds": Sequence[str],
        "Options": ModifyTransitGatewayVpcAttachmentRequestOptionsTypeDef,
        "DryRun": bool,
    },
    total=False,
)


class ModifyTransitGatewayVpcAttachmentRequestRequestTypeDef(
    _RequiredModifyTransitGatewayVpcAttachmentRequestRequestTypeDef,
    _OptionalModifyTransitGatewayVpcAttachmentRequestRequestTypeDef,
):
    pass


_RequiredModifyVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "VerifiedAccessEndpointId": str,
    },
)
_OptionalModifyVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
        "LoadBalancerOptions": ModifyVerifiedAccessEndpointLoadBalancerOptionsTypeDef,
        "NetworkInterfaceOptions": ModifyVerifiedAccessEndpointEniOptionsTypeDef,
        "Description": str,
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class ModifyVerifiedAccessEndpointRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessEndpointRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessEndpointRequestRequestTypeDef,
):
    pass


_RequiredModifyVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "VerifiedAccessTrustProviderId": str,
    },
)
_OptionalModifyVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "OidcOptions": ModifyVerifiedAccessTrustProviderOidcOptionsTypeDef,
        "Description": str,
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class ModifyVerifiedAccessTrustProviderRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessTrustProviderRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessTrustProviderRequestRequestTypeDef,
):
    pass


_RequiredModifyVpcPeeringConnectionOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpcPeeringConnectionOptionsRequestRequestTypeDef",
    {
        "VpcPeeringConnectionId": str,
    },
)
_OptionalModifyVpcPeeringConnectionOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpcPeeringConnectionOptionsRequestRequestTypeDef",
    {
        "AccepterPeeringConnectionOptions": PeeringConnectionOptionsRequestTypeDef,
        "DryRun": bool,
        "RequesterPeeringConnectionOptions": PeeringConnectionOptionsRequestTypeDef,
    },
    total=False,
)


class ModifyVpcPeeringConnectionOptionsRequestRequestTypeDef(
    _RequiredModifyVpcPeeringConnectionOptionsRequestRequestTypeDef,
    _OptionalModifyVpcPeeringConnectionOptionsRequestRequestTypeDef,
):
    pass


ModifyVpcPeeringConnectionOptionsResultOutputTypeDef = TypedDict(
    "ModifyVpcPeeringConnectionOptionsResultOutputTypeDef",
    {
        "AccepterPeeringConnectionOptions": PeeringConnectionOptionsOutputTypeDef,
        "RequesterPeeringConnectionOptions": PeeringConnectionOptionsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NatGatewayOutputTypeDef = TypedDict(
    "NatGatewayOutputTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[NatGatewayAddressOutputTypeDef],
        "NatGatewayId": str,
        "ProvisionedBandwidth": ProvisionedBandwidthOutputTypeDef,
        "State": NatGatewayStateType,
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[TagOutputTypeDef],
        "ConnectivityType": ConnectivityTypeType,
    },
)

NetworkInfoOutputTypeDef = TypedDict(
    "NetworkInfoOutputTypeDef",
    {
        "NetworkPerformance": str,
        "MaximumNetworkInterfaces": int,
        "MaximumNetworkCards": int,
        "DefaultNetworkCardIndex": int,
        "NetworkCards": List[NetworkCardInfoOutputTypeDef],
        "Ipv4AddressesPerInterface": int,
        "Ipv6AddressesPerInterface": int,
        "Ipv6Supported": bool,
        "EnaSupport": EnaSupportType,
        "EfaSupported": bool,
        "EfaInfo": EfaInfoOutputTypeDef,
        "EncryptionInTransitSupported": bool,
        "EnaSrdSupported": bool,
    },
)

NetworkInterfacePrivateIpAddressOutputTypeDef = TypedDict(
    "NetworkInterfacePrivateIpAddressOutputTypeDef",
    {
        "Association": NetworkInterfaceAssociationOutputTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
)

NetworkInterfacePermissionOutputTypeDef = TypedDict(
    "NetworkInterfacePermissionOutputTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": InterfacePermissionTypeType,
        "PermissionState": NetworkInterfacePermissionStateOutputTypeDef,
    },
)

VerifiedAccessTrustProviderOutputTypeDef = TypedDict(
    "VerifiedAccessTrustProviderOutputTypeDef",
    {
        "VerifiedAccessTrustProviderId": str,
        "Description": str,
        "TrustProviderType": TrustProviderTypeType,
        "UserTrustProviderType": UserTrustProviderTypeType,
        "DeviceTrustProviderType": DeviceTrustProviderTypeType,
        "OidcOptions": OidcOptionsOutputTypeDef,
        "DeviceOptions": DeviceOptionsOutputTypeDef,
        "PolicyReferenceName": str,
        "CreationTime": str,
        "LastUpdatedTime": str,
        "Tags": List[TagOutputTypeDef],
    },
)

PathRequestFilterTypeDef = TypedDict(
    "PathRequestFilterTypeDef",
    {
        "SourceAddress": str,
        "SourcePortRange": RequestFilterPortRangeTypeDef,
        "DestinationAddress": str,
        "DestinationPortRange": RequestFilterPortRangeTypeDef,
    },
    total=False,
)

PathStatementOutputTypeDef = TypedDict(
    "PathStatementOutputTypeDef",
    {
        "PacketHeaderStatement": PacketHeaderStatementOutputTypeDef,
        "ResourceStatement": ResourceStatementOutputTypeDef,
    },
)

ThroughResourcesStatementOutputTypeDef = TypedDict(
    "ThroughResourcesStatementOutputTypeDef",
    {
        "ResourceStatement": ResourceStatementOutputTypeDef,
    },
)

PathStatementRequestTypeDef = TypedDict(
    "PathStatementRequestTypeDef",
    {
        "PacketHeaderStatement": PacketHeaderStatementRequestTypeDef,
        "ResourceStatement": ResourceStatementRequestTypeDef,
    },
    total=False,
)

ThroughResourcesStatementRequestTypeDef = TypedDict(
    "ThroughResourcesStatementRequestTypeDef",
    {
        "ResourceStatement": ResourceStatementRequestTypeDef,
    },
    total=False,
)

ReservedInstancesListingOutputTypeDef = TypedDict(
    "ReservedInstancesListingOutputTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[InstanceCountOutputTypeDef],
        "PriceSchedules": List[PriceScheduleOutputTypeDef],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": ListingStatusType,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
        "UpdateDate": datetime,
    },
)

ProvisionPublicIpv4PoolCidrResultOutputTypeDef = TypedDict(
    "ProvisionPublicIpv4PoolCidrResultOutputTypeDef",
    {
        "PoolId": str,
        "PoolAddressRange": PublicIpv4PoolRangeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PublicIpv4PoolOutputTypeDef = TypedDict(
    "PublicIpv4PoolOutputTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolAddressRanges": List[PublicIpv4PoolRangeOutputTypeDef],
        "TotalAddressCount": int,
        "TotalAvailableAddressCount": int,
        "NetworkBorderGroup": str,
        "Tags": List[TagOutputTypeDef],
    },
)

_RequiredPurchaseScheduledInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredPurchaseScheduledInstancesRequestRequestTypeDef",
    {
        "PurchaseRequests": Sequence[PurchaseRequestTypeDef],
    },
)
_OptionalPurchaseScheduledInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalPurchaseScheduledInstancesRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class PurchaseScheduledInstancesRequestRequestTypeDef(
    _RequiredPurchaseScheduledInstancesRequestRequestTypeDef,
    _OptionalPurchaseScheduledInstancesRequestRequestTypeDef,
):
    pass


_RequiredPurchaseReservedInstancesOfferingRequestRequestTypeDef = TypedDict(
    "_RequiredPurchaseReservedInstancesOfferingRequestRequestTypeDef",
    {
        "InstanceCount": int,
        "ReservedInstancesOfferingId": str,
    },
)
_OptionalPurchaseReservedInstancesOfferingRequestRequestTypeDef = TypedDict(
    "_OptionalPurchaseReservedInstancesOfferingRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LimitPrice": ReservedInstanceLimitPriceTypeDef,
        "PurchaseTime": Union[datetime, str],
    },
    total=False,
)


class PurchaseReservedInstancesOfferingRequestRequestTypeDef(
    _RequiredPurchaseReservedInstancesOfferingRequestRequestTypeDef,
    _OptionalPurchaseReservedInstancesOfferingRequestRequestTypeDef,
):
    pass


ReservedInstancesOfferingOutputTypeDef = TypedDict(
    "ReservedInstancesOfferingOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "FixedPrice": float,
        "InstanceType": InstanceTypeType,
        "ProductDescription": RIProductDescriptionType,
        "ReservedInstancesOfferingId": str,
        "UsagePrice": float,
        "CurrencyCode": Literal["USD"],
        "InstanceTenancy": TenancyType,
        "Marketplace": bool,
        "OfferingClass": OfferingClassTypeType,
        "OfferingType": OfferingTypeValuesType,
        "PricingDetails": List[PricingDetailOutputTypeDef],
        "RecurringCharges": List[RecurringChargeOutputTypeDef],
        "Scope": scopeType,
    },
)

ReservedInstancesOutputTypeDef = TypedDict(
    "ReservedInstancesOutputTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "End": datetime,
        "FixedPrice": float,
        "InstanceCount": int,
        "InstanceType": InstanceTypeType,
        "ProductDescription": RIProductDescriptionType,
        "ReservedInstancesId": str,
        "Start": datetime,
        "State": ReservedInstanceStateType,
        "UsagePrice": float,
        "CurrencyCode": Literal["USD"],
        "InstanceTenancy": TenancyType,
        "OfferingClass": OfferingClassTypeType,
        "OfferingType": OfferingTypeValuesType,
        "RecurringCharges": List[RecurringChargeOutputTypeDef],
        "Scope": scopeType,
        "Tags": List[TagOutputTypeDef],
    },
)

SecurityGroupRuleOutputTypeDef = TypedDict(
    "SecurityGroupRuleOutputTypeDef",
    {
        "SecurityGroupRuleId": str,
        "GroupId": str,
        "GroupOwnerId": str,
        "IsEgress": bool,
        "IpProtocol": str,
        "FromPort": int,
        "ToPort": int,
        "CidrIpv4": str,
        "CidrIpv6": str,
        "PrefixListId": str,
        "ReferencedGroupInfo": ReferencedSecurityGroupOutputTypeDef,
        "Description": str,
        "Tags": List[TagOutputTypeDef],
    },
)

_RequiredRegisterInstanceEventNotificationAttributesRequestRequestTypeDef = TypedDict(
    "_RequiredRegisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    {
        "InstanceTagAttribute": RegisterInstanceTagAttributeRequestTypeDef,
    },
)
_OptionalRegisterInstanceEventNotificationAttributesRequestRequestTypeDef = TypedDict(
    "_OptionalRegisterInstanceEventNotificationAttributesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RegisterInstanceEventNotificationAttributesRequestRequestTypeDef(
    _RequiredRegisterInstanceEventNotificationAttributesRequestRequestTypeDef,
    _OptionalRegisterInstanceEventNotificationAttributesRequestRequestTypeDef,
):
    pass


RegisterTransitGatewayMulticastGroupMembersResultOutputTypeDef = TypedDict(
    "RegisterTransitGatewayMulticastGroupMembersResultOutputTypeDef",
    {
        "RegisteredMulticastGroupMembers": (
            TransitGatewayMulticastRegisteredGroupMembersOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RegisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef = TypedDict(
    "RegisterTransitGatewayMulticastGroupSourcesResultOutputTypeDef",
    {
        "RegisteredMulticastGroupSources": (
            TransitGatewayMulticastRegisteredGroupSourcesOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservedInstancesModificationResultOutputTypeDef = TypedDict(
    "ReservedInstancesModificationResultOutputTypeDef",
    {
        "ReservedInstancesId": str,
        "TargetConfiguration": ReservedInstancesConfigurationOutputTypeDef,
    },
)

StorageOutputTypeDef = TypedDict(
    "StorageOutputTypeDef",
    {
        "S3": S3StorageOutputTypeDef,
    },
)

StorageTypeDef = TypedDict(
    "StorageTypeDef",
    {
        "S3": S3StorageTypeDef,
    },
    total=False,
)

ScheduledInstanceAvailabilityOutputTypeDef = TypedDict(
    "ScheduledInstanceAvailabilityOutputTypeDef",
    {
        "AvailabilityZone": str,
        "AvailableInstanceCount": int,
        "FirstSlotStartTime": datetime,
        "HourlyPrice": str,
        "InstanceType": str,
        "MaxTermDurationInDays": int,
        "MinTermDurationInDays": int,
        "NetworkPlatform": str,
        "Platform": str,
        "PurchaseToken": str,
        "Recurrence": ScheduledInstanceRecurrenceOutputTypeDef,
        "SlotDurationInHours": int,
        "TotalScheduledInstanceHours": int,
    },
)

ScheduledInstanceOutputTypeDef = TypedDict(
    "ScheduledInstanceOutputTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": ScheduledInstanceRecurrenceOutputTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
)

ScheduledInstancesBlockDeviceMappingTypeDef = TypedDict(
    "ScheduledInstancesBlockDeviceMappingTypeDef",
    {
        "DeviceName": str,
        "Ebs": ScheduledInstancesEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)

ScheduledInstancesNetworkInterfaceTypeDef = TypedDict(
    "ScheduledInstancesNetworkInterfaceTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": Sequence[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[ScheduledInstancesIpv6AddressTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddressConfigs": Sequence[ScheduledInstancesPrivateIpAddressConfigTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)

SearchTransitGatewayMulticastGroupsResultOutputTypeDef = TypedDict(
    "SearchTransitGatewayMulticastGroupsResultOutputTypeDef",
    {
        "MulticastGroups": List[TransitGatewayMulticastGroupOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpcEndpointOutputTypeDef = TypedDict(
    "VpcEndpointOutputTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": VpcEndpointTypeType,
        "VpcId": str,
        "ServiceName": str,
        "State": StateType,
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[SecurityGroupIdentifierOutputTypeDef],
        "IpAddressType": IpAddressTypeType,
        "DnsOptions": DnsOptionsOutputTypeDef,
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[DnsEntryOutputTypeDef],
        "CreationTimestamp": datetime,
        "Tags": List[TagOutputTypeDef],
        "OwnerId": str,
        "LastError": LastErrorOutputTypeDef,
    },
)

_RequiredSecurityGroupRuleUpdateTypeDef = TypedDict(
    "_RequiredSecurityGroupRuleUpdateTypeDef",
    {
        "SecurityGroupRuleId": str,
    },
)
_OptionalSecurityGroupRuleUpdateTypeDef = TypedDict(
    "_OptionalSecurityGroupRuleUpdateTypeDef",
    {
        "SecurityGroupRule": SecurityGroupRuleRequestTypeDef,
    },
    total=False,
)


class SecurityGroupRuleUpdateTypeDef(
    _RequiredSecurityGroupRuleUpdateTypeDef, _OptionalSecurityGroupRuleUpdateTypeDef
):
    pass


ServiceConfigurationOutputTypeDef = TypedDict(
    "ServiceConfigurationOutputTypeDef",
    {
        "ServiceType": List[ServiceTypeDetailOutputTypeDef],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": ServiceStateType,
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "GatewayLoadBalancerArns": List[str],
        "SupportedIpAddressTypes": List[ServiceConnectivityTypeType],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "PrivateDnsNameConfiguration": PrivateDnsNameConfigurationOutputTypeDef,
        "PayerResponsibility": Literal["ServiceOwner"],
        "Tags": List[TagOutputTypeDef],
    },
)

ServiceDetailOutputTypeDef = TypedDict(
    "ServiceDetailOutputTypeDef",
    {
        "ServiceName": str,
        "ServiceId": str,
        "ServiceType": List[ServiceTypeDetailOutputTypeDef],
        "AvailabilityZones": List[str],
        "Owner": str,
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "PrivateDnsNames": List[PrivateDnsDetailsOutputTypeDef],
        "VpcEndpointPolicySupported": bool,
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "PayerResponsibility": Literal["ServiceOwner"],
        "Tags": List[TagOutputTypeDef],
        "PrivateDnsNameVerificationState": DnsNameStateType,
        "SupportedIpAddressTypes": List[ServiceConnectivityTypeType],
    },
)

SnapshotDetailOutputTypeDef = TypedDict(
    "SnapshotDetailOutputTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": UserBucketDetailsOutputTypeDef,
    },
)

SnapshotTaskDetailOutputTypeDef = TypedDict(
    "SnapshotTaskDetailOutputTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": UserBucketDetailsOutputTypeDef,
    },
)

SpotMaintenanceStrategiesOutputTypeDef = TypedDict(
    "SpotMaintenanceStrategiesOutputTypeDef",
    {
        "CapacityRebalance": SpotCapacityRebalanceOutputTypeDef,
    },
)

SpotMaintenanceStrategiesTypeDef = TypedDict(
    "SpotMaintenanceStrategiesTypeDef",
    {
        "CapacityRebalance": SpotCapacityRebalanceTypeDef,
    },
    total=False,
)

SpotDatafeedSubscriptionOutputTypeDef = TypedDict(
    "SpotDatafeedSubscriptionOutputTypeDef",
    {
        "Bucket": str,
        "Fault": SpotInstanceStateFaultOutputTypeDef,
        "OwnerId": str,
        "Prefix": str,
        "State": DatafeedSubscriptionStateType,
    },
)

TransitGatewayMulticastDomainAssociationOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDomainAssociationOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "ResourceOwnerId": str,
        "Subnet": SubnetAssociationOutputTypeDef,
    },
)

TransitGatewayMulticastDomainAssociationsOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDomainAssociationsOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "ResourceOwnerId": str,
        "Subnets": List[SubnetAssociationOutputTypeDef],
    },
)

SubnetIpv6CidrBlockAssociationOutputTypeDef = TypedDict(
    "SubnetIpv6CidrBlockAssociationOutputTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": SubnetCidrBlockStateOutputTypeDef,
    },
)

TargetReservationValueOutputTypeDef = TypedDict(
    "TargetReservationValueOutputTypeDef",
    {
        "ReservationValue": ReservationValueOutputTypeDef,
        "TargetConfiguration": TargetConfigurationOutputTypeDef,
    },
)

TargetGroupsConfigOutputTypeDef = TypedDict(
    "TargetGroupsConfigOutputTypeDef",
    {
        "TargetGroups": List[TargetGroupOutputTypeDef],
    },
)

TargetGroupsConfigTypeDef = TypedDict(
    "TargetGroupsConfigTypeDef",
    {
        "TargetGroups": Sequence[TargetGroupTypeDef],
    },
    total=False,
)

TrafficMirrorFilterRuleOutputTypeDef = TypedDict(
    "TrafficMirrorFilterRuleOutputTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": TrafficDirectionType,
        "RuleNumber": int,
        "RuleAction": TrafficMirrorRuleActionType,
        "Protocol": int,
        "DestinationPortRange": TrafficMirrorPortRangeOutputTypeDef,
        "SourcePortRange": TrafficMirrorPortRangeOutputTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
)

TransitGatewayAttachmentOutputTypeDef = TypedDict(
    "TransitGatewayAttachmentOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "TransitGatewayOwnerId": str,
        "ResourceOwnerId": str,
        "ResourceType": TransitGatewayAttachmentResourceTypeType,
        "ResourceId": str,
        "State": TransitGatewayAttachmentStateType,
        "Association": TransitGatewayAttachmentAssociationOutputTypeDef,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayConnectPeerConfigurationOutputTypeDef = TypedDict(
    "TransitGatewayConnectPeerConfigurationOutputTypeDef",
    {
        "TransitGatewayAddress": str,
        "PeerAddress": str,
        "InsideCidrBlocks": List[str],
        "Protocol": Literal["gre"],
        "BgpConfigurations": List[TransitGatewayAttachmentBgpConfigurationOutputTypeDef],
    },
)

TransitGatewayConnectOutputTypeDef = TypedDict(
    "TransitGatewayConnectOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransportTransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "State": TransitGatewayAttachmentStateType,
        "CreationTime": datetime,
        "Options": TransitGatewayConnectOptionsOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayMulticastDomainOutputTypeDef = TypedDict(
    "TransitGatewayMulticastDomainOutputTypeDef",
    {
        "TransitGatewayMulticastDomainId": str,
        "TransitGatewayId": str,
        "TransitGatewayMulticastDomainArn": str,
        "OwnerId": str,
        "Options": TransitGatewayMulticastDomainOptionsOutputTypeDef,
        "State": TransitGatewayMulticastDomainStateType,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayOutputTypeDef = TypedDict(
    "TransitGatewayOutputTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": TransitGatewayStateType,
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": TransitGatewayOptionsOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayPeeringAttachmentOutputTypeDef = TypedDict(
    "TransitGatewayPeeringAttachmentOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "AccepterTransitGatewayAttachmentId": str,
        "RequesterTgwInfo": PeeringTgwInfoOutputTypeDef,
        "AccepterTgwInfo": PeeringTgwInfoOutputTypeDef,
        "Options": TransitGatewayPeeringAttachmentOptionsOutputTypeDef,
        "Status": PeeringAttachmentStatusOutputTypeDef,
        "State": TransitGatewayAttachmentStateType,
        "CreationTime": datetime,
        "Tags": List[TagOutputTypeDef],
    },
)

TransitGatewayPolicyRuleOutputTypeDef = TypedDict(
    "TransitGatewayPolicyRuleOutputTypeDef",
    {
        "SourceCidrBlock": str,
        "SourcePortRange": str,
        "DestinationCidrBlock": str,
        "DestinationPortRange": str,
        "Protocol": str,
        "MetaData": TransitGatewayPolicyRuleMetaDataOutputTypeDef,
    },
)

TransitGatewayPrefixListReferenceOutputTypeDef = TypedDict(
    "TransitGatewayPrefixListReferenceOutputTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "PrefixListId": str,
        "PrefixListOwnerId": str,
        "State": TransitGatewayPrefixListReferenceStateType,
        "Blackhole": bool,
        "TransitGatewayAttachment": TransitGatewayPrefixListAttachmentOutputTypeDef,
    },
)

TransitGatewayRouteOutputTypeDef = TypedDict(
    "TransitGatewayRouteOutputTypeDef",
    {
        "DestinationCidrBlock": str,
        "PrefixListId": str,
        "TransitGatewayRouteTableAnnouncementId": str,
        "TransitGatewayAttachments": List[TransitGatewayRouteAttachmentOutputTypeDef],
        "Type": TransitGatewayRouteTypeType,
        "State": TransitGatewayRouteStateType,
    },
)

TransitGatewayVpcAttachmentOutputTypeDef = TypedDict(
    "TransitGatewayVpcAttachmentOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": TransitGatewayAttachmentStateType,
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": TransitGatewayVpcAttachmentOptionsOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

UnsuccessfulInstanceCreditSpecificationItemOutputTypeDef = TypedDict(
    "UnsuccessfulInstanceCreditSpecificationItemOutputTypeDef",
    {
        "InstanceId": str,
        "Error": UnsuccessfulInstanceCreditSpecificationItemErrorOutputTypeDef,
    },
)

UnsuccessfulItemOutputTypeDef = TypedDict(
    "UnsuccessfulItemOutputTypeDef",
    {
        "Error": UnsuccessfulItemErrorOutputTypeDef,
        "ResourceId": str,
    },
)

ValidationWarningOutputTypeDef = TypedDict(
    "ValidationWarningOutputTypeDef",
    {
        "Errors": List[ValidationErrorOutputTypeDef],
    },
)

VerifiedAccessEndpointOutputTypeDef = TypedDict(
    "VerifiedAccessEndpointOutputTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "VerifiedAccessGroupId": str,
        "VerifiedAccessEndpointId": str,
        "ApplicationDomain": str,
        "EndpointType": VerifiedAccessEndpointTypeType,
        "AttachmentType": Literal["vpc"],
        "DomainCertificateArn": str,
        "EndpointDomain": str,
        "DeviceValidationDomain": str,
        "SecurityGroupIds": List[str],
        "LoadBalancerOptions": VerifiedAccessEndpointLoadBalancerOptionsOutputTypeDef,
        "NetworkInterfaceOptions": VerifiedAccessEndpointEniOptionsOutputTypeDef,
        "Status": VerifiedAccessEndpointStatusOutputTypeDef,
        "Description": str,
        "CreationTime": str,
        "LastUpdatedTime": str,
        "DeletionTime": str,
        "Tags": List[TagOutputTypeDef],
    },
)

VerifiedAccessInstanceOutputTypeDef = TypedDict(
    "VerifiedAccessInstanceOutputTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "Description": str,
        "VerifiedAccessTrustProviders": List[VerifiedAccessTrustProviderCondensedOutputTypeDef],
        "CreationTime": str,
        "LastUpdatedTime": str,
        "Tags": List[TagOutputTypeDef],
    },
)

VerifiedAccessLogCloudWatchLogsDestinationOutputTypeDef = TypedDict(
    "VerifiedAccessLogCloudWatchLogsDestinationOutputTypeDef",
    {
        "Enabled": bool,
        "DeliveryStatus": VerifiedAccessLogDeliveryStatusOutputTypeDef,
        "LogGroup": str,
    },
)

VerifiedAccessLogKinesisDataFirehoseDestinationOutputTypeDef = TypedDict(
    "VerifiedAccessLogKinesisDataFirehoseDestinationOutputTypeDef",
    {
        "Enabled": bool,
        "DeliveryStatus": VerifiedAccessLogDeliveryStatusOutputTypeDef,
        "DeliveryStream": str,
    },
)

VerifiedAccessLogS3DestinationOutputTypeDef = TypedDict(
    "VerifiedAccessLogS3DestinationOutputTypeDef",
    {
        "Enabled": bool,
        "DeliveryStatus": VerifiedAccessLogDeliveryStatusOutputTypeDef,
        "BucketName": str,
        "Prefix": str,
        "BucketOwner": str,
    },
)

VerifiedAccessLogOptionsTypeDef = TypedDict(
    "VerifiedAccessLogOptionsTypeDef",
    {
        "S3": VerifiedAccessLogS3DestinationOptionsTypeDef,
        "CloudWatchLogs": VerifiedAccessLogCloudWatchLogsDestinationOptionsTypeDef,
        "KinesisDataFirehose": VerifiedAccessLogKinesisDataFirehoseDestinationOptionsTypeDef,
        "LogVersion": str,
        "IncludeTrustContext": bool,
    },
    total=False,
)

VolumeOutputTypeDef = TypedDict(
    "VolumeOutputTypeDef",
    {
        "Attachments": List[VolumeAttachmentOutputTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OutpostArn": str,
        "Size": int,
        "SnapshotId": str,
        "State": VolumeStateType,
        "VolumeId": str,
        "Iops": int,
        "Tags": List[TagOutputTypeDef],
        "VolumeType": VolumeTypeType,
        "FastRestored": bool,
        "MultiAttachEnabled": bool,
        "Throughput": int,
    },
)

VolumeResponseMetadataTypeDef = TypedDict(
    "VolumeResponseMetadataTypeDef",
    {
        "Attachments": List[VolumeAttachmentOutputTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OutpostArn": str,
        "Size": int,
        "SnapshotId": str,
        "State": VolumeStateType,
        "VolumeId": str,
        "Iops": int,
        "Tags": List[TagOutputTypeDef],
        "VolumeType": VolumeTypeType,
        "FastRestored": bool,
        "MultiAttachEnabled": bool,
        "Throughput": int,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VolumeStatusInfoOutputTypeDef = TypedDict(
    "VolumeStatusInfoOutputTypeDef",
    {
        "Details": List[VolumeStatusDetailsOutputTypeDef],
        "Status": VolumeStatusInfoStatusType,
    },
)

VpcCidrBlockAssociationOutputTypeDef = TypedDict(
    "VpcCidrBlockAssociationOutputTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": VpcCidrBlockStateOutputTypeDef,
    },
)

VpcIpv6CidrBlockAssociationOutputTypeDef = TypedDict(
    "VpcIpv6CidrBlockAssociationOutputTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": VpcCidrBlockStateOutputTypeDef,
        "NetworkBorderGroup": str,
        "Ipv6Pool": str,
    },
)

VpcPeeringConnectionVpcInfoOutputTypeDef = TypedDict(
    "VpcPeeringConnectionVpcInfoOutputTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[Ipv6CidrBlockOutputTypeDef],
        "CidrBlockSet": List[CidrBlockOutputTypeDef],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionOptionsDescriptionOutputTypeDef,
        "VpcId": str,
        "Region": str,
    },
)

VpcPeeringConnectionVpcInfoResponseMetadataTypeDef = TypedDict(
    "VpcPeeringConnectionVpcInfoResponseMetadataTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[Ipv6CidrBlockOutputTypeDef],
        "CidrBlockSet": List[CidrBlockOutputTypeDef],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionOptionsDescriptionOutputTypeDef,
        "VpcId": str,
        "Region": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeAccountAttributesResultOutputTypeDef = TypedDict(
    "DescribeAccountAttributesResultOutputTypeDef",
    {
        "AccountAttributes": List[AccountAttributeOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AdditionalDetailOutputTypeDef = TypedDict(
    "AdditionalDetailOutputTypeDef",
    {
        "AdditionalDetailType": str,
        "Component": AnalysisComponentOutputTypeDef,
        "VpcEndpointService": AnalysisComponentOutputTypeDef,
        "RuleOptions": List[RuleOptionOutputTypeDef],
        "RuleGroupTypePairs": List[RuleGroupTypePairOutputTypeDef],
        "RuleGroupRuleOptionsPairs": List[RuleGroupRuleOptionsPairOutputTypeDef],
        "ServiceName": str,
        "LoadBalancers": List[AnalysisComponentOutputTypeDef],
    },
)

DescribeAddressesAttributeResultOutputTypeDef = TypedDict(
    "DescribeAddressesAttributeResultOutputTypeDef",
    {
        "Addresses": List[AddressAttributeOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyAddressAttributeResultOutputTypeDef = TypedDict(
    "ModifyAddressAttributeResultOutputTypeDef",
    {
        "Address": AddressAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ResetAddressAttributeResultOutputTypeDef = TypedDict(
    "ResetAddressAttributeResultOutputTypeDef",
    {
        "Address": AddressAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeAddressesResultOutputTypeDef = TypedDict(
    "DescribeAddressesResultOutputTypeDef",
    {
        "Addresses": List[AddressOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcEndpointServicePermissionsResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointServicePermissionsResultOutputTypeDef",
    {
        "AllowedPrincipals": List[AllowedPrincipalOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateCarrierGatewayResultOutputTypeDef = TypedDict(
    "CreateCarrierGatewayResultOutputTypeDef",
    {
        "CarrierGateway": CarrierGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteCarrierGatewayResultOutputTypeDef = TypedDict(
    "DeleteCarrierGatewayResultOutputTypeDef",
    {
        "CarrierGateway": CarrierGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeCarrierGatewaysResultOutputTypeDef = TypedDict(
    "DescribeCarrierGatewaysResultOutputTypeDef",
    {
        "CarrierGateways": List[CarrierGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateCoipPoolResultOutputTypeDef = TypedDict(
    "CreateCoipPoolResultOutputTypeDef",
    {
        "CoipPool": CoipPoolOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteCoipPoolResultOutputTypeDef = TypedDict(
    "DeleteCoipPoolResultOutputTypeDef",
    {
        "CoipPool": CoipPoolOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeCoipPoolsResultOutputTypeDef = TypedDict(
    "DescribeCoipPoolsResultOutputTypeDef",
    {
        "CoipPools": List[CoipPoolOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateCustomerGatewayResultOutputTypeDef = TypedDict(
    "CreateCustomerGatewayResultOutputTypeDef",
    {
        "CustomerGateway": CustomerGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeCustomerGatewaysResultOutputTypeDef = TypedDict(
    "DescribeCustomerGatewaysResultOutputTypeDef",
    {
        "CustomerGateways": List[CustomerGatewayOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateInstanceConnectEndpointResultOutputTypeDef = TypedDict(
    "CreateInstanceConnectEndpointResultOutputTypeDef",
    {
        "InstanceConnectEndpoint": Ec2InstanceConnectEndpointOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteInstanceConnectEndpointResultOutputTypeDef = TypedDict(
    "DeleteInstanceConnectEndpointResultOutputTypeDef",
    {
        "InstanceConnectEndpoint": Ec2InstanceConnectEndpointOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceConnectEndpointsResultOutputTypeDef = TypedDict(
    "DescribeInstanceConnectEndpointsResultOutputTypeDef",
    {
        "InstanceConnectEndpoints": List[Ec2InstanceConnectEndpointOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeHostReservationsResultOutputTypeDef = TypedDict(
    "DescribeHostReservationsResultOutputTypeDef",
    {
        "HostReservationSet": List[HostReservationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceEventWindowOutputTypeDef = TypedDict(
    "InstanceEventWindowOutputTypeDef",
    {
        "InstanceEventWindowId": str,
        "TimeRanges": List[InstanceEventWindowTimeRangeOutputTypeDef],
        "Name": str,
        "CronExpression": str,
        "AssociationTarget": InstanceEventWindowAssociationTargetOutputTypeDef,
        "State": InstanceEventWindowStateType,
        "Tags": List[TagOutputTypeDef],
    },
)

AssociateIpamResourceDiscoveryResultOutputTypeDef = TypedDict(
    "AssociateIpamResourceDiscoveryResultOutputTypeDef",
    {
        "IpamResourceDiscoveryAssociation": IpamResourceDiscoveryAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpamResourceDiscoveryAssociationsResultOutputTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveryAssociationsResultOutputTypeDef",
    {
        "IpamResourceDiscoveryAssociations": List[IpamResourceDiscoveryAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateIpamResourceDiscoveryResultOutputTypeDef = TypedDict(
    "DisassociateIpamResourceDiscoveryResultOutputTypeDef",
    {
        "IpamResourceDiscoveryAssociation": IpamResourceDiscoveryAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateIpamScopeResultOutputTypeDef = TypedDict(
    "CreateIpamScopeResultOutputTypeDef",
    {
        "IpamScope": IpamScopeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteIpamScopeResultOutputTypeDef = TypedDict(
    "DeleteIpamScopeResultOutputTypeDef",
    {
        "IpamScope": IpamScopeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpamScopesResultOutputTypeDef = TypedDict(
    "DescribeIpamScopesResultOutputTypeDef",
    {
        "NextToken": str,
        "IpamScopes": List[IpamScopeOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyIpamScopeResultOutputTypeDef = TypedDict(
    "ModifyIpamScopeResultOutputTypeDef",
    {
        "IpamScope": IpamScopeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeKeyPairsResultOutputTypeDef = TypedDict(
    "DescribeKeyPairsResultOutputTypeDef",
    {
        "KeyPairs": List[KeyPairInfoOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLaunchTemplateResultOutputTypeDef = TypedDict(
    "DeleteLaunchTemplateResultOutputTypeDef",
    {
        "LaunchTemplate": LaunchTemplateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLaunchTemplatesResultOutputTypeDef = TypedDict(
    "DescribeLaunchTemplatesResultOutputTypeDef",
    {
        "LaunchTemplates": List[LaunchTemplateOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyLaunchTemplateResultOutputTypeDef = TypedDict(
    "ModifyLaunchTemplateResultOutputTypeDef",
    {
        "LaunchTemplate": LaunchTemplateOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewaysResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewaysResultOutputTypeDef",
    {
        "LocalGateways": List[LocalGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef = TypedDict(
    "CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociation": (
            LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef = TypedDict(
    "DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociationResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociation": (
            LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef
        ),
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVirtualInterfaceGroupAssociations": List[
            LocalGatewayRouteTableVirtualInterfaceGroupAssociationOutputTypeDef
        ],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateLocalGatewayRouteTableVpcAssociationResultOutputTypeDef = TypedDict(
    "CreateLocalGatewayRouteTableVpcAssociationResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociation": LocalGatewayRouteTableVpcAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLocalGatewayRouteTableVpcAssociationResultOutputTypeDef = TypedDict(
    "DeleteLocalGatewayRouteTableVpcAssociationResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociation": LocalGatewayRouteTableVpcAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewayRouteTableVpcAssociationsResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTableVpcAssociationsResultOutputTypeDef",
    {
        "LocalGatewayRouteTableVpcAssociations": List[
            LocalGatewayRouteTableVpcAssociationOutputTypeDef
        ],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewayVirtualInterfaceGroupsResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfaceGroupsResultOutputTypeDef",
    {
        "LocalGatewayVirtualInterfaceGroups": List[LocalGatewayVirtualInterfaceGroupOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewayVirtualInterfacesResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewayVirtualInterfacesResultOutputTypeDef",
    {
        "LocalGatewayVirtualInterfaces": List[LocalGatewayVirtualInterfaceOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateManagedPrefixListResultOutputTypeDef = TypedDict(
    "CreateManagedPrefixListResultOutputTypeDef",
    {
        "PrefixList": ManagedPrefixListOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteManagedPrefixListResultOutputTypeDef = TypedDict(
    "DeleteManagedPrefixListResultOutputTypeDef",
    {
        "PrefixList": ManagedPrefixListOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeManagedPrefixListsResultOutputTypeDef = TypedDict(
    "DescribeManagedPrefixListsResultOutputTypeDef",
    {
        "NextToken": str,
        "PrefixLists": List[ManagedPrefixListOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyManagedPrefixListResultOutputTypeDef = TypedDict(
    "ModifyManagedPrefixListResultOutputTypeDef",
    {
        "PrefixList": ManagedPrefixListOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RestoreManagedPrefixListVersionResultOutputTypeDef = TypedDict(
    "RestoreManagedPrefixListVersionResultOutputTypeDef",
    {
        "PrefixList": ManagedPrefixListOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInsightsAccessScopeAnalysesResultOutputTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopeAnalysesResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalyses": List[NetworkInsightsAccessScopeAnalysisOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StartNetworkInsightsAccessScopeAnalysisResultOutputTypeDef = TypedDict(
    "StartNetworkInsightsAccessScopeAnalysisResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysis": NetworkInsightsAccessScopeAnalysisOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInsightsAccessScopesResultOutputTypeDef = TypedDict(
    "DescribeNetworkInsightsAccessScopesResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopes": List[NetworkInsightsAccessScopeOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreatePlacementGroupResultOutputTypeDef = TypedDict(
    "CreatePlacementGroupResultOutputTypeDef",
    {
        "PlacementGroup": PlacementGroupOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribePlacementGroupsResultOutputTypeDef = TypedDict(
    "DescribePlacementGroupsResultOutputTypeDef",
    {
        "PlacementGroups": List[PlacementGroupOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateReplaceRootVolumeTaskResultOutputTypeDef = TypedDict(
    "CreateReplaceRootVolumeTaskResultOutputTypeDef",
    {
        "ReplaceRootVolumeTask": ReplaceRootVolumeTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeReplaceRootVolumeTasksResultOutputTypeDef = TypedDict(
    "DescribeReplaceRootVolumeTasksResultOutputTypeDef",
    {
        "ReplaceRootVolumeTasks": List[ReplaceRootVolumeTaskOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateSnapshotsResultOutputTypeDef = TypedDict(
    "CreateSnapshotsResultOutputTypeDef",
    {
        "Snapshots": List[SnapshotInfoOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSnapshotsResultOutputTypeDef = TypedDict(
    "DescribeSnapshotsResultOutputTypeDef",
    {
        "Snapshots": List[SnapshotOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSnapshotTierStatusResultOutputTypeDef = TypedDict(
    "DescribeSnapshotTierStatusResultOutputTypeDef",
    {
        "SnapshotTierStatuses": List[SnapshotTierStatusOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateSubnetCidrReservationResultOutputTypeDef = TypedDict(
    "CreateSubnetCidrReservationResultOutputTypeDef",
    {
        "SubnetCidrReservation": SubnetCidrReservationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteSubnetCidrReservationResultOutputTypeDef = TypedDict(
    "DeleteSubnetCidrReservationResultOutputTypeDef",
    {
        "DeletedSubnetCidrReservation": SubnetCidrReservationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetSubnetCidrReservationsResultOutputTypeDef = TypedDict(
    "GetSubnetCidrReservationsResultOutputTypeDef",
    {
        "SubnetIpv4CidrReservations": List[SubnetCidrReservationOutputTypeDef],
        "SubnetIpv6CidrReservations": List[SubnetCidrReservationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTrafficMirrorSessionResultOutputTypeDef = TypedDict(
    "CreateTrafficMirrorSessionResultOutputTypeDef",
    {
        "TrafficMirrorSession": TrafficMirrorSessionOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTrafficMirrorSessionsResultOutputTypeDef = TypedDict(
    "DescribeTrafficMirrorSessionsResultOutputTypeDef",
    {
        "TrafficMirrorSessions": List[TrafficMirrorSessionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTrafficMirrorSessionResultOutputTypeDef = TypedDict(
    "ModifyTrafficMirrorSessionResultOutputTypeDef",
    {
        "TrafficMirrorSession": TrafficMirrorSessionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTrafficMirrorTargetResultOutputTypeDef = TypedDict(
    "CreateTrafficMirrorTargetResultOutputTypeDef",
    {
        "TrafficMirrorTarget": TrafficMirrorTargetOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTrafficMirrorTargetsResultOutputTypeDef = TypedDict(
    "DescribeTrafficMirrorTargetsResultOutputTypeDef",
    {
        "TrafficMirrorTargets": List[TrafficMirrorTargetOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayPolicyTableResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayPolicyTableResultOutputTypeDef",
    {
        "TransitGatewayPolicyTable": TransitGatewayPolicyTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayPolicyTableResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayPolicyTableResultOutputTypeDef",
    {
        "TransitGatewayPolicyTable": TransitGatewayPolicyTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayPolicyTablesResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayPolicyTablesResultOutputTypeDef",
    {
        "TransitGatewayPolicyTables": List[TransitGatewayPolicyTableOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayRouteTableAnnouncementResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayRouteTableAnnouncementResultOutputTypeDef",
    {
        "TransitGatewayRouteTableAnnouncement": TransitGatewayRouteTableAnnouncementOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayRouteTableAnnouncementResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayRouteTableAnnouncementResultOutputTypeDef",
    {
        "TransitGatewayRouteTableAnnouncement": TransitGatewayRouteTableAnnouncementOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayRouteTableAnnouncementsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayRouteTableAnnouncementsResultOutputTypeDef",
    {
        "TransitGatewayRouteTableAnnouncements": List[
            TransitGatewayRouteTableAnnouncementOutputTypeDef
        ],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayRouteTableResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayRouteTableResultOutputTypeDef",
    {
        "TransitGatewayRouteTable": TransitGatewayRouteTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayRouteTableResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayRouteTableResultOutputTypeDef",
    {
        "TransitGatewayRouteTable": TransitGatewayRouteTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayRouteTablesResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayRouteTablesResultOutputTypeDef",
    {
        "TransitGatewayRouteTables": List[TransitGatewayRouteTableOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateTrunkInterfaceResultOutputTypeDef = TypedDict(
    "AssociateTrunkInterfaceResultOutputTypeDef",
    {
        "InterfaceAssociation": TrunkInterfaceAssociationOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTrunkInterfaceAssociationsResultOutputTypeDef = TypedDict(
    "DescribeTrunkInterfaceAssociationsResultOutputTypeDef",
    {
        "InterfaceAssociations": List[TrunkInterfaceAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVerifiedAccessGroupResultOutputTypeDef = TypedDict(
    "CreateVerifiedAccessGroupResultOutputTypeDef",
    {
        "VerifiedAccessGroup": VerifiedAccessGroupOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVerifiedAccessGroupResultOutputTypeDef = TypedDict(
    "DeleteVerifiedAccessGroupResultOutputTypeDef",
    {
        "VerifiedAccessGroup": VerifiedAccessGroupOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVerifiedAccessGroupsResultOutputTypeDef = TypedDict(
    "DescribeVerifiedAccessGroupsResultOutputTypeDef",
    {
        "VerifiedAccessGroups": List[VerifiedAccessGroupOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVerifiedAccessGroupResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessGroupResultOutputTypeDef",
    {
        "VerifiedAccessGroup": VerifiedAccessGroupOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcClassicLinkResultOutputTypeDef = TypedDict(
    "DescribeVpcClassicLinkResultOutputTypeDef",
    {
        "Vpcs": List[VpcClassicLinkOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ExplanationOutputTypeDef = TypedDict(
    "ExplanationOutputTypeDef",
    {
        "Acl": AnalysisComponentOutputTypeDef,
        "AclRule": AnalysisAclRuleOutputTypeDef,
        "Address": str,
        "Addresses": List[str],
        "AttachedTo": AnalysisComponentOutputTypeDef,
        "AvailabilityZones": List[str],
        "Cidrs": List[str],
        "Component": AnalysisComponentOutputTypeDef,
        "CustomerGateway": AnalysisComponentOutputTypeDef,
        "Destination": AnalysisComponentOutputTypeDef,
        "DestinationVpc": AnalysisComponentOutputTypeDef,
        "Direction": str,
        "ExplanationCode": str,
        "IngressRouteTable": AnalysisComponentOutputTypeDef,
        "InternetGateway": AnalysisComponentOutputTypeDef,
        "LoadBalancerArn": str,
        "ClassicLoadBalancerListener": AnalysisLoadBalancerListenerOutputTypeDef,
        "LoadBalancerListenerPort": int,
        "LoadBalancerTarget": AnalysisLoadBalancerTargetOutputTypeDef,
        "LoadBalancerTargetGroup": AnalysisComponentOutputTypeDef,
        "LoadBalancerTargetGroups": List[AnalysisComponentOutputTypeDef],
        "LoadBalancerTargetPort": int,
        "ElasticLoadBalancerListener": AnalysisComponentOutputTypeDef,
        "MissingComponent": str,
        "NatGateway": AnalysisComponentOutputTypeDef,
        "NetworkInterface": AnalysisComponentOutputTypeDef,
        "PacketField": str,
        "VpcPeeringConnection": AnalysisComponentOutputTypeDef,
        "Port": int,
        "PortRanges": List[PortRangeOutputTypeDef],
        "PrefixList": AnalysisComponentOutputTypeDef,
        "Protocols": List[str],
        "RouteTableRoute": AnalysisRouteTableRouteOutputTypeDef,
        "RouteTable": AnalysisComponentOutputTypeDef,
        "SecurityGroup": AnalysisComponentOutputTypeDef,
        "SecurityGroupRule": AnalysisSecurityGroupRuleOutputTypeDef,
        "SecurityGroups": List[AnalysisComponentOutputTypeDef],
        "SourceVpc": AnalysisComponentOutputTypeDef,
        "State": str,
        "Subnet": AnalysisComponentOutputTypeDef,
        "SubnetRouteTable": AnalysisComponentOutputTypeDef,
        "Vpc": AnalysisComponentOutputTypeDef,
        "VpcEndpoint": AnalysisComponentOutputTypeDef,
        "VpnConnection": AnalysisComponentOutputTypeDef,
        "VpnGateway": AnalysisComponentOutputTypeDef,
        "TransitGateway": AnalysisComponentOutputTypeDef,
        "TransitGatewayRouteTable": AnalysisComponentOutputTypeDef,
        "TransitGatewayRouteTableRoute": TransitGatewayRouteTableRouteOutputTypeDef,
        "TransitGatewayAttachment": AnalysisComponentOutputTypeDef,
        "ComponentAccount": str,
        "ComponentRegion": str,
        "FirewallStatelessRule": FirewallStatelessRuleOutputTypeDef,
        "FirewallStatefulRule": FirewallStatefulRuleOutputTypeDef,
    },
)

DescribeClientVpnTargetNetworksResultOutputTypeDef = TypedDict(
    "DescribeClientVpnTargetNetworksResultOutputTypeDef",
    {
        "ClientVpnTargetNetworks": List[TargetNetworkOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RouteTableOutputTypeDef = TypedDict(
    "RouteTableOutputTypeDef",
    {
        "Associations": List[RouteTableAssociationOutputTypeDef],
        "PropagatingVgws": List[PropagatingVgwOutputTypeDef],
        "RouteTableId": str,
        "Routes": List[RouteOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
)

_RequiredGetFlowLogsIntegrationTemplateRequestRequestTypeDef = TypedDict(
    "_RequiredGetFlowLogsIntegrationTemplateRequestRequestTypeDef",
    {
        "FlowLogId": str,
        "ConfigDeliveryS3DestinationArn": str,
        "IntegrateServices": IntegrateServicesTypeDef,
    },
)
_OptionalGetFlowLogsIntegrationTemplateRequestRequestTypeDef = TypedDict(
    "_OptionalGetFlowLogsIntegrationTemplateRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class GetFlowLogsIntegrationTemplateRequestRequestTypeDef(
    _RequiredGetFlowLogsIntegrationTemplateRequestRequestTypeDef,
    _OptionalGetFlowLogsIntegrationTemplateRequestRequestTypeDef,
):
    pass


CreateVpnGatewayResultOutputTypeDef = TypedDict(
    "CreateVpnGatewayResultOutputTypeDef",
    {
        "VpnGateway": VpnGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpnGatewaysResultOutputTypeDef = TypedDict(
    "DescribeVpnGatewaysResultOutputTypeDef",
    {
        "VpnGateways": List[VpnGatewayOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NetworkInterfaceAttachmentOutputTypeDef = TypedDict(
    "NetworkInterfaceAttachmentOutputTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "NetworkCardIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": AttachmentStatusType,
        "EnaSrdSpecification": AttachmentEnaSrdSpecificationOutputTypeDef,
    },
)

NetworkInterfaceAttachmentResponseMetadataTypeDef = TypedDict(
    "NetworkInterfaceAttachmentResponseMetadataTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "NetworkCardIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": AttachmentStatusType,
        "EnaSrdSpecification": AttachmentEnaSrdSpecificationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DhcpOptionsOutputTypeDef = TypedDict(
    "DhcpOptionsOutputTypeDef",
    {
        "DhcpConfigurations": List[DhcpConfigurationOutputTypeDef],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[TagOutputTypeDef],
    },
)

DescribeClientVpnAuthorizationRulesResultOutputTypeDef = TypedDict(
    "DescribeClientVpnAuthorizationRulesResultOutputTypeDef",
    {
        "AuthorizationRules": List[AuthorizationRuleOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeAvailabilityZonesResultOutputTypeDef = TypedDict(
    "DescribeAvailabilityZonesResultOutputTypeDef",
    {
        "AvailabilityZones": List[AvailabilityZoneOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

HostOutputTypeDef = TypedDict(
    "HostOutputTypeDef",
    {
        "AutoPlacement": AutoPlacementType,
        "AvailabilityZone": str,
        "AvailableCapacity": AvailableCapacityOutputTypeDef,
        "ClientToken": str,
        "HostId": str,
        "HostProperties": HostPropertiesOutputTypeDef,
        "HostReservationId": str,
        "Instances": List[HostInstanceOutputTypeDef],
        "State": AllocationStateType,
        "AllocationTime": datetime,
        "ReleaseTime": datetime,
        "Tags": List[TagOutputTypeDef],
        "HostRecovery": HostRecoveryType,
        "AllowsMultipleInstanceTypes": AllowsMultipleInstanceTypesType,
        "OwnerId": str,
        "AvailabilityZoneId": str,
        "MemberOfServiceLinkedResourceGroup": bool,
        "OutpostArn": str,
        "HostMaintenance": HostMaintenanceType,
        "AssetId": str,
    },
)

ImageAttributeOutputTypeDef = TypedDict(
    "ImageAttributeOutputTypeDef",
    {
        "BlockDeviceMappings": List[BlockDeviceMappingOutputTypeDef],
        "ImageId": str,
        "LaunchPermissions": List[LaunchPermissionOutputTypeDef],
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "Description": AttributeValueOutputTypeDef,
        "KernelId": AttributeValueOutputTypeDef,
        "RamdiskId": AttributeValueOutputTypeDef,
        "SriovNetSupport": AttributeValueOutputTypeDef,
        "BootMode": AttributeValueOutputTypeDef,
        "TpmSupport": AttributeValueOutputTypeDef,
        "UefiData": AttributeValueOutputTypeDef,
        "LastLaunchedTime": AttributeValueOutputTypeDef,
        "ImdsSupport": AttributeValueOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImageOutputTypeDef = TypedDict(
    "ImageOutputTypeDef",
    {
        "Architecture": ArchitectureValuesType,
        "CreationDate": str,
        "ImageId": str,
        "ImageLocation": str,
        "ImageType": ImageTypeValuesType,
        "Public": bool,
        "KernelId": str,
        "OwnerId": str,
        "Platform": Literal["Windows"],
        "PlatformDetails": str,
        "UsageOperation": str,
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "RamdiskId": str,
        "State": ImageStateType,
        "BlockDeviceMappings": List[BlockDeviceMappingOutputTypeDef],
        "Description": str,
        "EnaSupport": bool,
        "Hypervisor": HypervisorTypeType,
        "ImageOwnerAlias": str,
        "Name": str,
        "RootDeviceName": str,
        "RootDeviceType": DeviceTypeType,
        "SriovNetSupport": str,
        "StateReason": StateReasonOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "VirtualizationType": VirtualizationTypeType,
        "BootMode": BootModeValuesType,
        "TpmSupport": Literal["v2.0"],
        "DeprecationTime": str,
        "ImdsSupport": Literal["v2.0"],
    },
)

_RequiredRegisterImageRequestRequestTypeDef = TypedDict(
    "_RequiredRegisterImageRequestRequestTypeDef",
    {
        "Name": str,
    },
)
_OptionalRegisterImageRequestRequestTypeDef = TypedDict(
    "_OptionalRegisterImageRequestRequestTypeDef",
    {
        "ImageLocation": str,
        "Architecture": ArchitectureValuesType,
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "Description": str,
        "DryRun": bool,
        "EnaSupport": bool,
        "KernelId": str,
        "BillingProducts": Sequence[str],
        "RamdiskId": str,
        "RootDeviceName": str,
        "SriovNetSupport": str,
        "VirtualizationType": str,
        "BootMode": BootModeValuesType,
        "TpmSupport": Literal["v2.0"],
        "UefiData": str,
        "ImdsSupport": Literal["v2.0"],
    },
    total=False,
)


class RegisterImageRequestRequestTypeDef(
    _RequiredRegisterImageRequestRequestTypeDef, _OptionalRegisterImageRequestRequestTypeDef
):
    pass


_RequiredRegisterImageRequestServiceResourceRegisterImageTypeDef = TypedDict(
    "_RequiredRegisterImageRequestServiceResourceRegisterImageTypeDef",
    {
        "Name": str,
    },
)
_OptionalRegisterImageRequestServiceResourceRegisterImageTypeDef = TypedDict(
    "_OptionalRegisterImageRequestServiceResourceRegisterImageTypeDef",
    {
        "ImageLocation": str,
        "Architecture": ArchitectureValuesType,
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "Description": str,
        "DryRun": bool,
        "EnaSupport": bool,
        "KernelId": str,
        "BillingProducts": Sequence[str],
        "RamdiskId": str,
        "RootDeviceName": str,
        "SriovNetSupport": str,
        "VirtualizationType": str,
        "BootMode": BootModeValuesType,
        "TpmSupport": Literal["v2.0"],
        "UefiData": str,
        "ImdsSupport": Literal["v2.0"],
    },
    total=False,
)


class RegisterImageRequestServiceResourceRegisterImageTypeDef(
    _RequiredRegisterImageRequestServiceResourceRegisterImageTypeDef,
    _OptionalRegisterImageRequestServiceResourceRegisterImageTypeDef,
):
    pass


CancelCapacityReservationFleetsResultOutputTypeDef = TypedDict(
    "CancelCapacityReservationFleetsResultOutputTypeDef",
    {
        "SuccessfulFleetCancellations": List[
            CapacityReservationFleetCancellationStateOutputTypeDef
        ],
        "FailedFleetCancellations": List[
            FailedCapacityReservationFleetCancellationResultOutputTypeDef
        ],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CancelSpotFleetRequestsResponseOutputTypeDef = TypedDict(
    "CancelSpotFleetRequestsResponseOutputTypeDef",
    {
        "SuccessfulFleetRequests": List[CancelSpotFleetRequestsSuccessItemOutputTypeDef],
        "UnsuccessfulFleetRequests": List[CancelSpotFleetRequestsErrorItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateCapacityReservationResultOutputTypeDef = TypedDict(
    "CreateCapacityReservationResultOutputTypeDef",
    {
        "CapacityReservation": CapacityReservationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeCapacityReservationsResultOutputTypeDef = TypedDict(
    "DescribeCapacityReservationsResultOutputTypeDef",
    {
        "NextToken": str,
        "CapacityReservations": List[CapacityReservationOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeCapacityReservationFleetsResultOutputTypeDef = TypedDict(
    "DescribeCapacityReservationFleetsResultOutputTypeDef",
    {
        "CapacityReservationFleets": List[CapacityReservationFleetOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifyInstanceCapacityReservationAttributesRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceCapacityReservationAttributesRequestRequestTypeDef",
    {
        "InstanceId": str,
        "CapacityReservationSpecification": CapacityReservationSpecificationTypeDef,
    },
)
_OptionalModifyInstanceCapacityReservationAttributesRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceCapacityReservationAttributesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifyInstanceCapacityReservationAttributesRequestRequestTypeDef(
    _RequiredModifyInstanceCapacityReservationAttributesRequestRequestTypeDef,
    _OptionalModifyInstanceCapacityReservationAttributesRequestRequestTypeDef,
):
    pass


DescribeClassicLinkInstancesResultOutputTypeDef = TypedDict(
    "DescribeClassicLinkInstancesResultOutputTypeDef",
    {
        "Instances": List[ClassicLinkInstanceOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAssociateInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateInstanceEventWindowRequestRequestTypeDef",
    {
        "InstanceEventWindowId": str,
        "AssociationTarget": InstanceEventWindowAssociationRequestTypeDef,
    },
)
_OptionalAssociateInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateInstanceEventWindowRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class AssociateInstanceEventWindowRequestRequestTypeDef(
    _RequiredAssociateInstanceEventWindowRequestRequestTypeDef,
    _OptionalAssociateInstanceEventWindowRequestRequestTypeDef,
):
    pass


_RequiredDisassociateInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_RequiredDisassociateInstanceEventWindowRequestRequestTypeDef",
    {
        "InstanceEventWindowId": str,
        "AssociationTarget": InstanceEventWindowDisassociationRequestTypeDef,
    },
)
_OptionalDisassociateInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "_OptionalDisassociateInstanceEventWindowRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class DisassociateInstanceEventWindowRequestRequestTypeDef(
    _RequiredDisassociateInstanceEventWindowRequestRequestTypeDef,
    _OptionalDisassociateInstanceEventWindowRequestRequestTypeDef,
):
    pass


_RequiredAcceptAddressTransferRequestRequestTypeDef = TypedDict(
    "_RequiredAcceptAddressTransferRequestRequestTypeDef",
    {
        "Address": str,
    },
)
_OptionalAcceptAddressTransferRequestRequestTypeDef = TypedDict(
    "_OptionalAcceptAddressTransferRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class AcceptAddressTransferRequestRequestTypeDef(
    _RequiredAcceptAddressTransferRequestRequestTypeDef,
    _OptionalAcceptAddressTransferRequestRequestTypeDef,
):
    pass


AllocateAddressRequestRequestTypeDef = TypedDict(
    "AllocateAddressRequestRequestTypeDef",
    {
        "Domain": DomainTypeType,
        "Address": str,
        "PublicIpv4Pool": str,
        "NetworkBorderGroup": str,
        "CustomerOwnedIpv4Pool": str,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredAllocateHostsRequestRequestTypeDef = TypedDict(
    "_RequiredAllocateHostsRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
    },
)
_OptionalAllocateHostsRequestRequestTypeDef = TypedDict(
    "_OptionalAllocateHostsRequestRequestTypeDef",
    {
        "AutoPlacement": AutoPlacementType,
        "ClientToken": str,
        "InstanceType": str,
        "InstanceFamily": str,
        "Quantity": int,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "HostRecovery": HostRecoveryType,
        "OutpostArn": str,
        "HostMaintenance": HostMaintenanceType,
        "AssetIds": Sequence[str],
    },
    total=False,
)


class AllocateHostsRequestRequestTypeDef(
    _RequiredAllocateHostsRequestRequestTypeDef, _OptionalAllocateHostsRequestRequestTypeDef
):
    pass


_RequiredAssociateIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_RequiredAssociateIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "IpamId": str,
        "IpamResourceDiscoveryId": str,
    },
)
_OptionalAssociateIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "_OptionalAssociateIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)


class AssociateIpamResourceDiscoveryRequestRequestTypeDef(
    _RequiredAssociateIpamResourceDiscoveryRequestRequestTypeDef,
    _OptionalAssociateIpamResourceDiscoveryRequestRequestTypeDef,
):
    pass


_RequiredCopySnapshotRequestRequestTypeDef = TypedDict(
    "_RequiredCopySnapshotRequestRequestTypeDef",
    {
        "SourceRegion": str,
        "SourceSnapshotId": str,
    },
)
_OptionalCopySnapshotRequestRequestTypeDef = TypedDict(
    "_OptionalCopySnapshotRequestRequestTypeDef",
    {
        "Description": str,
        "DestinationOutpostArn": str,
        "DestinationRegion": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "PresignedUrl": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CopySnapshotRequestRequestTypeDef(
    _RequiredCopySnapshotRequestRequestTypeDef, _OptionalCopySnapshotRequestRequestTypeDef
):
    pass


_RequiredCopySnapshotRequestSnapshotCopyTypeDef = TypedDict(
    "_RequiredCopySnapshotRequestSnapshotCopyTypeDef",
    {
        "SourceRegion": str,
    },
)
_OptionalCopySnapshotRequestSnapshotCopyTypeDef = TypedDict(
    "_OptionalCopySnapshotRequestSnapshotCopyTypeDef",
    {
        "Description": str,
        "DestinationOutpostArn": str,
        "DestinationRegion": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "PresignedUrl": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CopySnapshotRequestSnapshotCopyTypeDef(
    _RequiredCopySnapshotRequestSnapshotCopyTypeDef, _OptionalCopySnapshotRequestSnapshotCopyTypeDef
):
    pass


_RequiredCreateCapacityReservationFleetRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCapacityReservationFleetRequestRequestTypeDef",
    {
        "InstanceTypeSpecifications": Sequence[ReservationFleetInstanceSpecificationTypeDef],
        "TotalTargetCapacity": int,
    },
)
_OptionalCreateCapacityReservationFleetRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCapacityReservationFleetRequestRequestTypeDef",
    {
        "AllocationStrategy": str,
        "ClientToken": str,
        "Tenancy": Literal["default"],
        "EndDate": Union[datetime, str],
        "InstanceMatchCriteria": Literal["open"],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateCapacityReservationFleetRequestRequestTypeDef(
    _RequiredCreateCapacityReservationFleetRequestRequestTypeDef,
    _OptionalCreateCapacityReservationFleetRequestRequestTypeDef,
):
    pass


_RequiredCreateCapacityReservationRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCapacityReservationRequestRequestTypeDef",
    {
        "InstanceType": str,
        "InstancePlatform": CapacityReservationInstancePlatformType,
        "InstanceCount": int,
    },
)
_OptionalCreateCapacityReservationRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCapacityReservationRequestRequestTypeDef",
    {
        "ClientToken": str,
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "Tenancy": CapacityReservationTenancyType,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "EndDate": Union[datetime, str],
        "EndDateType": EndDateTypeType,
        "InstanceMatchCriteria": InstanceMatchCriteriaType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "OutpostArn": str,
        "PlacementGroupArn": str,
    },
    total=False,
)


class CreateCapacityReservationRequestRequestTypeDef(
    _RequiredCreateCapacityReservationRequestRequestTypeDef,
    _OptionalCreateCapacityReservationRequestRequestTypeDef,
):
    pass


_RequiredCreateCarrierGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCarrierGatewayRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateCarrierGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCarrierGatewayRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class CreateCarrierGatewayRequestRequestTypeDef(
    _RequiredCreateCarrierGatewayRequestRequestTypeDef,
    _OptionalCreateCarrierGatewayRequestRequestTypeDef,
):
    pass


_RequiredCreateCoipPoolRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCoipPoolRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
    },
)
_OptionalCreateCoipPoolRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCoipPoolRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateCoipPoolRequestRequestTypeDef(
    _RequiredCreateCoipPoolRequestRequestTypeDef, _OptionalCreateCoipPoolRequestRequestTypeDef
):
    pass


_RequiredCreateCustomerGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredCreateCustomerGatewayRequestRequestTypeDef",
    {
        "Type": Literal["ipsec.1"],
    },
)
_OptionalCreateCustomerGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalCreateCustomerGatewayRequestRequestTypeDef",
    {
        "BgpAsn": int,
        "PublicIp": str,
        "CertificateArn": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DeviceName": str,
        "IpAddress": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateCustomerGatewayRequestRequestTypeDef(
    _RequiredCreateCustomerGatewayRequestRequestTypeDef,
    _OptionalCreateCustomerGatewayRequestRequestTypeDef,
):
    pass


_RequiredCreateDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredCreateDhcpOptionsRequestRequestTypeDef",
    {
        "DhcpConfigurations": Sequence[NewDhcpConfigurationTypeDef],
    },
)
_OptionalCreateDhcpOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalCreateDhcpOptionsRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateDhcpOptionsRequestRequestTypeDef(
    _RequiredCreateDhcpOptionsRequestRequestTypeDef, _OptionalCreateDhcpOptionsRequestRequestTypeDef
):
    pass


_RequiredCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef = TypedDict(
    "_RequiredCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": Sequence[NewDhcpConfigurationTypeDef],
    },
)
_OptionalCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef = TypedDict(
    "_OptionalCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef(
    _RequiredCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef,
    _OptionalCreateDhcpOptionsRequestServiceResourceCreateDhcpOptionsTypeDef,
):
    pass


_RequiredCreateEgressOnlyInternetGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredCreateEgressOnlyInternetGatewayRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateEgressOnlyInternetGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalCreateEgressOnlyInternetGatewayRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateEgressOnlyInternetGatewayRequestRequestTypeDef(
    _RequiredCreateEgressOnlyInternetGatewayRequestRequestTypeDef,
    _OptionalCreateEgressOnlyInternetGatewayRequestRequestTypeDef,
):
    pass


_RequiredCreateFlowLogsRequestRequestTypeDef = TypedDict(
    "_RequiredCreateFlowLogsRequestRequestTypeDef",
    {
        "ResourceIds": Sequence[str],
        "ResourceType": FlowLogsResourceTypeType,
    },
)
_OptionalCreateFlowLogsRequestRequestTypeDef = TypedDict(
    "_OptionalCreateFlowLogsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
        "DeliverLogsPermissionArn": str,
        "DeliverCrossAccountRole": str,
        "LogGroupName": str,
        "TrafficType": TrafficTypeType,
        "LogDestinationType": LogDestinationTypeType,
        "LogDestination": str,
        "LogFormat": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "MaxAggregationInterval": int,
        "DestinationOptions": DestinationOptionsRequestTypeDef,
    },
    total=False,
)


class CreateFlowLogsRequestRequestTypeDef(
    _RequiredCreateFlowLogsRequestRequestTypeDef, _OptionalCreateFlowLogsRequestRequestTypeDef
):
    pass


_RequiredCreateFpgaImageRequestRequestTypeDef = TypedDict(
    "_RequiredCreateFpgaImageRequestRequestTypeDef",
    {
        "InputStorageLocation": StorageLocationTypeDef,
    },
)
_OptionalCreateFpgaImageRequestRequestTypeDef = TypedDict(
    "_OptionalCreateFpgaImageRequestRequestTypeDef",
    {
        "DryRun": bool,
        "LogsStorageLocation": StorageLocationTypeDef,
        "Description": str,
        "Name": str,
        "ClientToken": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateFpgaImageRequestRequestTypeDef(
    _RequiredCreateFpgaImageRequestRequestTypeDef, _OptionalCreateFpgaImageRequestRequestTypeDef
):
    pass


_RequiredCreateImageRequestInstanceCreateImageTypeDef = TypedDict(
    "_RequiredCreateImageRequestInstanceCreateImageTypeDef",
    {
        "Name": str,
    },
)
_OptionalCreateImageRequestInstanceCreateImageTypeDef = TypedDict(
    "_OptionalCreateImageRequestInstanceCreateImageTypeDef",
    {
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "Description": str,
        "DryRun": bool,
        "NoReboot": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateImageRequestInstanceCreateImageTypeDef(
    _RequiredCreateImageRequestInstanceCreateImageTypeDef,
    _OptionalCreateImageRequestInstanceCreateImageTypeDef,
):
    pass


_RequiredCreateImageRequestRequestTypeDef = TypedDict(
    "_RequiredCreateImageRequestRequestTypeDef",
    {
        "InstanceId": str,
        "Name": str,
    },
)
_OptionalCreateImageRequestRequestTypeDef = TypedDict(
    "_OptionalCreateImageRequestRequestTypeDef",
    {
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "Description": str,
        "DryRun": bool,
        "NoReboot": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateImageRequestRequestTypeDef(
    _RequiredCreateImageRequestRequestTypeDef, _OptionalCreateImageRequestRequestTypeDef
):
    pass


_RequiredCreateInstanceConnectEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredCreateInstanceConnectEndpointRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalCreateInstanceConnectEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalCreateInstanceConnectEndpointRequestRequestTypeDef",
    {
        "DryRun": bool,
        "SecurityGroupIds": Sequence[str],
        "PreserveClientIp": bool,
        "ClientToken": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateInstanceConnectEndpointRequestRequestTypeDef(
    _RequiredCreateInstanceConnectEndpointRequestRequestTypeDef,
    _OptionalCreateInstanceConnectEndpointRequestRequestTypeDef,
):
    pass


CreateInstanceEventWindowRequestRequestTypeDef = TypedDict(
    "CreateInstanceEventWindowRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Name": str,
        "TimeRanges": Sequence[InstanceEventWindowTimeRangeRequestTypeDef],
        "CronExpression": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateInstanceExportTaskRequestRequestTypeDef = TypedDict(
    "_RequiredCreateInstanceExportTaskRequestRequestTypeDef",
    {
        "ExportToS3Task": ExportToS3TaskSpecificationTypeDef,
        "InstanceId": str,
        "TargetEnvironment": ExportEnvironmentType,
    },
)
_OptionalCreateInstanceExportTaskRequestRequestTypeDef = TypedDict(
    "_OptionalCreateInstanceExportTaskRequestRequestTypeDef",
    {
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateInstanceExportTaskRequestRequestTypeDef(
    _RequiredCreateInstanceExportTaskRequestRequestTypeDef,
    _OptionalCreateInstanceExportTaskRequestRequestTypeDef,
):
    pass


CreateInternetGatewayRequestRequestTypeDef = TypedDict(
    "CreateInternetGatewayRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)

CreateInternetGatewayRequestServiceResourceCreateInternetGatewayTypeDef = TypedDict(
    "CreateInternetGatewayRequestServiceResourceCreateInternetGatewayTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)

_RequiredCreateIpamPoolRequestRequestTypeDef = TypedDict(
    "_RequiredCreateIpamPoolRequestRequestTypeDef",
    {
        "IpamScopeId": str,
        "AddressFamily": AddressFamilyType,
    },
)
_OptionalCreateIpamPoolRequestRequestTypeDef = TypedDict(
    "_OptionalCreateIpamPoolRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Locale": str,
        "SourceIpamPoolId": str,
        "Description": str,
        "AutoImport": bool,
        "PubliclyAdvertisable": bool,
        "AllocationMinNetmaskLength": int,
        "AllocationMaxNetmaskLength": int,
        "AllocationDefaultNetmaskLength": int,
        "AllocationResourceTags": Sequence[RequestIpamResourceTagTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
        "AwsService": Literal["ec2"],
        "PublicIpSource": IpamPoolPublicIpSourceType,
    },
    total=False,
)


class CreateIpamPoolRequestRequestTypeDef(
    _RequiredCreateIpamPoolRequestRequestTypeDef, _OptionalCreateIpamPoolRequestRequestTypeDef
):
    pass


CreateIpamRequestRequestTypeDef = TypedDict(
    "CreateIpamRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "OperatingRegions": Sequence[AddIpamOperatingRegionTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)

CreateIpamResourceDiscoveryRequestRequestTypeDef = TypedDict(
    "CreateIpamResourceDiscoveryRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "OperatingRegions": Sequence[AddIpamOperatingRegionTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)

_RequiredCreateIpamScopeRequestRequestTypeDef = TypedDict(
    "_RequiredCreateIpamScopeRequestRequestTypeDef",
    {
        "IpamId": str,
    },
)
_OptionalCreateIpamScopeRequestRequestTypeDef = TypedDict(
    "_OptionalCreateIpamScopeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)


class CreateIpamScopeRequestRequestTypeDef(
    _RequiredCreateIpamScopeRequestRequestTypeDef, _OptionalCreateIpamScopeRequestRequestTypeDef
):
    pass


_RequiredCreateKeyPairRequestRequestTypeDef = TypedDict(
    "_RequiredCreateKeyPairRequestRequestTypeDef",
    {
        "KeyName": str,
    },
)
_OptionalCreateKeyPairRequestRequestTypeDef = TypedDict(
    "_OptionalCreateKeyPairRequestRequestTypeDef",
    {
        "DryRun": bool,
        "KeyType": KeyTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "KeyFormat": KeyFormatType,
    },
    total=False,
)


class CreateKeyPairRequestRequestTypeDef(
    _RequiredCreateKeyPairRequestRequestTypeDef, _OptionalCreateKeyPairRequestRequestTypeDef
):
    pass


_RequiredCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef = TypedDict(
    "_RequiredCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef",
    {
        "KeyName": str,
    },
)
_OptionalCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef = TypedDict(
    "_OptionalCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef",
    {
        "DryRun": bool,
        "KeyType": KeyTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "KeyFormat": KeyFormatType,
    },
    total=False,
)


class CreateKeyPairRequestServiceResourceCreateKeyPairTypeDef(
    _RequiredCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef,
    _OptionalCreateKeyPairRequestServiceResourceCreateKeyPairTypeDef,
):
    pass


_RequiredCreateLocalGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLocalGatewayRouteTableRequestRequestTypeDef",
    {
        "LocalGatewayId": str,
    },
)
_OptionalCreateLocalGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLocalGatewayRouteTableRequestRequestTypeDef",
    {
        "Mode": LocalGatewayRouteTableModeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateLocalGatewayRouteTableRequestRequestTypeDef(
    _RequiredCreateLocalGatewayRouteTableRequestRequestTypeDef,
    _OptionalCreateLocalGatewayRouteTableRequestRequestTypeDef,
):
    pass


_RequiredCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
        "LocalGatewayVirtualInterfaceGroupId": str,
    },
)
_OptionalCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef(
    _RequiredCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef,
    _OptionalCreateLocalGatewayRouteTableVirtualInterfaceGroupAssociationRequestRequestTypeDef,
):
    pass


_RequiredCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    {
        "LocalGatewayRouteTableId": str,
        "VpcId": str,
    },
)
_OptionalCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef(
    _RequiredCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef,
    _OptionalCreateLocalGatewayRouteTableVpcAssociationRequestRequestTypeDef,
):
    pass


_RequiredCreateManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_RequiredCreateManagedPrefixListRequestRequestTypeDef",
    {
        "PrefixListName": str,
        "MaxEntries": int,
        "AddressFamily": str,
    },
)
_OptionalCreateManagedPrefixListRequestRequestTypeDef = TypedDict(
    "_OptionalCreateManagedPrefixListRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Entries": Sequence[AddPrefixListEntryTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)


class CreateManagedPrefixListRequestRequestTypeDef(
    _RequiredCreateManagedPrefixListRequestRequestTypeDef,
    _OptionalCreateManagedPrefixListRequestRequestTypeDef,
):
    pass


_RequiredCreateNatGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNatGatewayRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalCreateNatGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNatGatewayRequestRequestTypeDef",
    {
        "AllocationId": str,
        "ClientToken": str,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ConnectivityType": ConnectivityTypeType,
        "PrivateIpAddress": str,
        "SecondaryAllocationIds": Sequence[str],
        "SecondaryPrivateIpAddresses": Sequence[str],
        "SecondaryPrivateIpAddressCount": int,
    },
    total=False,
)


class CreateNatGatewayRequestRequestTypeDef(
    _RequiredCreateNatGatewayRequestRequestTypeDef, _OptionalCreateNatGatewayRequestRequestTypeDef
):
    pass


_RequiredCreateNetworkAclRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkAclRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateNetworkAclRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkAclRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateNetworkAclRequestRequestTypeDef(
    _RequiredCreateNetworkAclRequestRequestTypeDef, _OptionalCreateNetworkAclRequestRequestTypeDef
):
    pass


_RequiredCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef = TypedDict(
    "_RequiredCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef = TypedDict(
    "_OptionalCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef(
    _RequiredCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef,
    _OptionalCreateNetworkAclRequestServiceResourceCreateNetworkAclTypeDef,
):
    pass


CreateNetworkAclRequestVpcCreateNetworkAclTypeDef = TypedDict(
    "CreateNetworkAclRequestVpcCreateNetworkAclTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkInterfaceRequestRequestTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalCreateNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkInterfaceRequestRequestTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "Groups": Sequence[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "PrivateIpAddress": str,
        "PrivateIpAddresses": Sequence[PrivateIpAddressSpecificationTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "Ipv4Prefixes": Sequence[Ipv4PrefixSpecificationRequestTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": Sequence[Ipv6PrefixSpecificationRequestTypeDef],
        "Ipv6PrefixCount": int,
        "InterfaceType": NetworkInterfaceCreationTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)


class CreateNetworkInterfaceRequestRequestTypeDef(
    _RequiredCreateNetworkInterfaceRequestRequestTypeDef,
    _OptionalCreateNetworkInterfaceRequestRequestTypeDef,
):
    pass


_RequiredCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef = TypedDict(
    "_RequiredCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef",
    {
        "SubnetId": str,
    },
)
_OptionalCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef = TypedDict(
    "_OptionalCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "Groups": Sequence[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "PrivateIpAddress": str,
        "PrivateIpAddresses": Sequence[PrivateIpAddressSpecificationTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "Ipv4Prefixes": Sequence[Ipv4PrefixSpecificationRequestTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": Sequence[Ipv6PrefixSpecificationRequestTypeDef],
        "Ipv6PrefixCount": int,
        "InterfaceType": NetworkInterfaceCreationTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)


class CreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef(
    _RequiredCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef,
    _OptionalCreateNetworkInterfaceRequestServiceResourceCreateNetworkInterfaceTypeDef,
):
    pass


CreateNetworkInterfaceRequestSubnetCreateNetworkInterfaceTypeDef = TypedDict(
    "CreateNetworkInterfaceRequestSubnetCreateNetworkInterfaceTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "Groups": Sequence[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "PrivateIpAddress": str,
        "PrivateIpAddresses": Sequence[PrivateIpAddressSpecificationTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "Ipv4Prefixes": Sequence[Ipv4PrefixSpecificationRequestTypeDef],
        "Ipv4PrefixCount": int,
        "Ipv6Prefixes": Sequence[Ipv6PrefixSpecificationRequestTypeDef],
        "Ipv6PrefixCount": int,
        "InterfaceType": NetworkInterfaceCreationTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
    },
    total=False,
)

CreatePlacementGroupRequestRequestTypeDef = TypedDict(
    "CreatePlacementGroupRequestRequestTypeDef",
    {
        "DryRun": bool,
        "GroupName": str,
        "Strategy": PlacementStrategyType,
        "PartitionCount": int,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "SpreadLevel": SpreadLevelType,
    },
    total=False,
)

CreatePlacementGroupRequestServiceResourceCreatePlacementGroupTypeDef = TypedDict(
    "CreatePlacementGroupRequestServiceResourceCreatePlacementGroupTypeDef",
    {
        "DryRun": bool,
        "GroupName": str,
        "Strategy": PlacementStrategyType,
        "PartitionCount": int,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "SpreadLevel": SpreadLevelType,
    },
    total=False,
)

CreatePublicIpv4PoolRequestRequestTypeDef = TypedDict(
    "CreatePublicIpv4PoolRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateReplaceRootVolumeTaskRequestRequestTypeDef = TypedDict(
    "_RequiredCreateReplaceRootVolumeTaskRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalCreateReplaceRootVolumeTaskRequestRequestTypeDef = TypedDict(
    "_OptionalCreateReplaceRootVolumeTaskRequestRequestTypeDef",
    {
        "SnapshotId": str,
        "ClientToken": str,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ImageId": str,
        "DeleteReplacedRootVolume": bool,
    },
    total=False,
)


class CreateReplaceRootVolumeTaskRequestRequestTypeDef(
    _RequiredCreateReplaceRootVolumeTaskRequestRequestTypeDef,
    _OptionalCreateReplaceRootVolumeTaskRequestRequestTypeDef,
):
    pass


_RequiredCreateRestoreImageTaskRequestRequestTypeDef = TypedDict(
    "_RequiredCreateRestoreImageTaskRequestRequestTypeDef",
    {
        "Bucket": str,
        "ObjectKey": str,
    },
)
_OptionalCreateRestoreImageTaskRequestRequestTypeDef = TypedDict(
    "_OptionalCreateRestoreImageTaskRequestRequestTypeDef",
    {
        "Name": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateRestoreImageTaskRequestRequestTypeDef(
    _RequiredCreateRestoreImageTaskRequestRequestTypeDef,
    _OptionalCreateRestoreImageTaskRequestRequestTypeDef,
):
    pass


_RequiredCreateRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredCreateRouteTableRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalCreateRouteTableRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateRouteTableRequestRequestTypeDef(
    _RequiredCreateRouteTableRequestRequestTypeDef, _OptionalCreateRouteTableRequestRequestTypeDef
):
    pass


_RequiredCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef = TypedDict(
    "_RequiredCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef = TypedDict(
    "_OptionalCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateRouteTableRequestServiceResourceCreateRouteTableTypeDef(
    _RequiredCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef,
    _OptionalCreateRouteTableRequestServiceResourceCreateRouteTableTypeDef,
):
    pass


CreateRouteTableRequestVpcCreateRouteTableTypeDef = TypedDict(
    "CreateRouteTableRequestVpcCreateRouteTableTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateSecurityGroupRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSecurityGroupRequestRequestTypeDef",
    {
        "Description": str,
        "GroupName": str,
    },
)
_OptionalCreateSecurityGroupRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSecurityGroupRequestRequestTypeDef",
    {
        "VpcId": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateSecurityGroupRequestRequestTypeDef(
    _RequiredCreateSecurityGroupRequestRequestTypeDef,
    _OptionalCreateSecurityGroupRequestRequestTypeDef,
):
    pass


_RequiredCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef = TypedDict(
    "_RequiredCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef",
    {
        "Description": str,
        "GroupName": str,
    },
)
_OptionalCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef = TypedDict(
    "_OptionalCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef",
    {
        "VpcId": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef(
    _RequiredCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef,
    _OptionalCreateSecurityGroupRequestServiceResourceCreateSecurityGroupTypeDef,
):
    pass


_RequiredCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef = TypedDict(
    "_RequiredCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef",
    {
        "Description": str,
        "GroupName": str,
    },
)
_OptionalCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef = TypedDict(
    "_OptionalCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef(
    _RequiredCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef,
    _OptionalCreateSecurityGroupRequestVpcCreateSecurityGroupTypeDef,
):
    pass


_RequiredCreateSnapshotRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSnapshotRequestRequestTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalCreateSnapshotRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSnapshotRequestRequestTypeDef",
    {
        "Description": str,
        "OutpostArn": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateSnapshotRequestRequestTypeDef(
    _RequiredCreateSnapshotRequestRequestTypeDef, _OptionalCreateSnapshotRequestRequestTypeDef
):
    pass


_RequiredCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef = TypedDict(
    "_RequiredCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef",
    {
        "VolumeId": str,
    },
)
_OptionalCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef = TypedDict(
    "_OptionalCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef",
    {
        "Description": str,
        "OutpostArn": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateSnapshotRequestServiceResourceCreateSnapshotTypeDef(
    _RequiredCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef,
    _OptionalCreateSnapshotRequestServiceResourceCreateSnapshotTypeDef,
):
    pass


CreateSnapshotRequestVolumeCreateSnapshotTypeDef = TypedDict(
    "CreateSnapshotRequestVolumeCreateSnapshotTypeDef",
    {
        "Description": str,
        "OutpostArn": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)

_RequiredCreateSnapshotsRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSnapshotsRequestRequestTypeDef",
    {
        "InstanceSpecification": InstanceSpecificationTypeDef,
    },
)
_OptionalCreateSnapshotsRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSnapshotsRequestRequestTypeDef",
    {
        "Description": str,
        "OutpostArn": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "CopyTagsFromSource": Literal["volume"],
    },
    total=False,
)


class CreateSnapshotsRequestRequestTypeDef(
    _RequiredCreateSnapshotsRequestRequestTypeDef, _OptionalCreateSnapshotsRequestRequestTypeDef
):
    pass


_RequiredCreateSubnetCidrReservationRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSubnetCidrReservationRequestRequestTypeDef",
    {
        "SubnetId": str,
        "Cidr": str,
        "ReservationType": SubnetCidrReservationTypeType,
    },
)
_OptionalCreateSubnetCidrReservationRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSubnetCidrReservationRequestRequestTypeDef",
    {
        "Description": str,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateSubnetCidrReservationRequestRequestTypeDef(
    _RequiredCreateSubnetCidrReservationRequestRequestTypeDef,
    _OptionalCreateSubnetCidrReservationRequestRequestTypeDef,
):
    pass


_RequiredCreateSubnetRequestRequestTypeDef = TypedDict(
    "_RequiredCreateSubnetRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateSubnetRequestRequestTypeDef = TypedDict(
    "_OptionalCreateSubnetRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "CidrBlock": str,
        "Ipv6CidrBlock": str,
        "OutpostArn": str,
        "DryRun": bool,
        "Ipv6Native": bool,
    },
    total=False,
)


class CreateSubnetRequestRequestTypeDef(
    _RequiredCreateSubnetRequestRequestTypeDef, _OptionalCreateSubnetRequestRequestTypeDef
):
    pass


_RequiredCreateSubnetRequestServiceResourceCreateSubnetTypeDef = TypedDict(
    "_RequiredCreateSubnetRequestServiceResourceCreateSubnetTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateSubnetRequestServiceResourceCreateSubnetTypeDef = TypedDict(
    "_OptionalCreateSubnetRequestServiceResourceCreateSubnetTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "CidrBlock": str,
        "Ipv6CidrBlock": str,
        "OutpostArn": str,
        "DryRun": bool,
        "Ipv6Native": bool,
    },
    total=False,
)


class CreateSubnetRequestServiceResourceCreateSubnetTypeDef(
    _RequiredCreateSubnetRequestServiceResourceCreateSubnetTypeDef,
    _OptionalCreateSubnetRequestServiceResourceCreateSubnetTypeDef,
):
    pass


CreateSubnetRequestVpcCreateSubnetTypeDef = TypedDict(
    "CreateSubnetRequestVpcCreateSubnetTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "CidrBlock": str,
        "Ipv6CidrBlock": str,
        "OutpostArn": str,
        "DryRun": bool,
        "Ipv6Native": bool,
    },
    total=False,
)

CreateTrafficMirrorFilterRequestRequestTypeDef = TypedDict(
    "CreateTrafficMirrorFilterRequestRequestTypeDef",
    {
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)

_RequiredCreateTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTrafficMirrorSessionRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "SessionNumber": int,
    },
)
_OptionalCreateTrafficMirrorSessionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTrafficMirrorSessionRequestRequestTypeDef",
    {
        "PacketLength": int,
        "VirtualNetworkId": int,
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class CreateTrafficMirrorSessionRequestRequestTypeDef(
    _RequiredCreateTrafficMirrorSessionRequestRequestTypeDef,
    _OptionalCreateTrafficMirrorSessionRequestRequestTypeDef,
):
    pass


CreateTrafficMirrorTargetRequestRequestTypeDef = TypedDict(
    "CreateTrafficMirrorTargetRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "ClientToken": str,
        "GatewayLoadBalancerEndpointId": str,
    },
    total=False,
)

_RequiredCreateTransitGatewayConnectPeerRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayConnectPeerRequestRequestTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "PeerAddress": str,
        "InsideCidrBlocks": Sequence[str],
    },
)
_OptionalCreateTransitGatewayConnectPeerRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayConnectPeerRequestRequestTypeDef",
    {
        "TransitGatewayAddress": str,
        "BgpOptions": TransitGatewayConnectRequestBgpOptionsTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayConnectPeerRequestRequestTypeDef(
    _RequiredCreateTransitGatewayConnectPeerRequestRequestTypeDef,
    _OptionalCreateTransitGatewayConnectPeerRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayConnectRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayConnectRequestRequestTypeDef",
    {
        "TransportTransitGatewayAttachmentId": str,
        "Options": CreateTransitGatewayConnectRequestOptionsTypeDef,
    },
)
_OptionalCreateTransitGatewayConnectRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayConnectRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayConnectRequestRequestTypeDef(
    _RequiredCreateTransitGatewayConnectRequestRequestTypeDef,
    _OptionalCreateTransitGatewayConnectRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
    },
)
_OptionalCreateTransitGatewayMulticastDomainRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayMulticastDomainRequestRequestTypeDef",
    {
        "Options": CreateTransitGatewayMulticastDomainRequestOptionsTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayMulticastDomainRequestRequestTypeDef(
    _RequiredCreateTransitGatewayMulticastDomainRequestRequestTypeDef,
    _OptionalCreateTransitGatewayMulticastDomainRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
        "PeerTransitGatewayId": str,
        "PeerAccountId": str,
        "PeerRegion": str,
    },
)
_OptionalCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef",
    {
        "Options": CreateTransitGatewayPeeringAttachmentRequestOptionsTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayPeeringAttachmentRequestRequestTypeDef(
    _RequiredCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef,
    _OptionalCreateTransitGatewayPeeringAttachmentRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
    },
)
_OptionalCreateTransitGatewayPolicyTableRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayPolicyTableRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayPolicyTableRequestRequestTypeDef(
    _RequiredCreateTransitGatewayPolicyTableRequestRequestTypeDef,
    _OptionalCreateTransitGatewayPolicyTableRequestRequestTypeDef,
):
    pass


CreateTransitGatewayRequestRequestTypeDef = TypedDict(
    "CreateTransitGatewayRequestRequestTypeDef",
    {
        "Description": str,
        "Options": TransitGatewayRequestOptionsTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)

_RequiredCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "PeeringAttachmentId": str,
    },
)
_OptionalCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef(
    _RequiredCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef,
    _OptionalCreateTransitGatewayRouteTableAnnouncementRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
    },
)
_OptionalCreateTransitGatewayRouteTableRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayRouteTableRequestRequestTypeDef",
    {
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayRouteTableRequestRequestTypeDef(
    _RequiredCreateTransitGatewayRouteTableRequestRequestTypeDef,
    _OptionalCreateTransitGatewayRouteTableRequestRequestTypeDef,
):
    pass


_RequiredCreateTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_RequiredCreateTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "TransitGatewayId": str,
        "VpcId": str,
        "SubnetIds": Sequence[str],
    },
)
_OptionalCreateTransitGatewayVpcAttachmentRequestRequestTypeDef = TypedDict(
    "_OptionalCreateTransitGatewayVpcAttachmentRequestRequestTypeDef",
    {
        "Options": CreateTransitGatewayVpcAttachmentRequestOptionsTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateTransitGatewayVpcAttachmentRequestRequestTypeDef(
    _RequiredCreateTransitGatewayVpcAttachmentRequestRequestTypeDef,
    _OptionalCreateTransitGatewayVpcAttachmentRequestRequestTypeDef,
):
    pass


_RequiredCreateVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "VerifiedAccessGroupId": str,
        "EndpointType": VerifiedAccessEndpointTypeType,
        "AttachmentType": Literal["vpc"],
        "DomainCertificateArn": str,
        "ApplicationDomain": str,
        "EndpointDomainPrefix": str,
    },
)
_OptionalCreateVerifiedAccessEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVerifiedAccessEndpointRequestRequestTypeDef",
    {
        "SecurityGroupIds": Sequence[str],
        "LoadBalancerOptions": CreateVerifiedAccessEndpointLoadBalancerOptionsTypeDef,
        "NetworkInterfaceOptions": CreateVerifiedAccessEndpointEniOptionsTypeDef,
        "Description": str,
        "PolicyDocument": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateVerifiedAccessEndpointRequestRequestTypeDef(
    _RequiredCreateVerifiedAccessEndpointRequestRequestTypeDef,
    _OptionalCreateVerifiedAccessEndpointRequestRequestTypeDef,
):
    pass


_RequiredCreateVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVerifiedAccessGroupRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
    },
)
_OptionalCreateVerifiedAccessGroupRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVerifiedAccessGroupRequestRequestTypeDef",
    {
        "Description": str,
        "PolicyDocument": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateVerifiedAccessGroupRequestRequestTypeDef(
    _RequiredCreateVerifiedAccessGroupRequestRequestTypeDef,
    _OptionalCreateVerifiedAccessGroupRequestRequestTypeDef,
):
    pass


CreateVerifiedAccessInstanceRequestRequestTypeDef = TypedDict(
    "CreateVerifiedAccessInstanceRequestRequestTypeDef",
    {
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)

_RequiredCreateVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "TrustProviderType": TrustProviderTypeType,
        "PolicyReferenceName": str,
    },
)
_OptionalCreateVerifiedAccessTrustProviderRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVerifiedAccessTrustProviderRequestRequestTypeDef",
    {
        "UserTrustProviderType": UserTrustProviderTypeType,
        "DeviceTrustProviderType": DeviceTrustProviderTypeType,
        "OidcOptions": CreateVerifiedAccessTrustProviderOidcOptionsTypeDef,
        "DeviceOptions": CreateVerifiedAccessTrustProviderDeviceOptionsTypeDef,
        "Description": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "ClientToken": str,
        "DryRun": bool,
    },
    total=False,
)


class CreateVerifiedAccessTrustProviderRequestRequestTypeDef(
    _RequiredCreateVerifiedAccessTrustProviderRequestRequestTypeDef,
    _OptionalCreateVerifiedAccessTrustProviderRequestRequestTypeDef,
):
    pass


_RequiredCreateVolumeRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVolumeRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
    },
)
_OptionalCreateVolumeRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVolumeRequestRequestTypeDef",
    {
        "Encrypted": bool,
        "Iops": int,
        "KmsKeyId": str,
        "OutpostArn": str,
        "Size": int,
        "SnapshotId": str,
        "VolumeType": VolumeTypeType,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "MultiAttachEnabled": bool,
        "Throughput": int,
        "ClientToken": str,
    },
    total=False,
)


class CreateVolumeRequestRequestTypeDef(
    _RequiredCreateVolumeRequestRequestTypeDef, _OptionalCreateVolumeRequestRequestTypeDef
):
    pass


_RequiredCreateVolumeRequestServiceResourceCreateVolumeTypeDef = TypedDict(
    "_RequiredCreateVolumeRequestServiceResourceCreateVolumeTypeDef",
    {
        "AvailabilityZone": str,
    },
)
_OptionalCreateVolumeRequestServiceResourceCreateVolumeTypeDef = TypedDict(
    "_OptionalCreateVolumeRequestServiceResourceCreateVolumeTypeDef",
    {
        "Encrypted": bool,
        "Iops": int,
        "KmsKeyId": str,
        "OutpostArn": str,
        "Size": int,
        "SnapshotId": str,
        "VolumeType": VolumeTypeType,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "MultiAttachEnabled": bool,
        "Throughput": int,
        "ClientToken": str,
    },
    total=False,
)


class CreateVolumeRequestServiceResourceCreateVolumeTypeDef(
    _RequiredCreateVolumeRequestServiceResourceCreateVolumeTypeDef,
    _OptionalCreateVolumeRequestServiceResourceCreateVolumeTypeDef,
):
    pass


_RequiredCreateVpcEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVpcEndpointRequestRequestTypeDef",
    {
        "VpcId": str,
        "ServiceName": str,
    },
)
_OptionalCreateVpcEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVpcEndpointRequestRequestTypeDef",
    {
        "DryRun": bool,
        "VpcEndpointType": VpcEndpointTypeType,
        "PolicyDocument": str,
        "RouteTableIds": Sequence[str],
        "SubnetIds": Sequence[str],
        "SecurityGroupIds": Sequence[str],
        "IpAddressType": IpAddressTypeType,
        "DnsOptions": DnsOptionsSpecificationTypeDef,
        "ClientToken": str,
        "PrivateDnsEnabled": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateVpcEndpointRequestRequestTypeDef(
    _RequiredCreateVpcEndpointRequestRequestTypeDef, _OptionalCreateVpcEndpointRequestRequestTypeDef
):
    pass


CreateVpcEndpointServiceConfigurationRequestRequestTypeDef = TypedDict(
    "CreateVpcEndpointServiceConfigurationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "AcceptanceRequired": bool,
        "PrivateDnsName": str,
        "NetworkLoadBalancerArns": Sequence[str],
        "GatewayLoadBalancerArns": Sequence[str],
        "SupportedIpAddressTypes": Sequence[str],
        "ClientToken": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVpcPeeringConnectionRequestRequestTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateVpcPeeringConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVpcPeeringConnectionRequestRequestTypeDef",
    {
        "DryRun": bool,
        "PeerOwnerId": str,
        "PeerVpcId": str,
        "PeerRegion": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateVpcPeeringConnectionRequestRequestTypeDef(
    _RequiredCreateVpcPeeringConnectionRequestRequestTypeDef,
    _OptionalCreateVpcPeeringConnectionRequestRequestTypeDef,
):
    pass


_RequiredCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef = TypedDict(
    "_RequiredCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef",
    {
        "VpcId": str,
    },
)
_OptionalCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef = TypedDict(
    "_OptionalCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef",
    {
        "DryRun": bool,
        "PeerOwnerId": str,
        "PeerVpcId": str,
        "PeerRegion": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef(
    _RequiredCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef,
    _OptionalCreateVpcPeeringConnectionRequestServiceResourceCreateVpcPeeringConnectionTypeDef,
):
    pass


CreateVpcPeeringConnectionRequestVpcRequestVpcPeeringConnectionTypeDef = TypedDict(
    "CreateVpcPeeringConnectionRequestVpcRequestVpcPeeringConnectionTypeDef",
    {
        "DryRun": bool,
        "PeerOwnerId": str,
        "PeerVpcId": str,
        "PeerRegion": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

CreateVpcRequestRequestTypeDef = TypedDict(
    "CreateVpcRequestRequestTypeDef",
    {
        "CidrBlock": str,
        "AmazonProvidedIpv6CidrBlock": bool,
        "Ipv6Pool": str,
        "Ipv6CidrBlock": str,
        "Ipv4IpamPoolId": str,
        "Ipv4NetmaskLength": int,
        "Ipv6IpamPoolId": str,
        "Ipv6NetmaskLength": int,
        "DryRun": bool,
        "InstanceTenancy": TenancyType,
        "Ipv6CidrBlockNetworkBorderGroup": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

CreateVpcRequestServiceResourceCreateVpcTypeDef = TypedDict(
    "CreateVpcRequestServiceResourceCreateVpcTypeDef",
    {
        "CidrBlock": str,
        "AmazonProvidedIpv6CidrBlock": bool,
        "Ipv6Pool": str,
        "Ipv6CidrBlock": str,
        "Ipv4IpamPoolId": str,
        "Ipv4NetmaskLength": int,
        "Ipv6IpamPoolId": str,
        "Ipv6NetmaskLength": int,
        "DryRun": bool,
        "InstanceTenancy": TenancyType,
        "Ipv6CidrBlockNetworkBorderGroup": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredCreateVpnGatewayRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVpnGatewayRequestRequestTypeDef",
    {
        "Type": Literal["ipsec.1"],
    },
)
_OptionalCreateVpnGatewayRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVpnGatewayRequestRequestTypeDef",
    {
        "AvailabilityZone": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "AmazonSideAsn": int,
        "DryRun": bool,
    },
    total=False,
)


class CreateVpnGatewayRequestRequestTypeDef(
    _RequiredCreateVpnGatewayRequestRequestTypeDef, _OptionalCreateVpnGatewayRequestRequestTypeDef
):
    pass


_RequiredExportImageRequestRequestTypeDef = TypedDict(
    "_RequiredExportImageRequestRequestTypeDef",
    {
        "DiskImageFormat": DiskImageFormatType,
        "ImageId": str,
        "S3ExportLocation": ExportTaskS3LocationRequestTypeDef,
    },
)
_OptionalExportImageRequestRequestTypeDef = TypedDict(
    "_OptionalExportImageRequestRequestTypeDef",
    {
        "ClientToken": str,
        "Description": str,
        "DryRun": bool,
        "RoleName": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class ExportImageRequestRequestTypeDef(
    _RequiredExportImageRequestRequestTypeDef, _OptionalExportImageRequestRequestTypeDef
):
    pass


_RequiredImportKeyPairRequestRequestTypeDef = TypedDict(
    "_RequiredImportKeyPairRequestRequestTypeDef",
    {
        "KeyName": str,
        "PublicKeyMaterial": Union[str, bytes, IO[Any], StreamingBody],
    },
)
_OptionalImportKeyPairRequestRequestTypeDef = TypedDict(
    "_OptionalImportKeyPairRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class ImportKeyPairRequestRequestTypeDef(
    _RequiredImportKeyPairRequestRequestTypeDef, _OptionalImportKeyPairRequestRequestTypeDef
):
    pass


_RequiredImportKeyPairRequestServiceResourceImportKeyPairTypeDef = TypedDict(
    "_RequiredImportKeyPairRequestServiceResourceImportKeyPairTypeDef",
    {
        "KeyName": str,
        "PublicKeyMaterial": Union[str, bytes, IO[Any], StreamingBody],
    },
)
_OptionalImportKeyPairRequestServiceResourceImportKeyPairTypeDef = TypedDict(
    "_OptionalImportKeyPairRequestServiceResourceImportKeyPairTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class ImportKeyPairRequestServiceResourceImportKeyPairTypeDef(
    _RequiredImportKeyPairRequestServiceResourceImportKeyPairTypeDef,
    _OptionalImportKeyPairRequestServiceResourceImportKeyPairTypeDef,
):
    pass


_RequiredProvisionByoipCidrRequestRequestTypeDef = TypedDict(
    "_RequiredProvisionByoipCidrRequestRequestTypeDef",
    {
        "Cidr": str,
    },
)
_OptionalProvisionByoipCidrRequestRequestTypeDef = TypedDict(
    "_OptionalProvisionByoipCidrRequestRequestTypeDef",
    {
        "CidrAuthorizationContext": CidrAuthorizationContextTypeDef,
        "PubliclyAdvertisable": bool,
        "Description": str,
        "DryRun": bool,
        "PoolTagSpecifications": Sequence[TagSpecificationTypeDef],
        "MultiRegion": bool,
    },
    total=False,
)


class ProvisionByoipCidrRequestRequestTypeDef(
    _RequiredProvisionByoipCidrRequestRequestTypeDef,
    _OptionalProvisionByoipCidrRequestRequestTypeDef,
):
    pass


_RequiredPurchaseHostReservationRequestRequestTypeDef = TypedDict(
    "_RequiredPurchaseHostReservationRequestRequestTypeDef",
    {
        "HostIdSet": Sequence[str],
        "OfferingId": str,
    },
)
_OptionalPurchaseHostReservationRequestRequestTypeDef = TypedDict(
    "_OptionalPurchaseHostReservationRequestRequestTypeDef",
    {
        "ClientToken": str,
        "CurrencyCode": Literal["USD"],
        "LimitPrice": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class PurchaseHostReservationRequestRequestTypeDef(
    _RequiredPurchaseHostReservationRequestRequestTypeDef,
    _OptionalPurchaseHostReservationRequestRequestTypeDef,
):
    pass


_RequiredStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef = TypedDict(
    "_RequiredStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
        "ClientToken": str,
    },
)
_OptionalStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef = TypedDict(
    "_OptionalStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef",
    {
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class StartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef(
    _RequiredStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef,
    _OptionalStartNetworkInsightsAccessScopeAnalysisRequestRequestTypeDef,
):
    pass


_RequiredStartNetworkInsightsAnalysisRequestRequestTypeDef = TypedDict(
    "_RequiredStartNetworkInsightsAnalysisRequestRequestTypeDef",
    {
        "NetworkInsightsPathId": str,
        "ClientToken": str,
    },
)
_OptionalStartNetworkInsightsAnalysisRequestRequestTypeDef = TypedDict(
    "_OptionalStartNetworkInsightsAnalysisRequestRequestTypeDef",
    {
        "AdditionalAccounts": Sequence[str],
        "FilterInArns": Sequence[str],
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class StartNetworkInsightsAnalysisRequestRequestTypeDef(
    _RequiredStartNetworkInsightsAnalysisRequestRequestTypeDef,
    _OptionalStartNetworkInsightsAnalysisRequestRequestTypeDef,
):
    pass


ClientVpnEndpointOutputTypeDef = TypedDict(
    "ClientVpnEndpointOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "Status": ClientVpnEndpointStatusOutputTypeDef,
        "CreationTime": str,
        "DeletionTime": str,
        "DnsName": str,
        "ClientCidrBlock": str,
        "DnsServers": List[str],
        "SplitTunnel": bool,
        "VpnProtocol": Literal["openvpn"],
        "TransportProtocol": TransportProtocolType,
        "VpnPort": int,
        "AssociatedTargetNetworks": List[AssociatedTargetNetworkOutputTypeDef],
        "ServerCertificateArn": str,
        "AuthenticationOptions": List[ClientVpnAuthenticationOutputTypeDef],
        "ConnectionLogOptions": ConnectionLogResponseOptionsOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "SecurityGroupIds": List[str],
        "VpcId": str,
        "SelfServicePortalUrl": str,
        "ClientConnectOptions": ClientConnectResponseOptionsOutputTypeDef,
        "SessionTimeoutHours": int,
        "ClientLoginBannerOptions": ClientLoginBannerResponseOptionsOutputTypeDef,
    },
)

_RequiredCreateClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_RequiredCreateClientVpnEndpointRequestRequestTypeDef",
    {
        "ClientCidrBlock": str,
        "ServerCertificateArn": str,
        "AuthenticationOptions": Sequence[ClientVpnAuthenticationRequestTypeDef],
        "ConnectionLogOptions": ConnectionLogOptionsTypeDef,
    },
)
_OptionalCreateClientVpnEndpointRequestRequestTypeDef = TypedDict(
    "_OptionalCreateClientVpnEndpointRequestRequestTypeDef",
    {
        "DnsServers": Sequence[str],
        "TransportProtocol": TransportProtocolType,
        "VpnPort": int,
        "Description": str,
        "SplitTunnel": bool,
        "DryRun": bool,
        "ClientToken": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "SecurityGroupIds": Sequence[str],
        "VpcId": str,
        "SelfServicePortal": SelfServicePortalType,
        "ClientConnectOptions": ClientConnectOptionsTypeDef,
        "SessionTimeoutHours": int,
        "ClientLoginBannerOptions": ClientLoginBannerOptionsTypeDef,
    },
    total=False,
)


class CreateClientVpnEndpointRequestRequestTypeDef(
    _RequiredCreateClientVpnEndpointRequestRequestTypeDef,
    _OptionalCreateClientVpnEndpointRequestRequestTypeDef,
):
    pass


DescribeClientVpnConnectionsResultOutputTypeDef = TypedDict(
    "DescribeClientVpnConnectionsResultOutputTypeDef",
    {
        "Connections": List[ClientVpnConnectionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TerminateClientVpnConnectionsResultOutputTypeDef = TypedDict(
    "TerminateClientVpnConnectionsResultOutputTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Username": str,
        "ConnectionStatuses": List[TerminateConnectionStatusOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeClientVpnRoutesResultOutputTypeDef = TypedDict(
    "DescribeClientVpnRoutesResultOutputTypeDef",
    {
        "Routes": List[ClientVpnRouteOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TunnelOptionOutputTypeDef = TypedDict(
    "TunnelOptionOutputTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "TunnelInsideIpv6Cidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "DpdTimeoutAction": str,
        "Phase1EncryptionAlgorithms": List[Phase1EncryptionAlgorithmsListValueOutputTypeDef],
        "Phase2EncryptionAlgorithms": List[Phase2EncryptionAlgorithmsListValueOutputTypeDef],
        "Phase1IntegrityAlgorithms": List[Phase1IntegrityAlgorithmsListValueOutputTypeDef],
        "Phase2IntegrityAlgorithms": List[Phase2IntegrityAlgorithmsListValueOutputTypeDef],
        "Phase1DHGroupNumbers": List[Phase1DHGroupNumbersListValueOutputTypeDef],
        "Phase2DHGroupNumbers": List[Phase2DHGroupNumbersListValueOutputTypeDef],
        "IkeVersions": List[IKEVersionsListValueOutputTypeDef],
        "StartupAction": str,
        "LogOptions": VpnTunnelLogOptionsOutputTypeDef,
        "EnableTunnelLifecycleControl": bool,
    },
)

ModifyVpnTunnelOptionsSpecificationTypeDef = TypedDict(
    "ModifyVpnTunnelOptionsSpecificationTypeDef",
    {
        "TunnelInsideCidr": str,
        "TunnelInsideIpv6Cidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "DPDTimeoutAction": str,
        "Phase1EncryptionAlgorithms": Sequence[Phase1EncryptionAlgorithmsRequestListValueTypeDef],
        "Phase2EncryptionAlgorithms": Sequence[Phase2EncryptionAlgorithmsRequestListValueTypeDef],
        "Phase1IntegrityAlgorithms": Sequence[Phase1IntegrityAlgorithmsRequestListValueTypeDef],
        "Phase2IntegrityAlgorithms": Sequence[Phase2IntegrityAlgorithmsRequestListValueTypeDef],
        "Phase1DHGroupNumbers": Sequence[Phase1DHGroupNumbersRequestListValueTypeDef],
        "Phase2DHGroupNumbers": Sequence[Phase2DHGroupNumbersRequestListValueTypeDef],
        "IKEVersions": Sequence[IKEVersionsRequestListValueTypeDef],
        "StartupAction": str,
        "LogOptions": VpnTunnelLogOptionsSpecificationTypeDef,
        "EnableTunnelLifecycleControl": bool,
    },
    total=False,
)

VpnTunnelOptionsSpecificationTypeDef = TypedDict(
    "VpnTunnelOptionsSpecificationTypeDef",
    {
        "TunnelInsideCidr": str,
        "TunnelInsideIpv6Cidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "DPDTimeoutAction": str,
        "Phase1EncryptionAlgorithms": Sequence[Phase1EncryptionAlgorithmsRequestListValueTypeDef],
        "Phase2EncryptionAlgorithms": Sequence[Phase2EncryptionAlgorithmsRequestListValueTypeDef],
        "Phase1IntegrityAlgorithms": Sequence[Phase1IntegrityAlgorithmsRequestListValueTypeDef],
        "Phase2IntegrityAlgorithms": Sequence[Phase2IntegrityAlgorithmsRequestListValueTypeDef],
        "Phase1DHGroupNumbers": Sequence[Phase1DHGroupNumbersRequestListValueTypeDef],
        "Phase2DHGroupNumbers": Sequence[Phase2DHGroupNumbersRequestListValueTypeDef],
        "IKEVersions": Sequence[IKEVersionsRequestListValueTypeDef],
        "StartupAction": str,
        "LogOptions": VpnTunnelLogOptionsSpecificationTypeDef,
        "EnableTunnelLifecycleControl": bool,
    },
    total=False,
)

RequestSpotLaunchSpecificationTypeDef = TypedDict(
    "RequestSpotLaunchSpecificationTypeDef",
    {
        "SecurityGroupIds": Sequence[str],
        "SecurityGroups": Sequence[str],
        "AddressingType": str,
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": RunInstancesMonitoringEnabledTypeDef,
        "NetworkInterfaces": Sequence[InstanceNetworkInterfaceSpecificationTypeDef],
        "Placement": SpotPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)

_RequiredModifySnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifySnapshotAttributeRequestRequestTypeDef",
    {
        "SnapshotId": str,
    },
)
_OptionalModifySnapshotAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifySnapshotAttributeRequestRequestTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
        "CreateVolumePermission": CreateVolumePermissionModificationsTypeDef,
        "GroupNames": Sequence[str],
        "OperationType": OperationTypeType,
        "UserIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)


class ModifySnapshotAttributeRequestRequestTypeDef(
    _RequiredModifySnapshotAttributeRequestRequestTypeDef,
    _OptionalModifySnapshotAttributeRequestRequestTypeDef,
):
    pass


ModifySnapshotAttributeRequestSnapshotModifyAttributeTypeDef = TypedDict(
    "ModifySnapshotAttributeRequestSnapshotModifyAttributeTypeDef",
    {
        "Attribute": SnapshotAttributeNameType,
        "CreateVolumePermission": CreateVolumePermissionModificationsTypeDef,
        "GroupNames": Sequence[str],
        "OperationType": OperationTypeType,
        "UserIds": Sequence[str],
        "DryRun": bool,
    },
    total=False,
)

GetAwsNetworkPerformanceDataResultOutputTypeDef = TypedDict(
    "GetAwsNetworkPerformanceDataResultOutputTypeDef",
    {
        "DataResponses": List[DataResponseOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteFleetsResultOutputTypeDef = TypedDict(
    "DeleteFleetsResultOutputTypeDef",
    {
        "SuccessfulFleetDeletions": List[DeleteFleetSuccessItemOutputTypeDef],
        "UnsuccessfulFleetDeletions": List[DeleteFleetErrorItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLaunchTemplateVersionsResultOutputTypeDef = TypedDict(
    "DeleteLaunchTemplateVersionsResultOutputTypeDef",
    {
        "SuccessfullyDeletedLaunchTemplateVersions": List[
            DeleteLaunchTemplateVersionsResponseSuccessItemOutputTypeDef
        ],
        "UnsuccessfullyDeletedLaunchTemplateVersions": List[
            DeleteLaunchTemplateVersionsResponseErrorItemOutputTypeDef
        ],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteQueuedReservedInstancesResultOutputTypeDef = TypedDict(
    "DeleteQueuedReservedInstancesResultOutputTypeDef",
    {
        "SuccessfulQueuedPurchaseDeletions": List[SuccessfulQueuedPurchaseDeletionOutputTypeDef],
        "FailedQueuedPurchaseDeletions": List[FailedQueuedPurchaseDeletionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribePrincipalIdFormatResultOutputTypeDef = TypedDict(
    "DescribePrincipalIdFormatResultOutputTypeDef",
    {
        "Principals": List[PrincipalIdFormatOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeFastLaunchImagesResultOutputTypeDef = TypedDict(
    "DescribeFastLaunchImagesResultOutputTypeDef",
    {
        "FastLaunchImages": List[DescribeFastLaunchImagesSuccessItemOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeFlowLogsResultOutputTypeDef = TypedDict(
    "DescribeFlowLogsResultOutputTypeDef",
    {
        "FlowLogs": List[FlowLogOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisableFastSnapshotRestoreErrorItemOutputTypeDef = TypedDict(
    "DisableFastSnapshotRestoreErrorItemOutputTypeDef",
    {
        "SnapshotId": str,
        "FastSnapshotRestoreStateErrors": List[
            DisableFastSnapshotRestoreStateErrorItemOutputTypeDef
        ],
    },
)

ImportInstanceTaskDetailsOutputTypeDef = TypedDict(
    "ImportInstanceTaskDetailsOutputTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": Literal["Windows"],
        "Volumes": List[ImportInstanceVolumeDetailItemOutputTypeDef],
    },
)

DescribeVpcEndpointConnectionsResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointConnectionsResultOutputTypeDef",
    {
        "VpcEndpointConnections": List[VpcEndpointConnectionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceAttributeOutputTypeDef = TypedDict(
    "InstanceAttributeOutputTypeDef",
    {
        "Groups": List[GroupIdentifierOutputTypeDef],
        "BlockDeviceMappings": List[InstanceBlockDeviceMappingOutputTypeDef],
        "DisableApiTermination": AttributeBooleanValueOutputTypeDef,
        "EnaSupport": AttributeBooleanValueOutputTypeDef,
        "EnclaveOptions": EnclaveOptionsOutputTypeDef,
        "EbsOptimized": AttributeBooleanValueOutputTypeDef,
        "InstanceId": str,
        "InstanceInitiatedShutdownBehavior": AttributeValueOutputTypeDef,
        "InstanceType": AttributeValueOutputTypeDef,
        "KernelId": AttributeValueOutputTypeDef,
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "RamdiskId": AttributeValueOutputTypeDef,
        "RootDeviceName": AttributeValueOutputTypeDef,
        "SourceDestCheck": AttributeBooleanValueOutputTypeDef,
        "SriovNetSupport": AttributeValueOutputTypeDef,
        "UserData": AttributeValueOutputTypeDef,
        "DisableApiStop": AttributeBooleanValueOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyInstanceAttributeRequestInstanceModifyAttributeTypeDef = TypedDict(
    "ModifyInstanceAttributeRequestInstanceModifyAttributeTypeDef",
    {
        "SourceDestCheck": AttributeBooleanValueTypeDef,
        "Attribute": InstanceAttributeNameType,
        "BlockDeviceMappings": Sequence[InstanceBlockDeviceMappingSpecificationTypeDef],
        "DisableApiTermination": AttributeBooleanValueTypeDef,
        "DryRun": bool,
        "EbsOptimized": AttributeBooleanValueTypeDef,
        "EnaSupport": AttributeBooleanValueTypeDef,
        "Groups": Sequence[str],
        "InstanceInitiatedShutdownBehavior": AttributeValueTypeDef,
        "InstanceType": AttributeValueTypeDef,
        "Kernel": AttributeValueTypeDef,
        "Ramdisk": AttributeValueTypeDef,
        "SriovNetSupport": AttributeValueTypeDef,
        "UserData": BlobAttributeValueTypeDef,
        "Value": str,
        "DisableApiStop": AttributeBooleanValueTypeDef,
    },
    total=False,
)

_RequiredModifyInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyInstanceAttributeRequestRequestTypeDef",
    {
        "InstanceId": str,
    },
)
_OptionalModifyInstanceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyInstanceAttributeRequestRequestTypeDef",
    {
        "SourceDestCheck": AttributeBooleanValueTypeDef,
        "Attribute": InstanceAttributeNameType,
        "BlockDeviceMappings": Sequence[InstanceBlockDeviceMappingSpecificationTypeDef],
        "DisableApiTermination": AttributeBooleanValueTypeDef,
        "DryRun": bool,
        "EbsOptimized": AttributeBooleanValueTypeDef,
        "EnaSupport": AttributeBooleanValueTypeDef,
        "Groups": Sequence[str],
        "InstanceInitiatedShutdownBehavior": AttributeValueTypeDef,
        "InstanceType": AttributeValueTypeDef,
        "Kernel": AttributeValueTypeDef,
        "Ramdisk": AttributeValueTypeDef,
        "SriovNetSupport": AttributeValueTypeDef,
        "UserData": BlobAttributeValueTypeDef,
        "Value": str,
        "DisableApiStop": AttributeBooleanValueTypeDef,
    },
    total=False,
)


class ModifyInstanceAttributeRequestRequestTypeDef(
    _RequiredModifyInstanceAttributeRequestRequestTypeDef,
    _OptionalModifyInstanceAttributeRequestRequestTypeDef,
):
    pass


CreateEgressOnlyInternetGatewayResultOutputTypeDef = TypedDict(
    "CreateEgressOnlyInternetGatewayResultOutputTypeDef",
    {
        "ClientToken": str,
        "EgressOnlyInternetGateway": EgressOnlyInternetGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeEgressOnlyInternetGatewaysResultOutputTypeDef = TypedDict(
    "DescribeEgressOnlyInternetGatewaysResultOutputTypeDef",
    {
        "EgressOnlyInternetGateways": List[EgressOnlyInternetGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateInternetGatewayResultOutputTypeDef = TypedDict(
    "CreateInternetGatewayResultOutputTypeDef",
    {
        "InternetGateway": InternetGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInternetGatewaysResultOutputTypeDef = TypedDict(
    "DescribeInternetGatewaysResultOutputTypeDef",
    {
        "InternetGateways": List[InternetGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeElasticGpusResultOutputTypeDef = TypedDict(
    "DescribeElasticGpusResultOutputTypeDef",
    {
        "ElasticGpuSet": List[ElasticGpusOutputTypeDef],
        "MaxResults": int,
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef = TypedDict(
    "_RequiredAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef",
    {
        "DeviceIndex": int,
        "InstanceId": str,
    },
)
_OptionalAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef = TypedDict(
    "_OptionalAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef",
    {
        "DryRun": bool,
        "NetworkCardIndex": int,
        "EnaSrdSpecification": EnaSrdSpecificationTypeDef,
    },
    total=False,
)


class AttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef(
    _RequiredAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef,
    _OptionalAttachNetworkInterfaceRequestNetworkInterfaceAttachTypeDef,
):
    pass


_RequiredAttachNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_RequiredAttachNetworkInterfaceRequestRequestTypeDef",
    {
        "DeviceIndex": int,
        "InstanceId": str,
        "NetworkInterfaceId": str,
    },
)
_OptionalAttachNetworkInterfaceRequestRequestTypeDef = TypedDict(
    "_OptionalAttachNetworkInterfaceRequestRequestTypeDef",
    {
        "DryRun": bool,
        "NetworkCardIndex": int,
        "EnaSrdSpecification": EnaSrdSpecificationTypeDef,
    },
    total=False,
)


class AttachNetworkInterfaceRequestRequestTypeDef(
    _RequiredAttachNetworkInterfaceRequestRequestTypeDef,
    _OptionalAttachNetworkInterfaceRequestRequestTypeDef,
):
    pass


ModifyNetworkInterfaceAttributeRequestNetworkInterfaceModifyAttributeTypeDef = TypedDict(
    "ModifyNetworkInterfaceAttributeRequestNetworkInterfaceModifyAttributeTypeDef",
    {
        "Attachment": NetworkInterfaceAttachmentChangesTypeDef,
        "Description": AttributeValueTypeDef,
        "DryRun": bool,
        "Groups": Sequence[str],
        "SourceDestCheck": AttributeBooleanValueTypeDef,
        "EnaSrdSpecification": EnaSrdSpecificationTypeDef,
    },
    total=False,
)

_RequiredModifyNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "NetworkInterfaceId": str,
    },
)
_OptionalModifyNetworkInterfaceAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyNetworkInterfaceAttributeRequestRequestTypeDef",
    {
        "Attachment": NetworkInterfaceAttachmentChangesTypeDef,
        "Description": AttributeValueTypeDef,
        "DryRun": bool,
        "Groups": Sequence[str],
        "SourceDestCheck": AttributeBooleanValueTypeDef,
        "EnaSrdSpecification": EnaSrdSpecificationTypeDef,
    },
    total=False,
)


class ModifyNetworkInterfaceAttributeRequestRequestTypeDef(
    _RequiredModifyNetworkInterfaceAttributeRequestRequestTypeDef,
    _OptionalModifyNetworkInterfaceAttributeRequestRequestTypeDef,
):
    pass


EnableFastSnapshotRestoreErrorItemOutputTypeDef = TypedDict(
    "EnableFastSnapshotRestoreErrorItemOutputTypeDef",
    {
        "SnapshotId": str,
        "FastSnapshotRestoreStateErrors": List[
            EnableFastSnapshotRestoreStateErrorItemOutputTypeDef
        ],
    },
)

DescribeFleetHistoryResultOutputTypeDef = TypedDict(
    "DescribeFleetHistoryResultOutputTypeDef",
    {
        "HistoryRecords": List[HistoryRecordEntryOutputTypeDef],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "FleetId": str,
        "StartTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotFleetRequestHistoryResponseOutputTypeDef = TypedDict(
    "DescribeSpotFleetRequestHistoryResponseOutputTypeDef",
    {
        "HistoryRecords": List[HistoryRecordOutputTypeDef],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "SpotFleetRequestId": str,
        "StartTime": datetime,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeExportImageTasksResultOutputTypeDef = TypedDict(
    "DescribeExportImageTasksResultOutputTypeDef",
    {
        "ExportImageTasks": List[ExportImageTaskOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateInstanceExportTaskResultOutputTypeDef = TypedDict(
    "CreateInstanceExportTaskResultOutputTypeDef",
    {
        "ExportTask": ExportTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeExportTasksResultOutputTypeDef = TypedDict(
    "DescribeExportTasksResultOutputTypeDef",
    {
        "ExportTasks": List[ExportTaskOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NetworkInsightsPathOutputTypeDef = TypedDict(
    "NetworkInsightsPathOutputTypeDef",
    {
        "NetworkInsightsPathId": str,
        "NetworkInsightsPathArn": str,
        "CreatedDate": datetime,
        "Source": str,
        "Destination": str,
        "SourceArn": str,
        "DestinationArn": str,
        "SourceIp": str,
        "DestinationIp": str,
        "Protocol": ProtocolType,
        "DestinationPort": int,
        "Tags": List[TagOutputTypeDef],
        "FilterAtSource": PathFilterOutputTypeDef,
        "FilterAtDestination": PathFilterOutputTypeDef,
    },
)

SpotOptionsOutputTypeDef = TypedDict(
    "SpotOptionsOutputTypeDef",
    {
        "AllocationStrategy": SpotAllocationStrategyType,
        "MaintenanceStrategies": FleetSpotMaintenanceStrategiesOutputTypeDef,
        "InstanceInterruptionBehavior": SpotInstanceInterruptionBehaviorType,
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
)

SpotOptionsRequestTypeDef = TypedDict(
    "SpotOptionsRequestTypeDef",
    {
        "AllocationStrategy": SpotAllocationStrategyType,
        "MaintenanceStrategies": FleetSpotMaintenanceStrategiesRequestTypeDef,
        "InstanceInterruptionBehavior": SpotInstanceInterruptionBehaviorType,
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)

FpgaInfoOutputTypeDef = TypedDict(
    "FpgaInfoOutputTypeDef",
    {
        "Fpgas": List[FpgaDeviceInfoOutputTypeDef],
        "TotalFpgaMemoryInMiB": int,
    },
)

DescribeFpgaImageAttributeResultOutputTypeDef = TypedDict(
    "DescribeFpgaImageAttributeResultOutputTypeDef",
    {
        "FpgaImageAttribute": FpgaImageAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyFpgaImageAttributeResultOutputTypeDef = TypedDict(
    "ModifyFpgaImageAttributeResultOutputTypeDef",
    {
        "FpgaImageAttribute": FpgaImageAttributeOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeFpgaImagesResultOutputTypeDef = TypedDict(
    "DescribeFpgaImagesResultOutputTypeDef",
    {
        "FpgaImages": List[FpgaImageOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GpuInfoOutputTypeDef = TypedDict(
    "GpuInfoOutputTypeDef",
    {
        "Gpus": List[GpuDeviceInfoOutputTypeDef],
        "TotalGpuMemoryInMiB": int,
    },
)

AssociateIamInstanceProfileResultOutputTypeDef = TypedDict(
    "AssociateIamInstanceProfileResultOutputTypeDef",
    {
        "IamInstanceProfileAssociation": IamInstanceProfileAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIamInstanceProfileAssociationsResultOutputTypeDef = TypedDict(
    "DescribeIamInstanceProfileAssociationsResultOutputTypeDef",
    {
        "IamInstanceProfileAssociations": List[IamInstanceProfileAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateIamInstanceProfileResultOutputTypeDef = TypedDict(
    "DisassociateIamInstanceProfileResultOutputTypeDef",
    {
        "IamInstanceProfileAssociation": IamInstanceProfileAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReplaceIamInstanceProfileAssociationResultOutputTypeDef = TypedDict(
    "ReplaceIamInstanceProfileAssociationResultOutputTypeDef",
    {
        "IamInstanceProfileAssociation": IamInstanceProfileAssociationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NetworkAclOutputTypeDef = TypedDict(
    "NetworkAclOutputTypeDef",
    {
        "Associations": List[NetworkAclAssociationOutputTypeDef],
        "Entries": List[NetworkAclEntryOutputTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[TagOutputTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
)

ImportImageRequestRequestTypeDef = TypedDict(
    "ImportImageRequestRequestTypeDef",
    {
        "Architecture": str,
        "ClientData": ClientDataTypeDef,
        "ClientToken": str,
        "Description": str,
        "DiskContainers": Sequence[ImageDiskContainerTypeDef],
        "DryRun": bool,
        "Encrypted": bool,
        "Hypervisor": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "RoleName": str,
        "LicenseSpecifications": Sequence[ImportImageLicenseConfigurationRequestTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "UsageOperation": str,
        "BootMode": BootModeValuesType,
    },
    total=False,
)

ImportSnapshotRequestRequestTypeDef = TypedDict(
    "ImportSnapshotRequestRequestTypeDef",
    {
        "ClientData": ClientDataTypeDef,
        "ClientToken": str,
        "Description": str,
        "DiskContainer": SnapshotDiskContainerTypeDef,
        "DryRun": bool,
        "Encrypted": bool,
        "KmsKeyId": str,
        "RoleName": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

CreateLocalGatewayRouteTableResultOutputTypeDef = TypedDict(
    "CreateLocalGatewayRouteTableResultOutputTypeDef",
    {
        "LocalGatewayRouteTable": LocalGatewayRouteTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteLocalGatewayRouteTableResultOutputTypeDef = TypedDict(
    "DeleteLocalGatewayRouteTableResultOutputTypeDef",
    {
        "LocalGatewayRouteTable": LocalGatewayRouteTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLocalGatewayRouteTablesResultOutputTypeDef = TypedDict(
    "DescribeLocalGatewayRouteTablesResultOutputTypeDef",
    {
        "LocalGatewayRouteTables": List[LocalGatewayRouteTableOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredImportInstanceRequestRequestTypeDef = TypedDict(
    "_RequiredImportInstanceRequestRequestTypeDef",
    {
        "Platform": Literal["Windows"],
    },
)
_OptionalImportInstanceRequestRequestTypeDef = TypedDict(
    "_OptionalImportInstanceRequestRequestTypeDef",
    {
        "Description": str,
        "DiskImages": Sequence[DiskImageTypeDef],
        "DryRun": bool,
        "LaunchSpecification": ImportInstanceLaunchSpecificationTypeDef,
    },
    total=False,
)


class ImportInstanceRequestRequestTypeDef(
    _RequiredImportInstanceRequestRequestTypeDef, _OptionalImportInstanceRequestRequestTypeDef
):
    pass


_RequiredRunInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredRunInstancesRequestRequestTypeDef",
    {
        "MaxCount": int,
        "MinCount": int,
    },
)
_OptionalRunInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalRunInstancesRequestRequestTypeDef",
    {
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": RunInstancesMonitoringEnabledTypeDef,
        "Placement": PlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": Sequence[str],
        "SecurityGroups": Sequence[str],
        "SubnetId": str,
        "UserData": str,
        "AdditionalInfo": str,
        "ClientToken": str,
        "DisableApiTermination": bool,
        "DryRun": bool,
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "NetworkInterfaces": Sequence[InstanceNetworkInterfaceSpecificationTypeDef],
        "PrivateIpAddress": str,
        "ElasticGpuSpecification": Sequence[ElasticGpuSpecificationTypeDef],
        "ElasticInferenceAccelerators": Sequence[ElasticInferenceAcceleratorTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "LaunchTemplate": LaunchTemplateSpecificationTypeDef,
        "InstanceMarketOptions": InstanceMarketOptionsRequestTypeDef,
        "CreditSpecification": CreditSpecificationRequestTypeDef,
        "CpuOptions": CpuOptionsRequestTypeDef,
        "CapacityReservationSpecification": CapacityReservationSpecificationTypeDef,
        "HibernationOptions": HibernationOptionsRequestTypeDef,
        "LicenseSpecifications": Sequence[LicenseConfigurationRequestTypeDef],
        "MetadataOptions": InstanceMetadataOptionsRequestTypeDef,
        "EnclaveOptions": EnclaveOptionsRequestTypeDef,
        "PrivateDnsNameOptions": PrivateDnsNameOptionsRequestTypeDef,
        "MaintenanceOptions": InstanceMaintenanceOptionsRequestTypeDef,
        "DisableApiStop": bool,
    },
    total=False,
)


class RunInstancesRequestRequestTypeDef(
    _RequiredRunInstancesRequestRequestTypeDef, _OptionalRunInstancesRequestRequestTypeDef
):
    pass


_RequiredRunInstancesRequestServiceResourceCreateInstancesTypeDef = TypedDict(
    "_RequiredRunInstancesRequestServiceResourceCreateInstancesTypeDef",
    {
        "MaxCount": int,
        "MinCount": int,
    },
)
_OptionalRunInstancesRequestServiceResourceCreateInstancesTypeDef = TypedDict(
    "_OptionalRunInstancesRequestServiceResourceCreateInstancesTypeDef",
    {
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": RunInstancesMonitoringEnabledTypeDef,
        "Placement": PlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": Sequence[str],
        "SecurityGroups": Sequence[str],
        "SubnetId": str,
        "UserData": str,
        "AdditionalInfo": str,
        "ClientToken": str,
        "DisableApiTermination": bool,
        "DryRun": bool,
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "NetworkInterfaces": Sequence[InstanceNetworkInterfaceSpecificationTypeDef],
        "PrivateIpAddress": str,
        "ElasticGpuSpecification": Sequence[ElasticGpuSpecificationTypeDef],
        "ElasticInferenceAccelerators": Sequence[ElasticInferenceAcceleratorTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "LaunchTemplate": LaunchTemplateSpecificationTypeDef,
        "InstanceMarketOptions": InstanceMarketOptionsRequestTypeDef,
        "CreditSpecification": CreditSpecificationRequestTypeDef,
        "CpuOptions": CpuOptionsRequestTypeDef,
        "CapacityReservationSpecification": CapacityReservationSpecificationTypeDef,
        "HibernationOptions": HibernationOptionsRequestTypeDef,
        "LicenseSpecifications": Sequence[LicenseConfigurationRequestTypeDef],
        "MetadataOptions": InstanceMetadataOptionsRequestTypeDef,
        "EnclaveOptions": EnclaveOptionsRequestTypeDef,
        "PrivateDnsNameOptions": PrivateDnsNameOptionsRequestTypeDef,
        "MaintenanceOptions": InstanceMaintenanceOptionsRequestTypeDef,
        "DisableApiStop": bool,
    },
    total=False,
)


class RunInstancesRequestServiceResourceCreateInstancesTypeDef(
    _RequiredRunInstancesRequestServiceResourceCreateInstancesTypeDef,
    _OptionalRunInstancesRequestServiceResourceCreateInstancesTypeDef,
):
    pass


_RequiredRunInstancesRequestSubnetCreateInstancesTypeDef = TypedDict(
    "_RequiredRunInstancesRequestSubnetCreateInstancesTypeDef",
    {
        "MaxCount": int,
        "MinCount": int,
    },
)
_OptionalRunInstancesRequestSubnetCreateInstancesTypeDef = TypedDict(
    "_OptionalRunInstancesRequestSubnetCreateInstancesTypeDef",
    {
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": Sequence[InstanceIpv6AddressTypeDef],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": RunInstancesMonitoringEnabledTypeDef,
        "Placement": PlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": Sequence[str],
        "SecurityGroups": Sequence[str],
        "UserData": str,
        "AdditionalInfo": str,
        "ClientToken": str,
        "DisableApiTermination": bool,
        "DryRun": bool,
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "NetworkInterfaces": Sequence[InstanceNetworkInterfaceSpecificationTypeDef],
        "PrivateIpAddress": str,
        "ElasticGpuSpecification": Sequence[ElasticGpuSpecificationTypeDef],
        "ElasticInferenceAccelerators": Sequence[ElasticInferenceAcceleratorTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "LaunchTemplate": LaunchTemplateSpecificationTypeDef,
        "InstanceMarketOptions": InstanceMarketOptionsRequestTypeDef,
        "CreditSpecification": CreditSpecificationRequestTypeDef,
        "CpuOptions": CpuOptionsRequestTypeDef,
        "CapacityReservationSpecification": CapacityReservationSpecificationTypeDef,
        "HibernationOptions": HibernationOptionsRequestTypeDef,
        "LicenseSpecifications": Sequence[LicenseConfigurationRequestTypeDef],
        "MetadataOptions": InstanceMetadataOptionsRequestTypeDef,
        "EnclaveOptions": EnclaveOptionsRequestTypeDef,
        "PrivateDnsNameOptions": PrivateDnsNameOptionsRequestTypeDef,
        "MaintenanceOptions": InstanceMaintenanceOptionsRequestTypeDef,
        "DisableApiStop": bool,
    },
    total=False,
)


class RunInstancesRequestSubnetCreateInstancesTypeDef(
    _RequiredRunInstancesRequestSubnetCreateInstancesTypeDef,
    _OptionalRunInstancesRequestSubnetCreateInstancesTypeDef,
):
    pass


MonitorInstancesResultOutputTypeDef = TypedDict(
    "MonitorInstancesResultOutputTypeDef",
    {
        "InstanceMonitorings": List[InstanceMonitoringOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

UnmonitorInstancesResultOutputTypeDef = TypedDict(
    "UnmonitorInstancesResultOutputTypeDef",
    {
        "InstanceMonitorings": List[InstanceMonitoringOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceNetworkInterfaceOutputTypeDef = TypedDict(
    "InstanceNetworkInterfaceOutputTypeDef",
    {
        "Association": InstanceNetworkInterfaceAssociationOutputTypeDef,
        "Attachment": InstanceNetworkInterfaceAttachmentOutputTypeDef,
        "Description": str,
        "Groups": List[GroupIdentifierOutputTypeDef],
        "Ipv6Addresses": List[InstanceIpv6AddressOutputTypeDef],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[InstancePrivateIpAddressOutputTypeDef],
        "SourceDestCheck": bool,
        "Status": NetworkInterfaceStatusType,
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
        "Ipv4Prefixes": List[InstanceIpv4PrefixOutputTypeDef],
        "Ipv6Prefixes": List[InstanceIpv6PrefixOutputTypeDef],
    },
)

LaunchSpecificationOutputTypeDef = TypedDict(
    "LaunchSpecificationOutputTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[GroupIdentifierOutputTypeDef],
        "AddressingType": str,
        "BlockDeviceMappings": List[BlockDeviceMappingOutputTypeDef],
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationOutputTypeDef,
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[InstanceNetworkInterfaceSpecificationOutputTypeDef],
        "Placement": SpotPlacementOutputTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": RunInstancesMonitoringEnabledOutputTypeDef,
    },
)

StartInstancesResultOutputTypeDef = TypedDict(
    "StartInstancesResultOutputTypeDef",
    {
        "StartingInstances": List[InstanceStateChangeOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StopInstancesResultOutputTypeDef = TypedDict(
    "StopInstancesResultOutputTypeDef",
    {
        "StoppingInstances": List[InstanceStateChangeOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TerminateInstancesResultOutputTypeDef = TypedDict(
    "TerminateInstancesResultOutputTypeDef",
    {
        "TerminatingInstances": List[InstanceStateChangeOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

FleetLaunchTemplateOverridesOutputTypeDef = TypedDict(
    "FleetLaunchTemplateOverridesOutputTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": PlacementResponseOutputTypeDef,
        "InstanceRequirements": InstanceRequirementsOutputTypeDef,
        "ImageId": str,
    },
)

LaunchTemplateOverridesOutputTypeDef = TypedDict(
    "LaunchTemplateOverridesOutputTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "InstanceRequirements": InstanceRequirementsOutputTypeDef,
    },
)

SpotFleetLaunchSpecificationOutputTypeDef = TypedDict(
    "SpotFleetLaunchSpecificationOutputTypeDef",
    {
        "SecurityGroups": List[GroupIdentifierOutputTypeDef],
        "AddressingType": str,
        "BlockDeviceMappings": List[BlockDeviceMappingOutputTypeDef],
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationOutputTypeDef,
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": SpotFleetMonitoringOutputTypeDef,
        "NetworkInterfaces": List[InstanceNetworkInterfaceSpecificationOutputTypeDef],
        "Placement": SpotPlacementOutputTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[SpotFleetTagSpecificationOutputTypeDef],
        "InstanceRequirements": InstanceRequirementsOutputTypeDef,
    },
)

FleetLaunchTemplateOverridesRequestTypeDef = TypedDict(
    "FleetLaunchTemplateOverridesRequestTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": PlacementTypeDef,
        "InstanceRequirements": InstanceRequirementsRequestTypeDef,
        "ImageId": str,
    },
    total=False,
)

_RequiredGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef = TypedDict(
    "_RequiredGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef",
    {
        "ArchitectureTypes": Sequence[ArchitectureTypeType],
        "VirtualizationTypes": Sequence[VirtualizationTypeType],
        "InstanceRequirements": InstanceRequirementsRequestTypeDef,
    },
)
_OptionalGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef = TypedDict(
    "_OptionalGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef",
    {
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef(
    _RequiredGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef,
    _OptionalGetInstanceTypesFromInstanceRequirementsRequestGetInstanceTypesFromInstanceRequirementsPaginateTypeDef,
):
    pass


_RequiredGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef = TypedDict(
    "_RequiredGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef",
    {
        "ArchitectureTypes": Sequence[ArchitectureTypeType],
        "VirtualizationTypes": Sequence[VirtualizationTypeType],
        "InstanceRequirements": InstanceRequirementsRequestTypeDef,
    },
)
_OptionalGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef = TypedDict(
    "_OptionalGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef(
    _RequiredGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef,
    _OptionalGetInstanceTypesFromInstanceRequirementsRequestRequestTypeDef,
):
    pass


InstanceRequirementsWithMetadataRequestTypeDef = TypedDict(
    "InstanceRequirementsWithMetadataRequestTypeDef",
    {
        "ArchitectureTypes": Sequence[ArchitectureTypeType],
        "VirtualizationTypes": Sequence[VirtualizationTypeType],
        "InstanceRequirements": InstanceRequirementsRequestTypeDef,
    },
    total=False,
)

LaunchTemplateOverridesTypeDef = TypedDict(
    "LaunchTemplateOverridesTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "InstanceRequirements": InstanceRequirementsTypeDef,
    },
    total=False,
)

SpotFleetLaunchSpecificationTypeDef = TypedDict(
    "SpotFleetLaunchSpecificationTypeDef",
    {
        "SecurityGroups": Sequence[GroupIdentifierTypeDef],
        "AddressingType": str,
        "BlockDeviceMappings": Sequence[BlockDeviceMappingTypeDef],
        "EbsOptimized": bool,
        "IamInstanceProfile": IamInstanceProfileSpecificationTypeDef,
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": SpotFleetMonitoringTypeDef,
        "NetworkInterfaces": Sequence[InstanceNetworkInterfaceSpecificationTypeDef],
        "Placement": SpotPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": Sequence[SpotFleetTagSpecificationTypeDef],
        "InstanceRequirements": InstanceRequirementsTypeDef,
    },
    total=False,
)

InstanceStatusOutputTypeDef = TypedDict(
    "InstanceStatusOutputTypeDef",
    {
        "AvailabilityZone": str,
        "OutpostArn": str,
        "Events": List[InstanceStatusEventOutputTypeDef],
        "InstanceId": str,
        "InstanceState": InstanceStateOutputTypeDef,
        "InstanceStatus": InstanceStatusSummaryOutputTypeDef,
        "SystemStatus": InstanceStatusSummaryOutputTypeDef,
    },
)

RevokeSecurityGroupEgressResultOutputTypeDef = TypedDict(
    "RevokeSecurityGroupEgressResultOutputTypeDef",
    {
        "Return": bool,
        "UnknownIpPermissions": List[IpPermissionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RevokeSecurityGroupIngressResultOutputTypeDef = TypedDict(
    "RevokeSecurityGroupIngressResultOutputTypeDef",
    {
        "Return": bool,
        "UnknownIpPermissions": List[IpPermissionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SecurityGroupOutputTypeDef = TypedDict(
    "SecurityGroupOutputTypeDef",
    {
        "Description": str,
        "GroupName": str,
        "IpPermissions": List[IpPermissionOutputTypeDef],
        "OwnerId": str,
        "GroupId": str,
        "IpPermissionsEgress": List[IpPermissionOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "VpcId": str,
    },
)

StaleSecurityGroupOutputTypeDef = TypedDict(
    "StaleSecurityGroupOutputTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "StaleIpPermissions": List[StaleIpPermissionOutputTypeDef],
        "StaleIpPermissionsEgress": List[StaleIpPermissionOutputTypeDef],
        "VpcId": str,
    },
)

_RequiredAuthorizeSecurityGroupEgressRequestRequestTypeDef = TypedDict(
    "_RequiredAuthorizeSecurityGroupEgressRequestRequestTypeDef",
    {
        "GroupId": str,
    },
)
_OptionalAuthorizeSecurityGroupEgressRequestRequestTypeDef = TypedDict(
    "_OptionalAuthorizeSecurityGroupEgressRequestRequestTypeDef",
    {
        "DryRun": bool,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "CidrIp": str,
        "FromPort": int,
        "IpProtocol": str,
        "ToPort": int,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
    },
    total=False,
)


class AuthorizeSecurityGroupEgressRequestRequestTypeDef(
    _RequiredAuthorizeSecurityGroupEgressRequestRequestTypeDef,
    _OptionalAuthorizeSecurityGroupEgressRequestRequestTypeDef,
):
    pass


AuthorizeSecurityGroupEgressRequestSecurityGroupAuthorizeEgressTypeDef = TypedDict(
    "AuthorizeSecurityGroupEgressRequestSecurityGroupAuthorizeEgressTypeDef",
    {
        "DryRun": bool,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "CidrIp": str,
        "FromPort": int,
        "IpProtocol": str,
        "ToPort": int,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
    },
    total=False,
)

AuthorizeSecurityGroupIngressRequestRequestTypeDef = TypedDict(
    "AuthorizeSecurityGroupIngressRequestRequestTypeDef",
    {
        "CidrIp": str,
        "FromPort": int,
        "GroupId": str,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "IpProtocol": str,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
        "ToPort": int,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

AuthorizeSecurityGroupIngressRequestSecurityGroupAuthorizeIngressTypeDef = TypedDict(
    "AuthorizeSecurityGroupIngressRequestSecurityGroupAuthorizeIngressTypeDef",
    {
        "CidrIp": str,
        "FromPort": int,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "IpProtocol": str,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
        "ToPort": int,
        "DryRun": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)

_RequiredRevokeSecurityGroupEgressRequestRequestTypeDef = TypedDict(
    "_RequiredRevokeSecurityGroupEgressRequestRequestTypeDef",
    {
        "GroupId": str,
    },
)
_OptionalRevokeSecurityGroupEgressRequestRequestTypeDef = TypedDict(
    "_OptionalRevokeSecurityGroupEgressRequestRequestTypeDef",
    {
        "DryRun": bool,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "SecurityGroupRuleIds": Sequence[str],
        "CidrIp": str,
        "FromPort": int,
        "IpProtocol": str,
        "ToPort": int,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
    },
    total=False,
)


class RevokeSecurityGroupEgressRequestRequestTypeDef(
    _RequiredRevokeSecurityGroupEgressRequestRequestTypeDef,
    _OptionalRevokeSecurityGroupEgressRequestRequestTypeDef,
):
    pass


RevokeSecurityGroupEgressRequestSecurityGroupRevokeEgressTypeDef = TypedDict(
    "RevokeSecurityGroupEgressRequestSecurityGroupRevokeEgressTypeDef",
    {
        "DryRun": bool,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "SecurityGroupRuleIds": Sequence[str],
        "CidrIp": str,
        "FromPort": int,
        "IpProtocol": str,
        "ToPort": int,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
    },
    total=False,
)

RevokeSecurityGroupIngressRequestRequestTypeDef = TypedDict(
    "RevokeSecurityGroupIngressRequestRequestTypeDef",
    {
        "CidrIp": str,
        "FromPort": int,
        "GroupId": str,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "IpProtocol": str,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
        "ToPort": int,
        "DryRun": bool,
        "SecurityGroupRuleIds": Sequence[str],
    },
    total=False,
)

RevokeSecurityGroupIngressRequestSecurityGroupRevokeIngressTypeDef = TypedDict(
    "RevokeSecurityGroupIngressRequestSecurityGroupRevokeIngressTypeDef",
    {
        "CidrIp": str,
        "FromPort": int,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "IpProtocol": str,
        "SourceSecurityGroupName": str,
        "SourceSecurityGroupOwnerId": str,
        "ToPort": int,
        "DryRun": bool,
        "SecurityGroupRuleIds": Sequence[str],
    },
    total=False,
)

UpdateSecurityGroupRuleDescriptionsEgressRequestRequestTypeDef = TypedDict(
    "UpdateSecurityGroupRuleDescriptionsEgressRequestRequestTypeDef",
    {
        "DryRun": bool,
        "GroupId": str,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "SecurityGroupRuleDescriptions": Sequence[SecurityGroupRuleDescriptionTypeDef],
    },
    total=False,
)

UpdateSecurityGroupRuleDescriptionsIngressRequestRequestTypeDef = TypedDict(
    "UpdateSecurityGroupRuleDescriptionsIngressRequestRequestTypeDef",
    {
        "DryRun": bool,
        "GroupId": str,
        "GroupName": str,
        "IpPermissions": Sequence[IpPermissionTypeDef],
        "SecurityGroupRuleDescriptions": Sequence[SecurityGroupRuleDescriptionTypeDef],
    },
    total=False,
)

GetIpamDiscoveredAccountsResultOutputTypeDef = TypedDict(
    "GetIpamDiscoveredAccountsResultOutputTypeDef",
    {
        "IpamDiscoveredAccounts": List[IpamDiscoveredAccountOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetIpamDiscoveredResourceCidrsResultOutputTypeDef = TypedDict(
    "GetIpamDiscoveredResourceCidrsResultOutputTypeDef",
    {
        "IpamDiscoveredResourceCidrs": List[IpamDiscoveredResourceCidrOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateIpamPoolResultOutputTypeDef = TypedDict(
    "CreateIpamPoolResultOutputTypeDef",
    {
        "IpamPool": IpamPoolOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteIpamPoolResultOutputTypeDef = TypedDict(
    "DeleteIpamPoolResultOutputTypeDef",
    {
        "IpamPool": IpamPoolOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpamPoolsResultOutputTypeDef = TypedDict(
    "DescribeIpamPoolsResultOutputTypeDef",
    {
        "NextToken": str,
        "IpamPools": List[IpamPoolOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyIpamPoolResultOutputTypeDef = TypedDict(
    "ModifyIpamPoolResultOutputTypeDef",
    {
        "IpamPool": IpamPoolOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetIpamResourceCidrsResultOutputTypeDef = TypedDict(
    "GetIpamResourceCidrsResultOutputTypeDef",
    {
        "NextToken": str,
        "IpamResourceCidrs": List[IpamResourceCidrOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyIpamResourceCidrResultOutputTypeDef = TypedDict(
    "ModifyIpamResourceCidrResultOutputTypeDef",
    {
        "IpamResourceCidr": IpamResourceCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateIpamResultOutputTypeDef = TypedDict(
    "CreateIpamResultOutputTypeDef",
    {
        "Ipam": IpamOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteIpamResultOutputTypeDef = TypedDict(
    "DeleteIpamResultOutputTypeDef",
    {
        "Ipam": IpamOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpamsResultOutputTypeDef = TypedDict(
    "DescribeIpamsResultOutputTypeDef",
    {
        "NextToken": str,
        "Ipams": List[IpamOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyIpamResultOutputTypeDef = TypedDict(
    "ModifyIpamResultOutputTypeDef",
    {
        "Ipam": IpamOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateIpamResourceDiscoveryResultOutputTypeDef = TypedDict(
    "CreateIpamResourceDiscoveryResultOutputTypeDef",
    {
        "IpamResourceDiscovery": IpamResourceDiscoveryOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteIpamResourceDiscoveryResultOutputTypeDef = TypedDict(
    "DeleteIpamResourceDiscoveryResultOutputTypeDef",
    {
        "IpamResourceDiscovery": IpamResourceDiscoveryOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpamResourceDiscoveriesResultOutputTypeDef = TypedDict(
    "DescribeIpamResourceDiscoveriesResultOutputTypeDef",
    {
        "IpamResourceDiscoveries": List[IpamResourceDiscoveryOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyIpamResourceDiscoveryResultOutputTypeDef = TypedDict(
    "ModifyIpamResourceDiscoveryResultOutputTypeDef",
    {
        "IpamResourceDiscovery": IpamResourceDiscoveryOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeprovisionIpamPoolCidrResultOutputTypeDef = TypedDict(
    "DeprovisionIpamPoolCidrResultOutputTypeDef",
    {
        "IpamPoolCidr": IpamPoolCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetIpamPoolCidrsResultOutputTypeDef = TypedDict(
    "GetIpamPoolCidrsResultOutputTypeDef",
    {
        "IpamPoolCidrs": List[IpamPoolCidrOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ProvisionIpamPoolCidrResultOutputTypeDef = TypedDict(
    "ProvisionIpamPoolCidrResultOutputTypeDef",
    {
        "IpamPoolCidr": IpamPoolCidrOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeIpv6PoolsResultOutputTypeDef = TypedDict(
    "DescribeIpv6PoolsResultOutputTypeDef",
    {
        "Ipv6Pools": List[Ipv6PoolOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyImageAttributeRequestImageModifyAttributeTypeDef = TypedDict(
    "ModifyImageAttributeRequestImageModifyAttributeTypeDef",
    {
        "Attribute": str,
        "Description": AttributeValueTypeDef,
        "LaunchPermission": LaunchPermissionModificationsTypeDef,
        "OperationType": OperationTypeType,
        "ProductCodes": Sequence[str],
        "UserGroups": Sequence[str],
        "UserIds": Sequence[str],
        "Value": str,
        "DryRun": bool,
        "OrganizationArns": Sequence[str],
        "OrganizationalUnitArns": Sequence[str],
        "ImdsSupport": AttributeValueTypeDef,
    },
    total=False,
)

_RequiredModifyImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyImageAttributeRequestRequestTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalModifyImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyImageAttributeRequestRequestTypeDef",
    {
        "Attribute": str,
        "Description": AttributeValueTypeDef,
        "LaunchPermission": LaunchPermissionModificationsTypeDef,
        "OperationType": OperationTypeType,
        "ProductCodes": Sequence[str],
        "UserGroups": Sequence[str],
        "UserIds": Sequence[str],
        "Value": str,
        "DryRun": bool,
        "OrganizationArns": Sequence[str],
        "OrganizationalUnitArns": Sequence[str],
        "ImdsSupport": AttributeValueTypeDef,
    },
    total=False,
)


class ModifyImageAttributeRequestRequestTypeDef(
    _RequiredModifyImageAttributeRequestRequestTypeDef,
    _OptionalModifyImageAttributeRequestRequestTypeDef,
):
    pass


ResponseLaunchTemplateDataOutputTypeDef = TypedDict(
    "ResponseLaunchTemplateDataOutputTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": LaunchTemplateIamInstanceProfileSpecificationOutputTypeDef,
        "BlockDeviceMappings": List[LaunchTemplateBlockDeviceMappingOutputTypeDef],
        "NetworkInterfaces": List[LaunchTemplateInstanceNetworkInterfaceSpecificationOutputTypeDef],
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KeyName": str,
        "Monitoring": LaunchTemplatesMonitoringOutputTypeDef,
        "Placement": LaunchTemplatePlacementOutputTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "UserData": str,
        "TagSpecifications": List[LaunchTemplateTagSpecificationOutputTypeDef],
        "ElasticGpuSpecifications": List[ElasticGpuSpecificationResponseOutputTypeDef],
        "ElasticInferenceAccelerators": List[
            LaunchTemplateElasticInferenceAcceleratorResponseOutputTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": LaunchTemplateInstanceMarketOptionsOutputTypeDef,
        "CreditSpecification": CreditSpecificationOutputTypeDef,
        "CpuOptions": LaunchTemplateCpuOptionsOutputTypeDef,
        "CapacityReservationSpecification": (
            LaunchTemplateCapacityReservationSpecificationResponseOutputTypeDef
        ),
        "LicenseSpecifications": List[LaunchTemplateLicenseConfigurationOutputTypeDef],
        "HibernationOptions": LaunchTemplateHibernationOptionsOutputTypeDef,
        "MetadataOptions": LaunchTemplateInstanceMetadataOptionsOutputTypeDef,
        "EnclaveOptions": LaunchTemplateEnclaveOptionsOutputTypeDef,
        "InstanceRequirements": InstanceRequirementsOutputTypeDef,
        "PrivateDnsNameOptions": LaunchTemplatePrivateDnsNameOptionsOutputTypeDef,
        "MaintenanceOptions": LaunchTemplateInstanceMaintenanceOptionsOutputTypeDef,
        "DisableApiStop": bool,
    },
)

RequestLaunchTemplateDataTypeDef = TypedDict(
    "RequestLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": LaunchTemplateIamInstanceProfileSpecificationRequestTypeDef,
        "BlockDeviceMappings": Sequence[LaunchTemplateBlockDeviceMappingRequestTypeDef],
        "NetworkInterfaces": Sequence[
            LaunchTemplateInstanceNetworkInterfaceSpecificationRequestTypeDef
        ],
        "ImageId": str,
        "InstanceType": InstanceTypeType,
        "KeyName": str,
        "Monitoring": LaunchTemplatesMonitoringRequestTypeDef,
        "Placement": LaunchTemplatePlacementRequestTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": ShutdownBehaviorType,
        "UserData": str,
        "TagSpecifications": Sequence[LaunchTemplateTagSpecificationRequestTypeDef],
        "ElasticGpuSpecifications": Sequence[ElasticGpuSpecificationTypeDef],
        "ElasticInferenceAccelerators": Sequence[LaunchTemplateElasticInferenceAcceleratorTypeDef],
        "SecurityGroupIds": Sequence[str],
        "SecurityGroups": Sequence[str],
        "InstanceMarketOptions": LaunchTemplateInstanceMarketOptionsRequestTypeDef,
        "CreditSpecification": CreditSpecificationRequestTypeDef,
        "CpuOptions": LaunchTemplateCpuOptionsRequestTypeDef,
        "CapacityReservationSpecification": (
            LaunchTemplateCapacityReservationSpecificationRequestTypeDef
        ),
        "LicenseSpecifications": Sequence[LaunchTemplateLicenseConfigurationRequestTypeDef],
        "HibernationOptions": LaunchTemplateHibernationOptionsRequestTypeDef,
        "MetadataOptions": LaunchTemplateInstanceMetadataOptionsRequestTypeDef,
        "EnclaveOptions": LaunchTemplateEnclaveOptionsRequestTypeDef,
        "InstanceRequirements": InstanceRequirementsRequestTypeDef,
        "PrivateDnsNameOptions": LaunchTemplatePrivateDnsNameOptionsRequestTypeDef,
        "MaintenanceOptions": LaunchTemplateInstanceMaintenanceOptionsRequestTypeDef,
        "DisableApiStop": bool,
    },
    total=False,
)

_RequiredModifyFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_RequiredModifyFpgaImageAttributeRequestRequestTypeDef",
    {
        "FpgaImageId": str,
    },
)
_OptionalModifyFpgaImageAttributeRequestRequestTypeDef = TypedDict(
    "_OptionalModifyFpgaImageAttributeRequestRequestTypeDef",
    {
        "DryRun": bool,
        "Attribute": FpgaImageAttributeNameType,
        "OperationType": OperationTypeType,
        "UserIds": Sequence[str],
        "UserGroups": Sequence[str],
        "ProductCodes": Sequence[str],
        "LoadPermission": LoadPermissionModificationsTypeDef,
        "Description": str,
        "Name": str,
    },
    total=False,
)


class ModifyFpgaImageAttributeRequestRequestTypeDef(
    _RequiredModifyFpgaImageAttributeRequestRequestTypeDef,
    _OptionalModifyFpgaImageAttributeRequestRequestTypeDef,
):
    pass


CreateNatGatewayResultOutputTypeDef = TypedDict(
    "CreateNatGatewayResultOutputTypeDef",
    {
        "ClientToken": str,
        "NatGateway": NatGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNatGatewaysResultOutputTypeDef = TypedDict(
    "DescribeNatGatewaysResultOutputTypeDef",
    {
        "NatGateways": List[NatGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateNetworkInterfacePermissionResultOutputTypeDef = TypedDict(
    "CreateNetworkInterfacePermissionResultOutputTypeDef",
    {
        "InterfacePermission": NetworkInterfacePermissionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInterfacePermissionsResultOutputTypeDef = TypedDict(
    "DescribeNetworkInterfacePermissionsResultOutputTypeDef",
    {
        "NetworkInterfacePermissions": List[NetworkInterfacePermissionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVerifiedAccessTrustProviderResultOutputTypeDef = TypedDict(
    "CreateVerifiedAccessTrustProviderResultOutputTypeDef",
    {
        "VerifiedAccessTrustProvider": VerifiedAccessTrustProviderOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVerifiedAccessTrustProviderResultOutputTypeDef = TypedDict(
    "DeleteVerifiedAccessTrustProviderResultOutputTypeDef",
    {
        "VerifiedAccessTrustProvider": VerifiedAccessTrustProviderOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVerifiedAccessTrustProvidersResultOutputTypeDef = TypedDict(
    "DescribeVerifiedAccessTrustProvidersResultOutputTypeDef",
    {
        "VerifiedAccessTrustProviders": List[VerifiedAccessTrustProviderOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVerifiedAccessTrustProviderResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessTrustProviderResultOutputTypeDef",
    {
        "VerifiedAccessTrustProvider": VerifiedAccessTrustProviderOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredCreateNetworkInsightsPathRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkInsightsPathRequestRequestTypeDef",
    {
        "Source": str,
        "Protocol": ProtocolType,
        "ClientToken": str,
    },
)
_OptionalCreateNetworkInsightsPathRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkInsightsPathRequestRequestTypeDef",
    {
        "SourceIp": str,
        "DestinationIp": str,
        "Destination": str,
        "DestinationPort": int,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
        "FilterAtSource": PathRequestFilterTypeDef,
        "FilterAtDestination": PathRequestFilterTypeDef,
    },
    total=False,
)


class CreateNetworkInsightsPathRequestRequestTypeDef(
    _RequiredCreateNetworkInsightsPathRequestRequestTypeDef,
    _OptionalCreateNetworkInsightsPathRequestRequestTypeDef,
):
    pass


AccessScopePathOutputTypeDef = TypedDict(
    "AccessScopePathOutputTypeDef",
    {
        "Source": PathStatementOutputTypeDef,
        "Destination": PathStatementOutputTypeDef,
        "ThroughResources": List[ThroughResourcesStatementOutputTypeDef],
    },
)

AccessScopePathRequestTypeDef = TypedDict(
    "AccessScopePathRequestTypeDef",
    {
        "Source": PathStatementRequestTypeDef,
        "Destination": PathStatementRequestTypeDef,
        "ThroughResources": Sequence[ThroughResourcesStatementRequestTypeDef],
    },
    total=False,
)

CancelReservedInstancesListingResultOutputTypeDef = TypedDict(
    "CancelReservedInstancesListingResultOutputTypeDef",
    {
        "ReservedInstancesListings": List[ReservedInstancesListingOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateReservedInstancesListingResultOutputTypeDef = TypedDict(
    "CreateReservedInstancesListingResultOutputTypeDef",
    {
        "ReservedInstancesListings": List[ReservedInstancesListingOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeReservedInstancesListingsResultOutputTypeDef = TypedDict(
    "DescribeReservedInstancesListingsResultOutputTypeDef",
    {
        "ReservedInstancesListings": List[ReservedInstancesListingOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribePublicIpv4PoolsResultOutputTypeDef = TypedDict(
    "DescribePublicIpv4PoolsResultOutputTypeDef",
    {
        "PublicIpv4Pools": List[PublicIpv4PoolOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeReservedInstancesOfferingsResultOutputTypeDef = TypedDict(
    "DescribeReservedInstancesOfferingsResultOutputTypeDef",
    {
        "ReservedInstancesOfferings": List[ReservedInstancesOfferingOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeReservedInstancesResultOutputTypeDef = TypedDict(
    "DescribeReservedInstancesResultOutputTypeDef",
    {
        "ReservedInstances": List[ReservedInstancesOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AuthorizeSecurityGroupEgressResultOutputTypeDef = TypedDict(
    "AuthorizeSecurityGroupEgressResultOutputTypeDef",
    {
        "Return": bool,
        "SecurityGroupRules": List[SecurityGroupRuleOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AuthorizeSecurityGroupIngressResultOutputTypeDef = TypedDict(
    "AuthorizeSecurityGroupIngressResultOutputTypeDef",
    {
        "Return": bool,
        "SecurityGroupRules": List[SecurityGroupRuleOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSecurityGroupRulesResultOutputTypeDef = TypedDict(
    "DescribeSecurityGroupRulesResultOutputTypeDef",
    {
        "SecurityGroupRules": List[SecurityGroupRuleOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservedInstancesModificationOutputTypeDef = TypedDict(
    "ReservedInstancesModificationOutputTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "EffectiveDate": datetime,
        "ModificationResults": List[ReservedInstancesModificationResultOutputTypeDef],
        "ReservedInstancesIds": List[ReservedInstancesIdOutputTypeDef],
        "ReservedInstancesModificationId": str,
        "Status": str,
        "StatusMessage": str,
        "UpdateDate": datetime,
    },
)

BundleTaskOutputTypeDef = TypedDict(
    "BundleTaskOutputTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": BundleTaskErrorOutputTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": BundleTaskStateType,
        "Storage": StorageOutputTypeDef,
        "UpdateTime": datetime,
    },
)

_RequiredBundleInstanceRequestRequestTypeDef = TypedDict(
    "_RequiredBundleInstanceRequestRequestTypeDef",
    {
        "InstanceId": str,
        "Storage": StorageTypeDef,
    },
)
_OptionalBundleInstanceRequestRequestTypeDef = TypedDict(
    "_OptionalBundleInstanceRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class BundleInstanceRequestRequestTypeDef(
    _RequiredBundleInstanceRequestRequestTypeDef, _OptionalBundleInstanceRequestRequestTypeDef
):
    pass


DescribeScheduledInstanceAvailabilityResultOutputTypeDef = TypedDict(
    "DescribeScheduledInstanceAvailabilityResultOutputTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceAvailabilitySet": List[ScheduledInstanceAvailabilityOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeScheduledInstancesResultOutputTypeDef = TypedDict(
    "DescribeScheduledInstancesResultOutputTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceSet": List[ScheduledInstanceOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PurchaseScheduledInstancesResultOutputTypeDef = TypedDict(
    "PurchaseScheduledInstancesResultOutputTypeDef",
    {
        "ScheduledInstanceSet": List[ScheduledInstanceOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredScheduledInstancesLaunchSpecificationTypeDef = TypedDict(
    "_RequiredScheduledInstancesLaunchSpecificationTypeDef",
    {
        "ImageId": str,
    },
)
_OptionalScheduledInstancesLaunchSpecificationTypeDef = TypedDict(
    "_OptionalScheduledInstancesLaunchSpecificationTypeDef",
    {
        "BlockDeviceMappings": Sequence[ScheduledInstancesBlockDeviceMappingTypeDef],
        "EbsOptimized": bool,
        "IamInstanceProfile": ScheduledInstancesIamInstanceProfileTypeDef,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ScheduledInstancesMonitoringTypeDef,
        "NetworkInterfaces": Sequence[ScheduledInstancesNetworkInterfaceTypeDef],
        "Placement": ScheduledInstancesPlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": Sequence[str],
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)


class ScheduledInstancesLaunchSpecificationTypeDef(
    _RequiredScheduledInstancesLaunchSpecificationTypeDef,
    _OptionalScheduledInstancesLaunchSpecificationTypeDef,
):
    pass


CreateVpcEndpointResultOutputTypeDef = TypedDict(
    "CreateVpcEndpointResultOutputTypeDef",
    {
        "VpcEndpoint": VpcEndpointOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcEndpointsResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointsResultOutputTypeDef",
    {
        "VpcEndpoints": List[VpcEndpointOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredModifySecurityGroupRulesRequestRequestTypeDef = TypedDict(
    "_RequiredModifySecurityGroupRulesRequestRequestTypeDef",
    {
        "GroupId": str,
        "SecurityGroupRules": Sequence[SecurityGroupRuleUpdateTypeDef],
    },
)
_OptionalModifySecurityGroupRulesRequestRequestTypeDef = TypedDict(
    "_OptionalModifySecurityGroupRulesRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class ModifySecurityGroupRulesRequestRequestTypeDef(
    _RequiredModifySecurityGroupRulesRequestRequestTypeDef,
    _OptionalModifySecurityGroupRulesRequestRequestTypeDef,
):
    pass


CreateVpcEndpointServiceConfigurationResultOutputTypeDef = TypedDict(
    "CreateVpcEndpointServiceConfigurationResultOutputTypeDef",
    {
        "ServiceConfiguration": ServiceConfigurationOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcEndpointServiceConfigurationsResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointServiceConfigurationsResultOutputTypeDef",
    {
        "ServiceConfigurations": List[ServiceConfigurationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcEndpointServicesResultOutputTypeDef = TypedDict(
    "DescribeVpcEndpointServicesResultOutputTypeDef",
    {
        "ServiceNames": List[str],
        "ServiceDetails": List[ServiceDetailOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportImageResultOutputTypeDef = TypedDict(
    "ImportImageResultOutputTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[SnapshotDetailOutputTypeDef],
        "Status": str,
        "StatusMessage": str,
        "LicenseSpecifications": List[ImportImageLicenseConfigurationResponseOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "UsageOperation": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportImageTaskOutputTypeDef = TypedDict(
    "ImportImageTaskOutputTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[SnapshotDetailOutputTypeDef],
        "Status": str,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
        "LicenseSpecifications": List[ImportImageLicenseConfigurationResponseOutputTypeDef],
        "UsageOperation": str,
        "BootMode": BootModeValuesType,
    },
)

ImportSnapshotResultOutputTypeDef = TypedDict(
    "ImportSnapshotResultOutputTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": SnapshotTaskDetailOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportSnapshotTaskOutputTypeDef = TypedDict(
    "ImportSnapshotTaskOutputTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": SnapshotTaskDetailOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

CreateSpotDatafeedSubscriptionResultOutputTypeDef = TypedDict(
    "CreateSpotDatafeedSubscriptionResultOutputTypeDef",
    {
        "SpotDatafeedSubscription": SpotDatafeedSubscriptionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotDatafeedSubscriptionResultOutputTypeDef = TypedDict(
    "DescribeSpotDatafeedSubscriptionResultOutputTypeDef",
    {
        "SpotDatafeedSubscription": SpotDatafeedSubscriptionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayMulticastDomainAssociationsResultOutputTypeDef = TypedDict(
    "GetTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    {
        "MulticastDomainAssociations": List[TransitGatewayMulticastDomainAssociationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptTransitGatewayMulticastDomainAssociationsResultOutputTypeDef = TypedDict(
    "AcceptTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    {
        "Associations": TransitGatewayMulticastDomainAssociationsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateTransitGatewayMulticastDomainResultOutputTypeDef = TypedDict(
    "AssociateTransitGatewayMulticastDomainResultOutputTypeDef",
    {
        "Associations": TransitGatewayMulticastDomainAssociationsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateTransitGatewayMulticastDomainResultOutputTypeDef = TypedDict(
    "DisassociateTransitGatewayMulticastDomainResultOutputTypeDef",
    {
        "Associations": TransitGatewayMulticastDomainAssociationsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RejectTransitGatewayMulticastDomainAssociationsResultOutputTypeDef = TypedDict(
    "RejectTransitGatewayMulticastDomainAssociationsResultOutputTypeDef",
    {
        "Associations": TransitGatewayMulticastDomainAssociationsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AssociateSubnetCidrBlockResultOutputTypeDef = TypedDict(
    "AssociateSubnetCidrBlockResultOutputTypeDef",
    {
        "Ipv6CidrBlockAssociation": SubnetIpv6CidrBlockAssociationOutputTypeDef,
        "SubnetId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateSubnetCidrBlockResultOutputTypeDef = TypedDict(
    "DisassociateSubnetCidrBlockResultOutputTypeDef",
    {
        "Ipv6CidrBlockAssociation": SubnetIpv6CidrBlockAssociationOutputTypeDef,
        "SubnetId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SubnetOutputTypeDef = TypedDict(
    "SubnetOutputTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "EnableLniAtDeviceIndex": int,
        "MapPublicIpOnLaunch": bool,
        "MapCustomerOwnedIpOnLaunch": bool,
        "CustomerOwnedIpv4Pool": str,
        "State": SubnetStateType,
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[SubnetIpv6CidrBlockAssociationOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "SubnetArn": str,
        "OutpostArn": str,
        "EnableDns64": bool,
        "Ipv6Native": bool,
        "PrivateDnsNameOptionsOnLaunch": PrivateDnsNameOptionsOnLaunchOutputTypeDef,
    },
)

GetReservedInstancesExchangeQuoteResultOutputTypeDef = TypedDict(
    "GetReservedInstancesExchangeQuoteResultOutputTypeDef",
    {
        "CurrencyCode": str,
        "IsValidExchange": bool,
        "OutputReservedInstancesWillExpireAt": datetime,
        "PaymentDue": str,
        "ReservedInstanceValueRollup": ReservationValueOutputTypeDef,
        "ReservedInstanceValueSet": List[ReservedInstanceReservationValueOutputTypeDef],
        "TargetConfigurationValueRollup": ReservationValueOutputTypeDef,
        "TargetConfigurationValueSet": List[TargetReservationValueOutputTypeDef],
        "ValidationFailureReason": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

LoadBalancersConfigOutputTypeDef = TypedDict(
    "LoadBalancersConfigOutputTypeDef",
    {
        "ClassicLoadBalancersConfig": ClassicLoadBalancersConfigOutputTypeDef,
        "TargetGroupsConfig": TargetGroupsConfigOutputTypeDef,
    },
)

LoadBalancersConfigTypeDef = TypedDict(
    "LoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": ClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": TargetGroupsConfigTypeDef,
    },
    total=False,
)

CreateTrafficMirrorFilterRuleResultOutputTypeDef = TypedDict(
    "CreateTrafficMirrorFilterRuleResultOutputTypeDef",
    {
        "TrafficMirrorFilterRule": TrafficMirrorFilterRuleOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTrafficMirrorFilterRuleResultOutputTypeDef = TypedDict(
    "ModifyTrafficMirrorFilterRuleResultOutputTypeDef",
    {
        "TrafficMirrorFilterRule": TrafficMirrorFilterRuleOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TrafficMirrorFilterOutputTypeDef = TypedDict(
    "TrafficMirrorFilterOutputTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[TrafficMirrorFilterRuleOutputTypeDef],
        "EgressFilterRules": List[TrafficMirrorFilterRuleOutputTypeDef],
        "NetworkServices": List[Literal["amazon-dns"]],
        "Description": str,
        "Tags": List[TagOutputTypeDef],
    },
)

DescribeTransitGatewayAttachmentsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayAttachmentsResultOutputTypeDef",
    {
        "TransitGatewayAttachments": List[TransitGatewayAttachmentOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TransitGatewayConnectPeerOutputTypeDef = TypedDict(
    "TransitGatewayConnectPeerOutputTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayConnectPeerId": str,
        "State": TransitGatewayConnectPeerStateType,
        "CreationTime": datetime,
        "ConnectPeerConfiguration": TransitGatewayConnectPeerConfigurationOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
    },
)

CreateTransitGatewayConnectResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayConnectResultOutputTypeDef",
    {
        "TransitGatewayConnect": TransitGatewayConnectOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayConnectResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayConnectResultOutputTypeDef",
    {
        "TransitGatewayConnect": TransitGatewayConnectOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayConnectsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayConnectsResultOutputTypeDef",
    {
        "TransitGatewayConnects": List[TransitGatewayConnectOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayMulticastDomainResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayMulticastDomainResultOutputTypeDef",
    {
        "TransitGatewayMulticastDomain": TransitGatewayMulticastDomainOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayMulticastDomainResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayMulticastDomainResultOutputTypeDef",
    {
        "TransitGatewayMulticastDomain": TransitGatewayMulticastDomainOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayMulticastDomainsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayMulticastDomainsResultOutputTypeDef",
    {
        "TransitGatewayMulticastDomains": List[TransitGatewayMulticastDomainOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayResultOutputTypeDef",
    {
        "TransitGateway": TransitGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayResultOutputTypeDef",
    {
        "TransitGateway": TransitGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewaysResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewaysResultOutputTypeDef",
    {
        "TransitGateways": List[TransitGatewayOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTransitGatewayResultOutputTypeDef = TypedDict(
    "ModifyTransitGatewayResultOutputTypeDef",
    {
        "TransitGateway": TransitGatewayOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptTransitGatewayPeeringAttachmentResultOutputTypeDef = TypedDict(
    "AcceptTransitGatewayPeeringAttachmentResultOutputTypeDef",
    {
        "TransitGatewayPeeringAttachment": TransitGatewayPeeringAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayPeeringAttachmentResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayPeeringAttachmentResultOutputTypeDef",
    {
        "TransitGatewayPeeringAttachment": TransitGatewayPeeringAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayPeeringAttachmentResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayPeeringAttachmentResultOutputTypeDef",
    {
        "TransitGatewayPeeringAttachment": TransitGatewayPeeringAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayPeeringAttachmentsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayPeeringAttachmentsResultOutputTypeDef",
    {
        "TransitGatewayPeeringAttachments": List[TransitGatewayPeeringAttachmentOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RejectTransitGatewayPeeringAttachmentResultOutputTypeDef = TypedDict(
    "RejectTransitGatewayPeeringAttachmentResultOutputTypeDef",
    {
        "TransitGatewayPeeringAttachment": TransitGatewayPeeringAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

TransitGatewayPolicyTableEntryOutputTypeDef = TypedDict(
    "TransitGatewayPolicyTableEntryOutputTypeDef",
    {
        "PolicyRuleNumber": str,
        "PolicyRule": TransitGatewayPolicyRuleOutputTypeDef,
        "TargetRouteTableId": str,
    },
)

CreateTransitGatewayPrefixListReferenceResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayPrefixListReferenceResultOutputTypeDef",
    {
        "TransitGatewayPrefixListReference": TransitGatewayPrefixListReferenceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayPrefixListReferenceResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayPrefixListReferenceResultOutputTypeDef",
    {
        "TransitGatewayPrefixListReference": TransitGatewayPrefixListReferenceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayPrefixListReferencesResultOutputTypeDef = TypedDict(
    "GetTransitGatewayPrefixListReferencesResultOutputTypeDef",
    {
        "TransitGatewayPrefixListReferences": List[TransitGatewayPrefixListReferenceOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTransitGatewayPrefixListReferenceResultOutputTypeDef = TypedDict(
    "ModifyTransitGatewayPrefixListReferenceResultOutputTypeDef",
    {
        "TransitGatewayPrefixListReference": TransitGatewayPrefixListReferenceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayRouteResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayRouteResultOutputTypeDef",
    {
        "Route": TransitGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayRouteResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayRouteResultOutputTypeDef",
    {
        "Route": TransitGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReplaceTransitGatewayRouteResultOutputTypeDef = TypedDict(
    "ReplaceTransitGatewayRouteResultOutputTypeDef",
    {
        "Route": TransitGatewayRouteOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

SearchTransitGatewayRoutesResultOutputTypeDef = TypedDict(
    "SearchTransitGatewayRoutesResultOutputTypeDef",
    {
        "Routes": List[TransitGatewayRouteOutputTypeDef],
        "AdditionalRoutesAvailable": bool,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptTransitGatewayVpcAttachmentResultOutputTypeDef = TypedDict(
    "AcceptTransitGatewayVpcAttachmentResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachment": TransitGatewayVpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayVpcAttachmentResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayVpcAttachmentResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachment": TransitGatewayVpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayVpcAttachmentResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayVpcAttachmentResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachment": TransitGatewayVpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayVpcAttachmentsResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayVpcAttachmentsResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachments": List[TransitGatewayVpcAttachmentOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTransitGatewayVpcAttachmentResultOutputTypeDef = TypedDict(
    "ModifyTransitGatewayVpcAttachmentResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachment": TransitGatewayVpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RejectTransitGatewayVpcAttachmentResultOutputTypeDef = TypedDict(
    "RejectTransitGatewayVpcAttachmentResultOutputTypeDef",
    {
        "TransitGatewayVpcAttachment": TransitGatewayVpcAttachmentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyInstanceCreditSpecificationResultOutputTypeDef = TypedDict(
    "ModifyInstanceCreditSpecificationResultOutputTypeDef",
    {
        "SuccessfulInstanceCreditSpecifications": List[
            SuccessfulInstanceCreditSpecificationItemOutputTypeDef
        ],
        "UnsuccessfulInstanceCreditSpecifications": List[
            UnsuccessfulInstanceCreditSpecificationItemOutputTypeDef
        ],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptVpcEndpointConnectionsResultOutputTypeDef = TypedDict(
    "AcceptVpcEndpointConnectionsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateFlowLogsResultOutputTypeDef = TypedDict(
    "CreateFlowLogsResultOutputTypeDef",
    {
        "ClientToken": str,
        "FlowLogIds": List[str],
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteFlowLogsResultOutputTypeDef = TypedDict(
    "DeleteFlowLogsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVpcEndpointConnectionNotificationsResultOutputTypeDef = TypedDict(
    "DeleteVpcEndpointConnectionNotificationsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVpcEndpointServiceConfigurationsResultOutputTypeDef = TypedDict(
    "DeleteVpcEndpointServiceConfigurationsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVpcEndpointsResultOutputTypeDef = TypedDict(
    "DeleteVpcEndpointsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyHostsResultOutputTypeDef = TypedDict(
    "ModifyHostsResultOutputTypeDef",
    {
        "Successful": List[str],
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RejectVpcEndpointConnectionsResultOutputTypeDef = TypedDict(
    "RejectVpcEndpointConnectionsResultOutputTypeDef",
    {
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReleaseHostsResultOutputTypeDef = TypedDict(
    "ReleaseHostsResultOutputTypeDef",
    {
        "Successful": List[str],
        "Unsuccessful": List[UnsuccessfulItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateLaunchTemplateResultOutputTypeDef = TypedDict(
    "CreateLaunchTemplateResultOutputTypeDef",
    {
        "LaunchTemplate": LaunchTemplateOutputTypeDef,
        "Warning": ValidationWarningOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVerifiedAccessEndpointResultOutputTypeDef = TypedDict(
    "CreateVerifiedAccessEndpointResultOutputTypeDef",
    {
        "VerifiedAccessEndpoint": VerifiedAccessEndpointOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVerifiedAccessEndpointResultOutputTypeDef = TypedDict(
    "DeleteVerifiedAccessEndpointResultOutputTypeDef",
    {
        "VerifiedAccessEndpoint": VerifiedAccessEndpointOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVerifiedAccessEndpointsResultOutputTypeDef = TypedDict(
    "DescribeVerifiedAccessEndpointsResultOutputTypeDef",
    {
        "VerifiedAccessEndpoints": List[VerifiedAccessEndpointOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVerifiedAccessEndpointResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessEndpointResultOutputTypeDef",
    {
        "VerifiedAccessEndpoint": VerifiedAccessEndpointOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AttachVerifiedAccessTrustProviderResultOutputTypeDef = TypedDict(
    "AttachVerifiedAccessTrustProviderResultOutputTypeDef",
    {
        "VerifiedAccessTrustProvider": VerifiedAccessTrustProviderOutputTypeDef,
        "VerifiedAccessInstance": VerifiedAccessInstanceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVerifiedAccessInstanceResultOutputTypeDef = TypedDict(
    "CreateVerifiedAccessInstanceResultOutputTypeDef",
    {
        "VerifiedAccessInstance": VerifiedAccessInstanceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteVerifiedAccessInstanceResultOutputTypeDef = TypedDict(
    "DeleteVerifiedAccessInstanceResultOutputTypeDef",
    {
        "VerifiedAccessInstance": VerifiedAccessInstanceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVerifiedAccessInstancesResultOutputTypeDef = TypedDict(
    "DescribeVerifiedAccessInstancesResultOutputTypeDef",
    {
        "VerifiedAccessInstances": List[VerifiedAccessInstanceOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DetachVerifiedAccessTrustProviderResultOutputTypeDef = TypedDict(
    "DetachVerifiedAccessTrustProviderResultOutputTypeDef",
    {
        "VerifiedAccessTrustProvider": VerifiedAccessTrustProviderOutputTypeDef,
        "VerifiedAccessInstance": VerifiedAccessInstanceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVerifiedAccessInstanceResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessInstanceResultOutputTypeDef",
    {
        "VerifiedAccessInstance": VerifiedAccessInstanceOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VerifiedAccessLogsOutputTypeDef = TypedDict(
    "VerifiedAccessLogsOutputTypeDef",
    {
        "S3": VerifiedAccessLogS3DestinationOutputTypeDef,
        "CloudWatchLogs": VerifiedAccessLogCloudWatchLogsDestinationOutputTypeDef,
        "KinesisDataFirehose": VerifiedAccessLogKinesisDataFirehoseDestinationOutputTypeDef,
        "LogVersion": str,
        "IncludeTrustContext": bool,
    },
)

_RequiredModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "AccessLogs": VerifiedAccessLogOptionsTypeDef,
    },
)
_OptionalModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
    },
    total=False,
)


class ModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef(
    _RequiredModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef,
    _OptionalModifyVerifiedAccessInstanceLoggingConfigurationRequestRequestTypeDef,
):
    pass


DescribeVolumesResultOutputTypeDef = TypedDict(
    "DescribeVolumesResultOutputTypeDef",
    {
        "Volumes": List[VolumeOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VolumeStatusItemOutputTypeDef = TypedDict(
    "VolumeStatusItemOutputTypeDef",
    {
        "Actions": List[VolumeStatusActionOutputTypeDef],
        "AvailabilityZone": str,
        "OutpostArn": str,
        "Events": List[VolumeStatusEventOutputTypeDef],
        "VolumeId": str,
        "VolumeStatus": VolumeStatusInfoOutputTypeDef,
        "AttachmentStatuses": List[VolumeStatusAttachmentStatusOutputTypeDef],
    },
)

AssociateVpcCidrBlockResultOutputTypeDef = TypedDict(
    "AssociateVpcCidrBlockResultOutputTypeDef",
    {
        "Ipv6CidrBlockAssociation": VpcIpv6CidrBlockAssociationOutputTypeDef,
        "CidrBlockAssociation": VpcCidrBlockAssociationOutputTypeDef,
        "VpcId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateVpcCidrBlockResultOutputTypeDef = TypedDict(
    "DisassociateVpcCidrBlockResultOutputTypeDef",
    {
        "Ipv6CidrBlockAssociation": VpcIpv6CidrBlockAssociationOutputTypeDef,
        "CidrBlockAssociation": VpcCidrBlockAssociationOutputTypeDef,
        "VpcId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpcOutputTypeDef = TypedDict(
    "VpcOutputTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": VpcStateType,
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": TenancyType,
        "Ipv6CidrBlockAssociationSet": List[VpcIpv6CidrBlockAssociationOutputTypeDef],
        "CidrBlockAssociationSet": List[VpcCidrBlockAssociationOutputTypeDef],
        "IsDefault": bool,
        "Tags": List[TagOutputTypeDef],
    },
)

VpcPeeringConnectionOutputTypeDef = TypedDict(
    "VpcPeeringConnectionOutputTypeDef",
    {
        "AccepterVpcInfo": VpcPeeringConnectionVpcInfoOutputTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": VpcPeeringConnectionVpcInfoOutputTypeDef,
        "Status": VpcPeeringConnectionStateReasonOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "VpcPeeringConnectionId": str,
    },
)

AssociateInstanceEventWindowResultOutputTypeDef = TypedDict(
    "AssociateInstanceEventWindowResultOutputTypeDef",
    {
        "InstanceEventWindow": InstanceEventWindowOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateInstanceEventWindowResultOutputTypeDef = TypedDict(
    "CreateInstanceEventWindowResultOutputTypeDef",
    {
        "InstanceEventWindow": InstanceEventWindowOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceEventWindowsResultOutputTypeDef = TypedDict(
    "DescribeInstanceEventWindowsResultOutputTypeDef",
    {
        "InstanceEventWindows": List[InstanceEventWindowOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DisassociateInstanceEventWindowResultOutputTypeDef = TypedDict(
    "DisassociateInstanceEventWindowResultOutputTypeDef",
    {
        "InstanceEventWindow": InstanceEventWindowOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyInstanceEventWindowResultOutputTypeDef = TypedDict(
    "ModifyInstanceEventWindowResultOutputTypeDef",
    {
        "InstanceEventWindow": InstanceEventWindowOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

PathComponentOutputTypeDef = TypedDict(
    "PathComponentOutputTypeDef",
    {
        "SequenceNumber": int,
        "AclRule": AnalysisAclRuleOutputTypeDef,
        "AttachedTo": AnalysisComponentOutputTypeDef,
        "Component": AnalysisComponentOutputTypeDef,
        "DestinationVpc": AnalysisComponentOutputTypeDef,
        "OutboundHeader": AnalysisPacketHeaderOutputTypeDef,
        "InboundHeader": AnalysisPacketHeaderOutputTypeDef,
        "RouteTableRoute": AnalysisRouteTableRouteOutputTypeDef,
        "SecurityGroupRule": AnalysisSecurityGroupRuleOutputTypeDef,
        "SourceVpc": AnalysisComponentOutputTypeDef,
        "Subnet": AnalysisComponentOutputTypeDef,
        "Vpc": AnalysisComponentOutputTypeDef,
        "AdditionalDetails": List[AdditionalDetailOutputTypeDef],
        "TransitGateway": AnalysisComponentOutputTypeDef,
        "TransitGatewayRouteTableRoute": TransitGatewayRouteTableRouteOutputTypeDef,
        "Explanations": List[ExplanationOutputTypeDef],
        "ElasticLoadBalancerListener": AnalysisComponentOutputTypeDef,
        "FirewallStatelessRule": FirewallStatelessRuleOutputTypeDef,
        "FirewallStatefulRule": FirewallStatefulRuleOutputTypeDef,
        "ServiceName": str,
    },
)

CreateRouteTableResultOutputTypeDef = TypedDict(
    "CreateRouteTableResultOutputTypeDef",
    {
        "RouteTable": RouteTableOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeRouteTablesResultOutputTypeDef = TypedDict(
    "DescribeRouteTablesResultOutputTypeDef",
    {
        "RouteTables": List[RouteTableOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInterfaceAttributeResultOutputTypeDef = TypedDict(
    "DescribeNetworkInterfaceAttributeResultOutputTypeDef",
    {
        "Attachment": NetworkInterfaceAttachmentOutputTypeDef,
        "Description": AttributeValueOutputTypeDef,
        "Groups": List[GroupIdentifierOutputTypeDef],
        "NetworkInterfaceId": str,
        "SourceDestCheck": AttributeBooleanValueOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

NetworkInterfaceOutputTypeDef = TypedDict(
    "NetworkInterfaceOutputTypeDef",
    {
        "Association": NetworkInterfaceAssociationOutputTypeDef,
        "Attachment": NetworkInterfaceAttachmentOutputTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[GroupIdentifierOutputTypeDef],
        "InterfaceType": NetworkInterfaceTypeType,
        "Ipv6Addresses": List[NetworkInterfaceIpv6AddressOutputTypeDef],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OutpostArn": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[NetworkInterfacePrivateIpAddressOutputTypeDef],
        "Ipv4Prefixes": List[Ipv4PrefixSpecificationOutputTypeDef],
        "Ipv6Prefixes": List[Ipv6PrefixSpecificationOutputTypeDef],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": NetworkInterfaceStatusType,
        "SubnetId": str,
        "TagSet": List[TagOutputTypeDef],
        "VpcId": str,
        "DenyAllIgwTraffic": bool,
        "Ipv6Native": bool,
        "Ipv6Address": str,
    },
)

CreateDhcpOptionsResultOutputTypeDef = TypedDict(
    "CreateDhcpOptionsResultOutputTypeDef",
    {
        "DhcpOptions": DhcpOptionsOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeDhcpOptionsResultOutputTypeDef = TypedDict(
    "DescribeDhcpOptionsResultOutputTypeDef",
    {
        "DhcpOptions": List[DhcpOptionsOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeHostsResultOutputTypeDef = TypedDict(
    "DescribeHostsResultOutputTypeDef",
    {
        "Hosts": List[HostOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeImagesResultOutputTypeDef = TypedDict(
    "DescribeImagesResultOutputTypeDef",
    {
        "Images": List[ImageOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeClientVpnEndpointsResultOutputTypeDef = TypedDict(
    "DescribeClientVpnEndpointsResultOutputTypeDef",
    {
        "ClientVpnEndpoints": List[ClientVpnEndpointOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpnConnectionOptionsOutputTypeDef = TypedDict(
    "VpnConnectionOptionsOutputTypeDef",
    {
        "EnableAcceleration": bool,
        "StaticRoutesOnly": bool,
        "LocalIpv4NetworkCidr": str,
        "RemoteIpv4NetworkCidr": str,
        "LocalIpv6NetworkCidr": str,
        "RemoteIpv6NetworkCidr": str,
        "OutsideIpAddressType": str,
        "TransportTransitGatewayAttachmentId": str,
        "TunnelInsideIpVersion": TunnelInsideIpVersionType,
        "TunnelOptions": List[TunnelOptionOutputTypeDef],
    },
)

_RequiredModifyVpnTunnelOptionsRequestRequestTypeDef = TypedDict(
    "_RequiredModifyVpnTunnelOptionsRequestRequestTypeDef",
    {
        "VpnConnectionId": str,
        "VpnTunnelOutsideIpAddress": str,
        "TunnelOptions": ModifyVpnTunnelOptionsSpecificationTypeDef,
    },
)
_OptionalModifyVpnTunnelOptionsRequestRequestTypeDef = TypedDict(
    "_OptionalModifyVpnTunnelOptionsRequestRequestTypeDef",
    {
        "DryRun": bool,
        "SkipTunnelReplacement": bool,
    },
    total=False,
)


class ModifyVpnTunnelOptionsRequestRequestTypeDef(
    _RequiredModifyVpnTunnelOptionsRequestRequestTypeDef,
    _OptionalModifyVpnTunnelOptionsRequestRequestTypeDef,
):
    pass


VpnConnectionOptionsSpecificationTypeDef = TypedDict(
    "VpnConnectionOptionsSpecificationTypeDef",
    {
        "EnableAcceleration": bool,
        "StaticRoutesOnly": bool,
        "TunnelInsideIpVersion": TunnelInsideIpVersionType,
        "TunnelOptions": Sequence[VpnTunnelOptionsSpecificationTypeDef],
        "LocalIpv4NetworkCidr": str,
        "RemoteIpv4NetworkCidr": str,
        "LocalIpv6NetworkCidr": str,
        "RemoteIpv6NetworkCidr": str,
        "OutsideIpAddressType": str,
        "TransportTransitGatewayAttachmentId": str,
    },
    total=False,
)

RequestSpotInstancesRequestRequestTypeDef = TypedDict(
    "RequestSpotInstancesRequestRequestTypeDef",
    {
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "ClientToken": str,
        "DryRun": bool,
        "InstanceCount": int,
        "LaunchGroup": str,
        "LaunchSpecification": RequestSpotLaunchSpecificationTypeDef,
        "SpotPrice": str,
        "Type": SpotInstanceTypeType,
        "ValidFrom": Union[datetime, str],
        "ValidUntil": Union[datetime, str],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
    },
    total=False,
)

DisableFastSnapshotRestoresResultOutputTypeDef = TypedDict(
    "DisableFastSnapshotRestoresResultOutputTypeDef",
    {
        "Successful": List[DisableFastSnapshotRestoreSuccessItemOutputTypeDef],
        "Unsuccessful": List[DisableFastSnapshotRestoreErrorItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ConversionTaskOutputTypeDef = TypedDict(
    "ConversionTaskOutputTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ImportInstanceTaskDetailsOutputTypeDef,
        "ImportVolume": ImportVolumeTaskDetailsOutputTypeDef,
        "State": ConversionTaskStateType,
        "StatusMessage": str,
        "Tags": List[TagOutputTypeDef],
    },
)

EnableFastSnapshotRestoresResultOutputTypeDef = TypedDict(
    "EnableFastSnapshotRestoresResultOutputTypeDef",
    {
        "Successful": List[EnableFastSnapshotRestoreSuccessItemOutputTypeDef],
        "Unsuccessful": List[EnableFastSnapshotRestoreErrorItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateNetworkInsightsPathResultOutputTypeDef = TypedDict(
    "CreateNetworkInsightsPathResultOutputTypeDef",
    {
        "NetworkInsightsPath": NetworkInsightsPathOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInsightsPathsResultOutputTypeDef = TypedDict(
    "DescribeNetworkInsightsPathsResultOutputTypeDef",
    {
        "NetworkInsightsPaths": List[NetworkInsightsPathOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceTypeInfoOutputTypeDef = TypedDict(
    "InstanceTypeInfoOutputTypeDef",
    {
        "InstanceType": InstanceTypeType,
        "CurrentGeneration": bool,
        "FreeTierEligible": bool,
        "SupportedUsageClasses": List[UsageClassTypeType],
        "SupportedRootDeviceTypes": List[RootDeviceTypeType],
        "SupportedVirtualizationTypes": List[VirtualizationTypeType],
        "BareMetal": bool,
        "Hypervisor": InstanceTypeHypervisorType,
        "ProcessorInfo": ProcessorInfoOutputTypeDef,
        "VCpuInfo": VCpuInfoOutputTypeDef,
        "MemoryInfo": MemoryInfoOutputTypeDef,
        "InstanceStorageSupported": bool,
        "InstanceStorageInfo": InstanceStorageInfoOutputTypeDef,
        "EbsInfo": EbsInfoOutputTypeDef,
        "NetworkInfo": NetworkInfoOutputTypeDef,
        "GpuInfo": GpuInfoOutputTypeDef,
        "FpgaInfo": FpgaInfoOutputTypeDef,
        "PlacementGroupInfo": PlacementGroupInfoOutputTypeDef,
        "InferenceAcceleratorInfo": InferenceAcceleratorInfoOutputTypeDef,
        "HibernationSupported": bool,
        "BurstablePerformanceSupported": bool,
        "DedicatedHostsSupported": bool,
        "AutoRecoverySupported": bool,
        "SupportedBootModes": List[BootModeTypeType],
        "NitroEnclavesSupport": NitroEnclavesSupportType,
    },
)

CreateNetworkAclResultOutputTypeDef = TypedDict(
    "CreateNetworkAclResultOutputTypeDef",
    {
        "NetworkAcl": NetworkAclOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkAclsResultOutputTypeDef = TypedDict(
    "DescribeNetworkAclsResultOutputTypeDef",
    {
        "NetworkAcls": List[NetworkAclOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

InstanceOutputTypeDef = TypedDict(
    "InstanceOutputTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": InstanceTypeType,
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": MonitoringOutputTypeDef,
        "Placement": PlacementOutputTypeDef,
        "Platform": Literal["Windows"],
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[ProductCodeOutputTypeDef],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": InstanceStateOutputTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": ArchitectureValuesType,
        "BlockDeviceMappings": List[InstanceBlockDeviceMappingOutputTypeDef],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": HypervisorTypeType,
        "IamInstanceProfile": IamInstanceProfileOutputTypeDef,
        "InstanceLifecycle": InstanceLifecycleTypeType,
        "ElasticGpuAssociations": List[ElasticGpuAssociationOutputTypeDef],
        "ElasticInferenceAcceleratorAssociations": List[
            ElasticInferenceAcceleratorAssociationOutputTypeDef
        ],
        "NetworkInterfaces": List[InstanceNetworkInterfaceOutputTypeDef],
        "OutpostArn": str,
        "RootDeviceName": str,
        "RootDeviceType": DeviceTypeType,
        "SecurityGroups": List[GroupIdentifierOutputTypeDef],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": StateReasonOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "VirtualizationType": VirtualizationTypeType,
        "CpuOptions": CpuOptionsOutputTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": CapacityReservationSpecificationResponseOutputTypeDef,
        "HibernationOptions": HibernationOptionsOutputTypeDef,
        "Licenses": List[LicenseConfigurationOutputTypeDef],
        "MetadataOptions": InstanceMetadataOptionsResponseOutputTypeDef,
        "EnclaveOptions": EnclaveOptionsOutputTypeDef,
        "BootMode": BootModeValuesType,
        "PlatformDetails": str,
        "UsageOperation": str,
        "UsageOperationUpdateTime": datetime,
        "PrivateDnsNameOptions": PrivateDnsNameOptionsResponseOutputTypeDef,
        "Ipv6Address": str,
        "TpmSupport": str,
        "MaintenanceOptions": InstanceMaintenanceOptionsOutputTypeDef,
        "CurrentInstanceBootMode": InstanceBootModeValuesType,
    },
)

SpotInstanceRequestOutputTypeDef = TypedDict(
    "SpotInstanceRequestOutputTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": SpotInstanceStateFaultOutputTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": LaunchSpecificationOutputTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": RIProductDescriptionType,
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": SpotInstanceStateType,
        "Status": SpotInstanceStatusOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "Type": SpotInstanceTypeType,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
    },
)

FleetLaunchTemplateConfigOutputTypeDef = TypedDict(
    "FleetLaunchTemplateConfigOutputTypeDef",
    {
        "LaunchTemplateSpecification": FleetLaunchTemplateSpecificationOutputTypeDef,
        "Overrides": List[FleetLaunchTemplateOverridesOutputTypeDef],
    },
)

LaunchTemplateAndOverridesResponseOutputTypeDef = TypedDict(
    "LaunchTemplateAndOverridesResponseOutputTypeDef",
    {
        "LaunchTemplateSpecification": FleetLaunchTemplateSpecificationOutputTypeDef,
        "Overrides": FleetLaunchTemplateOverridesOutputTypeDef,
    },
)

LaunchTemplateConfigOutputTypeDef = TypedDict(
    "LaunchTemplateConfigOutputTypeDef",
    {
        "LaunchTemplateSpecification": FleetLaunchTemplateSpecificationOutputTypeDef,
        "Overrides": List[LaunchTemplateOverridesOutputTypeDef],
    },
)

FleetLaunchTemplateConfigRequestTypeDef = TypedDict(
    "FleetLaunchTemplateConfigRequestTypeDef",
    {
        "LaunchTemplateSpecification": FleetLaunchTemplateSpecificationRequestTypeDef,
        "Overrides": Sequence[FleetLaunchTemplateOverridesRequestTypeDef],
    },
    total=False,
)

_RequiredGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef = TypedDict(
    "_RequiredGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef",
    {
        "TargetCapacity": int,
    },
)
_OptionalGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef = TypedDict(
    "_OptionalGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef",
    {
        "InstanceTypes": Sequence[str],
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
        "SingleAvailabilityZone": bool,
        "RegionNames": Sequence[str],
        "InstanceRequirementsWithMetadata": InstanceRequirementsWithMetadataRequestTypeDef,
        "DryRun": bool,
        "PaginationConfig": "PaginatorConfigTypeDef",
    },
    total=False,
)


class GetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef(
    _RequiredGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef,
    _OptionalGetSpotPlacementScoresRequestGetSpotPlacementScoresPaginateTypeDef,
):
    pass


_RequiredGetSpotPlacementScoresRequestRequestTypeDef = TypedDict(
    "_RequiredGetSpotPlacementScoresRequestRequestTypeDef",
    {
        "TargetCapacity": int,
    },
)
_OptionalGetSpotPlacementScoresRequestRequestTypeDef = TypedDict(
    "_OptionalGetSpotPlacementScoresRequestRequestTypeDef",
    {
        "InstanceTypes": Sequence[str],
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
        "SingleAvailabilityZone": bool,
        "RegionNames": Sequence[str],
        "InstanceRequirementsWithMetadata": InstanceRequirementsWithMetadataRequestTypeDef,
        "DryRun": bool,
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class GetSpotPlacementScoresRequestRequestTypeDef(
    _RequiredGetSpotPlacementScoresRequestRequestTypeDef,
    _OptionalGetSpotPlacementScoresRequestRequestTypeDef,
):
    pass


LaunchTemplateConfigTypeDef = TypedDict(
    "LaunchTemplateConfigTypeDef",
    {
        "LaunchTemplateSpecification": FleetLaunchTemplateSpecificationTypeDef,
        "Overrides": Sequence[LaunchTemplateOverridesTypeDef],
    },
    total=False,
)

DescribeInstanceStatusResultOutputTypeDef = TypedDict(
    "DescribeInstanceStatusResultOutputTypeDef",
    {
        "InstanceStatuses": List[InstanceStatusOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSecurityGroupsResultOutputTypeDef = TypedDict(
    "DescribeSecurityGroupsResultOutputTypeDef",
    {
        "SecurityGroups": List[SecurityGroupOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeStaleSecurityGroupsResultOutputTypeDef = TypedDict(
    "DescribeStaleSecurityGroupsResultOutputTypeDef",
    {
        "NextToken": str,
        "StaleSecurityGroupSet": List[StaleSecurityGroupOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetLaunchTemplateDataResultOutputTypeDef = TypedDict(
    "GetLaunchTemplateDataResultOutputTypeDef",
    {
        "LaunchTemplateData": ResponseLaunchTemplateDataOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

LaunchTemplateVersionOutputTypeDef = TypedDict(
    "LaunchTemplateVersionOutputTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": ResponseLaunchTemplateDataOutputTypeDef,
    },
)

_RequiredCreateLaunchTemplateRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLaunchTemplateRequestRequestTypeDef",
    {
        "LaunchTemplateName": str,
        "LaunchTemplateData": RequestLaunchTemplateDataTypeDef,
    },
)
_OptionalCreateLaunchTemplateRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLaunchTemplateRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
        "VersionDescription": str,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateLaunchTemplateRequestRequestTypeDef(
    _RequiredCreateLaunchTemplateRequestRequestTypeDef,
    _OptionalCreateLaunchTemplateRequestRequestTypeDef,
):
    pass


_RequiredCreateLaunchTemplateVersionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateLaunchTemplateVersionRequestRequestTypeDef",
    {
        "LaunchTemplateData": RequestLaunchTemplateDataTypeDef,
    },
)
_OptionalCreateLaunchTemplateVersionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateLaunchTemplateVersionRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "SourceVersion": str,
        "VersionDescription": str,
        "ResolveAlias": bool,
    },
    total=False,
)


class CreateLaunchTemplateVersionRequestRequestTypeDef(
    _RequiredCreateLaunchTemplateVersionRequestRequestTypeDef,
    _OptionalCreateLaunchTemplateVersionRequestRequestTypeDef,
):
    pass


NetworkInsightsAccessScopeContentOutputTypeDef = TypedDict(
    "NetworkInsightsAccessScopeContentOutputTypeDef",
    {
        "NetworkInsightsAccessScopeId": str,
        "MatchPaths": List[AccessScopePathOutputTypeDef],
        "ExcludePaths": List[AccessScopePathOutputTypeDef],
    },
)

_RequiredCreateNetworkInsightsAccessScopeRequestRequestTypeDef = TypedDict(
    "_RequiredCreateNetworkInsightsAccessScopeRequestRequestTypeDef",
    {
        "ClientToken": str,
    },
)
_OptionalCreateNetworkInsightsAccessScopeRequestRequestTypeDef = TypedDict(
    "_OptionalCreateNetworkInsightsAccessScopeRequestRequestTypeDef",
    {
        "MatchPaths": Sequence[AccessScopePathRequestTypeDef],
        "ExcludePaths": Sequence[AccessScopePathRequestTypeDef],
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "DryRun": bool,
    },
    total=False,
)


class CreateNetworkInsightsAccessScopeRequestRequestTypeDef(
    _RequiredCreateNetworkInsightsAccessScopeRequestRequestTypeDef,
    _OptionalCreateNetworkInsightsAccessScopeRequestRequestTypeDef,
):
    pass


DescribeReservedInstancesModificationsResultOutputTypeDef = TypedDict(
    "DescribeReservedInstancesModificationsResultOutputTypeDef",
    {
        "NextToken": str,
        "ReservedInstancesModifications": List[ReservedInstancesModificationOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

BundleInstanceResultOutputTypeDef = TypedDict(
    "BundleInstanceResultOutputTypeDef",
    {
        "BundleTask": BundleTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CancelBundleTaskResultOutputTypeDef = TypedDict(
    "CancelBundleTaskResultOutputTypeDef",
    {
        "BundleTask": BundleTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeBundleTasksResultOutputTypeDef = TypedDict(
    "DescribeBundleTasksResultOutputTypeDef",
    {
        "BundleTasks": List[BundleTaskOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

_RequiredRunScheduledInstancesRequestRequestTypeDef = TypedDict(
    "_RequiredRunScheduledInstancesRequestRequestTypeDef",
    {
        "LaunchSpecification": ScheduledInstancesLaunchSpecificationTypeDef,
        "ScheduledInstanceId": str,
    },
)
_OptionalRunScheduledInstancesRequestRequestTypeDef = TypedDict(
    "_OptionalRunScheduledInstancesRequestRequestTypeDef",
    {
        "ClientToken": str,
        "DryRun": bool,
        "InstanceCount": int,
    },
    total=False,
)


class RunScheduledInstancesRequestRequestTypeDef(
    _RequiredRunScheduledInstancesRequestRequestTypeDef,
    _OptionalRunScheduledInstancesRequestRequestTypeDef,
):
    pass


DescribeImportImageTasksResultOutputTypeDef = TypedDict(
    "DescribeImportImageTasksResultOutputTypeDef",
    {
        "ImportImageTasks": List[ImportImageTaskOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeImportSnapshotTasksResultOutputTypeDef = TypedDict(
    "DescribeImportSnapshotTasksResultOutputTypeDef",
    {
        "ImportSnapshotTasks": List[ImportSnapshotTaskOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateDefaultSubnetResultOutputTypeDef = TypedDict(
    "CreateDefaultSubnetResultOutputTypeDef",
    {
        "Subnet": SubnetOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateSubnetResultOutputTypeDef = TypedDict(
    "CreateSubnetResultOutputTypeDef",
    {
        "Subnet": SubnetOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSubnetsResultOutputTypeDef = TypedDict(
    "DescribeSubnetsResultOutputTypeDef",
    {
        "Subnets": List[SubnetOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTrafficMirrorFilterResultOutputTypeDef = TypedDict(
    "CreateTrafficMirrorFilterResultOutputTypeDef",
    {
        "TrafficMirrorFilter": TrafficMirrorFilterOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTrafficMirrorFiltersResultOutputTypeDef = TypedDict(
    "DescribeTrafficMirrorFiltersResultOutputTypeDef",
    {
        "TrafficMirrorFilters": List[TrafficMirrorFilterOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyTrafficMirrorFilterNetworkServicesResultOutputTypeDef = TypedDict(
    "ModifyTrafficMirrorFilterNetworkServicesResultOutputTypeDef",
    {
        "TrafficMirrorFilter": TrafficMirrorFilterOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateTransitGatewayConnectPeerResultOutputTypeDef = TypedDict(
    "CreateTransitGatewayConnectPeerResultOutputTypeDef",
    {
        "TransitGatewayConnectPeer": TransitGatewayConnectPeerOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DeleteTransitGatewayConnectPeerResultOutputTypeDef = TypedDict(
    "DeleteTransitGatewayConnectPeerResultOutputTypeDef",
    {
        "TransitGatewayConnectPeer": TransitGatewayConnectPeerOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeTransitGatewayConnectPeersResultOutputTypeDef = TypedDict(
    "DescribeTransitGatewayConnectPeersResultOutputTypeDef",
    {
        "TransitGatewayConnectPeers": List[TransitGatewayConnectPeerOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetTransitGatewayPolicyTableEntriesResultOutputTypeDef = TypedDict(
    "GetTransitGatewayPolicyTableEntriesResultOutputTypeDef",
    {
        "TransitGatewayPolicyTableEntries": List[TransitGatewayPolicyTableEntryOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VerifiedAccessInstanceLoggingConfigurationOutputTypeDef = TypedDict(
    "VerifiedAccessInstanceLoggingConfigurationOutputTypeDef",
    {
        "VerifiedAccessInstanceId": str,
        "AccessLogs": VerifiedAccessLogsOutputTypeDef,
    },
)

DescribeVolumeStatusResultOutputTypeDef = TypedDict(
    "DescribeVolumeStatusResultOutputTypeDef",
    {
        "NextToken": str,
        "VolumeStatuses": List[VolumeStatusItemOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateDefaultVpcResultOutputTypeDef = TypedDict(
    "CreateDefaultVpcResultOutputTypeDef",
    {
        "Vpc": VpcOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVpcResultOutputTypeDef = TypedDict(
    "CreateVpcResultOutputTypeDef",
    {
        "Vpc": VpcOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcsResultOutputTypeDef = TypedDict(
    "DescribeVpcsResultOutputTypeDef",
    {
        "Vpcs": List[VpcOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AcceptVpcPeeringConnectionResultOutputTypeDef = TypedDict(
    "AcceptVpcPeeringConnectionResultOutputTypeDef",
    {
        "VpcPeeringConnection": VpcPeeringConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVpcPeeringConnectionResultOutputTypeDef = TypedDict(
    "CreateVpcPeeringConnectionResultOutputTypeDef",
    {
        "VpcPeeringConnection": VpcPeeringConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpcPeeringConnectionsResultOutputTypeDef = TypedDict(
    "DescribeVpcPeeringConnectionsResultOutputTypeDef",
    {
        "VpcPeeringConnections": List[VpcPeeringConnectionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

AccessScopeAnalysisFindingOutputTypeDef = TypedDict(
    "AccessScopeAnalysisFindingOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
        "NetworkInsightsAccessScopeId": str,
        "FindingId": str,
        "FindingComponents": List[PathComponentOutputTypeDef],
    },
)

NetworkInsightsAnalysisOutputTypeDef = TypedDict(
    "NetworkInsightsAnalysisOutputTypeDef",
    {
        "NetworkInsightsAnalysisId": str,
        "NetworkInsightsAnalysisArn": str,
        "NetworkInsightsPathId": str,
        "AdditionalAccounts": List[str],
        "FilterInArns": List[str],
        "StartDate": datetime,
        "Status": AnalysisStatusType,
        "StatusMessage": str,
        "WarningMessage": str,
        "NetworkPathFound": bool,
        "ForwardPathComponents": List[PathComponentOutputTypeDef],
        "ReturnPathComponents": List[PathComponentOutputTypeDef],
        "Explanations": List[ExplanationOutputTypeDef],
        "AlternatePathHints": List[AlternatePathHintOutputTypeDef],
        "SuggestedAccounts": List[str],
        "Tags": List[TagOutputTypeDef],
    },
)

CreateNetworkInterfaceResultOutputTypeDef = TypedDict(
    "CreateNetworkInterfaceResultOutputTypeDef",
    {
        "NetworkInterface": NetworkInterfaceOutputTypeDef,
        "ClientToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInterfacesResultOutputTypeDef = TypedDict(
    "DescribeNetworkInterfacesResultOutputTypeDef",
    {
        "NetworkInterfaces": List[NetworkInterfaceOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

VpnConnectionOutputTypeDef = TypedDict(
    "VpnConnectionOutputTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": VpnStateType,
        "Type": Literal["ipsec.1"],
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "CoreNetworkArn": str,
        "CoreNetworkAttachmentArn": str,
        "GatewayAssociationState": GatewayAssociationStateType,
        "Options": VpnConnectionOptionsOutputTypeDef,
        "Routes": List[VpnStaticRouteOutputTypeDef],
        "Tags": List[TagOutputTypeDef],
        "VgwTelemetry": List[VgwTelemetryOutputTypeDef],
    },
)

_RequiredCreateVpnConnectionRequestRequestTypeDef = TypedDict(
    "_RequiredCreateVpnConnectionRequestRequestTypeDef",
    {
        "CustomerGatewayId": str,
        "Type": str,
    },
)
_OptionalCreateVpnConnectionRequestRequestTypeDef = TypedDict(
    "_OptionalCreateVpnConnectionRequestRequestTypeDef",
    {
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "DryRun": bool,
        "Options": VpnConnectionOptionsSpecificationTypeDef,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class CreateVpnConnectionRequestRequestTypeDef(
    _RequiredCreateVpnConnectionRequestRequestTypeDef,
    _OptionalCreateVpnConnectionRequestRequestTypeDef,
):
    pass


DescribeConversionTasksResultOutputTypeDef = TypedDict(
    "DescribeConversionTasksResultOutputTypeDef",
    {
        "ConversionTasks": List[ConversionTaskOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportInstanceResultOutputTypeDef = TypedDict(
    "ImportInstanceResultOutputTypeDef",
    {
        "ConversionTask": ConversionTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ImportVolumeResultOutputTypeDef = TypedDict(
    "ImportVolumeResultOutputTypeDef",
    {
        "ConversionTask": ConversionTaskOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstanceTypesResultOutputTypeDef = TypedDict(
    "DescribeInstanceTypesResultOutputTypeDef",
    {
        "InstanceTypes": List[InstanceTypeInfoOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ReservationOutputTypeDef = TypedDict(
    "ReservationOutputTypeDef",
    {
        "Groups": List[GroupIdentifierOutputTypeDef],
        "Instances": List[InstanceOutputTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
)

ReservationResponseMetadataTypeDef = TypedDict(
    "ReservationResponseMetadataTypeDef",
    {
        "Groups": List[GroupIdentifierOutputTypeDef],
        "Instances": List[InstanceOutputTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotInstanceRequestsResultOutputTypeDef = TypedDict(
    "DescribeSpotInstanceRequestsResultOutputTypeDef",
    {
        "SpotInstanceRequests": List[SpotInstanceRequestOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

RequestSpotInstancesResultOutputTypeDef = TypedDict(
    "RequestSpotInstancesResultOutputTypeDef",
    {
        "SpotInstanceRequests": List[SpotInstanceRequestOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateFleetErrorOutputTypeDef = TypedDict(
    "CreateFleetErrorOutputTypeDef",
    {
        "LaunchTemplateAndOverrides": LaunchTemplateAndOverridesResponseOutputTypeDef,
        "Lifecycle": InstanceLifecycleType,
        "ErrorCode": str,
        "ErrorMessage": str,
    },
)

CreateFleetInstanceOutputTypeDef = TypedDict(
    "CreateFleetInstanceOutputTypeDef",
    {
        "LaunchTemplateAndOverrides": LaunchTemplateAndOverridesResponseOutputTypeDef,
        "Lifecycle": InstanceLifecycleType,
        "InstanceIds": List[str],
        "InstanceType": InstanceTypeType,
        "Platform": Literal["Windows"],
    },
)

DescribeFleetErrorOutputTypeDef = TypedDict(
    "DescribeFleetErrorOutputTypeDef",
    {
        "LaunchTemplateAndOverrides": LaunchTemplateAndOverridesResponseOutputTypeDef,
        "Lifecycle": InstanceLifecycleType,
        "ErrorCode": str,
        "ErrorMessage": str,
    },
)

DescribeFleetsInstancesOutputTypeDef = TypedDict(
    "DescribeFleetsInstancesOutputTypeDef",
    {
        "LaunchTemplateAndOverrides": LaunchTemplateAndOverridesResponseOutputTypeDef,
        "Lifecycle": InstanceLifecycleType,
        "InstanceIds": List[str],
        "InstanceType": InstanceTypeType,
        "Platform": Literal["Windows"],
    },
)

SpotFleetRequestConfigDataOutputTypeDef = TypedDict(
    "SpotFleetRequestConfigDataOutputTypeDef",
    {
        "AllocationStrategy": AllocationStrategyType,
        "OnDemandAllocationStrategy": OnDemandAllocationStrategyType,
        "SpotMaintenanceStrategies": SpotMaintenanceStrategiesOutputTypeDef,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": ExcessCapacityTerminationPolicyType,
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[SpotFleetLaunchSpecificationOutputTypeDef],
        "LaunchTemplateConfigs": List[LaunchTemplateConfigOutputTypeDef],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": FleetTypeType,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
        "LoadBalancersConfig": LoadBalancersConfigOutputTypeDef,
        "InstancePoolsToUseCount": int,
        "Context": str,
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
        "TagSpecifications": List[TagSpecificationOutputTypeDef],
    },
)

_RequiredCreateFleetRequestRequestTypeDef = TypedDict(
    "_RequiredCreateFleetRequestRequestTypeDef",
    {
        "LaunchTemplateConfigs": Sequence[FleetLaunchTemplateConfigRequestTypeDef],
        "TargetCapacitySpecification": TargetCapacitySpecificationRequestTypeDef,
    },
)
_OptionalCreateFleetRequestRequestTypeDef = TypedDict(
    "_OptionalCreateFleetRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ClientToken": str,
        "SpotOptions": SpotOptionsRequestTypeDef,
        "OnDemandOptions": OnDemandOptionsRequestTypeDef,
        "ExcessCapacityTerminationPolicy": FleetExcessCapacityTerminationPolicyType,
        "TerminateInstancesWithExpiration": bool,
        "Type": FleetTypeType,
        "ValidFrom": Union[datetime, str],
        "ValidUntil": Union[datetime, str],
        "ReplaceUnhealthyInstances": bool,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
        "Context": str,
    },
    total=False,
)


class CreateFleetRequestRequestTypeDef(
    _RequiredCreateFleetRequestRequestTypeDef, _OptionalCreateFleetRequestRequestTypeDef
):
    pass


_RequiredModifyFleetRequestRequestTypeDef = TypedDict(
    "_RequiredModifyFleetRequestRequestTypeDef",
    {
        "FleetId": str,
    },
)
_OptionalModifyFleetRequestRequestTypeDef = TypedDict(
    "_OptionalModifyFleetRequestRequestTypeDef",
    {
        "DryRun": bool,
        "ExcessCapacityTerminationPolicy": FleetExcessCapacityTerminationPolicyType,
        "LaunchTemplateConfigs": Sequence[FleetLaunchTemplateConfigRequestTypeDef],
        "TargetCapacitySpecification": TargetCapacitySpecificationRequestTypeDef,
        "Context": str,
    },
    total=False,
)


class ModifyFleetRequestRequestTypeDef(
    _RequiredModifyFleetRequestRequestTypeDef, _OptionalModifyFleetRequestRequestTypeDef
):
    pass


_RequiredModifySpotFleetRequestRequestRequestTypeDef = TypedDict(
    "_RequiredModifySpotFleetRequestRequestRequestTypeDef",
    {
        "SpotFleetRequestId": str,
    },
)
_OptionalModifySpotFleetRequestRequestRequestTypeDef = TypedDict(
    "_OptionalModifySpotFleetRequestRequestRequestTypeDef",
    {
        "ExcessCapacityTerminationPolicy": ExcessCapacityTerminationPolicyType,
        "LaunchTemplateConfigs": Sequence[LaunchTemplateConfigTypeDef],
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "Context": str,
    },
    total=False,
)


class ModifySpotFleetRequestRequestRequestTypeDef(
    _RequiredModifySpotFleetRequestRequestRequestTypeDef,
    _OptionalModifySpotFleetRequestRequestRequestTypeDef,
):
    pass


_RequiredSpotFleetRequestConfigDataTypeDef = TypedDict(
    "_RequiredSpotFleetRequestConfigDataTypeDef",
    {
        "IamFleetRole": str,
        "TargetCapacity": int,
    },
)
_OptionalSpotFleetRequestConfigDataTypeDef = TypedDict(
    "_OptionalSpotFleetRequestConfigDataTypeDef",
    {
        "AllocationStrategy": AllocationStrategyType,
        "OnDemandAllocationStrategy": OnDemandAllocationStrategyType,
        "SpotMaintenanceStrategies": SpotMaintenanceStrategiesTypeDef,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": ExcessCapacityTerminationPolicyType,
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "LaunchSpecifications": Sequence[SpotFleetLaunchSpecificationTypeDef],
        "LaunchTemplateConfigs": Sequence[LaunchTemplateConfigTypeDef],
        "SpotPrice": str,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": FleetTypeType,
        "ValidFrom": Union[datetime, str],
        "ValidUntil": Union[datetime, str],
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": InstanceInterruptionBehaviorType,
        "LoadBalancersConfig": LoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
        "Context": str,
        "TargetCapacityUnitType": TargetCapacityUnitTypeType,
        "TagSpecifications": Sequence[TagSpecificationTypeDef],
    },
    total=False,
)


class SpotFleetRequestConfigDataTypeDef(
    _RequiredSpotFleetRequestConfigDataTypeDef, _OptionalSpotFleetRequestConfigDataTypeDef
):
    pass


CreateLaunchTemplateVersionResultOutputTypeDef = TypedDict(
    "CreateLaunchTemplateVersionResultOutputTypeDef",
    {
        "LaunchTemplateVersion": LaunchTemplateVersionOutputTypeDef,
        "Warning": ValidationWarningOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeLaunchTemplateVersionsResultOutputTypeDef = TypedDict(
    "DescribeLaunchTemplateVersionsResultOutputTypeDef",
    {
        "LaunchTemplateVersions": List[LaunchTemplateVersionOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateNetworkInsightsAccessScopeResultOutputTypeDef = TypedDict(
    "CreateNetworkInsightsAccessScopeResultOutputTypeDef",
    {
        "NetworkInsightsAccessScope": NetworkInsightsAccessScopeOutputTypeDef,
        "NetworkInsightsAccessScopeContent": NetworkInsightsAccessScopeContentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetNetworkInsightsAccessScopeContentResultOutputTypeDef = TypedDict(
    "GetNetworkInsightsAccessScopeContentResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeContent": NetworkInsightsAccessScopeContentOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVerifiedAccessInstanceLoggingConfigurationsResultOutputTypeDef = TypedDict(
    "DescribeVerifiedAccessInstanceLoggingConfigurationsResultOutputTypeDef",
    {
        "LoggingConfigurations": List[VerifiedAccessInstanceLoggingConfigurationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVerifiedAccessInstanceLoggingConfigurationResultOutputTypeDef = TypedDict(
    "ModifyVerifiedAccessInstanceLoggingConfigurationResultOutputTypeDef",
    {
        "LoggingConfiguration": VerifiedAccessInstanceLoggingConfigurationOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

GetNetworkInsightsAccessScopeAnalysisFindingsResultOutputTypeDef = TypedDict(
    "GetNetworkInsightsAccessScopeAnalysisFindingsResultOutputTypeDef",
    {
        "NetworkInsightsAccessScopeAnalysisId": str,
        "AnalysisStatus": AnalysisStatusType,
        "AnalysisFindings": List[AccessScopeAnalysisFindingOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeNetworkInsightsAnalysesResultOutputTypeDef = TypedDict(
    "DescribeNetworkInsightsAnalysesResultOutputTypeDef",
    {
        "NetworkInsightsAnalyses": List[NetworkInsightsAnalysisOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

StartNetworkInsightsAnalysisResultOutputTypeDef = TypedDict(
    "StartNetworkInsightsAnalysisResultOutputTypeDef",
    {
        "NetworkInsightsAnalysis": NetworkInsightsAnalysisOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateVpnConnectionResultOutputTypeDef = TypedDict(
    "CreateVpnConnectionResultOutputTypeDef",
    {
        "VpnConnection": VpnConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeVpnConnectionsResultOutputTypeDef = TypedDict(
    "DescribeVpnConnectionsResultOutputTypeDef",
    {
        "VpnConnections": List[VpnConnectionOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpnConnectionOptionsResultOutputTypeDef = TypedDict(
    "ModifyVpnConnectionOptionsResultOutputTypeDef",
    {
        "VpnConnection": VpnConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpnConnectionResultOutputTypeDef = TypedDict(
    "ModifyVpnConnectionResultOutputTypeDef",
    {
        "VpnConnection": VpnConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpnTunnelCertificateResultOutputTypeDef = TypedDict(
    "ModifyVpnTunnelCertificateResultOutputTypeDef",
    {
        "VpnConnection": VpnConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

ModifyVpnTunnelOptionsResultOutputTypeDef = TypedDict(
    "ModifyVpnTunnelOptionsResultOutputTypeDef",
    {
        "VpnConnection": VpnConnectionOutputTypeDef,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeInstancesResultOutputTypeDef = TypedDict(
    "DescribeInstancesResultOutputTypeDef",
    {
        "Reservations": List[ReservationOutputTypeDef],
        "NextToken": str,
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

CreateFleetResultOutputTypeDef = TypedDict(
    "CreateFleetResultOutputTypeDef",
    {
        "FleetId": str,
        "Errors": List[CreateFleetErrorOutputTypeDef],
        "Instances": List[CreateFleetInstanceOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

FleetDataOutputTypeDef = TypedDict(
    "FleetDataOutputTypeDef",
    {
        "ActivityStatus": FleetActivityStatusType,
        "CreateTime": datetime,
        "FleetId": str,
        "FleetState": FleetStateCodeType,
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": FleetExcessCapacityTerminationPolicyType,
        "FulfilledCapacity": float,
        "FulfilledOnDemandCapacity": float,
        "LaunchTemplateConfigs": List[FleetLaunchTemplateConfigOutputTypeDef],
        "TargetCapacitySpecification": TargetCapacitySpecificationOutputTypeDef,
        "TerminateInstancesWithExpiration": bool,
        "Type": FleetTypeType,
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "SpotOptions": SpotOptionsOutputTypeDef,
        "OnDemandOptions": OnDemandOptionsOutputTypeDef,
        "Tags": List[TagOutputTypeDef],
        "Errors": List[DescribeFleetErrorOutputTypeDef],
        "Instances": List[DescribeFleetsInstancesOutputTypeDef],
        "Context": str,
    },
)

SpotFleetRequestConfigOutputTypeDef = TypedDict(
    "SpotFleetRequestConfigOutputTypeDef",
    {
        "ActivityStatus": ActivityStatusType,
        "CreateTime": datetime,
        "SpotFleetRequestConfig": SpotFleetRequestConfigDataOutputTypeDef,
        "SpotFleetRequestId": str,
        "SpotFleetRequestState": BatchStateType,
        "Tags": List[TagOutputTypeDef],
    },
)

_RequiredRequestSpotFleetRequestRequestTypeDef = TypedDict(
    "_RequiredRequestSpotFleetRequestRequestTypeDef",
    {
        "SpotFleetRequestConfig": SpotFleetRequestConfigDataTypeDef,
    },
)
_OptionalRequestSpotFleetRequestRequestTypeDef = TypedDict(
    "_OptionalRequestSpotFleetRequestRequestTypeDef",
    {
        "DryRun": bool,
    },
    total=False,
)


class RequestSpotFleetRequestRequestTypeDef(
    _RequiredRequestSpotFleetRequestRequestTypeDef, _OptionalRequestSpotFleetRequestRequestTypeDef
):
    pass


DescribeFleetsResultOutputTypeDef = TypedDict(
    "DescribeFleetsResultOutputTypeDef",
    {
        "NextToken": str,
        "Fleets": List[FleetDataOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)

DescribeSpotFleetRequestsResponseOutputTypeDef = TypedDict(
    "DescribeSpotFleetRequestsResponseOutputTypeDef",
    {
        "NextToken": str,
        "SpotFleetRequestConfigs": List[SpotFleetRequestConfigOutputTypeDef],
        "ResponseMetadata": "ResponseMetadataTypeDef",
    },
)
